#include "device.h"


#define     FLASH_CONTROLLER_A      0
#define     FLASH_CONTROLLER_B      1

#define     FLASHA_BASE_ADDR        0x11000000
#define     FLASHB_BASE_ADDR        0x11080000

#define     FLASHA_INFO_BLOCK_ADDR        0x11800000
#define     FLASHB_INFO_BLOCK_ADDR        0x11880000


#define     DO_NOT_POLL_COMMAND_STATUS      0
#define     POLL_COMMAND_STATUS             1

#define     FLC_CMD_KEY0    0xF378
#define     FLC_CMD_KEY1    0x9D6A

#define     FLASH_ERROR_STATUS_BITS  (BITM_FLC_STAT_EERRMP | BITM_FLC_STAT_EERRMF | BITM_FLC_STAT_EERRMD | BITM_FLC_STAT_EERRMC | BITM_FLC_STAT_EERRSRT | BITM_FLC_STAT_CPGMERR | BITM_FLC_STAT_CIRFERR | BITM_FLC_STAT_CFNCMDM | BITM_FLC_STAT_CFSLP | BITM_FLC_STAT_CFBUSY )


#define     PAGE_ERASE_CMD              1
#define     MASS_ERASE_CMD              2
#define     PROGRAM_CMD                 3
#define     START_PROGRAM_CMD           4
#define     END_PROGRAM_CMD             5
#define     READ_CMD                    6
#define     SLEEP_CMD                   7
#define     SLEEP_WAKEUP_CMD            8
#define     POWER_DOWN_CMD              9
#define     POWER_DOWN_WAKEUP_CMD       10
#define     UPDATE_TIMING_INFO          11
#define     ABORT_CMD                   12


#define     FLASH_ROW_SIZE         512
#define     FLASH_PAGE_SIZ        4096

//#define     FLASH_ROW_COUNT        
#define     FLASH_PAGE_COUNT       128


#define REG_TESYS1_ENG_MODE_CFG0            0x40000080                                              /*  TESYS1 Engineering Mode Configuration Register 0 */
#define pREG_TESYS1_ENG_MODE_CFG0           ((volatile  uint32_t *) REG_TESYS1_ENG_MODE_CFG0)       /*  TESYS1 Engineering Mode Configuration Register 0 */

#define REG_SPU1_EMODE3                     0x400F801C                                              /*  SPU1 Engineering Mode Enable Register */
#define pREG_SPU1_EMODE3                    ((volatile  uint32_t *) REG_SPU1_EMODE3)                /*  SPU1 Engineering Mode Enable Register */


__ramfunc void CM41xFlash_ResetController(unsigned char Flash_Controller) ;
__ramfunc void CM41xFlash_ErasePage(unsigned char Flash_Controller, unsigned int PAGE_ADDR);
__ramfunc void CM41xFlash_MassErase(unsigned char Flash_Controller, unsigned char Erase_Info_Block);
__ramfunc void CM41xFlash_ReadBuffer(unsigned char Flash_Controller, unsigned int Flash_ADDR, unsigned int Program_count, unsigned int* Read_Buffer);
__ramfunc void CM41xFlash_WriteBuffer(unsigned char Flash_Controller, unsigned int Flash_ADDR, unsigned int Program_count, unsigned int* Write_Buffer);
__ramfunc void CM41xFlash_SetPerformanceMode(unsigned int core_clock);
__ramfunc  unsigned char CM41xFlash_CalcECC(unsigned int Data0, unsigned int Data1);
__ramfunc  void CM41xFlash_Write64bitWord_withECC(unsigned char Flash_Controller, unsigned int WORD_ADDR, unsigned int Write_Data0, unsigned int Write_Data1, unsigned char ECC_Byte);


__ramfunc void CM41xFlash_EnterCommandMode(unsigned char Flash_Controller);
__ramfunc void CM41xFlash_ExitCommandMode(unsigned char Flash_Controller) ;
__ramfunc void CM41xFlash_IssueCommand(unsigned char Flash_Controller, unsigned char command, unsigned char poll_status) ;
__ramfunc  void CM41xFlash_WriteROW(unsigned char Flash_Controller, unsigned int ROW_ADDR, unsigned int* Write_buff);
__ramfunc void CM41xFlash_WriteWord(unsigned char Flash_Controller, unsigned int WORD_ADDR, unsigned int Write_Data);
__ramfunc void CM41xFlash_SetInfoBlockProp(unsigned char Flash_Controller, unsigned int FLASH_ADDR, unsigned char* IRFWEN, unsigned char* IRFREN);
__ramfunc  void CM41xFlash_RestoreInfoBlockProp(unsigned char Flash_Controller, unsigned char IRFWEN, unsigned char IRFREN);
__ramfunc void Error_function(void);

