typedef enum 
        {PORTA, PORTB, PORTC, PORTD, PORTE, PORTF} type_PORT_NAME;

typedef enum 
        {HOLD, TRISTATE, LOW, HIGH} type_SAFE_STATE;

typedef enum 
        {EARLY, LATE} type_RESPONSE;

typedef enum
        {PIN_1, PIN_2, PIN_3, PIN_4, PIN_5, 
         PIN_6, PIN_7, PIN_8, PIN_9, PIN_10, 
         PIN_11, PIN_12, PIN_13, PIN_14, PIN_15} type_PIN_NUM;

           
           
//---------Enable GPIO Pin Safe State Functionality---------//
//
//      Description: 
//              Enable GPIO safe state for individual ports           
//      Parameters:
//              1. port_name (type: type_PORT_NAME) -> specify port name - PORTA, PORTB, PORTC, PORTD
//              2. safe_state (type: type_SAFE_STATE) -> specify port safe state - HOLD (hold previous value), TRISTATE, LOW or HIGH
//              3. response (type: type_RESPONSE) -> specify response of GPIO port to fault - EARLY (prompt assertion of safe state), LATE (delayed assertion of safe state) 
// 
   
void GPIO_Safe_State_Init(type_PORT_NAME port_name,
                          type_SAFE_STATE safe_state,
                          type_RESPONSE response);


//---------Enable GPIO Pin Safe State Functionality---------//
//
//      Description: 
//              Enable GPIO safe state for individual port pins          
//      Parameters:
//              1. port_name (type: type_PORT_NAME) -> specify port name - PORTA, PORTB, PORTC, PORTD
//              2. safe_state (type: type_SAFE_STATE) -> specify port safe state - HOLD (hold previous value), TRISTATE, LOW or HIGH
//              3. response (type: type_RESPONSE) -> specify response of GPIO port to fault - EARLY (prompt assertion of safe state), LATE (delayed assertion of safe state) 
//              4. pin_num (type: type_PIN_NUM) -> speicfy port pin number eg. PIN_1, PIN_2 ...... PIN_15
//           
void GPIO_Safe_State_Init_Pin(type_PORT_NAME port_name,
                              type_SAFE_STATE safe_state,
                              type_RESPONSE response,
                              type_PIN_NUM pin_num);