/**************************************************************************************************************************
*	File name 							: MiscFunctions.h
*	Purpose								: Contains include files, global variables, and function declarations
*										  corresponding to the "MiscFunctions.C" file.
*	Author								: Mitesh Moonat
*	VDSP version used for testing		: CCES Cygnus M2
*	Hardware used						: N/A
*	Connection details 					: N/A
*	Guidelines for change				: N/A
**************************************************************************************************************************/
#ifndef MISCFUNCTIONS_H_
#define MISCFUNCTIONS_H_


/*************************************************************************************************************************
									Include Files
**************************************************************************************************************************/
#include "ProcInclude.h"
#include "ProcessorSpecific.h"
#include "stdio.h"
#include "math.h"


/*************************************************************************************************************************
									Function Declarations
**************************************************************************************************************************/
//Miscellaneous function definitions
void Buf_Init(void* InitBuf, unsigned int uiSize, unsigned int uiBytesPerWord, unsigned int uiPattern,  unsigned int uiMask, unsigned int uiStride);
void Mem_Cpy(void* SrcBuf, void* DestBuf, unsigned int uiSize,unsigned int uiBytesPerWord);
int Buf_Compare(void* CmpBuf1, void* CmpBuf2, unsigned int uiSize, unsigned int uiBytesPerWord,  unsigned int uiMask, unsigned int uiStride);
void Buf_Fill(void* InitBuf, unsigned int uiSize, unsigned int uiBytesPerWord, unsigned int uiPattern,  unsigned int uiMask, unsigned int uiStride);
void Indicate_Pass(void);
void Indicate_Fail(void);
void Delay(unsigned int uiDelay);
void Print_Console(char* sText);
/************************************************************************************************************************/


/*************************************************************************************************************************
									MACROs
************************************************************************************************************************/
//Define this if debug printf statements are required
#define DEBUG_MODE

#define RAND 0
#define INCREMENT 1
#define INTMASK		0xFFFFFFFF
#define SHORTMASK	0x0000FFFF
#define BYTEMASK 	0x000000FF
#define INTTYPE		4
#define SHORTTYPE 	2
#define BYTETYPE	1


#endif /* MISCFUNCTIONS_H_ */
