#ifndef OCU_INIT_H_
#define OCU_INIT_H_

#define LFO_CM41x       16000000          /* LFO for OCU to processor in Hz */

typedef enum {FREQ_FAULT, CMON_FAULT, LMON_FAULT, DEAD_CLK 
} type_OCU_Fault_Type;


void OCU_Init(unsigned int ref_cnt, unsigned short int clk_ppm, unsigned short int lfo_ppm);
void OCU_Start_Manual();
void OCU_Start_Auto();
void OCU_Disable();
void OCU_Enable_Fault(type_OCU_Fault_Type fault_type);

void OCU0_ERR_Handler(void);  // Interrupt Handler 

#endif /* OCU_INIT_H_ */