//-----------VDDINT Monitoring---------//
#define VMU_VDDINT  // Enable VDDINT Monitoring
#define VDDINT_LOW_THRESHOLD_1 // Set VDDINT low threshold - 1.124V
#define VDDINT_LOW_THRESHOLD_2 // Set VDDINT low threshold - 1.11
// Default upper threshold is 1.286


//-----------VDDEXT Monitoring---------//
#define VMU_VDDEXT  // Enable VDDEXT Monitoring
#define VDDEXT_LOW_THRESHOLD_1 // Set VDDINT low threshold - 2.97V
#define VDDEXT_LOW_THRESHOLD_2 // Set VDDINT low threshold - 2.80V
// Default upper threshold is 3.59


typedef enum{
              DIS_ALL_TEST, VDDEXT_TEST, VDDINT_TEST, FAULT_COUNTER_TEST, TFPD_TEST, 
              TSBH_TEST, TPDS_TEST, TPDH_TEST, COMP_SAMPLING_CLK_TEST, EVDD_SHIFT_REGISTER_TEST, IVDD_SHIFT_REGISTER_TEST, FAST_RESPONSE_COMP_TEST
} type_Test_Mode;



//--------VMU Initialization Function------//
// Parameters:
// 1. vdd_int_en = 0 - Disable
//                 1 - Enable
//
// 2. vdd_ext_en = 0 - Disable
//                 1 - Enable
//
// 3. fast_comp_en = 0 - Disable
//                   1 - Enable
//
// 4. vdd_int_ref = 0 - Set VDDINT reference voltage to 1.124 V
//                  1 - Set VDDINT reference voltage to 1.11 V
//
// 5. vdd_ext_ref = 0 - Set VDDEXT reference voltage to 2.97 V
//                  1 - Set VDDEXT reference voltage to 2.80 V
//
// 6. fault_delay = 0 to 15 - Set fault delay from 1us to 17us
//
void VMU_Init(bool vdd_int_en,
              bool vdd_ext_en,
              bool fast_comp_en,
              unsigned short int vdd_int_ref,
              unsigned short int vdd_ext_ref,
              unsigned short int fault_delay
              );


//---------VMU Initialization Default Function--------//
//  Initialize VMU with deault settings:
//  VDDINT and VDDEXT moitoring enabled
//  Fast comparator is on
//  VDDINT reference = 1.124
//  VDDEXT reference = 2.97
//  Fault signal delay = 11us/12us
void VMU_Init_Default(void);
