#include "device.h"
#include "GPIO_Safe_State_Init.h"


void GPIO_Safe_State_Init(type_PORT_NAME port_name,
                          type_SAFE_STATE safe_state,
                          type_RESPONSE response
                          )
{
  unsigned int temp_reg=0;
  switch (port_name)
  {
  case PORTA:
    *pREG_PORTA_FER_CLR  = 0xFFFF;
    *pREG_PORTA_DIR_SET  = 0xFFFF; 
    *pREG_PORTA_DATA_SET  = 0xFFFF;
    // Configure safe state
    if(safe_state == HOLD)
    {
      for(int i=0; i<32; i+=2)
      {
        temp_reg |= (HOLD << i) & (3 << i);
      }
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (TRISTATE << i) & (3 << i);
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (LOW << i) & (3 << i);
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HIGH << i) & (3 << i);
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    // Response
    if(response == EARLY)
      *pREG_TEPADS0_PORTA_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS0_PORTA_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
  
  case PORTB:
    *pREG_PORTB_FER_CLR  = 0xFFFF;
    *pREG_PORTB_DIR_SET  = 0xFFFF; 
    *pREG_PORTB_DATA_SET  = 0xFFFF;
    // Configure safe state
    if(safe_state == HOLD)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HOLD << i) & (3 << i);
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (TRISTATE << i) & (3 << i);
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (LOW << i) & (3 << i);
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HIGH << i) & (3 << i);
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }   
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTB_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTB_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
       
  case PORTC:
    *pREG_PORTC_FER_CLR  = 0xFFFF;
    *pREG_PORTC_DIR_SET  = 0xFFFF; 
    *pREG_PORTC_DATA_SET  = 0xFFFF;
    // Configure safe state
    if(safe_state == HOLD)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HOLD << i) & (3 << i);
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (TRISTATE << i) & (3 << i);
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (LOW << i) & (3 << i);
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HIGH << i) & (3 << i);
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }   
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTC_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTC_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
    
  case PORTD:
    *pREG_PORTD_FER_CLR  = 0xFFFF;
    *pREG_PORTD_DIR_SET  = 0xFFFF; 
    *pREG_PORTD_DATA_SET  = 0xFFFF;
    // Configure safe state
    if(safe_state == HOLD)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HOLD << i) & (3 << i);
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (TRISTATE << i) & (3 << i);
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (LOW << i) & (3 << i);
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HIGH << i) & (3 << i);
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }   
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTD_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTD_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
       
  case PORTE:
    *pREG_PORTE_FER_CLR  = 0xFFFF;
    *pREG_PORTE_DIR_SET  = 0xFFFF; 
    *pREG_PORTE_DATA_SET  = 0xFFFF;
    // Configure safe state
    if(safe_state == HOLD)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HOLD << i) & (3 << i);
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (TRISTATE << i) & (3 << i);
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (LOW << i) & (3 << i);
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HIGH << i) & (3 << i);
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }   
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTE_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTE_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
       
  case PORTF:
    *pREG_PORTF_FER_CLR  = 0xFFFF;
    *pREG_PORTF_DIR_SET  = 0xFFFF; 
    *pREG_PORTF_DATA_SET  = 0xFFFF;
    // Configure safe state
    if(safe_state == HOLD)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HOLD << i) & (3 << i);
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (TRISTATE << i) & (3 << i);
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (LOW << i) & (3 << i);
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      for(int i=0; i<32; i+=2)
        temp_reg |= (HIGH << i) & (3 << i);
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }   
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTF_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTF_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
  } 
}





void GPIO_Safe_State_Init_Pin(type_PORT_NAME port_name,
                              type_SAFE_STATE safe_state,
                              type_RESPONSE response,
                              type_PIN_NUM pin_num)
{
  unsigned int temp_reg=0;
  switch (port_name)
  {
  case PORTA:
    *pREG_PORTA_FER_CLR   |= (1 << pin_num);
    *pREG_PORTA_DIR_SET   |= (1 << pin_num); 
    *pREG_PORTA_DATA_SET  |= (1 << pin_num);
    // Configure safe state
    if(safe_state == HOLD)
    {
      temp_reg |= (HOLD << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      temp_reg |= (TRISTATE << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      temp_reg |= (LOW << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      temp_reg |= (HIGH << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS0_PORTA_TRIPST = temp_reg;
    }
    // Response
    if(response == EARLY)
      *pREG_TEPADS0_PORTA_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS0_PORTA_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
  
  case PORTB:
    *pREG_PORTB_FER_CLR   |= (1 << pin_num);
    *pREG_PORTB_DIR_SET   |= (1 << pin_num); 
    *pREG_PORTB_DATA_SET  |= (1 << pin_num);
    // Configure safe state
    if(safe_state == HOLD)
    {
      temp_reg |= (HOLD << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      temp_reg |= (TRISTATE << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      temp_reg |= (LOW << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      temp_reg |= (HIGH << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTB_TRIPST = temp_reg;
    }
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTB_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTB_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
       
  case PORTC:
    *pREG_PORTC_FER_CLR   |= (1 << pin_num);
    *pREG_PORTC_DIR_SET   |= (1 << pin_num); 
    *pREG_PORTC_DATA_SET  |= (1 << pin_num);
    // Configure safe state
    if(safe_state == HOLD)
    {
      temp_reg |= (HOLD << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      temp_reg |= (TRISTATE << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      temp_reg |= (LOW << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      temp_reg |= (HIGH << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTC_TRIPST = temp_reg;
    }    
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTC_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTC_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
    
  case PORTD:
    *pREG_PORTD_FER_CLR   |= (1 << pin_num);
    *pREG_PORTD_DIR_SET   |= (1 << pin_num); 
    *pREG_PORTD_DATA_SET  |= (1 << pin_num);
    // Configure safe state
    if(safe_state == HOLD)
    {
      temp_reg |= (HOLD << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      temp_reg |= (TRISTATE << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      temp_reg |= (LOW << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      temp_reg |= (HIGH << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTD_TRIPST = temp_reg;
    }  
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTD_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTD_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
       
  case PORTE:
    *pREG_PORTE_FER_CLR   |= (1 << pin_num);
    *pREG_PORTE_DIR_SET   |= (1 << pin_num); 
    *pREG_PORTE_DATA_SET  |= (1 << pin_num);
    // Configure safe state
    if(safe_state == HOLD)
    {
      temp_reg |= (HOLD << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      temp_reg |= (TRISTATE << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      temp_reg |= (LOW << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      temp_reg |= (HIGH << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTE_TRIPST = temp_reg;
    }  
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTE_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTE_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
       
  case PORTF:
    *pREG_PORTF_FER_CLR   |= (1 << pin_num);
    *pREG_PORTF_DIR_SET   |= (1 << pin_num); 
    *pREG_PORTF_DATA_SET  |= (1 << pin_num);
    // Configure safe state
    if(safe_state == HOLD)
    {
      temp_reg |= (HOLD << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }
    else if(safe_state == TRISTATE)
    {
      temp_reg |= (TRISTATE << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }
    else if(safe_state == LOW)
    {
      temp_reg |= (LOW << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }
    else if(safe_state == HIGH)
    {
      temp_reg |= (HIGH << (pin_num+2)) & (3 << (pin_num+2));
      *pREG_TEPADS1_PORTF_TRIPST = temp_reg;
    }  
    // Response
    if(response == EARLY)
      *pREG_TEPADS1_PORTF_TRIPSEL = 0;
    else if(response == LATE)
      *pREG_TEPADS1_PORTF_TRIPSEL = BITM_TEPADS_PORT_TRIPSEL_SEL;
    break;
  } 
}

