#include "device.h"
#include "CGUInit.h"
#include "VMU_Init.h"

#define SSYNC  asm("sev;isb;")

void SystemInit_user(void)
{
#ifdef ADI_ADSP_CM41X_M4
//    CGU_Init(16, 0, 2, 6, 1, 1, 5, 3, 3);           // PLL_CLK = 240, CCLK = 240, SYSCLK = 80, S0CLK = 80, S1CLK = 80, DCLK = 80, OUTCLK = 80
//    VMU_Init_Default();                   // VDDINT Monitoring Enable, VDDEXT Monitoring Enable, Fast Comparator On, VDDINT Ref. = 1.124, VDDEXT Ref. = 2.97, Fault Delay = 11us/12us  
 

 
   *pREG_M4P_SRAM_CFG |= BITM_M4P_SRAM_CFG_EERRCORE | BITM_M4P_SRAM_CFG_EERRDMA | BITM_M4P_SRAM_CFG_POSTWR;

    NVIC_EnableIRQ((IRQn_Type) INTR_M4P_CORE_SRAM_EERR);
    NVIC_EnableIRQ((IRQn_Type) INTR_M4P_DMA_SRAM_EERR);
 
   *pREG_FLC0_IMSK   = BITM_FLC_IMSK_MBERRF | BITM_FLC_IMSK_MBERRD | BITM_FLC_IMSK_MBERRC | BITM_FLC_IMSK_IFL;
   *pREG_FLC1_IMSK   = BITM_FLC_IMSK_MBERRF | BITM_FLC_IMSK_MBERRD | BITM_FLC_IMSK_MBERRC | BITM_FLC_IMSK_IFL;

    NVIC_EnableIRQ((IRQn_Type) INTR_FLC0_CORE_FLASH_EERR);
    NVIC_EnableIRQ((IRQn_Type) INTR_FLC0_DMA_FLASH_EERR);
	
#endif

}



//unsigned int core_err_count, DMA_err_count;
void M4P_CORE_SRAM_EERR_Handler(void)
{
  asm("BKPT 0;");
// *pREG_M4P_SRAM_EEADDR_CORE = BITM_M4P_SRAM_EEADDR_CORE_EERR | BITM_M4P_SRAM_EEADDR_CORE_MEERR;
//  core_err_count++;
  SSYNC;
}

void M4P_DMA_SRAM_EERR_Handler(void)
{
  asm("BKPT 0;");
// *pREG_M4P_SRAM_EEADDR_DMA = BITM_M4P_SRAM_EEADDR_DMA_EERR | BITM_M4P_SRAM_EEADDR_DMA_MEERR;
//  DMA_err_count++;
  SSYNC;
}

void FLC0_CORE_FLASH_EERR_Handler(void)
{
    asm("BKPT 0;");  
  SSYNC;
}

void FLC0_DMA_FLASH_EERR_Handler(void)
{
    asm("BKPT 0;");
  SSYNC;
}

