/*********************************************************************************

Copyright(c) 2011 Analog Devices, Inc. All Rights Reserved.

This software is proprietary and confidential.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.

*********************************************************************************/

/*!
 * @file:    adi_mdma_streams_cm41x.h
 * @brief:   Memory DMA Stream ID definitions for ADSP-CM40z processor family
 * @version: $Revision: 30757 $
 * @date:    $Date: 2015-04-24 16:33:48 -0400 (Fri, 24 Apr 2015) $
 *
 * @details
 *           This is an additional header file for the Memory DMA Manager service of
 *           ADSP-CM40z processor family, which contains the Memory DMA Stream ID
 *           definitions used in the APIs
 */

#ifndef __ADI_MDMA_STREAMS_CM41X_H__
#define __ADI_MDMA_STREAMS_CM41X_H__

/*==============  D E F I N E S  ===============*/

/* CM41X Channel IDs */
#if defined(ADI_ADSP_CM41X )

/** @ingroup MDMA_Manager
 * Memory DMA Stream IDs for ADSP-CM40z processor family
 */

typedef enum
{
    ADI_DMA_MEMDMA_S0,        /*!< Memory DMA Stream 0 */

    ADI_DMA_MEMDMA_END_COUNT  /* Number of Memory DMA Streams */

} ADI_DMA_STREAM_ID;

#endif  /* ADI_ADSP_CM41X  */

#endif  /* __ADI_MDMA_STREAMS_CM41X_H__ */

/*****/

/*@}*/

