/** @addtogroup Core_Timer_Service Core Timer Service
*  @{
*/

/*!****************************************************************************
 * @file    adi_ctmr.h
 * @brief   Primary include file for Analog Devices Core Timer Services
 * @version $Revision: 28758 $
 * @date    $Date: 2014-11-21 07:58:15 -0500 (Fri, 21 Nov 2014) $
 *-----------------------------------------------------------------------------

Copyright (c), 2014 - Analog Devices Inc. All Rights Reserved.
This software is proprietary & confidential to Analog Devices, Inc.
and its licensors.

*****************************************************************************/

#ifndef __ADI_CTMR_H__
#define __ADI_CTMR_H__

/*=============  I N C L U D E S   =============*/

#include <sys/platform.h> 

/* ADSP-SC58X Processor family */
#if defined(__ADSPSC589_FAMILY__)


/* Timer service includes */
#include "adi_ctmr_sc58x.h"

/* ADSP-BFxxx */
#elif defined (__ADSPBLACKFIN__)

/* Timer service includes */
#include "adi_ctmr_bfxxx.h"

#else
#error "Unknown processor family"
#endif

#endif  /* __ADI_CTMR_H__ */

/*@}*/

