/** @addtogroup Timer_Service GP Timer Service
*  @{
*/
/*!****************************************************************************
 * @file    adi_tmr.h
 * @brief   Primary include file for Analog Devices GP Timer Services
 * @version $Revision: 30690 $
 * @date    $Date: 2015-04-16 13:00:35 -0400 (Thu, 16 Apr 2015) $
 *
 * @details   This is the primary API header file for GP timer service.
*
 *-----------------------------------------------------------------------------

Copyright (c), 2014 - Analog Devices Inc. All Rights Reserved.
This software is proprietary & confidential to Analog Devices, Inc.
and its licensors.

*****************************************************************************/

#ifndef __ADI_TMR_H__
#define __ADI_TMR_H__

/*=============  I N C L U D E S   =============*/

#include <sys/platform.h>

/* ADSP-BF60x, ADSP-CM40z, ADSP-BF70x Processor family */
#if defined (__ADSPBF609_FAMILY__) || \
    defined(ADI_ADSP_CM40Z)        || \
    defined(ADI_ADSP_CM41X)        || \
    defined(__ADSPBF707_FAMILY__)  || \
    defined(__ADSPSC589_FAMILY__)


/* Timer service includes */
#include "adi_tmr_bf6xx.h"

/* ADSP-BF5xx */
#elif defined (__ADSPBLACKFIN__) && !defined(__ADSPBF60x__)

/* Timer service includes */
#include "adi_tmr_reg_bf5xx.h"
#include "adi_tmr_bf5xx.h"

#else
#error "Unknown processor family"
#endif

#endif  /* __ADI_TMR_H__ */

/*@}*/

