/*!
*********************************************************************************
Copyright(c) 2011 Analog Devices, Inc. All Rights Reserved.

This software is proprietary and confidential.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.

@file      adi_uart.c

@brief     Global UART driver file.

@details   This a global file which includes a specific file based on the processor family.
           This included file will be  containing  UART device  driver functions.

$Revision: 30757 $
$Date: 2015-04-24 16:33:48 -0400 (Fri, 24 Apr 2015) $
*********************************************************************************/

/* disable misra diagnostics as necessary */
#ifdef _MISRA_RULES
#pragma diag(push)
#pragma diag(suppress:misra_rule_2_4:"Allows doxygen addtogroup block")
#endif /* _MISRA_RULES */


#ifdef _MISRA_RULES
#pragma diag(pop)
#endif /* _MISRA_RULES */

#ifdef _MISRA_RULES
#pragma diag(push)
#pragma diag(suppress:misra_rule_5_1:"Identifiers shall not rely on the significance of more than 31 characters")
#pragma diag(suppress:misra_rule_8_5:"Allows portions of code to be commented out")
#pragma diag(suppress:misra_rule_2_4:"Allows doxygen addtogroup block")
#endif /* _MISRA_RULES */

#include "sys/platform.h"

#if defined(__ADSPBF609_FAMILY__) || \
    defined(__ADSPBF707_FAMILY__) || \
    defined(__ADSPSC589_FAMILY__) || \
    defined(ADI_ADSP_CM40Z)       || \
    defined(ADI_ADSP_CM41X)
#include "adi_uart_bf60x.c"
#else
#include "adi_uart_bf5xx.c"
#endif


#ifdef _MISRA_RULES
#pragma diag(pop)
#endif /* _MISRA_RULES */
