/*********************************************************************************

Copyright(c) 2011 Analog Devices, Inc. All Rights Reserved.

This software is proprietary and confidential.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.

*********************************************************************************/
/*!
 * @file      adi_dma.c
 * @brief     DMA Manager service.
 * @version:  $Revision: 30757 $
 * @date:     $Date: 2015-04-24 16:33:48 -0400 (Fri, 24 Apr 2015) $
 *
 * @details
 *            This is the the primary source file for DMA Manager Service
 *
 */

#include "sys/platform.h"

/** @addtogroup DMA_Manager DMA Manager
 *  @{
 */

/*=========  D M A   I M P L E M E N T A T I O N   S O U R C E   F I L E S  =========*/

/* ADSP-BF608/609 Processor family or
 * ADSP-CM402/CM403/CM407/CM408 Processor family or
 * ADSP-BF70x Processor family or
 * ADSP-SC58x Processor family
 */
#if defined (__ADSPBF609_FAMILY__) || \
    defined (ADI_ADSP_CM40Z)       || \
    defined (ADI_ADSP_CM41X)       || \
    defined (__ADSPBF707_FAMILY__) || \
    defined (__ADSPSC589_FAMILY__)

/* DMA Manager implementation source for ADSP-BF60x Processor family */
#include "adi_dma_bf60x.c"

/* ADSP-BF5xx Processor family */
#else

/* DMA Manager implementation source for ADSP-BF5xx Processor family */
#include "adi_dma_bf5xx.c"

#endif /* __ADSPBF60x__*/

/*****/

/*
** EOF
*/

/*@}*/

