/******************************************************************************

Copyright (c) 2013 Analog Devices.  All Rights Reserved.

This software is proprietary and confidential.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.
 *******************************************************************************
 *
 * @file:    adi_pwr.c
 * @brief:   Dynamic Power Management service implementation
 * @version: $Revision: 30769 $
 * @date:    $Date: 2015-04-27 11:30:00 -0400 (Mon, 27 Apr 2015) $
 *
 ******************************************************************************/

#include "sys/platform.h"

#if defined (__ADSPBF609_FAMILY__) || \
    defined(ADI_ADSP_CM40Z)        || \
    defined(ADI_ADSP_CM41X)

/* Dynamic Power Management service implementation source for ADSP-BF60x Processor family */
#include "adi_pwr_bf60x.c"

#elif defined(__ADSPSC589_FAMILY__) || defined (__ADSPBF707_FAMILY__)

/* Dynamic Power Management service implementation source for ADSP-SC58x and ADSP-BF70x Processor family */
#include "adi_pwr_v2.c"

#else

/* Dynamic Power Management service implementation source for ADSP-BF5xx Processor family */
#include "adi_pwr_bf5xx.c"

#endif /* __ADSPBF609_FAMILY__*/
