/* ================================================================================

     Project      :   CM41X_M4
     File         :   CM41X_M4_device.h
     Description  :   C Register Definitions

     Date         :   Feb 27, 2015

     Copyright (c) Analog Devices, Inc.  All Rights Reserved.
     This software is proprietary and confidential to Analog Devices, Inc. and
     its licensors.

     This file was auto-generated. Do not make local changes to this file.

   ================================================================================ */

#ifndef _CM41X_M4_DEVICE_H
#define _CM41X_M4_DEVICE_H

/* pickup integer types */
#include <stdint.h>

/* pickup system typedefs */
#include "CM41x_M4_typedefs.h"

/* pickup register bitfield and bit masks */
#include "CM41x_M4_cdef.h"


#ifndef __IO
  #ifdef __cplusplus
    #define     __I     volatile      /* read-only */
    #define
  #else
    #define     __I     volatile      /* read-only */
    #define             const
  #endif
  #define       __O     volatile      /* write-only */
  #define       __IO    volatile      /* read-write */
#endif

#if defined (_MISRA_RULES)
/*
  anonymous unions violate ISO 9899:1990 and therefore MISRA Rule 1.1.
  Use of unions violates MISRA Rule 18.4.
  Anonymous unions are required for this implementation.
  Re-use of identifiers violates MISRA Rule 5.7.
  Field names are repeated for the CM41X_M4 register map.
*/
#pragma diag(push)
#pragma diag(suppress:misra_rule_1_1:"Allow anonymous unions")
#pragma diag(suppress:misra_rule_5_7:"Header will re-use identifiers")
#pragma diag(suppress:misra_rule_18_4:"Allow the use of a union")
#endif /* _MISRA_RULES */

#if defined ( __CC_ARM   )
#pragma anon_unions
#endif

/** @defgroup C_CFG0 Pads Controller (C_CFG0) Module
 *  Pads Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_C_CFG0_TypeDef
 *  \brief  Pads Controller
 *  ========================================================================== */
typedef struct _ADI_C_CFG0_TypeDef
{
    __I      uint8_t  RESERVED0[16];
    __IO     uint32_t DMA_MUXCTL;                    /*!< Peripheral DMA Multiplexer Control */
    __IO     uint32_t PWM_SYS_CFG;                   /*!< PWM System Configuration Register */
    __IO     uint32_t MBIST_CTL;                     /*!< MBIST Control Register */
    __IO     uint32_t SINC_TEST;                     /*!< SINC Test Register */
    __I      uint8_t  RESERVED1[32];
    __I      uint32_t SYSSTAT;                       /*!< System Status Register */
    __I      uint8_t  RESERVED2[12];
    __IO     uint32_t CLKNG_TRIPEN;                  /*!< Clock Not Good Trip Register */
    __I      uint8_t  RESERVED3[4];
    __IO     uint32_t FAULT_TRIPEN;                  /*!< Fault Trip Register */
    __I      uint8_t  RESERVED4[4];
    __IO     uint32_t ROT_UPDN_CFG;                  /*!< Rotary Counter Up/Down Configuration Register */
    __I      uint8_t  RESERVED5[12];
    __IO     uint32_t AHB_RESP_CFG;                  /*!< AHB Response Configuration Register */
    __IO     uint32_t AHB_TIMEOUT_VALUE;             /*!< AHB Timeout Value Register */
    __I      uint8_t  RESERVED6[8];
    __IO     uint32_t ENG_MODE_CFG0;                 /*!< Engineering Mode Configuration Register 0 */
    __IO     uint32_t LROM_STAT;                     /*!< Logic ROM status register */
} ADI_C_CFG0_TypeDef;

/*!@}*/

/** @defgroup TEPADS_CFG0 Pads Controller (TEPADS_CFG0) Module
 *  Pads Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TEPADS_CFG0_TypeDef
 *  \brief  Pads Controller
 *  ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t PCFG0;                         /*!< Peripheral Configuration0 Register */
    __I      uint8_t  RESERVED1[64];
    __IO     uint32_t FOCP_DIV;                      /*!< Fast Over Current Protection Clock Divisor */
    __I      uint8_t  RESERVED2[36];
    __IO     uint32_t DBC_PRESCALE;                  /*!< Debounce Prescale Register */
    __I      uint8_t  RESERVED3[12];
    __IO     uint32_t DBC_CTL[4];                    /*!< Debounce  Control Register(s) */
    __I      uint8_t  RESERVED4[16];
    __IO     uint32_t VMU_CTL;                       /*!< Voltage Monitor Unit Control Register */
    __IO     uint32_t VMU_TEST;                      /*!< Voltage Monitor Unit Test Register */
    __IO     uint32_t VMU_TRIPEN;                    /*!< Voltage Monitor Unit Trip Enable Register */
    __IO     uint32_t NVWR_RSTCTL;                   /*!< Non-Volatile Write Reset Control Register */
    __IO     uint32_t MONOSC_CFG;                    /*!< Monitor Oscillator Control Register */
    __I      uint8_t  RESERVED5[76];
    __IO     uint32_t PORT_DS[5];                    /*!< Multiport Drive Strength Register */
    __I      uint8_t  RESERVED6[12];
    __IO     uint32_t PORT_RCTL[5];                  /*!< Multiport Pullup/Pulldown Resistor Control Register */
    __I      uint8_t  RESERVED7[12];
    __IO     uint32_t PORT_TRIPST[5];                /*!< Multiport Trip State Register */
    __I      uint8_t  RESERVED8[12];
    __IO     uint32_t PORT_TRIPSEL[5];               /*!< Multiport Trip Select */
} ADI_TEPADS_CFG0_TypeDef;

/*!@}*/

/** @defgroup EMUID CHIP ID For ARM Emulators (EMUID) Module
 *  CHIP ID For ARM Emulators
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_EMUID_TypeDef
 *  \brief  CHIP ID For ARM Emulators
 *  ========================================================================== */
typedef struct _ADI_EMUID_TypeDef
{
    __I      uint8_t  RESERVED0[32];
    __I      uint16_t ADIID;                         /*!< Analog Devices Identification */
    __I      uint8_t  RESERVED1[2];
    __I      uint16_t CHIPID;                        /*!< Chip Identification */
} ADI_EMUID_TypeDef;

/*!@}*/

/** @defgroup PINT PINT (PINT) Module
 *  PINT
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_PINT_TypeDef
 *  \brief  PINT
 *  ========================================================================== */
typedef struct _ADI_PINT_TypeDef
{
    __IO     uint32_t MSK_SET;                       /*!< Pint Mask Set Register */
    __IO     uint32_t MSK_CLR;                       /*!< Pint Mask Clear Register */
    __IO     uint32_t REQ;                           /*!< Pint Request Register */
    __IO     uint32_t ASSIGN;                        /*!< Pint Assign Register */
    __IO     uint32_t EDGE_SET;                      /*!< Pint Edge Set Register */
    __IO     uint32_t EDGE_CLR;                      /*!< Pint Edge Clear Register */
    __IO     uint32_t INV_SET;                       /*!< Pint Invert Set Register */
    __IO     uint32_t INV_CLR;                       /*!< Pint Invert Clear Register */
    __I      uint32_t PINSTATE;                      /*!< Pint Pinstate Register */
    __IO     uint32_t LATCH;                         /*!< Pint Latch Register */
} ADI_PINT_TypeDef;

/*!@}*/

/** @defgroup PORT_CFG0 General Purpose Input/Output (PORT_CFG0) Module
 *  General Purpose Input/Output
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_PORT_CFG0_TypeDef
 *  \brief  General Purpose Input/Output
 *  ========================================================================== */
typedef struct _ADI_PORT_CFG0_TypeDef
{
    __IO     uint32_t FER;                           /*!< Port x Function Enable Register */
    __IO     uint32_t FER_SET;                       /*!< Port x Function Enable Set Register */
    __IO     uint32_t FER_CLR;                       /*!< Port x Function Enable Clear Register */
    __IO     uint32_t DATA;                          /*!< Port x GPIO Data Register */
    __IO     uint32_t DATA_SET;                      /*!< Port x GPIO Data Set Register */
    __IO     uint32_t DATA_CLR;                      /*!< Port x GPIO Data Clear Register */
    __IO     uint32_t DIR;                           /*!< Port x GPIO Direction Register */
    __IO     uint32_t DIR_SET;                       /*!< Port x GPIO Direction Set Register */
    __IO     uint32_t DIR_CLR;                       /*!< Port x GPIO Direction Clear Register */
    __IO     uint32_t INEN;                          /*!< Port x GPIO Input Enable Register */
    __IO     uint32_t INEN_SET;                      /*!< Port x GPIO Input Enable Set Register */
    __IO     uint32_t INEN_CLR;                      /*!< Port x GPIO Input Enable Clear Register */
    __IO     uint32_t MUX;                           /*!< Port x Multiplexer Control Register */
    __IO     uint32_t DATA_TGL;                      /*!< Port x GPIO Input Enable Toggle Register */
    __IO     uint32_t POL;                           /*!< Port x GPIO Polarity Invert Register */
    __IO     uint32_t POL_SET;                       /*!< Port x GPIO Polarity Invert Set Register */
    __IO     uint32_t POL_CLR;                       /*!< Port x GPIO Polarity Invert Clear Register */
    __IO     uint32_t LOCK;                          /*!< Port x GPIO Lock Register */
    __IO     uint32_t TRIG_TGL;                      /*!< Port x GPIO Trigger Toggle Register */
} ADI_PORT_CFG0_TypeDef;

/*!@}*/

/** @defgroup LBA0 Logic Block Array (LBA0) Module
 *  Logic Block Array
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_LBA0_TypeDef
 *  \brief  Logic Block Array
 *  ========================================================================== */
typedef struct _ADI_LBA0_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t CLK_CTL;                       /*!< Logic Block Array Clock Divisor */
    __IO     uint32_t DIR;                           /*!< Logic Block Array Pin Direction */
    __IO     uint32_t DIN;                           /*!< Logic Block Array Data Input */
    __I      uint32_t DOUT;                          /*!< Logic Block Array Data Output */
    __IO     uint32_t CFG;                           /*!< Logic Block Array Configuration Register */
    __IO     uint32_t SYNC_CTL;                      /*!< Logic Block Array GPIO Input Synchronization Control */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t BLK_CTL[8];                    /*!< Logic Block Control Register */
    __I      uint8_t  RESERVED2[192];
    __IO     uint32_t BLK_FN0[8];                    /*!< Logic Block Function 0 Register */
} ADI_LBA0_TypeDef;

/*!@}*/

/** @defgroup SEC_CFG0 System Event Controller (SEC_CFG0) Module
 *  System Event Controller
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_SB_TypeDef
 *! \brief  SSI Registers
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_SB_TypeDef
{
    __IO     uint32_t SCTL;                          /*!< Source Control Register n */
    __IO     uint32_t SSTAT;                         /*!< Source Status Register n */
} ADI_SEC_CFG0_SB_TypeDef;


/*! ==========================================================================
 *  \struct ADI_SEC_CFG0_TypeDef
 *  \brief  System Event Controller
 *  ========================================================================== */
typedef struct _ADI_SEC_CFG0_TypeDef
{
    __IO     uint32_t GCTL;                          /*!< Global Control Register */
    __IO     uint32_t GSTAT;                         /*!< Global Status Register */
    __IO     uint32_t RAISE;                         /*!< Global Raise Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t FCTL;                          /*!< Fault Control Register */
    __IO     uint32_t FSTAT;                         /*!< Fault Status Register */
    __I      uint32_t FSID;                          /*!< Fault Source ID Register */
    __IO     uint32_t FEND;                          /*!< Fault End Register */
    __IO     uint32_t FDLY;                          /*!< Fault Delay Register */
    __I      uint32_t FDLY_CUR;                      /*!< Fault Delay Current Register */
    __IO     uint32_t FSRDLY;                        /*!< Fault System Reset Delay Register */
    __I      uint32_t FSRDLY_CUR;                    /*!< Fault System Reset Delay Current Register */
    __IO     uint32_t FCOPP;                         /*!< Fault COP Period Register */
    __I      uint32_t FCOPP_CUR;                     /*!< Fault COP Period Current Register */
    __I      uint8_t  RESERVED1[1992];
    ADI_SEC_CFG0_SB_TypeDef SB[164];             /*!< SSI Registers */
} ADI_SEC_CFG0_TypeDef;

/*!@}*/

/** @defgroup WDOG Watch Dog Timer Unit (WDOG) Module
 *  Watch Dog Timer Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_WDOG_TypeDef
 *  \brief  Watch Dog Timer Unit
 *  ========================================================================== */
typedef struct _ADI_WDOG_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t CNT;                           /*!< Count Register */
    __IO     uint32_t STAT;                          /*!< Watchdog Timer Status Register */
} ADI_WDOG_TypeDef;

/*!@}*/

/** @defgroup RCU Reset Control Unit (RCU) Module
 *  Reset Control Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_RCU_TypeDef
 *  \brief  Reset Control Unit
 *  ========================================================================== */
typedef struct _ADI_RCU_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t CRCTL;                         /*!< Core Reset outputs Control Register */
    __IO     uint32_t CRSTAT;                        /*!< Core Reset outputs Status Register */
    __I      uint8_t  RESERVED0[8];
    __IO     uint32_t SRRQSTAT;                      /*!< System Reset Request Status */
    __I      uint8_t  RESERVED1[8];
    __IO     uint32_t SVECT_LCK;                     /*!< SVECT Lock Register */
    __IO     uint32_t BCODE;                         /*!< Boot Code Register */
    __IO     uint32_t SVECT0;                        /*!< Software Vector Register 0 */
    __IO     uint32_t SVECT1;                        /*!< Software Vector Register 1 */
    __I      uint8_t  RESERVED2[56];
    __IO     uint32_t MSG;                           /*!< Message Register */
    __IO     uint32_t MSG_SET;                       /*!< Message Set Bits Register */
    __IO     uint32_t MSG_CLR;                       /*!< Message Clear Bits Register */
    __I      uint8_t  RESERVED3[4];
    __I      uint32_t REVID;                         /*!< Revision ID Register */
} ADI_RCU_TypeDef;

/*!@}*/

/** @defgroup DPM Dynamic Power Management (DPM) Module
 *  Dynamic Power Management
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_DPM_TypeDef
 *  \brief  Dynamic Power Management
 *  ========================================================================== */
typedef struct _ADI_DPM_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint8_t  RESERVED0[20];
    __IO     uint32_t WAKE_EN;                       /*!< Wakeup Enable Register */
    __IO     uint32_t WAKE_POL;                      /*!< Wakeup Polarity Register */
    __IO     uint32_t WAKE_STAT;                     /*!< Wakeup Status Register */
    __I      uint8_t  RESERVED1[72];
    __IO     uint32_t PER_DIS0;                      /*!< Peripherals Disable Register 0 */
    __I      uint8_t  RESERVED2[16];
    __I      uint32_t REVID;                         /*!< Revision ID */
} ADI_DPM_TypeDef;

/*!@}*/

/** @defgroup CGU Clock Generation Unit (CGU) Module
 *  Clock Generation Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_CGU_TypeDef
 *  \brief  Clock Generation Unit
 *  ========================================================================== */
typedef struct _ADI_CGU_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t PLLCTL;                        /*!< PLL Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t DIV;                           /*!< Clocks Divisor Register */
    __IO     uint32_t CLKOUTSEL;                     /*!< CLKOUT Select Register */
    __IO     uint32_t OSCWDCTL;                      /*!< Oscillator Watchdog Register */
    __IO     uint32_t TSCTL;                         /*!< Timestamp Control Register */
    __IO     uint32_t TSVALUE0;                      /*!< Timestamp Counter Initial 32 LSB Value Register */
    __IO     uint32_t TSVALUE1;                      /*!< Timestamp Counter Initial MSB Value Register */
    __I      uint32_t TSCOUNT0;                      /*!< Time Stamp Counter 32 LSB Register */
    __I      uint32_t TSCOUNT1;                      /*!< Time Stamp Counter 32 MSB Register */
    __IO     uint32_t CCBF_DIS;                      /*!< Core Clock Buffer Disable Register */
    __I      uint32_t CCBF_STAT;                     /*!< Core Clock Buffer Status Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t SCBF_DIS;                      /*!< System Clock Buffer Disable Register */
    __I      uint32_t SCBF_STAT;                     /*!< System Clock Buffer Status Register */
    __I      uint8_t  RESERVED1[8];
    __I      uint32_t REVID;                         /*!< Revision ID Register */
} ADI_CGU_TypeDef;

/*!@}*/

/** @defgroup OCU Oscillator Counter Unit (OCU) Module
 *  Oscillator Counter Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_OCU_TypeDef
 *  \brief  Oscillator Counter Unit
 *  ========================================================================== */
typedef struct _ADI_OCU_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control register */
    __IO     uint32_t STAT;                          /*!< Status register */
    __I      uint32_t CLKCNT;                        /*!< Freq. measured count register */
    __IO     uint32_t REFCNT;                        /*!< Freq measurement reference count register */
    __IO     uint32_t MINCNT;                        /*!< Min. limit register */
    __IO     uint32_t MAXCNT;                        /*!< Max. limit register */
    __IO     uint32_t LMONCNT;                       /*!< LFO monitor reference count */
    __IO     uint32_t CMONCNT;                       /*!< Clkin monitor reference count */
    __I      uint8_t  RESERVED0[4016];
    __I      uint32_t PID4;                          /*!< Peripheral ID4Register */
    __I      uint32_t PID5;                          /*!< Peripheral ID5Register */
    __I      uint32_t PID6;                          /*!< Peripheral ID6Register */
    __I      uint32_t PID7;                          /*!< Peripheral ID7Register */
    __I      uint32_t PID0;                          /*!< Peripheral ID0Register */
    __I      uint32_t PID1;                          /*!< Peripheral ID1Register */
    __I      uint32_t PID2;                          /*!< Peripheral ID3Register */
    __I      uint32_t PID3;                          /*!< Peripheral ID3Register */
    __I      uint32_t CID0;                          /*!< Component ID0 Register */
    __I      uint32_t CID1;                          /*!< Component ID1 Register */
    __I      uint32_t CID2;                          /*!< Component ID2 Register */
    __I      uint32_t CID3;                          /*!< Component ID3 Register */
} ADI_OCU_TypeDef;

/*!@}*/

/** @defgroup TAPC TAPC (TAPC) Module
 *  TAPC
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TAPC_TypeDef
 *  \brief  TAPC
 *  ========================================================================== */
typedef struct _ADI_TAPC_TypeDef
{
    __I      uint32_t IDCODE;                        /*!< IDCODE Register */
    __I      uint32_t USERCODE;                      /*!< USERCODE Register */
    __IO     uint32_t SDBGKEY_CTL;                   /*!< Secure Debug Key Control Register */
    __I      uint32_t SDBGKEY_STAT;                  /*!< Secure Debug Key Status Register */
    __IO     uint32_t SDBGKEY0;                      /*!< Secure Debug Key 0 Register */
    __IO     uint32_t SDBGKEY1;                      /*!< Secure Debug Key 1 Register */
    __IO     uint32_t SDBGKEY2;                      /*!< Secure Debug Key 2 Register */
    __IO     uint32_t SDBGKEY3;                      /*!< Secure Debug Key 3 Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t TESTKEY0;                      /*!< TESTKEY Value Register */
    __I      uint8_t  RESERVED1[8];
    __IO     uint32_t DBGCTL;                        /*!< Debug Control */
    __IO     uint32_t DBGSTAT;                       /*!< Debug Status Register */
    __I      uint8_t  RESERVED2[24];
    __IO     uint32_t SDBGKEYCMP0;                   /*!< Secure Debug Key 0 key compare register */
    __IO     uint32_t SDBGKEYCMP1;                   /*!< Secure Debug Key 1 key compare register */
    __IO     uint32_t SDBGKEYCMP2;                   /*!< Secure Debug Key 2 key compare register */
    __IO     uint32_t SDBGKEYCMP3;                   /*!< Secure Debug Key 3 key compare register */
    __I      uint8_t  RESERVED3[16];
    __IO     uint32_t SDBGKEYID0;                    /*!< Secure Debug Key 0 key identification register */
    __IO     uint32_t SDBGKEYID1;                    /*!< Secure Debug Key 1 key identification register */
    __IO     uint32_t SDBGKEYID2;                    /*!< Secure Debug Key 2 key identification register */
    __IO     uint32_t SDBGKEYID3;                    /*!< Secure Debug Key 3 key identification register */
    __I      uint8_t  RESERVED4[96];
    __IO     uint32_t SCMSG;                         /*!< Secure Run Control Message register */
    __IO     uint32_t SCMSG_SET;                     /*!< Secure Run Control Message Set register */
    __IO     uint32_t SCMSG_CLR;                     /*!< Secure Run Control Message Clear register */
    __IO     uint32_t SCMSG_TGL;                     /*!< Secure Run Control Message Toggle register */
    __IO     uint32_t RCMSG;                         /*!< Run Control Message register */
    __IO     uint32_t RCMSG_SET;                     /*!< Run Control Message Set register */
    __IO     uint32_t RCMSG_CLR;                     /*!< Run Control Message Clear register */
    __IO     uint32_t RCMSG_TGL;                     /*!< Run Control Message Toggle register */
} ADI_TAPC_TypeDef;

/*!@}*/

/** @defgroup TRU_CFG0 Trigger Routing Unit (TRU_CFG0) Module
 *  Trigger Routing Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TRU_CFG0_TypeDef
 *  \brief  Trigger Routing Unit
 *  ========================================================================== */
typedef struct _ADI_TRU_CFG0_TypeDef
{
    __IO     uint32_t SSR[135];                      /*!< Slave Select Register */
    __I      uint8_t  RESERVED0[1476];
    __IO     uint32_t MTR;                           /*!< Master Trigger Register */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t ERRADDR;                       /*!< Error Address Register */
    __IO     uint32_t STAT;                          /*!< Status Information Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t GCTL;                          /*!< Global Control Register */
} ADI_TRU_CFG0_TypeDef;

/*!@}*/

/** @defgroup TIMER General-Purpose Timer Block (TIMER) Module
 *  General-Purpose Timer Block
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TMR_TypeDef
 *! \brief  TIMER0 Module's TMR register block
 * ========================================================================== */
typedef struct _ADI_TIMER_TMR_TypeDef
{
    __IO     uint32_t CFG;                           /*!< Timer n Configuration Register */
    __I      uint32_t CNT;                           /*!< Timer n Counter Register */
    __IO     uint32_t PER;                           /*!< Timer n Period Register */
    __IO     uint32_t WID;                           /*!< Timer n Width Register */
    __IO     uint32_t DLY;                           /*!< Timer n Delay Register */
    __I      uint8_t  RESERVED0[12];
} ADI_TIMER_TMR_TypeDef;


/*! ==========================================================================
 *  \struct ADI_TIMER_TypeDef
 *  \brief  General-Purpose Timer Block
 *  ========================================================================== */
typedef struct _ADI_TIMER_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t RUN;                           /*!< Run Register */
    __IO     uint32_t RUN_SET;                       /*!< Run Set Register */
    __IO     uint32_t RUN_CLR;                       /*!< Run Clear Register */
    __IO     uint32_t STOP_CFG;                      /*!< Stop Configuration Register */
    __IO     uint32_t STOP_CFG_SET;                  /*!< Stop Configuration Set Register */
    __IO     uint32_t STOP_CFG_CLR;                  /*!< Stop Configuration Clear Register */
    __IO     uint32_t DATA_IMSK;                     /*!< Data Interrupt Mask Register */
    __IO     uint32_t STAT_IMSK;                     /*!< Status Interrupt Mask Register */
    __IO     uint32_t TRG_MSK;                       /*!< Trigger Master Mask Register */
    __IO     uint32_t TRG_IE;                        /*!< Trigger Slave Enable Register */
    __IO     uint32_t DATA_ILAT;                     /*!< Data Interrupt Latch Register */
    __IO     uint32_t STAT_ILAT;                     /*!< Status Interrupt Latch Register */
    __I      uint32_t ERR_TYPE;                      /*!< Error Type Status Register */
    __IO     uint32_t BCAST_PER;                     /*!< Broadcast Period Register */
    __IO     uint32_t BCAST_WID;                     /*!< Broadcast Width Register */
    __IO     uint32_t BCAST_DLY;                     /*!< Broadcast Delay Register */
    __I      uint8_t  RESERVED1[28];
    ADI_TIMER_TMR_TypeDef TMR[8];                /*!<  */
} ADI_TIMER_TypeDef;

/*!@}*/

/** @defgroup CNT CNT (CNT) Module
 *  CNT
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_CNT_TypeDef
 *  \brief  CNT
 *  ========================================================================== */
typedef struct _ADI_CNT_TypeDef
{
    __IO     uint32_t CFG;                           /*!< Configuration Register */
    __IO     uint32_t IMSK;                          /*!< Interrupt Mask Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t CMD;                           /*!< Command Register */
    __IO     uint32_t DEBNCE;                        /*!< Debounce Register */
    __IO     uint32_t CNTR;                          /*!< Counter Register */
    __IO     uint32_t MAX;                           /*!< Maximum Count Register */
    __IO     uint32_t MIN;                           /*!< Minimum Count Register */
    __IO     uint32_t MDIV;                          /*!< M Value for Divider */
    __IO     uint32_t NDIV;                          /*!< N Value for Divider */
} ADI_CNT_TypeDef;

/*!@}*/

/** @defgroup TWI 2-Wire Interface (TWI) Module
 *  2-Wire Interface
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TWI_TypeDef
 *  \brief  2-Wire Interface
 *  ========================================================================== */
typedef struct _ADI_TWI_TypeDef
{
    __IO     uint32_t CLKDIV;                        /*!< SCL Clock Divider Register */
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t SLVCTL;                        /*!< Slave Mode Control Register */
    __I      uint32_t SLVSTAT;                       /*!< Slave Mode Status Register */
    __IO     uint32_t SLVADDR;                       /*!< Slave Mode Address Register */
    __IO     uint32_t MSTRCTL;                       /*!< Master Mode Control Registers */
    __IO     uint32_t MSTRSTAT;                      /*!< Master Mode Status Register */
    __IO     uint32_t MSTRADDR;                      /*!< Master Mode Address Register */
    __IO     uint32_t ISTAT;                         /*!< Interrupt Status Register */
    __IO     uint32_t IMSK;                          /*!< Interrupt Mask Register */
    __IO     uint32_t FIFOCTL;                       /*!< FIFO Control Register */
    __I      uint32_t FIFOSTAT;                      /*!< FIFO Status Register */
    __I      uint8_t  RESERVED0[80];
    __IO     uint32_t TXDATA8;                       /*!< Tx Data Single-Byte Register */
    __IO     uint32_t TXDATA16;                      /*!< Tx Data Double-Byte Register */
    __IO     uint32_t RXDATA8;                       /*!< Rx Data Single-Byte Register */
    __IO     uint32_t RXDATA16;                      /*!< Rx Data Double-Byte Register */
} ADI_TWI_TypeDef;

/*!@}*/

/** @defgroup CAN Controller Area Network (CAN) Module
 *  Controller Area Network
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_TypeDef
 *! \brief  Number of Mailbox Registers
 * ========================================================================== */
typedef struct _ADI_CAN_MB_TypeDef
{
    __IO     uint32_t DATA0;                         /*!< Mailbox Word 0 Register */
    __IO     uint32_t DATA1;                         /*!< Mailbox Word 1 Register */
    __IO     uint32_t DATA2;                         /*!< Mailbox Word 2 Register */
    __IO     uint32_t DATA3;                         /*!< Mailbox Word 3 Register */
    __IO     uint32_t LENGTH;                        /*!< Mailbox Length Register */
    __IO     uint32_t TIMESTAMP;                     /*!< Mailbox Timestamp Register */
    __IO     uint32_t ID0;                           /*!< Mailbox ID 0 Register */
    __IO     uint32_t ID1;                           /*!< Mailbox ID 1 Register */
} ADI_CAN_MB_TypeDef;


/* ==========================================================================
 *! \struct ADI_CAN_AM_TypeDef
 *! \brief  Number of Acceptance Mask Registers
 * ========================================================================== */
typedef struct _ADI_CAN_AM_TypeDef
{
    __IO     uint32_t L;                             /*!< Acceptance Mask (L) Register */
    __IO     uint32_t H;                             /*!< Acceptance Mask (H) Register */
} ADI_CAN_AM_TypeDef;


/*! ==========================================================================
 *  \struct ADI_CAN_TypeDef
 *  \brief  Controller Area Network
 *  ========================================================================== */
typedef struct _ADI_CAN_TypeDef
{
    __IO     uint32_t MC1;                           /*!< Mailbox Configuration 1 Register */
    __IO     uint32_t MD1;                           /*!< Mailbox Direction 1 Register */
    __IO     uint32_t TRS1;                          /*!< Transmission Request Set 1 Register */
    __IO     uint32_t TRR1;                          /*!< Transmission Request Reset 1 Register */
    __IO     uint32_t TA1;                           /*!< Transmission Acknowledge 1 Register */
    __IO     uint32_t AA1;                           /*!< Abort Acknowledge 1 Register */
    __IO     uint32_t RMP1;                          /*!< Receive Message Pending 1 Register */
    __I      uint32_t RML1;                          /*!< Receive Message Lost 1 Register */
    __IO     uint32_t MBTIF1;                        /*!< Mailbox Transmit Interrupt Flag 1 Register */
    __IO     uint32_t MBRIF1;                        /*!< Mailbox Receive Interrupt Flag 1 Register */
    __IO     uint32_t MBIM1;                         /*!< Mailbox Interrupt Mask 1 Register */
    __IO     uint32_t RFH1;                          /*!< Remote Frame Handling 1 Register */
    __IO     uint32_t OPSS1;                         /*!< Overwrite Protection/Single Shot Transmission 1 Register */
    __I      uint8_t  RESERVED0[12];
    __IO     uint32_t MC2;                           /*!< Mailbox Configuration 2 Register */
    __IO     uint32_t MD2;                           /*!< Mailbox Direction 2 Register */
    __IO     uint32_t TRS2;                          /*!< Transmission Request Set 2 Register */
    __IO     uint32_t TRR2;                          /*!< Transmission Request Reset 2 Register */
    __IO     uint32_t TA2;                           /*!< Transmission Acknowledge 2 Register */
    __IO     uint32_t AA2;                           /*!< Abort Acknowledge 2 Register */
    __IO     uint32_t RMP2;                          /*!< Receive Message Pending 2 Register */
    __I      uint32_t RML2;                          /*!< Receive Message Lost 2 Register */
    __IO     uint32_t MBTIF2;                        /*!< Mailbox Transmit Interrupt Flag 2 Register */
    __IO     uint32_t MBRIF2;                        /*!< Mailbox Receive Interrupt Flag 2 Register */
    __IO     uint32_t MBIM2;                         /*!< Mailbox Interrupt Mask 2 Register */
    __IO     uint32_t RFH2;                          /*!< Remote Frame Handling 2 Register */
    __IO     uint32_t OPSS2;                         /*!< Overwrite Protection/Single Shot Transmission 2 Register */
    __I      uint8_t  RESERVED1[12];
    __IO     uint32_t CLK;                           /*!< Clock Register */
    __IO     uint32_t TIMING;                        /*!< Timing Register */
    __IO     uint32_t DBG;                           /*!< Debug Register */
    __I      uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t CEC;                           /*!< Error Counter Register */
    __IO     uint32_t GIS;                           /*!< Global CAN Interrupt Status Register */
    __IO     uint32_t GIM;                           /*!< Global CAN Interrupt Mask Register */
    __I      uint32_t GIF;                           /*!< Global CAN Interrupt Flag Register */
    __IO     uint32_t CTL;                           /*!< CAN Master Control Register */
    __IO     uint32_t INT;                           /*!< Interrupt Pending Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t MBTD;                          /*!< Temporary Mailbox Disable Register */
    __IO     uint32_t EWR;                           /*!< Error Counter Warning Level Register */
    __IO     uint32_t ESR;                           /*!< Error Status Register */
    __I      uint8_t  RESERVED3[12];
    __IO     uint32_t UCCNT;                         /*!< Universal Counter Register */
    __IO     uint32_t UCRC;                          /*!< Universal Counter Reload/Capture Register */
    __IO     uint32_t UCCNF;                         /*!< Universal Counter Configuration Mode Register */
    __I      uint8_t  RESERVED4[48];
    ADI_CAN_AM_TypeDef AM[32];                   /*!< Number of Acceptance Mask Registers */
    ADI_CAN_MB_TypeDef MB[32];                   /*!< Number of Mailbox Registers */
} ADI_CAN_TypeDef;

/*!@}*/

/** @defgroup CPTMR Capture Timer (CPTMR) Module
 *  Capture Timer
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_CT_TypeDef
 *! \brief  Capture Timer
 * ========================================================================== */
typedef struct _ADI_CPTMR_CT_TypeDef
{
    __IO     uint32_t CFG;                           /*!< Configuration */
    __IO     uint32_t CNT;                           /*!< Counter */
    __I      uint32_t TON;                           /*!< On Time Capture */
    __I      uint8_t  RESERVED0[116];
} ADI_CPTMR_CT_TypeDef;


/*! ==========================================================================
 *  \struct ADI_CPTMR_TypeDef
 *  \brief  Capture Timer
 *  ========================================================================== */
typedef struct _ADI_CPTMR_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t RUN;                           /*!< Run */
    __IO     uint32_t RUN_SET;                       /*!< Run Set */
    __IO     uint32_t RUN_CLR;                       /*!< Run Clear */
    __IO     uint32_t DATA_IMSK;                     /*!< Data Imask */
    __IO     uint32_t DATA_IMSK_SET;                 /*!< Data Imask Set */
    __IO     uint32_t DATA_IMSK_CLR;                 /*!< Data Imask Clear */
    __IO     uint32_t STAT_IMSK;                     /*!< Status Imask */
    __IO     uint32_t STAT_IMSK_SET;                 /*!< Status Imask Set */
    __IO     uint32_t STAT_IMSK_CLR;                 /*!< Status Imask Clear */
    __IO     uint32_t DATA_ILAT;                     /*!< Data Ilat */
    __IO     uint32_t STAT_ILAT;                     /*!< Status Ilat */
    __I      uint8_t  RESERVED1[2000];
    ADI_CPTMR_CT_TypeDef CT[3];                  /*!< Capture Timer */
} ADI_CPTMR_TypeDef;

/*!@}*/

/** @defgroup PWM Pulse-Width Modulator (PWM) Module
 *  Pulse-Width Modulator
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_PWM_TypeDef
 *  \brief  Pulse-Width Modulator
 *  ========================================================================== */
typedef struct _ADI_PWM_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t CHANCFG;                       /*!< Channel Config Register */
    __IO     uint32_t TRIPCFG;                       /*!< Trip Config Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t IMSK;                          /*!< Interrupt Mask Register */
    __IO     uint32_t ILAT;                          /*!< Interrupt Latch Register */
    __IO     uint32_t CHOPCFG;                       /*!< Chop Configuration Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t SYNC_WID;                      /*!< Sync Pulse Width Register */
    __IO     uint32_t TM0;                           /*!< Timer 0 Period Register */
    __IO     uint32_t TM1;                           /*!< Timer 1 Period Register */
    __IO     uint32_t TM2;                           /*!< Timer 2 Period Register */
    __IO     uint32_t TM3;                           /*!< Timer 3 Period Register */
    __IO     uint32_t TM4;                           /*!< Timer 4 Period Register */
    __IO     uint32_t DLYA;                          /*!< Channel A Delay Register */
    __IO     uint32_t DLYB;                          /*!< Channel B Delay Register */
    __IO     uint32_t DLYC;                          /*!< Channel C Delay Register */
    __IO     uint32_t DLYD;                          /*!< Channel D Delay Register */
    __IO     uint32_t ACTL;                          /*!< Channel A Control Register */
    __IO     uint32_t AH0;                           /*!< Channel A-High Duty-0 Register */
    __IO     uint32_t AH1;                           /*!< Channel A-High Duty-1 Register */
    __IO     uint32_t AH0_HP;                        /*!< Channel A-High Heightened-Precision Duty-0 Register */
    __IO     uint32_t AH1_HP;                        /*!< Channel A-High Heightened-Precision Duty-1 Register */
    __IO     uint32_t AL0;                           /*!< Channel A-Low Duty-0 Register */
    __IO     uint32_t AL1;                           /*!< Channel A-Low Duty-1 Register */
    __IO     uint32_t AL0_HP;                        /*!< Channel A-Low Heightened-Precision Duty-0 Register */
    __IO     uint32_t AL1_HP;                        /*!< Channel A-Low Heightened-Precision Duty-1 Register */
    __IO     uint32_t BCTL;                          /*!< Channel B Control Register */
    __IO     uint32_t BH0;                           /*!< Channel B-High Duty-0 Register */
    __IO     uint32_t BH1;                           /*!< Channel B-High Duty-1 Register */
    __IO     uint32_t BH0_HP;                        /*!< Channel B-High Heightened-Precision Duty-0 Register */
    __IO     uint32_t BH1_HP;                        /*!< Channel B-High Heightened-Precision Duty-1 Register */
    __IO     uint32_t BL0;                           /*!< Channel B-Low Duty-0 Register */
    __IO     uint32_t BL1;                           /*!< Channel B-Low Duty-1 Register */
    __IO     uint32_t BL0_HP;                        /*!< Channel B-Low Heightened-Precision Duty-0 Register */
    __IO     uint32_t BL1_HP;                        /*!< Channel B-Low Heightened-Precision Duty-1 Register */
    __IO     uint32_t CCTL;                          /*!< Channel C Control Register */
    __IO     uint32_t CH0;                           /*!< Channel C-High Pulse Duty Register 0 */
    __IO     uint32_t CH1;                           /*!< Channel C-High Pulse Duty Register 1 */
    __IO     uint32_t CH0_HP;                        /*!< Channel C-High Pulse Heightened-Precision Duty Register 0 */
    __IO     uint32_t CH1_HP;                        /*!< Channel C-High Pulse Heightened-Precision Duty Register 1 */
    __IO     uint32_t CL0;                           /*!< Channel C-Low Pulse Duty Register 0 */
    __IO     uint32_t CL1;                           /*!< Channel C-Low Duty-1 Register */
    __IO     uint32_t CL0_HP;                        /*!< Channel C-Low Pulse Duty Register 1 */
    __IO     uint32_t CL1_HP;                        /*!< Channel C-Low Heightened-Precision Duty-1 Register */
    __IO     uint32_t DCTL;                          /*!< Channel D Control Register */
    __IO     uint32_t DH0;                           /*!< Channel D-High Duty-0 Register */
    __IO     uint32_t DH1;                           /*!< Channel D-High Pulse Duty Register 1 */
    __IO     uint32_t DH0_HP;                        /*!< Channel D-High Pulse Heightened-Precision Duty Register 0 */
    __IO     uint32_t DH1_HP;                        /*!< Channel D High Pulse Heightened-Precision Duty Register 1 */
    __IO     uint32_t DL0;                           /*!< Channel D-Low Pulse Duty Register 0 */
    __IO     uint32_t DL1;                           /*!< Channel D-Low Pulse Duty Register 1 */
    __IO     uint32_t DL0_HP;                        /*!< Channel D-Low Heightened-Precision Duty-0 Register */
    __IO     uint32_t DL1_HP;                        /*!< Channel D-Low Heightened-Precision Duty-1 Register */
    __IO     uint32_t AH_DUTY0;                      /*!< Channel A-High Full Duty0 Register */
    __IO     uint32_t AH_DUTY1;                      /*!< Channel A-High Full Duty1 Register */
    __IO     uint32_t AL_DUTY0;                      /*!< Channel A-Low Full Duty0 Register */
    __IO     uint32_t AL_DUTY1;                      /*!< Channel A-Low Full Duty1 Register */
    __IO     uint32_t BH_DUTY0;                      /*!< Channel B-High Full Duty0 Register */
    __IO     uint32_t BH_DUTY1;                      /*!< Channel B-High Full Duty1 Register */
    __IO     uint32_t BL_DUTY0;                      /*!< Channel B-Low Full Duty0 Register */
    __IO     uint32_t BL_DUTY1;                      /*!< Channel B-Low Full Duty1 Register */
    __IO     uint32_t CH_DUTY0;                      /*!< Channel C-High Full Duty0 Register */
    __IO     uint32_t CH_DUTY1;                      /*!< Channel C-High Full Duty1 Register */
    __IO     uint32_t CL_DUTY0;                      /*!< Channel C-Low Full Duty0 Register */
    __IO     uint32_t CL_DUTY1;                      /*!< Channel C-Low Full Duty1 Register */
    __IO     uint32_t DH_DUTY0;                      /*!< Channel D-High Full Duty0 Register */
    __IO     uint32_t DH_DUTY1;                      /*!< Channel D-High Full Duty1 Register */
    __IO     uint32_t DL_DUTY0;                      /*!< Channel D-Low Full Duty0 Register */
    __IO     uint32_t DL_DUTY1;                      /*!< Channel D-Low Full Duty1 Register */
    __IO     uint32_t CHA_DT;                        /*!< Channel A Dead-time register */
    __IO     uint32_t CHB_DT;                        /*!< Channel B Dead-time register */
    __IO     uint32_t CHC_DT;                        /*!< Channel C Dead-time register */
    __IO     uint32_t CHD_DT;                        /*!< Channel D Dead-time register */
    __I      uint8_t  RESERVED1[8];
    __IO     uint32_t SWTRIP;                        /*!< Software Trip Register */
    __IO     uint32_t TRIP_POL;                      /*!< Trip Polarity Register */
} ADI_PWM_TypeDef;

/*!@}*/

/** @defgroup TTU Trigger Timing Unit (TTU) Module
 *  Trigger Timing Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TTU_TypeDef
 *  \brief  Trigger Timing Unit
 *  ========================================================================== */
typedef struct _ADI_TTU_TypeDef
{
    __IO     uint32_t CTL;                           /*!< TTU Control Register */
    __I      uint32_t REVID;                         /*!< Revision ID Register */
    __IO     uint32_t STOP;                          /*!< Counter Stop Request Register */
    __I      uint32_t STAT;                          /*!< Counter Status register */
    __IO     uint32_t TST;                           /*!< Counter Testmode Register */
    __I      uint8_t  RESERVED0[12];
    __I      uint32_t CNT[4];                        /*!< Counter Current Value */
    __I      uint8_t  RESERVED1[16];
    __IO     uint32_t PER[4];                        /*!< Counter Period Register */
    __I      uint8_t  RESERVED2[48];
    __IO     uint32_t DLY[8];                        /*!< Trigger Output Delay Register */
    __I      uint8_t  RESERVED3[32];
    __IO     uint32_t DGRP[8];                       /*!< Trigger Output Counter Assignment */
} ADI_TTU_TypeDef;

/*!@}*/

/** @defgroup SMC Static Memory Controller (SMC) Module
 *  Static Memory Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SMC_TypeDef
 *  \brief  Static Memory Controller
 *  ========================================================================== */
typedef struct _ADI_SMC_TypeDef
{
    __I      uint8_t  RESERVED0[12];
    __IO     uint32_t B0CTL;                         /*!< Bank 0 Control Register */
    __IO     uint32_t B0TIM;                         /*!< Bank 0 Timing Register */
    __IO     uint32_t B0ETIM;                        /*!< Bank 0 Extended Timing Register */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t B1CTL;                         /*!< Bank 1 Control Register */
    __IO     uint32_t B1TIM;                         /*!< Bank 1 Timing Register */
    __IO     uint32_t B1ETIM;                        /*!< Bank 1 Extended Timing Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t B2CTL;                         /*!< Bank 2 Control Register */
    __IO     uint32_t B2TIM;                         /*!< Bank 2 Timing Register */
    __IO     uint32_t B2ETIM;                        /*!< Bank 2 Extended Timing Register */
    __I      uint8_t  RESERVED3[4];
    __IO     uint32_t B3CTL;                         /*!< Bank 3 Control Register */
    __IO     uint32_t B3TIM;                         /*!< Bank 3 Timing Register */
    __IO     uint32_t B3ETIM;                        /*!< Bank 3 Extended Timing Register */
} ADI_SMC_TypeDef;

/*!@}*/

/** @defgroup SPI Serial Peripheral Interface (SPI) Module
 *  Serial Peripheral Interface
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SPI_TypeDef
 *  \brief  Serial Peripheral Interface
 *  ========================================================================== */
typedef struct _ADI_SPI_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t RXCTL;                         /*!< Receive Control Register */
    __IO     uint32_t TXCTL;                         /*!< Transmit Control Register */
    __IO     uint32_t CLK;                           /*!< Clock Rate Register */
    __IO     uint32_t DLY;                           /*!< Delay Register */
    __IO     uint32_t SLVSEL;                        /*!< Slave Select Register */
    __IO     uint32_t RWC;                           /*!< Received Word Count Register */
    __IO     uint32_t RWCR;                          /*!< Received Word Count Reload Register */
    __IO     uint32_t TWC;                           /*!< Transmitted Word Count Register */
    __IO     uint32_t TWCR;                          /*!< Transmitted Word Count Reload Register */
    __I      uint8_t  RESERVED1[4];
    __I      uint32_t IMSK;                          /*!< Interrupt Mask Register */
    __IO     uint32_t IMSK_CLR;                      /*!< Interrupt Mask Clear Register */
    __IO     uint32_t IMSK_SET;                      /*!< Interrupt Mask Set Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint32_t ILAT;                          /*!< Masked Interrupt Condition Register */
    __IO     uint32_t ILAT_CLR;                      /*!< Masked Interrupt Clear Register */
    __I      uint8_t  RESERVED3[4];
    __I      uint32_t RFIFO;                         /*!< Receive FIFO Data Register */
    __I      uint8_t  RESERVED4[4];
    __IO     uint32_t TFIFO;                         /*!< Transmit FIFO Data Register */
    __I      uint8_t  RESERVED5[4];
    __IO     uint32_t MMRDH;                         /*!< Memory Mapped Read Header */
    __IO     uint32_t MMTOP;                         /*!< SPI Memory Top Address */
} ADI_SPI_TypeDef;

/*!@}*/

/** @defgroup SPORT Serial Port (SPORT) Module
 *  Serial Port
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SPORT_TypeDef
 *  \brief  Serial Port
 *  ========================================================================== */
typedef struct _ADI_SPORT_TypeDef
{
    __IO     uint32_t CTL_A;                         /*!< Half SPORT 'A' Control Register */
    __IO     uint32_t DIV_A;                         /*!< Half SPORT 'A' Divisor Register */
    __IO     uint32_t MCTL_A;                        /*!< Half SPORT 'A' Multi-channel Control Register */
    __IO     uint32_t CS0_A;                         /*!< Half SPORT 'A' Multi-channel 0-31 Select Register */
    __IO     uint32_t CS1_A;                         /*!< Half SPORT 'A' Multi-channel 32-63 Select Register */
    __IO     uint32_t CS2_A;                         /*!< Half SPORT 'A' Multi-channel 64-95 Select Register */
    __IO     uint32_t CS3_A;                         /*!< Half SPORT 'A' Multi-channel 96-127 Select Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t ERR_A;                         /*!< Half SPORT 'A' Error Register */
    __I      uint32_t MSTAT_A;                       /*!< Half SPORT 'A' Multi-channel Status Register */
    __IO     uint32_t CTL2_A;                        /*!< Half SPORT 'A' Control 2 Register */
    __I      uint8_t  RESERVED1[20];
    __IO     uint32_t TXPRI_A;                       /*!< Half SPORT 'A' Tx Buffer (Primary) Register */
    __IO     uint32_t RXPRI_A;                       /*!< Half SPORT 'A' Rx Buffer (Primary) Register */
    __IO     uint32_t TXSEC_A;                       /*!< Half SPORT 'A' Tx Buffer (Secondary) Register */
    __IO     uint32_t RXSEC_A;                       /*!< Half SPORT 'A' Rx Buffer (Secondary) Register */
    __I      uint8_t  RESERVED2[48];
    __IO     uint32_t CTL_B;                         /*!< Half SPORT 'B' Control Register */
    __IO     uint32_t DIV_B;                         /*!< Half SPORT 'B' Divisor Register */
    __IO     uint32_t MCTL_B;                        /*!< Half SPORT 'B' Multi-channel Control Register */
    __IO     uint32_t CS0_B;                         /*!< Half SPORT 'B' Multi-channel 0-31 Select Register */
    __IO     uint32_t CS1_B;                         /*!< Half SPORT 'B' Multi-channel 32-63 Select Register */
    __IO     uint32_t CS2_B;                         /*!< Half SPORT 'B' Multichannel 64-95 Select Register */
    __IO     uint32_t CS3_B;                         /*!< Half SPORT 'B' Multichannel 96-127 Select Register */
    __I      uint8_t  RESERVED3[4];
    __IO     uint32_t ERR_B;                         /*!< Half SPORT 'B' Error Register */
    __I      uint32_t MSTAT_B;                       /*!< Half SPORT 'B' Multi-channel Status Register */
    __IO     uint32_t CTL2_B;                        /*!< Half SPORT 'B' Control 2 Register */
    __I      uint8_t  RESERVED4[20];
    __IO     uint32_t TXPRI_B;                       /*!< Half SPORT 'B' Tx Buffer (Primary) Register */
    __IO     uint32_t RXPRI_B;                       /*!< Half SPORT 'B' Rx Buffer (Primary) Register */
    __IO     uint32_t TXSEC_B;                       /*!< Half SPORT 'B' Tx Buffer (Secondary) Register */
    __IO     uint32_t RXSEC_B;                       /*!< Half SPORT 'B' Rx Buffer (Secondary) Register */
} ADI_SPORT_TypeDef;

/*!@}*/

/** @defgroup UART UART (UART) Module
 *  UART
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_UART_TypeDef
 *  \brief  UART
 *  ========================================================================== */
typedef struct _ADI_UART_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t SCR;                           /*!< Scratch Register */
    __IO     uint32_t CLK;                           /*!< Clock Rate Register */
    __IO     uint32_t IMSK;                          /*!< Interrupt Mask Register */
    __IO     uint32_t IMSK_SET;                      /*!< Interrupt Mask Set Register */
    __IO     uint32_t IMSK_CLR;                      /*!< Interrupt Mask Clear Register */
    __I      uint32_t RBR;                           /*!< Receive Buffer Register */
    __IO     uint32_t THR;                           /*!< Transmit Hold Register */
    __IO     uint32_t TAIP;                          /*!< Transmit Address/Insert Pulse Register */
    __I      uint32_t TSR;                           /*!< Transmit Shift Register */
    __I      uint32_t RSR;                           /*!< Receive Shift Register */
    __I      uint32_t TXCNT;                         /*!< Transmit Counter Register */
    __I      uint32_t RXCNT;                         /*!< Receive Counter Register */
} ADI_UART_TypeDef;

/*!@}*/

/** @defgroup FFTB FFTB register map. (FFTB) Module
 *  FFTB register map.
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_FFTB_TypeDef
 *  \brief  FFTB register map.
 *  ========================================================================== */
typedef struct _ADI_FFTB_TypeDef
{
    __IO     uint32_t CTL;                           /*!< FFTB control register */
    __IO     uint32_t STAT;                          /*!< FFTB Status register */
    __IO     uint32_t FMTCTL;                        /*!< Format converter control register */
    __IO     uint32_t INOFST;                        /*!< Input offset register */
    __IO     uint32_t COMB;                          /*!< FFTB Input Comb Filter Control */
    __IO     uint32_t DMABASE;                       /*!< DMA output base address */
    __I      uint32_t DMAWR;                         /*!< DMA output write address */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t MAGSEL[9];                     /*!< Magnitude pin select registers */
    __I      uint8_t  RESERVED1[44];
    __I      uint32_t LIMSTAT[9];                    /*!< Limit status registers */
    __I      uint8_t  RESERVED2[44];
    __I      uint32_t MAXMAG;                        /*!< Maximum magnitude register */
    __I      uint32_t MINMAG;                        /*!< Minimum magnitude register */
} ADI_FFTB_TypeDef;

/*!@}*/

/** @defgroup SINC SINC (SINC) Module
 *  SINC
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SINC_TypeDef
 *  \brief  SINC
 *  ========================================================================== */
typedef struct _ADI_SINC_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t CLK;                           /*!< Clock Control Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t RATE0;                         /*!< Rate Control for Group 0 Register */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t LEVEL0;                        /*!< Level Control for Group 0 Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t LIMIT0;                        /*!< (Amplitude) Limits for Secondary Filter 0 Register */
    __IO     uint32_t LIMIT1;                        /*!< (Amplitude) Limits for Secondary Filter 1 Register */
    __IO     uint32_t LIMIT2;                        /*!< (Amplitude) Limits for Secondary Filter 2 Register */
    __IO     uint32_t LIMIT3;                        /*!< (Amplitude) Limits for Secondary Filter 3 Register */
    __IO     uint32_t BIAS0;                         /*!< Bias for Group 0 Register */
    __I      uint8_t  RESERVED3[4];
    __I      uint32_t PPTR0;                         /*!< Primary (Filters) Pointer for Group 0 Register */
    __I      uint8_t  RESERVED4[4];
    __IO     uint32_t PHEAD0;                        /*!< Primary (Filters) Head for Group 0 Register */
    __I      uint8_t  RESERVED5[4];
    __IO     uint32_t PTAIL0;                        /*!< Primary (Filters) Tail for Group 0 Register */
    __I      uint8_t  RESERVED6[4];
    __I      uint32_t HIS_STAT;                      /*!< History Status Register */
    __I      uint8_t  RESERVED7[44];
    __I      uint32_t P0SEC_HIST[4];                 /*!< Pair 0 Secondary (Filter) History n Register */
    __I      uint32_t P1SEC_HIST[4];                 /*!< Pair 1 Secondary (Filter) History n Register */
    __I      uint32_t P2SEC_HIST[4];                 /*!< Pair 2 Secondary (Filter) History n Register */
    __I      uint32_t P3SEC_HIST[4];                 /*!< Pair 3 Secondary (Filter) History n Register */
} ADI_SINC_TypeDef;

/*!@}*/

/** @defgroup ADCC ADC Controller (ADCC) Module
 *  ADC Controller
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVTn_TypeDef
 *! \brief  Event registers for each event
 * ========================================================================== */
typedef struct _ADI_ADCC_EVTn_TypeDef
{
    __IO     uint32_t EVT;                           /*!< Event n Time Register */
    __IO     uint32_t EVCTL;                         /*!< Event n Control Register */
} ADI_ADCC_EVTn_TypeDef;


/*! ==========================================================================
 *  \struct ADI_ADCC_TypeDef
 *  \brief  ADC Controller
 *  ========================================================================== */
typedef struct _ADI_ADCC_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t ERRSTAT;                       /*!< Error Status Register */
    __IO     uint32_t ERRMSK;                        /*!< Error Mask Register */
    __IO     uint32_t ERRMSK_SET;                    /*!< Error Mask Set Register */
    __IO     uint32_t ERRMSK_CLR;                    /*!< Error Mask Clear Register */
    __IO     uint32_t EISTAT;                        /*!< Event Interrupt Status Register */
    __IO     uint32_t EIMSK;                         /*!< Event Interrupt Mask Register */
    __IO     uint32_t EIMSK_SET;                     /*!< Event Interrupt Mask Set Register */
    __IO     uint32_t EIMSK_CLR;                     /*!< Event Interrupt Mask Clear Register */
    __IO     uint32_t FISTAT;                        /*!< Frame Interrupt Status Register */
    __IO     uint32_t FIMSK;                         /*!< Frame Interrupt Mask Register */
    __IO     uint32_t FIMSK_SET;                     /*!< Frame Interrupt Mask Set Register */
    __IO     uint32_t FIMSK_CLR;                     /*!< Frame Interrupt Mask Clear Register */
    __IO     uint32_t EVTEN;                         /*!< Event Enable Register */
    __IO     uint32_t EVTEN_SET;                     /*!< Event Enable Set Register */
    __IO     uint32_t EVTEN_CLR;                     /*!< Event Enable Clear Register */
    __IO     uint32_t ECOL;                          /*!< Event Collision Status Register */
    __IO     uint32_t EMISS;                         /*!< Event Miss Status Register */
    __IO     uint32_t BPTR0;                         /*!< Base Pointer 0 Register */
    __IO     uint32_t FRINC0;                        /*!< Frame Increment 0 Register */
    __IO     uint32_t CBSIZ0;                        /*!< Circular Buffer Size 0 Register */
    __IO     uint32_t TCA0;                          /*!< Timing Control A (ADC0) Register */
    __IO     uint32_t TCB0;                          /*!< Timing Control B (ADC0) Register */
    __IO     uint32_t BWMON0;                        /*!< Bandwidth Monitor 0 Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t BPTR1;                         /*!< DMA Base Pointer 1 Register */
    __IO     uint32_t FRINC1;                        /*!< Frame Increment 1 Register */
    __IO     uint32_t CBSIZ1;                        /*!< Circular Buffer Size 1 Register */
    __IO     uint32_t TCA1;                          /*!< Timing Control A (ADC1) Register */
    __IO     uint32_t TCB1;                          /*!< Timing Control B (ADC1) Register */
    __IO     uint32_t BWMON1;                        /*!< Bandwidth Monitor 1 Register */
    ADI_ADCC_EVTn_TypeDef EVTn[32];              /*!< Event registers for each event */
    __IO     uint32_t NUMFRAM0;                      /*!< Timer0 Frame Limit count for firing FINT0 */
    __IO     uint32_t NUMFRAM1;                      /*!< Timer1 Frame Limit count for firing FINT1 */
    __IO     uint32_t DATOVF;                        /*!< Data overflow indication register */
    __I      uint8_t  RESERVED1[120];
    __I      uint32_t EPND;                          /*!< Pending Events Status Register */
    __I      uint32_t T0STAT;                        /*!< Timer 0 Status Register */
    __I      uint32_t TMR0;                          /*!< Timer 0 Current Count Register */
    __I      uint32_t T1STAT;                        /*!< Timer 1 Status Register */
    __I      uint32_t TMR1;                          /*!< Timer 1 Current Count Register */
    __I      uint32_t EVDAT[32];                     /*!< Event n Data Register */
    __I      uint32_t EVSTAT[32];                    /*!< Event n Status Register */
    __I      uint32_t CBNUM0;                        /*!< Number of Wraps completed by TIMER0 Circular buffer DMA */
    __I      uint32_t CBNUM1;                        /*!< Number of Wraps completed by TIMER1 Circular buffer DMA */
    __I      uint32_t TRGCNT0;                       /*!< Trigger count of TIMER0 */
    __I      uint32_t TRGCNT1;                       /*!< Trigger count of TIMER1 */
    __I      uint8_t  RESERVED2[224];
    __IO     uint32_t ADCRW0;                        /*!< ADC0 Interface RW Access Register */
    __IO     uint32_t ADCRW1;                        /*!< ADC1 Interface RW Access Register */
} ADI_ADCC_TypeDef;

/*!@}*/

/** @defgroup DACC DAC Controller (DACC) Module
 *  DAC Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_DACC_TypeDef
 *  \brief  DAC Controller
 *  ========================================================================== */
typedef struct _ADI_DACC_TypeDef
{
    __IO     uint32_t CTL0;                          /*!< Control 0 Register */
    __IO     uint32_t CTL1;                          /*!< Control 1 Register */
    __IO     uint32_t ERRSTAT;                       /*!< Error Status Register */
    __IO     uint32_t ERRMSK;                        /*!< Error Mask Register */
    __IO     uint32_t ERRMSK_SET;                    /*!< Error Mask Set Register */
    __IO     uint32_t ERRMSK_CLR;                    /*!< Error Mask Clear Register */
    __IO     uint32_t ISTAT;                         /*!< Interrupt Status Register */
    __IO     uint32_t IMSK;                          /*!< Interrupt Mask Register */
    __IO     uint32_t IMSK_SET;                      /*!< Interrupt Mask Set Register */
    __IO     uint32_t IMSK_CLR;                      /*!< Interrupt Mask Clear Register */
    __IO     uint32_t TC0;                           /*!< Timing Control 0 Register */
    __IO     uint32_t BPTR0;                         /*!< Base Pointer 0 Register */
    __IO     uint32_t MOD0;                          /*!< Modify 0 Register */
    __IO     uint32_t CNT0;                          /*!< Count 0 Register */
    __IO     uint32_t DAT0;                          /*!< Data FIFO 0 Register */
    __IO     uint32_t TC1;                           /*!< Timing Control 1 Register */
    __IO     uint32_t BPTR1;                         /*!< Base Pointer 1 Register */
    __IO     uint32_t MOD1;                          /*!< Modify 1 Register */
    __IO     uint32_t CNT1;                          /*!< Count 1 Register */
    __IO     uint32_t DAT1;                          /*!< Data FIFO 1 Register */
    __IO     uint32_t BCST_CTL;                      /*!< Broadcast (Write) Control Register */
    __I      uint8_t  RESERVED0[172];
    __I      uint32_t CNTCUR0;                       /*!< Current Count 0 Register */
    __I      uint32_t CNTCUR1;                       /*!< Current Count 1 Register */
    __I      uint32_t STAT;                          /*!< Status Register */
} ADI_DACC_TypeDef;

/*!@}*/

/** @defgroup CRC Cyclic Redundancy Check Unit (CRC) Module
 *  Cyclic Redundancy Check Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_CRC_TypeDef
 *  \brief  Cyclic Redundancy Check Unit
 *  ========================================================================== */
typedef struct _ADI_CRC_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t DCNT;                          /*!< Data Word Count Register */
    __IO     uint32_t DCNTRLD;                       /*!< Data Word Count Reload Register */
    __I      uint8_t  RESERVED0[8];
    __IO     uint32_t COMP;                          /*!< Data Compare Register */
    __IO     uint32_t FILLVAL;                       /*!< Fill Value Register */
    __IO     uint32_t DFIFO;                         /*!< Data FIFO Register */
    __IO     uint32_t INEN;                          /*!< Interrupt Enable Register */
    __IO     uint32_t INEN_SET;                      /*!< Interrupt Enable Set Register */
    __IO     uint32_t INEN_CLR;                      /*!< Interrupt Enable Clear Register */
    __IO     uint32_t POLY;                          /*!< Polynomial Register */
    __I      uint8_t  RESERVED1[16];
    __IO     uint32_t STAT;                          /*!< Status Register */
    __IO     uint32_t DCNTCAP;                       /*!< Data Count Capture Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t RESULT_FIN;                    /*!< CRC Final Result Register */
    __IO     uint32_t RESULT_CUR;                    /*!< CRC Current Result Register */
} ADI_CRC_TypeDef;

/*!@}*/

/** @defgroup HAE Harmonic Analysis Engine (HAE) Module
 *  Harmonic Analysis Engine
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_HAE_TypeDef
 *  \brief  Harmonic Analysis Engine
 *  ========================================================================== */
typedef struct _ADI_HAE_TypeDef
{
    __I      uint8_t  RESERVED0[160];
    __IO     uint32_t RUN;                           /*!< Run Register */
    __I      uint8_t  RESERVED1[2652];
    __IO     uint32_t CFG0;                          /*!< Configuration 0 Register */
    __IO     uint32_t CFG1;                          /*!< Configuration 1 Register */
    __IO     uint32_t CFG2;                          /*!< Configuration 2 Register */
    __IO     uint32_t CFG3;                          /*!< Configuration 3 Register */
    __I      uint8_t  RESERVED2[16];
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint8_t  RESERVED3[28];
    __IO     uint32_t ISAMPLE;                       /*!< I (Current) Sample Register */
    __IO     uint32_t VSAMPLE;                       /*!< V (Voltage) Sample Register */
    __I      uint8_t  RESERVED4[56];
    __I      uint32_t IWAVEFORM;                     /*!< I (Current) Waveform Register */
    __I      uint32_t VWAVEFORM;                     /*!< V (Voltage) Waveform Register */
    __I      uint8_t  RESERVED5[4728];
    __IO     uint32_t CFG4;                          /*!< Configuration 4 Register */
    __IO     uint32_t DIDT_GAIN;                     /*!< DIDT Gain Register */
    __IO     uint32_t DIDT_COEF;                     /*!< DIDT Coefficient Register */
    __I      uint8_t  RESERVED6[4];
    __IO     uint32_t VLEVEL;                        /*!< Voltage Level Register */
    __I      uint8_t  RESERVED7[24];
    __IO     uint32_t H_INDX[12];                    /*!< Harmonic n Index Register */
} ADI_HAE_TypeDef;

/*!@}*/

/** @defgroup DMA_CFG0 DMA Channel (DMA_CFG0) Module
 *  DMA Channel
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_DMA_CFG0_TypeDef
 *  \brief  DMA Channel
 *  ========================================================================== */
typedef struct _ADI_DMA_CFG0_TypeDef
{
    __IO     uint32_t DSCPTR_NXT;                    /*!< Pointer to Next Initial Descriptor */
    __IO     uint32_t ADDRSTART;                     /*!< Start Address of Current Buffer */
    __IO     uint32_t CFG;                           /*!< Configuration Register */
    __IO     uint32_t XCNT;                          /*!< Inner Loop Count Start Value */
    __IO     uint32_t XMOD;                          /*!< Inner Loop Address Increment */
    __IO     uint32_t YCNT;                          /*!< Outer Loop Count Start Value (2D only) */
    __IO     uint32_t YMOD;                          /*!< Outer Loop Address Increment (2D only) */
    __I      uint8_t  RESERVED0[8];
    __IO     uint32_t DSCPTR_CUR;                    /*!< Current Descriptor Pointer */
    __I      uint32_t DSCPTR_PRV;                    /*!< Previous Initial Descriptor Pointer */
    __IO     uint32_t ADDR_CUR;                      /*!< Current Address */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint32_t XCNT_CUR;                      /*!< Current Count(1D) or intra-row XCNT (2D) */
    __I      uint32_t YCNT_CUR;                      /*!< Current Row Count (2D only) */
} ADI_DMA_CFG0_TypeDef;

/*!@}*/

/** @defgroup DMA_CFG1 DMA Channel (DMA_CFG1) Module
 *  DMA Channel
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_DMA_CFG1_TypeDef
 *  \brief  DMA Channel
 *  ========================================================================== */
typedef struct _ADI_DMA_CFG1_TypeDef
{
    __IO     uint32_t DSCPTR_NXT;                    /*!< Pointer to Next Initial Descriptor */
    __IO     uint32_t ADDRSTART;                     /*!< Start Address of Current Buffer */
    __IO     uint32_t CFG;                           /*!< Configuration Register */
    __IO     uint32_t XCNT;                          /*!< Inner Loop Count Start Value */
    __IO     uint32_t XMOD;                          /*!< Inner Loop Address Increment */
    __IO     uint32_t YCNT;                          /*!< Outer Loop Count Start Value (2D only) */
    __IO     uint32_t YMOD;                          /*!< Outer Loop Address Increment (2D only) */
    __I      uint8_t  RESERVED0[8];
    __IO     uint32_t DSCPTR_CUR;                    /*!< Current Descriptor Pointer */
    __I      uint32_t DSCPTR_PRV;                    /*!< Previous Initial Descriptor Pointer */
    __IO     uint32_t ADDR_CUR;                      /*!< Current Address */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint32_t XCNT_CUR;                      /*!< Current Count(1D) or intra-row XCNT (2D) */
    __I      uint32_t YCNT_CUR;                      /*!< Current Row Count (2D only) */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t BWLCNT;                        /*!< Bandwidth Limit Count */
    __I      uint32_t BWLCNT_CUR;                    /*!< Bandwidth Limit Count Current */
    __IO     uint32_t BWMCNT;                        /*!< Bandwidth Monitor Count */
    __I      uint32_t BWMCNT_CUR;                    /*!< Bandwidth Monitor Count Current */
} ADI_DMA_CFG1_TypeDef;

/*!@}*/

/** @defgroup MBOX_PORT1 MBOX Port 1 register map (MBOX_PORT1) Module
 *  MBOX Port 1 register map
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_MBOX_PORT1_TypeDef
 *  \brief  MBOX Port 1 register map
 *  ========================================================================== */
typedef struct _ADI_MBOX_PORT1_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Port 1 control register */
    __IO     uint32_t FORCEIRQ;                      /*!< Port 1 force IRQ register */
    __IO     uint32_t STAT;                          /*!< Port 1 status register */
    __IO     uint32_t ESTAT;                         /*!< Port 1 ECC status register */
    __IO     uint32_t RFRPER;                        /*!< Auto-refresh period register */
    __IO     uint32_t RFRADDR;                       /*!< Auto-refresh address register */
    __IO     uint32_t RFRCNT;                        /*!< Auto-refresh counter register */
} ADI_MBOX_PORT1_TypeDef;

/*!@}*/

/** @defgroup SMPU_CFG0 System Memory Protection Unit (SMPU_CFG0) Module
 *  System Memory Protection Unit
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_Rn_TypeDef
 *! \brief  Region n
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_Rn_TypeDef
{
    __IO     uint32_t RCTL;                          /*!< Region n Control Register */
    __IO     uint32_t RADDR;                         /*!< Region n Address Register */
    __IO     uint32_t RIDA;                          /*!< Region n ID A Register */
    __IO     uint32_t RIDMSKA;                       /*!< Region n ID Mask A Register */
    __IO     uint32_t RIDB;                          /*!< Region n ID B Register */
    __IO     uint32_t RIDMSKB;                       /*!< Region n ID Mask B Register */
} ADI_SMPU_CFG0_Rn_TypeDef;


/*! ==========================================================================
 *  \struct ADI_SMPU_CFG0_TypeDef
 *  \brief  System Memory Protection Unit
 *  ========================================================================== */
typedef struct _ADI_SMPU_CFG0_TypeDef
{
    __IO     uint32_t CTL;                           /*!< SMPU Control Register */
    __IO     uint32_t STAT;                          /*!< SMPU Status Register */
    __I      uint32_t IADDR;                         /*!< Interrupt Address Register */
    __I      uint32_t IDTLS;                         /*!< Interrupt Details Register */
    __I      uint32_t BADDR;                         /*!< Bus Error Address Register */
    __I      uint32_t BDTLS;                         /*!< Bus Error Details Register */
    __I      uint8_t  RESERVED0[8];
    ADI_SMPU_CFG0_Rn_TypeDef Rn[8];              /*!< Region n */
    __I      uint8_t  RESERVED1[320];
    __I      uint32_t REVID;                         /*!< SMPU Revision ID Register */
    __I      uint8_t  RESERVED2[1500];
    __IO     uint32_t SECURECTL;                     /*!< SMPU Control Secure Accesses Register */
    __I      uint8_t  RESERVED3[28];
    __IO     uint32_t SECURERCTL[8];                 /*!< Region n Control Secure Accesses Register */
} ADI_SMPU_CFG0_TypeDef;

/*!@}*/

/** @defgroup SMPU_CFG1 System Memory Protection Unit (SMPU_CFG1) Module
 *  System Memory Protection Unit
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_Rn_TypeDef
 *! \brief  Region n
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_Rn_TypeDef
{
    __IO     uint32_t RCTL;                          /*!< Region n Control Register */
    __IO     uint32_t RADDR;                         /*!< Region n Address Register */
    __IO     uint32_t RIDA;                          /*!< Region n ID A Register */
    __IO     uint32_t RIDMSKA;                       /*!< Region n ID Mask A Register */
    __IO     uint32_t RIDB;                          /*!< Region n ID B Register */
    __IO     uint32_t RIDMSKB;                       /*!< Region n ID Mask B Register */
} ADI_SMPU_CFG1_Rn_TypeDef;


/*! ==========================================================================
 *  \struct ADI_SMPU_CFG1_TypeDef
 *  \brief  System Memory Protection Unit
 *  ========================================================================== */
typedef struct _ADI_SMPU_CFG1_TypeDef
{
    __IO     uint32_t CTL;                           /*!< SMPU Control Register */
    __IO     uint32_t STAT;                          /*!< SMPU Status Register */
    __I      uint32_t IADDR;                         /*!< Interrupt Address Register */
    __I      uint32_t IDTLS;                         /*!< Interrupt Details Register */
    __I      uint32_t BADDR;                         /*!< Bus Error Address Register */
    __I      uint32_t BDTLS;                         /*!< Bus Error Details Register */
    __I      uint8_t  RESERVED0[8];
    ADI_SMPU_CFG1_Rn_TypeDef Rn[4];              /*!< Region n */
    __I      uint8_t  RESERVED1[416];
    __I      uint32_t REVID;                         /*!< SMPU Revision ID Register */
    __I      uint8_t  RESERVED2[1500];
    __IO     uint32_t SECURECTL;                     /*!< SMPU Control Secure Accesses Register */
    __I      uint8_t  RESERVED3[28];
    __IO     uint32_t SECURERCTL[4];                 /*!< Region n Control Secure Accesses Register */
} ADI_SMPU_CFG1_TypeDef;

/*!@}*/

/** @defgroup SWU System Watchpoint Unit (SWU) Module
 *  System Watchpoint Unit
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_WB_TypeDef
 *! \brief  SWU0 Module's WB register block
 * ========================================================================== */
typedef struct _ADI_SWU_WB_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register n */
    __IO     uint32_t LA;                            /*!< Lower Address Register n */
    __IO     uint32_t UA;                            /*!< Upper Address Register n */
    __IO     uint32_t ID;                            /*!< ID Register n */
    __IO     uint32_t CNT;                           /*!< Count Register n */
    __IO     uint32_t TARG;                          /*!< Target Register n */
    __I      uint32_t HIST;                          /*!< Bandwidth History Register n */
    __I      uint32_t CUR;                           /*!< Current Register n */
} ADI_SWU_WB_TypeDef;


/*! ==========================================================================
 *  \struct ADI_SWU_TypeDef
 *  \brief  System Watchpoint Unit
 *  ========================================================================== */
typedef struct _ADI_SWU_TypeDef
{
    __IO     uint32_t GCTL;                          /*!< Global Control Register */
    __IO     uint32_t GSTAT;                         /*!< Global Status Register */
    __I      uint8_t  RESERVED0[8];
    ADI_SWU_WB_TypeDef WB[4];                    /*!<  */
} ADI_SWU_TypeDef;

/*!@}*/

/** @defgroup SPU_CFG0 System Protection Unit (SPU_CFG0) Module
 *  System Protection Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SPU_CFG0_TypeDef
 *  \brief  System Protection Unit
 *  ========================================================================== */
typedef struct _ADI_SPU_CFG0_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint8_t  RESERVED0[56];
    __IO     uint32_t TIMEOUT;                       /*!< Timeout Register */
    __I      uint8_t  RESERVED1[956];
    __IO     uint32_t WP[66];                        /*!< Write Protect Register n */
    __I      uint8_t  RESERVED2[760];
    __IO     uint32_t AP[66];                        /*!< Access Protect Register n */
    __I      uint8_t  RESERVED3[1912];
    __I      uint32_t IDTLS;                         /*!< Interrupt Details Register */
    __I      uint32_t IADDR;                         /*!< Interrupt Address Register */
    __I      uint8_t  RESERVED4[3904];
    __I      uint32_t DEVID;                         /*!< Device Configuration Register */
    __I      uint32_t DEVTYPE;                       /*!< Device Type Identifier Register */
    __I      uint32_t PID4;                          /*!< Peripheral ID4 Register */
    __I      uint32_t PID5;                          /*!< Peripheral ID5 Register */
    __I      uint32_t PID6;                          /*!< Peripheral ID6 Register */
    __I      uint32_t PID7;                          /*!< Peripheral ID7 Register */
    __I      uint32_t PID0;                          /*!< Peripheral ID0 Register */
    __I      uint32_t PID1;                          /*!< Peripheral ID1 Register */
    __I      uint32_t PID2;                          /*!< Peripheral ID2 Register */
    __I      uint32_t PID3;                          /*!< Peripheral ID3 Register */
    __I      uint32_t CID0;                          /*!< Component ID0 Register */
    __I      uint32_t CID1;                          /*!< Component ID1 Register */
    __I      uint32_t CID2;                          /*!< Component ID2 Register */
    __I      uint32_t CID3;                          /*!< Component ID3 Register */
} ADI_SPU_CFG0_TypeDef;

/*!@}*/

/** @defgroup C_CFG1 Pads Controller (C_CFG1) Module
 *  Pads Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_C_CFG1_TypeDef
 *  \brief  Pads Controller
 *  ========================================================================== */
typedef struct _ADI_C_CFG1_TypeDef
{
    __I      uint8_t  RESERVED0[64];
    __I      uint32_t SYSSTAT;                       /*!< System Status Register */
    __I      uint8_t  RESERVED1[44];
    __IO     uint32_t AHB_RESP_CFG;                  /*!< AHB Response Configuration Register */
    __IO     uint32_t AHB_TIMEOUT_VALUE;             /*!< AHB Timeout Value Register */
    __I      uint8_t  RESERVED2[8];
    __IO     uint32_t ENG_MODE_CFG0;                 /*!< Engineering Mode Configuration Register 0 */
    __I      uint8_t  RESERVED3[48];
    __IO     uint32_t M0_VTOR;                       /*!< Vector table base offset field */
    __I      uint8_t  RESERVED4[40];
    __IO     uint32_t SRAM0_ECC;                     /*!< M0 SRAM ECC */
    __IO     uint32_t SYS_STCALIB;                   /*!< System */
    __IO     uint32_t IRQ_LATENCY;                   /*!< M0 IRQ LATENCY */
    __I      uint8_t  RESERVED5[276];
    __IO     uint32_t SISTAT0;                       /*!< Shared Interrupt 0 Status Register */
    __I      uint8_t  RESERVED6[8];
    __IO     uint32_t SISTAT3;                       /*!< Shared Interrupt 3 Status Register */
    __I      uint8_t  RESERVED7[4];
    __IO     uint32_t SISTAT5;                       /*!< Shared Interrupt 5 Status Register */
    __IO     uint32_t SISTAT6;                       /*!< Shared Interrupt 6 Status Register */
    __IO     uint32_t SISTAT7;                       /*!< Shared Interrupt 7 Status Register */
    __IO     uint32_t SISTAT8;                       /*!< Shared Interrupt 8 Status Register */
    __I      uint8_t  RESERVED8[4];
    __IO     uint32_t SISTAT10;                      /*!< Shared Interrupt 10 Status Register */
    __IO     uint32_t SISTAT11;                      /*!< Shared Interrupt 11 Status Register */
    __IO     uint32_t SISTAT12;                      /*!< Shared Interrupt 12 Status Register */
    __I      uint8_t  RESERVED9[8];
    __IO     uint32_t SISTAT15;                      /*!< Shared Interrupt 15 Status Register */
    __IO     uint32_t SISTAT16;                      /*!< Shared Interrupt 16 Status Register */
    __IO     uint32_t SISTAT17;                      /*!< Shared Interrupt 17 Status Register */
    __IO     uint32_t SISTAT18;                      /*!< Shared Interrupt 18 Status Register */
    __IO     uint32_t SISTAT19;                      /*!< Shared Interrupt 19 Status Register */
    __I      uint8_t  RESERVED10[8];
    __IO     uint32_t SISTAT22;                      /*!< Shared Interrupt 22 Status Register */
    __I      uint8_t  RESERVED11[8];
    __IO     uint32_t SISTAT25;                      /*!< Shared Interrupt 25 Status Register */
    __I      uint8_t  RESERVED12[8];
    __IO     uint32_t SISTAT28;                      /*!< Shared Interrupt 28 Status Register */
} ADI_C_CFG1_TypeDef;

/*!@}*/

/** @defgroup TEPADS_CFG1 Pads Controller (TEPADS_CFG1) Module
 *  Pads Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TEPADS_CFG1_TypeDef
 *  \brief  Pads Controller
 *  ========================================================================== */
typedef struct _ADI_TEPADS_CFG1_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t PCFG0;                         /*!< Peripheral Configuration0 Register */
    __I      uint8_t  RESERVED1[248];
    __IO     uint32_t PORT_DS;                       /*!< Multiport Drive Strength Register */
    __I      uint8_t  RESERVED2[28];
    __IO     uint32_t PORT_RCTL;                     /*!< Multiport Pullup/Pulldown Resistor Control Register */
    __I      uint8_t  RESERVED3[28];
    __IO     uint32_t PORT_TRIPST;                   /*!< Multiport Trip State Register */
    __I      uint8_t  RESERVED4[28];
    __IO     uint32_t PORT_TRIPSEL;                  /*!< Multiport Trip Select */
} ADI_TEPADS_CFG1_TypeDef;

/*!@}*/

/** @defgroup PORT_CFG1 General Purpose Input/Output (PORT_CFG1) Module
 *  General Purpose Input/Output
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_PORT_CFG1_TypeDef
 *  \brief  General Purpose Input/Output
 *  ========================================================================== */
typedef struct _ADI_PORT_CFG1_TypeDef
{
    __IO     uint32_t FER;                           /*!< Port x Function Enable Register */
    __IO     uint32_t FER_SET;                       /*!< Port x Function Enable Set Register */
    __IO     uint32_t FER_CLR;                       /*!< Port x Function Enable Clear Register */
    __IO     uint32_t DATA;                          /*!< Port x GPIO Data Register */
    __IO     uint32_t DATA_SET;                      /*!< Port x GPIO Data Set Register */
    __IO     uint32_t DATA_CLR;                      /*!< Port x GPIO Data Clear Register */
    __IO     uint32_t DIR;                           /*!< Port x GPIO Direction Register */
    __IO     uint32_t DIR_SET;                       /*!< Port x GPIO Direction Set Register */
    __IO     uint32_t DIR_CLR;                       /*!< Port x GPIO Direction Clear Register */
    __IO     uint32_t INEN;                          /*!< Port x GPIO Input Enable Register */
    __IO     uint32_t INEN_SET;                      /*!< Port x GPIO Input Enable Set Register */
    __IO     uint32_t INEN_CLR;                      /*!< Port x GPIO Input Enable Clear Register */
    __IO     uint32_t MUX;                           /*!< Port x Multiplexer Control Register */
    __IO     uint32_t DATA_TGL;                      /*!< Port x GPIO Input Enable Toggle Register */
    __IO     uint32_t POL;                           /*!< Port x GPIO Polarity Invert Register */
    __IO     uint32_t POL_SET;                       /*!< Port x GPIO Polarity Invert Set Register */
    __IO     uint32_t POL_CLR;                       /*!< Port x GPIO Polarity Invert Clear Register */
    __IO     uint32_t LOCK;                          /*!< Port x GPIO Lock Register */
    __IO     uint32_t TRIG_TGL;                      /*!< Port x GPIO Trigger Toggle Register */
} ADI_PORT_CFG1_TypeDef;

/*!@}*/

/** @defgroup SEC_CFG1 System Event Controller (SEC_CFG1) Module
 *  System Event Controller
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_SB_TypeDef
 *! \brief  SSI Registers
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_SB_TypeDef
{
    __IO     uint32_t SCTL;                          /*!< Source Control Register n */
    __IO     uint32_t SSTAT;                         /*!< Source Status Register n */
} ADI_SEC_CFG1_SB_TypeDef;


/*! ==========================================================================
 *  \struct ADI_SEC_CFG1_TypeDef
 *  \brief  System Event Controller
 *  ========================================================================== */
typedef struct _ADI_SEC_CFG1_TypeDef
{
    __IO     uint32_t GCTL;                          /*!< Global Control Register */
    __IO     uint32_t GSTAT;                         /*!< Global Status Register */
    __IO     uint32_t RAISE;                         /*!< Global Raise Register */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t FCTL;                          /*!< Fault Control Register */
    __IO     uint32_t FSTAT;                         /*!< Fault Status Register */
    __I      uint32_t FSID;                          /*!< Fault Source ID Register */
    __IO     uint32_t FEND;                          /*!< Fault End Register */
    __IO     uint32_t FDLY;                          /*!< Fault Delay Register */
    __I      uint32_t FDLY_CUR;                      /*!< Fault Delay Current Register */
    __IO     uint32_t FSRDLY;                        /*!< Fault System Reset Delay Register */
    __I      uint32_t FSRDLY_CUR;                    /*!< Fault System Reset Delay Current Register */
    __IO     uint32_t FCOPP;                         /*!< Fault COP Period Register */
    __I      uint32_t FCOPP_CUR;                     /*!< Fault COP Period Current Register */
    __I      uint8_t  RESERVED1[1992];
    ADI_SEC_CFG1_SB_TypeDef SB[76];              /*!< SSI Registers */
} ADI_SEC_CFG1_TypeDef;

/*!@}*/

/** @defgroup TRU_CFG1 Trigger Routing Unit (TRU_CFG1) Module
 *  Trigger Routing Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TRU_CFG1_TypeDef
 *  \brief  Trigger Routing Unit
 *  ========================================================================== */
typedef struct _ADI_TRU_CFG1_TypeDef
{
    __IO     uint32_t SSR[47];                       /*!< Slave Select Register */
    __I      uint8_t  RESERVED0[1828];
    __IO     uint32_t MTR;                           /*!< Master Trigger Register */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t ERRADDR;                       /*!< Error Address Register */
    __IO     uint32_t STAT;                          /*!< Status Information Register */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t GCTL;                          /*!< Global Control Register */
} ADI_TRU_CFG1_TypeDef;

/*!@}*/

/** @defgroup SMPU_CFG2 System Memory Protection Unit (SMPU_CFG2) Module
 *  System Memory Protection Unit
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_Rn_TypeDef
 *! \brief  Region n
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_Rn_TypeDef
{
    __IO     uint32_t RCTL;                          /*!< Region n Control Register */
    __IO     uint32_t RADDR;                         /*!< Region n Address Register */
    __IO     uint32_t RIDA;                          /*!< Region n ID A Register */
    __IO     uint32_t RIDMSKA;                       /*!< Region n ID Mask A Register */
    __IO     uint32_t RIDB;                          /*!< Region n ID B Register */
    __IO     uint32_t RIDMSKB;                       /*!< Region n ID Mask B Register */
} ADI_SMPU_CFG2_Rn_TypeDef;


/*! ==========================================================================
 *  \struct ADI_SMPU_CFG2_TypeDef
 *  \brief  System Memory Protection Unit
 *  ========================================================================== */
typedef struct _ADI_SMPU_CFG2_TypeDef
{
    __IO     uint32_t CTL;                           /*!< SMPU Control Register */
    __IO     uint32_t STAT;                          /*!< SMPU Status Register */
    __I      uint32_t IADDR;                         /*!< Interrupt Address Register */
    __I      uint32_t IDTLS;                         /*!< Interrupt Details Register */
    __I      uint32_t BADDR;                         /*!< Bus Error Address Register */
    __I      uint32_t BDTLS;                         /*!< Bus Error Details Register */
    __I      uint8_t  RESERVED0[8];
    ADI_SMPU_CFG2_Rn_TypeDef Rn[4];              /*!< Region n */
    __I      uint8_t  RESERVED1[416];
    __I      uint32_t REVID;                         /*!< SMPU Revision ID Register */
    __I      uint8_t  RESERVED2[1500];
    __IO     uint32_t SECURECTL;                     /*!< SMPU Control Secure Accesses Register */
    __I      uint8_t  RESERVED3[28];
    __IO     uint32_t SECURERCTL[4];                 /*!< Region n Control Secure Accesses Register */
} ADI_SMPU_CFG2_TypeDef;

/*!@}*/

/** @defgroup SPU_CFG1 System Protection Unit (SPU_CFG1) Module
 *  System Protection Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SPU_CFG1_TypeDef
 *  \brief  System Protection Unit
 *  ========================================================================== */
typedef struct _ADI_SPU_CFG1_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Control Register */
    __IO     uint32_t STAT;                          /*!< Status Register */
    __I      uint8_t  RESERVED0[56];
    __IO     uint32_t TIMEOUT;                       /*!< Timeout Register */
    __I      uint8_t  RESERVED1[956];
    __IO     uint32_t WP[20];                        /*!< Write Protect Register n */
    __I      uint8_t  RESERVED2[944];
    __IO     uint32_t AP[20];                        /*!< Access Protect Register n */
    __I      uint8_t  RESERVED3[2096];
    __I      uint32_t IDTLS;                         /*!< Interrupt Details Register */
    __I      uint32_t IADDR;                         /*!< Interrupt Address Register */
    __I      uint8_t  RESERVED4[3904];
    __I      uint32_t DEVID;                         /*!< Device Configuration Register */
    __I      uint32_t DEVTYPE;                       /*!< Device Type Identifier Register */
    __I      uint32_t PID4;                          /*!< Peripheral ID4 Register */
    __I      uint32_t PID5;                          /*!< Peripheral ID5 Register */
    __I      uint32_t PID6;                          /*!< Peripheral ID6 Register */
    __I      uint32_t PID7;                          /*!< Peripheral ID7 Register */
    __I      uint32_t PID0;                          /*!< Peripheral ID0 Register */
    __I      uint32_t PID1;                          /*!< Peripheral ID1 Register */
    __I      uint32_t PID2;                          /*!< Peripheral ID2 Register */
    __I      uint32_t PID3;                          /*!< Peripheral ID3 Register */
    __I      uint32_t CID0;                          /*!< Component ID0 Register */
    __I      uint32_t CID1;                          /*!< Component ID1 Register */
    __I      uint32_t CID2;                          /*!< Component ID2 Register */
    __I      uint32_t CID3;                          /*!< Component ID3 Register */
} ADI_SPU_CFG1_TypeDef;

/*!@}*/

/** @defgroup SCB System Crossbar (SCB) Module
 *  System Crossbar
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SCB_TypeDef
 *  \brief  System Crossbar
 *  ========================================================================== */
typedef struct _ADI_SCB_TypeDef
{
    __I      uint8_t  RESERVED0[8144];
    __I      uint32_t PERIPH_ID_4;                   /*!< Periph Id 4 */
    __I      uint32_t PERIPH_ID_5;                   /*!< Periph Id 5 */
    __I      uint32_t PERIPH_ID_6;                   /*!< Periph Id 6 */
    __I      uint32_t PERIPH_ID_7;                   /*!< Periph Id 7 */
    __I      uint32_t PERIPH_ID_0;                   /*!< Periph Id 0 */
    __I      uint32_t PERIPH_ID_1;                   /*!< Periph Id 1 */
    __I      uint32_t PERIPH_ID_2;                   /*!< Periph Id 2 */
    __I      uint32_t PERIPH_ID_3;                   /*!< Periph Id 3 */
    __I      uint32_t COMP_ID_0;                     /*!< Comp Id 0 */
    __I      uint32_t COMP_ID_1;                     /*!< Comp Id 1 */
    __I      uint32_t COMP_ID_2;                     /*!< Comp Id 2 */
    __I      uint32_t COMP_ID_3;                     /*!< Comp Id 3 */
    __I      uint8_t  RESERVED1[262400];
    __IO     uint32_t DMA0_READ_QOS;                 /*!< Dma0.read Qos */
    __IO     uint32_t DMA0_WRITE_QOS;                /*!< Dma0.write Qos */
    __IO     uint32_t DMA0_FN_MOD;                   /*!< Dma0.fn Mod */
    __I      uint8_t  RESERVED2[4084];
    __IO     uint32_t DMA1_READ_QOS;                 /*!< Dma1.read Qos */
    __IO     uint32_t DMA1_WRITE_QOS;                /*!< Dma1.write Qos */
    __IO     uint32_t DMA1_FN_MOD;                   /*!< Dma1.fn Mod */
    __I      uint8_t  RESERVED3[4084];
    __IO     uint32_t DMA2_READ_QOS;                 /*!< Dma2.read Qos */
    __IO     uint32_t DMA2_WRITE_QOS;                /*!< Dma2.write Qos */
    __IO     uint32_t DMA2_FN_MOD;                   /*!< Dma2.fn Mod */
    __I      uint8_t  RESERVED4[4084];
    __IO     uint32_t DMA3_READ_QOS;                 /*!< Dma3.read Qos */
    __IO     uint32_t DMA3_WRITE_QOS;                /*!< Dma3.write Qos */
    __IO     uint32_t DMA3_FN_MOD;                   /*!< Dma3.fn Mod */
    __I      uint8_t  RESERVED5[4084];
    __IO     uint32_t DMA4_READ_QOS;                 /*!< Dma4.read Qos */
    __IO     uint32_t DMA4_WRITE_QOS;                /*!< Dma4.write Qos */
    __IO     uint32_t DMA4_FN_MOD;                   /*!< Dma4.fn Mod */
    __I      uint8_t  RESERVED6[4084];
    __IO     uint32_t DMA5_READ_QOS;                 /*!< Dma5.read Qos */
    __IO     uint32_t DMA5_WRITE_QOS;                /*!< Dma5.write Qos */
    __IO     uint32_t DMA5_FN_MOD;                   /*!< Dma5.fn Mod */
    __I      uint8_t  RESERVED7[4084];
    __IO     uint32_t DMA6_READ_QOS;                 /*!< Dma6.read Qos */
    __IO     uint32_t DMA6_WRITE_QOS;                /*!< Dma6.write Qos */
    __IO     uint32_t DMA6_FN_MOD;                   /*!< Dma6.fn Mod */
    __I      uint8_t  RESERVED8[4084];
    __IO     uint32_t DMA7_READ_QOS;                 /*!< Dma7.read Qos */
    __IO     uint32_t DMA7_WRITE_QOS;                /*!< Dma7.write Qos */
    __IO     uint32_t DMA7_FN_MOD;                   /*!< Dma7.fn Mod */
    __I      uint8_t  RESERVED9[4084];
    __IO     uint32_t DMA8_READ_QOS;                 /*!< Dma8.read Qos */
    __IO     uint32_t DMA8_WRITE_QOS;                /*!< Dma8.write Qos */
    __IO     uint32_t DMA8_FN_MOD;                   /*!< Dma8.fn Mod */
    __I      uint8_t  RESERVED10[4084];
    __IO     uint32_t DMA9_READ_QOS;                 /*!< Dma9.read Qos */
    __IO     uint32_t DMA9_WRITE_QOS;                /*!< Dma9.write Qos */
    __IO     uint32_t DMA9_FN_MOD;                   /*!< Dma9.fn Mod */
    __I      uint8_t  RESERVED11[4084];
    __IO     uint32_t AFE0_READ_QOS;                 /*!< Afe0.read Qos */
    __IO     uint32_t AFE0_WRITE_QOS;                /*!< Afe0.write Qos */
    __IO     uint32_t AFE0_FN_MOD;                   /*!< Afe0.fn Mod */
    __I      uint8_t  RESERVED12[4084];
    __IO     uint32_t FFT0_MST_READ_QOS;             /*!< Fft0 Mst.read Qos */
    __IO     uint32_t FFT0_MST_WRITE_QOS;            /*!< Fft0 Mst.write Qos */
    __IO     uint32_t FFT0_MST_FN_MOD;               /*!< Fft0 Mst.fn Mod */
    __I      uint8_t  RESERVED13[3868];
    __IO     uint32_t CONT_SYS_FN_MOD_AHB;           /*!< Cont Sys.fn Mod Ahb */
    __I      uint8_t  RESERVED14[212];
    __IO     uint32_t CONT_SYS_READ_QOS;             /*!< Cont Sys.read Qos */
    __IO     uint32_t CONT_SYS_WRITE_QOS;            /*!< Cont Sys.write Qos */
    __IO     uint32_t CONT_SYS_FN_MOD;               /*!< Cont Sys.fn Mod */
    __I      uint8_t  RESERVED15[4084];
    __IO     uint32_t SUPER_AXI_READ_QOS;            /*!< Super Axi.read Qos */
    __IO     uint32_t SUPER_AXI_WRITE_QOS;           /*!< Super Axi.write Qos */
    __IO     uint32_t SUPER_AXI_FN_MOD;              /*!< Super Axi.fn Mod */
    __I      uint8_t  RESERVED16[8180];
    __IO     uint32_t SINC0_MST_READ_QOS;            /*!< Sinc0 Mst.read Qos */
    __IO     uint32_t SINC0_MST_WRITE_QOS;           /*!< Sinc0 Mst.write Qos */
    __IO     uint32_t SINC0_MST_FN_MOD;              /*!< Sinc0 Mst.fn Mod */
} ADI_SCB_TypeDef;

/*!@}*/

/** @defgroup SCS  (SCS) Module
 *
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_SCS_TypeDef
 *  \brief
 *  ========================================================================== */
typedef struct _ADI_SCS_TypeDef
{
    __I      uint8_t  RESERVED0[4];
    __I      uint32_t ICTR;                          /*!< Interrupt Control Type Register */
    __IO     uint32_t ACTLR;                         /*!< Auxiliary Control Register */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t STCSR;                         /*!< SysTick Control and Status Register */
    __IO     uint32_t STRVR;                         /*!< SysTick Reload Value Register */
    __IO     uint32_t STCVR;                         /*!< SysTick Current Value Register */
    __I      uint32_t STCR;                          /*!< SysTick Calibration Value Register */
    __I      uint8_t  RESERVED2[224];
    __IO     uint32_t NVIC_ISER[6];                  /*!< Irq  Set Enable Register n */
    __I      uint8_t  RESERVED3[104];
    __IO     uint32_t NVIC_ICER[6];                  /*!< Irq Clear Enable Register n */
    __I      uint8_t  RESERVED4[104];
    __IO     uint32_t NVIC_ISPR[6];                  /*!< Irq Set Pending Register n */
    __I      uint8_t  RESERVED5[104];
    __IO     uint32_t NVIC_ICPR[6];                  /*!< Irq Clear Pending Register n */
    __I      uint8_t  RESERVED6[104];
    __I      uint32_t NVIC_IABR[6];                  /*!< Irq Active Bit Register n */
    __I      uint8_t  RESERVED7[232];
    __IO     uint32_t NVIC_IPR[41];                  /*!< Irq Priority Register nn */
    __I      uint8_t  RESERVED8[2140];
    __I      uint32_t CPUID;                         /*!< CPUID Base Register */
    __IO     uint32_t ICSR;                          /*!< Interrupt Control State Register */
    __IO     uint32_t VTOR;                          /*!< Vector Table Offset Register */
    __IO     uint32_t AIRCR;                         /*!< Application Interrupt/Reset Control Register */
    __IO     uint32_t SCR;                           /*!< System Control Register */
    __IO     uint32_t CCR;                           /*!< Configuration Control Register */
    __IO     uint32_t SHPR1;                         /*!< System Handlers 4-7 Priority Register */
    __IO     uint32_t SHPR2;                         /*!< System Handlers 8-11 Priority Register */
    __IO     uint32_t SHPR3;                         /*!< System Handlers 12-15 Priority Register */
    __IO     uint32_t SHCSR;                         /*!< System Handler Control and State Register */
    __IO     uint32_t CFSR;                          /*!< Configurable Fault Status Registers */
    __IO     uint32_t HFSR;                          /*!< Hard Fault Status Register */
    __IO     uint32_t DFSR;                          /*!< Debug Fault Status Register */
    __IO     uint32_t MMFAR;                         /*!< Mem Manage Fault Address Register */
    __IO     uint32_t BFAR;                          /*!< Bus Fault Address Register */
    __IO     uint32_t AFSR;                          /*!< Auxiliary Fault Status Register */
    __I      uint32_t ID_PFR0;                       /*!< Processor Feature register0 */
    __I      uint32_t ID_PFR1;                       /*!< Processor Feature register1 */
    __I      uint32_t ID_DFR0;                       /*!< Debug Feature register0 */
    __I      uint32_t ID_AFR0;                       /*!< Auxiliary Feature register0 */
    __I      uint32_t ID_MMFR0;                      /*!< Memory Model Feature register0 */
    __I      uint32_t ID_MMFR1;                      /*!< Memory Model Feature register1 */
    __I      uint32_t ID_MMFR2;                      /*!< Memory Model Feature register2 */
    __I      uint32_t ID_MMFR3;                      /*!< Memory Model Feature register3 */
    __I      uint32_t ISAR0;                         /*!< ISA Feature register0 */
    __I      uint32_t ID_ISAR1;                      /*!< ISA Feature register1 */
    __I      uint32_t ID_ISAR2;                      /*!< ISA Feature register2 */
    __I      uint32_t ID_ISAR3;                      /*!< ISA Feature register3 */
    __I      uint32_t ID_ISAR4;                      /*!< ISA Feature register4 */
    __I      uint8_t  RESERVED9[20];
    __IO     uint32_t CPACR;                         /*!< Coprocessor Access Control Register */
    __I      uint8_t  RESERVED10[4];
    __I      uint32_t MPU_TYPE;                      /*!< MPU Type Register */
    __IO     uint32_t MPU_CTRL;                      /*!< MPU Control Register */
    __IO     uint32_t MPU_RNR;                       /*!< MPU Region Number Register */
    __IO     uint32_t MPU_RBAR;                      /*!< MPU Region Base Address Register */
    __IO     uint32_t MPU_RASR;                      /*!< MPU Region Attribute and Size Register */
    __IO     uint32_t MPU_RBAR_A1;                   /*!< MPU Alias 1 Region Base Address register */
    __IO     uint32_t MPU_RASR_A1;                   /*!< MPU Alias 1 Region Attribute and Size register */
    __IO     uint32_t MPU_RBAR_A2;                   /*!< MPU Alias 2 Region Base Address register */
    __IO     uint32_t MPU_RASR_A2;                   /*!< MPU Alias 2 Region Attribute and Size register */
    __IO     uint32_t MPU_RBAR_A3;                   /*!< MPU Alias 3 Region Base Address register */
    __IO     uint32_t MPU_RASR_A3;                   /*!< MPU Alias 3 Region Attribute and Size register */
    __I      uint8_t  RESERVED11[52];
    __IO     uint32_t DHCSR;                         /*!< Debug Halting Control and Status Register */
    __IO     uint32_t DCRSR;                         /*!< Deubg Core Register Selector Register */
    __IO     uint32_t DCRDR;                         /*!< Debug Core Register Data Register */
    __IO     uint32_t DEMCR;                         /*!< Debug Exception and Monitor Control Register */
    __I      uint8_t  RESERVED12[256];
    __IO     uint32_t STIR;                          /*!< Software Trigger Interrupt Register */
    __I      uint8_t  RESERVED13[48];
    __IO     uint32_t FPCCR;                         /*!< Floating Point Context Control Register */
    __IO     uint32_t FPCAR;                         /*!< Floating-Point Context Address Register */
    __IO     uint32_t FPDSCR;                        /*!< Floating Point Default Status Control Register */
    __I      uint32_t MVFR0;                         /*!< Media and FP Feature Register 0 (MVFR0) */
    __I      uint32_t MVFR1;                         /*!< Media and FP Feature Register 1 (MVFR1) */
    __I      uint8_t  RESERVED14[136];
    __I      uint32_t PID4;                          /*!< Peripheral identification register (PID4) */
    __I      uint32_t PID5;                          /*!< Peripheral identification register (PID5) */
    __I      uint32_t PID6;                          /*!< Peripheral identification register (PID6) */
    __I      uint32_t PID7;                          /*!< Peripheral identification register (PID7) */
    __I      uint32_t PID0;                          /*!< Peripheral identification register Bits 7:0 (PID0) */
    __I      uint32_t PID1;                          /*!< Peripheral identification register Bits 15:8 (PID1) */
    __I      uint32_t PID2;                          /*!< Peripheral identification register Bits 23:16 (PID2) */
    __I      uint32_t PID3;                          /*!< Peripheral identification register Bits 31:24 (PID3) */
    __I      uint32_t CID0;                          /*!< Component identification register Bits 7:0 (CID0) */
    __I      uint32_t CID1;                          /*!< Component identification register Bits 15:8 (CID1) */
    __I      uint32_t CID2;                          /*!< Component identification register Bits 23:16 (CID2) */
    __I      uint32_t CID3;                          /*!< Component identification register Bits 31:24 (CID3) */
} ADI_SCS_TypeDef;

/*!@}*/

/** @defgroup TRACE Trace Port Interface Unit (TRACE) Module
 *  Trace Port Interface Unit
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_TRACE_TypeDef
 *  \brief  Trace Port Interface Unit
 *  ========================================================================== */
typedef struct _ADI_TRACE_TypeDef
{
    __I      uint32_t SSPSR;                         /*!< Supported Sync Port Sizes Register. */
    __IO     uint32_t CSPSR;                         /*!< Current Sync Port Size Register. */
    __I      uint8_t  RESERVED0[8];
    __IO     uint32_t ACPR;                          /*!< Async Clock Prescaler Register. */
    __I      uint8_t  RESERVED1[220];
    __IO     uint32_t SPPR;                          /*!< Selected Pin Protocol Register. */
    __I      uint8_t  RESERVED2[524];
    __I      uint32_t FFSR;                          /*!< Formatter and Flush Status Register. */
    __IO     uint32_t FFCR;                          /*!< Formatter and Flush Control Register. */
    __IO     uint32_t FSCR;                          /*!< Formatter Synchronization Counter Register. */
    __I      uint8_t  RESERVED3[3036];
    __I      uint32_t TRIGGER;                       /*!< Integration Register: TRIGGER. */
    __I      uint32_t FIFO_DATA_0;                   /*!< Integration register: FIFO data 0. */
    __I      uint32_t ITATBCTR2;                     /*!< Integration Register: ITATBCTR2. */
    __I      uint8_t  RESERVED4[4];
    __I      uint32_t ITATBCTR0;                     /*!< Integration Register: ITATBCTR0. */
    __I      uint32_t FIFO_DATA_1;                   /*!< Integration register: FIFO data 1. */
    __IO     uint32_t ITCTRL;                        /*!< Integration Mode Control Register. */
    __I      uint8_t  RESERVED5[156];
    __IO     uint32_t CLAIMSET;                      /*!< Claim tag set register. */
    __IO     uint32_t CLAIMCLR;                      /*!< Claim tag clear register. */
    __I      uint8_t  RESERVED6[32];
    __IO     uint32_t DEVID;                         /*!< Device ID register. */
    __I      uint8_t  RESERVED7[4];
    __IO     uint32_t PID4;                          /*!< Peripheral identification register (PID4). */
    __IO     uint32_t PID5;                          /*!< Peripheral identification register (PID5). */
    __IO     uint32_t PID6;                          /*!< Peripheral identification register (PID6). */
    __IO     uint32_t PID7;                          /*!< Peripheral identification register (PID7). */
    __IO     uint32_t PID0;                          /*!< Peripheral identification register Bits 7:0 (PID0). */
    __IO     uint32_t PID1;                          /*!< Peripheral identification register Bits 15:8 (PID1). */
    __IO     uint32_t PID2;                          /*!< Peripheral identification register Bits 23:16 (PID2). */
    __IO     uint32_t PID3;                          /*!< Peripheral identification register Bits 31:24 (PID3). */
    __IO     uint32_t CID0;                          /*!< Component identification register Bits 7:0 (CID0). */
    __IO     uint32_t CID1;                          /*!< Component identification register Bits 15:8 (CID1). */
    __IO     uint32_t CID2;                          /*!< Component identification register Bits 23:16 (CID2). */
    __IO     uint32_t CID3;                          /*!< Component identification register Bits 31:24 (CID3). */
} ADI_TRACE_TypeDef;

/*!@}*/

/** @defgroup CXTMC CoreSight TMC  (CXTMC) Module
 *  CoreSight TMC
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_CXTMC_TypeDef
 *  \brief  CoreSight TMC
 *  ========================================================================== */
typedef struct _ADI_CXTMC_TypeDef
{
    __I      uint8_t  RESERVED0[772];
    __IO     uint32_t FFCR;                          /*!< Formatter and Flush Control Register */
    __I      uint8_t  RESERVED1[3224];
    __IO     uint32_t CLAIMSET;                      /*!< Claim Tag Set Register */
    __IO     uint32_t CLAIMCLR;                      /*!< Claim Tag Clear Register */
} ADI_CXTMC_TypeDef;

/*!@}*/

/** @defgroup M4P ARM Cortex-M4 Platform (M4P) Module
 *  ARM Cortex-M4 Platform
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_M4P_TypeDef
 *  \brief  ARM Cortex-M4 Platform
 *  ========================================================================== */
typedef struct _ADI_M4P_TypeDef
{
    __I      uint8_t  RESERVED0[32];
    __IO     uint32_t SRAM_CFG;                      /*!< SRAM Configuration Register */
    __I      uint8_t  RESERVED1[8];
    __IO     uint32_t BUSFLT;                        /*!< Bus Fault Error Information Register */
    __IO     uint32_t STCALIB;                       /*!< SysTick Calibration Register */
    __I      uint8_t  RESERVED2[40];
    __IO     uint32_t SRAM_INITDONE;                 /*!< SRAM initialization done status register */
    __IO     uint32_t SRAM_EEADDR_CORE;              /*!< SRAM ECC Error Address (Core) Register */
    __IO     uint32_t SRAM_EEADDR_DMA;               /*!< SRAM ECC Error Address (DMA) Register */
    __IO     uint32_t SRAM_RFRPER;                   /*!< SRAM Refresh Period Register */
    __I      uint32_t SRAM_RFRADDR;                  /*!< SRAM Refresh Address */
    __IO     uint32_t BROMERR;                       /*!< Boot ROM Error register */
} ADI_M4P_TypeDef;

/*!@}*/

/** @defgroup MATH Math Unit Function (MATH) Module
 *  Math Unit Function
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_MATH_TypeDef
 *  \brief  Math Unit Function
 *  ========================================================================== */
typedef struct _ADI_MATH_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Math Unit Interrupt Enable Control */
    __IO     uint32_t EXPF;                          /*!< exp(x) function */
    __I      uint8_t  RESERVED0[4];
    __IO     uint32_t EXP2F;                         /*!< exp2(x) function */
    __I      uint8_t  RESERVED1[4];
    __IO     uint32_t RECIPF;                        /*!< Reciprocal(x) or 1/x function */
    __I      uint8_t  RESERVED2[4];
    __IO     uint32_t SQRTF;                         /*!< Square Root or sqrt(x) function */
    __I      uint8_t  RESERVED3[4];
    __IO     uint32_t LNF;                           /*!< ln(x) function */
    __I      uint8_t  RESERVED4[4];
    __IO     uint32_t LOG2F;                         /*!< log2(x) function */
    __I      uint8_t  RESERVED5[4];
    __IO     uint32_t SINF;                          /*!< sin(x) function */
    __I      uint8_t  RESERVED6[4];
    __IO     uint32_t COSF;                          /*!< cos(x) function */
    __I      uint8_t  RESERVED7[4];
    __IO     uint32_t TANF;                          /*!< tan(x) function */
    __I      uint8_t  RESERVED8[4];
    __IO     uint32_t ASINF;                         /*!< arcsin(x) function */
    __I      uint8_t  RESERVED9[4];
    __IO     uint32_t ACOSF;                         /*!< arccos(x) function */
    __I      uint8_t  RESERVED10[4];
    __IO     uint32_t ATANF;                         /*!< arctan(x) function */
    __I      uint8_t  RESERVED11[32];
    __IO     uint32_t ATAN2F_Y;                      /*!< arctan(y/x) function */
    __IO     uint32_t ATAN2F_X;                      /*!< arctan(y/x) function */
    __IO     uint32_t HYPOTF_Y;                      /*!< hypot(x,y) = sqrt(x^2 + y^2) function */
    __IO     uint32_t HYPOTF_X;                      /*!< hypot(x,y) = sqrt(x^2 + y^2) function */
    __IO     uint32_t RTOPF_Y;                       /*!< Multi-function : sqrt(x^2+y^2) and arctan(y/x) */
    __IO     uint32_t RTOPF_X;                       /*!< Multi-function : sqrt(x^2+y^2) and arctan(y/x) */
    __IO     uint32_t PTORF_R;                       /*!< Multi-Function : r * sin(a) and r * cos(a) function */
    __IO     uint32_t PTORF_A;                       /*!< Multi-Function : r * sin(a) and r * cos(a) function */
    __I      uint8_t  RESERVED12[352];
    __IO     uint32_t GY;                            /*!< Generic Y function register */
    __IO     uint32_t GX;                            /*!< Generic X function register (GX) */
    __IO     uint32_t RES1;                          /*!< Math Unit Function Result 1 */
    __IO     uint32_t RES2;                          /*!< Math Unit Function Result 2 */
    __IO     uint32_t FSTAT;                         /*!< Math Unit Function Status Register */
    __IO     uint32_t ISTAT;                         /*!< Math Unit Interrupt Register */
    __I      uint32_t SSTAT;                         /*!< Math Unit Function State Status Register */
} ADI_MATH_TypeDef;

/*!@}*/

/** @defgroup FLC Flash Controller (FLC) Module
 *  Flash Controller
 *  @{
 */

/*! ==========================================================================
 *  \struct ADI_FLC_TypeDef
 *  \brief  Flash Controller
 *  ========================================================================== */
typedef struct _ADI_FLC_TypeDef
{
    __IO     uint32_t CTL;                           /*!< Flash Controller Control Register */
    __IO     uint32_t CMD;                           /*!< Flash Controller Command Register */
    __IO     uint32_t IMSK;                          /*!< Flash Controller Interrupt Enable Register */
    __IO     uint32_t ADDR;                          /*!< Flash controller Command Address Register */
    __IO     uint32_t DATA0;                         /*!< Flash Controller Command Data Register 0 */
    __IO     uint32_t DATA1;                         /*!< Flash Controller Command Data Register 1 */
    __IO     uint32_t ECC;                           /*!< Flash Controller Command ECC register */
    __IO     uint32_t STAT;                          /*!< Flash Controller Status Register */
    __IO     uint32_t CMD_KEY;                       /*!< Flash Controller Command Key Register */
    __IO     uint32_t SBERR_THR;                     /*!< Flash Controller ECC Single Bit Error Threshold Register */
    __IO     uint32_t TIM_PGM;                       /*!< Flash Controller Program Timing Register */
    __IO     uint32_t TIM_ERASE;                     /*!< Flash Controller Erase Timing Register */
    __IO     uint32_t TIM_PWR;                       /*!< Flash Controller Power Timing Register */
    __IO     uint32_t TIM_NVSTR;                     /*!< Flash Controller NVSTR Timing Register */
    __I      uint8_t  RESERVED0[8];
    __IO     uint32_t PRFCTL;                        /*!< Flash Prefetch Control Register */
    __IO     uint32_t FILL_CNT;                      /*!< Flash Pre-fetcher Fill Count Register */
    __IO     uint32_t MISS_CNT;                      /*!< Flash Pre-fetcher Miss Count Register */
    __IO     uint32_t REF_CNT;                       /*!< Flash Pre-fetcher Reference Count Register */
    __IO     uint32_t PMODE_BYP;                     /*!< Flash Pre-fetcher Performance Mode Bypass Register */
    __I      uint32_t REVID;                         /*!< Revision ID */
} ADI_FLC_TypeDef;

/*!@}*/

/* ******************************************************************************
 *    Peripheral Memory Map Declarations
 * *****************************************************************************/
/*!    @defgroup PMEMMAPDEC Peripheral Memory Map Declarations
 *     \addtogroup PMEMMAPDEC
 *     @{ */
#define ADI_C1_BASE                    0x40000000    /*!<  Base address of C1 */
#define ADI_TEPADS1_BASE               0x40001000    /*!<  Base address of TEPADS1 */
#define ADI_EMUID0_BASE                0x40002000    /*!<  Base address of EMUID0 */
#define ADI_PINT0_BASE                 0x41002000    /*!<  Base address of PINT0 */
#define ADI_PINT1_BASE                 0x40003000    /*!<  Base address of PINT1 */
#define ADI_PINT2_BASE                 0x40004000    /*!<  Base address of PINT2 */
#define ADI_PINT3_BASE                 0x40005000    /*!<  Base address of PINT3 */
#define ADI_PINT4_BASE                 0x40006000    /*!<  Base address of PINT4 */
#define ADI_PINT5_BASE                 0x40007000    /*!<  Base address of PINT5 */
#define ADI_PORTB_BASE                 0x40008000    /*!<  Base address of PORTB */
#define ADI_PORTC_BASE                 0x40009000    /*!<  Base address of PORTC */
#define ADI_PORTD_BASE                 0x4000a000    /*!<  Base address of PORTD */
#define ADI_PORTE_BASE                 0x4000b000    /*!<  Base address of PORTE */
#define ADI_PORTF_BASE                 0x4000c000    /*!<  Base address of PORTF */
#define ADI_LBA0_BASE                  0x4000f000    /*!<  Base address of LBA0 */
#define ADI_SEC1_BASE                  0x40010000    /*!<  Base address of SEC1 */
#define ADI_WDOG0_BASE                 0x41005000    /*!<  Base address of WDOG0 */
#define ADI_WDOG1_BASE                 0x40011000    /*!<  Base address of WDOG1 */
#define ADI_RCU0_BASE                  0x40012000    /*!<  Base address of RCU0 */
#define ADI_DPM0_BASE                  0x40013000    /*!<  Base address of DPM0 */
#define ADI_CGU0_BASE                  0x40014000    /*!<  Base address of CGU0 */
#define ADI_OCU0_BASE                  0x40015000    /*!<  Base address of OCU0 */
#define ADI_EFS0_BASE                  0x40016000    /*!<  Base address of EFS0 */
#define ADI_TAPC_BASE                  0x40017000    /*!<  Base address of TAPC */
#define ADI_TRU1_BASE                  0x40020000    /*!<  Base address of TRU1 */
#define ADI_TIMER0_BASE                0x41007000    /*!<  Base address of TIMER0 */
#define ADI_TIMER1_BASE                0x40021000    /*!<  Base address of TIMER1 */
#define ADI_CNT0_BASE                  0x40022000    /*!<  Base address of CNT0 */
#define ADI_TWI0_BASE                  0x40023000    /*!<  Base address of TWI0 */
#define ADI_CAN0_BASE                  0x41008200    /*!<  Base address of CAN0 */
#define ADI_CAN1_BASE                  0x40024200    /*!<  Base address of CAN1 */
#define ADI_CPTMR0_BASE                0x40025000    /*!<  Base address of CPTMR0 */
#define ADI_PWM0_BASE                  0x40028000    /*!<  Base address of PWM0 */
#define ADI_PWM1_BASE                  0x40029000    /*!<  Base address of PWM1 */
#define ADI_PWM2_BASE                  0x4002a000    /*!<  Base address of PWM2 */
#define ADI_HPPWMBST_BASE              0x4002b000    /*!<  Base address of HPPWMBST */
#define ADI_TTU0_BASE                  0x4002c000    /*!<  Base address of TTU0 */
#define ADI_SMC0_BASE                  0x4002f000    /*!<  Base address of SMC0 */
#define ADI_SPI0_BASE                  0x41009000    /*!<  Base address of SPI0 */
#define ADI_SPI1_BASE                  0x40040000    /*!<  Base address of SPI1 */
#define ADI_SPORT0_BASE                0x40042000    /*!<  Base address of SPORT0 */
#define ADI_UART0_BASE                 0x4100a000    /*!<  Base address of UART0 */
#define ADI_UART1_BASE                 0x40044000    /*!<  Base address of UART1 */
#define ADI_UART2_BASE                 0x40045000    /*!<  Base address of UART2 */
#define ADI_UART3_BASE                 0x40046000    /*!<  Base address of UART3 */
#define ADI_UART4_BASE                 0x40047000    /*!<  Base address of UART4 */
#define ADI_FFTB0_BASE                 0x40048000    /*!<  Base address of FFTB0 */
#define ADI_SINC0_BASE                 0x40049000    /*!<  Base address of SINC0 */
#define ADI_ADCC0_BASE                 0x4100b000    /*!<  Base address of ADCC0 */
#define ADI_ADCC1_BASE                 0x4004a000    /*!<  Base address of ADCC1 */
#define ADI_DACC0_BASE                 0x4004b000    /*!<  Base address of DACC0 */
#define ADI_CRC0_BASE                  0x4004c000    /*!<  Base address of CRC0 */
#define ADI_HAE0_BASE                  0x40050000    /*!<  Base address of HAE0 */
#define ADI_DMA0_BASE                  0x4100c000    /*!<  Base address of DMA0 */
#define ADI_DMA1_BASE                  0x4100d000    /*!<  Base address of DMA1 */
#define ADI_DMA2_BASE                  0x4100e000    /*!<  Base address of DMA2 */
#define ADI_DMA3_BASE                  0x4100f000    /*!<  Base address of DMA3 */
#define ADI_DMA4_BASE                  0x40060000    /*!<  Base address of DMA4 */
#define ADI_DMA5_BASE                  0x40061000    /*!<  Base address of DMA5 */
#define ADI_DMA6_BASE                  0x40062000    /*!<  Base address of DMA6 */
#define ADI_DMA7_BASE                  0x40063000    /*!<  Base address of DMA7 */
#define ADI_DMA8_BASE                  0x40064000    /*!<  Base address of DMA8 */
#define ADI_DMA9_BASE                  0x40065000    /*!<  Base address of DMA9 */
#define ADI_DMA10_BASE                 0x40066000    /*!<  Base address of DMA10 */
#define ADI_DMA11_BASE                 0x40067000    /*!<  Base address of DMA11 */
#define ADI_DMA12_BASE                 0x40068000    /*!<  Base address of DMA12 */
#define ADI_DMA13_BASE                 0x40069000    /*!<  Base address of DMA13 */
#define ADI_MBOX0_PORT1_BASE           0x400d1000    /*!<  Base address of MBOX0_PORT1 */
#define ADI_SMPU1_BASE                 0x400e0000    /*!<  Base address of SMPU1 */
#define ADI_SMPU2_BASE                 0x400e1000    /*!<  Base address of SMPU2 */
#define ADI_SWU0_BASE                  0x410f0000    /*!<  Base address of SWU0 */
#define ADI_SWU1_BASE                  0x410f1000    /*!<  Base address of SWU1 */
#define ADI_SWU2_BASE                  0x400f0000    /*!<  Base address of SWU2 */
#define ADI_SWU3_BASE                  0x400f1000    /*!<  Base address of SWU3 */
#define ADI_SWU4_BASE                  0x400f2000    /*!<  Base address of SWU4 */
#define ADI_SWU5_BASE                  0x400f3000    /*!<  Base address of SWU5 */
#define ADI_SWU6_BASE                  0x400f4000    /*!<  Base address of SWU6 */
#define ADI_SPU1_BASE                  0x400f8000    /*!<  Base address of SPU1 */
#define ADI_C0_BASE                    0x41000000    /*!<  Base address of C0 */
#define ADI_TEPADS0_BASE               0x41001000    /*!<  Base address of TEPADS0 */
#define ADI_PORTA_BASE                 0x41003000    /*!<  Base address of PORTA */
#define ADI_SEC0_BASE                  0x41004000    /*!<  Base address of SEC0 */
#define ADI_TRU0_BASE                  0x41006000    /*!<  Base address of TRU0 */
#define ADI_SMPU0_BASE                 0x410e0000    /*!<  Base address of SMPU0 */
#define ADI_SPU0_BASE                  0x410f8000    /*!<  Base address of SPU0 */
#define ADI_SCB0_BASE                  0x4f000000    /*!<  Base address of SCB0 */
#define ADI_ITM0_BASE                  0xe0000000    /*!<  Base address of ITM0 */
#define ADI_DWT0_BASE                  0xe0001000    /*!<  Base address of DWT0 */
#define ADI_FPB0_BASE                  0xe0002000    /*!<  Base address of FPB0 */
#define ADI_SCS0_BASE                  0xe000e000    /*!<  Base address of SCS0 */
#define ADI_TRACE0_BASE                0xe0040000    /*!<  Base address of TRACE0 */
#define ADI_ETM0_BASE                  0xe0041000    /*!<  Base address of ETM0 */
#define ADI_CSTF0_BASE                 0xe0043000    /*!<  Base address of CSTF0 */
#define ADI_CXTMC0_BASE                0xe0044000    /*!<  Base address of CXTMC0 */
#define ADI_CTI0_BASE                  0xe0048000    /*!<  Base address of CTI0 */
#define ADI_CTI1_BASE                  0xe0049000    /*!<  Base address of CTI1 */
#define ADI_CTI2_BASE                  0xe004a000    /*!<  Base address of CTI2 */
#define ADI_CTI3_BASE                  0xe004b000    /*!<  Base address of CTI3 */
#define ADI_M4P_BASE                   0xf8008000    /*!<  Base address of M4P */
#define ADI_MATH0_BASE                 0xf8009000    /*!<  Base address of MATH0 */
#define ADI_FLC0_BASE                  0xf8010000    /*!<  Base address of FLC0 */
#define ADI_FLC1_BASE                  0xf8011000    /*!<  Base address of FLC1 */

/*!    @} */

/* ******************************************************************************
 *    Peripheral Pointer Declarations
 * *****************************************************************************/
/*!    @Defgroup Pptrdec Peripheral Pointer Declarations
 *     \Addtogroup Pptrdec
 *     @{ */
#define pADI_C1                        ((ADI_C_CFG0_TypeDef   *) ADI_C1_BASE         ) /*!<  Pointer to Pads Controller (C1) */
#define pADI_TEPADS1                   ((ADI_TEPADS_CFG0_TypeDef *) ADI_TEPADS1_BASE    ) /*!<  Pointer to Pads Controller (TEPADS1) */
#define pADI_EMUID0                    ((ADI_EMUID_TypeDef    *) ADI_EMUID0_BASE     ) /*!<  Pointer to CHIP ID For ARM Emulators (EMUID0) */
#define pADI_PINT0                     ((ADI_PINT_TypeDef     *) ADI_PINT0_BASE      ) /*!<  Pointer to PINT (PINT0) */
#define pADI_PINT1                     ((ADI_PINT_TypeDef     *) ADI_PINT1_BASE      ) /*!<  Pointer to PINT (PINT1) */
#define pADI_PINT2                     ((ADI_PINT_TypeDef     *) ADI_PINT2_BASE      ) /*!<  Pointer to PINT (PINT2) */
#define pADI_PINT3                     ((ADI_PINT_TypeDef     *) ADI_PINT3_BASE      ) /*!<  Pointer to PINT (PINT3) */
#define pADI_PINT4                     ((ADI_PINT_TypeDef     *) ADI_PINT4_BASE      ) /*!<  Pointer to PINT (PINT4) */
#define pADI_PINT5                     ((ADI_PINT_TypeDef     *) ADI_PINT5_BASE      ) /*!<  Pointer to PINT (PINT5) */
#define pADI_PORTB                     ((ADI_PORT_CFG0_TypeDef *) ADI_PORTB_BASE      ) /*!<  Pointer to General Purpose Input/Output (PORTB) */
#define pADI_PORTC                     ((ADI_PORT_CFG0_TypeDef *) ADI_PORTC_BASE      ) /*!<  Pointer to General Purpose Input/Output (PORTC) */
#define pADI_PORTD                     ((ADI_PORT_CFG0_TypeDef *) ADI_PORTD_BASE      ) /*!<  Pointer to General Purpose Input/Output (PORTD) */
#define pADI_PORTE                     ((ADI_PORT_CFG0_TypeDef *) ADI_PORTE_BASE      ) /*!<  Pointer to General Purpose Input/Output (PORTE) */
#define pADI_PORTF                     ((ADI_PORT_CFG0_TypeDef *) ADI_PORTF_BASE      ) /*!<  Pointer to General Purpose Input/Output (PORTF) */
#define pADI_LBA0                      ((ADI_LBA0_TypeDef     *) ADI_LBA0_BASE       ) /*!<  Pointer to Logic Block Array (LBA0) */
#define pADI_SEC1                      ((ADI_SEC_CFG0_TypeDef *) ADI_SEC1_BASE       ) /*!<  Pointer to System Event Controller (SEC1) */
#define pADI_WDOG0                     ((ADI_WDOG_TypeDef     *) ADI_WDOG0_BASE      ) /*!<  Pointer to Watch Dog Timer Unit (WDOG0) */
#define pADI_WDOG1                     ((ADI_WDOG_TypeDef     *) ADI_WDOG1_BASE      ) /*!<  Pointer to Watch Dog Timer Unit (WDOG1) */
#define pADI_RCU0                      ((ADI_RCU_TypeDef      *) ADI_RCU0_BASE       ) /*!<  Pointer to Reset Control Unit (RCU0) */
#define pADI_DPM0                      ((ADI_DPM_TypeDef      *) ADI_DPM0_BASE       ) /*!<  Pointer to Dynamic Power Management (DPM0) */
#define pADI_CGU0                      ((ADI_CGU_TypeDef      *) ADI_CGU0_BASE       ) /*!<  Pointer to Clock Generation Unit (CGU0) */
#define pADI_OCU0                      ((ADI_OCU_TypeDef      *) ADI_OCU0_BASE       ) /*!<  Pointer to Oscillator Counter Unit (OCU0) */
#define pADI_EFS0                      ((ADI_EFS_TypeDef      *) ADI_EFS0_BASE       ) /*!<  Pointer to eFUSE Controller (EFS0) */
#define pADI_TAPC                      ((ADI_TAPC_TypeDef     *) ADI_TAPC_BASE       ) /*!<  Pointer to TAPC (TAPC) */
#define pADI_TRU1                      ((ADI_TRU_CFG0_TypeDef *) ADI_TRU1_BASE       ) /*!<  Pointer to Trigger Routing Unit (TRU1) */
#define pADI_TIMER0                    ((ADI_TIMER_TypeDef    *) ADI_TIMER0_BASE     ) /*!<  Pointer to General-Purpose Timer Block (TIMER0) */
#define pADI_TIMER1                    ((ADI_TIMER_TypeDef    *) ADI_TIMER1_BASE     ) /*!<  Pointer to General-Purpose Timer Block (TIMER1) */
#define pADI_CNT0                      ((ADI_CNT_TypeDef      *) ADI_CNT0_BASE       ) /*!<  Pointer to CNT (CNT0) */
#define pADI_TWI0                      ((ADI_TWI_TypeDef      *) ADI_TWI0_BASE       ) /*!<  Pointer to 2-Wire Interface (TWI0) */
#define pADI_CAN0                      ((ADI_CAN_TypeDef      *) ADI_CAN0_BASE       ) /*!<  Pointer to Controller Area Network (CAN0) */
#define pADI_CAN1                      ((ADI_CAN_TypeDef      *) ADI_CAN1_BASE       ) /*!<  Pointer to Controller Area Network (CAN1) */
#define pADI_CPTMR0                    ((ADI_CPTMR_TypeDef    *) ADI_CPTMR0_BASE     ) /*!<  Pointer to Capture Timer (CPTMR0) */
#define pADI_PWM0                      ((ADI_PWM_TypeDef      *) ADI_PWM0_BASE       ) /*!<  Pointer to Pulse-Width Modulator (PWM0) */
#define pADI_PWM1                      ((ADI_PWM_TypeDef      *) ADI_PWM1_BASE       ) /*!<  Pointer to Pulse-Width Modulator (PWM1) */
#define pADI_PWM2                      ((ADI_PWM_TypeDef      *) ADI_PWM2_BASE       ) /*!<  Pointer to Pulse-Width Modulator (PWM2) */
#define pADI_HPPWMBST                  ((ADI_HPPWMBST_TypeDef *) ADI_HPPWMBST_BASE   ) /*!<  Pointer to BIST for HPPWM (HPPWMBST) */
#define pADI_TTU0                      ((ADI_TTU_TypeDef      *) ADI_TTU0_BASE       ) /*!<  Pointer to Trigger Timing Unit (TTU0) */
#define pADI_SMC0                      ((ADI_SMC_TypeDef      *) ADI_SMC0_BASE       ) /*!<  Pointer to Static Memory Controller (SMC0) */
#define pADI_SPI0                      ((ADI_SPI_TypeDef      *) ADI_SPI0_BASE       ) /*!<  Pointer to Serial Peripheral Interface (SPI0) */
#define pADI_SPI1                      ((ADI_SPI_TypeDef      *) ADI_SPI1_BASE       ) /*!<  Pointer to Serial Peripheral Interface (SPI1) */
#define pADI_SPORT0                    ((ADI_SPORT_TypeDef    *) ADI_SPORT0_BASE     ) /*!<  Pointer to Serial Port (SPORT0) */
#define pADI_UART0                     ((ADI_UART_TypeDef     *) ADI_UART0_BASE      ) /*!<  Pointer to UART (UART0) */
#define pADI_UART1                     ((ADI_UART_TypeDef     *) ADI_UART1_BASE      ) /*!<  Pointer to UART (UART1) */
#define pADI_UART2                     ((ADI_UART_TypeDef     *) ADI_UART2_BASE      ) /*!<  Pointer to UART (UART2) */
#define pADI_UART3                     ((ADI_UART_TypeDef     *) ADI_UART3_BASE      ) /*!<  Pointer to UART (UART3) */
#define pADI_UART4                     ((ADI_UART_TypeDef     *) ADI_UART4_BASE      ) /*!<  Pointer to UART (UART4) */
#define pADI_FFTB0                     ((ADI_FFTB_TypeDef     *) ADI_FFTB0_BASE      ) /*!<  Pointer to FFTB register map. (FFTB0) */
#define pADI_SINC0                     ((ADI_SINC_TypeDef     *) ADI_SINC0_BASE      ) /*!<  Pointer to SINC (SINC0) */
#define pADI_ADCC0                     ((ADI_ADCC_TypeDef     *) ADI_ADCC0_BASE      ) /*!<  Pointer to ADC Controller (ADCC0) */
#define pADI_ADCC1                     ((ADI_ADCC_TypeDef     *) ADI_ADCC1_BASE      ) /*!<  Pointer to ADC Controller (ADCC1) */
#define pADI_DACC0                     ((ADI_DACC_TypeDef     *) ADI_DACC0_BASE      ) /*!<  Pointer to DAC Controller (DACC0) */
#define pADI_CRC0                      ((ADI_CRC_TypeDef      *) ADI_CRC0_BASE       ) /*!<  Pointer to Cyclic Redundancy Check Unit (CRC0) */
#define pADI_HAE0                      ((ADI_HAE_TypeDef      *) ADI_HAE0_BASE       ) /*!<  Pointer to Harmonic Analysis Engine (HAE0) */
#define pADI_DMA0                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA0_BASE       ) /*!<  Pointer to DMA Channel (DMA0) */
#define pADI_DMA1                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA1_BASE       ) /*!<  Pointer to DMA Channel (DMA1) */
#define pADI_DMA2                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA2_BASE       ) /*!<  Pointer to DMA Channel (DMA2) */
#define pADI_DMA3                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA3_BASE       ) /*!<  Pointer to DMA Channel (DMA3) */
#define pADI_DMA4                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA4_BASE       ) /*!<  Pointer to DMA Channel (DMA4) */
#define pADI_DMA5                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA5_BASE       ) /*!<  Pointer to DMA Channel (DMA5) */
#define pADI_DMA6                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA6_BASE       ) /*!<  Pointer to DMA Channel (DMA6) */
#define pADI_DMA7                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA7_BASE       ) /*!<  Pointer to DMA Channel (DMA7) */
#define pADI_DMA8                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA8_BASE       ) /*!<  Pointer to DMA Channel (DMA8) */
#define pADI_DMA9                      ((ADI_DMA_CFG0_TypeDef *) ADI_DMA9_BASE       ) /*!<  Pointer to DMA Channel (DMA9) */
#define pADI_DMA10                     ((ADI_DMA_CFG0_TypeDef *) ADI_DMA10_BASE      ) /*!<  Pointer to DMA Channel (DMA10) */
#define pADI_DMA11                     ((ADI_DMA_CFG0_TypeDef *) ADI_DMA11_BASE      ) /*!<  Pointer to DMA Channel (DMA11) */
#define pADI_DMA12                     ((ADI_DMA_CFG1_TypeDef *) ADI_DMA12_BASE      ) /*!<  Pointer to DMA Channel (DMA12) */
#define pADI_DMA13                     ((ADI_DMA_CFG1_TypeDef *) ADI_DMA13_BASE      ) /*!<  Pointer to DMA Channel (DMA13) */
#define pADI_MBOX0_PORT1               ((ADI_MBOX_PORT1_TypeDef *) ADI_MBOX0_PORT1_BASE) /*!<  Pointer to MBOX Port 1 register map (MBOX0_PORT1) */
#define pADI_SMPU1                     ((ADI_SMPU_CFG0_TypeDef *) ADI_SMPU1_BASE      ) /*!<  Pointer to System Memory Protection Unit (SMPU1) */
#define pADI_SMPU2                     ((ADI_SMPU_CFG1_TypeDef *) ADI_SMPU2_BASE      ) /*!<  Pointer to System Memory Protection Unit (SMPU2) */
#define pADI_SWU0                      ((ADI_SWU_TypeDef      *) ADI_SWU0_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU0) */
#define pADI_SWU1                      ((ADI_SWU_TypeDef      *) ADI_SWU1_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU1) */
#define pADI_SWU2                      ((ADI_SWU_TypeDef      *) ADI_SWU2_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU2) */
#define pADI_SWU3                      ((ADI_SWU_TypeDef      *) ADI_SWU3_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU3) */
#define pADI_SWU4                      ((ADI_SWU_TypeDef      *) ADI_SWU4_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU4) */
#define pADI_SWU5                      ((ADI_SWU_TypeDef      *) ADI_SWU5_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU5) */
#define pADI_SWU6                      ((ADI_SWU_TypeDef      *) ADI_SWU6_BASE       ) /*!<  Pointer to System Watchpoint Unit (SWU6) */
#define pADI_SPU1                      ((ADI_SPU_CFG0_TypeDef *) ADI_SPU1_BASE       ) /*!<  Pointer to System Protection Unit (SPU1) */
#define pADI_C0                        ((ADI_C_CFG1_TypeDef   *) ADI_C0_BASE         ) /*!<  Pointer to Pads Controller (C0) */
#define pADI_TEPADS0                   ((ADI_TEPADS_CFG1_TypeDef *) ADI_TEPADS0_BASE    ) /*!<  Pointer to Pads Controller (TEPADS0) */
#define pADI_PORTA                     ((ADI_PORT_CFG1_TypeDef *) ADI_PORTA_BASE      ) /*!<  Pointer to General Purpose Input/Output (PORTA) */
#define pADI_SEC0                      ((ADI_SEC_CFG1_TypeDef *) ADI_SEC0_BASE       ) /*!<  Pointer to System Event Controller (SEC0) */
#define pADI_TRU0                      ((ADI_TRU_CFG1_TypeDef *) ADI_TRU0_BASE       ) /*!<  Pointer to Trigger Routing Unit (TRU0) */
#define pADI_SMPU0                     ((ADI_SMPU_CFG2_TypeDef *) ADI_SMPU0_BASE      ) /*!<  Pointer to System Memory Protection Unit (SMPU0) */
#define pADI_SPU0                      ((ADI_SPU_CFG1_TypeDef *) ADI_SPU0_BASE       ) /*!<  Pointer to System Protection Unit (SPU0) */
#define pADI_SCB0                      ((ADI_SCB_TypeDef      *) ADI_SCB0_BASE       ) /*!<  Pointer to System Crossbar (SCB0) */
#define pADI_ITM0                      ((ADI_ITM_TypeDef      *) ADI_ITM0_BASE       ) /*!<  Pointer to  (ITM0) */
#define pADI_DWT0                      ((ADI_DWT_TypeDef      *) ADI_DWT0_BASE       ) /*!<  Pointer to  (DWT0) */
#define pADI_FPB0                      ((ADI_FPB_TypeDef      *) ADI_FPB0_BASE       ) /*!<  Pointer to  (FPB0) */
#define pADI_SCS0                      ((ADI_SCS_TypeDef      *) ADI_SCS0_BASE       ) /*!<  Pointer to  (SCS0) */
#define pADI_TRACE0                    ((ADI_TRACE_TypeDef    *) ADI_TRACE0_BASE     ) /*!<  Pointer to Trace Port Interface Unit (TRACE0) */
#define pADI_ETM0                      ((ADI_ETM_TypeDef      *) ADI_ETM0_BASE       ) /*!<  Pointer to  (ETM0) */
#define pADI_CSTF0                     ((ADI_CSTF_TypeDef     *) ADI_CSTF0_BASE      ) /*!<  Pointer to CSTF_Register_Definitions (CSTF0) */
#define pADI_CXTMC0                    ((ADI_CXTMC_TypeDef    *) ADI_CXTMC0_BASE     ) /*!<  Pointer to CoreSight TMC  (CXTMC0) */
#define pADI_CTI0                      ((ADI_CTI_CFG0_TypeDef *) ADI_CTI0_BASE       ) /*!<  Pointer to CSCTI_Register_Definitions (CTI0) */
#define pADI_CTI1                      ((ADI_CTI_CFG1_TypeDef *) ADI_CTI1_BASE       ) /*!<  Pointer to CSCTI_Register_Definitions (CTI1) */
#define pADI_CTI2                      ((ADI_CTI_CFG2_TypeDef *) ADI_CTI2_BASE       ) /*!<  Pointer to CSCTI_Register_Definitions (CTI2) */
#define pADI_CTI3                      ((ADI_CTI_CFG3_TypeDef *) ADI_CTI3_BASE       ) /*!<  Pointer to CSCTI_Register_Definitions (CTI3) */
#define pADI_M4P                       ((ADI_M4P_TypeDef      *) ADI_M4P_BASE        ) /*!<  Pointer to ARM Cortex-M4 Platform (M4P) */
#define pADI_MATH0                     ((ADI_MATH_TypeDef     *) ADI_MATH0_BASE      ) /*!<  Pointer to Math Unit Function (MATH0) */
#define pADI_FLC0                      ((ADI_FLC_TypeDef      *) ADI_FLC0_BASE       ) /*!<  Pointer to Flash Controller (FLC0) */
#define pADI_FLC1                      ((ADI_FLC_TypeDef      *) ADI_FLC1_BASE       ) /*!<  Pointer to Flash Controller (FLC1) */

/*!    @} */


// here beginnith the addons...

#include <core_cm4.h>    /* Cortex-M4 processor and core peripherals*/

#endif

