/* ================================================================================

     Project      :   CM41X_M0
     File         :   CM41X_M0_cdef.h
     Description  :   C MMR Pointer Definitions

     Date         :   Feb 27, 2015

     Copyright (c) Analog Devices, Inc.  All Rights Reserved.
     This software is proprietary and confidential to Analog Devices, Inc. and
     its licensors.

     This file was auto-generated. Do not make local changes to this file.

   ================================================================================ */

#ifndef _CM41X_M0_CDEF_H
#define _CM41X_M0_CDEF_H

#include <stdint.h>

/* pickup register bitfield and bit masks */
#include "CM41X_M0.h"


/*  =================================================================================
 *      Pads Controller (C1)
 *  ================================================================================= */
#define pREG_C1_DMA_MUXCTL               ((volatile  uint32_t *) REG_C1_DMA_MUXCTL)               /*  Peripheral DMA Multiplexer Control */
#define pREG_C1_PWM_SYS_CFG              ((volatile  uint32_t *) REG_C1_PWM_SYS_CFG)              /*  PWM System Configuration Register */
#define pREG_C1_MBIST_CTL                ((volatile  uint32_t *) REG_C1_MBIST_CTL)                /*  MBIST Control Register */
#define pREG_C1_SINC_TEST                ((volatile  uint32_t *) REG_C1_SINC_TEST)                /*  SINC Test Register */
#define pREG_C1_SYSSTAT                  ((volatile  uint32_t *) REG_C1_SYSSTAT)                  /*  System Status Register */
#define pREG_C1_CLKNG_TRIPEN             ((volatile  uint32_t *) REG_C1_CLKNG_TRIPEN)             /*  Clock Not Good Trip Register */
#define pREG_C1_FAULT_TRIPEN             ((volatile  uint32_t *) REG_C1_FAULT_TRIPEN)             /*  Fault Trip Register */
#define pREG_C1_ROT_UPDN_CFG             ((volatile  uint32_t *) REG_C1_ROT_UPDN_CFG)             /*  Rotary Counter Up/Down Configuration Register */
#define pREG_C1_AHB_RESP_CFG             ((volatile  uint32_t *) REG_C1_AHB_RESP_CFG)             /*  AHB Response Configuration Register */
#define pREG_C1_AHB_TIMEOUT_VALUE        ((volatile  uint32_t *) REG_C1_AHB_TIMEOUT_VALUE)        /*  AHB Timeout Value Register */
#define pREG_C1_ENG_MODE_CFG0            ((volatile  uint32_t *) REG_C1_ENG_MODE_CFG0)            /*  Engineering Mode Configuration Register 0 */
#define pREG_C1_LROM_STAT                ((volatile  uint32_t *) REG_C1_LROM_STAT)                /*  Logic ROM status register */

/*  =================================================================================
 *      Pads Controller (TEPADS1)
 *  ================================================================================= */
#define pREG_TEPADS1_PCFG0               ((volatile  uint32_t *) REG_TEPADS1_PCFG0)               /*  Peripheral Configuration0 Register */
#define pREG_TEPADS1_FOCP_DIV            ((volatile  uint32_t *) REG_TEPADS1_FOCP_DIV)            /*  Fast Over Current Protection Clock Divisor */
#define pREG_TEPADS1_DBC_PRESCALE        ((volatile  uint32_t *) REG_TEPADS1_DBC_PRESCALE)        /*  Debounce Prescale Register */
#define pREG_TEPADS1_DBC0_CTL            ((volatile  uint32_t *) REG_TEPADS1_DBC0_CTL)            /*  Debounce  Control Register(s) */
#define pREG_TEPADS1_DBC1_CTL            ((volatile  uint32_t *) REG_TEPADS1_DBC1_CTL)            /*  Debounce  Control Register(s) */
#define pREG_TEPADS1_DBC2_CTL            ((volatile  uint32_t *) REG_TEPADS1_DBC2_CTL)            /*  Debounce  Control Register(s) */
#define pREG_TEPADS1_DBC3_CTL            ((volatile  uint32_t *) REG_TEPADS1_DBC3_CTL)            /*  Debounce  Control Register(s) */
#define pREG_TEPADS1_VMU_CTL             ((volatile  uint32_t *) REG_TEPADS1_VMU_CTL)             /*  Voltage Monitor Unit Control Register */
#define pREG_TEPADS1_VMU_TEST            ((volatile  uint32_t *) REG_TEPADS1_VMU_TEST)            /*  Voltage Monitor Unit Test Register */
#define pREG_TEPADS1_VMU_TRIPEN          ((volatile  uint32_t *) REG_TEPADS1_VMU_TRIPEN)          /*  Voltage Monitor Unit Trip Enable Register */
#define pREG_TEPADS1_NVWR_RSTCTL         ((volatile  uint32_t *) REG_TEPADS1_NVWR_RSTCTL)         /*  Non-Volatile Write Reset Control Register */
#define pREG_TEPADS1_MONOSC_CFG          ((volatile  uint32_t *) REG_TEPADS1_MONOSC_CFG)          /*  Monitor Oscillator Control Register */
#define pREG_TEPADS1_PORTB_DS            ((volatile  uint32_t *) REG_TEPADS1_PORTB_DS)            /*  Multiport Drive Strength Register */
#define pREG_TEPADS1_PORTC_DS            ((volatile  uint32_t *) REG_TEPADS1_PORTC_DS)            /*  Multiport Drive Strength Register */
#define pREG_TEPADS1_PORTD_DS            ((volatile  uint32_t *) REG_TEPADS1_PORTD_DS)            /*  Multiport Drive Strength Register */
#define pREG_TEPADS1_PORTE_DS            ((volatile  uint32_t *) REG_TEPADS1_PORTE_DS)            /*  Multiport Drive Strength Register */
#define pREG_TEPADS1_PORTF_DS            ((volatile  uint32_t *) REG_TEPADS1_PORTF_DS)            /*  Multiport Drive Strength Register */
#define pREG_TEPADS1_PORTB_RCTL          ((volatile  uint32_t *) REG_TEPADS1_PORTB_RCTL)          /*  Multiport Pullup/Pulldown Resistor Control Register */
#define pREG_TEPADS1_PORTC_RCTL          ((volatile  uint32_t *) REG_TEPADS1_PORTC_RCTL)          /*  Multiport Pullup/Pulldown Resistor Control Register */
#define pREG_TEPADS1_PORTD_RCTL          ((volatile  uint32_t *) REG_TEPADS1_PORTD_RCTL)          /*  Multiport Pullup/Pulldown Resistor Control Register */
#define pREG_TEPADS1_PORTE_RCTL          ((volatile  uint32_t *) REG_TEPADS1_PORTE_RCTL)          /*  Multiport Pullup/Pulldown Resistor Control Register */
#define pREG_TEPADS1_PORTF_RCTL          ((volatile  uint32_t *) REG_TEPADS1_PORTF_RCTL)          /*  Multiport Pullup/Pulldown Resistor Control Register */
#define pREG_TEPADS1_PORTB_TRIPST        ((volatile  uint32_t *) REG_TEPADS1_PORTB_TRIPST)        /*  Multiport Trip State Register */
#define pREG_TEPADS1_PORTC_TRIPST        ((volatile  uint32_t *) REG_TEPADS1_PORTC_TRIPST)        /*  Multiport Trip State Register */
#define pREG_TEPADS1_PORTD_TRIPST        ((volatile  uint32_t *) REG_TEPADS1_PORTD_TRIPST)        /*  Multiport Trip State Register */
#define pREG_TEPADS1_PORTE_TRIPST        ((volatile  uint32_t *) REG_TEPADS1_PORTE_TRIPST)        /*  Multiport Trip State Register */
#define pREG_TEPADS1_PORTF_TRIPST        ((volatile  uint32_t *) REG_TEPADS1_PORTF_TRIPST)        /*  Multiport Trip State Register */
#define pREG_TEPADS1_PORTB_TRIPSEL       ((volatile  uint32_t *) REG_TEPADS1_PORTB_TRIPSEL)       /*  Multiport Trip Select */
#define pREG_TEPADS1_PORTC_TRIPSEL       ((volatile  uint32_t *) REG_TEPADS1_PORTC_TRIPSEL)       /*  Multiport Trip Select */
#define pREG_TEPADS1_PORTD_TRIPSEL       ((volatile  uint32_t *) REG_TEPADS1_PORTD_TRIPSEL)       /*  Multiport Trip Select */
#define pREG_TEPADS1_PORTE_TRIPSEL       ((volatile  uint32_t *) REG_TEPADS1_PORTE_TRIPSEL)       /*  Multiport Trip Select */
#define pREG_TEPADS1_PORTF_TRIPSEL       ((volatile  uint32_t *) REG_TEPADS1_PORTF_TRIPSEL)       /*  Multiport Trip Select */

/*  =================================================================================
 *      CHIP ID For ARM Emulators (EMUID0)
 *  ================================================================================= */
#define pREG_EMUID0_ADIID                ((volatile  uint16_t *) REG_EMUID0_ADIID)                /*  Analog Devices Identification */
#define pREG_EMUID0_CHIPID               ((volatile  uint16_t *) REG_EMUID0_CHIPID)               /*  Chip Identification */

/*  =================================================================================
 *      PINT (PINT0)
 *  ================================================================================= */
#define pREG_PINT0_MSK_SET               ((volatile  uint32_t *) REG_PINT0_MSK_SET)               /*  Pint Mask Set Register */
#define pREG_PINT0_MSK_CLR               ((volatile  uint32_t *) REG_PINT0_MSK_CLR)               /*  Pint Mask Clear Register */
#define pREG_PINT0_REQ                   ((volatile  uint32_t *) REG_PINT0_REQ)                   /*  Pint Request Register */
#define pREG_PINT0_ASSIGN                ((volatile  uint32_t *) REG_PINT0_ASSIGN)                /*  Pint Assign Register */
#define pREG_PINT0_EDGE_SET              ((volatile  uint32_t *) REG_PINT0_EDGE_SET)              /*  Pint Edge Set Register */
#define pREG_PINT0_EDGE_CLR              ((volatile  uint32_t *) REG_PINT0_EDGE_CLR)              /*  Pint Edge Clear Register */
#define pREG_PINT0_INV_SET               ((volatile  uint32_t *) REG_PINT0_INV_SET)               /*  Pint Invert Set Register */
#define pREG_PINT0_INV_CLR               ((volatile  uint32_t *) REG_PINT0_INV_CLR)               /*  Pint Invert Clear Register */
#define pREG_PINT0_PINSTATE              ((volatile  uint32_t *) REG_PINT0_PINSTATE)              /*  Pint Pinstate Register */
#define pREG_PINT0_LATCH                 ((volatile  uint32_t *) REG_PINT0_LATCH)                 /*  Pint Latch Register */

/*  =================================================================================
 *      PINT (PINT1)
 *  ================================================================================= */
#define pREG_PINT1_MSK_SET               ((volatile  uint32_t *) REG_PINT1_MSK_SET)               /*  Pint Mask Set Register */
#define pREG_PINT1_MSK_CLR               ((volatile  uint32_t *) REG_PINT1_MSK_CLR)               /*  Pint Mask Clear Register */
#define pREG_PINT1_REQ                   ((volatile  uint32_t *) REG_PINT1_REQ)                   /*  Pint Request Register */
#define pREG_PINT1_ASSIGN                ((volatile  uint32_t *) REG_PINT1_ASSIGN)                /*  Pint Assign Register */
#define pREG_PINT1_EDGE_SET              ((volatile  uint32_t *) REG_PINT1_EDGE_SET)              /*  Pint Edge Set Register */
#define pREG_PINT1_EDGE_CLR              ((volatile  uint32_t *) REG_PINT1_EDGE_CLR)              /*  Pint Edge Clear Register */
#define pREG_PINT1_INV_SET               ((volatile  uint32_t *) REG_PINT1_INV_SET)               /*  Pint Invert Set Register */
#define pREG_PINT1_INV_CLR               ((volatile  uint32_t *) REG_PINT1_INV_CLR)               /*  Pint Invert Clear Register */
#define pREG_PINT1_PINSTATE              ((volatile  uint32_t *) REG_PINT1_PINSTATE)              /*  Pint Pinstate Register */
#define pREG_PINT1_LATCH                 ((volatile  uint32_t *) REG_PINT1_LATCH)                 /*  Pint Latch Register */

/*  =================================================================================
 *      PINT (PINT2)
 *  ================================================================================= */
#define pREG_PINT2_MSK_SET               ((volatile  uint32_t *) REG_PINT2_MSK_SET)               /*  Pint Mask Set Register */
#define pREG_PINT2_MSK_CLR               ((volatile  uint32_t *) REG_PINT2_MSK_CLR)               /*  Pint Mask Clear Register */
#define pREG_PINT2_REQ                   ((volatile  uint32_t *) REG_PINT2_REQ)                   /*  Pint Request Register */
#define pREG_PINT2_ASSIGN                ((volatile  uint32_t *) REG_PINT2_ASSIGN)                /*  Pint Assign Register */
#define pREG_PINT2_EDGE_SET              ((volatile  uint32_t *) REG_PINT2_EDGE_SET)              /*  Pint Edge Set Register */
#define pREG_PINT2_EDGE_CLR              ((volatile  uint32_t *) REG_PINT2_EDGE_CLR)              /*  Pint Edge Clear Register */
#define pREG_PINT2_INV_SET               ((volatile  uint32_t *) REG_PINT2_INV_SET)               /*  Pint Invert Set Register */
#define pREG_PINT2_INV_CLR               ((volatile  uint32_t *) REG_PINT2_INV_CLR)               /*  Pint Invert Clear Register */
#define pREG_PINT2_PINSTATE              ((volatile  uint32_t *) REG_PINT2_PINSTATE)              /*  Pint Pinstate Register */
#define pREG_PINT2_LATCH                 ((volatile  uint32_t *) REG_PINT2_LATCH)                 /*  Pint Latch Register */

/*  =================================================================================
 *      PINT (PINT3)
 *  ================================================================================= */
#define pREG_PINT3_MSK_SET               ((volatile  uint32_t *) REG_PINT3_MSK_SET)               /*  Pint Mask Set Register */
#define pREG_PINT3_MSK_CLR               ((volatile  uint32_t *) REG_PINT3_MSK_CLR)               /*  Pint Mask Clear Register */
#define pREG_PINT3_REQ                   ((volatile  uint32_t *) REG_PINT3_REQ)                   /*  Pint Request Register */
#define pREG_PINT3_ASSIGN                ((volatile  uint32_t *) REG_PINT3_ASSIGN)                /*  Pint Assign Register */
#define pREG_PINT3_EDGE_SET              ((volatile  uint32_t *) REG_PINT3_EDGE_SET)              /*  Pint Edge Set Register */
#define pREG_PINT3_EDGE_CLR              ((volatile  uint32_t *) REG_PINT3_EDGE_CLR)              /*  Pint Edge Clear Register */
#define pREG_PINT3_INV_SET               ((volatile  uint32_t *) REG_PINT3_INV_SET)               /*  Pint Invert Set Register */
#define pREG_PINT3_INV_CLR               ((volatile  uint32_t *) REG_PINT3_INV_CLR)               /*  Pint Invert Clear Register */
#define pREG_PINT3_PINSTATE              ((volatile  uint32_t *) REG_PINT3_PINSTATE)              /*  Pint Pinstate Register */
#define pREG_PINT3_LATCH                 ((volatile  uint32_t *) REG_PINT3_LATCH)                 /*  Pint Latch Register */

/*  =================================================================================
 *      PINT (PINT4)
 *  ================================================================================= */
#define pREG_PINT4_MSK_SET               ((volatile  uint32_t *) REG_PINT4_MSK_SET)               /*  Pint Mask Set Register */
#define pREG_PINT4_MSK_CLR               ((volatile  uint32_t *) REG_PINT4_MSK_CLR)               /*  Pint Mask Clear Register */
#define pREG_PINT4_REQ                   ((volatile  uint32_t *) REG_PINT4_REQ)                   /*  Pint Request Register */
#define pREG_PINT4_ASSIGN                ((volatile  uint32_t *) REG_PINT4_ASSIGN)                /*  Pint Assign Register */
#define pREG_PINT4_EDGE_SET              ((volatile  uint32_t *) REG_PINT4_EDGE_SET)              /*  Pint Edge Set Register */
#define pREG_PINT4_EDGE_CLR              ((volatile  uint32_t *) REG_PINT4_EDGE_CLR)              /*  Pint Edge Clear Register */
#define pREG_PINT4_INV_SET               ((volatile  uint32_t *) REG_PINT4_INV_SET)               /*  Pint Invert Set Register */
#define pREG_PINT4_INV_CLR               ((volatile  uint32_t *) REG_PINT4_INV_CLR)               /*  Pint Invert Clear Register */
#define pREG_PINT4_PINSTATE              ((volatile  uint32_t *) REG_PINT4_PINSTATE)              /*  Pint Pinstate Register */
#define pREG_PINT4_LATCH                 ((volatile  uint32_t *) REG_PINT4_LATCH)                 /*  Pint Latch Register */

/*  =================================================================================
 *      PINT (PINT5)
 *  ================================================================================= */
#define pREG_PINT5_MSK_SET               ((volatile  uint32_t *) REG_PINT5_MSK_SET)               /*  Pint Mask Set Register */
#define pREG_PINT5_MSK_CLR               ((volatile  uint32_t *) REG_PINT5_MSK_CLR)               /*  Pint Mask Clear Register */
#define pREG_PINT5_REQ                   ((volatile  uint32_t *) REG_PINT5_REQ)                   /*  Pint Request Register */
#define pREG_PINT5_ASSIGN                ((volatile  uint32_t *) REG_PINT5_ASSIGN)                /*  Pint Assign Register */
#define pREG_PINT5_EDGE_SET              ((volatile  uint32_t *) REG_PINT5_EDGE_SET)              /*  Pint Edge Set Register */
#define pREG_PINT5_EDGE_CLR              ((volatile  uint32_t *) REG_PINT5_EDGE_CLR)              /*  Pint Edge Clear Register */
#define pREG_PINT5_INV_SET               ((volatile  uint32_t *) REG_PINT5_INV_SET)               /*  Pint Invert Set Register */
#define pREG_PINT5_INV_CLR               ((volatile  uint32_t *) REG_PINT5_INV_CLR)               /*  Pint Invert Clear Register */
#define pREG_PINT5_PINSTATE              ((volatile  uint32_t *) REG_PINT5_PINSTATE)              /*  Pint Pinstate Register */
#define pREG_PINT5_LATCH                 ((volatile  uint32_t *) REG_PINT5_LATCH)                 /*  Pint Latch Register */

/*  =================================================================================
 *      General Purpose Input/Output (PORTB)
 *  ================================================================================= */
#define pREG_PORTB_FER                   ((volatile  uint32_t *) REG_PORTB_FER)                   /*  Port x Function Enable Register */
#define pREG_PORTB_FER_SET               ((volatile  uint32_t *) REG_PORTB_FER_SET)               /*  Port x Function Enable Set Register */
#define pREG_PORTB_FER_CLR               ((volatile  uint32_t *) REG_PORTB_FER_CLR)               /*  Port x Function Enable Clear Register */
#define pREG_PORTB_DATA                  ((volatile  uint32_t *) REG_PORTB_DATA)                  /*  Port x GPIO Data Register */
#define pREG_PORTB_DATA_SET              ((volatile  uint32_t *) REG_PORTB_DATA_SET)              /*  Port x GPIO Data Set Register */
#define pREG_PORTB_DATA_CLR              ((volatile  uint32_t *) REG_PORTB_DATA_CLR)              /*  Port x GPIO Data Clear Register */
#define pREG_PORTB_DIR                   ((volatile  uint32_t *) REG_PORTB_DIR)                   /*  Port x GPIO Direction Register */
#define pREG_PORTB_DIR_SET               ((volatile  uint32_t *) REG_PORTB_DIR_SET)               /*  Port x GPIO Direction Set Register */
#define pREG_PORTB_DIR_CLR               ((volatile  uint32_t *) REG_PORTB_DIR_CLR)               /*  Port x GPIO Direction Clear Register */
#define pREG_PORTB_INEN                  ((volatile  uint32_t *) REG_PORTB_INEN)                  /*  Port x GPIO Input Enable Register */
#define pREG_PORTB_INEN_SET              ((volatile  uint32_t *) REG_PORTB_INEN_SET)              /*  Port x GPIO Input Enable Set Register */
#define pREG_PORTB_INEN_CLR              ((volatile  uint32_t *) REG_PORTB_INEN_CLR)              /*  Port x GPIO Input Enable Clear Register */
#define pREG_PORTB_MUX                   ((volatile  uint32_t *) REG_PORTB_MUX)                   /*  Port x Multiplexer Control Register */
#define pREG_PORTB_DATA_TGL              ((volatile  uint32_t *) REG_PORTB_DATA_TGL)              /*  Port x GPIO Input Enable Toggle Register */
#define pREG_PORTB_POL                   ((volatile  uint32_t *) REG_PORTB_POL)                   /*  Port x GPIO Polarity Invert Register */
#define pREG_PORTB_POL_SET               ((volatile  uint32_t *) REG_PORTB_POL_SET)               /*  Port x GPIO Polarity Invert Set Register */
#define pREG_PORTB_POL_CLR               ((volatile  uint32_t *) REG_PORTB_POL_CLR)               /*  Port x GPIO Polarity Invert Clear Register */
#define pREG_PORTB_LOCK                  ((volatile  uint32_t *) REG_PORTB_LOCK)                  /*  Port x GPIO Lock Register */
#define pREG_PORTB_TRIG_TGL              ((volatile  uint32_t *) REG_PORTB_TRIG_TGL)              /*  Port x GPIO Trigger Toggle Register */

/*  =================================================================================
 *      General Purpose Input/Output (PORTC)
 *  ================================================================================= */
#define pREG_PORTC_FER                   ((volatile  uint32_t *) REG_PORTC_FER)                   /*  Port x Function Enable Register */
#define pREG_PORTC_FER_SET               ((volatile  uint32_t *) REG_PORTC_FER_SET)               /*  Port x Function Enable Set Register */
#define pREG_PORTC_FER_CLR               ((volatile  uint32_t *) REG_PORTC_FER_CLR)               /*  Port x Function Enable Clear Register */
#define pREG_PORTC_DATA                  ((volatile  uint32_t *) REG_PORTC_DATA)                  /*  Port x GPIO Data Register */
#define pREG_PORTC_DATA_SET              ((volatile  uint32_t *) REG_PORTC_DATA_SET)              /*  Port x GPIO Data Set Register */
#define pREG_PORTC_DATA_CLR              ((volatile  uint32_t *) REG_PORTC_DATA_CLR)              /*  Port x GPIO Data Clear Register */
#define pREG_PORTC_DIR                   ((volatile  uint32_t *) REG_PORTC_DIR)                   /*  Port x GPIO Direction Register */
#define pREG_PORTC_DIR_SET               ((volatile  uint32_t *) REG_PORTC_DIR_SET)               /*  Port x GPIO Direction Set Register */
#define pREG_PORTC_DIR_CLR               ((volatile  uint32_t *) REG_PORTC_DIR_CLR)               /*  Port x GPIO Direction Clear Register */
#define pREG_PORTC_INEN                  ((volatile  uint32_t *) REG_PORTC_INEN)                  /*  Port x GPIO Input Enable Register */
#define pREG_PORTC_INEN_SET              ((volatile  uint32_t *) REG_PORTC_INEN_SET)              /*  Port x GPIO Input Enable Set Register */
#define pREG_PORTC_INEN_CLR              ((volatile  uint32_t *) REG_PORTC_INEN_CLR)              /*  Port x GPIO Input Enable Clear Register */
#define pREG_PORTC_MUX                   ((volatile  uint32_t *) REG_PORTC_MUX)                   /*  Port x Multiplexer Control Register */
#define pREG_PORTC_DATA_TGL              ((volatile  uint32_t *) REG_PORTC_DATA_TGL)              /*  Port x GPIO Input Enable Toggle Register */
#define pREG_PORTC_POL                   ((volatile  uint32_t *) REG_PORTC_POL)                   /*  Port x GPIO Polarity Invert Register */
#define pREG_PORTC_POL_SET               ((volatile  uint32_t *) REG_PORTC_POL_SET)               /*  Port x GPIO Polarity Invert Set Register */
#define pREG_PORTC_POL_CLR               ((volatile  uint32_t *) REG_PORTC_POL_CLR)               /*  Port x GPIO Polarity Invert Clear Register */
#define pREG_PORTC_LOCK                  ((volatile  uint32_t *) REG_PORTC_LOCK)                  /*  Port x GPIO Lock Register */
#define pREG_PORTC_TRIG_TGL              ((volatile  uint32_t *) REG_PORTC_TRIG_TGL)              /*  Port x GPIO Trigger Toggle Register */

/*  =================================================================================
 *      General Purpose Input/Output (PORTD)
 *  ================================================================================= */
#define pREG_PORTD_FER                   ((volatile  uint32_t *) REG_PORTD_FER)                   /*  Port x Function Enable Register */
#define pREG_PORTD_FER_SET               ((volatile  uint32_t *) REG_PORTD_FER_SET)               /*  Port x Function Enable Set Register */
#define pREG_PORTD_FER_CLR               ((volatile  uint32_t *) REG_PORTD_FER_CLR)               /*  Port x Function Enable Clear Register */
#define pREG_PORTD_DATA                  ((volatile  uint32_t *) REG_PORTD_DATA)                  /*  Port x GPIO Data Register */
#define pREG_PORTD_DATA_SET              ((volatile  uint32_t *) REG_PORTD_DATA_SET)              /*  Port x GPIO Data Set Register */
#define pREG_PORTD_DATA_CLR              ((volatile  uint32_t *) REG_PORTD_DATA_CLR)              /*  Port x GPIO Data Clear Register */
#define pREG_PORTD_DIR                   ((volatile  uint32_t *) REG_PORTD_DIR)                   /*  Port x GPIO Direction Register */
#define pREG_PORTD_DIR_SET               ((volatile  uint32_t *) REG_PORTD_DIR_SET)               /*  Port x GPIO Direction Set Register */
#define pREG_PORTD_DIR_CLR               ((volatile  uint32_t *) REG_PORTD_DIR_CLR)               /*  Port x GPIO Direction Clear Register */
#define pREG_PORTD_INEN                  ((volatile  uint32_t *) REG_PORTD_INEN)                  /*  Port x GPIO Input Enable Register */
#define pREG_PORTD_INEN_SET              ((volatile  uint32_t *) REG_PORTD_INEN_SET)              /*  Port x GPIO Input Enable Set Register */
#define pREG_PORTD_INEN_CLR              ((volatile  uint32_t *) REG_PORTD_INEN_CLR)              /*  Port x GPIO Input Enable Clear Register */
#define pREG_PORTD_MUX                   ((volatile  uint32_t *) REG_PORTD_MUX)                   /*  Port x Multiplexer Control Register */
#define pREG_PORTD_DATA_TGL              ((volatile  uint32_t *) REG_PORTD_DATA_TGL)              /*  Port x GPIO Input Enable Toggle Register */
#define pREG_PORTD_POL                   ((volatile  uint32_t *) REG_PORTD_POL)                   /*  Port x GPIO Polarity Invert Register */
#define pREG_PORTD_POL_SET               ((volatile  uint32_t *) REG_PORTD_POL_SET)               /*  Port x GPIO Polarity Invert Set Register */
#define pREG_PORTD_POL_CLR               ((volatile  uint32_t *) REG_PORTD_POL_CLR)               /*  Port x GPIO Polarity Invert Clear Register */
#define pREG_PORTD_LOCK                  ((volatile  uint32_t *) REG_PORTD_LOCK)                  /*  Port x GPIO Lock Register */
#define pREG_PORTD_TRIG_TGL              ((volatile  uint32_t *) REG_PORTD_TRIG_TGL)              /*  Port x GPIO Trigger Toggle Register */

/*  =================================================================================
 *      General Purpose Input/Output (PORTE)
 *  ================================================================================= */
#define pREG_PORTE_FER                   ((volatile  uint32_t *) REG_PORTE_FER)                   /*  Port x Function Enable Register */
#define pREG_PORTE_FER_SET               ((volatile  uint32_t *) REG_PORTE_FER_SET)               /*  Port x Function Enable Set Register */
#define pREG_PORTE_FER_CLR               ((volatile  uint32_t *) REG_PORTE_FER_CLR)               /*  Port x Function Enable Clear Register */
#define pREG_PORTE_DATA                  ((volatile  uint32_t *) REG_PORTE_DATA)                  /*  Port x GPIO Data Register */
#define pREG_PORTE_DATA_SET              ((volatile  uint32_t *) REG_PORTE_DATA_SET)              /*  Port x GPIO Data Set Register */
#define pREG_PORTE_DATA_CLR              ((volatile  uint32_t *) REG_PORTE_DATA_CLR)              /*  Port x GPIO Data Clear Register */
#define pREG_PORTE_DIR                   ((volatile  uint32_t *) REG_PORTE_DIR)                   /*  Port x GPIO Direction Register */
#define pREG_PORTE_DIR_SET               ((volatile  uint32_t *) REG_PORTE_DIR_SET)               /*  Port x GPIO Direction Set Register */
#define pREG_PORTE_DIR_CLR               ((volatile  uint32_t *) REG_PORTE_DIR_CLR)               /*  Port x GPIO Direction Clear Register */
#define pREG_PORTE_INEN                  ((volatile  uint32_t *) REG_PORTE_INEN)                  /*  Port x GPIO Input Enable Register */
#define pREG_PORTE_INEN_SET              ((volatile  uint32_t *) REG_PORTE_INEN_SET)              /*  Port x GPIO Input Enable Set Register */
#define pREG_PORTE_INEN_CLR              ((volatile  uint32_t *) REG_PORTE_INEN_CLR)              /*  Port x GPIO Input Enable Clear Register */
#define pREG_PORTE_MUX                   ((volatile  uint32_t *) REG_PORTE_MUX)                   /*  Port x Multiplexer Control Register */
#define pREG_PORTE_DATA_TGL              ((volatile  uint32_t *) REG_PORTE_DATA_TGL)              /*  Port x GPIO Input Enable Toggle Register */
#define pREG_PORTE_POL                   ((volatile  uint32_t *) REG_PORTE_POL)                   /*  Port x GPIO Polarity Invert Register */
#define pREG_PORTE_POL_SET               ((volatile  uint32_t *) REG_PORTE_POL_SET)               /*  Port x GPIO Polarity Invert Set Register */
#define pREG_PORTE_POL_CLR               ((volatile  uint32_t *) REG_PORTE_POL_CLR)               /*  Port x GPIO Polarity Invert Clear Register */
#define pREG_PORTE_LOCK                  ((volatile  uint32_t *) REG_PORTE_LOCK)                  /*  Port x GPIO Lock Register */
#define pREG_PORTE_TRIG_TGL              ((volatile  uint32_t *) REG_PORTE_TRIG_TGL)              /*  Port x GPIO Trigger Toggle Register */

/*  =================================================================================
 *      General Purpose Input/Output (PORTF)
 *  ================================================================================= */
#define pREG_PORTF_FER                   ((volatile  uint32_t *) REG_PORTF_FER)                   /*  Port x Function Enable Register */
#define pREG_PORTF_FER_SET               ((volatile  uint32_t *) REG_PORTF_FER_SET)               /*  Port x Function Enable Set Register */
#define pREG_PORTF_FER_CLR               ((volatile  uint32_t *) REG_PORTF_FER_CLR)               /*  Port x Function Enable Clear Register */
#define pREG_PORTF_DATA                  ((volatile  uint32_t *) REG_PORTF_DATA)                  /*  Port x GPIO Data Register */
#define pREG_PORTF_DATA_SET              ((volatile  uint32_t *) REG_PORTF_DATA_SET)              /*  Port x GPIO Data Set Register */
#define pREG_PORTF_DATA_CLR              ((volatile  uint32_t *) REG_PORTF_DATA_CLR)              /*  Port x GPIO Data Clear Register */
#define pREG_PORTF_DIR                   ((volatile  uint32_t *) REG_PORTF_DIR)                   /*  Port x GPIO Direction Register */
#define pREG_PORTF_DIR_SET               ((volatile  uint32_t *) REG_PORTF_DIR_SET)               /*  Port x GPIO Direction Set Register */
#define pREG_PORTF_DIR_CLR               ((volatile  uint32_t *) REG_PORTF_DIR_CLR)               /*  Port x GPIO Direction Clear Register */
#define pREG_PORTF_INEN                  ((volatile  uint32_t *) REG_PORTF_INEN)                  /*  Port x GPIO Input Enable Register */
#define pREG_PORTF_INEN_SET              ((volatile  uint32_t *) REG_PORTF_INEN_SET)              /*  Port x GPIO Input Enable Set Register */
#define pREG_PORTF_INEN_CLR              ((volatile  uint32_t *) REG_PORTF_INEN_CLR)              /*  Port x GPIO Input Enable Clear Register */
#define pREG_PORTF_MUX                   ((volatile  uint32_t *) REG_PORTF_MUX)                   /*  Port x Multiplexer Control Register */
#define pREG_PORTF_DATA_TGL              ((volatile  uint32_t *) REG_PORTF_DATA_TGL)              /*  Port x GPIO Input Enable Toggle Register */
#define pREG_PORTF_POL                   ((volatile  uint32_t *) REG_PORTF_POL)                   /*  Port x GPIO Polarity Invert Register */
#define pREG_PORTF_POL_SET               ((volatile  uint32_t *) REG_PORTF_POL_SET)               /*  Port x GPIO Polarity Invert Set Register */
#define pREG_PORTF_POL_CLR               ((volatile  uint32_t *) REG_PORTF_POL_CLR)               /*  Port x GPIO Polarity Invert Clear Register */
#define pREG_PORTF_LOCK                  ((volatile  uint32_t *) REG_PORTF_LOCK)                  /*  Port x GPIO Lock Register */
#define pREG_PORTF_TRIG_TGL              ((volatile  uint32_t *) REG_PORTF_TRIG_TGL)              /*  Port x GPIO Trigger Toggle Register */

/*  =================================================================================
 *      Logic Block Array (LBA0)
 *  ================================================================================= */
#define pREG_LBA0_CLK_CTL                ((volatile  uint32_t *) REG_LBA0_CLK_CTL)                /*  Logic Block Array Clock Divisor */
#define pREG_LBA0_DIR                    ((volatile  uint32_t *) REG_LBA0_DIR)                    /*  Logic Block Array Pin Direction */
#define pREG_LBA0_DIN                    ((volatile  uint32_t *) REG_LBA0_DIN)                    /*  Logic Block Array Data Input */
#define pREG_LBA0_DOUT                   ((volatile  uint32_t *) REG_LBA0_DOUT)                   /*  Logic Block Array Data Output */
#define pREG_LBA0_CFG                    ((volatile  uint32_t *) REG_LBA0_CFG)                    /*  Logic Block Array Configuration Register */
#define pREG_LBA0_SYNC_CTL               ((volatile  uint32_t *) REG_LBA0_SYNC_CTL)               /*  Logic Block Array GPIO Input Synchronization Control */
#define pREG_LBA0_BLK0_CTL               ((volatile  uint32_t *) REG_LBA0_BLK0_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK1_CTL               ((volatile  uint32_t *) REG_LBA0_BLK1_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK2_CTL               ((volatile  uint32_t *) REG_LBA0_BLK2_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK3_CTL               ((volatile  uint32_t *) REG_LBA0_BLK3_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK4_CTL               ((volatile  uint32_t *) REG_LBA0_BLK4_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK5_CTL               ((volatile  uint32_t *) REG_LBA0_BLK5_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK6_CTL               ((volatile  uint32_t *) REG_LBA0_BLK6_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK7_CTL               ((volatile  uint32_t *) REG_LBA0_BLK7_CTL)               /*  Logic Block Control Register */
#define pREG_LBA0_BLK0_FN0               ((volatile  uint32_t *) REG_LBA0_BLK0_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK0_FN1               ((volatile  uint32_t *) REG_LBA0_BLK0_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK0_FN2               ((volatile  uint32_t *) REG_LBA0_BLK0_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK0_FN3               ((volatile  uint32_t *) REG_LBA0_BLK0_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK0_FN4               ((volatile  uint32_t *) REG_LBA0_BLK0_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK0_FN5               ((volatile  uint32_t *) REG_LBA0_BLK0_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK0_FN6               ((volatile  uint32_t *) REG_LBA0_BLK0_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK0_FN7               ((volatile  uint32_t *) REG_LBA0_BLK0_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK1_FN0               ((volatile  uint32_t *) REG_LBA0_BLK1_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK1_FN1               ((volatile  uint32_t *) REG_LBA0_BLK1_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK1_FN2               ((volatile  uint32_t *) REG_LBA0_BLK1_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK1_FN3               ((volatile  uint32_t *) REG_LBA0_BLK1_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK1_FN4               ((volatile  uint32_t *) REG_LBA0_BLK1_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK1_FN5               ((volatile  uint32_t *) REG_LBA0_BLK1_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK1_FN6               ((volatile  uint32_t *) REG_LBA0_BLK1_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK1_FN7               ((volatile  uint32_t *) REG_LBA0_BLK1_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK2_FN0               ((volatile  uint32_t *) REG_LBA0_BLK2_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK2_FN1               ((volatile  uint32_t *) REG_LBA0_BLK2_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK2_FN2               ((volatile  uint32_t *) REG_LBA0_BLK2_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK2_FN3               ((volatile  uint32_t *) REG_LBA0_BLK2_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK2_FN4               ((volatile  uint32_t *) REG_LBA0_BLK2_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK2_FN5               ((volatile  uint32_t *) REG_LBA0_BLK2_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK2_FN6               ((volatile  uint32_t *) REG_LBA0_BLK2_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK2_FN7               ((volatile  uint32_t *) REG_LBA0_BLK2_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK3_FN0               ((volatile  uint32_t *) REG_LBA0_BLK3_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK3_FN1               ((volatile  uint32_t *) REG_LBA0_BLK3_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK3_FN2               ((volatile  uint32_t *) REG_LBA0_BLK3_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK3_FN3               ((volatile  uint32_t *) REG_LBA0_BLK3_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK3_FN4               ((volatile  uint32_t *) REG_LBA0_BLK3_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK3_FN5               ((volatile  uint32_t *) REG_LBA0_BLK3_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK3_FN6               ((volatile  uint32_t *) REG_LBA0_BLK3_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK3_FN7               ((volatile  uint32_t *) REG_LBA0_BLK3_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK4_FN0               ((volatile  uint32_t *) REG_LBA0_BLK4_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK4_FN1               ((volatile  uint32_t *) REG_LBA0_BLK4_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK4_FN2               ((volatile  uint32_t *) REG_LBA0_BLK4_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK4_FN3               ((volatile  uint32_t *) REG_LBA0_BLK4_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK4_FN4               ((volatile  uint32_t *) REG_LBA0_BLK4_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK4_FN5               ((volatile  uint32_t *) REG_LBA0_BLK4_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK4_FN6               ((volatile  uint32_t *) REG_LBA0_BLK4_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK4_FN7               ((volatile  uint32_t *) REG_LBA0_BLK4_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK5_FN0               ((volatile  uint32_t *) REG_LBA0_BLK5_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK5_FN1               ((volatile  uint32_t *) REG_LBA0_BLK5_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK5_FN2               ((volatile  uint32_t *) REG_LBA0_BLK5_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK5_FN3               ((volatile  uint32_t *) REG_LBA0_BLK5_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK5_FN4               ((volatile  uint32_t *) REG_LBA0_BLK5_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK5_FN5               ((volatile  uint32_t *) REG_LBA0_BLK5_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK5_FN6               ((volatile  uint32_t *) REG_LBA0_BLK5_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK5_FN7               ((volatile  uint32_t *) REG_LBA0_BLK5_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK6_FN0               ((volatile  uint32_t *) REG_LBA0_BLK6_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK6_FN1               ((volatile  uint32_t *) REG_LBA0_BLK6_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK6_FN2               ((volatile  uint32_t *) REG_LBA0_BLK6_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK6_FN3               ((volatile  uint32_t *) REG_LBA0_BLK6_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK6_FN4               ((volatile  uint32_t *) REG_LBA0_BLK6_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK6_FN5               ((volatile  uint32_t *) REG_LBA0_BLK6_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK6_FN6               ((volatile  uint32_t *) REG_LBA0_BLK6_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK6_FN7               ((volatile  uint32_t *) REG_LBA0_BLK6_FN7)               /*  Logic Block Function 7 Register */
#define pREG_LBA0_BLK7_FN0               ((volatile  uint32_t *) REG_LBA0_BLK7_FN0)               /*  Logic Block Function 0 Register */
#define pREG_LBA0_BLK7_FN1               ((volatile  uint32_t *) REG_LBA0_BLK7_FN1)               /*  Logic Block Function 1 Register */
#define pREG_LBA0_BLK7_FN2               ((volatile  uint32_t *) REG_LBA0_BLK7_FN2)               /*  Logic Block Function 2 Register */
#define pREG_LBA0_BLK7_FN3               ((volatile  uint32_t *) REG_LBA0_BLK7_FN3)               /*  Logic Block Function 3 Register */
#define pREG_LBA0_BLK7_FN4               ((volatile  uint32_t *) REG_LBA0_BLK7_FN4)               /*  Logic Block Function 4 Register */
#define pREG_LBA0_BLK7_FN5               ((volatile  uint32_t *) REG_LBA0_BLK7_FN5)               /*  Logic Block Function 5 Register */
#define pREG_LBA0_BLK7_FN6               ((volatile  uint32_t *) REG_LBA0_BLK7_FN6)               /*  Logic Block Function 6 Register */
#define pREG_LBA0_BLK7_FN7               ((volatile  uint32_t *) REG_LBA0_BLK7_FN7)               /*  Logic Block Function 7 Register */

/*  =================================================================================
 *      System Event Controller (SEC1)
 *  ================================================================================= */
#define pREG_SEC1_GCTL                   ((volatile  uint32_t *) REG_SEC1_GCTL)                   /*  Global Control Register */
#define pREG_SEC1_GSTAT                  ((volatile  uint32_t *) REG_SEC1_GSTAT)                  /*  Global Status Register */
#define pREG_SEC1_RAISE                  ((volatile  uint32_t *) REG_SEC1_RAISE)                  /*  Global Raise Register */
#define pREG_SEC1_FCTL                   ((volatile  uint32_t *) REG_SEC1_FCTL)                   /*  Fault Control Register */
#define pREG_SEC1_FSTAT                  ((volatile  uint32_t *) REG_SEC1_FSTAT)                  /*  Fault Status Register */
#define pREG_SEC1_FSID                   ((volatile  uint32_t *) REG_SEC1_FSID)                   /*  Fault Source ID Register */
#define pREG_SEC1_FEND                   ((volatile  uint32_t *) REG_SEC1_FEND)                   /*  Fault End Register */
#define pREG_SEC1_FDLY                   ((volatile  uint32_t *) REG_SEC1_FDLY)                   /*  Fault Delay Register */
#define pREG_SEC1_FDLY_CUR               ((volatile  uint32_t *) REG_SEC1_FDLY_CUR)               /*  Fault Delay Current Register */
#define pREG_SEC1_FSRDLY                 ((volatile  uint32_t *) REG_SEC1_FSRDLY)                 /*  Fault System Reset Delay Register */
#define pREG_SEC1_FSRDLY_CUR             ((volatile  uint32_t *) REG_SEC1_FSRDLY_CUR)             /*  Fault System Reset Delay Current Register */
#define pREG_SEC1_FCOPP                  ((volatile  uint32_t *) REG_SEC1_FCOPP)                  /*  Fault COP Period Register */
#define pREG_SEC1_FCOPP_CUR              ((volatile  uint32_t *) REG_SEC1_FCOPP_CUR)              /*  Fault COP Period Current Register */
#define pREG_SEC1_SCTL0                  ((volatile  uint32_t *) REG_SEC1_SCTL0)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT0                 ((volatile  uint32_t *) REG_SEC1_SSTAT0)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL1                  ((volatile  uint32_t *) REG_SEC1_SCTL1)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT1                 ((volatile  uint32_t *) REG_SEC1_SSTAT1)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL2                  ((volatile  uint32_t *) REG_SEC1_SCTL2)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT2                 ((volatile  uint32_t *) REG_SEC1_SSTAT2)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL3                  ((volatile  uint32_t *) REG_SEC1_SCTL3)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT3                 ((volatile  uint32_t *) REG_SEC1_SSTAT3)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL4                  ((volatile  uint32_t *) REG_SEC1_SCTL4)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT4                 ((volatile  uint32_t *) REG_SEC1_SSTAT4)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL5                  ((volatile  uint32_t *) REG_SEC1_SCTL5)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT5                 ((volatile  uint32_t *) REG_SEC1_SSTAT5)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL6                  ((volatile  uint32_t *) REG_SEC1_SCTL6)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT6                 ((volatile  uint32_t *) REG_SEC1_SSTAT6)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL7                  ((volatile  uint32_t *) REG_SEC1_SCTL7)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT7                 ((volatile  uint32_t *) REG_SEC1_SSTAT7)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL8                  ((volatile  uint32_t *) REG_SEC1_SCTL8)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT8                 ((volatile  uint32_t *) REG_SEC1_SSTAT8)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL9                  ((volatile  uint32_t *) REG_SEC1_SCTL9)                  /*  Source Control Register n */
#define pREG_SEC1_SSTAT9                 ((volatile  uint32_t *) REG_SEC1_SSTAT9)                 /*  Source Status Register n */
#define pREG_SEC1_SCTL10                 ((volatile  uint32_t *) REG_SEC1_SCTL10)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT10                ((volatile  uint32_t *) REG_SEC1_SSTAT10)                /*  Source Status Register n */
#define pREG_SEC1_SCTL11                 ((volatile  uint32_t *) REG_SEC1_SCTL11)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT11                ((volatile  uint32_t *) REG_SEC1_SSTAT11)                /*  Source Status Register n */
#define pREG_SEC1_SCTL12                 ((volatile  uint32_t *) REG_SEC1_SCTL12)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT12                ((volatile  uint32_t *) REG_SEC1_SSTAT12)                /*  Source Status Register n */
#define pREG_SEC1_SCTL13                 ((volatile  uint32_t *) REG_SEC1_SCTL13)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT13                ((volatile  uint32_t *) REG_SEC1_SSTAT13)                /*  Source Status Register n */
#define pREG_SEC1_SCTL14                 ((volatile  uint32_t *) REG_SEC1_SCTL14)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT14                ((volatile  uint32_t *) REG_SEC1_SSTAT14)                /*  Source Status Register n */
#define pREG_SEC1_SCTL15                 ((volatile  uint32_t *) REG_SEC1_SCTL15)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT15                ((volatile  uint32_t *) REG_SEC1_SSTAT15)                /*  Source Status Register n */
#define pREG_SEC1_SCTL16                 ((volatile  uint32_t *) REG_SEC1_SCTL16)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT16                ((volatile  uint32_t *) REG_SEC1_SSTAT16)                /*  Source Status Register n */
#define pREG_SEC1_SCTL17                 ((volatile  uint32_t *) REG_SEC1_SCTL17)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT17                ((volatile  uint32_t *) REG_SEC1_SSTAT17)                /*  Source Status Register n */
#define pREG_SEC1_SCTL18                 ((volatile  uint32_t *) REG_SEC1_SCTL18)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT18                ((volatile  uint32_t *) REG_SEC1_SSTAT18)                /*  Source Status Register n */
#define pREG_SEC1_SCTL19                 ((volatile  uint32_t *) REG_SEC1_SCTL19)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT19                ((volatile  uint32_t *) REG_SEC1_SSTAT19)                /*  Source Status Register n */
#define pREG_SEC1_SCTL20                 ((volatile  uint32_t *) REG_SEC1_SCTL20)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT20                ((volatile  uint32_t *) REG_SEC1_SSTAT20)                /*  Source Status Register n */
#define pREG_SEC1_SCTL21                 ((volatile  uint32_t *) REG_SEC1_SCTL21)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT21                ((volatile  uint32_t *) REG_SEC1_SSTAT21)                /*  Source Status Register n */
#define pREG_SEC1_SCTL22                 ((volatile  uint32_t *) REG_SEC1_SCTL22)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT22                ((volatile  uint32_t *) REG_SEC1_SSTAT22)                /*  Source Status Register n */
#define pREG_SEC1_SCTL23                 ((volatile  uint32_t *) REG_SEC1_SCTL23)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT23                ((volatile  uint32_t *) REG_SEC1_SSTAT23)                /*  Source Status Register n */
#define pREG_SEC1_SCTL24                 ((volatile  uint32_t *) REG_SEC1_SCTL24)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT24                ((volatile  uint32_t *) REG_SEC1_SSTAT24)                /*  Source Status Register n */
#define pREG_SEC1_SCTL25                 ((volatile  uint32_t *) REG_SEC1_SCTL25)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT25                ((volatile  uint32_t *) REG_SEC1_SSTAT25)                /*  Source Status Register n */
#define pREG_SEC1_SCTL26                 ((volatile  uint32_t *) REG_SEC1_SCTL26)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT26                ((volatile  uint32_t *) REG_SEC1_SSTAT26)                /*  Source Status Register n */
#define pREG_SEC1_SCTL27                 ((volatile  uint32_t *) REG_SEC1_SCTL27)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT27                ((volatile  uint32_t *) REG_SEC1_SSTAT27)                /*  Source Status Register n */
#define pREG_SEC1_SCTL28                 ((volatile  uint32_t *) REG_SEC1_SCTL28)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT28                ((volatile  uint32_t *) REG_SEC1_SSTAT28)                /*  Source Status Register n */
#define pREG_SEC1_SCTL29                 ((volatile  uint32_t *) REG_SEC1_SCTL29)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT29                ((volatile  uint32_t *) REG_SEC1_SSTAT29)                /*  Source Status Register n */
#define pREG_SEC1_SCTL30                 ((volatile  uint32_t *) REG_SEC1_SCTL30)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT30                ((volatile  uint32_t *) REG_SEC1_SSTAT30)                /*  Source Status Register n */
#define pREG_SEC1_SCTL31                 ((volatile  uint32_t *) REG_SEC1_SCTL31)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT31                ((volatile  uint32_t *) REG_SEC1_SSTAT31)                /*  Source Status Register n */
#define pREG_SEC1_SCTL32                 ((volatile  uint32_t *) REG_SEC1_SCTL32)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT32                ((volatile  uint32_t *) REG_SEC1_SSTAT32)                /*  Source Status Register n */
#define pREG_SEC1_SCTL33                 ((volatile  uint32_t *) REG_SEC1_SCTL33)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT33                ((volatile  uint32_t *) REG_SEC1_SSTAT33)                /*  Source Status Register n */
#define pREG_SEC1_SCTL34                 ((volatile  uint32_t *) REG_SEC1_SCTL34)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT34                ((volatile  uint32_t *) REG_SEC1_SSTAT34)                /*  Source Status Register n */
#define pREG_SEC1_SCTL35                 ((volatile  uint32_t *) REG_SEC1_SCTL35)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT35                ((volatile  uint32_t *) REG_SEC1_SSTAT35)                /*  Source Status Register n */
#define pREG_SEC1_SCTL36                 ((volatile  uint32_t *) REG_SEC1_SCTL36)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT36                ((volatile  uint32_t *) REG_SEC1_SSTAT36)                /*  Source Status Register n */
#define pREG_SEC1_SCTL37                 ((volatile  uint32_t *) REG_SEC1_SCTL37)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT37                ((volatile  uint32_t *) REG_SEC1_SSTAT37)                /*  Source Status Register n */
#define pREG_SEC1_SCTL38                 ((volatile  uint32_t *) REG_SEC1_SCTL38)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT38                ((volatile  uint32_t *) REG_SEC1_SSTAT38)                /*  Source Status Register n */
#define pREG_SEC1_SCTL39                 ((volatile  uint32_t *) REG_SEC1_SCTL39)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT39                ((volatile  uint32_t *) REG_SEC1_SSTAT39)                /*  Source Status Register n */
#define pREG_SEC1_SCTL40                 ((volatile  uint32_t *) REG_SEC1_SCTL40)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT40                ((volatile  uint32_t *) REG_SEC1_SSTAT40)                /*  Source Status Register n */
#define pREG_SEC1_SCTL41                 ((volatile  uint32_t *) REG_SEC1_SCTL41)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT41                ((volatile  uint32_t *) REG_SEC1_SSTAT41)                /*  Source Status Register n */
#define pREG_SEC1_SCTL42                 ((volatile  uint32_t *) REG_SEC1_SCTL42)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT42                ((volatile  uint32_t *) REG_SEC1_SSTAT42)                /*  Source Status Register n */
#define pREG_SEC1_SCTL43                 ((volatile  uint32_t *) REG_SEC1_SCTL43)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT43                ((volatile  uint32_t *) REG_SEC1_SSTAT43)                /*  Source Status Register n */
#define pREG_SEC1_SCTL44                 ((volatile  uint32_t *) REG_SEC1_SCTL44)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT44                ((volatile  uint32_t *) REG_SEC1_SSTAT44)                /*  Source Status Register n */
#define pREG_SEC1_SCTL45                 ((volatile  uint32_t *) REG_SEC1_SCTL45)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT45                ((volatile  uint32_t *) REG_SEC1_SSTAT45)                /*  Source Status Register n */
#define pREG_SEC1_SCTL46                 ((volatile  uint32_t *) REG_SEC1_SCTL46)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT46                ((volatile  uint32_t *) REG_SEC1_SSTAT46)                /*  Source Status Register n */
#define pREG_SEC1_SCTL47                 ((volatile  uint32_t *) REG_SEC1_SCTL47)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT47                ((volatile  uint32_t *) REG_SEC1_SSTAT47)                /*  Source Status Register n */
#define pREG_SEC1_SCTL48                 ((volatile  uint32_t *) REG_SEC1_SCTL48)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT48                ((volatile  uint32_t *) REG_SEC1_SSTAT48)                /*  Source Status Register n */
#define pREG_SEC1_SCTL49                 ((volatile  uint32_t *) REG_SEC1_SCTL49)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT49                ((volatile  uint32_t *) REG_SEC1_SSTAT49)                /*  Source Status Register n */
#define pREG_SEC1_SCTL50                 ((volatile  uint32_t *) REG_SEC1_SCTL50)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT50                ((volatile  uint32_t *) REG_SEC1_SSTAT50)                /*  Source Status Register n */
#define pREG_SEC1_SCTL51                 ((volatile  uint32_t *) REG_SEC1_SCTL51)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT51                ((volatile  uint32_t *) REG_SEC1_SSTAT51)                /*  Source Status Register n */
#define pREG_SEC1_SCTL52                 ((volatile  uint32_t *) REG_SEC1_SCTL52)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT52                ((volatile  uint32_t *) REG_SEC1_SSTAT52)                /*  Source Status Register n */
#define pREG_SEC1_SCTL53                 ((volatile  uint32_t *) REG_SEC1_SCTL53)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT53                ((volatile  uint32_t *) REG_SEC1_SSTAT53)                /*  Source Status Register n */
#define pREG_SEC1_SCTL54                 ((volatile  uint32_t *) REG_SEC1_SCTL54)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT54                ((volatile  uint32_t *) REG_SEC1_SSTAT54)                /*  Source Status Register n */
#define pREG_SEC1_SCTL55                 ((volatile  uint32_t *) REG_SEC1_SCTL55)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT55                ((volatile  uint32_t *) REG_SEC1_SSTAT55)                /*  Source Status Register n */
#define pREG_SEC1_SCTL56                 ((volatile  uint32_t *) REG_SEC1_SCTL56)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT56                ((volatile  uint32_t *) REG_SEC1_SSTAT56)                /*  Source Status Register n */
#define pREG_SEC1_SCTL57                 ((volatile  uint32_t *) REG_SEC1_SCTL57)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT57                ((volatile  uint32_t *) REG_SEC1_SSTAT57)                /*  Source Status Register n */
#define pREG_SEC1_SCTL58                 ((volatile  uint32_t *) REG_SEC1_SCTL58)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT58                ((volatile  uint32_t *) REG_SEC1_SSTAT58)                /*  Source Status Register n */
#define pREG_SEC1_SCTL59                 ((volatile  uint32_t *) REG_SEC1_SCTL59)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT59                ((volatile  uint32_t *) REG_SEC1_SSTAT59)                /*  Source Status Register n */
#define pREG_SEC1_SCTL60                 ((volatile  uint32_t *) REG_SEC1_SCTL60)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT60                ((volatile  uint32_t *) REG_SEC1_SSTAT60)                /*  Source Status Register n */
#define pREG_SEC1_SCTL61                 ((volatile  uint32_t *) REG_SEC1_SCTL61)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT61                ((volatile  uint32_t *) REG_SEC1_SSTAT61)                /*  Source Status Register n */
#define pREG_SEC1_SCTL62                 ((volatile  uint32_t *) REG_SEC1_SCTL62)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT62                ((volatile  uint32_t *) REG_SEC1_SSTAT62)                /*  Source Status Register n */
#define pREG_SEC1_SCTL63                 ((volatile  uint32_t *) REG_SEC1_SCTL63)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT63                ((volatile  uint32_t *) REG_SEC1_SSTAT63)                /*  Source Status Register n */
#define pREG_SEC1_SCTL64                 ((volatile  uint32_t *) REG_SEC1_SCTL64)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT64                ((volatile  uint32_t *) REG_SEC1_SSTAT64)                /*  Source Status Register n */
#define pREG_SEC1_SCTL65                 ((volatile  uint32_t *) REG_SEC1_SCTL65)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT65                ((volatile  uint32_t *) REG_SEC1_SSTAT65)                /*  Source Status Register n */
#define pREG_SEC1_SCTL66                 ((volatile  uint32_t *) REG_SEC1_SCTL66)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT66                ((volatile  uint32_t *) REG_SEC1_SSTAT66)                /*  Source Status Register n */
#define pREG_SEC1_SCTL67                 ((volatile  uint32_t *) REG_SEC1_SCTL67)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT67                ((volatile  uint32_t *) REG_SEC1_SSTAT67)                /*  Source Status Register n */
#define pREG_SEC1_SCTL68                 ((volatile  uint32_t *) REG_SEC1_SCTL68)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT68                ((volatile  uint32_t *) REG_SEC1_SSTAT68)                /*  Source Status Register n */
#define pREG_SEC1_SCTL69                 ((volatile  uint32_t *) REG_SEC1_SCTL69)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT69                ((volatile  uint32_t *) REG_SEC1_SSTAT69)                /*  Source Status Register n */
#define pREG_SEC1_SCTL70                 ((volatile  uint32_t *) REG_SEC1_SCTL70)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT70                ((volatile  uint32_t *) REG_SEC1_SSTAT70)                /*  Source Status Register n */
#define pREG_SEC1_SCTL71                 ((volatile  uint32_t *) REG_SEC1_SCTL71)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT71                ((volatile  uint32_t *) REG_SEC1_SSTAT71)                /*  Source Status Register n */
#define pREG_SEC1_SCTL72                 ((volatile  uint32_t *) REG_SEC1_SCTL72)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT72                ((volatile  uint32_t *) REG_SEC1_SSTAT72)                /*  Source Status Register n */
#define pREG_SEC1_SCTL73                 ((volatile  uint32_t *) REG_SEC1_SCTL73)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT73                ((volatile  uint32_t *) REG_SEC1_SSTAT73)                /*  Source Status Register n */
#define pREG_SEC1_SCTL74                 ((volatile  uint32_t *) REG_SEC1_SCTL74)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT74                ((volatile  uint32_t *) REG_SEC1_SSTAT74)                /*  Source Status Register n */
#define pREG_SEC1_SCTL75                 ((volatile  uint32_t *) REG_SEC1_SCTL75)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT75                ((volatile  uint32_t *) REG_SEC1_SSTAT75)                /*  Source Status Register n */
#define pREG_SEC1_SCTL76                 ((volatile  uint32_t *) REG_SEC1_SCTL76)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT76                ((volatile  uint32_t *) REG_SEC1_SSTAT76)                /*  Source Status Register n */
#define pREG_SEC1_SCTL77                 ((volatile  uint32_t *) REG_SEC1_SCTL77)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT77                ((volatile  uint32_t *) REG_SEC1_SSTAT77)                /*  Source Status Register n */
#define pREG_SEC1_SCTL78                 ((volatile  uint32_t *) REG_SEC1_SCTL78)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT78                ((volatile  uint32_t *) REG_SEC1_SSTAT78)                /*  Source Status Register n */
#define pREG_SEC1_SCTL79                 ((volatile  uint32_t *) REG_SEC1_SCTL79)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT79                ((volatile  uint32_t *) REG_SEC1_SSTAT79)                /*  Source Status Register n */
#define pREG_SEC1_SCTL80                 ((volatile  uint32_t *) REG_SEC1_SCTL80)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT80                ((volatile  uint32_t *) REG_SEC1_SSTAT80)                /*  Source Status Register n */
#define pREG_SEC1_SCTL81                 ((volatile  uint32_t *) REG_SEC1_SCTL81)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT81                ((volatile  uint32_t *) REG_SEC1_SSTAT81)                /*  Source Status Register n */
#define pREG_SEC1_SCTL82                 ((volatile  uint32_t *) REG_SEC1_SCTL82)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT82                ((volatile  uint32_t *) REG_SEC1_SSTAT82)                /*  Source Status Register n */
#define pREG_SEC1_SCTL83                 ((volatile  uint32_t *) REG_SEC1_SCTL83)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT83                ((volatile  uint32_t *) REG_SEC1_SSTAT83)                /*  Source Status Register n */
#define pREG_SEC1_SCTL84                 ((volatile  uint32_t *) REG_SEC1_SCTL84)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT84                ((volatile  uint32_t *) REG_SEC1_SSTAT84)                /*  Source Status Register n */
#define pREG_SEC1_SCTL85                 ((volatile  uint32_t *) REG_SEC1_SCTL85)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT85                ((volatile  uint32_t *) REG_SEC1_SSTAT85)                /*  Source Status Register n */
#define pREG_SEC1_SCTL86                 ((volatile  uint32_t *) REG_SEC1_SCTL86)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT86                ((volatile  uint32_t *) REG_SEC1_SSTAT86)                /*  Source Status Register n */
#define pREG_SEC1_SCTL87                 ((volatile  uint32_t *) REG_SEC1_SCTL87)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT87                ((volatile  uint32_t *) REG_SEC1_SSTAT87)                /*  Source Status Register n */
#define pREG_SEC1_SCTL88                 ((volatile  uint32_t *) REG_SEC1_SCTL88)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT88                ((volatile  uint32_t *) REG_SEC1_SSTAT88)                /*  Source Status Register n */
#define pREG_SEC1_SCTL89                 ((volatile  uint32_t *) REG_SEC1_SCTL89)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT89                ((volatile  uint32_t *) REG_SEC1_SSTAT89)                /*  Source Status Register n */
#define pREG_SEC1_SCTL90                 ((volatile  uint32_t *) REG_SEC1_SCTL90)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT90                ((volatile  uint32_t *) REG_SEC1_SSTAT90)                /*  Source Status Register n */
#define pREG_SEC1_SCTL91                 ((volatile  uint32_t *) REG_SEC1_SCTL91)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT91                ((volatile  uint32_t *) REG_SEC1_SSTAT91)                /*  Source Status Register n */
#define pREG_SEC1_SCTL92                 ((volatile  uint32_t *) REG_SEC1_SCTL92)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT92                ((volatile  uint32_t *) REG_SEC1_SSTAT92)                /*  Source Status Register n */
#define pREG_SEC1_SCTL93                 ((volatile  uint32_t *) REG_SEC1_SCTL93)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT93                ((volatile  uint32_t *) REG_SEC1_SSTAT93)                /*  Source Status Register n */
#define pREG_SEC1_SCTL94                 ((volatile  uint32_t *) REG_SEC1_SCTL94)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT94                ((volatile  uint32_t *) REG_SEC1_SSTAT94)                /*  Source Status Register n */
#define pREG_SEC1_SCTL95                 ((volatile  uint32_t *) REG_SEC1_SCTL95)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT95                ((volatile  uint32_t *) REG_SEC1_SSTAT95)                /*  Source Status Register n */
#define pREG_SEC1_SCTL96                 ((volatile  uint32_t *) REG_SEC1_SCTL96)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT96                ((volatile  uint32_t *) REG_SEC1_SSTAT96)                /*  Source Status Register n */
#define pREG_SEC1_SCTL97                 ((volatile  uint32_t *) REG_SEC1_SCTL97)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT97                ((volatile  uint32_t *) REG_SEC1_SSTAT97)                /*  Source Status Register n */
#define pREG_SEC1_SCTL98                 ((volatile  uint32_t *) REG_SEC1_SCTL98)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT98                ((volatile  uint32_t *) REG_SEC1_SSTAT98)                /*  Source Status Register n */
#define pREG_SEC1_SCTL99                 ((volatile  uint32_t *) REG_SEC1_SCTL99)                 /*  Source Control Register n */
#define pREG_SEC1_SSTAT99                ((volatile  uint32_t *) REG_SEC1_SSTAT99)                /*  Source Status Register n */
#define pREG_SEC1_SCTL100                ((volatile  uint32_t *) REG_SEC1_SCTL100)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT100               ((volatile  uint32_t *) REG_SEC1_SSTAT100)               /*  Source Status Register n */
#define pREG_SEC1_SCTL101                ((volatile  uint32_t *) REG_SEC1_SCTL101)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT101               ((volatile  uint32_t *) REG_SEC1_SSTAT101)               /*  Source Status Register n */
#define pREG_SEC1_SCTL102                ((volatile  uint32_t *) REG_SEC1_SCTL102)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT102               ((volatile  uint32_t *) REG_SEC1_SSTAT102)               /*  Source Status Register n */
#define pREG_SEC1_SCTL103                ((volatile  uint32_t *) REG_SEC1_SCTL103)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT103               ((volatile  uint32_t *) REG_SEC1_SSTAT103)               /*  Source Status Register n */
#define pREG_SEC1_SCTL104                ((volatile  uint32_t *) REG_SEC1_SCTL104)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT104               ((volatile  uint32_t *) REG_SEC1_SSTAT104)               /*  Source Status Register n */
#define pREG_SEC1_SCTL105                ((volatile  uint32_t *) REG_SEC1_SCTL105)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT105               ((volatile  uint32_t *) REG_SEC1_SSTAT105)               /*  Source Status Register n */
#define pREG_SEC1_SCTL106                ((volatile  uint32_t *) REG_SEC1_SCTL106)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT106               ((volatile  uint32_t *) REG_SEC1_SSTAT106)               /*  Source Status Register n */
#define pREG_SEC1_SCTL107                ((volatile  uint32_t *) REG_SEC1_SCTL107)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT107               ((volatile  uint32_t *) REG_SEC1_SSTAT107)               /*  Source Status Register n */
#define pREG_SEC1_SCTL108                ((volatile  uint32_t *) REG_SEC1_SCTL108)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT108               ((volatile  uint32_t *) REG_SEC1_SSTAT108)               /*  Source Status Register n */
#define pREG_SEC1_SCTL109                ((volatile  uint32_t *) REG_SEC1_SCTL109)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT109               ((volatile  uint32_t *) REG_SEC1_SSTAT109)               /*  Source Status Register n */
#define pREG_SEC1_SCTL110                ((volatile  uint32_t *) REG_SEC1_SCTL110)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT110               ((volatile  uint32_t *) REG_SEC1_SSTAT110)               /*  Source Status Register n */
#define pREG_SEC1_SCTL111                ((volatile  uint32_t *) REG_SEC1_SCTL111)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT111               ((volatile  uint32_t *) REG_SEC1_SSTAT111)               /*  Source Status Register n */
#define pREG_SEC1_SCTL112                ((volatile  uint32_t *) REG_SEC1_SCTL112)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT112               ((volatile  uint32_t *) REG_SEC1_SSTAT112)               /*  Source Status Register n */
#define pREG_SEC1_SCTL113                ((volatile  uint32_t *) REG_SEC1_SCTL113)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT113               ((volatile  uint32_t *) REG_SEC1_SSTAT113)               /*  Source Status Register n */
#define pREG_SEC1_SCTL114                ((volatile  uint32_t *) REG_SEC1_SCTL114)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT114               ((volatile  uint32_t *) REG_SEC1_SSTAT114)               /*  Source Status Register n */
#define pREG_SEC1_SCTL115                ((volatile  uint32_t *) REG_SEC1_SCTL115)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT115               ((volatile  uint32_t *) REG_SEC1_SSTAT115)               /*  Source Status Register n */
#define pREG_SEC1_SCTL116                ((volatile  uint32_t *) REG_SEC1_SCTL116)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT116               ((volatile  uint32_t *) REG_SEC1_SSTAT116)               /*  Source Status Register n */
#define pREG_SEC1_SCTL117                ((volatile  uint32_t *) REG_SEC1_SCTL117)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT117               ((volatile  uint32_t *) REG_SEC1_SSTAT117)               /*  Source Status Register n */
#define pREG_SEC1_SCTL118                ((volatile  uint32_t *) REG_SEC1_SCTL118)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT118               ((volatile  uint32_t *) REG_SEC1_SSTAT118)               /*  Source Status Register n */
#define pREG_SEC1_SCTL119                ((volatile  uint32_t *) REG_SEC1_SCTL119)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT119               ((volatile  uint32_t *) REG_SEC1_SSTAT119)               /*  Source Status Register n */
#define pREG_SEC1_SCTL120                ((volatile  uint32_t *) REG_SEC1_SCTL120)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT120               ((volatile  uint32_t *) REG_SEC1_SSTAT120)               /*  Source Status Register n */
#define pREG_SEC1_SCTL121                ((volatile  uint32_t *) REG_SEC1_SCTL121)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT121               ((volatile  uint32_t *) REG_SEC1_SSTAT121)               /*  Source Status Register n */
#define pREG_SEC1_SCTL122                ((volatile  uint32_t *) REG_SEC1_SCTL122)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT122               ((volatile  uint32_t *) REG_SEC1_SSTAT122)               /*  Source Status Register n */
#define pREG_SEC1_SCTL123                ((volatile  uint32_t *) REG_SEC1_SCTL123)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT123               ((volatile  uint32_t *) REG_SEC1_SSTAT123)               /*  Source Status Register n */
#define pREG_SEC1_SCTL124                ((volatile  uint32_t *) REG_SEC1_SCTL124)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT124               ((volatile  uint32_t *) REG_SEC1_SSTAT124)               /*  Source Status Register n */
#define pREG_SEC1_SCTL125                ((volatile  uint32_t *) REG_SEC1_SCTL125)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT125               ((volatile  uint32_t *) REG_SEC1_SSTAT125)               /*  Source Status Register n */
#define pREG_SEC1_SCTL126                ((volatile  uint32_t *) REG_SEC1_SCTL126)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT126               ((volatile  uint32_t *) REG_SEC1_SSTAT126)               /*  Source Status Register n */
#define pREG_SEC1_SCTL127                ((volatile  uint32_t *) REG_SEC1_SCTL127)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT127               ((volatile  uint32_t *) REG_SEC1_SSTAT127)               /*  Source Status Register n */
#define pREG_SEC1_SCTL128                ((volatile  uint32_t *) REG_SEC1_SCTL128)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT128               ((volatile  uint32_t *) REG_SEC1_SSTAT128)               /*  Source Status Register n */
#define pREG_SEC1_SCTL129                ((volatile  uint32_t *) REG_SEC1_SCTL129)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT129               ((volatile  uint32_t *) REG_SEC1_SSTAT129)               /*  Source Status Register n */
#define pREG_SEC1_SCTL130                ((volatile  uint32_t *) REG_SEC1_SCTL130)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT130               ((volatile  uint32_t *) REG_SEC1_SSTAT130)               /*  Source Status Register n */
#define pREG_SEC1_SCTL131                ((volatile  uint32_t *) REG_SEC1_SCTL131)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT131               ((volatile  uint32_t *) REG_SEC1_SSTAT131)               /*  Source Status Register n */
#define pREG_SEC1_SCTL132                ((volatile  uint32_t *) REG_SEC1_SCTL132)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT132               ((volatile  uint32_t *) REG_SEC1_SSTAT132)               /*  Source Status Register n */
#define pREG_SEC1_SCTL133                ((volatile  uint32_t *) REG_SEC1_SCTL133)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT133               ((volatile  uint32_t *) REG_SEC1_SSTAT133)               /*  Source Status Register n */
#define pREG_SEC1_SCTL134                ((volatile  uint32_t *) REG_SEC1_SCTL134)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT134               ((volatile  uint32_t *) REG_SEC1_SSTAT134)               /*  Source Status Register n */
#define pREG_SEC1_SCTL135                ((volatile  uint32_t *) REG_SEC1_SCTL135)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT135               ((volatile  uint32_t *) REG_SEC1_SSTAT135)               /*  Source Status Register n */
#define pREG_SEC1_SCTL136                ((volatile  uint32_t *) REG_SEC1_SCTL136)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT136               ((volatile  uint32_t *) REG_SEC1_SSTAT136)               /*  Source Status Register n */
#define pREG_SEC1_SCTL137                ((volatile  uint32_t *) REG_SEC1_SCTL137)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT137               ((volatile  uint32_t *) REG_SEC1_SSTAT137)               /*  Source Status Register n */
#define pREG_SEC1_SCTL138                ((volatile  uint32_t *) REG_SEC1_SCTL138)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT138               ((volatile  uint32_t *) REG_SEC1_SSTAT138)               /*  Source Status Register n */
#define pREG_SEC1_SCTL139                ((volatile  uint32_t *) REG_SEC1_SCTL139)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT139               ((volatile  uint32_t *) REG_SEC1_SSTAT139)               /*  Source Status Register n */
#define pREG_SEC1_SCTL140                ((volatile  uint32_t *) REG_SEC1_SCTL140)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT140               ((volatile  uint32_t *) REG_SEC1_SSTAT140)               /*  Source Status Register n */
#define pREG_SEC1_SCTL141                ((volatile  uint32_t *) REG_SEC1_SCTL141)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT141               ((volatile  uint32_t *) REG_SEC1_SSTAT141)               /*  Source Status Register n */
#define pREG_SEC1_SCTL142                ((volatile  uint32_t *) REG_SEC1_SCTL142)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT142               ((volatile  uint32_t *) REG_SEC1_SSTAT142)               /*  Source Status Register n */
#define pREG_SEC1_SCTL143                ((volatile  uint32_t *) REG_SEC1_SCTL143)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT143               ((volatile  uint32_t *) REG_SEC1_SSTAT143)               /*  Source Status Register n */
#define pREG_SEC1_SCTL144                ((volatile  uint32_t *) REG_SEC1_SCTL144)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT144               ((volatile  uint32_t *) REG_SEC1_SSTAT144)               /*  Source Status Register n */
#define pREG_SEC1_SCTL145                ((volatile  uint32_t *) REG_SEC1_SCTL145)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT145               ((volatile  uint32_t *) REG_SEC1_SSTAT145)               /*  Source Status Register n */
#define pREG_SEC1_SCTL146                ((volatile  uint32_t *) REG_SEC1_SCTL146)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT146               ((volatile  uint32_t *) REG_SEC1_SSTAT146)               /*  Source Status Register n */
#define pREG_SEC1_SCTL147                ((volatile  uint32_t *) REG_SEC1_SCTL147)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT147               ((volatile  uint32_t *) REG_SEC1_SSTAT147)               /*  Source Status Register n */
#define pREG_SEC1_SCTL148                ((volatile  uint32_t *) REG_SEC1_SCTL148)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT148               ((volatile  uint32_t *) REG_SEC1_SSTAT148)               /*  Source Status Register n */
#define pREG_SEC1_SCTL149                ((volatile  uint32_t *) REG_SEC1_SCTL149)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT149               ((volatile  uint32_t *) REG_SEC1_SSTAT149)               /*  Source Status Register n */
#define pREG_SEC1_SCTL150                ((volatile  uint32_t *) REG_SEC1_SCTL150)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT150               ((volatile  uint32_t *) REG_SEC1_SSTAT150)               /*  Source Status Register n */
#define pREG_SEC1_SCTL151                ((volatile  uint32_t *) REG_SEC1_SCTL151)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT151               ((volatile  uint32_t *) REG_SEC1_SSTAT151)               /*  Source Status Register n */
#define pREG_SEC1_SCTL152                ((volatile  uint32_t *) REG_SEC1_SCTL152)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT152               ((volatile  uint32_t *) REG_SEC1_SSTAT152)               /*  Source Status Register n */
#define pREG_SEC1_SCTL153                ((volatile  uint32_t *) REG_SEC1_SCTL153)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT153               ((volatile  uint32_t *) REG_SEC1_SSTAT153)               /*  Source Status Register n */
#define pREG_SEC1_SCTL154                ((volatile  uint32_t *) REG_SEC1_SCTL154)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT154               ((volatile  uint32_t *) REG_SEC1_SSTAT154)               /*  Source Status Register n */
#define pREG_SEC1_SCTL155                ((volatile  uint32_t *) REG_SEC1_SCTL155)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT155               ((volatile  uint32_t *) REG_SEC1_SSTAT155)               /*  Source Status Register n */
#define pREG_SEC1_SCTL156                ((volatile  uint32_t *) REG_SEC1_SCTL156)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT156               ((volatile  uint32_t *) REG_SEC1_SSTAT156)               /*  Source Status Register n */
#define pREG_SEC1_SCTL157                ((volatile  uint32_t *) REG_SEC1_SCTL157)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT157               ((volatile  uint32_t *) REG_SEC1_SSTAT157)               /*  Source Status Register n */
#define pREG_SEC1_SCTL158                ((volatile  uint32_t *) REG_SEC1_SCTL158)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT158               ((volatile  uint32_t *) REG_SEC1_SSTAT158)               /*  Source Status Register n */
#define pREG_SEC1_SCTL159                ((volatile  uint32_t *) REG_SEC1_SCTL159)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT159               ((volatile  uint32_t *) REG_SEC1_SSTAT159)               /*  Source Status Register n */
#define pREG_SEC1_SCTL160                ((volatile  uint32_t *) REG_SEC1_SCTL160)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT160               ((volatile  uint32_t *) REG_SEC1_SSTAT160)               /*  Source Status Register n */
#define pREG_SEC1_SCTL161                ((volatile  uint32_t *) REG_SEC1_SCTL161)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT161               ((volatile  uint32_t *) REG_SEC1_SSTAT161)               /*  Source Status Register n */
#define pREG_SEC1_SCTL162                ((volatile  uint32_t *) REG_SEC1_SCTL162)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT162               ((volatile  uint32_t *) REG_SEC1_SSTAT162)               /*  Source Status Register n */
#define pREG_SEC1_SCTL163                ((volatile  uint32_t *) REG_SEC1_SCTL163)                /*  Source Control Register n */
#define pREG_SEC1_SSTAT163               ((volatile  uint32_t *) REG_SEC1_SSTAT163)               /*  Source Status Register n */

/*  =================================================================================
 *      Watch Dog Timer Unit (WDOG0)
 *  ================================================================================= */
#define pREG_WDOG0_CTL                   ((volatile  uint32_t *) REG_WDOG0_CTL)                   /*  Control Register */
#define pREG_WDOG0_CNT                   ((volatile  uint32_t *) REG_WDOG0_CNT)                   /*  Count Register */
#define pREG_WDOG0_STAT                  ((volatile  uint32_t *) REG_WDOG0_STAT)                  /*  Watchdog Timer Status Register */

/*  =================================================================================
 *      Watch Dog Timer Unit (WDOG1)
 *  ================================================================================= */
#define pREG_WDOG1_CTL                   ((volatile  uint32_t *) REG_WDOG1_CTL)                   /*  Control Register */
#define pREG_WDOG1_CNT                   ((volatile  uint32_t *) REG_WDOG1_CNT)                   /*  Count Register */
#define pREG_WDOG1_STAT                  ((volatile  uint32_t *) REG_WDOG1_STAT)                  /*  Watchdog Timer Status Register */

/*  =================================================================================
 *      Reset Control Unit (RCU0)
 *  ================================================================================= */
#define pREG_RCU0_CTL                    ((volatile  uint32_t *) REG_RCU0_CTL)                    /*  Control Register */
#define pREG_RCU0_STAT                   ((volatile  uint32_t *) REG_RCU0_STAT)                   /*  Status Register */
#define pREG_RCU0_CRCTL                  ((volatile  uint32_t *) REG_RCU0_CRCTL)                  /*  Core Reset outputs Control Register */
#define pREG_RCU0_CRSTAT                 ((volatile  uint32_t *) REG_RCU0_CRSTAT)                 /*  Core Reset outputs Status Register */
#define pREG_RCU0_SRRQSTAT               ((volatile  uint32_t *) REG_RCU0_SRRQSTAT)               /*  System Reset Request Status */
#define pREG_RCU0_SVECT_LCK              ((volatile  uint32_t *) REG_RCU0_SVECT_LCK)              /*  SVECT Lock Register */
#define pREG_RCU0_BCODE                  ((volatile  uint32_t *) REG_RCU0_BCODE)                  /*  Boot Code Register */
#define pREG_RCU0_SVECT0                 ((volatile  uint32_t *) REG_RCU0_SVECT0)                 /*  Software Vector Register 0 */
#define pREG_RCU0_SVECT1                 ((volatile  uint32_t *) REG_RCU0_SVECT1)                 /*  Software Vector Register 1 */
#define pREG_RCU0_MSG                    ((volatile  uint32_t *) REG_RCU0_MSG)                    /*  Message Register */
#define pREG_RCU0_MSG_SET                ((volatile  uint32_t *) REG_RCU0_MSG_SET)                /*  Message Set Bits Register */
#define pREG_RCU0_MSG_CLR                ((volatile  uint32_t *) REG_RCU0_MSG_CLR)                /*  Message Clear Bits Register */
#define pREG_RCU0_REVID                  ((volatile  uint32_t *) REG_RCU0_REVID)                  /*  Revision ID Register */

/*  =================================================================================
 *      Dynamic Power Management (DPM0)
 *  ================================================================================= */
#define pREG_DPM0_CTL                    ((volatile  uint32_t *) REG_DPM0_CTL)                    /*  Control Register */
#define pREG_DPM0_STAT                   ((volatile  uint32_t *) REG_DPM0_STAT)                   /*  Status Register */
#define pREG_DPM0_WAKE_EN                ((volatile  uint32_t *) REG_DPM0_WAKE_EN)                /*  Wakeup Enable Register */
#define pREG_DPM0_WAKE_POL               ((volatile  uint32_t *) REG_DPM0_WAKE_POL)               /*  Wakeup Polarity Register */
#define pREG_DPM0_WAKE_STAT              ((volatile  uint32_t *) REG_DPM0_WAKE_STAT)              /*  Wakeup Status Register */
#define pREG_DPM0_PER_DIS0               ((volatile  uint32_t *) REG_DPM0_PER_DIS0)               /*  Peripherals Disable Register 0 */
#define pREG_DPM0_REVID                  ((volatile  uint32_t *) REG_DPM0_REVID)                  /*  Revision ID */

/*  =================================================================================
 *      Clock Generation Unit (CGU0)
 *  ================================================================================= */
#define pREG_CGU0_CTL                    ((volatile  uint32_t *) REG_CGU0_CTL)                    /*  Control Register */
#define pREG_CGU0_PLLCTL                 ((volatile  uint32_t *) REG_CGU0_PLLCTL)                 /*  PLL Control Register */
#define pREG_CGU0_STAT                   ((volatile  uint32_t *) REG_CGU0_STAT)                   /*  Status Register */
#define pREG_CGU0_DIV                    ((volatile  uint32_t *) REG_CGU0_DIV)                    /*  Clocks Divisor Register */
#define pREG_CGU0_CLKOUTSEL              ((volatile  uint32_t *) REG_CGU0_CLKOUTSEL)              /*  CLKOUT Select Register */
#define pREG_CGU0_OSCWDCTL               ((volatile  uint32_t *) REG_CGU0_OSCWDCTL)               /*  Oscillator Watchdog Register */
#define pREG_CGU0_TSCTL                  ((volatile  uint32_t *) REG_CGU0_TSCTL)                  /*  Timestamp Control Register */
#define pREG_CGU0_TSVALUE0               ((volatile  uint32_t *) REG_CGU0_TSVALUE0)               /*  Timestamp Counter Initial 32 LSB Value Register */
#define pREG_CGU0_TSVALUE1               ((volatile  uint32_t *) REG_CGU0_TSVALUE1)               /*  Timestamp Counter Initial MSB Value Register */
#define pREG_CGU0_TSCOUNT0               ((volatile  uint32_t *) REG_CGU0_TSCOUNT0)               /*  Time Stamp Counter 32 LSB Register */
#define pREG_CGU0_TSCOUNT1               ((volatile  uint32_t *) REG_CGU0_TSCOUNT1)               /*  Time Stamp Counter 32 MSB Register */
#define pREG_CGU0_CCBF_DIS               ((volatile  uint32_t *) REG_CGU0_CCBF_DIS)               /*  Core Clock Buffer Disable Register */
#define pREG_CGU0_CCBF_STAT              ((volatile  uint32_t *) REG_CGU0_CCBF_STAT)              /*  Core Clock Buffer Status Register */
#define pREG_CGU0_SCBF_DIS               ((volatile  uint32_t *) REG_CGU0_SCBF_DIS)               /*  System Clock Buffer Disable Register */
#define pREG_CGU0_SCBF_STAT              ((volatile  uint32_t *) REG_CGU0_SCBF_STAT)              /*  System Clock Buffer Status Register */
#define pREG_CGU0_REVID                  ((volatile  uint32_t *) REG_CGU0_REVID)                  /*  Revision ID Register */

/*  =================================================================================
 *      Oscillator Counter Unit (OCU0)
 *  ================================================================================= */
#define pREG_OCU0_CTL                    ((volatile  uint32_t *) REG_OCU0_CTL)                    /*  Control register */
#define pREG_OCU0_STAT                   ((volatile  uint32_t *) REG_OCU0_STAT)                   /*  Status register */
#define pREG_OCU0_CLKCNT                 ((volatile  uint32_t *) REG_OCU0_CLKCNT)                 /*  Freq. measured count register */
#define pREG_OCU0_REFCNT                 ((volatile  uint32_t *) REG_OCU0_REFCNT)                 /*  Freq measurement reference count register */
#define pREG_OCU0_MINCNT                 ((volatile  uint32_t *) REG_OCU0_MINCNT)                 /*  Min. limit register */
#define pREG_OCU0_MAXCNT                 ((volatile  uint32_t *) REG_OCU0_MAXCNT)                 /*  Max. limit register */
#define pREG_OCU0_LMONCNT                ((volatile  uint32_t *) REG_OCU0_LMONCNT)                /*  LFO monitor reference count */
#define pREG_OCU0_CMONCNT                ((volatile  uint32_t *) REG_OCU0_CMONCNT)                /*  Clkin monitor reference count */
#define pREG_OCU0_PID4                   ((volatile  uint32_t *) REG_OCU0_PID4)                   /*  Peripheral ID4Register */
#define pREG_OCU0_PID5                   ((volatile  uint32_t *) REG_OCU0_PID5)                   /*  Peripheral ID5Register */
#define pREG_OCU0_PID6                   ((volatile  uint32_t *) REG_OCU0_PID6)                   /*  Peripheral ID6Register */
#define pREG_OCU0_PID7                   ((volatile  uint32_t *) REG_OCU0_PID7)                   /*  Peripheral ID7Register */
#define pREG_OCU0_PID0                   ((volatile  uint32_t *) REG_OCU0_PID0)                   /*  Peripheral ID0Register */
#define pREG_OCU0_PID1                   ((volatile  uint32_t *) REG_OCU0_PID1)                   /*  Peripheral ID1Register */
#define pREG_OCU0_PID2                   ((volatile  uint32_t *) REG_OCU0_PID2)                   /*  Peripheral ID3Register */
#define pREG_OCU0_PID3                   ((volatile  uint32_t *) REG_OCU0_PID3)                   /*  Peripheral ID3Register */
#define pREG_OCU0_CID0                   ((volatile  uint32_t *) REG_OCU0_CID0)                   /*  Component ID0 Register */
#define pREG_OCU0_CID1                   ((volatile  uint32_t *) REG_OCU0_CID1)                   /*  Component ID1 Register */
#define pREG_OCU0_CID2                   ((volatile  uint32_t *) REG_OCU0_CID2)                   /*  Component ID2 Register */
#define pREG_OCU0_CID3                   ((volatile  uint32_t *) REG_OCU0_CID3)                   /*  Component ID3 Register */

/*  =================================================================================
 *      eFUSE Controller (EFS0)
 *  ================================================================================= */

/*  =================================================================================
 *      TAPC (TAPC)
 *  ================================================================================= */
#define pREG_TAPC_IDCODE                 ((volatile  uint32_t *) REG_TAPC_IDCODE)                 /*  IDCODE Register */
#define pREG_TAPC_USERCODE               ((volatile  uint32_t *) REG_TAPC_USERCODE)               /*  USERCODE Register */
#define pREG_TAPC_SDBGKEY_CTL            ((volatile  uint32_t *) REG_TAPC_SDBGKEY_CTL)            /*  Secure Debug Key Control Register */
#define pREG_TAPC_SDBGKEY_STAT           ((volatile  uint32_t *) REG_TAPC_SDBGKEY_STAT)           /*  Secure Debug Key Status Register */
#define pREG_TAPC_SDBGKEY0               ((volatile  uint32_t *) REG_TAPC_SDBGKEY0)               /*  Secure Debug Key 0 Register */
#define pREG_TAPC_SDBGKEY1               ((volatile  uint32_t *) REG_TAPC_SDBGKEY1)               /*  Secure Debug Key 1 Register */
#define pREG_TAPC_SDBGKEY2               ((volatile  uint32_t *) REG_TAPC_SDBGKEY2)               /*  Secure Debug Key 2 Register */
#define pREG_TAPC_SDBGKEY3               ((volatile  uint32_t *) REG_TAPC_SDBGKEY3)               /*  Secure Debug Key 3 Register */
#define pREG_TAPC_TESTKEY0               ((volatile  uint32_t *) REG_TAPC_TESTKEY0)               /*  TESTKEY Value Register */
#define pREG_TAPC_DBGCTL                 ((volatile  uint32_t *) REG_TAPC_DBGCTL)                 /*  Debug Control */
#define pREG_TAPC_DBGSTAT                ((volatile  uint32_t *) REG_TAPC_DBGSTAT)                /*  Debug Status Register */
#define pREG_TAPC_SDBGKEYCMP0            ((volatile  uint32_t *) REG_TAPC_SDBGKEYCMP0)            /*  Secure Debug Key 0 key compare register */
#define pREG_TAPC_SDBGKEYCMP1            ((volatile  uint32_t *) REG_TAPC_SDBGKEYCMP1)            /*  Secure Debug Key 1 key compare register */
#define pREG_TAPC_SDBGKEYCMP2            ((volatile  uint32_t *) REG_TAPC_SDBGKEYCMP2)            /*  Secure Debug Key 2 key compare register */
#define pREG_TAPC_SDBGKEYCMP3            ((volatile  uint32_t *) REG_TAPC_SDBGKEYCMP3)            /*  Secure Debug Key 3 key compare register */
#define pREG_TAPC_SDBGKEYID0             ((volatile  uint32_t *) REG_TAPC_SDBGKEYID0)             /*  Secure Debug Key 0 key identification register */
#define pREG_TAPC_SDBGKEYID1             ((volatile  uint32_t *) REG_TAPC_SDBGKEYID1)             /*  Secure Debug Key 1 key identification register */
#define pREG_TAPC_SDBGKEYID2             ((volatile  uint32_t *) REG_TAPC_SDBGKEYID2)             /*  Secure Debug Key 2 key identification register */
#define pREG_TAPC_SDBGKEYID3             ((volatile  uint32_t *) REG_TAPC_SDBGKEYID3)             /*  Secure Debug Key 3 key identification register */
#define pREG_TAPC_SCMSG                  ((volatile  uint32_t *) REG_TAPC_SCMSG)                  /*  Secure Run Control Message register */
#define pREG_TAPC_SCMSG_SET              ((volatile  uint32_t *) REG_TAPC_SCMSG_SET)              /*  Secure Run Control Message Set register */
#define pREG_TAPC_SCMSG_CLR              ((volatile  uint32_t *) REG_TAPC_SCMSG_CLR)              /*  Secure Run Control Message Clear register */
#define pREG_TAPC_SCMSG_TGL              ((volatile  uint32_t *) REG_TAPC_SCMSG_TGL)              /*  Secure Run Control Message Toggle register */
#define pREG_TAPC_RCMSG                  ((volatile  uint32_t *) REG_TAPC_RCMSG)                  /*  Run Control Message register */
#define pREG_TAPC_RCMSG_SET              ((volatile  uint32_t *) REG_TAPC_RCMSG_SET)              /*  Run Control Message Set register */
#define pREG_TAPC_RCMSG_CLR              ((volatile  uint32_t *) REG_TAPC_RCMSG_CLR)              /*  Run Control Message Clear register */
#define pREG_TAPC_RCMSG_TGL              ((volatile  uint32_t *) REG_TAPC_RCMSG_TGL)              /*  Run Control Message Toggle register */

/*  =================================================================================
 *      Trigger Routing Unit (TRU1)
 *  ================================================================================= */
#define pREG_TRU1_SSR0                   ((volatile  uint32_t *) REG_TRU1_SSR0)                   /*  Slave Select Register */
#define pREG_TRU1_SSR1                   ((volatile  uint32_t *) REG_TRU1_SSR1)                   /*  Slave Select Register */
#define pREG_TRU1_SSR2                   ((volatile  uint32_t *) REG_TRU1_SSR2)                   /*  Slave Select Register */
#define pREG_TRU1_SSR3                   ((volatile  uint32_t *) REG_TRU1_SSR3)                   /*  Slave Select Register */
#define pREG_TRU1_SSR4                   ((volatile  uint32_t *) REG_TRU1_SSR4)                   /*  Slave Select Register */
#define pREG_TRU1_SSR5                   ((volatile  uint32_t *) REG_TRU1_SSR5)                   /*  Slave Select Register */
#define pREG_TRU1_SSR6                   ((volatile  uint32_t *) REG_TRU1_SSR6)                   /*  Slave Select Register */
#define pREG_TRU1_SSR7                   ((volatile  uint32_t *) REG_TRU1_SSR7)                   /*  Slave Select Register */
#define pREG_TRU1_SSR8                   ((volatile  uint32_t *) REG_TRU1_SSR8)                   /*  Slave Select Register */
#define pREG_TRU1_SSR9                   ((volatile  uint32_t *) REG_TRU1_SSR9)                   /*  Slave Select Register */
#define pREG_TRU1_SSR10                  ((volatile  uint32_t *) REG_TRU1_SSR10)                  /*  Slave Select Register */
#define pREG_TRU1_SSR11                  ((volatile  uint32_t *) REG_TRU1_SSR11)                  /*  Slave Select Register */
#define pREG_TRU1_SSR12                  ((volatile  uint32_t *) REG_TRU1_SSR12)                  /*  Slave Select Register */
#define pREG_TRU1_SSR13                  ((volatile  uint32_t *) REG_TRU1_SSR13)                  /*  Slave Select Register */
#define pREG_TRU1_SSR14                  ((volatile  uint32_t *) REG_TRU1_SSR14)                  /*  Slave Select Register */
#define pREG_TRU1_SSR15                  ((volatile  uint32_t *) REG_TRU1_SSR15)                  /*  Slave Select Register */
#define pREG_TRU1_SSR16                  ((volatile  uint32_t *) REG_TRU1_SSR16)                  /*  Slave Select Register */
#define pREG_TRU1_SSR17                  ((volatile  uint32_t *) REG_TRU1_SSR17)                  /*  Slave Select Register */
#define pREG_TRU1_SSR18                  ((volatile  uint32_t *) REG_TRU1_SSR18)                  /*  Slave Select Register */
#define pREG_TRU1_SSR19                  ((volatile  uint32_t *) REG_TRU1_SSR19)                  /*  Slave Select Register */
#define pREG_TRU1_SSR20                  ((volatile  uint32_t *) REG_TRU1_SSR20)                  /*  Slave Select Register */
#define pREG_TRU1_SSR21                  ((volatile  uint32_t *) REG_TRU1_SSR21)                  /*  Slave Select Register */
#define pREG_TRU1_SSR22                  ((volatile  uint32_t *) REG_TRU1_SSR22)                  /*  Slave Select Register */
#define pREG_TRU1_SSR23                  ((volatile  uint32_t *) REG_TRU1_SSR23)                  /*  Slave Select Register */
#define pREG_TRU1_SSR24                  ((volatile  uint32_t *) REG_TRU1_SSR24)                  /*  Slave Select Register */
#define pREG_TRU1_SSR25                  ((volatile  uint32_t *) REG_TRU1_SSR25)                  /*  Slave Select Register */
#define pREG_TRU1_SSR26                  ((volatile  uint32_t *) REG_TRU1_SSR26)                  /*  Slave Select Register */
#define pREG_TRU1_SSR27                  ((volatile  uint32_t *) REG_TRU1_SSR27)                  /*  Slave Select Register */
#define pREG_TRU1_SSR28                  ((volatile  uint32_t *) REG_TRU1_SSR28)                  /*  Slave Select Register */
#define pREG_TRU1_SSR29                  ((volatile  uint32_t *) REG_TRU1_SSR29)                  /*  Slave Select Register */
#define pREG_TRU1_SSR30                  ((volatile  uint32_t *) REG_TRU1_SSR30)                  /*  Slave Select Register */
#define pREG_TRU1_SSR31                  ((volatile  uint32_t *) REG_TRU1_SSR31)                  /*  Slave Select Register */
#define pREG_TRU1_SSR32                  ((volatile  uint32_t *) REG_TRU1_SSR32)                  /*  Slave Select Register */
#define pREG_TRU1_SSR33                  ((volatile  uint32_t *) REG_TRU1_SSR33)                  /*  Slave Select Register */
#define pREG_TRU1_SSR34                  ((volatile  uint32_t *) REG_TRU1_SSR34)                  /*  Slave Select Register */
#define pREG_TRU1_SSR35                  ((volatile  uint32_t *) REG_TRU1_SSR35)                  /*  Slave Select Register */
#define pREG_TRU1_SSR36                  ((volatile  uint32_t *) REG_TRU1_SSR36)                  /*  Slave Select Register */
#define pREG_TRU1_SSR37                  ((volatile  uint32_t *) REG_TRU1_SSR37)                  /*  Slave Select Register */
#define pREG_TRU1_SSR38                  ((volatile  uint32_t *) REG_TRU1_SSR38)                  /*  Slave Select Register */
#define pREG_TRU1_SSR39                  ((volatile  uint32_t *) REG_TRU1_SSR39)                  /*  Slave Select Register */
#define pREG_TRU1_SSR40                  ((volatile  uint32_t *) REG_TRU1_SSR40)                  /*  Slave Select Register */
#define pREG_TRU1_SSR41                  ((volatile  uint32_t *) REG_TRU1_SSR41)                  /*  Slave Select Register */
#define pREG_TRU1_SSR42                  ((volatile  uint32_t *) REG_TRU1_SSR42)                  /*  Slave Select Register */
#define pREG_TRU1_SSR43                  ((volatile  uint32_t *) REG_TRU1_SSR43)                  /*  Slave Select Register */
#define pREG_TRU1_SSR44                  ((volatile  uint32_t *) REG_TRU1_SSR44)                  /*  Slave Select Register */
#define pREG_TRU1_SSR45                  ((volatile  uint32_t *) REG_TRU1_SSR45)                  /*  Slave Select Register */
#define pREG_TRU1_SSR46                  ((volatile  uint32_t *) REG_TRU1_SSR46)                  /*  Slave Select Register */
#define pREG_TRU1_SSR47                  ((volatile  uint32_t *) REG_TRU1_SSR47)                  /*  Slave Select Register */
#define pREG_TRU1_SSR48                  ((volatile  uint32_t *) REG_TRU1_SSR48)                  /*  Slave Select Register */
#define pREG_TRU1_SSR49                  ((volatile  uint32_t *) REG_TRU1_SSR49)                  /*  Slave Select Register */
#define pREG_TRU1_SSR50                  ((volatile  uint32_t *) REG_TRU1_SSR50)                  /*  Slave Select Register */
#define pREG_TRU1_SSR51                  ((volatile  uint32_t *) REG_TRU1_SSR51)                  /*  Slave Select Register */
#define pREG_TRU1_SSR52                  ((volatile  uint32_t *) REG_TRU1_SSR52)                  /*  Slave Select Register */
#define pREG_TRU1_SSR53                  ((volatile  uint32_t *) REG_TRU1_SSR53)                  /*  Slave Select Register */
#define pREG_TRU1_SSR54                  ((volatile  uint32_t *) REG_TRU1_SSR54)                  /*  Slave Select Register */
#define pREG_TRU1_SSR55                  ((volatile  uint32_t *) REG_TRU1_SSR55)                  /*  Slave Select Register */
#define pREG_TRU1_SSR56                  ((volatile  uint32_t *) REG_TRU1_SSR56)                  /*  Slave Select Register */
#define pREG_TRU1_SSR57                  ((volatile  uint32_t *) REG_TRU1_SSR57)                  /*  Slave Select Register */
#define pREG_TRU1_SSR58                  ((volatile  uint32_t *) REG_TRU1_SSR58)                  /*  Slave Select Register */
#define pREG_TRU1_SSR59                  ((volatile  uint32_t *) REG_TRU1_SSR59)                  /*  Slave Select Register */
#define pREG_TRU1_SSR60                  ((volatile  uint32_t *) REG_TRU1_SSR60)                  /*  Slave Select Register */
#define pREG_TRU1_SSR61                  ((volatile  uint32_t *) REG_TRU1_SSR61)                  /*  Slave Select Register */
#define pREG_TRU1_SSR62                  ((volatile  uint32_t *) REG_TRU1_SSR62)                  /*  Slave Select Register */
#define pREG_TRU1_SSR63                  ((volatile  uint32_t *) REG_TRU1_SSR63)                  /*  Slave Select Register */
#define pREG_TRU1_SSR64                  ((volatile  uint32_t *) REG_TRU1_SSR64)                  /*  Slave Select Register */
#define pREG_TRU1_SSR65                  ((volatile  uint32_t *) REG_TRU1_SSR65)                  /*  Slave Select Register */
#define pREG_TRU1_SSR66                  ((volatile  uint32_t *) REG_TRU1_SSR66)                  /*  Slave Select Register */
#define pREG_TRU1_SSR67                  ((volatile  uint32_t *) REG_TRU1_SSR67)                  /*  Slave Select Register */
#define pREG_TRU1_SSR68                  ((volatile  uint32_t *) REG_TRU1_SSR68)                  /*  Slave Select Register */
#define pREG_TRU1_SSR69                  ((volatile  uint32_t *) REG_TRU1_SSR69)                  /*  Slave Select Register */
#define pREG_TRU1_SSR70                  ((volatile  uint32_t *) REG_TRU1_SSR70)                  /*  Slave Select Register */
#define pREG_TRU1_SSR71                  ((volatile  uint32_t *) REG_TRU1_SSR71)                  /*  Slave Select Register */
#define pREG_TRU1_SSR72                  ((volatile  uint32_t *) REG_TRU1_SSR72)                  /*  Slave Select Register */
#define pREG_TRU1_SSR73                  ((volatile  uint32_t *) REG_TRU1_SSR73)                  /*  Slave Select Register */
#define pREG_TRU1_SSR74                  ((volatile  uint32_t *) REG_TRU1_SSR74)                  /*  Slave Select Register */
#define pREG_TRU1_SSR75                  ((volatile  uint32_t *) REG_TRU1_SSR75)                  /*  Slave Select Register */
#define pREG_TRU1_SSR76                  ((volatile  uint32_t *) REG_TRU1_SSR76)                  /*  Slave Select Register */
#define pREG_TRU1_SSR77                  ((volatile  uint32_t *) REG_TRU1_SSR77)                  /*  Slave Select Register */
#define pREG_TRU1_SSR78                  ((volatile  uint32_t *) REG_TRU1_SSR78)                  /*  Slave Select Register */
#define pREG_TRU1_SSR79                  ((volatile  uint32_t *) REG_TRU1_SSR79)                  /*  Slave Select Register */
#define pREG_TRU1_SSR80                  ((volatile  uint32_t *) REG_TRU1_SSR80)                  /*  Slave Select Register */
#define pREG_TRU1_SSR81                  ((volatile  uint32_t *) REG_TRU1_SSR81)                  /*  Slave Select Register */
#define pREG_TRU1_SSR82                  ((volatile  uint32_t *) REG_TRU1_SSR82)                  /*  Slave Select Register */
#define pREG_TRU1_SSR83                  ((volatile  uint32_t *) REG_TRU1_SSR83)                  /*  Slave Select Register */
#define pREG_TRU1_SSR84                  ((volatile  uint32_t *) REG_TRU1_SSR84)                  /*  Slave Select Register */
#define pREG_TRU1_SSR85                  ((volatile  uint32_t *) REG_TRU1_SSR85)                  /*  Slave Select Register */
#define pREG_TRU1_SSR86                  ((volatile  uint32_t *) REG_TRU1_SSR86)                  /*  Slave Select Register */
#define pREG_TRU1_SSR87                  ((volatile  uint32_t *) REG_TRU1_SSR87)                  /*  Slave Select Register */
#define pREG_TRU1_SSR88                  ((volatile  uint32_t *) REG_TRU1_SSR88)                  /*  Slave Select Register */
#define pREG_TRU1_SSR89                  ((volatile  uint32_t *) REG_TRU1_SSR89)                  /*  Slave Select Register */
#define pREG_TRU1_SSR90                  ((volatile  uint32_t *) REG_TRU1_SSR90)                  /*  Slave Select Register */
#define pREG_TRU1_SSR91                  ((volatile  uint32_t *) REG_TRU1_SSR91)                  /*  Slave Select Register */
#define pREG_TRU1_SSR92                  ((volatile  uint32_t *) REG_TRU1_SSR92)                  /*  Slave Select Register */
#define pREG_TRU1_SSR93                  ((volatile  uint32_t *) REG_TRU1_SSR93)                  /*  Slave Select Register */
#define pREG_TRU1_SSR94                  ((volatile  uint32_t *) REG_TRU1_SSR94)                  /*  Slave Select Register */
#define pREG_TRU1_SSR95                  ((volatile  uint32_t *) REG_TRU1_SSR95)                  /*  Slave Select Register */
#define pREG_TRU1_SSR96                  ((volatile  uint32_t *) REG_TRU1_SSR96)                  /*  Slave Select Register */
#define pREG_TRU1_SSR97                  ((volatile  uint32_t *) REG_TRU1_SSR97)                  /*  Slave Select Register */
#define pREG_TRU1_SSR98                  ((volatile  uint32_t *) REG_TRU1_SSR98)                  /*  Slave Select Register */
#define pREG_TRU1_SSR99                  ((volatile  uint32_t *) REG_TRU1_SSR99)                  /*  Slave Select Register */
#define pREG_TRU1_SSR100                 ((volatile  uint32_t *) REG_TRU1_SSR100)                 /*  Slave Select Register */
#define pREG_TRU1_SSR101                 ((volatile  uint32_t *) REG_TRU1_SSR101)                 /*  Slave Select Register */
#define pREG_TRU1_SSR102                 ((volatile  uint32_t *) REG_TRU1_SSR102)                 /*  Slave Select Register */
#define pREG_TRU1_SSR103                 ((volatile  uint32_t *) REG_TRU1_SSR103)                 /*  Slave Select Register */
#define pREG_TRU1_SSR104                 ((volatile  uint32_t *) REG_TRU1_SSR104)                 /*  Slave Select Register */
#define pREG_TRU1_SSR105                 ((volatile  uint32_t *) REG_TRU1_SSR105)                 /*  Slave Select Register */
#define pREG_TRU1_SSR106                 ((volatile  uint32_t *) REG_TRU1_SSR106)                 /*  Slave Select Register */
#define pREG_TRU1_SSR107                 ((volatile  uint32_t *) REG_TRU1_SSR107)                 /*  Slave Select Register */
#define pREG_TRU1_SSR108                 ((volatile  uint32_t *) REG_TRU1_SSR108)                 /*  Slave Select Register */
#define pREG_TRU1_SSR109                 ((volatile  uint32_t *) REG_TRU1_SSR109)                 /*  Slave Select Register */
#define pREG_TRU1_SSR110                 ((volatile  uint32_t *) REG_TRU1_SSR110)                 /*  Slave Select Register */
#define pREG_TRU1_SSR111                 ((volatile  uint32_t *) REG_TRU1_SSR111)                 /*  Slave Select Register */
#define pREG_TRU1_SSR112                 ((volatile  uint32_t *) REG_TRU1_SSR112)                 /*  Slave Select Register */
#define pREG_TRU1_SSR113                 ((volatile  uint32_t *) REG_TRU1_SSR113)                 /*  Slave Select Register */
#define pREG_TRU1_SSR114                 ((volatile  uint32_t *) REG_TRU1_SSR114)                 /*  Slave Select Register */
#define pREG_TRU1_SSR115                 ((volatile  uint32_t *) REG_TRU1_SSR115)                 /*  Slave Select Register */
#define pREG_TRU1_SSR116                 ((volatile  uint32_t *) REG_TRU1_SSR116)                 /*  Slave Select Register */
#define pREG_TRU1_SSR117                 ((volatile  uint32_t *) REG_TRU1_SSR117)                 /*  Slave Select Register */
#define pREG_TRU1_SSR118                 ((volatile  uint32_t *) REG_TRU1_SSR118)                 /*  Slave Select Register */
#define pREG_TRU1_SSR119                 ((volatile  uint32_t *) REG_TRU1_SSR119)                 /*  Slave Select Register */
#define pREG_TRU1_SSR120                 ((volatile  uint32_t *) REG_TRU1_SSR120)                 /*  Slave Select Register */
#define pREG_TRU1_SSR121                 ((volatile  uint32_t *) REG_TRU1_SSR121)                 /*  Slave Select Register */
#define pREG_TRU1_SSR122                 ((volatile  uint32_t *) REG_TRU1_SSR122)                 /*  Slave Select Register */
#define pREG_TRU1_SSR123                 ((volatile  uint32_t *) REG_TRU1_SSR123)                 /*  Slave Select Register */
#define pREG_TRU1_SSR124                 ((volatile  uint32_t *) REG_TRU1_SSR124)                 /*  Slave Select Register */
#define pREG_TRU1_SSR125                 ((volatile  uint32_t *) REG_TRU1_SSR125)                 /*  Slave Select Register */
#define pREG_TRU1_SSR126                 ((volatile  uint32_t *) REG_TRU1_SSR126)                 /*  Slave Select Register */
#define pREG_TRU1_SSR127                 ((volatile  uint32_t *) REG_TRU1_SSR127)                 /*  Slave Select Register */
#define pREG_TRU1_SSR128                 ((volatile  uint32_t *) REG_TRU1_SSR128)                 /*  Slave Select Register */
#define pREG_TRU1_SSR129                 ((volatile  uint32_t *) REG_TRU1_SSR129)                 /*  Slave Select Register */
#define pREG_TRU1_SSR130                 ((volatile  uint32_t *) REG_TRU1_SSR130)                 /*  Slave Select Register */
#define pREG_TRU1_SSR131                 ((volatile  uint32_t *) REG_TRU1_SSR131)                 /*  Slave Select Register */
#define pREG_TRU1_SSR132                 ((volatile  uint32_t *) REG_TRU1_SSR132)                 /*  Slave Select Register */
#define pREG_TRU1_SSR133                 ((volatile  uint32_t *) REG_TRU1_SSR133)                 /*  Slave Select Register */
#define pREG_TRU1_SSR134                 ((volatile  uint32_t *) REG_TRU1_SSR134)                 /*  Slave Select Register */
#define pREG_TRU1_MTR                    ((volatile  uint32_t *) REG_TRU1_MTR)                    /*  Master Trigger Register */
#define pREG_TRU1_ERRADDR                ((volatile  uint32_t *) REG_TRU1_ERRADDR)                /*  Error Address Register */
#define pREG_TRU1_STAT                   ((volatile  uint32_t *) REG_TRU1_STAT)                   /*  Status Information Register */
#define pREG_TRU1_GCTL                   ((volatile  uint32_t *) REG_TRU1_GCTL)                   /*  Global Control Register */

/*  =================================================================================
 *      General-Purpose Timer Block (TIMER0)
 *  ================================================================================= */
#define pREG_TIMER0_RUN                  ((volatile  uint32_t *) REG_TIMER0_RUN)                  /*  Run Register */
#define pREG_TIMER0_RUN_SET              ((volatile  uint32_t *) REG_TIMER0_RUN_SET)              /*  Run Set Register */
#define pREG_TIMER0_RUN_CLR              ((volatile  uint32_t *) REG_TIMER0_RUN_CLR)              /*  Run Clear Register */
#define pREG_TIMER0_STOP_CFG             ((volatile  uint32_t *) REG_TIMER0_STOP_CFG)             /*  Stop Configuration Register */
#define pREG_TIMER0_STOP_CFG_SET         ((volatile  uint32_t *) REG_TIMER0_STOP_CFG_SET)         /*  Stop Configuration Set Register */
#define pREG_TIMER0_STOP_CFG_CLR         ((volatile  uint32_t *) REG_TIMER0_STOP_CFG_CLR)         /*  Stop Configuration Clear Register */
#define pREG_TIMER0_DATA_IMSK            ((volatile  uint32_t *) REG_TIMER0_DATA_IMSK)            /*  Data Interrupt Mask Register */
#define pREG_TIMER0_STAT_IMSK            ((volatile  uint32_t *) REG_TIMER0_STAT_IMSK)            /*  Status Interrupt Mask Register */
#define pREG_TIMER0_TRG_MSK              ((volatile  uint32_t *) REG_TIMER0_TRG_MSK)              /*  Trigger Master Mask Register */
#define pREG_TIMER0_TRG_IE               ((volatile  uint32_t *) REG_TIMER0_TRG_IE)               /*  Trigger Slave Enable Register */
#define pREG_TIMER0_DATA_ILAT            ((volatile  uint32_t *) REG_TIMER0_DATA_ILAT)            /*  Data Interrupt Latch Register */
#define pREG_TIMER0_STAT_ILAT            ((volatile  uint32_t *) REG_TIMER0_STAT_ILAT)            /*  Status Interrupt Latch Register */
#define pREG_TIMER0_ERR_TYPE             ((volatile  uint32_t *) REG_TIMER0_ERR_TYPE)             /*  Error Type Status Register */
#define pREG_TIMER0_BCAST_PER            ((volatile  uint32_t *) REG_TIMER0_BCAST_PER)            /*  Broadcast Period Register */
#define pREG_TIMER0_BCAST_WID            ((volatile  uint32_t *) REG_TIMER0_BCAST_WID)            /*  Broadcast Width Register */
#define pREG_TIMER0_BCAST_DLY            ((volatile  uint32_t *) REG_TIMER0_BCAST_DLY)            /*  Broadcast Delay Register */
#define pREG_TIMER0_TMR0_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR0_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR0_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR0_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR0_PER             ((volatile  uint32_t *) REG_TIMER0_TMR0_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR0_WID             ((volatile  uint32_t *) REG_TIMER0_TMR0_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR0_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR0_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR1_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR1_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR1_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR1_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR1_PER             ((volatile  uint32_t *) REG_TIMER0_TMR1_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR1_WID             ((volatile  uint32_t *) REG_TIMER0_TMR1_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR1_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR1_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR2_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR2_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR2_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR2_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR2_PER             ((volatile  uint32_t *) REG_TIMER0_TMR2_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR2_WID             ((volatile  uint32_t *) REG_TIMER0_TMR2_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR2_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR2_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR3_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR3_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR3_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR3_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR3_PER             ((volatile  uint32_t *) REG_TIMER0_TMR3_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR3_WID             ((volatile  uint32_t *) REG_TIMER0_TMR3_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR3_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR3_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR4_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR4_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR4_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR4_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR4_PER             ((volatile  uint32_t *) REG_TIMER0_TMR4_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR4_WID             ((volatile  uint32_t *) REG_TIMER0_TMR4_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR4_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR4_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR5_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR5_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR5_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR5_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR5_PER             ((volatile  uint32_t *) REG_TIMER0_TMR5_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR5_WID             ((volatile  uint32_t *) REG_TIMER0_TMR5_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR5_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR5_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR6_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR6_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR6_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR6_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR6_PER             ((volatile  uint32_t *) REG_TIMER0_TMR6_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR6_WID             ((volatile  uint32_t *) REG_TIMER0_TMR6_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR6_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR6_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER0_TMR7_CFG             ((volatile  uint32_t *) REG_TIMER0_TMR7_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER0_TMR7_CNT             ((volatile  uint32_t *) REG_TIMER0_TMR7_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER0_TMR7_PER             ((volatile  uint32_t *) REG_TIMER0_TMR7_PER)             /*  Timer n Period Register */
#define pREG_TIMER0_TMR7_WID             ((volatile  uint32_t *) REG_TIMER0_TMR7_WID)             /*  Timer n Width Register */
#define pREG_TIMER0_TMR7_DLY             ((volatile  uint32_t *) REG_TIMER0_TMR7_DLY)             /*  Timer n Delay Register */

/*  =================================================================================
 *      General-Purpose Timer Block (TIMER1)
 *  ================================================================================= */
#define pREG_TIMER1_RUN                  ((volatile  uint32_t *) REG_TIMER1_RUN)                  /*  Run Register */
#define pREG_TIMER1_RUN_SET              ((volatile  uint32_t *) REG_TIMER1_RUN_SET)              /*  Run Set Register */
#define pREG_TIMER1_RUN_CLR              ((volatile  uint32_t *) REG_TIMER1_RUN_CLR)              /*  Run Clear Register */
#define pREG_TIMER1_STOP_CFG             ((volatile  uint32_t *) REG_TIMER1_STOP_CFG)             /*  Stop Configuration Register */
#define pREG_TIMER1_STOP_CFG_SET         ((volatile  uint32_t *) REG_TIMER1_STOP_CFG_SET)         /*  Stop Configuration Set Register */
#define pREG_TIMER1_STOP_CFG_CLR         ((volatile  uint32_t *) REG_TIMER1_STOP_CFG_CLR)         /*  Stop Configuration Clear Register */
#define pREG_TIMER1_DATA_IMSK            ((volatile  uint32_t *) REG_TIMER1_DATA_IMSK)            /*  Data Interrupt Mask Register */
#define pREG_TIMER1_STAT_IMSK            ((volatile  uint32_t *) REG_TIMER1_STAT_IMSK)            /*  Status Interrupt Mask Register */
#define pREG_TIMER1_TRG_MSK              ((volatile  uint32_t *) REG_TIMER1_TRG_MSK)              /*  Trigger Master Mask Register */
#define pREG_TIMER1_TRG_IE               ((volatile  uint32_t *) REG_TIMER1_TRG_IE)               /*  Trigger Slave Enable Register */
#define pREG_TIMER1_DATA_ILAT            ((volatile  uint32_t *) REG_TIMER1_DATA_ILAT)            /*  Data Interrupt Latch Register */
#define pREG_TIMER1_STAT_ILAT            ((volatile  uint32_t *) REG_TIMER1_STAT_ILAT)            /*  Status Interrupt Latch Register */
#define pREG_TIMER1_ERR_TYPE             ((volatile  uint32_t *) REG_TIMER1_ERR_TYPE)             /*  Error Type Status Register */
#define pREG_TIMER1_BCAST_PER            ((volatile  uint32_t *) REG_TIMER1_BCAST_PER)            /*  Broadcast Period Register */
#define pREG_TIMER1_BCAST_WID            ((volatile  uint32_t *) REG_TIMER1_BCAST_WID)            /*  Broadcast Width Register */
#define pREG_TIMER1_BCAST_DLY            ((volatile  uint32_t *) REG_TIMER1_BCAST_DLY)            /*  Broadcast Delay Register */
#define pREG_TIMER1_TMR0_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR0_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR0_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR0_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR0_PER             ((volatile  uint32_t *) REG_TIMER1_TMR0_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR0_WID             ((volatile  uint32_t *) REG_TIMER1_TMR0_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR0_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR0_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR1_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR1_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR1_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR1_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR1_PER             ((volatile  uint32_t *) REG_TIMER1_TMR1_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR1_WID             ((volatile  uint32_t *) REG_TIMER1_TMR1_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR1_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR1_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR2_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR2_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR2_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR2_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR2_PER             ((volatile  uint32_t *) REG_TIMER1_TMR2_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR2_WID             ((volatile  uint32_t *) REG_TIMER1_TMR2_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR2_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR2_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR3_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR3_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR3_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR3_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR3_PER             ((volatile  uint32_t *) REG_TIMER1_TMR3_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR3_WID             ((volatile  uint32_t *) REG_TIMER1_TMR3_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR3_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR3_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR4_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR4_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR4_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR4_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR4_PER             ((volatile  uint32_t *) REG_TIMER1_TMR4_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR4_WID             ((volatile  uint32_t *) REG_TIMER1_TMR4_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR4_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR4_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR5_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR5_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR5_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR5_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR5_PER             ((volatile  uint32_t *) REG_TIMER1_TMR5_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR5_WID             ((volatile  uint32_t *) REG_TIMER1_TMR5_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR5_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR5_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR6_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR6_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR6_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR6_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR6_PER             ((volatile  uint32_t *) REG_TIMER1_TMR6_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR6_WID             ((volatile  uint32_t *) REG_TIMER1_TMR6_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR6_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR6_DLY)             /*  Timer n Delay Register */
#define pREG_TIMER1_TMR7_CFG             ((volatile  uint32_t *) REG_TIMER1_TMR7_CFG)             /*  Timer n Configuration Register */
#define pREG_TIMER1_TMR7_CNT             ((volatile  uint32_t *) REG_TIMER1_TMR7_CNT)             /*  Timer n Counter Register */
#define pREG_TIMER1_TMR7_PER             ((volatile  uint32_t *) REG_TIMER1_TMR7_PER)             /*  Timer n Period Register */
#define pREG_TIMER1_TMR7_WID             ((volatile  uint32_t *) REG_TIMER1_TMR7_WID)             /*  Timer n Width Register */
#define pREG_TIMER1_TMR7_DLY             ((volatile  uint32_t *) REG_TIMER1_TMR7_DLY)             /*  Timer n Delay Register */

/*  =================================================================================
 *      CNT (CNT0)
 *  ================================================================================= */
#define pREG_CNT0_CFG                    ((volatile  uint32_t *) REG_CNT0_CFG)                    /*  Configuration Register */
#define pREG_CNT0_IMSK                   ((volatile  uint32_t *) REG_CNT0_IMSK)                   /*  Interrupt Mask Register */
#define pREG_CNT0_STAT                   ((volatile  uint32_t *) REG_CNT0_STAT)                   /*  Status Register */
#define pREG_CNT0_CMD                    ((volatile  uint32_t *) REG_CNT0_CMD)                    /*  Command Register */
#define pREG_CNT0_DEBNCE                 ((volatile  uint32_t *) REG_CNT0_DEBNCE)                 /*  Debounce Register */
#define pREG_CNT0_CNTR                   ((volatile  uint32_t *) REG_CNT0_CNTR)                   /*  Counter Register */
#define pREG_CNT0_MAX                    ((volatile  uint32_t *) REG_CNT0_MAX)                    /*  Maximum Count Register */
#define pREG_CNT0_MIN                    ((volatile  uint32_t *) REG_CNT0_MIN)                    /*  Minimum Count Register */
#define pREG_CNT0_MDIV                   ((volatile  uint32_t *) REG_CNT0_MDIV)                   /*  M Value for Divider */
#define pREG_CNT0_NDIV                   ((volatile  uint32_t *) REG_CNT0_NDIV)                   /*  N Value for Divider */

/*  =================================================================================
 *      2-Wire Interface (TWI0)
 *  ================================================================================= */
#define pREG_TWI0_CLKDIV                 ((volatile  uint32_t *) REG_TWI0_CLKDIV)                 /*  SCL Clock Divider Register */
#define pREG_TWI0_CTL                    ((volatile  uint32_t *) REG_TWI0_CTL)                    /*  Control Register */
#define pREG_TWI0_SLVCTL                 ((volatile  uint32_t *) REG_TWI0_SLVCTL)                 /*  Slave Mode Control Register */
#define pREG_TWI0_SLVSTAT                ((volatile  uint32_t *) REG_TWI0_SLVSTAT)                /*  Slave Mode Status Register */
#define pREG_TWI0_SLVADDR                ((volatile  uint32_t *) REG_TWI0_SLVADDR)                /*  Slave Mode Address Register */
#define pREG_TWI0_MSTRCTL                ((volatile  uint32_t *) REG_TWI0_MSTRCTL)                /*  Master Mode Control Registers */
#define pREG_TWI0_MSTRSTAT               ((volatile  uint32_t *) REG_TWI0_MSTRSTAT)               /*  Master Mode Status Register */
#define pREG_TWI0_MSTRADDR               ((volatile  uint32_t *) REG_TWI0_MSTRADDR)               /*  Master Mode Address Register */
#define pREG_TWI0_ISTAT                  ((volatile  uint32_t *) REG_TWI0_ISTAT)                  /*  Interrupt Status Register */
#define pREG_TWI0_IMSK                   ((volatile  uint32_t *) REG_TWI0_IMSK)                   /*  Interrupt Mask Register */
#define pREG_TWI0_FIFOCTL                ((volatile  uint32_t *) REG_TWI0_FIFOCTL)                /*  FIFO Control Register */
#define pREG_TWI0_FIFOSTAT               ((volatile  uint32_t *) REG_TWI0_FIFOSTAT)               /*  FIFO Status Register */
#define pREG_TWI0_TXDATA8                ((volatile  uint32_t *) REG_TWI0_TXDATA8)                /*  Tx Data Single-Byte Register */
#define pREG_TWI0_TXDATA16               ((volatile  uint32_t *) REG_TWI0_TXDATA16)               /*  Tx Data Double-Byte Register */
#define pREG_TWI0_RXDATA8                ((volatile  uint32_t *) REG_TWI0_RXDATA8)                /*  Rx Data Single-Byte Register */
#define pREG_TWI0_RXDATA16               ((volatile  uint32_t *) REG_TWI0_RXDATA16)               /*  Rx Data Double-Byte Register */

/*  =================================================================================
 *      Controller Area Network (CAN0)
 *  ================================================================================= */
#define pREG_CAN0_MC1                    ((volatile  uint32_t *) REG_CAN0_MC1)                    /*  Mailbox Configuration 1 Register */
#define pREG_CAN0_MD1                    ((volatile  uint32_t *) REG_CAN0_MD1)                    /*  Mailbox Direction 1 Register */
#define pREG_CAN0_TRS1                   ((volatile  uint32_t *) REG_CAN0_TRS1)                   /*  Transmission Request Set 1 Register */
#define pREG_CAN0_TRR1                   ((volatile  uint32_t *) REG_CAN0_TRR1)                   /*  Transmission Request Reset 1 Register */
#define pREG_CAN0_TA1                    ((volatile  uint32_t *) REG_CAN0_TA1)                    /*  Transmission Acknowledge 1 Register */
#define pREG_CAN0_AA1                    ((volatile  uint32_t *) REG_CAN0_AA1)                    /*  Abort Acknowledge 1 Register */
#define pREG_CAN0_RMP1                   ((volatile  uint32_t *) REG_CAN0_RMP1)                   /*  Receive Message Pending 1 Register */
#define pREG_CAN0_RML1                   ((volatile  uint32_t *) REG_CAN0_RML1)                   /*  Receive Message Lost 1 Register */
#define pREG_CAN0_MBTIF1                 ((volatile  uint32_t *) REG_CAN0_MBTIF1)                 /*  Mailbox Transmit Interrupt Flag 1 Register */
#define pREG_CAN0_MBRIF1                 ((volatile  uint32_t *) REG_CAN0_MBRIF1)                 /*  Mailbox Receive Interrupt Flag 1 Register */
#define pREG_CAN0_MBIM1                  ((volatile  uint32_t *) REG_CAN0_MBIM1)                  /*  Mailbox Interrupt Mask 1 Register */
#define pREG_CAN0_RFH1                   ((volatile  uint32_t *) REG_CAN0_RFH1)                   /*  Remote Frame Handling 1 Register */
#define pREG_CAN0_OPSS1                  ((volatile  uint32_t *) REG_CAN0_OPSS1)                  /*  Overwrite Protection/Single Shot Transmission 1 Register */
#define pREG_CAN0_MC2                    ((volatile  uint32_t *) REG_CAN0_MC2)                    /*  Mailbox Configuration 2 Register */
#define pREG_CAN0_MD2                    ((volatile  uint32_t *) REG_CAN0_MD2)                    /*  Mailbox Direction 2 Register */
#define pREG_CAN0_TRS2                   ((volatile  uint32_t *) REG_CAN0_TRS2)                   /*  Transmission Request Set 2 Register */
#define pREG_CAN0_TRR2                   ((volatile  uint32_t *) REG_CAN0_TRR2)                   /*  Transmission Request Reset 2 Register */
#define pREG_CAN0_TA2                    ((volatile  uint32_t *) REG_CAN0_TA2)                    /*  Transmission Acknowledge 2 Register */
#define pREG_CAN0_AA2                    ((volatile  uint32_t *) REG_CAN0_AA2)                    /*  Abort Acknowledge 2 Register */
#define pREG_CAN0_RMP2                   ((volatile  uint32_t *) REG_CAN0_RMP2)                   /*  Receive Message Pending 2 Register */
#define pREG_CAN0_RML2                   ((volatile  uint32_t *) REG_CAN0_RML2)                   /*  Receive Message Lost 2 Register */
#define pREG_CAN0_MBTIF2                 ((volatile  uint32_t *) REG_CAN0_MBTIF2)                 /*  Mailbox Transmit Interrupt Flag 2 Register */
#define pREG_CAN0_MBRIF2                 ((volatile  uint32_t *) REG_CAN0_MBRIF2)                 /*  Mailbox Receive Interrupt Flag 2 Register */
#define pREG_CAN0_MBIM2                  ((volatile  uint32_t *) REG_CAN0_MBIM2)                  /*  Mailbox Interrupt Mask 2 Register */
#define pREG_CAN0_RFH2                   ((volatile  uint32_t *) REG_CAN0_RFH2)                   /*  Remote Frame Handling 2 Register */
#define pREG_CAN0_OPSS2                  ((volatile  uint32_t *) REG_CAN0_OPSS2)                  /*  Overwrite Protection/Single Shot Transmission 2 Register */
#define pREG_CAN0_CLK                    ((volatile  uint32_t *) REG_CAN0_CLK)                    /*  Clock Register */
#define pREG_CAN0_TIMING                 ((volatile  uint32_t *) REG_CAN0_TIMING)                 /*  Timing Register */
#define pREG_CAN0_DBG                    ((volatile  uint32_t *) REG_CAN0_DBG)                    /*  Debug Register */
#define pREG_CAN0_STAT                   ((volatile  uint32_t *) REG_CAN0_STAT)                   /*  Status Register */
#define pREG_CAN0_CEC                    ((volatile  uint32_t *) REG_CAN0_CEC)                    /*  Error Counter Register */
#define pREG_CAN0_GIS                    ((volatile  uint32_t *) REG_CAN0_GIS)                    /*  Global CAN Interrupt Status Register */
#define pREG_CAN0_GIM                    ((volatile  uint32_t *) REG_CAN0_GIM)                    /*  Global CAN Interrupt Mask Register */
#define pREG_CAN0_GIF                    ((volatile  uint32_t *) REG_CAN0_GIF)                    /*  Global CAN Interrupt Flag Register */
#define pREG_CAN0_CTL                    ((volatile  uint32_t *) REG_CAN0_CTL)                    /*  CAN Master Control Register */
#define pREG_CAN0_INT                    ((volatile  uint32_t *) REG_CAN0_INT)                    /*  Interrupt Pending Register */
#define pREG_CAN0_MBTD                   ((volatile  uint32_t *) REG_CAN0_MBTD)                   /*  Temporary Mailbox Disable Register */
#define pREG_CAN0_EWR                    ((volatile  uint32_t *) REG_CAN0_EWR)                    /*  Error Counter Warning Level Register */
#define pREG_CAN0_ESR                    ((volatile  uint32_t *) REG_CAN0_ESR)                    /*  Error Status Register */
#define pREG_CAN0_UCCNT                  ((volatile  uint32_t *) REG_CAN0_UCCNT)                  /*  Universal Counter Register */
#define pREG_CAN0_UCRC                   ((volatile  uint32_t *) REG_CAN0_UCRC)                   /*  Universal Counter Reload/Capture Register */
#define pREG_CAN0_UCCNF                  ((volatile  uint32_t *) REG_CAN0_UCCNF)                  /*  Universal Counter Configuration Mode Register */
#define pREG_CAN0_AM00L                  ((volatile  uint32_t *) REG_CAN0_AM00L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM00H                  ((volatile  uint32_t *) REG_CAN0_AM00H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM01L                  ((volatile  uint32_t *) REG_CAN0_AM01L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM01H                  ((volatile  uint32_t *) REG_CAN0_AM01H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM02L                  ((volatile  uint32_t *) REG_CAN0_AM02L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM02H                  ((volatile  uint32_t *) REG_CAN0_AM02H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM03L                  ((volatile  uint32_t *) REG_CAN0_AM03L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM03H                  ((volatile  uint32_t *) REG_CAN0_AM03H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM04L                  ((volatile  uint32_t *) REG_CAN0_AM04L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM04H                  ((volatile  uint32_t *) REG_CAN0_AM04H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM05L                  ((volatile  uint32_t *) REG_CAN0_AM05L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM05H                  ((volatile  uint32_t *) REG_CAN0_AM05H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM06L                  ((volatile  uint32_t *) REG_CAN0_AM06L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM06H                  ((volatile  uint32_t *) REG_CAN0_AM06H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM07L                  ((volatile  uint32_t *) REG_CAN0_AM07L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM07H                  ((volatile  uint32_t *) REG_CAN0_AM07H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM08L                  ((volatile  uint32_t *) REG_CAN0_AM08L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM08H                  ((volatile  uint32_t *) REG_CAN0_AM08H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM09L                  ((volatile  uint32_t *) REG_CAN0_AM09L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM09H                  ((volatile  uint32_t *) REG_CAN0_AM09H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM10L                  ((volatile  uint32_t *) REG_CAN0_AM10L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM10H                  ((volatile  uint32_t *) REG_CAN0_AM10H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM11L                  ((volatile  uint32_t *) REG_CAN0_AM11L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM11H                  ((volatile  uint32_t *) REG_CAN0_AM11H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM12L                  ((volatile  uint32_t *) REG_CAN0_AM12L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM12H                  ((volatile  uint32_t *) REG_CAN0_AM12H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM13L                  ((volatile  uint32_t *) REG_CAN0_AM13L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM13H                  ((volatile  uint32_t *) REG_CAN0_AM13H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM14L                  ((volatile  uint32_t *) REG_CAN0_AM14L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM14H                  ((volatile  uint32_t *) REG_CAN0_AM14H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM15L                  ((volatile  uint32_t *) REG_CAN0_AM15L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM15H                  ((volatile  uint32_t *) REG_CAN0_AM15H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM16L                  ((volatile  uint32_t *) REG_CAN0_AM16L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM16H                  ((volatile  uint32_t *) REG_CAN0_AM16H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM17L                  ((volatile  uint32_t *) REG_CAN0_AM17L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM17H                  ((volatile  uint32_t *) REG_CAN0_AM17H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM18L                  ((volatile  uint32_t *) REG_CAN0_AM18L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM18H                  ((volatile  uint32_t *) REG_CAN0_AM18H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM19L                  ((volatile  uint32_t *) REG_CAN0_AM19L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM19H                  ((volatile  uint32_t *) REG_CAN0_AM19H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM20L                  ((volatile  uint32_t *) REG_CAN0_AM20L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM20H                  ((volatile  uint32_t *) REG_CAN0_AM20H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM21L                  ((volatile  uint32_t *) REG_CAN0_AM21L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM21H                  ((volatile  uint32_t *) REG_CAN0_AM21H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM22L                  ((volatile  uint32_t *) REG_CAN0_AM22L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM22H                  ((volatile  uint32_t *) REG_CAN0_AM22H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM23L                  ((volatile  uint32_t *) REG_CAN0_AM23L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM23H                  ((volatile  uint32_t *) REG_CAN0_AM23H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM24L                  ((volatile  uint32_t *) REG_CAN0_AM24L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM24H                  ((volatile  uint32_t *) REG_CAN0_AM24H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM25L                  ((volatile  uint32_t *) REG_CAN0_AM25L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM25H                  ((volatile  uint32_t *) REG_CAN0_AM25H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM26L                  ((volatile  uint32_t *) REG_CAN0_AM26L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM26H                  ((volatile  uint32_t *) REG_CAN0_AM26H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM27L                  ((volatile  uint32_t *) REG_CAN0_AM27L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM27H                  ((volatile  uint32_t *) REG_CAN0_AM27H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM28L                  ((volatile  uint32_t *) REG_CAN0_AM28L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM28H                  ((volatile  uint32_t *) REG_CAN0_AM28H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM29L                  ((volatile  uint32_t *) REG_CAN0_AM29L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM29H                  ((volatile  uint32_t *) REG_CAN0_AM29H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM30L                  ((volatile  uint32_t *) REG_CAN0_AM30L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM30H                  ((volatile  uint32_t *) REG_CAN0_AM30H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_AM31L                  ((volatile  uint32_t *) REG_CAN0_AM31L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN0_AM31H                  ((volatile  uint32_t *) REG_CAN0_AM31H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN0_MB00_DATA0             ((volatile  uint32_t *) REG_CAN0_MB00_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB00_DATA1             ((volatile  uint32_t *) REG_CAN0_MB00_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB00_DATA2             ((volatile  uint32_t *) REG_CAN0_MB00_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB00_DATA3             ((volatile  uint32_t *) REG_CAN0_MB00_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB00_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB00_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB00_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB00_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB00_ID0               ((volatile  uint32_t *) REG_CAN0_MB00_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB00_ID1               ((volatile  uint32_t *) REG_CAN0_MB00_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB01_DATA0             ((volatile  uint32_t *) REG_CAN0_MB01_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB01_DATA1             ((volatile  uint32_t *) REG_CAN0_MB01_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB01_DATA2             ((volatile  uint32_t *) REG_CAN0_MB01_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB01_DATA3             ((volatile  uint32_t *) REG_CAN0_MB01_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB01_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB01_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB01_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB01_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB01_ID0               ((volatile  uint32_t *) REG_CAN0_MB01_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB01_ID1               ((volatile  uint32_t *) REG_CAN0_MB01_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB02_DATA0             ((volatile  uint32_t *) REG_CAN0_MB02_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB02_DATA1             ((volatile  uint32_t *) REG_CAN0_MB02_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB02_DATA2             ((volatile  uint32_t *) REG_CAN0_MB02_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB02_DATA3             ((volatile  uint32_t *) REG_CAN0_MB02_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB02_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB02_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB02_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB02_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB02_ID0               ((volatile  uint32_t *) REG_CAN0_MB02_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB02_ID1               ((volatile  uint32_t *) REG_CAN0_MB02_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB03_DATA0             ((volatile  uint32_t *) REG_CAN0_MB03_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB03_DATA1             ((volatile  uint32_t *) REG_CAN0_MB03_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB03_DATA2             ((volatile  uint32_t *) REG_CAN0_MB03_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB03_DATA3             ((volatile  uint32_t *) REG_CAN0_MB03_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB03_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB03_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB03_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB03_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB03_ID0               ((volatile  uint32_t *) REG_CAN0_MB03_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB03_ID1               ((volatile  uint32_t *) REG_CAN0_MB03_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB04_DATA0             ((volatile  uint32_t *) REG_CAN0_MB04_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB04_DATA1             ((volatile  uint32_t *) REG_CAN0_MB04_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB04_DATA2             ((volatile  uint32_t *) REG_CAN0_MB04_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB04_DATA3             ((volatile  uint32_t *) REG_CAN0_MB04_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB04_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB04_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB04_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB04_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB04_ID0               ((volatile  uint32_t *) REG_CAN0_MB04_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB04_ID1               ((volatile  uint32_t *) REG_CAN0_MB04_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB05_DATA0             ((volatile  uint32_t *) REG_CAN0_MB05_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB05_DATA1             ((volatile  uint32_t *) REG_CAN0_MB05_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB05_DATA2             ((volatile  uint32_t *) REG_CAN0_MB05_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB05_DATA3             ((volatile  uint32_t *) REG_CAN0_MB05_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB05_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB05_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB05_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB05_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB05_ID0               ((volatile  uint32_t *) REG_CAN0_MB05_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB05_ID1               ((volatile  uint32_t *) REG_CAN0_MB05_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB06_DATA0             ((volatile  uint32_t *) REG_CAN0_MB06_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB06_DATA1             ((volatile  uint32_t *) REG_CAN0_MB06_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB06_DATA2             ((volatile  uint32_t *) REG_CAN0_MB06_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB06_DATA3             ((volatile  uint32_t *) REG_CAN0_MB06_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB06_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB06_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB06_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB06_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB06_ID0               ((volatile  uint32_t *) REG_CAN0_MB06_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB06_ID1               ((volatile  uint32_t *) REG_CAN0_MB06_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB07_DATA0             ((volatile  uint32_t *) REG_CAN0_MB07_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB07_DATA1             ((volatile  uint32_t *) REG_CAN0_MB07_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB07_DATA2             ((volatile  uint32_t *) REG_CAN0_MB07_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB07_DATA3             ((volatile  uint32_t *) REG_CAN0_MB07_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB07_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB07_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB07_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB07_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB07_ID0               ((volatile  uint32_t *) REG_CAN0_MB07_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB07_ID1               ((volatile  uint32_t *) REG_CAN0_MB07_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB08_DATA0             ((volatile  uint32_t *) REG_CAN0_MB08_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB08_DATA1             ((volatile  uint32_t *) REG_CAN0_MB08_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB08_DATA2             ((volatile  uint32_t *) REG_CAN0_MB08_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB08_DATA3             ((volatile  uint32_t *) REG_CAN0_MB08_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB08_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB08_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB08_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB08_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB08_ID0               ((volatile  uint32_t *) REG_CAN0_MB08_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB08_ID1               ((volatile  uint32_t *) REG_CAN0_MB08_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB09_DATA0             ((volatile  uint32_t *) REG_CAN0_MB09_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB09_DATA1             ((volatile  uint32_t *) REG_CAN0_MB09_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB09_DATA2             ((volatile  uint32_t *) REG_CAN0_MB09_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB09_DATA3             ((volatile  uint32_t *) REG_CAN0_MB09_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB09_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB09_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB09_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB09_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB09_ID0               ((volatile  uint32_t *) REG_CAN0_MB09_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB09_ID1               ((volatile  uint32_t *) REG_CAN0_MB09_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB10_DATA0             ((volatile  uint32_t *) REG_CAN0_MB10_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB10_DATA1             ((volatile  uint32_t *) REG_CAN0_MB10_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB10_DATA2             ((volatile  uint32_t *) REG_CAN0_MB10_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB10_DATA3             ((volatile  uint32_t *) REG_CAN0_MB10_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB10_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB10_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB10_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB10_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB10_ID0               ((volatile  uint32_t *) REG_CAN0_MB10_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB10_ID1               ((volatile  uint32_t *) REG_CAN0_MB10_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB11_DATA0             ((volatile  uint32_t *) REG_CAN0_MB11_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB11_DATA1             ((volatile  uint32_t *) REG_CAN0_MB11_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB11_DATA2             ((volatile  uint32_t *) REG_CAN0_MB11_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB11_DATA3             ((volatile  uint32_t *) REG_CAN0_MB11_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB11_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB11_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB11_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB11_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB11_ID0               ((volatile  uint32_t *) REG_CAN0_MB11_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB11_ID1               ((volatile  uint32_t *) REG_CAN0_MB11_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB12_DATA0             ((volatile  uint32_t *) REG_CAN0_MB12_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB12_DATA1             ((volatile  uint32_t *) REG_CAN0_MB12_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB12_DATA2             ((volatile  uint32_t *) REG_CAN0_MB12_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB12_DATA3             ((volatile  uint32_t *) REG_CAN0_MB12_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB12_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB12_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB12_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB12_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB12_ID0               ((volatile  uint32_t *) REG_CAN0_MB12_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB12_ID1               ((volatile  uint32_t *) REG_CAN0_MB12_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB13_DATA0             ((volatile  uint32_t *) REG_CAN0_MB13_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB13_DATA1             ((volatile  uint32_t *) REG_CAN0_MB13_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB13_DATA2             ((volatile  uint32_t *) REG_CAN0_MB13_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB13_DATA3             ((volatile  uint32_t *) REG_CAN0_MB13_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB13_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB13_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB13_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB13_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB13_ID0               ((volatile  uint32_t *) REG_CAN0_MB13_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB13_ID1               ((volatile  uint32_t *) REG_CAN0_MB13_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB14_DATA0             ((volatile  uint32_t *) REG_CAN0_MB14_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB14_DATA1             ((volatile  uint32_t *) REG_CAN0_MB14_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB14_DATA2             ((volatile  uint32_t *) REG_CAN0_MB14_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB14_DATA3             ((volatile  uint32_t *) REG_CAN0_MB14_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB14_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB14_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB14_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB14_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB14_ID0               ((volatile  uint32_t *) REG_CAN0_MB14_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB14_ID1               ((volatile  uint32_t *) REG_CAN0_MB14_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB15_DATA0             ((volatile  uint32_t *) REG_CAN0_MB15_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB15_DATA1             ((volatile  uint32_t *) REG_CAN0_MB15_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB15_DATA2             ((volatile  uint32_t *) REG_CAN0_MB15_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB15_DATA3             ((volatile  uint32_t *) REG_CAN0_MB15_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB15_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB15_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB15_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB15_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB15_ID0               ((volatile  uint32_t *) REG_CAN0_MB15_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB15_ID1               ((volatile  uint32_t *) REG_CAN0_MB15_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB16_DATA0             ((volatile  uint32_t *) REG_CAN0_MB16_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB16_DATA1             ((volatile  uint32_t *) REG_CAN0_MB16_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB16_DATA2             ((volatile  uint32_t *) REG_CAN0_MB16_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB16_DATA3             ((volatile  uint32_t *) REG_CAN0_MB16_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB16_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB16_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB16_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB16_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB16_ID0               ((volatile  uint32_t *) REG_CAN0_MB16_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB16_ID1               ((volatile  uint32_t *) REG_CAN0_MB16_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB17_DATA0             ((volatile  uint32_t *) REG_CAN0_MB17_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB17_DATA1             ((volatile  uint32_t *) REG_CAN0_MB17_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB17_DATA2             ((volatile  uint32_t *) REG_CAN0_MB17_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB17_DATA3             ((volatile  uint32_t *) REG_CAN0_MB17_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB17_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB17_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB17_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB17_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB17_ID0               ((volatile  uint32_t *) REG_CAN0_MB17_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB17_ID1               ((volatile  uint32_t *) REG_CAN0_MB17_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB18_DATA0             ((volatile  uint32_t *) REG_CAN0_MB18_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB18_DATA1             ((volatile  uint32_t *) REG_CAN0_MB18_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB18_DATA2             ((volatile  uint32_t *) REG_CAN0_MB18_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB18_DATA3             ((volatile  uint32_t *) REG_CAN0_MB18_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB18_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB18_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB18_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB18_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB18_ID0               ((volatile  uint32_t *) REG_CAN0_MB18_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB18_ID1               ((volatile  uint32_t *) REG_CAN0_MB18_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB19_DATA0             ((volatile  uint32_t *) REG_CAN0_MB19_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB19_DATA1             ((volatile  uint32_t *) REG_CAN0_MB19_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB19_DATA2             ((volatile  uint32_t *) REG_CAN0_MB19_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB19_DATA3             ((volatile  uint32_t *) REG_CAN0_MB19_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB19_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB19_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB19_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB19_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB19_ID0               ((volatile  uint32_t *) REG_CAN0_MB19_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB19_ID1               ((volatile  uint32_t *) REG_CAN0_MB19_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB20_DATA0             ((volatile  uint32_t *) REG_CAN0_MB20_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB20_DATA1             ((volatile  uint32_t *) REG_CAN0_MB20_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB20_DATA2             ((volatile  uint32_t *) REG_CAN0_MB20_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB20_DATA3             ((volatile  uint32_t *) REG_CAN0_MB20_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB20_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB20_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB20_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB20_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB20_ID0               ((volatile  uint32_t *) REG_CAN0_MB20_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB20_ID1               ((volatile  uint32_t *) REG_CAN0_MB20_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB21_DATA0             ((volatile  uint32_t *) REG_CAN0_MB21_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB21_DATA1             ((volatile  uint32_t *) REG_CAN0_MB21_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB21_DATA2             ((volatile  uint32_t *) REG_CAN0_MB21_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB21_DATA3             ((volatile  uint32_t *) REG_CAN0_MB21_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB21_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB21_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB21_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB21_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB21_ID0               ((volatile  uint32_t *) REG_CAN0_MB21_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB21_ID1               ((volatile  uint32_t *) REG_CAN0_MB21_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB22_DATA0             ((volatile  uint32_t *) REG_CAN0_MB22_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB22_DATA1             ((volatile  uint32_t *) REG_CAN0_MB22_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB22_DATA2             ((volatile  uint32_t *) REG_CAN0_MB22_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB22_DATA3             ((volatile  uint32_t *) REG_CAN0_MB22_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB22_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB22_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB22_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB22_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB22_ID0               ((volatile  uint32_t *) REG_CAN0_MB22_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB22_ID1               ((volatile  uint32_t *) REG_CAN0_MB22_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB23_DATA0             ((volatile  uint32_t *) REG_CAN0_MB23_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB23_DATA1             ((volatile  uint32_t *) REG_CAN0_MB23_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB23_DATA2             ((volatile  uint32_t *) REG_CAN0_MB23_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB23_DATA3             ((volatile  uint32_t *) REG_CAN0_MB23_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB23_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB23_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB23_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB23_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB23_ID0               ((volatile  uint32_t *) REG_CAN0_MB23_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB23_ID1               ((volatile  uint32_t *) REG_CAN0_MB23_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB24_DATA0             ((volatile  uint32_t *) REG_CAN0_MB24_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB24_DATA1             ((volatile  uint32_t *) REG_CAN0_MB24_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB24_DATA2             ((volatile  uint32_t *) REG_CAN0_MB24_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB24_DATA3             ((volatile  uint32_t *) REG_CAN0_MB24_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB24_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB24_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB24_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB24_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB24_ID0               ((volatile  uint32_t *) REG_CAN0_MB24_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB24_ID1               ((volatile  uint32_t *) REG_CAN0_MB24_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB25_DATA0             ((volatile  uint32_t *) REG_CAN0_MB25_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB25_DATA1             ((volatile  uint32_t *) REG_CAN0_MB25_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB25_DATA2             ((volatile  uint32_t *) REG_CAN0_MB25_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB25_DATA3             ((volatile  uint32_t *) REG_CAN0_MB25_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB25_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB25_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB25_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB25_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB25_ID0               ((volatile  uint32_t *) REG_CAN0_MB25_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB25_ID1               ((volatile  uint32_t *) REG_CAN0_MB25_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB26_DATA0             ((volatile  uint32_t *) REG_CAN0_MB26_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB26_DATA1             ((volatile  uint32_t *) REG_CAN0_MB26_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB26_DATA2             ((volatile  uint32_t *) REG_CAN0_MB26_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB26_DATA3             ((volatile  uint32_t *) REG_CAN0_MB26_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB26_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB26_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB26_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB26_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB26_ID0               ((volatile  uint32_t *) REG_CAN0_MB26_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB26_ID1               ((volatile  uint32_t *) REG_CAN0_MB26_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB27_DATA0             ((volatile  uint32_t *) REG_CAN0_MB27_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB27_DATA1             ((volatile  uint32_t *) REG_CAN0_MB27_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB27_DATA2             ((volatile  uint32_t *) REG_CAN0_MB27_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB27_DATA3             ((volatile  uint32_t *) REG_CAN0_MB27_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB27_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB27_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB27_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB27_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB27_ID0               ((volatile  uint32_t *) REG_CAN0_MB27_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB27_ID1               ((volatile  uint32_t *) REG_CAN0_MB27_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB28_DATA0             ((volatile  uint32_t *) REG_CAN0_MB28_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB28_DATA1             ((volatile  uint32_t *) REG_CAN0_MB28_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB28_DATA2             ((volatile  uint32_t *) REG_CAN0_MB28_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB28_DATA3             ((volatile  uint32_t *) REG_CAN0_MB28_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB28_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB28_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB28_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB28_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB28_ID0               ((volatile  uint32_t *) REG_CAN0_MB28_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB28_ID1               ((volatile  uint32_t *) REG_CAN0_MB28_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB29_DATA0             ((volatile  uint32_t *) REG_CAN0_MB29_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB29_DATA1             ((volatile  uint32_t *) REG_CAN0_MB29_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB29_DATA2             ((volatile  uint32_t *) REG_CAN0_MB29_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB29_DATA3             ((volatile  uint32_t *) REG_CAN0_MB29_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB29_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB29_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB29_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB29_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB29_ID0               ((volatile  uint32_t *) REG_CAN0_MB29_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB29_ID1               ((volatile  uint32_t *) REG_CAN0_MB29_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB30_DATA0             ((volatile  uint32_t *) REG_CAN0_MB30_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB30_DATA1             ((volatile  uint32_t *) REG_CAN0_MB30_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB30_DATA2             ((volatile  uint32_t *) REG_CAN0_MB30_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB30_DATA3             ((volatile  uint32_t *) REG_CAN0_MB30_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB30_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB30_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB30_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB30_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB30_ID0               ((volatile  uint32_t *) REG_CAN0_MB30_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB30_ID1               ((volatile  uint32_t *) REG_CAN0_MB30_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN0_MB31_DATA0             ((volatile  uint32_t *) REG_CAN0_MB31_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN0_MB31_DATA1             ((volatile  uint32_t *) REG_CAN0_MB31_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN0_MB31_DATA2             ((volatile  uint32_t *) REG_CAN0_MB31_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN0_MB31_DATA3             ((volatile  uint32_t *) REG_CAN0_MB31_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN0_MB31_LENGTH            ((volatile  uint32_t *) REG_CAN0_MB31_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN0_MB31_TIMESTAMP         ((volatile  uint32_t *) REG_CAN0_MB31_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN0_MB31_ID0               ((volatile  uint32_t *) REG_CAN0_MB31_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN0_MB31_ID1               ((volatile  uint32_t *) REG_CAN0_MB31_ID1)               /*  Mailbox ID 1 Register */

/*  =================================================================================
 *      Controller Area Network (CAN1)
 *  ================================================================================= */
#define pREG_CAN1_MC1                    ((volatile  uint32_t *) REG_CAN1_MC1)                    /*  Mailbox Configuration 1 Register */
#define pREG_CAN1_MD1                    ((volatile  uint32_t *) REG_CAN1_MD1)                    /*  Mailbox Direction 1 Register */
#define pREG_CAN1_TRS1                   ((volatile  uint32_t *) REG_CAN1_TRS1)                   /*  Transmission Request Set 1 Register */
#define pREG_CAN1_TRR1                   ((volatile  uint32_t *) REG_CAN1_TRR1)                   /*  Transmission Request Reset 1 Register */
#define pREG_CAN1_TA1                    ((volatile  uint32_t *) REG_CAN1_TA1)                    /*  Transmission Acknowledge 1 Register */
#define pREG_CAN1_AA1                    ((volatile  uint32_t *) REG_CAN1_AA1)                    /*  Abort Acknowledge 1 Register */
#define pREG_CAN1_RMP1                   ((volatile  uint32_t *) REG_CAN1_RMP1)                   /*  Receive Message Pending 1 Register */
#define pREG_CAN1_RML1                   ((volatile  uint32_t *) REG_CAN1_RML1)                   /*  Receive Message Lost 1 Register */
#define pREG_CAN1_MBTIF1                 ((volatile  uint32_t *) REG_CAN1_MBTIF1)                 /*  Mailbox Transmit Interrupt Flag 1 Register */
#define pREG_CAN1_MBRIF1                 ((volatile  uint32_t *) REG_CAN1_MBRIF1)                 /*  Mailbox Receive Interrupt Flag 1 Register */
#define pREG_CAN1_MBIM1                  ((volatile  uint32_t *) REG_CAN1_MBIM1)                  /*  Mailbox Interrupt Mask 1 Register */
#define pREG_CAN1_RFH1                   ((volatile  uint32_t *) REG_CAN1_RFH1)                   /*  Remote Frame Handling 1 Register */
#define pREG_CAN1_OPSS1                  ((volatile  uint32_t *) REG_CAN1_OPSS1)                  /*  Overwrite Protection/Single Shot Transmission 1 Register */
#define pREG_CAN1_MC2                    ((volatile  uint32_t *) REG_CAN1_MC2)                    /*  Mailbox Configuration 2 Register */
#define pREG_CAN1_MD2                    ((volatile  uint32_t *) REG_CAN1_MD2)                    /*  Mailbox Direction 2 Register */
#define pREG_CAN1_TRS2                   ((volatile  uint32_t *) REG_CAN1_TRS2)                   /*  Transmission Request Set 2 Register */
#define pREG_CAN1_TRR2                   ((volatile  uint32_t *) REG_CAN1_TRR2)                   /*  Transmission Request Reset 2 Register */
#define pREG_CAN1_TA2                    ((volatile  uint32_t *) REG_CAN1_TA2)                    /*  Transmission Acknowledge 2 Register */
#define pREG_CAN1_AA2                    ((volatile  uint32_t *) REG_CAN1_AA2)                    /*  Abort Acknowledge 2 Register */
#define pREG_CAN1_RMP2                   ((volatile  uint32_t *) REG_CAN1_RMP2)                   /*  Receive Message Pending 2 Register */
#define pREG_CAN1_RML2                   ((volatile  uint32_t *) REG_CAN1_RML2)                   /*  Receive Message Lost 2 Register */
#define pREG_CAN1_MBTIF2                 ((volatile  uint32_t *) REG_CAN1_MBTIF2)                 /*  Mailbox Transmit Interrupt Flag 2 Register */
#define pREG_CAN1_MBRIF2                 ((volatile  uint32_t *) REG_CAN1_MBRIF2)                 /*  Mailbox Receive Interrupt Flag 2 Register */
#define pREG_CAN1_MBIM2                  ((volatile  uint32_t *) REG_CAN1_MBIM2)                  /*  Mailbox Interrupt Mask 2 Register */
#define pREG_CAN1_RFH2                   ((volatile  uint32_t *) REG_CAN1_RFH2)                   /*  Remote Frame Handling 2 Register */
#define pREG_CAN1_OPSS2                  ((volatile  uint32_t *) REG_CAN1_OPSS2)                  /*  Overwrite Protection/Single Shot Transmission 2 Register */
#define pREG_CAN1_CLK                    ((volatile  uint32_t *) REG_CAN1_CLK)                    /*  Clock Register */
#define pREG_CAN1_TIMING                 ((volatile  uint32_t *) REG_CAN1_TIMING)                 /*  Timing Register */
#define pREG_CAN1_DBG                    ((volatile  uint32_t *) REG_CAN1_DBG)                    /*  Debug Register */
#define pREG_CAN1_STAT                   ((volatile  uint32_t *) REG_CAN1_STAT)                   /*  Status Register */
#define pREG_CAN1_CEC                    ((volatile  uint32_t *) REG_CAN1_CEC)                    /*  Error Counter Register */
#define pREG_CAN1_GIS                    ((volatile  uint32_t *) REG_CAN1_GIS)                    /*  Global CAN Interrupt Status Register */
#define pREG_CAN1_GIM                    ((volatile  uint32_t *) REG_CAN1_GIM)                    /*  Global CAN Interrupt Mask Register */
#define pREG_CAN1_GIF                    ((volatile  uint32_t *) REG_CAN1_GIF)                    /*  Global CAN Interrupt Flag Register */
#define pREG_CAN1_CTL                    ((volatile  uint32_t *) REG_CAN1_CTL)                    /*  CAN Master Control Register */
#define pREG_CAN1_INT                    ((volatile  uint32_t *) REG_CAN1_INT)                    /*  Interrupt Pending Register */
#define pREG_CAN1_MBTD                   ((volatile  uint32_t *) REG_CAN1_MBTD)                   /*  Temporary Mailbox Disable Register */
#define pREG_CAN1_EWR                    ((volatile  uint32_t *) REG_CAN1_EWR)                    /*  Error Counter Warning Level Register */
#define pREG_CAN1_ESR                    ((volatile  uint32_t *) REG_CAN1_ESR)                    /*  Error Status Register */
#define pREG_CAN1_UCCNT                  ((volatile  uint32_t *) REG_CAN1_UCCNT)                  /*  Universal Counter Register */
#define pREG_CAN1_UCRC                   ((volatile  uint32_t *) REG_CAN1_UCRC)                   /*  Universal Counter Reload/Capture Register */
#define pREG_CAN1_UCCNF                  ((volatile  uint32_t *) REG_CAN1_UCCNF)                  /*  Universal Counter Configuration Mode Register */
#define pREG_CAN1_AM00L                  ((volatile  uint32_t *) REG_CAN1_AM00L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM00H                  ((volatile  uint32_t *) REG_CAN1_AM00H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM01L                  ((volatile  uint32_t *) REG_CAN1_AM01L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM01H                  ((volatile  uint32_t *) REG_CAN1_AM01H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM02L                  ((volatile  uint32_t *) REG_CAN1_AM02L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM02H                  ((volatile  uint32_t *) REG_CAN1_AM02H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM03L                  ((volatile  uint32_t *) REG_CAN1_AM03L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM03H                  ((volatile  uint32_t *) REG_CAN1_AM03H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM04L                  ((volatile  uint32_t *) REG_CAN1_AM04L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM04H                  ((volatile  uint32_t *) REG_CAN1_AM04H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM05L                  ((volatile  uint32_t *) REG_CAN1_AM05L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM05H                  ((volatile  uint32_t *) REG_CAN1_AM05H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM06L                  ((volatile  uint32_t *) REG_CAN1_AM06L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM06H                  ((volatile  uint32_t *) REG_CAN1_AM06H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM07L                  ((volatile  uint32_t *) REG_CAN1_AM07L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM07H                  ((volatile  uint32_t *) REG_CAN1_AM07H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM08L                  ((volatile  uint32_t *) REG_CAN1_AM08L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM08H                  ((volatile  uint32_t *) REG_CAN1_AM08H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM09L                  ((volatile  uint32_t *) REG_CAN1_AM09L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM09H                  ((volatile  uint32_t *) REG_CAN1_AM09H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM10L                  ((volatile  uint32_t *) REG_CAN1_AM10L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM10H                  ((volatile  uint32_t *) REG_CAN1_AM10H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM11L                  ((volatile  uint32_t *) REG_CAN1_AM11L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM11H                  ((volatile  uint32_t *) REG_CAN1_AM11H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM12L                  ((volatile  uint32_t *) REG_CAN1_AM12L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM12H                  ((volatile  uint32_t *) REG_CAN1_AM12H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM13L                  ((volatile  uint32_t *) REG_CAN1_AM13L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM13H                  ((volatile  uint32_t *) REG_CAN1_AM13H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM14L                  ((volatile  uint32_t *) REG_CAN1_AM14L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM14H                  ((volatile  uint32_t *) REG_CAN1_AM14H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM15L                  ((volatile  uint32_t *) REG_CAN1_AM15L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM15H                  ((volatile  uint32_t *) REG_CAN1_AM15H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM16L                  ((volatile  uint32_t *) REG_CAN1_AM16L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM16H                  ((volatile  uint32_t *) REG_CAN1_AM16H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM17L                  ((volatile  uint32_t *) REG_CAN1_AM17L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM17H                  ((volatile  uint32_t *) REG_CAN1_AM17H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM18L                  ((volatile  uint32_t *) REG_CAN1_AM18L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM18H                  ((volatile  uint32_t *) REG_CAN1_AM18H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM19L                  ((volatile  uint32_t *) REG_CAN1_AM19L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM19H                  ((volatile  uint32_t *) REG_CAN1_AM19H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM20L                  ((volatile  uint32_t *) REG_CAN1_AM20L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM20H                  ((volatile  uint32_t *) REG_CAN1_AM20H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM21L                  ((volatile  uint32_t *) REG_CAN1_AM21L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM21H                  ((volatile  uint32_t *) REG_CAN1_AM21H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM22L                  ((volatile  uint32_t *) REG_CAN1_AM22L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM22H                  ((volatile  uint32_t *) REG_CAN1_AM22H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM23L                  ((volatile  uint32_t *) REG_CAN1_AM23L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM23H                  ((volatile  uint32_t *) REG_CAN1_AM23H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM24L                  ((volatile  uint32_t *) REG_CAN1_AM24L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM24H                  ((volatile  uint32_t *) REG_CAN1_AM24H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM25L                  ((volatile  uint32_t *) REG_CAN1_AM25L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM25H                  ((volatile  uint32_t *) REG_CAN1_AM25H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM26L                  ((volatile  uint32_t *) REG_CAN1_AM26L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM26H                  ((volatile  uint32_t *) REG_CAN1_AM26H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM27L                  ((volatile  uint32_t *) REG_CAN1_AM27L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM27H                  ((volatile  uint32_t *) REG_CAN1_AM27H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM28L                  ((volatile  uint32_t *) REG_CAN1_AM28L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM28H                  ((volatile  uint32_t *) REG_CAN1_AM28H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM29L                  ((volatile  uint32_t *) REG_CAN1_AM29L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM29H                  ((volatile  uint32_t *) REG_CAN1_AM29H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM30L                  ((volatile  uint32_t *) REG_CAN1_AM30L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM30H                  ((volatile  uint32_t *) REG_CAN1_AM30H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_AM31L                  ((volatile  uint32_t *) REG_CAN1_AM31L)                  /*  Acceptance Mask (L) Register */
#define pREG_CAN1_AM31H                  ((volatile  uint32_t *) REG_CAN1_AM31H)                  /*  Acceptance Mask (H) Register */
#define pREG_CAN1_MB00_DATA0             ((volatile  uint32_t *) REG_CAN1_MB00_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB00_DATA1             ((volatile  uint32_t *) REG_CAN1_MB00_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB00_DATA2             ((volatile  uint32_t *) REG_CAN1_MB00_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB00_DATA3             ((volatile  uint32_t *) REG_CAN1_MB00_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB00_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB00_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB00_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB00_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB00_ID0               ((volatile  uint32_t *) REG_CAN1_MB00_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB00_ID1               ((volatile  uint32_t *) REG_CAN1_MB00_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB01_DATA0             ((volatile  uint32_t *) REG_CAN1_MB01_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB01_DATA1             ((volatile  uint32_t *) REG_CAN1_MB01_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB01_DATA2             ((volatile  uint32_t *) REG_CAN1_MB01_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB01_DATA3             ((volatile  uint32_t *) REG_CAN1_MB01_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB01_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB01_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB01_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB01_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB01_ID0               ((volatile  uint32_t *) REG_CAN1_MB01_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB01_ID1               ((volatile  uint32_t *) REG_CAN1_MB01_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB02_DATA0             ((volatile  uint32_t *) REG_CAN1_MB02_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB02_DATA1             ((volatile  uint32_t *) REG_CAN1_MB02_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB02_DATA2             ((volatile  uint32_t *) REG_CAN1_MB02_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB02_DATA3             ((volatile  uint32_t *) REG_CAN1_MB02_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB02_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB02_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB02_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB02_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB02_ID0               ((volatile  uint32_t *) REG_CAN1_MB02_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB02_ID1               ((volatile  uint32_t *) REG_CAN1_MB02_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB03_DATA0             ((volatile  uint32_t *) REG_CAN1_MB03_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB03_DATA1             ((volatile  uint32_t *) REG_CAN1_MB03_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB03_DATA2             ((volatile  uint32_t *) REG_CAN1_MB03_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB03_DATA3             ((volatile  uint32_t *) REG_CAN1_MB03_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB03_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB03_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB03_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB03_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB03_ID0               ((volatile  uint32_t *) REG_CAN1_MB03_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB03_ID1               ((volatile  uint32_t *) REG_CAN1_MB03_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB04_DATA0             ((volatile  uint32_t *) REG_CAN1_MB04_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB04_DATA1             ((volatile  uint32_t *) REG_CAN1_MB04_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB04_DATA2             ((volatile  uint32_t *) REG_CAN1_MB04_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB04_DATA3             ((volatile  uint32_t *) REG_CAN1_MB04_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB04_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB04_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB04_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB04_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB04_ID0               ((volatile  uint32_t *) REG_CAN1_MB04_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB04_ID1               ((volatile  uint32_t *) REG_CAN1_MB04_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB05_DATA0             ((volatile  uint32_t *) REG_CAN1_MB05_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB05_DATA1             ((volatile  uint32_t *) REG_CAN1_MB05_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB05_DATA2             ((volatile  uint32_t *) REG_CAN1_MB05_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB05_DATA3             ((volatile  uint32_t *) REG_CAN1_MB05_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB05_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB05_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB05_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB05_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB05_ID0               ((volatile  uint32_t *) REG_CAN1_MB05_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB05_ID1               ((volatile  uint32_t *) REG_CAN1_MB05_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB06_DATA0             ((volatile  uint32_t *) REG_CAN1_MB06_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB06_DATA1             ((volatile  uint32_t *) REG_CAN1_MB06_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB06_DATA2             ((volatile  uint32_t *) REG_CAN1_MB06_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB06_DATA3             ((volatile  uint32_t *) REG_CAN1_MB06_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB06_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB06_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB06_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB06_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB06_ID0               ((volatile  uint32_t *) REG_CAN1_MB06_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB06_ID1               ((volatile  uint32_t *) REG_CAN1_MB06_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB07_DATA0             ((volatile  uint32_t *) REG_CAN1_MB07_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB07_DATA1             ((volatile  uint32_t *) REG_CAN1_MB07_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB07_DATA2             ((volatile  uint32_t *) REG_CAN1_MB07_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB07_DATA3             ((volatile  uint32_t *) REG_CAN1_MB07_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB07_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB07_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB07_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB07_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB07_ID0               ((volatile  uint32_t *) REG_CAN1_MB07_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB07_ID1               ((volatile  uint32_t *) REG_CAN1_MB07_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB08_DATA0             ((volatile  uint32_t *) REG_CAN1_MB08_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB08_DATA1             ((volatile  uint32_t *) REG_CAN1_MB08_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB08_DATA2             ((volatile  uint32_t *) REG_CAN1_MB08_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB08_DATA3             ((volatile  uint32_t *) REG_CAN1_MB08_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB08_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB08_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB08_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB08_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB08_ID0               ((volatile  uint32_t *) REG_CAN1_MB08_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB08_ID1               ((volatile  uint32_t *) REG_CAN1_MB08_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB09_DATA0             ((volatile  uint32_t *) REG_CAN1_MB09_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB09_DATA1             ((volatile  uint32_t *) REG_CAN1_MB09_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB09_DATA2             ((volatile  uint32_t *) REG_CAN1_MB09_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB09_DATA3             ((volatile  uint32_t *) REG_CAN1_MB09_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB09_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB09_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB09_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB09_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB09_ID0               ((volatile  uint32_t *) REG_CAN1_MB09_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB09_ID1               ((volatile  uint32_t *) REG_CAN1_MB09_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB10_DATA0             ((volatile  uint32_t *) REG_CAN1_MB10_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB10_DATA1             ((volatile  uint32_t *) REG_CAN1_MB10_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB10_DATA2             ((volatile  uint32_t *) REG_CAN1_MB10_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB10_DATA3             ((volatile  uint32_t *) REG_CAN1_MB10_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB10_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB10_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB10_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB10_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB10_ID0               ((volatile  uint32_t *) REG_CAN1_MB10_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB10_ID1               ((volatile  uint32_t *) REG_CAN1_MB10_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB11_DATA0             ((volatile  uint32_t *) REG_CAN1_MB11_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB11_DATA1             ((volatile  uint32_t *) REG_CAN1_MB11_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB11_DATA2             ((volatile  uint32_t *) REG_CAN1_MB11_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB11_DATA3             ((volatile  uint32_t *) REG_CAN1_MB11_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB11_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB11_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB11_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB11_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB11_ID0               ((volatile  uint32_t *) REG_CAN1_MB11_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB11_ID1               ((volatile  uint32_t *) REG_CAN1_MB11_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB12_DATA0             ((volatile  uint32_t *) REG_CAN1_MB12_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB12_DATA1             ((volatile  uint32_t *) REG_CAN1_MB12_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB12_DATA2             ((volatile  uint32_t *) REG_CAN1_MB12_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB12_DATA3             ((volatile  uint32_t *) REG_CAN1_MB12_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB12_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB12_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB12_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB12_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB12_ID0               ((volatile  uint32_t *) REG_CAN1_MB12_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB12_ID1               ((volatile  uint32_t *) REG_CAN1_MB12_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB13_DATA0             ((volatile  uint32_t *) REG_CAN1_MB13_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB13_DATA1             ((volatile  uint32_t *) REG_CAN1_MB13_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB13_DATA2             ((volatile  uint32_t *) REG_CAN1_MB13_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB13_DATA3             ((volatile  uint32_t *) REG_CAN1_MB13_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB13_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB13_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB13_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB13_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB13_ID0               ((volatile  uint32_t *) REG_CAN1_MB13_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB13_ID1               ((volatile  uint32_t *) REG_CAN1_MB13_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB14_DATA0             ((volatile  uint32_t *) REG_CAN1_MB14_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB14_DATA1             ((volatile  uint32_t *) REG_CAN1_MB14_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB14_DATA2             ((volatile  uint32_t *) REG_CAN1_MB14_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB14_DATA3             ((volatile  uint32_t *) REG_CAN1_MB14_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB14_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB14_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB14_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB14_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB14_ID0               ((volatile  uint32_t *) REG_CAN1_MB14_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB14_ID1               ((volatile  uint32_t *) REG_CAN1_MB14_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB15_DATA0             ((volatile  uint32_t *) REG_CAN1_MB15_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB15_DATA1             ((volatile  uint32_t *) REG_CAN1_MB15_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB15_DATA2             ((volatile  uint32_t *) REG_CAN1_MB15_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB15_DATA3             ((volatile  uint32_t *) REG_CAN1_MB15_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB15_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB15_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB15_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB15_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB15_ID0               ((volatile  uint32_t *) REG_CAN1_MB15_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB15_ID1               ((volatile  uint32_t *) REG_CAN1_MB15_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB16_DATA0             ((volatile  uint32_t *) REG_CAN1_MB16_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB16_DATA1             ((volatile  uint32_t *) REG_CAN1_MB16_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB16_DATA2             ((volatile  uint32_t *) REG_CAN1_MB16_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB16_DATA3             ((volatile  uint32_t *) REG_CAN1_MB16_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB16_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB16_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB16_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB16_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB16_ID0               ((volatile  uint32_t *) REG_CAN1_MB16_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB16_ID1               ((volatile  uint32_t *) REG_CAN1_MB16_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB17_DATA0             ((volatile  uint32_t *) REG_CAN1_MB17_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB17_DATA1             ((volatile  uint32_t *) REG_CAN1_MB17_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB17_DATA2             ((volatile  uint32_t *) REG_CAN1_MB17_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB17_DATA3             ((volatile  uint32_t *) REG_CAN1_MB17_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB17_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB17_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB17_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB17_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB17_ID0               ((volatile  uint32_t *) REG_CAN1_MB17_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB17_ID1               ((volatile  uint32_t *) REG_CAN1_MB17_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB18_DATA0             ((volatile  uint32_t *) REG_CAN1_MB18_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB18_DATA1             ((volatile  uint32_t *) REG_CAN1_MB18_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB18_DATA2             ((volatile  uint32_t *) REG_CAN1_MB18_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB18_DATA3             ((volatile  uint32_t *) REG_CAN1_MB18_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB18_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB18_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB18_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB18_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB18_ID0               ((volatile  uint32_t *) REG_CAN1_MB18_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB18_ID1               ((volatile  uint32_t *) REG_CAN1_MB18_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB19_DATA0             ((volatile  uint32_t *) REG_CAN1_MB19_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB19_DATA1             ((volatile  uint32_t *) REG_CAN1_MB19_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB19_DATA2             ((volatile  uint32_t *) REG_CAN1_MB19_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB19_DATA3             ((volatile  uint32_t *) REG_CAN1_MB19_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB19_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB19_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB19_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB19_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB19_ID0               ((volatile  uint32_t *) REG_CAN1_MB19_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB19_ID1               ((volatile  uint32_t *) REG_CAN1_MB19_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB20_DATA0             ((volatile  uint32_t *) REG_CAN1_MB20_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB20_DATA1             ((volatile  uint32_t *) REG_CAN1_MB20_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB20_DATA2             ((volatile  uint32_t *) REG_CAN1_MB20_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB20_DATA3             ((volatile  uint32_t *) REG_CAN1_MB20_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB20_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB20_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB20_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB20_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB20_ID0               ((volatile  uint32_t *) REG_CAN1_MB20_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB20_ID1               ((volatile  uint32_t *) REG_CAN1_MB20_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB21_DATA0             ((volatile  uint32_t *) REG_CAN1_MB21_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB21_DATA1             ((volatile  uint32_t *) REG_CAN1_MB21_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB21_DATA2             ((volatile  uint32_t *) REG_CAN1_MB21_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB21_DATA3             ((volatile  uint32_t *) REG_CAN1_MB21_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB21_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB21_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB21_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB21_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB21_ID0               ((volatile  uint32_t *) REG_CAN1_MB21_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB21_ID1               ((volatile  uint32_t *) REG_CAN1_MB21_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB22_DATA0             ((volatile  uint32_t *) REG_CAN1_MB22_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB22_DATA1             ((volatile  uint32_t *) REG_CAN1_MB22_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB22_DATA2             ((volatile  uint32_t *) REG_CAN1_MB22_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB22_DATA3             ((volatile  uint32_t *) REG_CAN1_MB22_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB22_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB22_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB22_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB22_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB22_ID0               ((volatile  uint32_t *) REG_CAN1_MB22_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB22_ID1               ((volatile  uint32_t *) REG_CAN1_MB22_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB23_DATA0             ((volatile  uint32_t *) REG_CAN1_MB23_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB23_DATA1             ((volatile  uint32_t *) REG_CAN1_MB23_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB23_DATA2             ((volatile  uint32_t *) REG_CAN1_MB23_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB23_DATA3             ((volatile  uint32_t *) REG_CAN1_MB23_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB23_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB23_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB23_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB23_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB23_ID0               ((volatile  uint32_t *) REG_CAN1_MB23_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB23_ID1               ((volatile  uint32_t *) REG_CAN1_MB23_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB24_DATA0             ((volatile  uint32_t *) REG_CAN1_MB24_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB24_DATA1             ((volatile  uint32_t *) REG_CAN1_MB24_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB24_DATA2             ((volatile  uint32_t *) REG_CAN1_MB24_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB24_DATA3             ((volatile  uint32_t *) REG_CAN1_MB24_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB24_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB24_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB24_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB24_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB24_ID0               ((volatile  uint32_t *) REG_CAN1_MB24_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB24_ID1               ((volatile  uint32_t *) REG_CAN1_MB24_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB25_DATA0             ((volatile  uint32_t *) REG_CAN1_MB25_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB25_DATA1             ((volatile  uint32_t *) REG_CAN1_MB25_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB25_DATA2             ((volatile  uint32_t *) REG_CAN1_MB25_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB25_DATA3             ((volatile  uint32_t *) REG_CAN1_MB25_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB25_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB25_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB25_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB25_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB25_ID0               ((volatile  uint32_t *) REG_CAN1_MB25_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB25_ID1               ((volatile  uint32_t *) REG_CAN1_MB25_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB26_DATA0             ((volatile  uint32_t *) REG_CAN1_MB26_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB26_DATA1             ((volatile  uint32_t *) REG_CAN1_MB26_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB26_DATA2             ((volatile  uint32_t *) REG_CAN1_MB26_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB26_DATA3             ((volatile  uint32_t *) REG_CAN1_MB26_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB26_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB26_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB26_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB26_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB26_ID0               ((volatile  uint32_t *) REG_CAN1_MB26_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB26_ID1               ((volatile  uint32_t *) REG_CAN1_MB26_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB27_DATA0             ((volatile  uint32_t *) REG_CAN1_MB27_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB27_DATA1             ((volatile  uint32_t *) REG_CAN1_MB27_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB27_DATA2             ((volatile  uint32_t *) REG_CAN1_MB27_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB27_DATA3             ((volatile  uint32_t *) REG_CAN1_MB27_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB27_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB27_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB27_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB27_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB27_ID0               ((volatile  uint32_t *) REG_CAN1_MB27_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB27_ID1               ((volatile  uint32_t *) REG_CAN1_MB27_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB28_DATA0             ((volatile  uint32_t *) REG_CAN1_MB28_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB28_DATA1             ((volatile  uint32_t *) REG_CAN1_MB28_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB28_DATA2             ((volatile  uint32_t *) REG_CAN1_MB28_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB28_DATA3             ((volatile  uint32_t *) REG_CAN1_MB28_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB28_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB28_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB28_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB28_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB28_ID0               ((volatile  uint32_t *) REG_CAN1_MB28_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB28_ID1               ((volatile  uint32_t *) REG_CAN1_MB28_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB29_DATA0             ((volatile  uint32_t *) REG_CAN1_MB29_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB29_DATA1             ((volatile  uint32_t *) REG_CAN1_MB29_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB29_DATA2             ((volatile  uint32_t *) REG_CAN1_MB29_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB29_DATA3             ((volatile  uint32_t *) REG_CAN1_MB29_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB29_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB29_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB29_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB29_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB29_ID0               ((volatile  uint32_t *) REG_CAN1_MB29_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB29_ID1               ((volatile  uint32_t *) REG_CAN1_MB29_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB30_DATA0             ((volatile  uint32_t *) REG_CAN1_MB30_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB30_DATA1             ((volatile  uint32_t *) REG_CAN1_MB30_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB30_DATA2             ((volatile  uint32_t *) REG_CAN1_MB30_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB30_DATA3             ((volatile  uint32_t *) REG_CAN1_MB30_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB30_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB30_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB30_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB30_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB30_ID0               ((volatile  uint32_t *) REG_CAN1_MB30_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB30_ID1               ((volatile  uint32_t *) REG_CAN1_MB30_ID1)               /*  Mailbox ID 1 Register */
#define pREG_CAN1_MB31_DATA0             ((volatile  uint32_t *) REG_CAN1_MB31_DATA0)             /*  Mailbox Word 0 Register */
#define pREG_CAN1_MB31_DATA1             ((volatile  uint32_t *) REG_CAN1_MB31_DATA1)             /*  Mailbox Word 1 Register */
#define pREG_CAN1_MB31_DATA2             ((volatile  uint32_t *) REG_CAN1_MB31_DATA2)             /*  Mailbox Word 2 Register */
#define pREG_CAN1_MB31_DATA3             ((volatile  uint32_t *) REG_CAN1_MB31_DATA3)             /*  Mailbox Word 3 Register */
#define pREG_CAN1_MB31_LENGTH            ((volatile  uint32_t *) REG_CAN1_MB31_LENGTH)            /*  Mailbox Length Register */
#define pREG_CAN1_MB31_TIMESTAMP         ((volatile  uint32_t *) REG_CAN1_MB31_TIMESTAMP)         /*  Mailbox Timestamp Register */
#define pREG_CAN1_MB31_ID0               ((volatile  uint32_t *) REG_CAN1_MB31_ID0)               /*  Mailbox ID 0 Register */
#define pREG_CAN1_MB31_ID1               ((volatile  uint32_t *) REG_CAN1_MB31_ID1)               /*  Mailbox ID 1 Register */

/*  =================================================================================
 *      Capture Timer (CPTMR0)
 *  ================================================================================= */
#define pREG_CPTMR0_RUN                  ((volatile  uint32_t *) REG_CPTMR0_RUN)                  /*  Run */
#define pREG_CPTMR0_RUN_SET              ((volatile  uint32_t *) REG_CPTMR0_RUN_SET)              /*  Run Set */
#define pREG_CPTMR0_RUN_CLR              ((volatile  uint32_t *) REG_CPTMR0_RUN_CLR)              /*  Run Clear */
#define pREG_CPTMR0_DATA_IMSK            ((volatile  uint32_t *) REG_CPTMR0_DATA_IMSK)            /*  Data Imask */
#define pREG_CPTMR0_DATA_IMSK_SET        ((volatile  uint32_t *) REG_CPTMR0_DATA_IMSK_SET)        /*  Data Imask Set */
#define pREG_CPTMR0_DATA_IMSK_CLR        ((volatile  uint32_t *) REG_CPTMR0_DATA_IMSK_CLR)        /*  Data Imask Clear */
#define pREG_CPTMR0_STAT_IMSK            ((volatile  uint32_t *) REG_CPTMR0_STAT_IMSK)            /*  Status Imask */
#define pREG_CPTMR0_STAT_IMSK_SET        ((volatile  uint32_t *) REG_CPTMR0_STAT_IMSK_SET)        /*  Status Imask Set */
#define pREG_CPTMR0_STAT_IMSK_CLR        ((volatile  uint32_t *) REG_CPTMR0_STAT_IMSK_CLR)        /*  Status Imask Clear */
#define pREG_CPTMR0_DATA_ILAT            ((volatile  uint32_t *) REG_CPTMR0_DATA_ILAT)            /*  Data Ilat */
#define pREG_CPTMR0_STAT_ILAT            ((volatile  uint32_t *) REG_CPTMR0_STAT_ILAT)            /*  Status Ilat */
#define pREG_CPTMR0_CFG0                 ((volatile  uint32_t *) REG_CPTMR0_CFG0)                 /*  Configuration */
#define pREG_CPTMR0_CNT0                 ((volatile  uint32_t *) REG_CPTMR0_CNT0)                 /*  Counter */
#define pREG_CPTMR0_TON0                 ((volatile  uint32_t *) REG_CPTMR0_TON0)                 /*  On Time Capture */
#define pREG_CPTMR0_CFG1                 ((volatile  uint32_t *) REG_CPTMR0_CFG1)                 /*  Configuration */
#define pREG_CPTMR0_CNT1                 ((volatile  uint32_t *) REG_CPTMR0_CNT1)                 /*  Counter */
#define pREG_CPTMR0_TON1                 ((volatile  uint32_t *) REG_CPTMR0_TON1)                 /*  On Time Capture */
#define pREG_CPTMR0_CFG2                 ((volatile  uint32_t *) REG_CPTMR0_CFG2)                 /*  Configuration */
#define pREG_CPTMR0_CNT2                 ((volatile  uint32_t *) REG_CPTMR0_CNT2)                 /*  Counter */
#define pREG_CPTMR0_TON2                 ((volatile  uint32_t *) REG_CPTMR0_TON2)                 /*  On Time Capture */

/*  =================================================================================
 *      Pulse-Width Modulator (PWM0)
 *  ================================================================================= */
#define pREG_PWM0_CTL                    ((volatile  uint32_t *) REG_PWM0_CTL)                    /*  Control Register */
#define pREG_PWM0_CHANCFG                ((volatile  uint32_t *) REG_PWM0_CHANCFG)                /*  Channel Config Register */
#define pREG_PWM0_TRIPCFG                ((volatile  uint32_t *) REG_PWM0_TRIPCFG)                /*  Trip Config Register */
#define pREG_PWM0_STAT                   ((volatile  uint32_t *) REG_PWM0_STAT)                   /*  Status Register */
#define pREG_PWM0_IMSK                   ((volatile  uint32_t *) REG_PWM0_IMSK)                   /*  Interrupt Mask Register */
#define pREG_PWM0_ILAT                   ((volatile  uint32_t *) REG_PWM0_ILAT)                   /*  Interrupt Latch Register */
#define pREG_PWM0_CHOPCFG                ((volatile  uint32_t *) REG_PWM0_CHOPCFG)                /*  Chop Configuration Register */
#define pREG_PWM0_SYNC_WID               ((volatile  uint32_t *) REG_PWM0_SYNC_WID)               /*  Sync Pulse Width Register */
#define pREG_PWM0_TM0                    ((volatile  uint32_t *) REG_PWM0_TM0)                    /*  Timer 0 Period Register */
#define pREG_PWM0_TM1                    ((volatile  uint32_t *) REG_PWM0_TM1)                    /*  Timer 1 Period Register */
#define pREG_PWM0_TM2                    ((volatile  uint32_t *) REG_PWM0_TM2)                    /*  Timer 2 Period Register */
#define pREG_PWM0_TM3                    ((volatile  uint32_t *) REG_PWM0_TM3)                    /*  Timer 3 Period Register */
#define pREG_PWM0_TM4                    ((volatile  uint32_t *) REG_PWM0_TM4)                    /*  Timer 4 Period Register */
#define pREG_PWM0_DLYA                   ((volatile  uint32_t *) REG_PWM0_DLYA)                   /*  Channel A Delay Register */
#define pREG_PWM0_DLYB                   ((volatile  uint32_t *) REG_PWM0_DLYB)                   /*  Channel B Delay Register */
#define pREG_PWM0_DLYC                   ((volatile  uint32_t *) REG_PWM0_DLYC)                   /*  Channel C Delay Register */
#define pREG_PWM0_DLYD                   ((volatile  uint32_t *) REG_PWM0_DLYD)                   /*  Channel D Delay Register */
#define pREG_PWM0_ACTL                   ((volatile  uint32_t *) REG_PWM0_ACTL)                   /*  Channel A Control Register */
#define pREG_PWM0_AH0                    ((volatile  uint32_t *) REG_PWM0_AH0)                    /*  Channel A-High Duty-0 Register */
#define pREG_PWM0_AH1                    ((volatile  uint32_t *) REG_PWM0_AH1)                    /*  Channel A-High Duty-1 Register */
#define pREG_PWM0_AH0_HP                 ((volatile  uint32_t *) REG_PWM0_AH0_HP)                 /*  Channel A-High Heightened-Precision Duty-0 Register */
#define pREG_PWM0_AH1_HP                 ((volatile  uint32_t *) REG_PWM0_AH1_HP)                 /*  Channel A-High Heightened-Precision Duty-1 Register */
#define pREG_PWM0_AL0                    ((volatile  uint32_t *) REG_PWM0_AL0)                    /*  Channel A-Low Duty-0 Register */
#define pREG_PWM0_AL1                    ((volatile  uint32_t *) REG_PWM0_AL1)                    /*  Channel A-Low Duty-1 Register */
#define pREG_PWM0_AL0_HP                 ((volatile  uint32_t *) REG_PWM0_AL0_HP)                 /*  Channel A-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM0_AL1_HP                 ((volatile  uint32_t *) REG_PWM0_AL1_HP)                 /*  Channel A-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM0_BCTL                   ((volatile  uint32_t *) REG_PWM0_BCTL)                   /*  Channel B Control Register */
#define pREG_PWM0_BH0                    ((volatile  uint32_t *) REG_PWM0_BH0)                    /*  Channel B-High Duty-0 Register */
#define pREG_PWM0_BH1                    ((volatile  uint32_t *) REG_PWM0_BH1)                    /*  Channel B-High Duty-1 Register */
#define pREG_PWM0_BH0_HP                 ((volatile  uint32_t *) REG_PWM0_BH0_HP)                 /*  Channel B-High Heightened-Precision Duty-0 Register */
#define pREG_PWM0_BH1_HP                 ((volatile  uint32_t *) REG_PWM0_BH1_HP)                 /*  Channel B-High Heightened-Precision Duty-1 Register */
#define pREG_PWM0_BL0                    ((volatile  uint32_t *) REG_PWM0_BL0)                    /*  Channel B-Low Duty-0 Register */
#define pREG_PWM0_BL1                    ((volatile  uint32_t *) REG_PWM0_BL1)                    /*  Channel B-Low Duty-1 Register */
#define pREG_PWM0_BL0_HP                 ((volatile  uint32_t *) REG_PWM0_BL0_HP)                 /*  Channel B-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM0_BL1_HP                 ((volatile  uint32_t *) REG_PWM0_BL1_HP)                 /*  Channel B-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM0_CCTL                   ((volatile  uint32_t *) REG_PWM0_CCTL)                   /*  Channel C Control Register */
#define pREG_PWM0_CH0                    ((volatile  uint32_t *) REG_PWM0_CH0)                    /*  Channel C-High Pulse Duty Register 0 */
#define pREG_PWM0_CH1                    ((volatile  uint32_t *) REG_PWM0_CH1)                    /*  Channel C-High Pulse Duty Register 1 */
#define pREG_PWM0_CH0_HP                 ((volatile  uint32_t *) REG_PWM0_CH0_HP)                 /*  Channel C-High Pulse Heightened-Precision Duty Register 0 */
#define pREG_PWM0_CH1_HP                 ((volatile  uint32_t *) REG_PWM0_CH1_HP)                 /*  Channel C-High Pulse Heightened-Precision Duty Register 1 */
#define pREG_PWM0_CL0                    ((volatile  uint32_t *) REG_PWM0_CL0)                    /*  Channel C-Low Pulse Duty Register 0 */
#define pREG_PWM0_CL1                    ((volatile  uint32_t *) REG_PWM0_CL1)                    /*  Channel C-Low Duty-1 Register */
#define pREG_PWM0_CL0_HP                 ((volatile  uint32_t *) REG_PWM0_CL0_HP)                 /*  Channel C-Low Pulse Duty Register 1 */
#define pREG_PWM0_CL1_HP                 ((volatile  uint32_t *) REG_PWM0_CL1_HP)                 /*  Channel C-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM0_DCTL                   ((volatile  uint32_t *) REG_PWM0_DCTL)                   /*  Channel D Control Register */
#define pREG_PWM0_DH0                    ((volatile  uint32_t *) REG_PWM0_DH0)                    /*  Channel D-High Duty-0 Register */
#define pREG_PWM0_DH1                    ((volatile  uint32_t *) REG_PWM0_DH1)                    /*  Channel D-High Pulse Duty Register 1 */
#define pREG_PWM0_DH0_HP                 ((volatile  uint32_t *) REG_PWM0_DH0_HP)                 /*  Channel D-High Pulse Heightened-Precision Duty Register 0 */
#define pREG_PWM0_DH1_HP                 ((volatile  uint32_t *) REG_PWM0_DH1_HP)                 /*  Channel D High Pulse Heightened-Precision Duty Register 1 */
#define pREG_PWM0_DL0                    ((volatile  uint32_t *) REG_PWM0_DL0)                    /*  Channel D-Low Pulse Duty Register 0 */
#define pREG_PWM0_DL1                    ((volatile  uint32_t *) REG_PWM0_DL1)                    /*  Channel D-Low Pulse Duty Register 1 */
#define pREG_PWM0_DL0_HP                 ((volatile  uint32_t *) REG_PWM0_DL0_HP)                 /*  Channel D-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM0_DL1_HP                 ((volatile  uint32_t *) REG_PWM0_DL1_HP)                 /*  Channel D-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM0_AH_DUTY0               ((volatile  uint32_t *) REG_PWM0_AH_DUTY0)               /*  Channel A-High Full Duty0 Register */
#define pREG_PWM0_AH_DUTY1               ((volatile  uint32_t *) REG_PWM0_AH_DUTY1)               /*  Channel A-High Full Duty1 Register */
#define pREG_PWM0_AL_DUTY0               ((volatile  uint32_t *) REG_PWM0_AL_DUTY0)               /*  Channel A-Low Full Duty0 Register */
#define pREG_PWM0_AL_DUTY1               ((volatile  uint32_t *) REG_PWM0_AL_DUTY1)               /*  Channel A-Low Full Duty1 Register */
#define pREG_PWM0_BH_DUTY0               ((volatile  uint32_t *) REG_PWM0_BH_DUTY0)               /*  Channel B-High Full Duty0 Register */
#define pREG_PWM0_BH_DUTY1               ((volatile  uint32_t *) REG_PWM0_BH_DUTY1)               /*  Channel B-High Full Duty1 Register */
#define pREG_PWM0_BL_DUTY0               ((volatile  uint32_t *) REG_PWM0_BL_DUTY0)               /*  Channel B-Low Full Duty0 Register */
#define pREG_PWM0_BL_DUTY1               ((volatile  uint32_t *) REG_PWM0_BL_DUTY1)               /*  Channel B-Low Full Duty1 Register */
#define pREG_PWM0_CH_DUTY0               ((volatile  uint32_t *) REG_PWM0_CH_DUTY0)               /*  Channel C-High Full Duty0 Register */
#define pREG_PWM0_CH_DUTY1               ((volatile  uint32_t *) REG_PWM0_CH_DUTY1)               /*  Channel C-High Full Duty1 Register */
#define pREG_PWM0_CL_DUTY0               ((volatile  uint32_t *) REG_PWM0_CL_DUTY0)               /*  Channel C-Low Full Duty0 Register */
#define pREG_PWM0_CL_DUTY1               ((volatile  uint32_t *) REG_PWM0_CL_DUTY1)               /*  Channel C-Low Full Duty1 Register */
#define pREG_PWM0_DH_DUTY0               ((volatile  uint32_t *) REG_PWM0_DH_DUTY0)               /*  Channel D-High Full Duty0 Register */
#define pREG_PWM0_DH_DUTY1               ((volatile  uint32_t *) REG_PWM0_DH_DUTY1)               /*  Channel D-High Full Duty1 Register */
#define pREG_PWM0_DL_DUTY0               ((volatile  uint32_t *) REG_PWM0_DL_DUTY0)               /*  Channel D-Low Full Duty0 Register */
#define pREG_PWM0_DL_DUTY1               ((volatile  uint32_t *) REG_PWM0_DL_DUTY1)               /*  Channel D-Low Full Duty1 Register */
#define pREG_PWM0_CHA_DT                 ((volatile  uint32_t *) REG_PWM0_CHA_DT)                 /*  Channel A Dead-time register */
#define pREG_PWM0_CHB_DT                 ((volatile  uint32_t *) REG_PWM0_CHB_DT)                 /*  Channel B Dead-time register */
#define pREG_PWM0_CHC_DT                 ((volatile  uint32_t *) REG_PWM0_CHC_DT)                 /*  Channel C Dead-time register */
#define pREG_PWM0_CHD_DT                 ((volatile  uint32_t *) REG_PWM0_CHD_DT)                 /*  Channel D Dead-time register */
#define pREG_PWM0_SWTRIP                 ((volatile  uint32_t *) REG_PWM0_SWTRIP)                 /*  Software Trip Register */
#define pREG_PWM0_TRIP_POL               ((volatile  uint32_t *) REG_PWM0_TRIP_POL)               /*  Trip Polarity Register */

/*  =================================================================================
 *      Pulse-Width Modulator (PWM1)
 *  ================================================================================= */
#define pREG_PWM1_CTL                    ((volatile  uint32_t *) REG_PWM1_CTL)                    /*  Control Register */
#define pREG_PWM1_CHANCFG                ((volatile  uint32_t *) REG_PWM1_CHANCFG)                /*  Channel Config Register */
#define pREG_PWM1_TRIPCFG                ((volatile  uint32_t *) REG_PWM1_TRIPCFG)                /*  Trip Config Register */
#define pREG_PWM1_STAT                   ((volatile  uint32_t *) REG_PWM1_STAT)                   /*  Status Register */
#define pREG_PWM1_IMSK                   ((volatile  uint32_t *) REG_PWM1_IMSK)                   /*  Interrupt Mask Register */
#define pREG_PWM1_ILAT                   ((volatile  uint32_t *) REG_PWM1_ILAT)                   /*  Interrupt Latch Register */
#define pREG_PWM1_CHOPCFG                ((volatile  uint32_t *) REG_PWM1_CHOPCFG)                /*  Chop Configuration Register */
#define pREG_PWM1_SYNC_WID               ((volatile  uint32_t *) REG_PWM1_SYNC_WID)               /*  Sync Pulse Width Register */
#define pREG_PWM1_TM0                    ((volatile  uint32_t *) REG_PWM1_TM0)                    /*  Timer 0 Period Register */
#define pREG_PWM1_TM1                    ((volatile  uint32_t *) REG_PWM1_TM1)                    /*  Timer 1 Period Register */
#define pREG_PWM1_TM2                    ((volatile  uint32_t *) REG_PWM1_TM2)                    /*  Timer 2 Period Register */
#define pREG_PWM1_TM3                    ((volatile  uint32_t *) REG_PWM1_TM3)                    /*  Timer 3 Period Register */
#define pREG_PWM1_TM4                    ((volatile  uint32_t *) REG_PWM1_TM4)                    /*  Timer 4 Period Register */
#define pREG_PWM1_DLYA                   ((volatile  uint32_t *) REG_PWM1_DLYA)                   /*  Channel A Delay Register */
#define pREG_PWM1_DLYB                   ((volatile  uint32_t *) REG_PWM1_DLYB)                   /*  Channel B Delay Register */
#define pREG_PWM1_DLYC                   ((volatile  uint32_t *) REG_PWM1_DLYC)                   /*  Channel C Delay Register */
#define pREG_PWM1_DLYD                   ((volatile  uint32_t *) REG_PWM1_DLYD)                   /*  Channel D Delay Register */
#define pREG_PWM1_ACTL                   ((volatile  uint32_t *) REG_PWM1_ACTL)                   /*  Channel A Control Register */
#define pREG_PWM1_AH0                    ((volatile  uint32_t *) REG_PWM1_AH0)                    /*  Channel A-High Duty-0 Register */
#define pREG_PWM1_AH1                    ((volatile  uint32_t *) REG_PWM1_AH1)                    /*  Channel A-High Duty-1 Register */
#define pREG_PWM1_AH0_HP                 ((volatile  uint32_t *) REG_PWM1_AH0_HP)                 /*  Channel A-High Heightened-Precision Duty-0 Register */
#define pREG_PWM1_AH1_HP                 ((volatile  uint32_t *) REG_PWM1_AH1_HP)                 /*  Channel A-High Heightened-Precision Duty-1 Register */
#define pREG_PWM1_AL0                    ((volatile  uint32_t *) REG_PWM1_AL0)                    /*  Channel A-Low Duty-0 Register */
#define pREG_PWM1_AL1                    ((volatile  uint32_t *) REG_PWM1_AL1)                    /*  Channel A-Low Duty-1 Register */
#define pREG_PWM1_AL0_HP                 ((volatile  uint32_t *) REG_PWM1_AL0_HP)                 /*  Channel A-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM1_AL1_HP                 ((volatile  uint32_t *) REG_PWM1_AL1_HP)                 /*  Channel A-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM1_BCTL                   ((volatile  uint32_t *) REG_PWM1_BCTL)                   /*  Channel B Control Register */
#define pREG_PWM1_BH0                    ((volatile  uint32_t *) REG_PWM1_BH0)                    /*  Channel B-High Duty-0 Register */
#define pREG_PWM1_BH1                    ((volatile  uint32_t *) REG_PWM1_BH1)                    /*  Channel B-High Duty-1 Register */
#define pREG_PWM1_BH0_HP                 ((volatile  uint32_t *) REG_PWM1_BH0_HP)                 /*  Channel B-High Heightened-Precision Duty-0 Register */
#define pREG_PWM1_BH1_HP                 ((volatile  uint32_t *) REG_PWM1_BH1_HP)                 /*  Channel B-High Heightened-Precision Duty-1 Register */
#define pREG_PWM1_BL0                    ((volatile  uint32_t *) REG_PWM1_BL0)                    /*  Channel B-Low Duty-0 Register */
#define pREG_PWM1_BL1                    ((volatile  uint32_t *) REG_PWM1_BL1)                    /*  Channel B-Low Duty-1 Register */
#define pREG_PWM1_BL0_HP                 ((volatile  uint32_t *) REG_PWM1_BL0_HP)                 /*  Channel B-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM1_BL1_HP                 ((volatile  uint32_t *) REG_PWM1_BL1_HP)                 /*  Channel B-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM1_CCTL                   ((volatile  uint32_t *) REG_PWM1_CCTL)                   /*  Channel C Control Register */
#define pREG_PWM1_CH0                    ((volatile  uint32_t *) REG_PWM1_CH0)                    /*  Channel C-High Pulse Duty Register 0 */
#define pREG_PWM1_CH1                    ((volatile  uint32_t *) REG_PWM1_CH1)                    /*  Channel C-High Pulse Duty Register 1 */
#define pREG_PWM1_CH0_HP                 ((volatile  uint32_t *) REG_PWM1_CH0_HP)                 /*  Channel C-High Pulse Heightened-Precision Duty Register 0 */
#define pREG_PWM1_CH1_HP                 ((volatile  uint32_t *) REG_PWM1_CH1_HP)                 /*  Channel C-High Pulse Heightened-Precision Duty Register 1 */
#define pREG_PWM1_CL0                    ((volatile  uint32_t *) REG_PWM1_CL0)                    /*  Channel C-Low Pulse Duty Register 0 */
#define pREG_PWM1_CL1                    ((volatile  uint32_t *) REG_PWM1_CL1)                    /*  Channel C-Low Duty-1 Register */
#define pREG_PWM1_CL0_HP                 ((volatile  uint32_t *) REG_PWM1_CL0_HP)                 /*  Channel C-Low Pulse Duty Register 1 */
#define pREG_PWM1_CL1_HP                 ((volatile  uint32_t *) REG_PWM1_CL1_HP)                 /*  Channel C-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM1_DCTL                   ((volatile  uint32_t *) REG_PWM1_DCTL)                   /*  Channel D Control Register */
#define pREG_PWM1_DH0                    ((volatile  uint32_t *) REG_PWM1_DH0)                    /*  Channel D-High Duty-0 Register */
#define pREG_PWM1_DH1                    ((volatile  uint32_t *) REG_PWM1_DH1)                    /*  Channel D-High Pulse Duty Register 1 */
#define pREG_PWM1_DH0_HP                 ((volatile  uint32_t *) REG_PWM1_DH0_HP)                 /*  Channel D-High Pulse Heightened-Precision Duty Register 0 */
#define pREG_PWM1_DH1_HP                 ((volatile  uint32_t *) REG_PWM1_DH1_HP)                 /*  Channel D High Pulse Heightened-Precision Duty Register 1 */
#define pREG_PWM1_DL0                    ((volatile  uint32_t *) REG_PWM1_DL0)                    /*  Channel D-Low Pulse Duty Register 0 */
#define pREG_PWM1_DL1                    ((volatile  uint32_t *) REG_PWM1_DL1)                    /*  Channel D-Low Pulse Duty Register 1 */
#define pREG_PWM1_DL0_HP                 ((volatile  uint32_t *) REG_PWM1_DL0_HP)                 /*  Channel D-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM1_DL1_HP                 ((volatile  uint32_t *) REG_PWM1_DL1_HP)                 /*  Channel D-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM1_AH_DUTY0               ((volatile  uint32_t *) REG_PWM1_AH_DUTY0)               /*  Channel A-High Full Duty0 Register */
#define pREG_PWM1_AH_DUTY1               ((volatile  uint32_t *) REG_PWM1_AH_DUTY1)               /*  Channel A-High Full Duty1 Register */
#define pREG_PWM1_AL_DUTY0               ((volatile  uint32_t *) REG_PWM1_AL_DUTY0)               /*  Channel A-Low Full Duty0 Register */
#define pREG_PWM1_AL_DUTY1               ((volatile  uint32_t *) REG_PWM1_AL_DUTY1)               /*  Channel A-Low Full Duty1 Register */
#define pREG_PWM1_BH_DUTY0               ((volatile  uint32_t *) REG_PWM1_BH_DUTY0)               /*  Channel B-High Full Duty0 Register */
#define pREG_PWM1_BH_DUTY1               ((volatile  uint32_t *) REG_PWM1_BH_DUTY1)               /*  Channel B-High Full Duty1 Register */
#define pREG_PWM1_BL_DUTY0               ((volatile  uint32_t *) REG_PWM1_BL_DUTY0)               /*  Channel B-Low Full Duty0 Register */
#define pREG_PWM1_BL_DUTY1               ((volatile  uint32_t *) REG_PWM1_BL_DUTY1)               /*  Channel B-Low Full Duty1 Register */
#define pREG_PWM1_CH_DUTY0               ((volatile  uint32_t *) REG_PWM1_CH_DUTY0)               /*  Channel C-High Full Duty0 Register */
#define pREG_PWM1_CH_DUTY1               ((volatile  uint32_t *) REG_PWM1_CH_DUTY1)               /*  Channel C-High Full Duty1 Register */
#define pREG_PWM1_CL_DUTY0               ((volatile  uint32_t *) REG_PWM1_CL_DUTY0)               /*  Channel C-Low Full Duty0 Register */
#define pREG_PWM1_CL_DUTY1               ((volatile  uint32_t *) REG_PWM1_CL_DUTY1)               /*  Channel C-Low Full Duty1 Register */
#define pREG_PWM1_DH_DUTY0               ((volatile  uint32_t *) REG_PWM1_DH_DUTY0)               /*  Channel D-High Full Duty0 Register */
#define pREG_PWM1_DH_DUTY1               ((volatile  uint32_t *) REG_PWM1_DH_DUTY1)               /*  Channel D-High Full Duty1 Register */
#define pREG_PWM1_DL_DUTY0               ((volatile  uint32_t *) REG_PWM1_DL_DUTY0)               /*  Channel D-Low Full Duty0 Register */
#define pREG_PWM1_DL_DUTY1               ((volatile  uint32_t *) REG_PWM1_DL_DUTY1)               /*  Channel D-Low Full Duty1 Register */
#define pREG_PWM1_CHA_DT                 ((volatile  uint32_t *) REG_PWM1_CHA_DT)                 /*  Channel A Dead-time register */
#define pREG_PWM1_CHB_DT                 ((volatile  uint32_t *) REG_PWM1_CHB_DT)                 /*  Channel B Dead-time register */
#define pREG_PWM1_CHC_DT                 ((volatile  uint32_t *) REG_PWM1_CHC_DT)                 /*  Channel C Dead-time register */
#define pREG_PWM1_CHD_DT                 ((volatile  uint32_t *) REG_PWM1_CHD_DT)                 /*  Channel D Dead-time register */
#define pREG_PWM1_SWTRIP                 ((volatile  uint32_t *) REG_PWM1_SWTRIP)                 /*  Software Trip Register */
#define pREG_PWM1_TRIP_POL               ((volatile  uint32_t *) REG_PWM1_TRIP_POL)               /*  Trip Polarity Register */

/*  =================================================================================
 *      Pulse-Width Modulator (PWM2)
 *  ================================================================================= */
#define pREG_PWM2_CTL                    ((volatile  uint32_t *) REG_PWM2_CTL)                    /*  Control Register */
#define pREG_PWM2_CHANCFG                ((volatile  uint32_t *) REG_PWM2_CHANCFG)                /*  Channel Config Register */
#define pREG_PWM2_TRIPCFG                ((volatile  uint32_t *) REG_PWM2_TRIPCFG)                /*  Trip Config Register */
#define pREG_PWM2_STAT                   ((volatile  uint32_t *) REG_PWM2_STAT)                   /*  Status Register */
#define pREG_PWM2_IMSK                   ((volatile  uint32_t *) REG_PWM2_IMSK)                   /*  Interrupt Mask Register */
#define pREG_PWM2_ILAT                   ((volatile  uint32_t *) REG_PWM2_ILAT)                   /*  Interrupt Latch Register */
#define pREG_PWM2_CHOPCFG                ((volatile  uint32_t *) REG_PWM2_CHOPCFG)                /*  Chop Configuration Register */
#define pREG_PWM2_SYNC_WID               ((volatile  uint32_t *) REG_PWM2_SYNC_WID)               /*  Sync Pulse Width Register */
#define pREG_PWM2_TM0                    ((volatile  uint32_t *) REG_PWM2_TM0)                    /*  Timer 0 Period Register */
#define pREG_PWM2_TM1                    ((volatile  uint32_t *) REG_PWM2_TM1)                    /*  Timer 1 Period Register */
#define pREG_PWM2_TM2                    ((volatile  uint32_t *) REG_PWM2_TM2)                    /*  Timer 2 Period Register */
#define pREG_PWM2_TM3                    ((volatile  uint32_t *) REG_PWM2_TM3)                    /*  Timer 3 Period Register */
#define pREG_PWM2_TM4                    ((volatile  uint32_t *) REG_PWM2_TM4)                    /*  Timer 4 Period Register */
#define pREG_PWM2_DLYA                   ((volatile  uint32_t *) REG_PWM2_DLYA)                   /*  Channel A Delay Register */
#define pREG_PWM2_DLYB                   ((volatile  uint32_t *) REG_PWM2_DLYB)                   /*  Channel B Delay Register */
#define pREG_PWM2_DLYC                   ((volatile  uint32_t *) REG_PWM2_DLYC)                   /*  Channel C Delay Register */
#define pREG_PWM2_DLYD                   ((volatile  uint32_t *) REG_PWM2_DLYD)                   /*  Channel D Delay Register */
#define pREG_PWM2_ACTL                   ((volatile  uint32_t *) REG_PWM2_ACTL)                   /*  Channel A Control Register */
#define pREG_PWM2_AH0                    ((volatile  uint32_t *) REG_PWM2_AH0)                    /*  Channel A-High Duty-0 Register */
#define pREG_PWM2_AH1                    ((volatile  uint32_t *) REG_PWM2_AH1)                    /*  Channel A-High Duty-1 Register */
#define pREG_PWM2_AH0_HP                 ((volatile  uint32_t *) REG_PWM2_AH0_HP)                 /*  Channel A-High Heightened-Precision Duty-0 Register */
#define pREG_PWM2_AH1_HP                 ((volatile  uint32_t *) REG_PWM2_AH1_HP)                 /*  Channel A-High Heightened-Precision Duty-1 Register */
#define pREG_PWM2_AL0                    ((volatile  uint32_t *) REG_PWM2_AL0)                    /*  Channel A-Low Duty-0 Register */
#define pREG_PWM2_AL1                    ((volatile  uint32_t *) REG_PWM2_AL1)                    /*  Channel A-Low Duty-1 Register */
#define pREG_PWM2_AL0_HP                 ((volatile  uint32_t *) REG_PWM2_AL0_HP)                 /*  Channel A-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM2_AL1_HP                 ((volatile  uint32_t *) REG_PWM2_AL1_HP)                 /*  Channel A-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM2_BCTL                   ((volatile  uint32_t *) REG_PWM2_BCTL)                   /*  Channel B Control Register */
#define pREG_PWM2_BH0                    ((volatile  uint32_t *) REG_PWM2_BH0)                    /*  Channel B-High Duty-0 Register */
#define pREG_PWM2_BH1                    ((volatile  uint32_t *) REG_PWM2_BH1)                    /*  Channel B-High Duty-1 Register */
#define pREG_PWM2_BH0_HP                 ((volatile  uint32_t *) REG_PWM2_BH0_HP)                 /*  Channel B-High Heightened-Precision Duty-0 Register */
#define pREG_PWM2_BH1_HP                 ((volatile  uint32_t *) REG_PWM2_BH1_HP)                 /*  Channel B-High Heightened-Precision Duty-1 Register */
#define pREG_PWM2_BL0                    ((volatile  uint32_t *) REG_PWM2_BL0)                    /*  Channel B-Low Duty-0 Register */
#define pREG_PWM2_BL1                    ((volatile  uint32_t *) REG_PWM2_BL1)                    /*  Channel B-Low Duty-1 Register */
#define pREG_PWM2_BL0_HP                 ((volatile  uint32_t *) REG_PWM2_BL0_HP)                 /*  Channel B-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM2_BL1_HP                 ((volatile  uint32_t *) REG_PWM2_BL1_HP)                 /*  Channel B-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM2_CCTL                   ((volatile  uint32_t *) REG_PWM2_CCTL)                   /*  Channel C Control Register */
#define pREG_PWM2_CH0                    ((volatile  uint32_t *) REG_PWM2_CH0)                    /*  Channel C-High Pulse Duty Register 0 */
#define pREG_PWM2_CH1                    ((volatile  uint32_t *) REG_PWM2_CH1)                    /*  Channel C-High Pulse Duty Register 1 */
#define pREG_PWM2_CH0_HP                 ((volatile  uint32_t *) REG_PWM2_CH0_HP)                 /*  Channel C-High Pulse Heightened-Precision Duty Register 0 */
#define pREG_PWM2_CH1_HP                 ((volatile  uint32_t *) REG_PWM2_CH1_HP)                 /*  Channel C-High Pulse Heightened-Precision Duty Register 1 */
#define pREG_PWM2_CL0                    ((volatile  uint32_t *) REG_PWM2_CL0)                    /*  Channel C-Low Pulse Duty Register 0 */
#define pREG_PWM2_CL1                    ((volatile  uint32_t *) REG_PWM2_CL1)                    /*  Channel C-Low Duty-1 Register */
#define pREG_PWM2_CL0_HP                 ((volatile  uint32_t *) REG_PWM2_CL0_HP)                 /*  Channel C-Low Pulse Duty Register 1 */
#define pREG_PWM2_CL1_HP                 ((volatile  uint32_t *) REG_PWM2_CL1_HP)                 /*  Channel C-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM2_DCTL                   ((volatile  uint32_t *) REG_PWM2_DCTL)                   /*  Channel D Control Register */
#define pREG_PWM2_DH0                    ((volatile  uint32_t *) REG_PWM2_DH0)                    /*  Channel D-High Duty-0 Register */
#define pREG_PWM2_DH1                    ((volatile  uint32_t *) REG_PWM2_DH1)                    /*  Channel D-High Pulse Duty Register 1 */
#define pREG_PWM2_DH0_HP                 ((volatile  uint32_t *) REG_PWM2_DH0_HP)                 /*  Channel D-High Pulse Heightened-Precision Duty Register 0 */
#define pREG_PWM2_DH1_HP                 ((volatile  uint32_t *) REG_PWM2_DH1_HP)                 /*  Channel D High Pulse Heightened-Precision Duty Register 1 */
#define pREG_PWM2_DL0                    ((volatile  uint32_t *) REG_PWM2_DL0)                    /*  Channel D-Low Pulse Duty Register 0 */
#define pREG_PWM2_DL1                    ((volatile  uint32_t *) REG_PWM2_DL1)                    /*  Channel D-Low Pulse Duty Register 1 */
#define pREG_PWM2_DL0_HP                 ((volatile  uint32_t *) REG_PWM2_DL0_HP)                 /*  Channel D-Low Heightened-Precision Duty-0 Register */
#define pREG_PWM2_DL1_HP                 ((volatile  uint32_t *) REG_PWM2_DL1_HP)                 /*  Channel D-Low Heightened-Precision Duty-1 Register */
#define pREG_PWM2_AH_DUTY0               ((volatile  uint32_t *) REG_PWM2_AH_DUTY0)               /*  Channel A-High Full Duty0 Register */
#define pREG_PWM2_AH_DUTY1               ((volatile  uint32_t *) REG_PWM2_AH_DUTY1)               /*  Channel A-High Full Duty1 Register */
#define pREG_PWM2_AL_DUTY0               ((volatile  uint32_t *) REG_PWM2_AL_DUTY0)               /*  Channel A-Low Full Duty0 Register */
#define pREG_PWM2_AL_DUTY1               ((volatile  uint32_t *) REG_PWM2_AL_DUTY1)               /*  Channel A-Low Full Duty1 Register */
#define pREG_PWM2_BH_DUTY0               ((volatile  uint32_t *) REG_PWM2_BH_DUTY0)               /*  Channel B-High Full Duty0 Register */
#define pREG_PWM2_BH_DUTY1               ((volatile  uint32_t *) REG_PWM2_BH_DUTY1)               /*  Channel B-High Full Duty1 Register */
#define pREG_PWM2_BL_DUTY0               ((volatile  uint32_t *) REG_PWM2_BL_DUTY0)               /*  Channel B-Low Full Duty0 Register */
#define pREG_PWM2_BL_DUTY1               ((volatile  uint32_t *) REG_PWM2_BL_DUTY1)               /*  Channel B-Low Full Duty1 Register */
#define pREG_PWM2_CH_DUTY0               ((volatile  uint32_t *) REG_PWM2_CH_DUTY0)               /*  Channel C-High Full Duty0 Register */
#define pREG_PWM2_CH_DUTY1               ((volatile  uint32_t *) REG_PWM2_CH_DUTY1)               /*  Channel C-High Full Duty1 Register */
#define pREG_PWM2_CL_DUTY0               ((volatile  uint32_t *) REG_PWM2_CL_DUTY0)               /*  Channel C-Low Full Duty0 Register */
#define pREG_PWM2_CL_DUTY1               ((volatile  uint32_t *) REG_PWM2_CL_DUTY1)               /*  Channel C-Low Full Duty1 Register */
#define pREG_PWM2_DH_DUTY0               ((volatile  uint32_t *) REG_PWM2_DH_DUTY0)               /*  Channel D-High Full Duty0 Register */
#define pREG_PWM2_DH_DUTY1               ((volatile  uint32_t *) REG_PWM2_DH_DUTY1)               /*  Channel D-High Full Duty1 Register */
#define pREG_PWM2_DL_DUTY0               ((volatile  uint32_t *) REG_PWM2_DL_DUTY0)               /*  Channel D-Low Full Duty0 Register */
#define pREG_PWM2_DL_DUTY1               ((volatile  uint32_t *) REG_PWM2_DL_DUTY1)               /*  Channel D-Low Full Duty1 Register */
#define pREG_PWM2_CHA_DT                 ((volatile  uint32_t *) REG_PWM2_CHA_DT)                 /*  Channel A Dead-time register */
#define pREG_PWM2_CHB_DT                 ((volatile  uint32_t *) REG_PWM2_CHB_DT)                 /*  Channel B Dead-time register */
#define pREG_PWM2_CHC_DT                 ((volatile  uint32_t *) REG_PWM2_CHC_DT)                 /*  Channel C Dead-time register */
#define pREG_PWM2_CHD_DT                 ((volatile  uint32_t *) REG_PWM2_CHD_DT)                 /*  Channel D Dead-time register */
#define pREG_PWM2_SWTRIP                 ((volatile  uint32_t *) REG_PWM2_SWTRIP)                 /*  Software Trip Register */
#define pREG_PWM2_TRIP_POL               ((volatile  uint32_t *) REG_PWM2_TRIP_POL)               /*  Trip Polarity Register */

/*  =================================================================================
 *      BIST for HPPWM (HPPWMBST)
 *  ================================================================================= */

/*  =================================================================================
 *      Trigger Timing Unit (TTU0)
 *  ================================================================================= */
#define pREG_TTU0_CTL                    ((volatile  uint32_t *) REG_TTU0_CTL)                    /*  TTU Control Register */
#define pREG_TTU0_REVID                  ((volatile  uint32_t *) REG_TTU0_REVID)                  /*  Revision ID Register */
#define pREG_TTU0_STOP                   ((volatile  uint32_t *) REG_TTU0_STOP)                   /*  Counter Stop Request Register */
#define pREG_TTU0_STAT                   ((volatile  uint32_t *) REG_TTU0_STAT)                   /*  Counter Status register */
#define pREG_TTU0_TST                    ((volatile  uint32_t *) REG_TTU0_TST)                    /*  Counter Testmode Register */
#define pREG_TTU0_CNT0                   ((volatile  uint32_t *) REG_TTU0_CNT0)                   /*  Counter Current Value */
#define pREG_TTU0_CNT1                   ((volatile  uint32_t *) REG_TTU0_CNT1)                   /*  Counter Current Value */
#define pREG_TTU0_CNT2                   ((volatile  uint32_t *) REG_TTU0_CNT2)                   /*  Counter Current Value */
#define pREG_TTU0_CNT3                   ((volatile  uint32_t *) REG_TTU0_CNT3)                   /*  Counter Current Value */
#define pREG_TTU0_PER0                   ((volatile  uint32_t *) REG_TTU0_PER0)                   /*  Counter Period Register */
#define pREG_TTU0_PER1                   ((volatile  uint32_t *) REG_TTU0_PER1)                   /*  Counter Period Register */
#define pREG_TTU0_PER2                   ((volatile  uint32_t *) REG_TTU0_PER2)                   /*  Counter Period Register */
#define pREG_TTU0_PER3                   ((volatile  uint32_t *) REG_TTU0_PER3)                   /*  Counter Period Register */
#define pREG_TTU0_DLY0                   ((volatile  uint32_t *) REG_TTU0_DLY0)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY1                   ((volatile  uint32_t *) REG_TTU0_DLY1)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY2                   ((volatile  uint32_t *) REG_TTU0_DLY2)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY3                   ((volatile  uint32_t *) REG_TTU0_DLY3)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY4                   ((volatile  uint32_t *) REG_TTU0_DLY4)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY5                   ((volatile  uint32_t *) REG_TTU0_DLY5)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY6                   ((volatile  uint32_t *) REG_TTU0_DLY6)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DLY7                   ((volatile  uint32_t *) REG_TTU0_DLY7)                   /*  Trigger Output Delay Register */
#define pREG_TTU0_DGRP0                  ((volatile  uint32_t *) REG_TTU0_DGRP0)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP1                  ((volatile  uint32_t *) REG_TTU0_DGRP1)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP2                  ((volatile  uint32_t *) REG_TTU0_DGRP2)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP3                  ((volatile  uint32_t *) REG_TTU0_DGRP3)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP4                  ((volatile  uint32_t *) REG_TTU0_DGRP4)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP5                  ((volatile  uint32_t *) REG_TTU0_DGRP5)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP6                  ((volatile  uint32_t *) REG_TTU0_DGRP6)                  /*  Trigger Output Counter Assignment */
#define pREG_TTU0_DGRP7                  ((volatile  uint32_t *) REG_TTU0_DGRP7)                  /*  Trigger Output Counter Assignment */

/*  =================================================================================
 *      Static Memory Controller (SMC0)
 *  ================================================================================= */
#define pREG_SMC0_B0CTL                  ((volatile  uint32_t *) REG_SMC0_B0CTL)                  /*  Bank 0 Control Register */
#define pREG_SMC0_B0TIM                  ((volatile  uint32_t *) REG_SMC0_B0TIM)                  /*  Bank 0 Timing Register */
#define pREG_SMC0_B0ETIM                 ((volatile  uint32_t *) REG_SMC0_B0ETIM)                 /*  Bank 0 Extended Timing Register */
#define pREG_SMC0_B1CTL                  ((volatile  uint32_t *) REG_SMC0_B1CTL)                  /*  Bank 1 Control Register */
#define pREG_SMC0_B1TIM                  ((volatile  uint32_t *) REG_SMC0_B1TIM)                  /*  Bank 1 Timing Register */
#define pREG_SMC0_B1ETIM                 ((volatile  uint32_t *) REG_SMC0_B1ETIM)                 /*  Bank 1 Extended Timing Register */
#define pREG_SMC0_B2CTL                  ((volatile  uint32_t *) REG_SMC0_B2CTL)                  /*  Bank 2 Control Register */
#define pREG_SMC0_B2TIM                  ((volatile  uint32_t *) REG_SMC0_B2TIM)                  /*  Bank 2 Timing Register */
#define pREG_SMC0_B2ETIM                 ((volatile  uint32_t *) REG_SMC0_B2ETIM)                 /*  Bank 2 Extended Timing Register */
#define pREG_SMC0_B3CTL                  ((volatile  uint32_t *) REG_SMC0_B3CTL)                  /*  Bank 3 Control Register */
#define pREG_SMC0_B3TIM                  ((volatile  uint32_t *) REG_SMC0_B3TIM)                  /*  Bank 3 Timing Register */
#define pREG_SMC0_B3ETIM                 ((volatile  uint32_t *) REG_SMC0_B3ETIM)                 /*  Bank 3 Extended Timing Register */

/*  =================================================================================
 *      Serial Peripheral Interface (SPI0)
 *  ================================================================================= */
#define pREG_SPI0_CTL                    ((volatile  uint32_t *) REG_SPI0_CTL)                    /*  Control Register */
#define pREG_SPI0_RXCTL                  ((volatile  uint32_t *) REG_SPI0_RXCTL)                  /*  Receive Control Register */
#define pREG_SPI0_TXCTL                  ((volatile  uint32_t *) REG_SPI0_TXCTL)                  /*  Transmit Control Register */
#define pREG_SPI0_CLK                    ((volatile  uint32_t *) REG_SPI0_CLK)                    /*  Clock Rate Register */
#define pREG_SPI0_DLY                    ((volatile  uint32_t *) REG_SPI0_DLY)                    /*  Delay Register */
#define pREG_SPI0_SLVSEL                 ((volatile  uint32_t *) REG_SPI0_SLVSEL)                 /*  Slave Select Register */
#define pREG_SPI0_RWC                    ((volatile  uint32_t *) REG_SPI0_RWC)                    /*  Received Word Count Register */
#define pREG_SPI0_RWCR                   ((volatile  uint32_t *) REG_SPI0_RWCR)                   /*  Received Word Count Reload Register */
#define pREG_SPI0_TWC                    ((volatile  uint32_t *) REG_SPI0_TWC)                    /*  Transmitted Word Count Register */
#define pREG_SPI0_TWCR                   ((volatile  uint32_t *) REG_SPI0_TWCR)                   /*  Transmitted Word Count Reload Register */
#define pREG_SPI0_IMSK                   ((volatile  uint32_t *) REG_SPI0_IMSK)                   /*  Interrupt Mask Register */
#define pREG_SPI0_IMSK_CLR               ((volatile  uint32_t *) REG_SPI0_IMSK_CLR)               /*  Interrupt Mask Clear Register */
#define pREG_SPI0_IMSK_SET               ((volatile  uint32_t *) REG_SPI0_IMSK_SET)               /*  Interrupt Mask Set Register */
#define pREG_SPI0_STAT                   ((volatile  uint32_t *) REG_SPI0_STAT)                   /*  Status Register */
#define pREG_SPI0_ILAT                   ((volatile  uint32_t *) REG_SPI0_ILAT)                   /*  Masked Interrupt Condition Register */
#define pREG_SPI0_ILAT_CLR               ((volatile  uint32_t *) REG_SPI0_ILAT_CLR)               /*  Masked Interrupt Clear Register */
#define pREG_SPI0_RFIFO                  ((volatile  uint32_t *) REG_SPI0_RFIFO)                  /*  Receive FIFO Data Register */
#define pREG_SPI0_TFIFO                  ((volatile  uint32_t *) REG_SPI0_TFIFO)                  /*  Transmit FIFO Data Register */
#define pREG_SPI0_MMRDH                  ((volatile  uint32_t *) REG_SPI0_MMRDH)                  /*  Memory Mapped Read Header */
#define pREG_SPI0_MMTOP                  ((volatile  uint32_t *) REG_SPI0_MMTOP)                  /*  SPI Memory Top Address */

/*  =================================================================================
 *      Serial Peripheral Interface (SPI1)
 *  ================================================================================= */
#define pREG_SPI1_CTL                    ((volatile  uint32_t *) REG_SPI1_CTL)                    /*  Control Register */
#define pREG_SPI1_RXCTL                  ((volatile  uint32_t *) REG_SPI1_RXCTL)                  /*  Receive Control Register */
#define pREG_SPI1_TXCTL                  ((volatile  uint32_t *) REG_SPI1_TXCTL)                  /*  Transmit Control Register */
#define pREG_SPI1_CLK                    ((volatile  uint32_t *) REG_SPI1_CLK)                    /*  Clock Rate Register */
#define pREG_SPI1_DLY                    ((volatile  uint32_t *) REG_SPI1_DLY)                    /*  Delay Register */
#define pREG_SPI1_SLVSEL                 ((volatile  uint32_t *) REG_SPI1_SLVSEL)                 /*  Slave Select Register */
#define pREG_SPI1_RWC                    ((volatile  uint32_t *) REG_SPI1_RWC)                    /*  Received Word Count Register */
#define pREG_SPI1_RWCR                   ((volatile  uint32_t *) REG_SPI1_RWCR)                   /*  Received Word Count Reload Register */
#define pREG_SPI1_TWC                    ((volatile  uint32_t *) REG_SPI1_TWC)                    /*  Transmitted Word Count Register */
#define pREG_SPI1_TWCR                   ((volatile  uint32_t *) REG_SPI1_TWCR)                   /*  Transmitted Word Count Reload Register */
#define pREG_SPI1_IMSK                   ((volatile  uint32_t *) REG_SPI1_IMSK)                   /*  Interrupt Mask Register */
#define pREG_SPI1_IMSK_CLR               ((volatile  uint32_t *) REG_SPI1_IMSK_CLR)               /*  Interrupt Mask Clear Register */
#define pREG_SPI1_IMSK_SET               ((volatile  uint32_t *) REG_SPI1_IMSK_SET)               /*  Interrupt Mask Set Register */
#define pREG_SPI1_STAT                   ((volatile  uint32_t *) REG_SPI1_STAT)                   /*  Status Register */
#define pREG_SPI1_ILAT                   ((volatile  uint32_t *) REG_SPI1_ILAT)                   /*  Masked Interrupt Condition Register */
#define pREG_SPI1_ILAT_CLR               ((volatile  uint32_t *) REG_SPI1_ILAT_CLR)               /*  Masked Interrupt Clear Register */
#define pREG_SPI1_RFIFO                  ((volatile  uint32_t *) REG_SPI1_RFIFO)                  /*  Receive FIFO Data Register */
#define pREG_SPI1_TFIFO                  ((volatile  uint32_t *) REG_SPI1_TFIFO)                  /*  Transmit FIFO Data Register */
#define pREG_SPI1_MMRDH                  ((volatile  uint32_t *) REG_SPI1_MMRDH)                  /*  Memory Mapped Read Header */
#define pREG_SPI1_MMTOP                  ((volatile  uint32_t *) REG_SPI1_MMTOP)                  /*  SPI Memory Top Address */

/*  =================================================================================
 *      Serial Port (SPORT0)
 *  ================================================================================= */
#define pREG_SPORT0_CTL_A                ((volatile  uint32_t *) REG_SPORT0_CTL_A)                /*  Half SPORT 'A' Control Register */
#define pREG_SPORT0_DIV_A                ((volatile  uint32_t *) REG_SPORT0_DIV_A)                /*  Half SPORT 'A' Divisor Register */
#define pREG_SPORT0_MCTL_A               ((volatile  uint32_t *) REG_SPORT0_MCTL_A)               /*  Half SPORT 'A' Multi-channel Control Register */
#define pREG_SPORT0_CS0_A                ((volatile  uint32_t *) REG_SPORT0_CS0_A)                /*  Half SPORT 'A' Multi-channel 0-31 Select Register */
#define pREG_SPORT0_CS1_A                ((volatile  uint32_t *) REG_SPORT0_CS1_A)                /*  Half SPORT 'A' Multi-channel 32-63 Select Register */
#define pREG_SPORT0_CS2_A                ((volatile  uint32_t *) REG_SPORT0_CS2_A)                /*  Half SPORT 'A' Multi-channel 64-95 Select Register */
#define pREG_SPORT0_CS3_A                ((volatile  uint32_t *) REG_SPORT0_CS3_A)                /*  Half SPORT 'A' Multi-channel 96-127 Select Register */
#define pREG_SPORT0_ERR_A                ((volatile  uint32_t *) REG_SPORT0_ERR_A)                /*  Half SPORT 'A' Error Register */
#define pREG_SPORT0_MSTAT_A              ((volatile  uint32_t *) REG_SPORT0_MSTAT_A)              /*  Half SPORT 'A' Multi-channel Status Register */
#define pREG_SPORT0_CTL2_A               ((volatile  uint32_t *) REG_SPORT0_CTL2_A)               /*  Half SPORT 'A' Control 2 Register */
#define pREG_SPORT0_TXPRI_A              ((volatile  uint32_t *) REG_SPORT0_TXPRI_A)              /*  Half SPORT 'A' Tx Buffer (Primary) Register */
#define pREG_SPORT0_RXPRI_A              ((volatile  uint32_t *) REG_SPORT0_RXPRI_A)              /*  Half SPORT 'A' Rx Buffer (Primary) Register */
#define pREG_SPORT0_TXSEC_A              ((volatile  uint32_t *) REG_SPORT0_TXSEC_A)              /*  Half SPORT 'A' Tx Buffer (Secondary) Register */
#define pREG_SPORT0_RXSEC_A              ((volatile  uint32_t *) REG_SPORT0_RXSEC_A)              /*  Half SPORT 'A' Rx Buffer (Secondary) Register */
#define pREG_SPORT0_CTL_B                ((volatile  uint32_t *) REG_SPORT0_CTL_B)                /*  Half SPORT 'B' Control Register */
#define pREG_SPORT0_DIV_B                ((volatile  uint32_t *) REG_SPORT0_DIV_B)                /*  Half SPORT 'B' Divisor Register */
#define pREG_SPORT0_MCTL_B               ((volatile  uint32_t *) REG_SPORT0_MCTL_B)               /*  Half SPORT 'B' Multi-channel Control Register */
#define pREG_SPORT0_CS0_B                ((volatile  uint32_t *) REG_SPORT0_CS0_B)                /*  Half SPORT 'B' Multi-channel 0-31 Select Register */
#define pREG_SPORT0_CS1_B                ((volatile  uint32_t *) REG_SPORT0_CS1_B)                /*  Half SPORT 'B' Multi-channel 32-63 Select Register */
#define pREG_SPORT0_CS2_B                ((volatile  uint32_t *) REG_SPORT0_CS2_B)                /*  Half SPORT 'B' Multichannel 64-95 Select Register */
#define pREG_SPORT0_CS3_B                ((volatile  uint32_t *) REG_SPORT0_CS3_B)                /*  Half SPORT 'B' Multichannel 96-127 Select Register */
#define pREG_SPORT0_ERR_B                ((volatile  uint32_t *) REG_SPORT0_ERR_B)                /*  Half SPORT 'B' Error Register */
#define pREG_SPORT0_MSTAT_B              ((volatile  uint32_t *) REG_SPORT0_MSTAT_B)              /*  Half SPORT 'B' Multi-channel Status Register */
#define pREG_SPORT0_CTL2_B               ((volatile  uint32_t *) REG_SPORT0_CTL2_B)               /*  Half SPORT 'B' Control 2 Register */
#define pREG_SPORT0_TXPRI_B              ((volatile  uint32_t *) REG_SPORT0_TXPRI_B)              /*  Half SPORT 'B' Tx Buffer (Primary) Register */
#define pREG_SPORT0_RXPRI_B              ((volatile  uint32_t *) REG_SPORT0_RXPRI_B)              /*  Half SPORT 'B' Rx Buffer (Primary) Register */
#define pREG_SPORT0_TXSEC_B              ((volatile  uint32_t *) REG_SPORT0_TXSEC_B)              /*  Half SPORT 'B' Tx Buffer (Secondary) Register */
#define pREG_SPORT0_RXSEC_B              ((volatile  uint32_t *) REG_SPORT0_RXSEC_B)              /*  Half SPORT 'B' Rx Buffer (Secondary) Register */

/*  =================================================================================
 *      UART (UART0)
 *  ================================================================================= */
#define pREG_UART0_CTL                   ((volatile  uint32_t *) REG_UART0_CTL)                   /*  Control Register */
#define pREG_UART0_STAT                  ((volatile  uint32_t *) REG_UART0_STAT)                  /*  Status Register */
#define pREG_UART0_SCR                   ((volatile  uint32_t *) REG_UART0_SCR)                   /*  Scratch Register */
#define pREG_UART0_CLK                   ((volatile  uint32_t *) REG_UART0_CLK)                   /*  Clock Rate Register */
#define pREG_UART0_IMSK                  ((volatile  uint32_t *) REG_UART0_IMSK)                  /*  Interrupt Mask Register */
#define pREG_UART0_IMSK_SET              ((volatile  uint32_t *) REG_UART0_IMSK_SET)              /*  Interrupt Mask Set Register */
#define pREG_UART0_IMSK_CLR              ((volatile  uint32_t *) REG_UART0_IMSK_CLR)              /*  Interrupt Mask Clear Register */
#define pREG_UART0_RBR                   ((volatile  uint32_t *) REG_UART0_RBR)                   /*  Receive Buffer Register */
#define pREG_UART0_THR                   ((volatile  uint32_t *) REG_UART0_THR)                   /*  Transmit Hold Register */
#define pREG_UART0_TAIP                  ((volatile  uint32_t *) REG_UART0_TAIP)                  /*  Transmit Address/Insert Pulse Register */
#define pREG_UART0_TSR                   ((volatile  uint32_t *) REG_UART0_TSR)                   /*  Transmit Shift Register */
#define pREG_UART0_RSR                   ((volatile  uint32_t *) REG_UART0_RSR)                   /*  Receive Shift Register */
#define pREG_UART0_TXCNT                 ((volatile  uint32_t *) REG_UART0_TXCNT)                 /*  Transmit Counter Register */
#define pREG_UART0_RXCNT                 ((volatile  uint32_t *) REG_UART0_RXCNT)                 /*  Receive Counter Register */

/*  =================================================================================
 *      UART (UART1)
 *  ================================================================================= */
#define pREG_UART1_CTL                   ((volatile  uint32_t *) REG_UART1_CTL)                   /*  Control Register */
#define pREG_UART1_STAT                  ((volatile  uint32_t *) REG_UART1_STAT)                  /*  Status Register */
#define pREG_UART1_SCR                   ((volatile  uint32_t *) REG_UART1_SCR)                   /*  Scratch Register */
#define pREG_UART1_CLK                   ((volatile  uint32_t *) REG_UART1_CLK)                   /*  Clock Rate Register */
#define pREG_UART1_IMSK                  ((volatile  uint32_t *) REG_UART1_IMSK)                  /*  Interrupt Mask Register */
#define pREG_UART1_IMSK_SET              ((volatile  uint32_t *) REG_UART1_IMSK_SET)              /*  Interrupt Mask Set Register */
#define pREG_UART1_IMSK_CLR              ((volatile  uint32_t *) REG_UART1_IMSK_CLR)              /*  Interrupt Mask Clear Register */
#define pREG_UART1_RBR                   ((volatile  uint32_t *) REG_UART1_RBR)                   /*  Receive Buffer Register */
#define pREG_UART1_THR                   ((volatile  uint32_t *) REG_UART1_THR)                   /*  Transmit Hold Register */
#define pREG_UART1_TAIP                  ((volatile  uint32_t *) REG_UART1_TAIP)                  /*  Transmit Address/Insert Pulse Register */
#define pREG_UART1_TSR                   ((volatile  uint32_t *) REG_UART1_TSR)                   /*  Transmit Shift Register */
#define pREG_UART1_RSR                   ((volatile  uint32_t *) REG_UART1_RSR)                   /*  Receive Shift Register */
#define pREG_UART1_TXCNT                 ((volatile  uint32_t *) REG_UART1_TXCNT)                 /*  Transmit Counter Register */
#define pREG_UART1_RXCNT                 ((volatile  uint32_t *) REG_UART1_RXCNT)                 /*  Receive Counter Register */

/*  =================================================================================
 *      UART (UART2)
 *  ================================================================================= */
#define pREG_UART2_CTL                   ((volatile  uint32_t *) REG_UART2_CTL)                   /*  Control Register */
#define pREG_UART2_STAT                  ((volatile  uint32_t *) REG_UART2_STAT)                  /*  Status Register */
#define pREG_UART2_SCR                   ((volatile  uint32_t *) REG_UART2_SCR)                   /*  Scratch Register */
#define pREG_UART2_CLK                   ((volatile  uint32_t *) REG_UART2_CLK)                   /*  Clock Rate Register */
#define pREG_UART2_IMSK                  ((volatile  uint32_t *) REG_UART2_IMSK)                  /*  Interrupt Mask Register */
#define pREG_UART2_IMSK_SET              ((volatile  uint32_t *) REG_UART2_IMSK_SET)              /*  Interrupt Mask Set Register */
#define pREG_UART2_IMSK_CLR              ((volatile  uint32_t *) REG_UART2_IMSK_CLR)              /*  Interrupt Mask Clear Register */
#define pREG_UART2_RBR                   ((volatile  uint32_t *) REG_UART2_RBR)                   /*  Receive Buffer Register */
#define pREG_UART2_THR                   ((volatile  uint32_t *) REG_UART2_THR)                   /*  Transmit Hold Register */
#define pREG_UART2_TAIP                  ((volatile  uint32_t *) REG_UART2_TAIP)                  /*  Transmit Address/Insert Pulse Register */
#define pREG_UART2_TSR                   ((volatile  uint32_t *) REG_UART2_TSR)                   /*  Transmit Shift Register */
#define pREG_UART2_RSR                   ((volatile  uint32_t *) REG_UART2_RSR)                   /*  Receive Shift Register */
#define pREG_UART2_TXCNT                 ((volatile  uint32_t *) REG_UART2_TXCNT)                 /*  Transmit Counter Register */
#define pREG_UART2_RXCNT                 ((volatile  uint32_t *) REG_UART2_RXCNT)                 /*  Receive Counter Register */

/*  =================================================================================
 *      UART (UART3)
 *  ================================================================================= */
#define pREG_UART3_CTL                   ((volatile  uint32_t *) REG_UART3_CTL)                   /*  Control Register */
#define pREG_UART3_STAT                  ((volatile  uint32_t *) REG_UART3_STAT)                  /*  Status Register */
#define pREG_UART3_SCR                   ((volatile  uint32_t *) REG_UART3_SCR)                   /*  Scratch Register */
#define pREG_UART3_CLK                   ((volatile  uint32_t *) REG_UART3_CLK)                   /*  Clock Rate Register */
#define pREG_UART3_IMSK                  ((volatile  uint32_t *) REG_UART3_IMSK)                  /*  Interrupt Mask Register */
#define pREG_UART3_IMSK_SET              ((volatile  uint32_t *) REG_UART3_IMSK_SET)              /*  Interrupt Mask Set Register */
#define pREG_UART3_IMSK_CLR              ((volatile  uint32_t *) REG_UART3_IMSK_CLR)              /*  Interrupt Mask Clear Register */
#define pREG_UART3_RBR                   ((volatile  uint32_t *) REG_UART3_RBR)                   /*  Receive Buffer Register */
#define pREG_UART3_THR                   ((volatile  uint32_t *) REG_UART3_THR)                   /*  Transmit Hold Register */
#define pREG_UART3_TAIP                  ((volatile  uint32_t *) REG_UART3_TAIP)                  /*  Transmit Address/Insert Pulse Register */
#define pREG_UART3_TSR                   ((volatile  uint32_t *) REG_UART3_TSR)                   /*  Transmit Shift Register */
#define pREG_UART3_RSR                   ((volatile  uint32_t *) REG_UART3_RSR)                   /*  Receive Shift Register */
#define pREG_UART3_TXCNT                 ((volatile  uint32_t *) REG_UART3_TXCNT)                 /*  Transmit Counter Register */
#define pREG_UART3_RXCNT                 ((volatile  uint32_t *) REG_UART3_RXCNT)                 /*  Receive Counter Register */

/*  =================================================================================
 *      UART (UART4)
 *  ================================================================================= */
#define pREG_UART4_CTL                   ((volatile  uint32_t *) REG_UART4_CTL)                   /*  Control Register */
#define pREG_UART4_STAT                  ((volatile  uint32_t *) REG_UART4_STAT)                  /*  Status Register */
#define pREG_UART4_SCR                   ((volatile  uint32_t *) REG_UART4_SCR)                   /*  Scratch Register */
#define pREG_UART4_CLK                   ((volatile  uint32_t *) REG_UART4_CLK)                   /*  Clock Rate Register */
#define pREG_UART4_IMSK                  ((volatile  uint32_t *) REG_UART4_IMSK)                  /*  Interrupt Mask Register */
#define pREG_UART4_IMSK_SET              ((volatile  uint32_t *) REG_UART4_IMSK_SET)              /*  Interrupt Mask Set Register */
#define pREG_UART4_IMSK_CLR              ((volatile  uint32_t *) REG_UART4_IMSK_CLR)              /*  Interrupt Mask Clear Register */
#define pREG_UART4_RBR                   ((volatile  uint32_t *) REG_UART4_RBR)                   /*  Receive Buffer Register */
#define pREG_UART4_THR                   ((volatile  uint32_t *) REG_UART4_THR)                   /*  Transmit Hold Register */
#define pREG_UART4_TAIP                  ((volatile  uint32_t *) REG_UART4_TAIP)                  /*  Transmit Address/Insert Pulse Register */
#define pREG_UART4_TSR                   ((volatile  uint32_t *) REG_UART4_TSR)                   /*  Transmit Shift Register */
#define pREG_UART4_RSR                   ((volatile  uint32_t *) REG_UART4_RSR)                   /*  Receive Shift Register */
#define pREG_UART4_TXCNT                 ((volatile  uint32_t *) REG_UART4_TXCNT)                 /*  Transmit Counter Register */
#define pREG_UART4_RXCNT                 ((volatile  uint32_t *) REG_UART4_RXCNT)                 /*  Receive Counter Register */

/*  =================================================================================
 *      FFTB register map. (FFTB0)
 *  ================================================================================= */
#define pREG_FFTB0_CTL                   ((volatile  uint32_t *) REG_FFTB0_CTL)                   /*  FFTB control register */
#define pREG_FFTB0_STAT                  ((volatile  uint32_t *) REG_FFTB0_STAT)                  /*  FFTB Status register */
#define pREG_FFTB0_FMTCTL                ((volatile  uint32_t *) REG_FFTB0_FMTCTL)                /*  Format converter control register */
#define pREG_FFTB0_INOFST                ((volatile  uint32_t *) REG_FFTB0_INOFST)                /*  Input offset register */
#define pREG_FFTB0_COMB                  ((volatile  uint32_t *) REG_FFTB0_COMB)                  /*  FFTB Input Comb Filter Control */
#define pREG_FFTB0_DMABASE               ((volatile  uint32_t *) REG_FFTB0_DMABASE)               /*  DMA output base address */
#define pREG_FFTB0_DMAWR                 ((volatile  uint32_t *) REG_FFTB0_DMAWR)                 /*  DMA output write address */
#define pREG_FFTB0_MAGSEL0               ((volatile  uint32_t *) REG_FFTB0_MAGSEL0)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL1               ((volatile  uint32_t *) REG_FFTB0_MAGSEL1)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL2               ((volatile  uint32_t *) REG_FFTB0_MAGSEL2)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL3               ((volatile  uint32_t *) REG_FFTB0_MAGSEL3)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL4               ((volatile  uint32_t *) REG_FFTB0_MAGSEL4)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL5               ((volatile  uint32_t *) REG_FFTB0_MAGSEL5)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL6               ((volatile  uint32_t *) REG_FFTB0_MAGSEL6)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL7               ((volatile  uint32_t *) REG_FFTB0_MAGSEL7)               /*  Magnitude pin select registers */
#define pREG_FFTB0_MAGSEL8               ((volatile  uint32_t *) REG_FFTB0_MAGSEL8)               /*  Magnitude pin select registers */
#define pREG_FFTB0_LIMSTAT0              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT0)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT1              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT1)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT2              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT2)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT3              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT3)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT4              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT4)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT5              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT5)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT6              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT6)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT7              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT7)              /*  Limit status registers */
#define pREG_FFTB0_LIMSTAT8              ((volatile  uint32_t *) REG_FFTB0_LIMSTAT8)              /*  Limit status registers */
#define pREG_FFTB0_MAXMAG                ((volatile  uint32_t *) REG_FFTB0_MAXMAG)                /*  Maximum magnitude register */
#define pREG_FFTB0_MINMAG                ((volatile  uint32_t *) REG_FFTB0_MINMAG)                /*  Minimum magnitude register */

/*  =================================================================================
 *      SINC (SINC0)
 *  ================================================================================= */
#define pREG_SINC0_CTL                   ((volatile  uint32_t *) REG_SINC0_CTL)                   /*  Control Register */
#define pREG_SINC0_STAT                  ((volatile  uint32_t *) REG_SINC0_STAT)                  /*  Status Register */
#define pREG_SINC0_CLK                   ((volatile  uint32_t *) REG_SINC0_CLK)                   /*  Clock Control Register */
#define pREG_SINC0_RATE0                 ((volatile  uint32_t *) REG_SINC0_RATE0)                 /*  Rate Control for Group 0 Register */
#define pREG_SINC0_LEVEL0                ((volatile  uint32_t *) REG_SINC0_LEVEL0)                /*  Level Control for Group 0 Register */
#define pREG_SINC0_LIMIT0                ((volatile  uint32_t *) REG_SINC0_LIMIT0)                /*  (Amplitude) Limits for Secondary Filter 0 Register */
#define pREG_SINC0_LIMIT1                ((volatile  uint32_t *) REG_SINC0_LIMIT1)                /*  (Amplitude) Limits for Secondary Filter 1 Register */
#define pREG_SINC0_LIMIT2                ((volatile  uint32_t *) REG_SINC0_LIMIT2)                /*  (Amplitude) Limits for Secondary Filter 2 Register */
#define pREG_SINC0_LIMIT3                ((volatile  uint32_t *) REG_SINC0_LIMIT3)                /*  (Amplitude) Limits for Secondary Filter 3 Register */
#define pREG_SINC0_BIAS0                 ((volatile  uint32_t *) REG_SINC0_BIAS0)                 /*  Bias for Group 0 Register */
#define pREG_SINC0_PPTR0                 ((volatile  uint32_t *) REG_SINC0_PPTR0)                 /*  Primary (Filters) Pointer for Group 0 Register */
#define pREG_SINC0_PHEAD0                ((volatile  uint32_t *) REG_SINC0_PHEAD0)                /*  Primary (Filters) Head for Group 0 Register */
#define pREG_SINC0_PTAIL0                ((volatile  uint32_t *) REG_SINC0_PTAIL0)                /*  Primary (Filters) Tail for Group 0 Register */
#define pREG_SINC0_HIS_STAT              ((volatile  uint32_t *) REG_SINC0_HIS_STAT)              /*  History Status Register */
#define pREG_SINC0_P0SEC_HIST0           ((volatile  uint32_t *) REG_SINC0_P0SEC_HIST0)           /*  Pair 0 Secondary (Filter) History n Register */
#define pREG_SINC0_P0SEC_HIST1           ((volatile  uint32_t *) REG_SINC0_P0SEC_HIST1)           /*  Pair 0 Secondary (Filter) History n Register */
#define pREG_SINC0_P0SEC_HIST2           ((volatile  uint32_t *) REG_SINC0_P0SEC_HIST2)           /*  Pair 0 Secondary (Filter) History n Register */
#define pREG_SINC0_P0SEC_HIST3           ((volatile  uint32_t *) REG_SINC0_P0SEC_HIST3)           /*  Pair 0 Secondary (Filter) History n Register */
#define pREG_SINC0_P1SEC_HIST0           ((volatile  uint32_t *) REG_SINC0_P1SEC_HIST0)           /*  Pair 1 Secondary (Filter) History n Register */
#define pREG_SINC0_P1SEC_HIST1           ((volatile  uint32_t *) REG_SINC0_P1SEC_HIST1)           /*  Pair 1 Secondary (Filter) History n Register */
#define pREG_SINC0_P1SEC_HIST2           ((volatile  uint32_t *) REG_SINC0_P1SEC_HIST2)           /*  Pair 1 Secondary (Filter) History n Register */
#define pREG_SINC0_P1SEC_HIST3           ((volatile  uint32_t *) REG_SINC0_P1SEC_HIST3)           /*  Pair 1 Secondary (Filter) History n Register */
#define pREG_SINC0_P2SEC_HIST0           ((volatile  uint32_t *) REG_SINC0_P2SEC_HIST0)           /*  Pair 2 Secondary (Filter) History n Register */
#define pREG_SINC0_P2SEC_HIST1           ((volatile  uint32_t *) REG_SINC0_P2SEC_HIST1)           /*  Pair 2 Secondary (Filter) History n Register */
#define pREG_SINC0_P2SEC_HIST2           ((volatile  uint32_t *) REG_SINC0_P2SEC_HIST2)           /*  Pair 2 Secondary (Filter) History n Register */
#define pREG_SINC0_P2SEC_HIST3           ((volatile  uint32_t *) REG_SINC0_P2SEC_HIST3)           /*  Pair 2 Secondary (Filter) History n Register */
#define pREG_SINC0_P3SEC_HIST0           ((volatile  uint32_t *) REG_SINC0_P3SEC_HIST0)           /*  Pair 3 Secondary (Filter) History n Register */
#define pREG_SINC0_P3SEC_HIST1           ((volatile  uint32_t *) REG_SINC0_P3SEC_HIST1)           /*  Pair 3 Secondary (Filter) History n Register */
#define pREG_SINC0_P3SEC_HIST2           ((volatile  uint32_t *) REG_SINC0_P3SEC_HIST2)           /*  Pair 3 Secondary (Filter) History n Register */
#define pREG_SINC0_P3SEC_HIST3           ((volatile  uint32_t *) REG_SINC0_P3SEC_HIST3)           /*  Pair 3 Secondary (Filter) History n Register */

/*  =================================================================================
 *      ADC Controller (ADCC0)
 *  ================================================================================= */
#define pREG_ADCC0_CTL                   ((volatile  uint32_t *) REG_ADCC0_CTL)                   /*  Control Register */
#define pREG_ADCC0_ERRSTAT               ((volatile  uint32_t *) REG_ADCC0_ERRSTAT)               /*  Error Status Register */
#define pREG_ADCC0_ERRMSK                ((volatile  uint32_t *) REG_ADCC0_ERRMSK)                /*  Error Mask Register */
#define pREG_ADCC0_ERRMSK_SET            ((volatile  uint32_t *) REG_ADCC0_ERRMSK_SET)            /*  Error Mask Set Register */
#define pREG_ADCC0_ERRMSK_CLR            ((volatile  uint32_t *) REG_ADCC0_ERRMSK_CLR)            /*  Error Mask Clear Register */
#define pREG_ADCC0_EISTAT                ((volatile  uint32_t *) REG_ADCC0_EISTAT)                /*  Event Interrupt Status Register */
#define pREG_ADCC0_EIMSK                 ((volatile  uint32_t *) REG_ADCC0_EIMSK)                 /*  Event Interrupt Mask Register */
#define pREG_ADCC0_EIMSK_SET             ((volatile  uint32_t *) REG_ADCC0_EIMSK_SET)             /*  Event Interrupt Mask Set Register */
#define pREG_ADCC0_EIMSK_CLR             ((volatile  uint32_t *) REG_ADCC0_EIMSK_CLR)             /*  Event Interrupt Mask Clear Register */
#define pREG_ADCC0_FISTAT                ((volatile  uint32_t *) REG_ADCC0_FISTAT)                /*  Frame Interrupt Status Register */
#define pREG_ADCC0_FIMSK                 ((volatile  uint32_t *) REG_ADCC0_FIMSK)                 /*  Frame Interrupt Mask Register */
#define pREG_ADCC0_FIMSK_SET             ((volatile  uint32_t *) REG_ADCC0_FIMSK_SET)             /*  Frame Interrupt Mask Set Register */
#define pREG_ADCC0_FIMSK_CLR             ((volatile  uint32_t *) REG_ADCC0_FIMSK_CLR)             /*  Frame Interrupt Mask Clear Register */
#define pREG_ADCC0_EVTEN                 ((volatile  uint32_t *) REG_ADCC0_EVTEN)                 /*  Event Enable Register */
#define pREG_ADCC0_EVTEN_SET             ((volatile  uint32_t *) REG_ADCC0_EVTEN_SET)             /*  Event Enable Set Register */
#define pREG_ADCC0_EVTEN_CLR             ((volatile  uint32_t *) REG_ADCC0_EVTEN_CLR)             /*  Event Enable Clear Register */
#define pREG_ADCC0_ECOL                  ((volatile  uint32_t *) REG_ADCC0_ECOL)                  /*  Event Collision Status Register */
#define pREG_ADCC0_EMISS                 ((volatile  uint32_t *) REG_ADCC0_EMISS)                 /*  Event Miss Status Register */
#define pREG_ADCC0_BPTR0                 ((volatile  uint32_t *) REG_ADCC0_BPTR0)                 /*  Base Pointer 0 Register */
#define pREG_ADCC0_FRINC0                ((volatile  uint32_t *) REG_ADCC0_FRINC0)                /*  Frame Increment 0 Register */
#define pREG_ADCC0_CBSIZ0                ((volatile  uint32_t *) REG_ADCC0_CBSIZ0)                /*  Circular Buffer Size 0 Register */
#define pREG_ADCC0_TCA0                  ((volatile  uint32_t *) REG_ADCC0_TCA0)                  /*  Timing Control A (ADC0) Register */
#define pREG_ADCC0_TCB0                  ((volatile  uint32_t *) REG_ADCC0_TCB0)                  /*  Timing Control B (ADC0) Register */
#define pREG_ADCC0_BWMON0                ((volatile  uint32_t *) REG_ADCC0_BWMON0)                /*  Bandwidth Monitor 0 Register */
#define pREG_ADCC0_BPTR1                 ((volatile  uint32_t *) REG_ADCC0_BPTR1)                 /*  DMA Base Pointer 1 Register */
#define pREG_ADCC0_FRINC1                ((volatile  uint32_t *) REG_ADCC0_FRINC1)                /*  Frame Increment 1 Register */
#define pREG_ADCC0_CBSIZ1                ((volatile  uint32_t *) REG_ADCC0_CBSIZ1)                /*  Circular Buffer Size 1 Register */
#define pREG_ADCC0_TCA1                  ((volatile  uint32_t *) REG_ADCC0_TCA1)                  /*  Timing Control A (ADC1) Register */
#define pREG_ADCC0_TCB1                  ((volatile  uint32_t *) REG_ADCC0_TCB1)                  /*  Timing Control B (ADC1) Register */
#define pREG_ADCC0_BWMON1                ((volatile  uint32_t *) REG_ADCC0_BWMON1)                /*  Bandwidth Monitor 1 Register */
#define pREG_ADCC0_EVT00                 ((volatile  uint32_t *) REG_ADCC0_EVT00)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL00               ((volatile  uint32_t *) REG_ADCC0_EVCTL00)               /*  Event n Control Register */
#define pREG_ADCC0_EVT01                 ((volatile  uint32_t *) REG_ADCC0_EVT01)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL01               ((volatile  uint32_t *) REG_ADCC0_EVCTL01)               /*  Event n Control Register */
#define pREG_ADCC0_EVT02                 ((volatile  uint32_t *) REG_ADCC0_EVT02)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL02               ((volatile  uint32_t *) REG_ADCC0_EVCTL02)               /*  Event n Control Register */
#define pREG_ADCC0_EVT03                 ((volatile  uint32_t *) REG_ADCC0_EVT03)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL03               ((volatile  uint32_t *) REG_ADCC0_EVCTL03)               /*  Event n Control Register */
#define pREG_ADCC0_EVT04                 ((volatile  uint32_t *) REG_ADCC0_EVT04)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL04               ((volatile  uint32_t *) REG_ADCC0_EVCTL04)               /*  Event n Control Register */
#define pREG_ADCC0_EVT05                 ((volatile  uint32_t *) REG_ADCC0_EVT05)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL05               ((volatile  uint32_t *) REG_ADCC0_EVCTL05)               /*  Event n Control Register */
#define pREG_ADCC0_EVT06                 ((volatile  uint32_t *) REG_ADCC0_EVT06)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL06               ((volatile  uint32_t *) REG_ADCC0_EVCTL06)               /*  Event n Control Register */
#define pREG_ADCC0_EVT07                 ((volatile  uint32_t *) REG_ADCC0_EVT07)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL07               ((volatile  uint32_t *) REG_ADCC0_EVCTL07)               /*  Event n Control Register */
#define pREG_ADCC0_EVT08                 ((volatile  uint32_t *) REG_ADCC0_EVT08)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL08               ((volatile  uint32_t *) REG_ADCC0_EVCTL08)               /*  Event n Control Register */
#define pREG_ADCC0_EVT09                 ((volatile  uint32_t *) REG_ADCC0_EVT09)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL09               ((volatile  uint32_t *) REG_ADCC0_EVCTL09)               /*  Event n Control Register */
#define pREG_ADCC0_EVT10                 ((volatile  uint32_t *) REG_ADCC0_EVT10)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL10               ((volatile  uint32_t *) REG_ADCC0_EVCTL10)               /*  Event n Control Register */
#define pREG_ADCC0_EVT11                 ((volatile  uint32_t *) REG_ADCC0_EVT11)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL11               ((volatile  uint32_t *) REG_ADCC0_EVCTL11)               /*  Event n Control Register */
#define pREG_ADCC0_EVT12                 ((volatile  uint32_t *) REG_ADCC0_EVT12)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL12               ((volatile  uint32_t *) REG_ADCC0_EVCTL12)               /*  Event n Control Register */
#define pREG_ADCC0_EVT13                 ((volatile  uint32_t *) REG_ADCC0_EVT13)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL13               ((volatile  uint32_t *) REG_ADCC0_EVCTL13)               /*  Event n Control Register */
#define pREG_ADCC0_EVT14                 ((volatile  uint32_t *) REG_ADCC0_EVT14)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL14               ((volatile  uint32_t *) REG_ADCC0_EVCTL14)               /*  Event n Control Register */
#define pREG_ADCC0_EVT15                 ((volatile  uint32_t *) REG_ADCC0_EVT15)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL15               ((volatile  uint32_t *) REG_ADCC0_EVCTL15)               /*  Event n Control Register */
#define pREG_ADCC0_EVT16                 ((volatile  uint32_t *) REG_ADCC0_EVT16)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL16               ((volatile  uint32_t *) REG_ADCC0_EVCTL16)               /*  Event n Control Register */
#define pREG_ADCC0_EVT17                 ((volatile  uint32_t *) REG_ADCC0_EVT17)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL17               ((volatile  uint32_t *) REG_ADCC0_EVCTL17)               /*  Event n Control Register */
#define pREG_ADCC0_EVT18                 ((volatile  uint32_t *) REG_ADCC0_EVT18)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL18               ((volatile  uint32_t *) REG_ADCC0_EVCTL18)               /*  Event n Control Register */
#define pREG_ADCC0_EVT19                 ((volatile  uint32_t *) REG_ADCC0_EVT19)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL19               ((volatile  uint32_t *) REG_ADCC0_EVCTL19)               /*  Event n Control Register */
#define pREG_ADCC0_EVT20                 ((volatile  uint32_t *) REG_ADCC0_EVT20)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL20               ((volatile  uint32_t *) REG_ADCC0_EVCTL20)               /*  Event n Control Register */
#define pREG_ADCC0_EVT21                 ((volatile  uint32_t *) REG_ADCC0_EVT21)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL21               ((volatile  uint32_t *) REG_ADCC0_EVCTL21)               /*  Event n Control Register */
#define pREG_ADCC0_EVT22                 ((volatile  uint32_t *) REG_ADCC0_EVT22)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL22               ((volatile  uint32_t *) REG_ADCC0_EVCTL22)               /*  Event n Control Register */
#define pREG_ADCC0_EVT23                 ((volatile  uint32_t *) REG_ADCC0_EVT23)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL23               ((volatile  uint32_t *) REG_ADCC0_EVCTL23)               /*  Event n Control Register */
#define pREG_ADCC0_EVT24                 ((volatile  uint32_t *) REG_ADCC0_EVT24)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL24               ((volatile  uint32_t *) REG_ADCC0_EVCTL24)               /*  Event n Control Register */
#define pREG_ADCC0_EVT25                 ((volatile  uint32_t *) REG_ADCC0_EVT25)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL25               ((volatile  uint32_t *) REG_ADCC0_EVCTL25)               /*  Event n Control Register */
#define pREG_ADCC0_EVT26                 ((volatile  uint32_t *) REG_ADCC0_EVT26)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL26               ((volatile  uint32_t *) REG_ADCC0_EVCTL26)               /*  Event n Control Register */
#define pREG_ADCC0_EVT27                 ((volatile  uint32_t *) REG_ADCC0_EVT27)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL27               ((volatile  uint32_t *) REG_ADCC0_EVCTL27)               /*  Event n Control Register */
#define pREG_ADCC0_EVT28                 ((volatile  uint32_t *) REG_ADCC0_EVT28)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL28               ((volatile  uint32_t *) REG_ADCC0_EVCTL28)               /*  Event n Control Register */
#define pREG_ADCC0_EVT29                 ((volatile  uint32_t *) REG_ADCC0_EVT29)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL29               ((volatile  uint32_t *) REG_ADCC0_EVCTL29)               /*  Event n Control Register */
#define pREG_ADCC0_EVT30                 ((volatile  uint32_t *) REG_ADCC0_EVT30)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL30               ((volatile  uint32_t *) REG_ADCC0_EVCTL30)               /*  Event n Control Register */
#define pREG_ADCC0_EVT31                 ((volatile  uint32_t *) REG_ADCC0_EVT31)                 /*  Event n Time Register */
#define pREG_ADCC0_EVCTL31               ((volatile  uint32_t *) REG_ADCC0_EVCTL31)               /*  Event n Control Register */
#define pREG_ADCC0_NUMFRAM0              ((volatile  uint32_t *) REG_ADCC0_NUMFRAM0)              /*  Timer0 Frame Limit count for firing FINT0 */
#define pREG_ADCC0_NUMFRAM1              ((volatile  uint32_t *) REG_ADCC0_NUMFRAM1)              /*  Timer1 Frame Limit count for firing FINT1 */
#define pREG_ADCC0_DATOVF                ((volatile  uint32_t *) REG_ADCC0_DATOVF)                /*  Data overflow indication register */
#define pREG_ADCC0_EPND                  ((volatile  uint32_t *) REG_ADCC0_EPND)                  /*  Pending Events Status Register */
#define pREG_ADCC0_T0STAT                ((volatile  uint32_t *) REG_ADCC0_T0STAT)                /*  Timer 0 Status Register */
#define pREG_ADCC0_TMR0                  ((volatile  uint32_t *) REG_ADCC0_TMR0)                  /*  Timer 0 Current Count Register */
#define pREG_ADCC0_T1STAT                ((volatile  uint32_t *) REG_ADCC0_T1STAT)                /*  Timer 1 Status Register */
#define pREG_ADCC0_TMR1                  ((volatile  uint32_t *) REG_ADCC0_TMR1)                  /*  Timer 1 Current Count Register */
#define pREG_ADCC0_EVDAT00               ((volatile  uint32_t *) REG_ADCC0_EVDAT00)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT01               ((volatile  uint32_t *) REG_ADCC0_EVDAT01)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT02               ((volatile  uint32_t *) REG_ADCC0_EVDAT02)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT03               ((volatile  uint32_t *) REG_ADCC0_EVDAT03)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT04               ((volatile  uint32_t *) REG_ADCC0_EVDAT04)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT05               ((volatile  uint32_t *) REG_ADCC0_EVDAT05)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT06               ((volatile  uint32_t *) REG_ADCC0_EVDAT06)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT07               ((volatile  uint32_t *) REG_ADCC0_EVDAT07)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT08               ((volatile  uint32_t *) REG_ADCC0_EVDAT08)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT09               ((volatile  uint32_t *) REG_ADCC0_EVDAT09)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT10               ((volatile  uint32_t *) REG_ADCC0_EVDAT10)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT11               ((volatile  uint32_t *) REG_ADCC0_EVDAT11)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT12               ((volatile  uint32_t *) REG_ADCC0_EVDAT12)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT13               ((volatile  uint32_t *) REG_ADCC0_EVDAT13)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT14               ((volatile  uint32_t *) REG_ADCC0_EVDAT14)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT15               ((volatile  uint32_t *) REG_ADCC0_EVDAT15)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT16               ((volatile  uint32_t *) REG_ADCC0_EVDAT16)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT17               ((volatile  uint32_t *) REG_ADCC0_EVDAT17)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT18               ((volatile  uint32_t *) REG_ADCC0_EVDAT18)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT19               ((volatile  uint32_t *) REG_ADCC0_EVDAT19)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT20               ((volatile  uint32_t *) REG_ADCC0_EVDAT20)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT21               ((volatile  uint32_t *) REG_ADCC0_EVDAT21)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT22               ((volatile  uint32_t *) REG_ADCC0_EVDAT22)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT23               ((volatile  uint32_t *) REG_ADCC0_EVDAT23)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT24               ((volatile  uint32_t *) REG_ADCC0_EVDAT24)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT25               ((volatile  uint32_t *) REG_ADCC0_EVDAT25)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT26               ((volatile  uint32_t *) REG_ADCC0_EVDAT26)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT27               ((volatile  uint32_t *) REG_ADCC0_EVDAT27)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT28               ((volatile  uint32_t *) REG_ADCC0_EVDAT28)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT29               ((volatile  uint32_t *) REG_ADCC0_EVDAT29)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT30               ((volatile  uint32_t *) REG_ADCC0_EVDAT30)               /*  Event n Data Register */
#define pREG_ADCC0_EVDAT31               ((volatile  uint32_t *) REG_ADCC0_EVDAT31)               /*  Event n Data Register */
#define pREG_ADCC0_EVSTAT00              ((volatile  uint32_t *) REG_ADCC0_EVSTAT00)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT01              ((volatile  uint32_t *) REG_ADCC0_EVSTAT01)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT02              ((volatile  uint32_t *) REG_ADCC0_EVSTAT02)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT03              ((volatile  uint32_t *) REG_ADCC0_EVSTAT03)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT04              ((volatile  uint32_t *) REG_ADCC0_EVSTAT04)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT05              ((volatile  uint32_t *) REG_ADCC0_EVSTAT05)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT06              ((volatile  uint32_t *) REG_ADCC0_EVSTAT06)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT07              ((volatile  uint32_t *) REG_ADCC0_EVSTAT07)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT08              ((volatile  uint32_t *) REG_ADCC0_EVSTAT08)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT09              ((volatile  uint32_t *) REG_ADCC0_EVSTAT09)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT10              ((volatile  uint32_t *) REG_ADCC0_EVSTAT10)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT11              ((volatile  uint32_t *) REG_ADCC0_EVSTAT11)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT12              ((volatile  uint32_t *) REG_ADCC0_EVSTAT12)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT13              ((volatile  uint32_t *) REG_ADCC0_EVSTAT13)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT14              ((volatile  uint32_t *) REG_ADCC0_EVSTAT14)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT15              ((volatile  uint32_t *) REG_ADCC0_EVSTAT15)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT16              ((volatile  uint32_t *) REG_ADCC0_EVSTAT16)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT17              ((volatile  uint32_t *) REG_ADCC0_EVSTAT17)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT18              ((volatile  uint32_t *) REG_ADCC0_EVSTAT18)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT19              ((volatile  uint32_t *) REG_ADCC0_EVSTAT19)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT20              ((volatile  uint32_t *) REG_ADCC0_EVSTAT20)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT21              ((volatile  uint32_t *) REG_ADCC0_EVSTAT21)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT22              ((volatile  uint32_t *) REG_ADCC0_EVSTAT22)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT23              ((volatile  uint32_t *) REG_ADCC0_EVSTAT23)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT24              ((volatile  uint32_t *) REG_ADCC0_EVSTAT24)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT25              ((volatile  uint32_t *) REG_ADCC0_EVSTAT25)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT26              ((volatile  uint32_t *) REG_ADCC0_EVSTAT26)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT27              ((volatile  uint32_t *) REG_ADCC0_EVSTAT27)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT28              ((volatile  uint32_t *) REG_ADCC0_EVSTAT28)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT29              ((volatile  uint32_t *) REG_ADCC0_EVSTAT29)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT30              ((volatile  uint32_t *) REG_ADCC0_EVSTAT30)              /*  Event n Status Register */
#define pREG_ADCC0_EVSTAT31              ((volatile  uint32_t *) REG_ADCC0_EVSTAT31)              /*  Event n Status Register */
#define pREG_ADCC0_CBNUM0                ((volatile  uint32_t *) REG_ADCC0_CBNUM0)                /*  Number of Wraps completed by TIMER0 Circular buffer DMA */
#define pREG_ADCC0_CBNUM1                ((volatile  uint32_t *) REG_ADCC0_CBNUM1)                /*  Number of Wraps completed by TIMER1 Circular buffer DMA */
#define pREG_ADCC0_TRGCNT0               ((volatile  uint32_t *) REG_ADCC0_TRGCNT0)               /*  Trigger count of TIMER0 */
#define pREG_ADCC0_TRGCNT1               ((volatile  uint32_t *) REG_ADCC0_TRGCNT1)               /*  Trigger count of TIMER1 */
#define pREG_ADCC0_ADCRW0                ((volatile  uint32_t *) REG_ADCC0_ADCRW0)                /*  ADC0 Interface RW Access Register */
#define pREG_ADCC0_ADCRW1                ((volatile  uint32_t *) REG_ADCC0_ADCRW1)                /*  ADC1 Interface RW Access Register */

/*  =================================================================================
 *      ADC Controller (ADCC1)
 *  ================================================================================= */
#define pREG_ADCC1_CTL                   ((volatile  uint32_t *) REG_ADCC1_CTL)                   /*  Control Register */
#define pREG_ADCC1_ERRSTAT               ((volatile  uint32_t *) REG_ADCC1_ERRSTAT)               /*  Error Status Register */
#define pREG_ADCC1_ERRMSK                ((volatile  uint32_t *) REG_ADCC1_ERRMSK)                /*  Error Mask Register */
#define pREG_ADCC1_ERRMSK_SET            ((volatile  uint32_t *) REG_ADCC1_ERRMSK_SET)            /*  Error Mask Set Register */
#define pREG_ADCC1_ERRMSK_CLR            ((volatile  uint32_t *) REG_ADCC1_ERRMSK_CLR)            /*  Error Mask Clear Register */
#define pREG_ADCC1_EISTAT                ((volatile  uint32_t *) REG_ADCC1_EISTAT)                /*  Event Interrupt Status Register */
#define pREG_ADCC1_EIMSK                 ((volatile  uint32_t *) REG_ADCC1_EIMSK)                 /*  Event Interrupt Mask Register */
#define pREG_ADCC1_EIMSK_SET             ((volatile  uint32_t *) REG_ADCC1_EIMSK_SET)             /*  Event Interrupt Mask Set Register */
#define pREG_ADCC1_EIMSK_CLR             ((volatile  uint32_t *) REG_ADCC1_EIMSK_CLR)             /*  Event Interrupt Mask Clear Register */
#define pREG_ADCC1_FISTAT                ((volatile  uint32_t *) REG_ADCC1_FISTAT)                /*  Frame Interrupt Status Register */
#define pREG_ADCC1_FIMSK                 ((volatile  uint32_t *) REG_ADCC1_FIMSK)                 /*  Frame Interrupt Mask Register */
#define pREG_ADCC1_FIMSK_SET             ((volatile  uint32_t *) REG_ADCC1_FIMSK_SET)             /*  Frame Interrupt Mask Set Register */
#define pREG_ADCC1_FIMSK_CLR             ((volatile  uint32_t *) REG_ADCC1_FIMSK_CLR)             /*  Frame Interrupt Mask Clear Register */
#define pREG_ADCC1_EVTEN                 ((volatile  uint32_t *) REG_ADCC1_EVTEN)                 /*  Event Enable Register */
#define pREG_ADCC1_EVTEN_SET             ((volatile  uint32_t *) REG_ADCC1_EVTEN_SET)             /*  Event Enable Set Register */
#define pREG_ADCC1_EVTEN_CLR             ((volatile  uint32_t *) REG_ADCC1_EVTEN_CLR)             /*  Event Enable Clear Register */
#define pREG_ADCC1_ECOL                  ((volatile  uint32_t *) REG_ADCC1_ECOL)                  /*  Event Collision Status Register */
#define pREG_ADCC1_EMISS                 ((volatile  uint32_t *) REG_ADCC1_EMISS)                 /*  Event Miss Status Register */
#define pREG_ADCC1_BPTR0                 ((volatile  uint32_t *) REG_ADCC1_BPTR0)                 /*  Base Pointer 0 Register */
#define pREG_ADCC1_FRINC0                ((volatile  uint32_t *) REG_ADCC1_FRINC0)                /*  Frame Increment 0 Register */
#define pREG_ADCC1_CBSIZ0                ((volatile  uint32_t *) REG_ADCC1_CBSIZ0)                /*  Circular Buffer Size 0 Register */
#define pREG_ADCC1_TCA0                  ((volatile  uint32_t *) REG_ADCC1_TCA0)                  /*  Timing Control A (ADC0) Register */
#define pREG_ADCC1_TCB0                  ((volatile  uint32_t *) REG_ADCC1_TCB0)                  /*  Timing Control B (ADC0) Register */
#define pREG_ADCC1_BWMON0                ((volatile  uint32_t *) REG_ADCC1_BWMON0)                /*  Bandwidth Monitor 0 Register */
#define pREG_ADCC1_BPTR1                 ((volatile  uint32_t *) REG_ADCC1_BPTR1)                 /*  DMA Base Pointer 1 Register */
#define pREG_ADCC1_FRINC1                ((volatile  uint32_t *) REG_ADCC1_FRINC1)                /*  Frame Increment 1 Register */
#define pREG_ADCC1_CBSIZ1                ((volatile  uint32_t *) REG_ADCC1_CBSIZ1)                /*  Circular Buffer Size 1 Register */
#define pREG_ADCC1_TCA1                  ((volatile  uint32_t *) REG_ADCC1_TCA1)                  /*  Timing Control A (ADC1) Register */
#define pREG_ADCC1_TCB1                  ((volatile  uint32_t *) REG_ADCC1_TCB1)                  /*  Timing Control B (ADC1) Register */
#define pREG_ADCC1_BWMON1                ((volatile  uint32_t *) REG_ADCC1_BWMON1)                /*  Bandwidth Monitor 1 Register */
#define pREG_ADCC1_EVT00                 ((volatile  uint32_t *) REG_ADCC1_EVT00)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL00               ((volatile  uint32_t *) REG_ADCC1_EVCTL00)               /*  Event n Control Register */
#define pREG_ADCC1_EVT01                 ((volatile  uint32_t *) REG_ADCC1_EVT01)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL01               ((volatile  uint32_t *) REG_ADCC1_EVCTL01)               /*  Event n Control Register */
#define pREG_ADCC1_EVT02                 ((volatile  uint32_t *) REG_ADCC1_EVT02)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL02               ((volatile  uint32_t *) REG_ADCC1_EVCTL02)               /*  Event n Control Register */
#define pREG_ADCC1_EVT03                 ((volatile  uint32_t *) REG_ADCC1_EVT03)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL03               ((volatile  uint32_t *) REG_ADCC1_EVCTL03)               /*  Event n Control Register */
#define pREG_ADCC1_EVT04                 ((volatile  uint32_t *) REG_ADCC1_EVT04)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL04               ((volatile  uint32_t *) REG_ADCC1_EVCTL04)               /*  Event n Control Register */
#define pREG_ADCC1_EVT05                 ((volatile  uint32_t *) REG_ADCC1_EVT05)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL05               ((volatile  uint32_t *) REG_ADCC1_EVCTL05)               /*  Event n Control Register */
#define pREG_ADCC1_EVT06                 ((volatile  uint32_t *) REG_ADCC1_EVT06)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL06               ((volatile  uint32_t *) REG_ADCC1_EVCTL06)               /*  Event n Control Register */
#define pREG_ADCC1_EVT07                 ((volatile  uint32_t *) REG_ADCC1_EVT07)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL07               ((volatile  uint32_t *) REG_ADCC1_EVCTL07)               /*  Event n Control Register */
#define pREG_ADCC1_EVT08                 ((volatile  uint32_t *) REG_ADCC1_EVT08)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL08               ((volatile  uint32_t *) REG_ADCC1_EVCTL08)               /*  Event n Control Register */
#define pREG_ADCC1_EVT09                 ((volatile  uint32_t *) REG_ADCC1_EVT09)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL09               ((volatile  uint32_t *) REG_ADCC1_EVCTL09)               /*  Event n Control Register */
#define pREG_ADCC1_EVT10                 ((volatile  uint32_t *) REG_ADCC1_EVT10)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL10               ((volatile  uint32_t *) REG_ADCC1_EVCTL10)               /*  Event n Control Register */
#define pREG_ADCC1_EVT11                 ((volatile  uint32_t *) REG_ADCC1_EVT11)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL11               ((volatile  uint32_t *) REG_ADCC1_EVCTL11)               /*  Event n Control Register */
#define pREG_ADCC1_EVT12                 ((volatile  uint32_t *) REG_ADCC1_EVT12)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL12               ((volatile  uint32_t *) REG_ADCC1_EVCTL12)               /*  Event n Control Register */
#define pREG_ADCC1_EVT13                 ((volatile  uint32_t *) REG_ADCC1_EVT13)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL13               ((volatile  uint32_t *) REG_ADCC1_EVCTL13)               /*  Event n Control Register */
#define pREG_ADCC1_EVT14                 ((volatile  uint32_t *) REG_ADCC1_EVT14)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL14               ((volatile  uint32_t *) REG_ADCC1_EVCTL14)               /*  Event n Control Register */
#define pREG_ADCC1_EVT15                 ((volatile  uint32_t *) REG_ADCC1_EVT15)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL15               ((volatile  uint32_t *) REG_ADCC1_EVCTL15)               /*  Event n Control Register */
#define pREG_ADCC1_EVT16                 ((volatile  uint32_t *) REG_ADCC1_EVT16)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL16               ((volatile  uint32_t *) REG_ADCC1_EVCTL16)               /*  Event n Control Register */
#define pREG_ADCC1_EVT17                 ((volatile  uint32_t *) REG_ADCC1_EVT17)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL17               ((volatile  uint32_t *) REG_ADCC1_EVCTL17)               /*  Event n Control Register */
#define pREG_ADCC1_EVT18                 ((volatile  uint32_t *) REG_ADCC1_EVT18)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL18               ((volatile  uint32_t *) REG_ADCC1_EVCTL18)               /*  Event n Control Register */
#define pREG_ADCC1_EVT19                 ((volatile  uint32_t *) REG_ADCC1_EVT19)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL19               ((volatile  uint32_t *) REG_ADCC1_EVCTL19)               /*  Event n Control Register */
#define pREG_ADCC1_EVT20                 ((volatile  uint32_t *) REG_ADCC1_EVT20)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL20               ((volatile  uint32_t *) REG_ADCC1_EVCTL20)               /*  Event n Control Register */
#define pREG_ADCC1_EVT21                 ((volatile  uint32_t *) REG_ADCC1_EVT21)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL21               ((volatile  uint32_t *) REG_ADCC1_EVCTL21)               /*  Event n Control Register */
#define pREG_ADCC1_EVT22                 ((volatile  uint32_t *) REG_ADCC1_EVT22)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL22               ((volatile  uint32_t *) REG_ADCC1_EVCTL22)               /*  Event n Control Register */
#define pREG_ADCC1_EVT23                 ((volatile  uint32_t *) REG_ADCC1_EVT23)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL23               ((volatile  uint32_t *) REG_ADCC1_EVCTL23)               /*  Event n Control Register */
#define pREG_ADCC1_EVT24                 ((volatile  uint32_t *) REG_ADCC1_EVT24)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL24               ((volatile  uint32_t *) REG_ADCC1_EVCTL24)               /*  Event n Control Register */
#define pREG_ADCC1_EVT25                 ((volatile  uint32_t *) REG_ADCC1_EVT25)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL25               ((volatile  uint32_t *) REG_ADCC1_EVCTL25)               /*  Event n Control Register */
#define pREG_ADCC1_EVT26                 ((volatile  uint32_t *) REG_ADCC1_EVT26)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL26               ((volatile  uint32_t *) REG_ADCC1_EVCTL26)               /*  Event n Control Register */
#define pREG_ADCC1_EVT27                 ((volatile  uint32_t *) REG_ADCC1_EVT27)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL27               ((volatile  uint32_t *) REG_ADCC1_EVCTL27)               /*  Event n Control Register */
#define pREG_ADCC1_EVT28                 ((volatile  uint32_t *) REG_ADCC1_EVT28)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL28               ((volatile  uint32_t *) REG_ADCC1_EVCTL28)               /*  Event n Control Register */
#define pREG_ADCC1_EVT29                 ((volatile  uint32_t *) REG_ADCC1_EVT29)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL29               ((volatile  uint32_t *) REG_ADCC1_EVCTL29)               /*  Event n Control Register */
#define pREG_ADCC1_EVT30                 ((volatile  uint32_t *) REG_ADCC1_EVT30)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL30               ((volatile  uint32_t *) REG_ADCC1_EVCTL30)               /*  Event n Control Register */
#define pREG_ADCC1_EVT31                 ((volatile  uint32_t *) REG_ADCC1_EVT31)                 /*  Event n Time Register */
#define pREG_ADCC1_EVCTL31               ((volatile  uint32_t *) REG_ADCC1_EVCTL31)               /*  Event n Control Register */
#define pREG_ADCC1_NUMFRAM0              ((volatile  uint32_t *) REG_ADCC1_NUMFRAM0)              /*  Timer0 Frame Limit count for firing FINT0 */
#define pREG_ADCC1_NUMFRAM1              ((volatile  uint32_t *) REG_ADCC1_NUMFRAM1)              /*  Timer1 Frame Limit count for firing FINT1 */
#define pREG_ADCC1_DATOVF                ((volatile  uint32_t *) REG_ADCC1_DATOVF)                /*  Data overflow indication register */
#define pREG_ADCC1_EPND                  ((volatile  uint32_t *) REG_ADCC1_EPND)                  /*  Pending Events Status Register */
#define pREG_ADCC1_T0STAT                ((volatile  uint32_t *) REG_ADCC1_T0STAT)                /*  Timer 0 Status Register */
#define pREG_ADCC1_TMR0                  ((volatile  uint32_t *) REG_ADCC1_TMR0)                  /*  Timer 0 Current Count Register */
#define pREG_ADCC1_T1STAT                ((volatile  uint32_t *) REG_ADCC1_T1STAT)                /*  Timer 1 Status Register */
#define pREG_ADCC1_TMR1                  ((volatile  uint32_t *) REG_ADCC1_TMR1)                  /*  Timer 1 Current Count Register */
#define pREG_ADCC1_EVDAT00               ((volatile  uint32_t *) REG_ADCC1_EVDAT00)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT01               ((volatile  uint32_t *) REG_ADCC1_EVDAT01)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT02               ((volatile  uint32_t *) REG_ADCC1_EVDAT02)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT03               ((volatile  uint32_t *) REG_ADCC1_EVDAT03)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT04               ((volatile  uint32_t *) REG_ADCC1_EVDAT04)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT05               ((volatile  uint32_t *) REG_ADCC1_EVDAT05)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT06               ((volatile  uint32_t *) REG_ADCC1_EVDAT06)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT07               ((volatile  uint32_t *) REG_ADCC1_EVDAT07)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT08               ((volatile  uint32_t *) REG_ADCC1_EVDAT08)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT09               ((volatile  uint32_t *) REG_ADCC1_EVDAT09)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT10               ((volatile  uint32_t *) REG_ADCC1_EVDAT10)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT11               ((volatile  uint32_t *) REG_ADCC1_EVDAT11)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT12               ((volatile  uint32_t *) REG_ADCC1_EVDAT12)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT13               ((volatile  uint32_t *) REG_ADCC1_EVDAT13)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT14               ((volatile  uint32_t *) REG_ADCC1_EVDAT14)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT15               ((volatile  uint32_t *) REG_ADCC1_EVDAT15)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT16               ((volatile  uint32_t *) REG_ADCC1_EVDAT16)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT17               ((volatile  uint32_t *) REG_ADCC1_EVDAT17)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT18               ((volatile  uint32_t *) REG_ADCC1_EVDAT18)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT19               ((volatile  uint32_t *) REG_ADCC1_EVDAT19)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT20               ((volatile  uint32_t *) REG_ADCC1_EVDAT20)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT21               ((volatile  uint32_t *) REG_ADCC1_EVDAT21)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT22               ((volatile  uint32_t *) REG_ADCC1_EVDAT22)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT23               ((volatile  uint32_t *) REG_ADCC1_EVDAT23)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT24               ((volatile  uint32_t *) REG_ADCC1_EVDAT24)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT25               ((volatile  uint32_t *) REG_ADCC1_EVDAT25)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT26               ((volatile  uint32_t *) REG_ADCC1_EVDAT26)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT27               ((volatile  uint32_t *) REG_ADCC1_EVDAT27)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT28               ((volatile  uint32_t *) REG_ADCC1_EVDAT28)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT29               ((volatile  uint32_t *) REG_ADCC1_EVDAT29)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT30               ((volatile  uint32_t *) REG_ADCC1_EVDAT30)               /*  Event n Data Register */
#define pREG_ADCC1_EVDAT31               ((volatile  uint32_t *) REG_ADCC1_EVDAT31)               /*  Event n Data Register */
#define pREG_ADCC1_EVSTAT00              ((volatile  uint32_t *) REG_ADCC1_EVSTAT00)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT01              ((volatile  uint32_t *) REG_ADCC1_EVSTAT01)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT02              ((volatile  uint32_t *) REG_ADCC1_EVSTAT02)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT03              ((volatile  uint32_t *) REG_ADCC1_EVSTAT03)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT04              ((volatile  uint32_t *) REG_ADCC1_EVSTAT04)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT05              ((volatile  uint32_t *) REG_ADCC1_EVSTAT05)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT06              ((volatile  uint32_t *) REG_ADCC1_EVSTAT06)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT07              ((volatile  uint32_t *) REG_ADCC1_EVSTAT07)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT08              ((volatile  uint32_t *) REG_ADCC1_EVSTAT08)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT09              ((volatile  uint32_t *) REG_ADCC1_EVSTAT09)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT10              ((volatile  uint32_t *) REG_ADCC1_EVSTAT10)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT11              ((volatile  uint32_t *) REG_ADCC1_EVSTAT11)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT12              ((volatile  uint32_t *) REG_ADCC1_EVSTAT12)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT13              ((volatile  uint32_t *) REG_ADCC1_EVSTAT13)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT14              ((volatile  uint32_t *) REG_ADCC1_EVSTAT14)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT15              ((volatile  uint32_t *) REG_ADCC1_EVSTAT15)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT16              ((volatile  uint32_t *) REG_ADCC1_EVSTAT16)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT17              ((volatile  uint32_t *) REG_ADCC1_EVSTAT17)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT18              ((volatile  uint32_t *) REG_ADCC1_EVSTAT18)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT19              ((volatile  uint32_t *) REG_ADCC1_EVSTAT19)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT20              ((volatile  uint32_t *) REG_ADCC1_EVSTAT20)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT21              ((volatile  uint32_t *) REG_ADCC1_EVSTAT21)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT22              ((volatile  uint32_t *) REG_ADCC1_EVSTAT22)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT23              ((volatile  uint32_t *) REG_ADCC1_EVSTAT23)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT24              ((volatile  uint32_t *) REG_ADCC1_EVSTAT24)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT25              ((volatile  uint32_t *) REG_ADCC1_EVSTAT25)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT26              ((volatile  uint32_t *) REG_ADCC1_EVSTAT26)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT27              ((volatile  uint32_t *) REG_ADCC1_EVSTAT27)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT28              ((volatile  uint32_t *) REG_ADCC1_EVSTAT28)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT29              ((volatile  uint32_t *) REG_ADCC1_EVSTAT29)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT30              ((volatile  uint32_t *) REG_ADCC1_EVSTAT30)              /*  Event n Status Register */
#define pREG_ADCC1_EVSTAT31              ((volatile  uint32_t *) REG_ADCC1_EVSTAT31)              /*  Event n Status Register */
#define pREG_ADCC1_CBNUM0                ((volatile  uint32_t *) REG_ADCC1_CBNUM0)                /*  Number of Wraps completed by TIMER0 Circular buffer DMA */
#define pREG_ADCC1_CBNUM1                ((volatile  uint32_t *) REG_ADCC1_CBNUM1)                /*  Number of Wraps completed by TIMER1 Circular buffer DMA */
#define pREG_ADCC1_TRGCNT0               ((volatile  uint32_t *) REG_ADCC1_TRGCNT0)               /*  Trigger count of TIMER0 */
#define pREG_ADCC1_TRGCNT1               ((volatile  uint32_t *) REG_ADCC1_TRGCNT1)               /*  Trigger count of TIMER1 */
#define pREG_ADCC1_ADCRW0                ((volatile  uint32_t *) REG_ADCC1_ADCRW0)                /*  ADC0 Interface RW Access Register */
#define pREG_ADCC1_ADCRW1                ((volatile  uint32_t *) REG_ADCC1_ADCRW1)                /*  ADC1 Interface RW Access Register */

/*  =================================================================================
 *      DAC Controller (DACC0)
 *  ================================================================================= */
#define pREG_DACC0_CTL0                  ((volatile  uint32_t *) REG_DACC0_CTL0)                  /*  Control 0 Register */
#define pREG_DACC0_CTL1                  ((volatile  uint32_t *) REG_DACC0_CTL1)                  /*  Control 1 Register */
#define pREG_DACC0_ERRSTAT               ((volatile  uint32_t *) REG_DACC0_ERRSTAT)               /*  Error Status Register */
#define pREG_DACC0_ERRMSK                ((volatile  uint32_t *) REG_DACC0_ERRMSK)                /*  Error Mask Register */
#define pREG_DACC0_ERRMSK_SET            ((volatile  uint32_t *) REG_DACC0_ERRMSK_SET)            /*  Error Mask Set Register */
#define pREG_DACC0_ERRMSK_CLR            ((volatile  uint32_t *) REG_DACC0_ERRMSK_CLR)            /*  Error Mask Clear Register */
#define pREG_DACC0_ISTAT                 ((volatile  uint32_t *) REG_DACC0_ISTAT)                 /*  Interrupt Status Register */
#define pREG_DACC0_IMSK                  ((volatile  uint32_t *) REG_DACC0_IMSK)                  /*  Interrupt Mask Register */
#define pREG_DACC0_IMSK_SET              ((volatile  uint32_t *) REG_DACC0_IMSK_SET)              /*  Interrupt Mask Set Register */
#define pREG_DACC0_IMSK_CLR              ((volatile  uint32_t *) REG_DACC0_IMSK_CLR)              /*  Interrupt Mask Clear Register */
#define pREG_DACC0_TC0                   ((volatile  uint32_t *) REG_DACC0_TC0)                   /*  Timing Control 0 Register */
#define pREG_DACC0_BPTR0                 ((volatile  uint32_t *) REG_DACC0_BPTR0)                 /*  Base Pointer 0 Register */
#define pREG_DACC0_MOD0                  ((volatile  uint32_t *) REG_DACC0_MOD0)                  /*  Modify 0 Register */
#define pREG_DACC0_CNT0                  ((volatile  uint32_t *) REG_DACC0_CNT0)                  /*  Count 0 Register */
#define pREG_DACC0_DAT0                  ((volatile  uint32_t *) REG_DACC0_DAT0)                  /*  Data FIFO 0 Register */
#define pREG_DACC0_TC1                   ((volatile  uint32_t *) REG_DACC0_TC1)                   /*  Timing Control 1 Register */
#define pREG_DACC0_BPTR1                 ((volatile  uint32_t *) REG_DACC0_BPTR1)                 /*  Base Pointer 1 Register */
#define pREG_DACC0_MOD1                  ((volatile  uint32_t *) REG_DACC0_MOD1)                  /*  Modify 1 Register */
#define pREG_DACC0_CNT1                  ((volatile  uint32_t *) REG_DACC0_CNT1)                  /*  Count 1 Register */
#define pREG_DACC0_DAT1                  ((volatile  uint32_t *) REG_DACC0_DAT1)                  /*  Data FIFO 1 Register */
#define pREG_DACC0_BCST_CTL              ((volatile  uint32_t *) REG_DACC0_BCST_CTL)              /*  Broadcast (Write) Control Register */
#define pREG_DACC0_CNTCUR0               ((volatile  uint32_t *) REG_DACC0_CNTCUR0)               /*  Current Count 0 Register */
#define pREG_DACC0_CNTCUR1               ((volatile  uint32_t *) REG_DACC0_CNTCUR1)               /*  Current Count 1 Register */
#define pREG_DACC0_STAT                  ((volatile  uint32_t *) REG_DACC0_STAT)                  /*  Status Register */

/*  =================================================================================
 *      Cyclic Redundancy Check Unit (CRC0)
 *  ================================================================================= */
#define pREG_CRC0_CTL                    ((volatile  uint32_t *) REG_CRC0_CTL)                    /*  Control Register */
#define pREG_CRC0_DCNT                   ((volatile  uint32_t *) REG_CRC0_DCNT)                   /*  Data Word Count Register */
#define pREG_CRC0_DCNTRLD                ((volatile  uint32_t *) REG_CRC0_DCNTRLD)                /*  Data Word Count Reload Register */
#define pREG_CRC0_COMP                   ((volatile  uint32_t *) REG_CRC0_COMP)                   /*  Data Compare Register */
#define pREG_CRC0_FILLVAL                ((volatile  uint32_t *) REG_CRC0_FILLVAL)                /*  Fill Value Register */
#define pREG_CRC0_DFIFO                  ((volatile  uint32_t *) REG_CRC0_DFIFO)                  /*  Data FIFO Register */
#define pREG_CRC0_INEN                   ((volatile  uint32_t *) REG_CRC0_INEN)                   /*  Interrupt Enable Register */
#define pREG_CRC0_INEN_SET               ((volatile  uint32_t *) REG_CRC0_INEN_SET)               /*  Interrupt Enable Set Register */
#define pREG_CRC0_INEN_CLR               ((volatile  uint32_t *) REG_CRC0_INEN_CLR)               /*  Interrupt Enable Clear Register */
#define pREG_CRC0_POLY                   ((volatile  uint32_t *) REG_CRC0_POLY)                   /*  Polynomial Register */
#define pREG_CRC0_STAT                   ((volatile  uint32_t *) REG_CRC0_STAT)                   /*  Status Register */
#define pREG_CRC0_DCNTCAP                ((volatile  uint32_t *) REG_CRC0_DCNTCAP)                /*  Data Count Capture Register */
#define pREG_CRC0_RESULT_FIN             ((volatile  uint32_t *) REG_CRC0_RESULT_FIN)             /*  CRC Final Result Register */
#define pREG_CRC0_RESULT_CUR             ((volatile  uint32_t *) REG_CRC0_RESULT_CUR)             /*  CRC Current Result Register */

/*  =================================================================================
 *      Harmonic Analysis Engine (HAE0)
 *  ================================================================================= */
#define pREG_HAE0_RUN                    ((volatile  uint32_t *) REG_HAE0_RUN)                    /*  Run Register */
#define pREG_HAE0_CFG0                   ((volatile  uint32_t *) REG_HAE0_CFG0)                   /*  Configuration 0 Register */
#define pREG_HAE0_CFG1                   ((volatile  uint32_t *) REG_HAE0_CFG1)                   /*  Configuration 1 Register */
#define pREG_HAE0_CFG2                   ((volatile  uint32_t *) REG_HAE0_CFG2)                   /*  Configuration 2 Register */
#define pREG_HAE0_CFG3                   ((volatile  uint32_t *) REG_HAE0_CFG3)                   /*  Configuration 3 Register */
#define pREG_HAE0_STAT                   ((volatile  uint32_t *) REG_HAE0_STAT)                   /*  Status Register */
#define pREG_HAE0_ISAMPLE                ((volatile  uint32_t *) REG_HAE0_ISAMPLE)                /*  I (Current) Sample Register */
#define pREG_HAE0_VSAMPLE                ((volatile  uint32_t *) REG_HAE0_VSAMPLE)                /*  V (Voltage) Sample Register */
#define pREG_HAE0_IWAVEFORM              ((volatile  uint32_t *) REG_HAE0_IWAVEFORM)              /*  I (Current) Waveform Register */
#define pREG_HAE0_VWAVEFORM              ((volatile  uint32_t *) REG_HAE0_VWAVEFORM)              /*  V (Voltage) Waveform Register */
#define pREG_HAE0_CFG4                   ((volatile  uint32_t *) REG_HAE0_CFG4)                   /*  Configuration 4 Register */
#define pREG_HAE0_DIDT_GAIN              ((volatile  uint32_t *) REG_HAE0_DIDT_GAIN)              /*  DIDT Gain Register */
#define pREG_HAE0_DIDT_COEF              ((volatile  uint32_t *) REG_HAE0_DIDT_COEF)              /*  DIDT Coefficient Register */
#define pREG_HAE0_VLEVEL                 ((volatile  uint32_t *) REG_HAE0_VLEVEL)                 /*  Voltage Level Register */
#define pREG_HAE0_H00_INDX               ((volatile  uint32_t *) REG_HAE0_H00_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H01_INDX               ((volatile  uint32_t *) REG_HAE0_H01_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H02_INDX               ((volatile  uint32_t *) REG_HAE0_H02_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H03_INDX               ((volatile  uint32_t *) REG_HAE0_H03_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H04_INDX               ((volatile  uint32_t *) REG_HAE0_H04_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H05_INDX               ((volatile  uint32_t *) REG_HAE0_H05_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H06_INDX               ((volatile  uint32_t *) REG_HAE0_H06_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H07_INDX               ((volatile  uint32_t *) REG_HAE0_H07_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H08_INDX               ((volatile  uint32_t *) REG_HAE0_H08_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H09_INDX               ((volatile  uint32_t *) REG_HAE0_H09_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H10_INDX               ((volatile  uint32_t *) REG_HAE0_H10_INDX)               /*  Harmonic n Index Register */
#define pREG_HAE0_H11_INDX               ((volatile  uint32_t *) REG_HAE0_H11_INDX)               /*  Harmonic n Index Register */

/*  =================================================================================
 *      DMA Channel (DMA0)
 *  ================================================================================= */
#define pREG_DMA0_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA0_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA0_ADDRSTART              ((volatile  uint32_t *) REG_DMA0_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA0_CFG                    ((volatile  uint32_t *) REG_DMA0_CFG)                    /*  Configuration Register */
#define pREG_DMA0_XCNT                   ((volatile  uint32_t *) REG_DMA0_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA0_XMOD                   ((volatile  uint32_t *) REG_DMA0_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA0_YCNT                   ((volatile  uint32_t *) REG_DMA0_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA0_YMOD                   ((volatile  uint32_t *) REG_DMA0_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA0_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA0_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA0_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA0_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA0_ADDR_CUR               ((volatile  uint32_t *) REG_DMA0_ADDR_CUR)               /*  Current Address */
#define pREG_DMA0_STAT                   ((volatile  uint32_t *) REG_DMA0_STAT)                   /*  Status Register */
#define pREG_DMA0_XCNT_CUR               ((volatile  uint32_t *) REG_DMA0_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA0_YCNT_CUR               ((volatile  uint32_t *) REG_DMA0_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA1)
 *  ================================================================================= */
#define pREG_DMA1_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA1_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA1_ADDRSTART              ((volatile  uint32_t *) REG_DMA1_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA1_CFG                    ((volatile  uint32_t *) REG_DMA1_CFG)                    /*  Configuration Register */
#define pREG_DMA1_XCNT                   ((volatile  uint32_t *) REG_DMA1_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA1_XMOD                   ((volatile  uint32_t *) REG_DMA1_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA1_YCNT                   ((volatile  uint32_t *) REG_DMA1_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA1_YMOD                   ((volatile  uint32_t *) REG_DMA1_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA1_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA1_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA1_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA1_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA1_ADDR_CUR               ((volatile  uint32_t *) REG_DMA1_ADDR_CUR)               /*  Current Address */
#define pREG_DMA1_STAT                   ((volatile  uint32_t *) REG_DMA1_STAT)                   /*  Status Register */
#define pREG_DMA1_XCNT_CUR               ((volatile  uint32_t *) REG_DMA1_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA1_YCNT_CUR               ((volatile  uint32_t *) REG_DMA1_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA2)
 *  ================================================================================= */
#define pREG_DMA2_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA2_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA2_ADDRSTART              ((volatile  uint32_t *) REG_DMA2_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA2_CFG                    ((volatile  uint32_t *) REG_DMA2_CFG)                    /*  Configuration Register */
#define pREG_DMA2_XCNT                   ((volatile  uint32_t *) REG_DMA2_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA2_XMOD                   ((volatile  uint32_t *) REG_DMA2_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA2_YCNT                   ((volatile  uint32_t *) REG_DMA2_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA2_YMOD                   ((volatile  uint32_t *) REG_DMA2_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA2_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA2_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA2_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA2_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA2_ADDR_CUR               ((volatile  uint32_t *) REG_DMA2_ADDR_CUR)               /*  Current Address */
#define pREG_DMA2_STAT                   ((volatile  uint32_t *) REG_DMA2_STAT)                   /*  Status Register */
#define pREG_DMA2_XCNT_CUR               ((volatile  uint32_t *) REG_DMA2_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA2_YCNT_CUR               ((volatile  uint32_t *) REG_DMA2_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA3)
 *  ================================================================================= */
#define pREG_DMA3_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA3_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA3_ADDRSTART              ((volatile  uint32_t *) REG_DMA3_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA3_CFG                    ((volatile  uint32_t *) REG_DMA3_CFG)                    /*  Configuration Register */
#define pREG_DMA3_XCNT                   ((volatile  uint32_t *) REG_DMA3_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA3_XMOD                   ((volatile  uint32_t *) REG_DMA3_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA3_YCNT                   ((volatile  uint32_t *) REG_DMA3_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA3_YMOD                   ((volatile  uint32_t *) REG_DMA3_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA3_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA3_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA3_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA3_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA3_ADDR_CUR               ((volatile  uint32_t *) REG_DMA3_ADDR_CUR)               /*  Current Address */
#define pREG_DMA3_STAT                   ((volatile  uint32_t *) REG_DMA3_STAT)                   /*  Status Register */
#define pREG_DMA3_XCNT_CUR               ((volatile  uint32_t *) REG_DMA3_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA3_YCNT_CUR               ((volatile  uint32_t *) REG_DMA3_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA4)
 *  ================================================================================= */
#define pREG_DMA4_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA4_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA4_ADDRSTART              ((volatile  uint32_t *) REG_DMA4_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA4_CFG                    ((volatile  uint32_t *) REG_DMA4_CFG)                    /*  Configuration Register */
#define pREG_DMA4_XCNT                   ((volatile  uint32_t *) REG_DMA4_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA4_XMOD                   ((volatile  uint32_t *) REG_DMA4_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA4_YCNT                   ((volatile  uint32_t *) REG_DMA4_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA4_YMOD                   ((volatile  uint32_t *) REG_DMA4_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA4_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA4_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA4_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA4_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA4_ADDR_CUR               ((volatile  uint32_t *) REG_DMA4_ADDR_CUR)               /*  Current Address */
#define pREG_DMA4_STAT                   ((volatile  uint32_t *) REG_DMA4_STAT)                   /*  Status Register */
#define pREG_DMA4_XCNT_CUR               ((volatile  uint32_t *) REG_DMA4_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA4_YCNT_CUR               ((volatile  uint32_t *) REG_DMA4_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA5)
 *  ================================================================================= */
#define pREG_DMA5_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA5_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA5_ADDRSTART              ((volatile  uint32_t *) REG_DMA5_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA5_CFG                    ((volatile  uint32_t *) REG_DMA5_CFG)                    /*  Configuration Register */
#define pREG_DMA5_XCNT                   ((volatile  uint32_t *) REG_DMA5_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA5_XMOD                   ((volatile  uint32_t *) REG_DMA5_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA5_YCNT                   ((volatile  uint32_t *) REG_DMA5_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA5_YMOD                   ((volatile  uint32_t *) REG_DMA5_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA5_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA5_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA5_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA5_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA5_ADDR_CUR               ((volatile  uint32_t *) REG_DMA5_ADDR_CUR)               /*  Current Address */
#define pREG_DMA5_STAT                   ((volatile  uint32_t *) REG_DMA5_STAT)                   /*  Status Register */
#define pREG_DMA5_XCNT_CUR               ((volatile  uint32_t *) REG_DMA5_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA5_YCNT_CUR               ((volatile  uint32_t *) REG_DMA5_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA6)
 *  ================================================================================= */
#define pREG_DMA6_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA6_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA6_ADDRSTART              ((volatile  uint32_t *) REG_DMA6_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA6_CFG                    ((volatile  uint32_t *) REG_DMA6_CFG)                    /*  Configuration Register */
#define pREG_DMA6_XCNT                   ((volatile  uint32_t *) REG_DMA6_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA6_XMOD                   ((volatile  uint32_t *) REG_DMA6_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA6_YCNT                   ((volatile  uint32_t *) REG_DMA6_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA6_YMOD                   ((volatile  uint32_t *) REG_DMA6_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA6_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA6_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA6_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA6_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA6_ADDR_CUR               ((volatile  uint32_t *) REG_DMA6_ADDR_CUR)               /*  Current Address */
#define pREG_DMA6_STAT                   ((volatile  uint32_t *) REG_DMA6_STAT)                   /*  Status Register */
#define pREG_DMA6_XCNT_CUR               ((volatile  uint32_t *) REG_DMA6_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA6_YCNT_CUR               ((volatile  uint32_t *) REG_DMA6_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA7)
 *  ================================================================================= */
#define pREG_DMA7_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA7_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA7_ADDRSTART              ((volatile  uint32_t *) REG_DMA7_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA7_CFG                    ((volatile  uint32_t *) REG_DMA7_CFG)                    /*  Configuration Register */
#define pREG_DMA7_XCNT                   ((volatile  uint32_t *) REG_DMA7_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA7_XMOD                   ((volatile  uint32_t *) REG_DMA7_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA7_YCNT                   ((volatile  uint32_t *) REG_DMA7_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA7_YMOD                   ((volatile  uint32_t *) REG_DMA7_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA7_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA7_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA7_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA7_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA7_ADDR_CUR               ((volatile  uint32_t *) REG_DMA7_ADDR_CUR)               /*  Current Address */
#define pREG_DMA7_STAT                   ((volatile  uint32_t *) REG_DMA7_STAT)                   /*  Status Register */
#define pREG_DMA7_XCNT_CUR               ((volatile  uint32_t *) REG_DMA7_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA7_YCNT_CUR               ((volatile  uint32_t *) REG_DMA7_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA8)
 *  ================================================================================= */
#define pREG_DMA8_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA8_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA8_ADDRSTART              ((volatile  uint32_t *) REG_DMA8_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA8_CFG                    ((volatile  uint32_t *) REG_DMA8_CFG)                    /*  Configuration Register */
#define pREG_DMA8_XCNT                   ((volatile  uint32_t *) REG_DMA8_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA8_XMOD                   ((volatile  uint32_t *) REG_DMA8_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA8_YCNT                   ((volatile  uint32_t *) REG_DMA8_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA8_YMOD                   ((volatile  uint32_t *) REG_DMA8_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA8_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA8_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA8_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA8_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA8_ADDR_CUR               ((volatile  uint32_t *) REG_DMA8_ADDR_CUR)               /*  Current Address */
#define pREG_DMA8_STAT                   ((volatile  uint32_t *) REG_DMA8_STAT)                   /*  Status Register */
#define pREG_DMA8_XCNT_CUR               ((volatile  uint32_t *) REG_DMA8_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA8_YCNT_CUR               ((volatile  uint32_t *) REG_DMA8_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA9)
 *  ================================================================================= */
#define pREG_DMA9_DSCPTR_NXT             ((volatile  uint32_t *) REG_DMA9_DSCPTR_NXT)             /*  Pointer to Next Initial Descriptor */
#define pREG_DMA9_ADDRSTART              ((volatile  uint32_t *) REG_DMA9_ADDRSTART)              /*  Start Address of Current Buffer */
#define pREG_DMA9_CFG                    ((volatile  uint32_t *) REG_DMA9_CFG)                    /*  Configuration Register */
#define pREG_DMA9_XCNT                   ((volatile  uint32_t *) REG_DMA9_XCNT)                   /*  Inner Loop Count Start Value */
#define pREG_DMA9_XMOD                   ((volatile  uint32_t *) REG_DMA9_XMOD)                   /*  Inner Loop Address Increment */
#define pREG_DMA9_YCNT                   ((volatile  uint32_t *) REG_DMA9_YCNT)                   /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA9_YMOD                   ((volatile  uint32_t *) REG_DMA9_YMOD)                   /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA9_DSCPTR_CUR             ((volatile  uint32_t *) REG_DMA9_DSCPTR_CUR)             /*  Current Descriptor Pointer */
#define pREG_DMA9_DSCPTR_PRV             ((volatile  uint32_t *) REG_DMA9_DSCPTR_PRV)             /*  Previous Initial Descriptor Pointer */
#define pREG_DMA9_ADDR_CUR               ((volatile  uint32_t *) REG_DMA9_ADDR_CUR)               /*  Current Address */
#define pREG_DMA9_STAT                   ((volatile  uint32_t *) REG_DMA9_STAT)                   /*  Status Register */
#define pREG_DMA9_XCNT_CUR               ((volatile  uint32_t *) REG_DMA9_XCNT_CUR)               /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA9_YCNT_CUR               ((volatile  uint32_t *) REG_DMA9_YCNT_CUR)               /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA10)
 *  ================================================================================= */
#define pREG_DMA10_DSCPTR_NXT            ((volatile  uint32_t *) REG_DMA10_DSCPTR_NXT)            /*  Pointer to Next Initial Descriptor */
#define pREG_DMA10_ADDRSTART             ((volatile  uint32_t *) REG_DMA10_ADDRSTART)             /*  Start Address of Current Buffer */
#define pREG_DMA10_CFG                   ((volatile  uint32_t *) REG_DMA10_CFG)                   /*  Configuration Register */
#define pREG_DMA10_XCNT                  ((volatile  uint32_t *) REG_DMA10_XCNT)                  /*  Inner Loop Count Start Value */
#define pREG_DMA10_XMOD                  ((volatile  uint32_t *) REG_DMA10_XMOD)                  /*  Inner Loop Address Increment */
#define pREG_DMA10_YCNT                  ((volatile  uint32_t *) REG_DMA10_YCNT)                  /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA10_YMOD                  ((volatile  uint32_t *) REG_DMA10_YMOD)                  /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA10_DSCPTR_CUR            ((volatile  uint32_t *) REG_DMA10_DSCPTR_CUR)            /*  Current Descriptor Pointer */
#define pREG_DMA10_DSCPTR_PRV            ((volatile  uint32_t *) REG_DMA10_DSCPTR_PRV)            /*  Previous Initial Descriptor Pointer */
#define pREG_DMA10_ADDR_CUR              ((volatile  uint32_t *) REG_DMA10_ADDR_CUR)              /*  Current Address */
#define pREG_DMA10_STAT                  ((volatile  uint32_t *) REG_DMA10_STAT)                  /*  Status Register */
#define pREG_DMA10_XCNT_CUR              ((volatile  uint32_t *) REG_DMA10_XCNT_CUR)              /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA10_YCNT_CUR              ((volatile  uint32_t *) REG_DMA10_YCNT_CUR)              /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA11)
 *  ================================================================================= */
#define pREG_DMA11_DSCPTR_NXT            ((volatile  uint32_t *) REG_DMA11_DSCPTR_NXT)            /*  Pointer to Next Initial Descriptor */
#define pREG_DMA11_ADDRSTART             ((volatile  uint32_t *) REG_DMA11_ADDRSTART)             /*  Start Address of Current Buffer */
#define pREG_DMA11_CFG                   ((volatile  uint32_t *) REG_DMA11_CFG)                   /*  Configuration Register */
#define pREG_DMA11_XCNT                  ((volatile  uint32_t *) REG_DMA11_XCNT)                  /*  Inner Loop Count Start Value */
#define pREG_DMA11_XMOD                  ((volatile  uint32_t *) REG_DMA11_XMOD)                  /*  Inner Loop Address Increment */
#define pREG_DMA11_YCNT                  ((volatile  uint32_t *) REG_DMA11_YCNT)                  /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA11_YMOD                  ((volatile  uint32_t *) REG_DMA11_YMOD)                  /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA11_DSCPTR_CUR            ((volatile  uint32_t *) REG_DMA11_DSCPTR_CUR)            /*  Current Descriptor Pointer */
#define pREG_DMA11_DSCPTR_PRV            ((volatile  uint32_t *) REG_DMA11_DSCPTR_PRV)            /*  Previous Initial Descriptor Pointer */
#define pREG_DMA11_ADDR_CUR              ((volatile  uint32_t *) REG_DMA11_ADDR_CUR)              /*  Current Address */
#define pREG_DMA11_STAT                  ((volatile  uint32_t *) REG_DMA11_STAT)                  /*  Status Register */
#define pREG_DMA11_XCNT_CUR              ((volatile  uint32_t *) REG_DMA11_XCNT_CUR)              /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA11_YCNT_CUR              ((volatile  uint32_t *) REG_DMA11_YCNT_CUR)              /*  Current Row Count (2D only) */

/*  =================================================================================
 *      DMA Channel (DMA12)
 *  ================================================================================= */
#define pREG_DMA12_DSCPTR_NXT            ((volatile  uint32_t *) REG_DMA12_DSCPTR_NXT)            /*  Pointer to Next Initial Descriptor */
#define pREG_DMA12_ADDRSTART             ((volatile  uint32_t *) REG_DMA12_ADDRSTART)             /*  Start Address of Current Buffer */
#define pREG_DMA12_CFG                   ((volatile  uint32_t *) REG_DMA12_CFG)                   /*  Configuration Register */
#define pREG_DMA12_XCNT                  ((volatile  uint32_t *) REG_DMA12_XCNT)                  /*  Inner Loop Count Start Value */
#define pREG_DMA12_XMOD                  ((volatile  uint32_t *) REG_DMA12_XMOD)                  /*  Inner Loop Address Increment */
#define pREG_DMA12_YCNT                  ((volatile  uint32_t *) REG_DMA12_YCNT)                  /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA12_YMOD                  ((volatile  uint32_t *) REG_DMA12_YMOD)                  /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA12_DSCPTR_CUR            ((volatile  uint32_t *) REG_DMA12_DSCPTR_CUR)            /*  Current Descriptor Pointer */
#define pREG_DMA12_DSCPTR_PRV            ((volatile  uint32_t *) REG_DMA12_DSCPTR_PRV)            /*  Previous Initial Descriptor Pointer */
#define pREG_DMA12_ADDR_CUR              ((volatile  uint32_t *) REG_DMA12_ADDR_CUR)              /*  Current Address */
#define pREG_DMA12_STAT                  ((volatile  uint32_t *) REG_DMA12_STAT)                  /*  Status Register */
#define pREG_DMA12_XCNT_CUR              ((volatile  uint32_t *) REG_DMA12_XCNT_CUR)              /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA12_YCNT_CUR              ((volatile  uint32_t *) REG_DMA12_YCNT_CUR)              /*  Current Row Count (2D only) */
#define pREG_DMA12_BWLCNT                ((volatile  uint32_t *) REG_DMA12_BWLCNT)                /*  Bandwidth Limit Count */
#define pREG_DMA12_BWLCNT_CUR            ((volatile  uint32_t *) REG_DMA12_BWLCNT_CUR)            /*  Bandwidth Limit Count Current */
#define pREG_DMA12_BWMCNT                ((volatile  uint32_t *) REG_DMA12_BWMCNT)                /*  Bandwidth Monitor Count */
#define pREG_DMA12_BWMCNT_CUR            ((volatile  uint32_t *) REG_DMA12_BWMCNT_CUR)            /*  Bandwidth Monitor Count Current */

/*  =================================================================================
 *      DMA Channel (DMA13)
 *  ================================================================================= */
#define pREG_DMA13_DSCPTR_NXT            ((volatile  uint32_t *) REG_DMA13_DSCPTR_NXT)            /*  Pointer to Next Initial Descriptor */
#define pREG_DMA13_ADDRSTART             ((volatile  uint32_t *) REG_DMA13_ADDRSTART)             /*  Start Address of Current Buffer */
#define pREG_DMA13_CFG                   ((volatile  uint32_t *) REG_DMA13_CFG)                   /*  Configuration Register */
#define pREG_DMA13_XCNT                  ((volatile  uint32_t *) REG_DMA13_XCNT)                  /*  Inner Loop Count Start Value */
#define pREG_DMA13_XMOD                  ((volatile  uint32_t *) REG_DMA13_XMOD)                  /*  Inner Loop Address Increment */
#define pREG_DMA13_YCNT                  ((volatile  uint32_t *) REG_DMA13_YCNT)                  /*  Outer Loop Count Start Value (2D only) */
#define pREG_DMA13_YMOD                  ((volatile  uint32_t *) REG_DMA13_YMOD)                  /*  Outer Loop Address Increment (2D only) */
#define pREG_DMA13_DSCPTR_CUR            ((volatile  uint32_t *) REG_DMA13_DSCPTR_CUR)            /*  Current Descriptor Pointer */
#define pREG_DMA13_DSCPTR_PRV            ((volatile  uint32_t *) REG_DMA13_DSCPTR_PRV)            /*  Previous Initial Descriptor Pointer */
#define pREG_DMA13_ADDR_CUR              ((volatile  uint32_t *) REG_DMA13_ADDR_CUR)              /*  Current Address */
#define pREG_DMA13_STAT                  ((volatile  uint32_t *) REG_DMA13_STAT)                  /*  Status Register */
#define pREG_DMA13_XCNT_CUR              ((volatile  uint32_t *) REG_DMA13_XCNT_CUR)              /*  Current Count(1D) or intra-row XCNT (2D) */
#define pREG_DMA13_YCNT_CUR              ((volatile  uint32_t *) REG_DMA13_YCNT_CUR)              /*  Current Row Count (2D only) */
#define pREG_DMA13_BWLCNT                ((volatile  uint32_t *) REG_DMA13_BWLCNT)                /*  Bandwidth Limit Count */
#define pREG_DMA13_BWLCNT_CUR            ((volatile  uint32_t *) REG_DMA13_BWLCNT_CUR)            /*  Bandwidth Limit Count Current */
#define pREG_DMA13_BWMCNT                ((volatile  uint32_t *) REG_DMA13_BWMCNT)                /*  Bandwidth Monitor Count */
#define pREG_DMA13_BWMCNT_CUR            ((volatile  uint32_t *) REG_DMA13_BWMCNT_CUR)            /*  Bandwidth Monitor Count Current */

/*  =================================================================================
 *      MBOX Port 0 register map (MBOX0_PORT0)
 *  ================================================================================= */
#define pREG_MBOX0_PORT0_CTL             ((volatile  uint32_t *) REG_MBOX0_PORT0_CTL)             /*  Port 0 control register */
#define pREG_MBOX0_PORT0_FORCEIRQ        ((volatile  uint32_t *) REG_MBOX0_PORT0_FORCEIRQ)        /*  Port 0 force IRQ register */
#define pREG_MBOX0_PORT0_STAT            ((volatile  uint32_t *) REG_MBOX0_PORT0_STAT)            /*  Port 0 status register */
#define pREG_MBOX0_PORT0_ESTAT           ((volatile  uint32_t *) REG_MBOX0_PORT0_ESTAT)           /*  Port 0 ECC status register */

/*  =================================================================================
 *      MBOX Port 1 register map (MBOX0_PORT1)
 *  ================================================================================= */
#define pREG_MBOX0_PORT1_CTL             ((volatile  uint32_t *) REG_MBOX0_PORT1_CTL)             /*  Port 1 control register */
#define pREG_MBOX0_PORT1_FORCEIRQ        ((volatile  uint32_t *) REG_MBOX0_PORT1_FORCEIRQ)        /*  Port 1 force IRQ register */
#define pREG_MBOX0_PORT1_STAT            ((volatile  uint32_t *) REG_MBOX0_PORT1_STAT)            /*  Port 1 status register */
#define pREG_MBOX0_PORT1_ESTAT           ((volatile  uint32_t *) REG_MBOX0_PORT1_ESTAT)           /*  Port 1 ECC status register */
#define pREG_MBOX0_PORT1_RFRPER          ((volatile  uint32_t *) REG_MBOX0_PORT1_RFRPER)          /*  Auto-refresh period register */
#define pREG_MBOX0_PORT1_RFRADDR         ((volatile  uint32_t *) REG_MBOX0_PORT1_RFRADDR)         /*  Auto-refresh address register */
#define pREG_MBOX0_PORT1_RFRCNT          ((volatile  uint32_t *) REG_MBOX0_PORT1_RFRCNT)          /*  Auto-refresh counter register */

/*  =================================================================================
 *      System Memory Protection Unit (SMPU1)
 *  ================================================================================= */
#define pREG_SMPU1_CTL                   ((volatile  uint32_t *) REG_SMPU1_CTL)                   /*  SMPU Control Register */
#define pREG_SMPU1_STAT                  ((volatile  uint32_t *) REG_SMPU1_STAT)                  /*  SMPU Status Register */
#define pREG_SMPU1_IADDR                 ((volatile  uint32_t *) REG_SMPU1_IADDR)                 /*  Interrupt Address Register */
#define pREG_SMPU1_IDTLS                 ((volatile  uint32_t *) REG_SMPU1_IDTLS)                 /*  Interrupt Details Register */
#define pREG_SMPU1_BADDR                 ((volatile  uint32_t *) REG_SMPU1_BADDR)                 /*  Bus Error Address Register */
#define pREG_SMPU1_BDTLS                 ((volatile  uint32_t *) REG_SMPU1_BDTLS)                 /*  Bus Error Details Register */
#define pREG_SMPU1_RCTL0                 ((volatile  uint32_t *) REG_SMPU1_RCTL0)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR0                ((volatile  uint32_t *) REG_SMPU1_RADDR0)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA0                 ((volatile  uint32_t *) REG_SMPU1_RIDA0)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA0              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA0)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB0                 ((volatile  uint32_t *) REG_SMPU1_RIDB0)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB0              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB0)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL1                 ((volatile  uint32_t *) REG_SMPU1_RCTL1)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR1                ((volatile  uint32_t *) REG_SMPU1_RADDR1)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA1                 ((volatile  uint32_t *) REG_SMPU1_RIDA1)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA1              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA1)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB1                 ((volatile  uint32_t *) REG_SMPU1_RIDB1)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB1              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB1)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL2                 ((volatile  uint32_t *) REG_SMPU1_RCTL2)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR2                ((volatile  uint32_t *) REG_SMPU1_RADDR2)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA2                 ((volatile  uint32_t *) REG_SMPU1_RIDA2)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA2              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA2)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB2                 ((volatile  uint32_t *) REG_SMPU1_RIDB2)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB2              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB2)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL3                 ((volatile  uint32_t *) REG_SMPU1_RCTL3)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR3                ((volatile  uint32_t *) REG_SMPU1_RADDR3)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA3                 ((volatile  uint32_t *) REG_SMPU1_RIDA3)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA3              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA3)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB3                 ((volatile  uint32_t *) REG_SMPU1_RIDB3)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB3              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB3)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL4                 ((volatile  uint32_t *) REG_SMPU1_RCTL4)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR4                ((volatile  uint32_t *) REG_SMPU1_RADDR4)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA4                 ((volatile  uint32_t *) REG_SMPU1_RIDA4)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA4              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA4)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB4                 ((volatile  uint32_t *) REG_SMPU1_RIDB4)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB4              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB4)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL5                 ((volatile  uint32_t *) REG_SMPU1_RCTL5)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR5                ((volatile  uint32_t *) REG_SMPU1_RADDR5)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA5                 ((volatile  uint32_t *) REG_SMPU1_RIDA5)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA5              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA5)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB5                 ((volatile  uint32_t *) REG_SMPU1_RIDB5)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB5              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB5)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL6                 ((volatile  uint32_t *) REG_SMPU1_RCTL6)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR6                ((volatile  uint32_t *) REG_SMPU1_RADDR6)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA6                 ((volatile  uint32_t *) REG_SMPU1_RIDA6)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA6              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA6)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB6                 ((volatile  uint32_t *) REG_SMPU1_RIDB6)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB6              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB6)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_RCTL7                 ((volatile  uint32_t *) REG_SMPU1_RCTL7)                 /*  Region n Control Register */
#define pREG_SMPU1_RADDR7                ((volatile  uint32_t *) REG_SMPU1_RADDR7)                /*  Region n Address Register */
#define pREG_SMPU1_RIDA7                 ((volatile  uint32_t *) REG_SMPU1_RIDA7)                 /*  Region n ID A Register */
#define pREG_SMPU1_RIDMSKA7              ((volatile  uint32_t *) REG_SMPU1_RIDMSKA7)              /*  Region n ID Mask A Register */
#define pREG_SMPU1_RIDB7                 ((volatile  uint32_t *) REG_SMPU1_RIDB7)                 /*  Region n ID B Register */
#define pREG_SMPU1_RIDMSKB7              ((volatile  uint32_t *) REG_SMPU1_RIDMSKB7)              /*  Region n ID Mask B Register */
#define pREG_SMPU1_REVID                 ((volatile  uint32_t *) REG_SMPU1_REVID)                 /*  SMPU Revision ID Register */
#define pREG_SMPU1_SECURECTL             ((volatile  uint32_t *) REG_SMPU1_SECURECTL)             /*  SMPU Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL0           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL0)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL1           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL1)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL2           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL2)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL3           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL3)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL4           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL4)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL5           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL5)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL6           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL6)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU1_SECURERCTL7           ((volatile  uint32_t *) REG_SMPU1_SECURERCTL7)           /*  Region n Control Secure Accesses Register */

/*  =================================================================================
 *      System Memory Protection Unit (SMPU2)
 *  ================================================================================= */
#define pREG_SMPU2_CTL                   ((volatile  uint32_t *) REG_SMPU2_CTL)                   /*  SMPU Control Register */
#define pREG_SMPU2_STAT                  ((volatile  uint32_t *) REG_SMPU2_STAT)                  /*  SMPU Status Register */
#define pREG_SMPU2_IADDR                 ((volatile  uint32_t *) REG_SMPU2_IADDR)                 /*  Interrupt Address Register */
#define pREG_SMPU2_IDTLS                 ((volatile  uint32_t *) REG_SMPU2_IDTLS)                 /*  Interrupt Details Register */
#define pREG_SMPU2_BADDR                 ((volatile  uint32_t *) REG_SMPU2_BADDR)                 /*  Bus Error Address Register */
#define pREG_SMPU2_BDTLS                 ((volatile  uint32_t *) REG_SMPU2_BDTLS)                 /*  Bus Error Details Register */
#define pREG_SMPU2_RCTL0                 ((volatile  uint32_t *) REG_SMPU2_RCTL0)                 /*  Region n Control Register */
#define pREG_SMPU2_RADDR0                ((volatile  uint32_t *) REG_SMPU2_RADDR0)                /*  Region n Address Register */
#define pREG_SMPU2_RIDA0                 ((volatile  uint32_t *) REG_SMPU2_RIDA0)                 /*  Region n ID A Register */
#define pREG_SMPU2_RIDMSKA0              ((volatile  uint32_t *) REG_SMPU2_RIDMSKA0)              /*  Region n ID Mask A Register */
#define pREG_SMPU2_RIDB0                 ((volatile  uint32_t *) REG_SMPU2_RIDB0)                 /*  Region n ID B Register */
#define pREG_SMPU2_RIDMSKB0              ((volatile  uint32_t *) REG_SMPU2_RIDMSKB0)              /*  Region n ID Mask B Register */
#define pREG_SMPU2_RCTL1                 ((volatile  uint32_t *) REG_SMPU2_RCTL1)                 /*  Region n Control Register */
#define pREG_SMPU2_RADDR1                ((volatile  uint32_t *) REG_SMPU2_RADDR1)                /*  Region n Address Register */
#define pREG_SMPU2_RIDA1                 ((volatile  uint32_t *) REG_SMPU2_RIDA1)                 /*  Region n ID A Register */
#define pREG_SMPU2_RIDMSKA1              ((volatile  uint32_t *) REG_SMPU2_RIDMSKA1)              /*  Region n ID Mask A Register */
#define pREG_SMPU2_RIDB1                 ((volatile  uint32_t *) REG_SMPU2_RIDB1)                 /*  Region n ID B Register */
#define pREG_SMPU2_RIDMSKB1              ((volatile  uint32_t *) REG_SMPU2_RIDMSKB1)              /*  Region n ID Mask B Register */
#define pREG_SMPU2_RCTL2                 ((volatile  uint32_t *) REG_SMPU2_RCTL2)                 /*  Region n Control Register */
#define pREG_SMPU2_RADDR2                ((volatile  uint32_t *) REG_SMPU2_RADDR2)                /*  Region n Address Register */
#define pREG_SMPU2_RIDA2                 ((volatile  uint32_t *) REG_SMPU2_RIDA2)                 /*  Region n ID A Register */
#define pREG_SMPU2_RIDMSKA2              ((volatile  uint32_t *) REG_SMPU2_RIDMSKA2)              /*  Region n ID Mask A Register */
#define pREG_SMPU2_RIDB2                 ((volatile  uint32_t *) REG_SMPU2_RIDB2)                 /*  Region n ID B Register */
#define pREG_SMPU2_RIDMSKB2              ((volatile  uint32_t *) REG_SMPU2_RIDMSKB2)              /*  Region n ID Mask B Register */
#define pREG_SMPU2_RCTL3                 ((volatile  uint32_t *) REG_SMPU2_RCTL3)                 /*  Region n Control Register */
#define pREG_SMPU2_RADDR3                ((volatile  uint32_t *) REG_SMPU2_RADDR3)                /*  Region n Address Register */
#define pREG_SMPU2_RIDA3                 ((volatile  uint32_t *) REG_SMPU2_RIDA3)                 /*  Region n ID A Register */
#define pREG_SMPU2_RIDMSKA3              ((volatile  uint32_t *) REG_SMPU2_RIDMSKA3)              /*  Region n ID Mask A Register */
#define pREG_SMPU2_RIDB3                 ((volatile  uint32_t *) REG_SMPU2_RIDB3)                 /*  Region n ID B Register */
#define pREG_SMPU2_RIDMSKB3              ((volatile  uint32_t *) REG_SMPU2_RIDMSKB3)              /*  Region n ID Mask B Register */
#define pREG_SMPU2_REVID                 ((volatile  uint32_t *) REG_SMPU2_REVID)                 /*  SMPU Revision ID Register */
#define pREG_SMPU2_SECURECTL             ((volatile  uint32_t *) REG_SMPU2_SECURECTL)             /*  SMPU Control Secure Accesses Register */
#define pREG_SMPU2_SECURERCTL0           ((volatile  uint32_t *) REG_SMPU2_SECURERCTL0)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU2_SECURERCTL1           ((volatile  uint32_t *) REG_SMPU2_SECURERCTL1)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU2_SECURERCTL2           ((volatile  uint32_t *) REG_SMPU2_SECURERCTL2)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU2_SECURERCTL3           ((volatile  uint32_t *) REG_SMPU2_SECURERCTL3)           /*  Region n Control Secure Accesses Register */

/*  =================================================================================
 *      System Watchpoint Unit (SWU0)
 *  ================================================================================= */
#define pREG_SWU0_GCTL                   ((volatile  uint32_t *) REG_SWU0_GCTL)                   /*  Global Control Register */
#define pREG_SWU0_GSTAT                  ((volatile  uint32_t *) REG_SWU0_GSTAT)                  /*  Global Status Register */
#define pREG_SWU0_CTL0                   ((volatile  uint32_t *) REG_SWU0_CTL0)                   /*  Control Register n */
#define pREG_SWU0_LA0                    ((volatile  uint32_t *) REG_SWU0_LA0)                    /*  Lower Address Register n */
#define pREG_SWU0_UA0                    ((volatile  uint32_t *) REG_SWU0_UA0)                    /*  Upper Address Register n */
#define pREG_SWU0_ID0                    ((volatile  uint32_t *) REG_SWU0_ID0)                    /*  ID Register n */
#define pREG_SWU0_CNT0                   ((volatile  uint32_t *) REG_SWU0_CNT0)                   /*  Count Register n */
#define pREG_SWU0_TARG0                  ((volatile  uint32_t *) REG_SWU0_TARG0)                  /*  Target Register n */
#define pREG_SWU0_HIST0                  ((volatile  uint32_t *) REG_SWU0_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU0_CUR0                   ((volatile  uint32_t *) REG_SWU0_CUR0)                   /*  Current Register n */
#define pREG_SWU0_CTL1                   ((volatile  uint32_t *) REG_SWU0_CTL1)                   /*  Control Register n */
#define pREG_SWU0_LA1                    ((volatile  uint32_t *) REG_SWU0_LA1)                    /*  Lower Address Register n */
#define pREG_SWU0_UA1                    ((volatile  uint32_t *) REG_SWU0_UA1)                    /*  Upper Address Register n */
#define pREG_SWU0_ID1                    ((volatile  uint32_t *) REG_SWU0_ID1)                    /*  ID Register n */
#define pREG_SWU0_CNT1                   ((volatile  uint32_t *) REG_SWU0_CNT1)                   /*  Count Register n */
#define pREG_SWU0_TARG1                  ((volatile  uint32_t *) REG_SWU0_TARG1)                  /*  Target Register n */
#define pREG_SWU0_HIST1                  ((volatile  uint32_t *) REG_SWU0_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU0_CUR1                   ((volatile  uint32_t *) REG_SWU0_CUR1)                   /*  Current Register n */
#define pREG_SWU0_CTL2                   ((volatile  uint32_t *) REG_SWU0_CTL2)                   /*  Control Register n */
#define pREG_SWU0_LA2                    ((volatile  uint32_t *) REG_SWU0_LA2)                    /*  Lower Address Register n */
#define pREG_SWU0_UA2                    ((volatile  uint32_t *) REG_SWU0_UA2)                    /*  Upper Address Register n */
#define pREG_SWU0_ID2                    ((volatile  uint32_t *) REG_SWU0_ID2)                    /*  ID Register n */
#define pREG_SWU0_CNT2                   ((volatile  uint32_t *) REG_SWU0_CNT2)                   /*  Count Register n */
#define pREG_SWU0_TARG2                  ((volatile  uint32_t *) REG_SWU0_TARG2)                  /*  Target Register n */
#define pREG_SWU0_HIST2                  ((volatile  uint32_t *) REG_SWU0_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU0_CUR2                   ((volatile  uint32_t *) REG_SWU0_CUR2)                   /*  Current Register n */
#define pREG_SWU0_CTL3                   ((volatile  uint32_t *) REG_SWU0_CTL3)                   /*  Control Register n */
#define pREG_SWU0_LA3                    ((volatile  uint32_t *) REG_SWU0_LA3)                    /*  Lower Address Register n */
#define pREG_SWU0_UA3                    ((volatile  uint32_t *) REG_SWU0_UA3)                    /*  Upper Address Register n */
#define pREG_SWU0_ID3                    ((volatile  uint32_t *) REG_SWU0_ID3)                    /*  ID Register n */
#define pREG_SWU0_CNT3                   ((volatile  uint32_t *) REG_SWU0_CNT3)                   /*  Count Register n */
#define pREG_SWU0_TARG3                  ((volatile  uint32_t *) REG_SWU0_TARG3)                  /*  Target Register n */
#define pREG_SWU0_HIST3                  ((volatile  uint32_t *) REG_SWU0_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU0_CUR3                   ((volatile  uint32_t *) REG_SWU0_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Watchpoint Unit (SWU1)
 *  ================================================================================= */
#define pREG_SWU1_GCTL                   ((volatile  uint32_t *) REG_SWU1_GCTL)                   /*  Global Control Register */
#define pREG_SWU1_GSTAT                  ((volatile  uint32_t *) REG_SWU1_GSTAT)                  /*  Global Status Register */
#define pREG_SWU1_CTL0                   ((volatile  uint32_t *) REG_SWU1_CTL0)                   /*  Control Register n */
#define pREG_SWU1_LA0                    ((volatile  uint32_t *) REG_SWU1_LA0)                    /*  Lower Address Register n */
#define pREG_SWU1_UA0                    ((volatile  uint32_t *) REG_SWU1_UA0)                    /*  Upper Address Register n */
#define pREG_SWU1_ID0                    ((volatile  uint32_t *) REG_SWU1_ID0)                    /*  ID Register n */
#define pREG_SWU1_CNT0                   ((volatile  uint32_t *) REG_SWU1_CNT0)                   /*  Count Register n */
#define pREG_SWU1_TARG0                  ((volatile  uint32_t *) REG_SWU1_TARG0)                  /*  Target Register n */
#define pREG_SWU1_HIST0                  ((volatile  uint32_t *) REG_SWU1_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU1_CUR0                   ((volatile  uint32_t *) REG_SWU1_CUR0)                   /*  Current Register n */
#define pREG_SWU1_CTL1                   ((volatile  uint32_t *) REG_SWU1_CTL1)                   /*  Control Register n */
#define pREG_SWU1_LA1                    ((volatile  uint32_t *) REG_SWU1_LA1)                    /*  Lower Address Register n */
#define pREG_SWU1_UA1                    ((volatile  uint32_t *) REG_SWU1_UA1)                    /*  Upper Address Register n */
#define pREG_SWU1_ID1                    ((volatile  uint32_t *) REG_SWU1_ID1)                    /*  ID Register n */
#define pREG_SWU1_CNT1                   ((volatile  uint32_t *) REG_SWU1_CNT1)                   /*  Count Register n */
#define pREG_SWU1_TARG1                  ((volatile  uint32_t *) REG_SWU1_TARG1)                  /*  Target Register n */
#define pREG_SWU1_HIST1                  ((volatile  uint32_t *) REG_SWU1_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU1_CUR1                   ((volatile  uint32_t *) REG_SWU1_CUR1)                   /*  Current Register n */
#define pREG_SWU1_CTL2                   ((volatile  uint32_t *) REG_SWU1_CTL2)                   /*  Control Register n */
#define pREG_SWU1_LA2                    ((volatile  uint32_t *) REG_SWU1_LA2)                    /*  Lower Address Register n */
#define pREG_SWU1_UA2                    ((volatile  uint32_t *) REG_SWU1_UA2)                    /*  Upper Address Register n */
#define pREG_SWU1_ID2                    ((volatile  uint32_t *) REG_SWU1_ID2)                    /*  ID Register n */
#define pREG_SWU1_CNT2                   ((volatile  uint32_t *) REG_SWU1_CNT2)                   /*  Count Register n */
#define pREG_SWU1_TARG2                  ((volatile  uint32_t *) REG_SWU1_TARG2)                  /*  Target Register n */
#define pREG_SWU1_HIST2                  ((volatile  uint32_t *) REG_SWU1_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU1_CUR2                   ((volatile  uint32_t *) REG_SWU1_CUR2)                   /*  Current Register n */
#define pREG_SWU1_CTL3                   ((volatile  uint32_t *) REG_SWU1_CTL3)                   /*  Control Register n */
#define pREG_SWU1_LA3                    ((volatile  uint32_t *) REG_SWU1_LA3)                    /*  Lower Address Register n */
#define pREG_SWU1_UA3                    ((volatile  uint32_t *) REG_SWU1_UA3)                    /*  Upper Address Register n */
#define pREG_SWU1_ID3                    ((volatile  uint32_t *) REG_SWU1_ID3)                    /*  ID Register n */
#define pREG_SWU1_CNT3                   ((volatile  uint32_t *) REG_SWU1_CNT3)                   /*  Count Register n */
#define pREG_SWU1_TARG3                  ((volatile  uint32_t *) REG_SWU1_TARG3)                  /*  Target Register n */
#define pREG_SWU1_HIST3                  ((volatile  uint32_t *) REG_SWU1_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU1_CUR3                   ((volatile  uint32_t *) REG_SWU1_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Watchpoint Unit (SWU2)
 *  ================================================================================= */
#define pREG_SWU2_GCTL                   ((volatile  uint32_t *) REG_SWU2_GCTL)                   /*  Global Control Register */
#define pREG_SWU2_GSTAT                  ((volatile  uint32_t *) REG_SWU2_GSTAT)                  /*  Global Status Register */
#define pREG_SWU2_CTL0                   ((volatile  uint32_t *) REG_SWU2_CTL0)                   /*  Control Register n */
#define pREG_SWU2_LA0                    ((volatile  uint32_t *) REG_SWU2_LA0)                    /*  Lower Address Register n */
#define pREG_SWU2_UA0                    ((volatile  uint32_t *) REG_SWU2_UA0)                    /*  Upper Address Register n */
#define pREG_SWU2_ID0                    ((volatile  uint32_t *) REG_SWU2_ID0)                    /*  ID Register n */
#define pREG_SWU2_CNT0                   ((volatile  uint32_t *) REG_SWU2_CNT0)                   /*  Count Register n */
#define pREG_SWU2_TARG0                  ((volatile  uint32_t *) REG_SWU2_TARG0)                  /*  Target Register n */
#define pREG_SWU2_HIST0                  ((volatile  uint32_t *) REG_SWU2_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU2_CUR0                   ((volatile  uint32_t *) REG_SWU2_CUR0)                   /*  Current Register n */
#define pREG_SWU2_CTL1                   ((volatile  uint32_t *) REG_SWU2_CTL1)                   /*  Control Register n */
#define pREG_SWU2_LA1                    ((volatile  uint32_t *) REG_SWU2_LA1)                    /*  Lower Address Register n */
#define pREG_SWU2_UA1                    ((volatile  uint32_t *) REG_SWU2_UA1)                    /*  Upper Address Register n */
#define pREG_SWU2_ID1                    ((volatile  uint32_t *) REG_SWU2_ID1)                    /*  ID Register n */
#define pREG_SWU2_CNT1                   ((volatile  uint32_t *) REG_SWU2_CNT1)                   /*  Count Register n */
#define pREG_SWU2_TARG1                  ((volatile  uint32_t *) REG_SWU2_TARG1)                  /*  Target Register n */
#define pREG_SWU2_HIST1                  ((volatile  uint32_t *) REG_SWU2_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU2_CUR1                   ((volatile  uint32_t *) REG_SWU2_CUR1)                   /*  Current Register n */
#define pREG_SWU2_CTL2                   ((volatile  uint32_t *) REG_SWU2_CTL2)                   /*  Control Register n */
#define pREG_SWU2_LA2                    ((volatile  uint32_t *) REG_SWU2_LA2)                    /*  Lower Address Register n */
#define pREG_SWU2_UA2                    ((volatile  uint32_t *) REG_SWU2_UA2)                    /*  Upper Address Register n */
#define pREG_SWU2_ID2                    ((volatile  uint32_t *) REG_SWU2_ID2)                    /*  ID Register n */
#define pREG_SWU2_CNT2                   ((volatile  uint32_t *) REG_SWU2_CNT2)                   /*  Count Register n */
#define pREG_SWU2_TARG2                  ((volatile  uint32_t *) REG_SWU2_TARG2)                  /*  Target Register n */
#define pREG_SWU2_HIST2                  ((volatile  uint32_t *) REG_SWU2_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU2_CUR2                   ((volatile  uint32_t *) REG_SWU2_CUR2)                   /*  Current Register n */
#define pREG_SWU2_CTL3                   ((volatile  uint32_t *) REG_SWU2_CTL3)                   /*  Control Register n */
#define pREG_SWU2_LA3                    ((volatile  uint32_t *) REG_SWU2_LA3)                    /*  Lower Address Register n */
#define pREG_SWU2_UA3                    ((volatile  uint32_t *) REG_SWU2_UA3)                    /*  Upper Address Register n */
#define pREG_SWU2_ID3                    ((volatile  uint32_t *) REG_SWU2_ID3)                    /*  ID Register n */
#define pREG_SWU2_CNT3                   ((volatile  uint32_t *) REG_SWU2_CNT3)                   /*  Count Register n */
#define pREG_SWU2_TARG3                  ((volatile  uint32_t *) REG_SWU2_TARG3)                  /*  Target Register n */
#define pREG_SWU2_HIST3                  ((volatile  uint32_t *) REG_SWU2_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU2_CUR3                   ((volatile  uint32_t *) REG_SWU2_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Watchpoint Unit (SWU3)
 *  ================================================================================= */
#define pREG_SWU3_GCTL                   ((volatile  uint32_t *) REG_SWU3_GCTL)                   /*  Global Control Register */
#define pREG_SWU3_GSTAT                  ((volatile  uint32_t *) REG_SWU3_GSTAT)                  /*  Global Status Register */
#define pREG_SWU3_CTL0                   ((volatile  uint32_t *) REG_SWU3_CTL0)                   /*  Control Register n */
#define pREG_SWU3_LA0                    ((volatile  uint32_t *) REG_SWU3_LA0)                    /*  Lower Address Register n */
#define pREG_SWU3_UA0                    ((volatile  uint32_t *) REG_SWU3_UA0)                    /*  Upper Address Register n */
#define pREG_SWU3_ID0                    ((volatile  uint32_t *) REG_SWU3_ID0)                    /*  ID Register n */
#define pREG_SWU3_CNT0                   ((volatile  uint32_t *) REG_SWU3_CNT0)                   /*  Count Register n */
#define pREG_SWU3_TARG0                  ((volatile  uint32_t *) REG_SWU3_TARG0)                  /*  Target Register n */
#define pREG_SWU3_HIST0                  ((volatile  uint32_t *) REG_SWU3_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU3_CUR0                   ((volatile  uint32_t *) REG_SWU3_CUR0)                   /*  Current Register n */
#define pREG_SWU3_CTL1                   ((volatile  uint32_t *) REG_SWU3_CTL1)                   /*  Control Register n */
#define pREG_SWU3_LA1                    ((volatile  uint32_t *) REG_SWU3_LA1)                    /*  Lower Address Register n */
#define pREG_SWU3_UA1                    ((volatile  uint32_t *) REG_SWU3_UA1)                    /*  Upper Address Register n */
#define pREG_SWU3_ID1                    ((volatile  uint32_t *) REG_SWU3_ID1)                    /*  ID Register n */
#define pREG_SWU3_CNT1                   ((volatile  uint32_t *) REG_SWU3_CNT1)                   /*  Count Register n */
#define pREG_SWU3_TARG1                  ((volatile  uint32_t *) REG_SWU3_TARG1)                  /*  Target Register n */
#define pREG_SWU3_HIST1                  ((volatile  uint32_t *) REG_SWU3_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU3_CUR1                   ((volatile  uint32_t *) REG_SWU3_CUR1)                   /*  Current Register n */
#define pREG_SWU3_CTL2                   ((volatile  uint32_t *) REG_SWU3_CTL2)                   /*  Control Register n */
#define pREG_SWU3_LA2                    ((volatile  uint32_t *) REG_SWU3_LA2)                    /*  Lower Address Register n */
#define pREG_SWU3_UA2                    ((volatile  uint32_t *) REG_SWU3_UA2)                    /*  Upper Address Register n */
#define pREG_SWU3_ID2                    ((volatile  uint32_t *) REG_SWU3_ID2)                    /*  ID Register n */
#define pREG_SWU3_CNT2                   ((volatile  uint32_t *) REG_SWU3_CNT2)                   /*  Count Register n */
#define pREG_SWU3_TARG2                  ((volatile  uint32_t *) REG_SWU3_TARG2)                  /*  Target Register n */
#define pREG_SWU3_HIST2                  ((volatile  uint32_t *) REG_SWU3_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU3_CUR2                   ((volatile  uint32_t *) REG_SWU3_CUR2)                   /*  Current Register n */
#define pREG_SWU3_CTL3                   ((volatile  uint32_t *) REG_SWU3_CTL3)                   /*  Control Register n */
#define pREG_SWU3_LA3                    ((volatile  uint32_t *) REG_SWU3_LA3)                    /*  Lower Address Register n */
#define pREG_SWU3_UA3                    ((volatile  uint32_t *) REG_SWU3_UA3)                    /*  Upper Address Register n */
#define pREG_SWU3_ID3                    ((volatile  uint32_t *) REG_SWU3_ID3)                    /*  ID Register n */
#define pREG_SWU3_CNT3                   ((volatile  uint32_t *) REG_SWU3_CNT3)                   /*  Count Register n */
#define pREG_SWU3_TARG3                  ((volatile  uint32_t *) REG_SWU3_TARG3)                  /*  Target Register n */
#define pREG_SWU3_HIST3                  ((volatile  uint32_t *) REG_SWU3_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU3_CUR3                   ((volatile  uint32_t *) REG_SWU3_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Watchpoint Unit (SWU4)
 *  ================================================================================= */
#define pREG_SWU4_GCTL                   ((volatile  uint32_t *) REG_SWU4_GCTL)                   /*  Global Control Register */
#define pREG_SWU4_GSTAT                  ((volatile  uint32_t *) REG_SWU4_GSTAT)                  /*  Global Status Register */
#define pREG_SWU4_CTL0                   ((volatile  uint32_t *) REG_SWU4_CTL0)                   /*  Control Register n */
#define pREG_SWU4_LA0                    ((volatile  uint32_t *) REG_SWU4_LA0)                    /*  Lower Address Register n */
#define pREG_SWU4_UA0                    ((volatile  uint32_t *) REG_SWU4_UA0)                    /*  Upper Address Register n */
#define pREG_SWU4_ID0                    ((volatile  uint32_t *) REG_SWU4_ID0)                    /*  ID Register n */
#define pREG_SWU4_CNT0                   ((volatile  uint32_t *) REG_SWU4_CNT0)                   /*  Count Register n */
#define pREG_SWU4_TARG0                  ((volatile  uint32_t *) REG_SWU4_TARG0)                  /*  Target Register n */
#define pREG_SWU4_HIST0                  ((volatile  uint32_t *) REG_SWU4_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU4_CUR0                   ((volatile  uint32_t *) REG_SWU4_CUR0)                   /*  Current Register n */
#define pREG_SWU4_CTL1                   ((volatile  uint32_t *) REG_SWU4_CTL1)                   /*  Control Register n */
#define pREG_SWU4_LA1                    ((volatile  uint32_t *) REG_SWU4_LA1)                    /*  Lower Address Register n */
#define pREG_SWU4_UA1                    ((volatile  uint32_t *) REG_SWU4_UA1)                    /*  Upper Address Register n */
#define pREG_SWU4_ID1                    ((volatile  uint32_t *) REG_SWU4_ID1)                    /*  ID Register n */
#define pREG_SWU4_CNT1                   ((volatile  uint32_t *) REG_SWU4_CNT1)                   /*  Count Register n */
#define pREG_SWU4_TARG1                  ((volatile  uint32_t *) REG_SWU4_TARG1)                  /*  Target Register n */
#define pREG_SWU4_HIST1                  ((volatile  uint32_t *) REG_SWU4_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU4_CUR1                   ((volatile  uint32_t *) REG_SWU4_CUR1)                   /*  Current Register n */
#define pREG_SWU4_CTL2                   ((volatile  uint32_t *) REG_SWU4_CTL2)                   /*  Control Register n */
#define pREG_SWU4_LA2                    ((volatile  uint32_t *) REG_SWU4_LA2)                    /*  Lower Address Register n */
#define pREG_SWU4_UA2                    ((volatile  uint32_t *) REG_SWU4_UA2)                    /*  Upper Address Register n */
#define pREG_SWU4_ID2                    ((volatile  uint32_t *) REG_SWU4_ID2)                    /*  ID Register n */
#define pREG_SWU4_CNT2                   ((volatile  uint32_t *) REG_SWU4_CNT2)                   /*  Count Register n */
#define pREG_SWU4_TARG2                  ((volatile  uint32_t *) REG_SWU4_TARG2)                  /*  Target Register n */
#define pREG_SWU4_HIST2                  ((volatile  uint32_t *) REG_SWU4_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU4_CUR2                   ((volatile  uint32_t *) REG_SWU4_CUR2)                   /*  Current Register n */
#define pREG_SWU4_CTL3                   ((volatile  uint32_t *) REG_SWU4_CTL3)                   /*  Control Register n */
#define pREG_SWU4_LA3                    ((volatile  uint32_t *) REG_SWU4_LA3)                    /*  Lower Address Register n */
#define pREG_SWU4_UA3                    ((volatile  uint32_t *) REG_SWU4_UA3)                    /*  Upper Address Register n */
#define pREG_SWU4_ID3                    ((volatile  uint32_t *) REG_SWU4_ID3)                    /*  ID Register n */
#define pREG_SWU4_CNT3                   ((volatile  uint32_t *) REG_SWU4_CNT3)                   /*  Count Register n */
#define pREG_SWU4_TARG3                  ((volatile  uint32_t *) REG_SWU4_TARG3)                  /*  Target Register n */
#define pREG_SWU4_HIST3                  ((volatile  uint32_t *) REG_SWU4_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU4_CUR3                   ((volatile  uint32_t *) REG_SWU4_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Watchpoint Unit (SWU5)
 *  ================================================================================= */
#define pREG_SWU5_GCTL                   ((volatile  uint32_t *) REG_SWU5_GCTL)                   /*  Global Control Register */
#define pREG_SWU5_GSTAT                  ((volatile  uint32_t *) REG_SWU5_GSTAT)                  /*  Global Status Register */
#define pREG_SWU5_CTL0                   ((volatile  uint32_t *) REG_SWU5_CTL0)                   /*  Control Register n */
#define pREG_SWU5_LA0                    ((volatile  uint32_t *) REG_SWU5_LA0)                    /*  Lower Address Register n */
#define pREG_SWU5_UA0                    ((volatile  uint32_t *) REG_SWU5_UA0)                    /*  Upper Address Register n */
#define pREG_SWU5_ID0                    ((volatile  uint32_t *) REG_SWU5_ID0)                    /*  ID Register n */
#define pREG_SWU5_CNT0                   ((volatile  uint32_t *) REG_SWU5_CNT0)                   /*  Count Register n */
#define pREG_SWU5_TARG0                  ((volatile  uint32_t *) REG_SWU5_TARG0)                  /*  Target Register n */
#define pREG_SWU5_HIST0                  ((volatile  uint32_t *) REG_SWU5_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU5_CUR0                   ((volatile  uint32_t *) REG_SWU5_CUR0)                   /*  Current Register n */
#define pREG_SWU5_CTL1                   ((volatile  uint32_t *) REG_SWU5_CTL1)                   /*  Control Register n */
#define pREG_SWU5_LA1                    ((volatile  uint32_t *) REG_SWU5_LA1)                    /*  Lower Address Register n */
#define pREG_SWU5_UA1                    ((volatile  uint32_t *) REG_SWU5_UA1)                    /*  Upper Address Register n */
#define pREG_SWU5_ID1                    ((volatile  uint32_t *) REG_SWU5_ID1)                    /*  ID Register n */
#define pREG_SWU5_CNT1                   ((volatile  uint32_t *) REG_SWU5_CNT1)                   /*  Count Register n */
#define pREG_SWU5_TARG1                  ((volatile  uint32_t *) REG_SWU5_TARG1)                  /*  Target Register n */
#define pREG_SWU5_HIST1                  ((volatile  uint32_t *) REG_SWU5_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU5_CUR1                   ((volatile  uint32_t *) REG_SWU5_CUR1)                   /*  Current Register n */
#define pREG_SWU5_CTL2                   ((volatile  uint32_t *) REG_SWU5_CTL2)                   /*  Control Register n */
#define pREG_SWU5_LA2                    ((volatile  uint32_t *) REG_SWU5_LA2)                    /*  Lower Address Register n */
#define pREG_SWU5_UA2                    ((volatile  uint32_t *) REG_SWU5_UA2)                    /*  Upper Address Register n */
#define pREG_SWU5_ID2                    ((volatile  uint32_t *) REG_SWU5_ID2)                    /*  ID Register n */
#define pREG_SWU5_CNT2                   ((volatile  uint32_t *) REG_SWU5_CNT2)                   /*  Count Register n */
#define pREG_SWU5_TARG2                  ((volatile  uint32_t *) REG_SWU5_TARG2)                  /*  Target Register n */
#define pREG_SWU5_HIST2                  ((volatile  uint32_t *) REG_SWU5_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU5_CUR2                   ((volatile  uint32_t *) REG_SWU5_CUR2)                   /*  Current Register n */
#define pREG_SWU5_CTL3                   ((volatile  uint32_t *) REG_SWU5_CTL3)                   /*  Control Register n */
#define pREG_SWU5_LA3                    ((volatile  uint32_t *) REG_SWU5_LA3)                    /*  Lower Address Register n */
#define pREG_SWU5_UA3                    ((volatile  uint32_t *) REG_SWU5_UA3)                    /*  Upper Address Register n */
#define pREG_SWU5_ID3                    ((volatile  uint32_t *) REG_SWU5_ID3)                    /*  ID Register n */
#define pREG_SWU5_CNT3                   ((volatile  uint32_t *) REG_SWU5_CNT3)                   /*  Count Register n */
#define pREG_SWU5_TARG3                  ((volatile  uint32_t *) REG_SWU5_TARG3)                  /*  Target Register n */
#define pREG_SWU5_HIST3                  ((volatile  uint32_t *) REG_SWU5_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU5_CUR3                   ((volatile  uint32_t *) REG_SWU5_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Watchpoint Unit (SWU6)
 *  ================================================================================= */
#define pREG_SWU6_GCTL                   ((volatile  uint32_t *) REG_SWU6_GCTL)                   /*  Global Control Register */
#define pREG_SWU6_GSTAT                  ((volatile  uint32_t *) REG_SWU6_GSTAT)                  /*  Global Status Register */
#define pREG_SWU6_CTL0                   ((volatile  uint32_t *) REG_SWU6_CTL0)                   /*  Control Register n */
#define pREG_SWU6_LA0                    ((volatile  uint32_t *) REG_SWU6_LA0)                    /*  Lower Address Register n */
#define pREG_SWU6_UA0                    ((volatile  uint32_t *) REG_SWU6_UA0)                    /*  Upper Address Register n */
#define pREG_SWU6_ID0                    ((volatile  uint32_t *) REG_SWU6_ID0)                    /*  ID Register n */
#define pREG_SWU6_CNT0                   ((volatile  uint32_t *) REG_SWU6_CNT0)                   /*  Count Register n */
#define pREG_SWU6_TARG0                  ((volatile  uint32_t *) REG_SWU6_TARG0)                  /*  Target Register n */
#define pREG_SWU6_HIST0                  ((volatile  uint32_t *) REG_SWU6_HIST0)                  /*  Bandwidth History Register n */
#define pREG_SWU6_CUR0                   ((volatile  uint32_t *) REG_SWU6_CUR0)                   /*  Current Register n */
#define pREG_SWU6_CTL1                   ((volatile  uint32_t *) REG_SWU6_CTL1)                   /*  Control Register n */
#define pREG_SWU6_LA1                    ((volatile  uint32_t *) REG_SWU6_LA1)                    /*  Lower Address Register n */
#define pREG_SWU6_UA1                    ((volatile  uint32_t *) REG_SWU6_UA1)                    /*  Upper Address Register n */
#define pREG_SWU6_ID1                    ((volatile  uint32_t *) REG_SWU6_ID1)                    /*  ID Register n */
#define pREG_SWU6_CNT1                   ((volatile  uint32_t *) REG_SWU6_CNT1)                   /*  Count Register n */
#define pREG_SWU6_TARG1                  ((volatile  uint32_t *) REG_SWU6_TARG1)                  /*  Target Register n */
#define pREG_SWU6_HIST1                  ((volatile  uint32_t *) REG_SWU6_HIST1)                  /*  Bandwidth History Register n */
#define pREG_SWU6_CUR1                   ((volatile  uint32_t *) REG_SWU6_CUR1)                   /*  Current Register n */
#define pREG_SWU6_CTL2                   ((volatile  uint32_t *) REG_SWU6_CTL2)                   /*  Control Register n */
#define pREG_SWU6_LA2                    ((volatile  uint32_t *) REG_SWU6_LA2)                    /*  Lower Address Register n */
#define pREG_SWU6_UA2                    ((volatile  uint32_t *) REG_SWU6_UA2)                    /*  Upper Address Register n */
#define pREG_SWU6_ID2                    ((volatile  uint32_t *) REG_SWU6_ID2)                    /*  ID Register n */
#define pREG_SWU6_CNT2                   ((volatile  uint32_t *) REG_SWU6_CNT2)                   /*  Count Register n */
#define pREG_SWU6_TARG2                  ((volatile  uint32_t *) REG_SWU6_TARG2)                  /*  Target Register n */
#define pREG_SWU6_HIST2                  ((volatile  uint32_t *) REG_SWU6_HIST2)                  /*  Bandwidth History Register n */
#define pREG_SWU6_CUR2                   ((volatile  uint32_t *) REG_SWU6_CUR2)                   /*  Current Register n */
#define pREG_SWU6_CTL3                   ((volatile  uint32_t *) REG_SWU6_CTL3)                   /*  Control Register n */
#define pREG_SWU6_LA3                    ((volatile  uint32_t *) REG_SWU6_LA3)                    /*  Lower Address Register n */
#define pREG_SWU6_UA3                    ((volatile  uint32_t *) REG_SWU6_UA3)                    /*  Upper Address Register n */
#define pREG_SWU6_ID3                    ((volatile  uint32_t *) REG_SWU6_ID3)                    /*  ID Register n */
#define pREG_SWU6_CNT3                   ((volatile  uint32_t *) REG_SWU6_CNT3)                   /*  Count Register n */
#define pREG_SWU6_TARG3                  ((volatile  uint32_t *) REG_SWU6_TARG3)                  /*  Target Register n */
#define pREG_SWU6_HIST3                  ((volatile  uint32_t *) REG_SWU6_HIST3)                  /*  Bandwidth History Register n */
#define pREG_SWU6_CUR3                   ((volatile  uint32_t *) REG_SWU6_CUR3)                   /*  Current Register n */

/*  =================================================================================
 *      System Protection Unit (SPU1)
 *  ================================================================================= */
#define pREG_SPU1_CTL                    ((volatile  uint32_t *) REG_SPU1_CTL)                    /*  Control Register */
#define pREG_SPU1_STAT                   ((volatile  uint32_t *) REG_SPU1_STAT)                   /*  Status Register */
#define pREG_SPU1_TIMEOUT                ((volatile  uint32_t *) REG_SPU1_TIMEOUT)                /*  Timeout Register */
#define pREG_SPU1_WP0                    ((volatile  uint32_t *) REG_SPU1_WP0)                    /*  Write Protect Register n */
#define pREG_SPU1_WP1                    ((volatile  uint32_t *) REG_SPU1_WP1)                    /*  Write Protect Register n */
#define pREG_SPU1_WP2                    ((volatile  uint32_t *) REG_SPU1_WP2)                    /*  Write Protect Register n */
#define pREG_SPU1_WP3                    ((volatile  uint32_t *) REG_SPU1_WP3)                    /*  Write Protect Register n */
#define pREG_SPU1_WP4                    ((volatile  uint32_t *) REG_SPU1_WP4)                    /*  Write Protect Register n */
#define pREG_SPU1_WP5                    ((volatile  uint32_t *) REG_SPU1_WP5)                    /*  Write Protect Register n */
#define pREG_SPU1_WP6                    ((volatile  uint32_t *) REG_SPU1_WP6)                    /*  Write Protect Register n */
#define pREG_SPU1_WP7                    ((volatile  uint32_t *) REG_SPU1_WP7)                    /*  Write Protect Register n */
#define pREG_SPU1_WP8                    ((volatile  uint32_t *) REG_SPU1_WP8)                    /*  Write Protect Register n */
#define pREG_SPU1_WP9                    ((volatile  uint32_t *) REG_SPU1_WP9)                    /*  Write Protect Register n */
#define pREG_SPU1_WP10                   ((volatile  uint32_t *) REG_SPU1_WP10)                   /*  Write Protect Register n */
#define pREG_SPU1_WP11                   ((volatile  uint32_t *) REG_SPU1_WP11)                   /*  Write Protect Register n */
#define pREG_SPU1_WP12                   ((volatile  uint32_t *) REG_SPU1_WP12)                   /*  Write Protect Register n */
#define pREG_SPU1_WP13                   ((volatile  uint32_t *) REG_SPU1_WP13)                   /*  Write Protect Register n */
#define pREG_SPU1_WP14                   ((volatile  uint32_t *) REG_SPU1_WP14)                   /*  Write Protect Register n */
#define pREG_SPU1_WP15                   ((volatile  uint32_t *) REG_SPU1_WP15)                   /*  Write Protect Register n */
#define pREG_SPU1_WP16                   ((volatile  uint32_t *) REG_SPU1_WP16)                   /*  Write Protect Register n */
#define pREG_SPU1_WP17                   ((volatile  uint32_t *) REG_SPU1_WP17)                   /*  Write Protect Register n */
#define pREG_SPU1_WP18                   ((volatile  uint32_t *) REG_SPU1_WP18)                   /*  Write Protect Register n */
#define pREG_SPU1_WP19                   ((volatile  uint32_t *) REG_SPU1_WP19)                   /*  Write Protect Register n */
#define pREG_SPU1_WP20                   ((volatile  uint32_t *) REG_SPU1_WP20)                   /*  Write Protect Register n */
#define pREG_SPU1_WP21                   ((volatile  uint32_t *) REG_SPU1_WP21)                   /*  Write Protect Register n */
#define pREG_SPU1_WP22                   ((volatile  uint32_t *) REG_SPU1_WP22)                   /*  Write Protect Register n */
#define pREG_SPU1_WP23                   ((volatile  uint32_t *) REG_SPU1_WP23)                   /*  Write Protect Register n */
#define pREG_SPU1_WP24                   ((volatile  uint32_t *) REG_SPU1_WP24)                   /*  Write Protect Register n */
#define pREG_SPU1_WP25                   ((volatile  uint32_t *) REG_SPU1_WP25)                   /*  Write Protect Register n */
#define pREG_SPU1_WP26                   ((volatile  uint32_t *) REG_SPU1_WP26)                   /*  Write Protect Register n */
#define pREG_SPU1_WP27                   ((volatile  uint32_t *) REG_SPU1_WP27)                   /*  Write Protect Register n */
#define pREG_SPU1_WP28                   ((volatile  uint32_t *) REG_SPU1_WP28)                   /*  Write Protect Register n */
#define pREG_SPU1_WP29                   ((volatile  uint32_t *) REG_SPU1_WP29)                   /*  Write Protect Register n */
#define pREG_SPU1_WP30                   ((volatile  uint32_t *) REG_SPU1_WP30)                   /*  Write Protect Register n */
#define pREG_SPU1_WP31                   ((volatile  uint32_t *) REG_SPU1_WP31)                   /*  Write Protect Register n */
#define pREG_SPU1_WP32                   ((volatile  uint32_t *) REG_SPU1_WP32)                   /*  Write Protect Register n */
#define pREG_SPU1_WP33                   ((volatile  uint32_t *) REG_SPU1_WP33)                   /*  Write Protect Register n */
#define pREG_SPU1_WP34                   ((volatile  uint32_t *) REG_SPU1_WP34)                   /*  Write Protect Register n */
#define pREG_SPU1_WP35                   ((volatile  uint32_t *) REG_SPU1_WP35)                   /*  Write Protect Register n */
#define pREG_SPU1_WP36                   ((volatile  uint32_t *) REG_SPU1_WP36)                   /*  Write Protect Register n */
#define pREG_SPU1_WP37                   ((volatile  uint32_t *) REG_SPU1_WP37)                   /*  Write Protect Register n */
#define pREG_SPU1_WP38                   ((volatile  uint32_t *) REG_SPU1_WP38)                   /*  Write Protect Register n */
#define pREG_SPU1_WP39                   ((volatile  uint32_t *) REG_SPU1_WP39)                   /*  Write Protect Register n */
#define pREG_SPU1_WP40                   ((volatile  uint32_t *) REG_SPU1_WP40)                   /*  Write Protect Register n */
#define pREG_SPU1_WP41                   ((volatile  uint32_t *) REG_SPU1_WP41)                   /*  Write Protect Register n */
#define pREG_SPU1_WP42                   ((volatile  uint32_t *) REG_SPU1_WP42)                   /*  Write Protect Register n */
#define pREG_SPU1_WP43                   ((volatile  uint32_t *) REG_SPU1_WP43)                   /*  Write Protect Register n */
#define pREG_SPU1_WP44                   ((volatile  uint32_t *) REG_SPU1_WP44)                   /*  Write Protect Register n */
#define pREG_SPU1_WP45                   ((volatile  uint32_t *) REG_SPU1_WP45)                   /*  Write Protect Register n */
#define pREG_SPU1_WP46                   ((volatile  uint32_t *) REG_SPU1_WP46)                   /*  Write Protect Register n */
#define pREG_SPU1_WP47                   ((volatile  uint32_t *) REG_SPU1_WP47)                   /*  Write Protect Register n */
#define pREG_SPU1_WP48                   ((volatile  uint32_t *) REG_SPU1_WP48)                   /*  Write Protect Register n */
#define pREG_SPU1_WP49                   ((volatile  uint32_t *) REG_SPU1_WP49)                   /*  Write Protect Register n */
#define pREG_SPU1_WP50                   ((volatile  uint32_t *) REG_SPU1_WP50)                   /*  Write Protect Register n */
#define pREG_SPU1_WP51                   ((volatile  uint32_t *) REG_SPU1_WP51)                   /*  Write Protect Register n */
#define pREG_SPU1_WP52                   ((volatile  uint32_t *) REG_SPU1_WP52)                   /*  Write Protect Register n */
#define pREG_SPU1_WP53                   ((volatile  uint32_t *) REG_SPU1_WP53)                   /*  Write Protect Register n */
#define pREG_SPU1_WP54                   ((volatile  uint32_t *) REG_SPU1_WP54)                   /*  Write Protect Register n */
#define pREG_SPU1_WP55                   ((volatile  uint32_t *) REG_SPU1_WP55)                   /*  Write Protect Register n */
#define pREG_SPU1_WP56                   ((volatile  uint32_t *) REG_SPU1_WP56)                   /*  Write Protect Register n */
#define pREG_SPU1_WP57                   ((volatile  uint32_t *) REG_SPU1_WP57)                   /*  Write Protect Register n */
#define pREG_SPU1_WP58                   ((volatile  uint32_t *) REG_SPU1_WP58)                   /*  Write Protect Register n */
#define pREG_SPU1_WP59                   ((volatile  uint32_t *) REG_SPU1_WP59)                   /*  Write Protect Register n */
#define pREG_SPU1_WP60                   ((volatile  uint32_t *) REG_SPU1_WP60)                   /*  Write Protect Register n */
#define pREG_SPU1_WP61                   ((volatile  uint32_t *) REG_SPU1_WP61)                   /*  Write Protect Register n */
#define pREG_SPU1_WP62                   ((volatile  uint32_t *) REG_SPU1_WP62)                   /*  Write Protect Register n */
#define pREG_SPU1_WP63                   ((volatile  uint32_t *) REG_SPU1_WP63)                   /*  Write Protect Register n */
#define pREG_SPU1_WP64                   ((volatile  uint32_t *) REG_SPU1_WP64)                   /*  Write Protect Register n */
#define pREG_SPU1_WP65                   ((volatile  uint32_t *) REG_SPU1_WP65)                   /*  Write Protect Register n */
#define pREG_SPU1_AP0                    ((volatile  uint32_t *) REG_SPU1_AP0)                    /*  Access Protect Register n */
#define pREG_SPU1_AP1                    ((volatile  uint32_t *) REG_SPU1_AP1)                    /*  Access Protect Register n */
#define pREG_SPU1_AP2                    ((volatile  uint32_t *) REG_SPU1_AP2)                    /*  Access Protect Register n */
#define pREG_SPU1_AP3                    ((volatile  uint32_t *) REG_SPU1_AP3)                    /*  Access Protect Register n */
#define pREG_SPU1_AP4                    ((volatile  uint32_t *) REG_SPU1_AP4)                    /*  Access Protect Register n */
#define pREG_SPU1_AP5                    ((volatile  uint32_t *) REG_SPU1_AP5)                    /*  Access Protect Register n */
#define pREG_SPU1_AP6                    ((volatile  uint32_t *) REG_SPU1_AP6)                    /*  Access Protect Register n */
#define pREG_SPU1_AP7                    ((volatile  uint32_t *) REG_SPU1_AP7)                    /*  Access Protect Register n */
#define pREG_SPU1_AP8                    ((volatile  uint32_t *) REG_SPU1_AP8)                    /*  Access Protect Register n */
#define pREG_SPU1_AP9                    ((volatile  uint32_t *) REG_SPU1_AP9)                    /*  Access Protect Register n */
#define pREG_SPU1_AP10                   ((volatile  uint32_t *) REG_SPU1_AP10)                   /*  Access Protect Register n */
#define pREG_SPU1_AP11                   ((volatile  uint32_t *) REG_SPU1_AP11)                   /*  Access Protect Register n */
#define pREG_SPU1_AP12                   ((volatile  uint32_t *) REG_SPU1_AP12)                   /*  Access Protect Register n */
#define pREG_SPU1_AP13                   ((volatile  uint32_t *) REG_SPU1_AP13)                   /*  Access Protect Register n */
#define pREG_SPU1_AP14                   ((volatile  uint32_t *) REG_SPU1_AP14)                   /*  Access Protect Register n */
#define pREG_SPU1_AP15                   ((volatile  uint32_t *) REG_SPU1_AP15)                   /*  Access Protect Register n */
#define pREG_SPU1_AP16                   ((volatile  uint32_t *) REG_SPU1_AP16)                   /*  Access Protect Register n */
#define pREG_SPU1_AP17                   ((volatile  uint32_t *) REG_SPU1_AP17)                   /*  Access Protect Register n */
#define pREG_SPU1_AP18                   ((volatile  uint32_t *) REG_SPU1_AP18)                   /*  Access Protect Register n */
#define pREG_SPU1_AP19                   ((volatile  uint32_t *) REG_SPU1_AP19)                   /*  Access Protect Register n */
#define pREG_SPU1_AP20                   ((volatile  uint32_t *) REG_SPU1_AP20)                   /*  Access Protect Register n */
#define pREG_SPU1_AP21                   ((volatile  uint32_t *) REG_SPU1_AP21)                   /*  Access Protect Register n */
#define pREG_SPU1_AP22                   ((volatile  uint32_t *) REG_SPU1_AP22)                   /*  Access Protect Register n */
#define pREG_SPU1_AP23                   ((volatile  uint32_t *) REG_SPU1_AP23)                   /*  Access Protect Register n */
#define pREG_SPU1_AP24                   ((volatile  uint32_t *) REG_SPU1_AP24)                   /*  Access Protect Register n */
#define pREG_SPU1_AP25                   ((volatile  uint32_t *) REG_SPU1_AP25)                   /*  Access Protect Register n */
#define pREG_SPU1_AP26                   ((volatile  uint32_t *) REG_SPU1_AP26)                   /*  Access Protect Register n */
#define pREG_SPU1_AP27                   ((volatile  uint32_t *) REG_SPU1_AP27)                   /*  Access Protect Register n */
#define pREG_SPU1_AP28                   ((volatile  uint32_t *) REG_SPU1_AP28)                   /*  Access Protect Register n */
#define pREG_SPU1_AP29                   ((volatile  uint32_t *) REG_SPU1_AP29)                   /*  Access Protect Register n */
#define pREG_SPU1_AP30                   ((volatile  uint32_t *) REG_SPU1_AP30)                   /*  Access Protect Register n */
#define pREG_SPU1_AP31                   ((volatile  uint32_t *) REG_SPU1_AP31)                   /*  Access Protect Register n */
#define pREG_SPU1_AP32                   ((volatile  uint32_t *) REG_SPU1_AP32)                   /*  Access Protect Register n */
#define pREG_SPU1_AP33                   ((volatile  uint32_t *) REG_SPU1_AP33)                   /*  Access Protect Register n */
#define pREG_SPU1_AP34                   ((volatile  uint32_t *) REG_SPU1_AP34)                   /*  Access Protect Register n */
#define pREG_SPU1_AP35                   ((volatile  uint32_t *) REG_SPU1_AP35)                   /*  Access Protect Register n */
#define pREG_SPU1_AP36                   ((volatile  uint32_t *) REG_SPU1_AP36)                   /*  Access Protect Register n */
#define pREG_SPU1_AP37                   ((volatile  uint32_t *) REG_SPU1_AP37)                   /*  Access Protect Register n */
#define pREG_SPU1_AP38                   ((volatile  uint32_t *) REG_SPU1_AP38)                   /*  Access Protect Register n */
#define pREG_SPU1_AP39                   ((volatile  uint32_t *) REG_SPU1_AP39)                   /*  Access Protect Register n */
#define pREG_SPU1_AP40                   ((volatile  uint32_t *) REG_SPU1_AP40)                   /*  Access Protect Register n */
#define pREG_SPU1_AP41                   ((volatile  uint32_t *) REG_SPU1_AP41)                   /*  Access Protect Register n */
#define pREG_SPU1_AP42                   ((volatile  uint32_t *) REG_SPU1_AP42)                   /*  Access Protect Register n */
#define pREG_SPU1_AP43                   ((volatile  uint32_t *) REG_SPU1_AP43)                   /*  Access Protect Register n */
#define pREG_SPU1_AP44                   ((volatile  uint32_t *) REG_SPU1_AP44)                   /*  Access Protect Register n */
#define pREG_SPU1_AP45                   ((volatile  uint32_t *) REG_SPU1_AP45)                   /*  Access Protect Register n */
#define pREG_SPU1_AP46                   ((volatile  uint32_t *) REG_SPU1_AP46)                   /*  Access Protect Register n */
#define pREG_SPU1_AP47                   ((volatile  uint32_t *) REG_SPU1_AP47)                   /*  Access Protect Register n */
#define pREG_SPU1_AP48                   ((volatile  uint32_t *) REG_SPU1_AP48)                   /*  Access Protect Register n */
#define pREG_SPU1_AP49                   ((volatile  uint32_t *) REG_SPU1_AP49)                   /*  Access Protect Register n */
#define pREG_SPU1_AP50                   ((volatile  uint32_t *) REG_SPU1_AP50)                   /*  Access Protect Register n */
#define pREG_SPU1_AP51                   ((volatile  uint32_t *) REG_SPU1_AP51)                   /*  Access Protect Register n */
#define pREG_SPU1_AP52                   ((volatile  uint32_t *) REG_SPU1_AP52)                   /*  Access Protect Register n */
#define pREG_SPU1_AP53                   ((volatile  uint32_t *) REG_SPU1_AP53)                   /*  Access Protect Register n */
#define pREG_SPU1_AP54                   ((volatile  uint32_t *) REG_SPU1_AP54)                   /*  Access Protect Register n */
#define pREG_SPU1_AP55                   ((volatile  uint32_t *) REG_SPU1_AP55)                   /*  Access Protect Register n */
#define pREG_SPU1_AP56                   ((volatile  uint32_t *) REG_SPU1_AP56)                   /*  Access Protect Register n */
#define pREG_SPU1_AP57                   ((volatile  uint32_t *) REG_SPU1_AP57)                   /*  Access Protect Register n */
#define pREG_SPU1_AP58                   ((volatile  uint32_t *) REG_SPU1_AP58)                   /*  Access Protect Register n */
#define pREG_SPU1_AP59                   ((volatile  uint32_t *) REG_SPU1_AP59)                   /*  Access Protect Register n */
#define pREG_SPU1_AP60                   ((volatile  uint32_t *) REG_SPU1_AP60)                   /*  Access Protect Register n */
#define pREG_SPU1_AP61                   ((volatile  uint32_t *) REG_SPU1_AP61)                   /*  Access Protect Register n */
#define pREG_SPU1_AP62                   ((volatile  uint32_t *) REG_SPU1_AP62)                   /*  Access Protect Register n */
#define pREG_SPU1_AP63                   ((volatile  uint32_t *) REG_SPU1_AP63)                   /*  Access Protect Register n */
#define pREG_SPU1_AP64                   ((volatile  uint32_t *) REG_SPU1_AP64)                   /*  Access Protect Register n */
#define pREG_SPU1_AP65                   ((volatile  uint32_t *) REG_SPU1_AP65)                   /*  Access Protect Register n */
#define pREG_SPU1_IDTLS                  ((volatile  uint32_t *) REG_SPU1_IDTLS)                  /*  Interrupt Details Register */
#define pREG_SPU1_IADDR                  ((volatile  uint32_t *) REG_SPU1_IADDR)                  /*  Interrupt Address Register */
#define pREG_SPU1_DEVID                  ((volatile  uint32_t *) REG_SPU1_DEVID)                  /*  Device Configuration Register */
#define pREG_SPU1_DEVTYPE                ((volatile  uint32_t *) REG_SPU1_DEVTYPE)                /*  Device Type Identifier Register */
#define pREG_SPU1_PID4                   ((volatile  uint32_t *) REG_SPU1_PID4)                   /*  Peripheral ID4 Register */
#define pREG_SPU1_PID5                   ((volatile  uint32_t *) REG_SPU1_PID5)                   /*  Peripheral ID5 Register */
#define pREG_SPU1_PID6                   ((volatile  uint32_t *) REG_SPU1_PID6)                   /*  Peripheral ID6 Register */
#define pREG_SPU1_PID7                   ((volatile  uint32_t *) REG_SPU1_PID7)                   /*  Peripheral ID7 Register */
#define pREG_SPU1_PID0                   ((volatile  uint32_t *) REG_SPU1_PID0)                   /*  Peripheral ID0 Register */
#define pREG_SPU1_PID1                   ((volatile  uint32_t *) REG_SPU1_PID1)                   /*  Peripheral ID1 Register */
#define pREG_SPU1_PID2                   ((volatile  uint32_t *) REG_SPU1_PID2)                   /*  Peripheral ID2 Register */
#define pREG_SPU1_PID3                   ((volatile  uint32_t *) REG_SPU1_PID3)                   /*  Peripheral ID3 Register */
#define pREG_SPU1_CID0                   ((volatile  uint32_t *) REG_SPU1_CID0)                   /*  Component ID0 Register */
#define pREG_SPU1_CID1                   ((volatile  uint32_t *) REG_SPU1_CID1)                   /*  Component ID1 Register */
#define pREG_SPU1_CID2                   ((volatile  uint32_t *) REG_SPU1_CID2)                   /*  Component ID2 Register */
#define pREG_SPU1_CID3                   ((volatile  uint32_t *) REG_SPU1_CID3)                   /*  Component ID3 Register */

/*  =================================================================================
 *      Pads Controller (C0)
 *  ================================================================================= */
#define pREG_C0_SYSSTAT                  ((volatile  uint32_t *) REG_C0_SYSSTAT)                  /*  System Status Register */
#define pREG_C0_AHB_RESP_CFG             ((volatile  uint32_t *) REG_C0_AHB_RESP_CFG)             /*  AHB Response Configuration Register */
#define pREG_C0_AHB_TIMEOUT_VALUE        ((volatile  uint32_t *) REG_C0_AHB_TIMEOUT_VALUE)        /*  AHB Timeout Value Register */
#define pREG_C0_ENG_MODE_CFG0            ((volatile  uint32_t *) REG_C0_ENG_MODE_CFG0)            /*  Engineering Mode Configuration Register 0 */
#define pREG_C0_M0_VTOR                  ((volatile  uint32_t *) REG_C0_M0_VTOR)                  /*  Vector table base offset field */
#define pREG_C0_SRAM0_ECC                ((volatile  uint32_t *) REG_C0_SRAM0_ECC)                /*  M0 SRAM ECC */
#define pREG_C0_SYS_STCALIB              ((volatile  uint32_t *) REG_C0_SYS_STCALIB)              /*  System */
#define pREG_C0_IRQ_LATENCY              ((volatile  uint32_t *) REG_C0_IRQ_LATENCY)              /*  M0 IRQ LATENCY */
#define pREG_C0_SISTAT0                  ((volatile  uint32_t *) REG_C0_SISTAT0)                  /*  Shared Interrupt 0 Status Register */
#define pREG_C0_SISTAT3                  ((volatile  uint32_t *) REG_C0_SISTAT3)                  /*  Shared Interrupt 3 Status Register */
#define pREG_C0_SISTAT5                  ((volatile  uint32_t *) REG_C0_SISTAT5)                  /*  Shared Interrupt 5 Status Register */
#define pREG_C0_SISTAT6                  ((volatile  uint32_t *) REG_C0_SISTAT6)                  /*  Shared Interrupt 6 Status Register */
#define pREG_C0_SISTAT7                  ((volatile  uint32_t *) REG_C0_SISTAT7)                  /*  Shared Interrupt 7 Status Register */
#define pREG_C0_SISTAT8                  ((volatile  uint32_t *) REG_C0_SISTAT8)                  /*  Shared Interrupt 8 Status Register */
#define pREG_C0_SISTAT10                 ((volatile  uint32_t *) REG_C0_SISTAT10)                 /*  Shared Interrupt 10 Status Register */
#define pREG_C0_SISTAT11                 ((volatile  uint32_t *) REG_C0_SISTAT11)                 /*  Shared Interrupt 11 Status Register */
#define pREG_C0_SISTAT12                 ((volatile  uint32_t *) REG_C0_SISTAT12)                 /*  Shared Interrupt 12 Status Register */
#define pREG_C0_SISTAT15                 ((volatile  uint32_t *) REG_C0_SISTAT15)                 /*  Shared Interrupt 15 Status Register */
#define pREG_C0_SISTAT16                 ((volatile  uint32_t *) REG_C0_SISTAT16)                 /*  Shared Interrupt 16 Status Register */
#define pREG_C0_SISTAT17                 ((volatile  uint32_t *) REG_C0_SISTAT17)                 /*  Shared Interrupt 17 Status Register */
#define pREG_C0_SISTAT18                 ((volatile  uint32_t *) REG_C0_SISTAT18)                 /*  Shared Interrupt 18 Status Register */
#define pREG_C0_SISTAT19                 ((volatile  uint32_t *) REG_C0_SISTAT19)                 /*  Shared Interrupt 19 Status Register */
#define pREG_C0_SISTAT22                 ((volatile  uint32_t *) REG_C0_SISTAT22)                 /*  Shared Interrupt 22 Status Register */
#define pREG_C0_SISTAT25                 ((volatile  uint32_t *) REG_C0_SISTAT25)                 /*  Shared Interrupt 25 Status Register */
#define pREG_C0_SISTAT28                 ((volatile  uint32_t *) REG_C0_SISTAT28)                 /*  Shared Interrupt 28 Status Register */

/*  =================================================================================
 *      Pads Controller (TEPADS0)
 *  ================================================================================= */
#define pREG_TEPADS0_PCFG0               ((volatile  uint32_t *) REG_TEPADS0_PCFG0)               /*  Peripheral Configuration0 Register */
#define pREG_TEPADS0_PORTA_DS            ((volatile  uint32_t *) REG_TEPADS0_PORTA_DS)            /*  Multiport Drive Strength Register */
#define pREG_TEPADS0_PORTA_RCTL          ((volatile  uint32_t *) REG_TEPADS0_PORTA_RCTL)          /*  Multiport Pullup/Pulldown Resistor Control Register */
#define pREG_TEPADS0_PORTA_TRIPST        ((volatile  uint32_t *) REG_TEPADS0_PORTA_TRIPST)        /*  Multiport Trip State Register */
#define pREG_TEPADS0_PORTA_TRIPSEL       ((volatile  uint32_t *) REG_TEPADS0_PORTA_TRIPSEL)       /*  Multiport Trip Select */

/*  =================================================================================
 *      General Purpose Input/Output (PORTA)
 *  ================================================================================= */
#define pREG_PORTA_FER                   ((volatile  uint32_t *) REG_PORTA_FER)                   /*  Port x Function Enable Register */
#define pREG_PORTA_FER_SET               ((volatile  uint32_t *) REG_PORTA_FER_SET)               /*  Port x Function Enable Set Register */
#define pREG_PORTA_FER_CLR               ((volatile  uint32_t *) REG_PORTA_FER_CLR)               /*  Port x Function Enable Clear Register */
#define pREG_PORTA_DATA                  ((volatile  uint32_t *) REG_PORTA_DATA)                  /*  Port x GPIO Data Register */
#define pREG_PORTA_DATA_SET              ((volatile  uint32_t *) REG_PORTA_DATA_SET)              /*  Port x GPIO Data Set Register */
#define pREG_PORTA_DATA_CLR              ((volatile  uint32_t *) REG_PORTA_DATA_CLR)              /*  Port x GPIO Data Clear Register */
#define pREG_PORTA_DIR                   ((volatile  uint32_t *) REG_PORTA_DIR)                   /*  Port x GPIO Direction Register */
#define pREG_PORTA_DIR_SET               ((volatile  uint32_t *) REG_PORTA_DIR_SET)               /*  Port x GPIO Direction Set Register */
#define pREG_PORTA_DIR_CLR               ((volatile  uint32_t *) REG_PORTA_DIR_CLR)               /*  Port x GPIO Direction Clear Register */
#define pREG_PORTA_INEN                  ((volatile  uint32_t *) REG_PORTA_INEN)                  /*  Port x GPIO Input Enable Register */
#define pREG_PORTA_INEN_SET              ((volatile  uint32_t *) REG_PORTA_INEN_SET)              /*  Port x GPIO Input Enable Set Register */
#define pREG_PORTA_INEN_CLR              ((volatile  uint32_t *) REG_PORTA_INEN_CLR)              /*  Port x GPIO Input Enable Clear Register */
#define pREG_PORTA_MUX                   ((volatile  uint32_t *) REG_PORTA_MUX)                   /*  Port x Multiplexer Control Register */
#define pREG_PORTA_DATA_TGL              ((volatile  uint32_t *) REG_PORTA_DATA_TGL)              /*  Port x GPIO Input Enable Toggle Register */
#define pREG_PORTA_POL                   ((volatile  uint32_t *) REG_PORTA_POL)                   /*  Port x GPIO Polarity Invert Register */
#define pREG_PORTA_POL_SET               ((volatile  uint32_t *) REG_PORTA_POL_SET)               /*  Port x GPIO Polarity Invert Set Register */
#define pREG_PORTA_POL_CLR               ((volatile  uint32_t *) REG_PORTA_POL_CLR)               /*  Port x GPIO Polarity Invert Clear Register */
#define pREG_PORTA_LOCK                  ((volatile  uint32_t *) REG_PORTA_LOCK)                  /*  Port x GPIO Lock Register */
#define pREG_PORTA_TRIG_TGL              ((volatile  uint32_t *) REG_PORTA_TRIG_TGL)              /*  Port x GPIO Trigger Toggle Register */

/*  =================================================================================
 *      System Event Controller (SEC0)
 *  ================================================================================= */
#define pREG_SEC0_GCTL                   ((volatile  uint32_t *) REG_SEC0_GCTL)                   /*  Global Control Register */
#define pREG_SEC0_GSTAT                  ((volatile  uint32_t *) REG_SEC0_GSTAT)                  /*  Global Status Register */
#define pREG_SEC0_RAISE                  ((volatile  uint32_t *) REG_SEC0_RAISE)                  /*  Global Raise Register */
#define pREG_SEC0_FCTL                   ((volatile  uint32_t *) REG_SEC0_FCTL)                   /*  Fault Control Register */
#define pREG_SEC0_FSTAT                  ((volatile  uint32_t *) REG_SEC0_FSTAT)                  /*  Fault Status Register */
#define pREG_SEC0_FSID                   ((volatile  uint32_t *) REG_SEC0_FSID)                   /*  Fault Source ID Register */
#define pREG_SEC0_FEND                   ((volatile  uint32_t *) REG_SEC0_FEND)                   /*  Fault End Register */
#define pREG_SEC0_FDLY                   ((volatile  uint32_t *) REG_SEC0_FDLY)                   /*  Fault Delay Register */
#define pREG_SEC0_FDLY_CUR               ((volatile  uint32_t *) REG_SEC0_FDLY_CUR)               /*  Fault Delay Current Register */
#define pREG_SEC0_FSRDLY                 ((volatile  uint32_t *) REG_SEC0_FSRDLY)                 /*  Fault System Reset Delay Register */
#define pREG_SEC0_FSRDLY_CUR             ((volatile  uint32_t *) REG_SEC0_FSRDLY_CUR)             /*  Fault System Reset Delay Current Register */
#define pREG_SEC0_FCOPP                  ((volatile  uint32_t *) REG_SEC0_FCOPP)                  /*  Fault COP Period Register */
#define pREG_SEC0_FCOPP_CUR              ((volatile  uint32_t *) REG_SEC0_FCOPP_CUR)              /*  Fault COP Period Current Register */
#define pREG_SEC0_SCTL0                  ((volatile  uint32_t *) REG_SEC0_SCTL0)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT0                 ((volatile  uint32_t *) REG_SEC0_SSTAT0)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL1                  ((volatile  uint32_t *) REG_SEC0_SCTL1)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT1                 ((volatile  uint32_t *) REG_SEC0_SSTAT1)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL2                  ((volatile  uint32_t *) REG_SEC0_SCTL2)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT2                 ((volatile  uint32_t *) REG_SEC0_SSTAT2)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL3                  ((volatile  uint32_t *) REG_SEC0_SCTL3)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT3                 ((volatile  uint32_t *) REG_SEC0_SSTAT3)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL4                  ((volatile  uint32_t *) REG_SEC0_SCTL4)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT4                 ((volatile  uint32_t *) REG_SEC0_SSTAT4)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL5                  ((volatile  uint32_t *) REG_SEC0_SCTL5)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT5                 ((volatile  uint32_t *) REG_SEC0_SSTAT5)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL6                  ((volatile  uint32_t *) REG_SEC0_SCTL6)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT6                 ((volatile  uint32_t *) REG_SEC0_SSTAT6)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL7                  ((volatile  uint32_t *) REG_SEC0_SCTL7)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT7                 ((volatile  uint32_t *) REG_SEC0_SSTAT7)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL8                  ((volatile  uint32_t *) REG_SEC0_SCTL8)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT8                 ((volatile  uint32_t *) REG_SEC0_SSTAT8)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL9                  ((volatile  uint32_t *) REG_SEC0_SCTL9)                  /*  Source Control Register n */
#define pREG_SEC0_SSTAT9                 ((volatile  uint32_t *) REG_SEC0_SSTAT9)                 /*  Source Status Register n */
#define pREG_SEC0_SCTL10                 ((volatile  uint32_t *) REG_SEC0_SCTL10)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT10                ((volatile  uint32_t *) REG_SEC0_SSTAT10)                /*  Source Status Register n */
#define pREG_SEC0_SCTL11                 ((volatile  uint32_t *) REG_SEC0_SCTL11)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT11                ((volatile  uint32_t *) REG_SEC0_SSTAT11)                /*  Source Status Register n */
#define pREG_SEC0_SCTL12                 ((volatile  uint32_t *) REG_SEC0_SCTL12)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT12                ((volatile  uint32_t *) REG_SEC0_SSTAT12)                /*  Source Status Register n */
#define pREG_SEC0_SCTL13                 ((volatile  uint32_t *) REG_SEC0_SCTL13)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT13                ((volatile  uint32_t *) REG_SEC0_SSTAT13)                /*  Source Status Register n */
#define pREG_SEC0_SCTL14                 ((volatile  uint32_t *) REG_SEC0_SCTL14)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT14                ((volatile  uint32_t *) REG_SEC0_SSTAT14)                /*  Source Status Register n */
#define pREG_SEC0_SCTL15                 ((volatile  uint32_t *) REG_SEC0_SCTL15)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT15                ((volatile  uint32_t *) REG_SEC0_SSTAT15)                /*  Source Status Register n */
#define pREG_SEC0_SCTL16                 ((volatile  uint32_t *) REG_SEC0_SCTL16)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT16                ((volatile  uint32_t *) REG_SEC0_SSTAT16)                /*  Source Status Register n */
#define pREG_SEC0_SCTL17                 ((volatile  uint32_t *) REG_SEC0_SCTL17)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT17                ((volatile  uint32_t *) REG_SEC0_SSTAT17)                /*  Source Status Register n */
#define pREG_SEC0_SCTL18                 ((volatile  uint32_t *) REG_SEC0_SCTL18)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT18                ((volatile  uint32_t *) REG_SEC0_SSTAT18)                /*  Source Status Register n */
#define pREG_SEC0_SCTL19                 ((volatile  uint32_t *) REG_SEC0_SCTL19)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT19                ((volatile  uint32_t *) REG_SEC0_SSTAT19)                /*  Source Status Register n */
#define pREG_SEC0_SCTL20                 ((volatile  uint32_t *) REG_SEC0_SCTL20)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT20                ((volatile  uint32_t *) REG_SEC0_SSTAT20)                /*  Source Status Register n */
#define pREG_SEC0_SCTL21                 ((volatile  uint32_t *) REG_SEC0_SCTL21)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT21                ((volatile  uint32_t *) REG_SEC0_SSTAT21)                /*  Source Status Register n */
#define pREG_SEC0_SCTL22                 ((volatile  uint32_t *) REG_SEC0_SCTL22)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT22                ((volatile  uint32_t *) REG_SEC0_SSTAT22)                /*  Source Status Register n */
#define pREG_SEC0_SCTL23                 ((volatile  uint32_t *) REG_SEC0_SCTL23)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT23                ((volatile  uint32_t *) REG_SEC0_SSTAT23)                /*  Source Status Register n */
#define pREG_SEC0_SCTL24                 ((volatile  uint32_t *) REG_SEC0_SCTL24)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT24                ((volatile  uint32_t *) REG_SEC0_SSTAT24)                /*  Source Status Register n */
#define pREG_SEC0_SCTL25                 ((volatile  uint32_t *) REG_SEC0_SCTL25)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT25                ((volatile  uint32_t *) REG_SEC0_SSTAT25)                /*  Source Status Register n */
#define pREG_SEC0_SCTL26                 ((volatile  uint32_t *) REG_SEC0_SCTL26)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT26                ((volatile  uint32_t *) REG_SEC0_SSTAT26)                /*  Source Status Register n */
#define pREG_SEC0_SCTL27                 ((volatile  uint32_t *) REG_SEC0_SCTL27)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT27                ((volatile  uint32_t *) REG_SEC0_SSTAT27)                /*  Source Status Register n */
#define pREG_SEC0_SCTL28                 ((volatile  uint32_t *) REG_SEC0_SCTL28)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT28                ((volatile  uint32_t *) REG_SEC0_SSTAT28)                /*  Source Status Register n */
#define pREG_SEC0_SCTL29                 ((volatile  uint32_t *) REG_SEC0_SCTL29)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT29                ((volatile  uint32_t *) REG_SEC0_SSTAT29)                /*  Source Status Register n */
#define pREG_SEC0_SCTL30                 ((volatile  uint32_t *) REG_SEC0_SCTL30)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT30                ((volatile  uint32_t *) REG_SEC0_SSTAT30)                /*  Source Status Register n */
#define pREG_SEC0_SCTL31                 ((volatile  uint32_t *) REG_SEC0_SCTL31)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT31                ((volatile  uint32_t *) REG_SEC0_SSTAT31)                /*  Source Status Register n */
#define pREG_SEC0_SCTL32                 ((volatile  uint32_t *) REG_SEC0_SCTL32)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT32                ((volatile  uint32_t *) REG_SEC0_SSTAT32)                /*  Source Status Register n */
#define pREG_SEC0_SCTL33                 ((volatile  uint32_t *) REG_SEC0_SCTL33)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT33                ((volatile  uint32_t *) REG_SEC0_SSTAT33)                /*  Source Status Register n */
#define pREG_SEC0_SCTL34                 ((volatile  uint32_t *) REG_SEC0_SCTL34)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT34                ((volatile  uint32_t *) REG_SEC0_SSTAT34)                /*  Source Status Register n */
#define pREG_SEC0_SCTL35                 ((volatile  uint32_t *) REG_SEC0_SCTL35)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT35                ((volatile  uint32_t *) REG_SEC0_SSTAT35)                /*  Source Status Register n */
#define pREG_SEC0_SCTL36                 ((volatile  uint32_t *) REG_SEC0_SCTL36)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT36                ((volatile  uint32_t *) REG_SEC0_SSTAT36)                /*  Source Status Register n */
#define pREG_SEC0_SCTL37                 ((volatile  uint32_t *) REG_SEC0_SCTL37)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT37                ((volatile  uint32_t *) REG_SEC0_SSTAT37)                /*  Source Status Register n */
#define pREG_SEC0_SCTL38                 ((volatile  uint32_t *) REG_SEC0_SCTL38)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT38                ((volatile  uint32_t *) REG_SEC0_SSTAT38)                /*  Source Status Register n */
#define pREG_SEC0_SCTL39                 ((volatile  uint32_t *) REG_SEC0_SCTL39)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT39                ((volatile  uint32_t *) REG_SEC0_SSTAT39)                /*  Source Status Register n */
#define pREG_SEC0_SCTL40                 ((volatile  uint32_t *) REG_SEC0_SCTL40)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT40                ((volatile  uint32_t *) REG_SEC0_SSTAT40)                /*  Source Status Register n */
#define pREG_SEC0_SCTL41                 ((volatile  uint32_t *) REG_SEC0_SCTL41)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT41                ((volatile  uint32_t *) REG_SEC0_SSTAT41)                /*  Source Status Register n */
#define pREG_SEC0_SCTL42                 ((volatile  uint32_t *) REG_SEC0_SCTL42)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT42                ((volatile  uint32_t *) REG_SEC0_SSTAT42)                /*  Source Status Register n */
#define pREG_SEC0_SCTL43                 ((volatile  uint32_t *) REG_SEC0_SCTL43)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT43                ((volatile  uint32_t *) REG_SEC0_SSTAT43)                /*  Source Status Register n */
#define pREG_SEC0_SCTL44                 ((volatile  uint32_t *) REG_SEC0_SCTL44)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT44                ((volatile  uint32_t *) REG_SEC0_SSTAT44)                /*  Source Status Register n */
#define pREG_SEC0_SCTL45                 ((volatile  uint32_t *) REG_SEC0_SCTL45)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT45                ((volatile  uint32_t *) REG_SEC0_SSTAT45)                /*  Source Status Register n */
#define pREG_SEC0_SCTL46                 ((volatile  uint32_t *) REG_SEC0_SCTL46)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT46                ((volatile  uint32_t *) REG_SEC0_SSTAT46)                /*  Source Status Register n */
#define pREG_SEC0_SCTL47                 ((volatile  uint32_t *) REG_SEC0_SCTL47)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT47                ((volatile  uint32_t *) REG_SEC0_SSTAT47)                /*  Source Status Register n */
#define pREG_SEC0_SCTL48                 ((volatile  uint32_t *) REG_SEC0_SCTL48)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT48                ((volatile  uint32_t *) REG_SEC0_SSTAT48)                /*  Source Status Register n */
#define pREG_SEC0_SCTL49                 ((volatile  uint32_t *) REG_SEC0_SCTL49)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT49                ((volatile  uint32_t *) REG_SEC0_SSTAT49)                /*  Source Status Register n */
#define pREG_SEC0_SCTL50                 ((volatile  uint32_t *) REG_SEC0_SCTL50)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT50                ((volatile  uint32_t *) REG_SEC0_SSTAT50)                /*  Source Status Register n */
#define pREG_SEC0_SCTL51                 ((volatile  uint32_t *) REG_SEC0_SCTL51)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT51                ((volatile  uint32_t *) REG_SEC0_SSTAT51)                /*  Source Status Register n */
#define pREG_SEC0_SCTL52                 ((volatile  uint32_t *) REG_SEC0_SCTL52)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT52                ((volatile  uint32_t *) REG_SEC0_SSTAT52)                /*  Source Status Register n */
#define pREG_SEC0_SCTL53                 ((volatile  uint32_t *) REG_SEC0_SCTL53)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT53                ((volatile  uint32_t *) REG_SEC0_SSTAT53)                /*  Source Status Register n */
#define pREG_SEC0_SCTL54                 ((volatile  uint32_t *) REG_SEC0_SCTL54)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT54                ((volatile  uint32_t *) REG_SEC0_SSTAT54)                /*  Source Status Register n */
#define pREG_SEC0_SCTL55                 ((volatile  uint32_t *) REG_SEC0_SCTL55)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT55                ((volatile  uint32_t *) REG_SEC0_SSTAT55)                /*  Source Status Register n */
#define pREG_SEC0_SCTL56                 ((volatile  uint32_t *) REG_SEC0_SCTL56)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT56                ((volatile  uint32_t *) REG_SEC0_SSTAT56)                /*  Source Status Register n */
#define pREG_SEC0_SCTL57                 ((volatile  uint32_t *) REG_SEC0_SCTL57)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT57                ((volatile  uint32_t *) REG_SEC0_SSTAT57)                /*  Source Status Register n */
#define pREG_SEC0_SCTL58                 ((volatile  uint32_t *) REG_SEC0_SCTL58)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT58                ((volatile  uint32_t *) REG_SEC0_SSTAT58)                /*  Source Status Register n */
#define pREG_SEC0_SCTL59                 ((volatile  uint32_t *) REG_SEC0_SCTL59)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT59                ((volatile  uint32_t *) REG_SEC0_SSTAT59)                /*  Source Status Register n */
#define pREG_SEC0_SCTL60                 ((volatile  uint32_t *) REG_SEC0_SCTL60)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT60                ((volatile  uint32_t *) REG_SEC0_SSTAT60)                /*  Source Status Register n */
#define pREG_SEC0_SCTL61                 ((volatile  uint32_t *) REG_SEC0_SCTL61)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT61                ((volatile  uint32_t *) REG_SEC0_SSTAT61)                /*  Source Status Register n */
#define pREG_SEC0_SCTL62                 ((volatile  uint32_t *) REG_SEC0_SCTL62)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT62                ((volatile  uint32_t *) REG_SEC0_SSTAT62)                /*  Source Status Register n */
#define pREG_SEC0_SCTL63                 ((volatile  uint32_t *) REG_SEC0_SCTL63)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT63                ((volatile  uint32_t *) REG_SEC0_SSTAT63)                /*  Source Status Register n */
#define pREG_SEC0_SCTL64                 ((volatile  uint32_t *) REG_SEC0_SCTL64)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT64                ((volatile  uint32_t *) REG_SEC0_SSTAT64)                /*  Source Status Register n */
#define pREG_SEC0_SCTL65                 ((volatile  uint32_t *) REG_SEC0_SCTL65)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT65                ((volatile  uint32_t *) REG_SEC0_SSTAT65)                /*  Source Status Register n */
#define pREG_SEC0_SCTL66                 ((volatile  uint32_t *) REG_SEC0_SCTL66)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT66                ((volatile  uint32_t *) REG_SEC0_SSTAT66)                /*  Source Status Register n */
#define pREG_SEC0_SCTL67                 ((volatile  uint32_t *) REG_SEC0_SCTL67)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT67                ((volatile  uint32_t *) REG_SEC0_SSTAT67)                /*  Source Status Register n */
#define pREG_SEC0_SCTL68                 ((volatile  uint32_t *) REG_SEC0_SCTL68)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT68                ((volatile  uint32_t *) REG_SEC0_SSTAT68)                /*  Source Status Register n */
#define pREG_SEC0_SCTL69                 ((volatile  uint32_t *) REG_SEC0_SCTL69)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT69                ((volatile  uint32_t *) REG_SEC0_SSTAT69)                /*  Source Status Register n */
#define pREG_SEC0_SCTL70                 ((volatile  uint32_t *) REG_SEC0_SCTL70)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT70                ((volatile  uint32_t *) REG_SEC0_SSTAT70)                /*  Source Status Register n */
#define pREG_SEC0_SCTL71                 ((volatile  uint32_t *) REG_SEC0_SCTL71)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT71                ((volatile  uint32_t *) REG_SEC0_SSTAT71)                /*  Source Status Register n */
#define pREG_SEC0_SCTL72                 ((volatile  uint32_t *) REG_SEC0_SCTL72)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT72                ((volatile  uint32_t *) REG_SEC0_SSTAT72)                /*  Source Status Register n */
#define pREG_SEC0_SCTL73                 ((volatile  uint32_t *) REG_SEC0_SCTL73)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT73                ((volatile  uint32_t *) REG_SEC0_SSTAT73)                /*  Source Status Register n */
#define pREG_SEC0_SCTL74                 ((volatile  uint32_t *) REG_SEC0_SCTL74)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT74                ((volatile  uint32_t *) REG_SEC0_SSTAT74)                /*  Source Status Register n */
#define pREG_SEC0_SCTL75                 ((volatile  uint32_t *) REG_SEC0_SCTL75)                 /*  Source Control Register n */
#define pREG_SEC0_SSTAT75                ((volatile  uint32_t *) REG_SEC0_SSTAT75)                /*  Source Status Register n */

/*  =================================================================================
 *      Trigger Routing Unit (TRU0)
 *  ================================================================================= */
#define pREG_TRU0_SSR0                   ((volatile  uint32_t *) REG_TRU0_SSR0)                   /*  Slave Select Register */
#define pREG_TRU0_SSR1                   ((volatile  uint32_t *) REG_TRU0_SSR1)                   /*  Slave Select Register */
#define pREG_TRU0_SSR2                   ((volatile  uint32_t *) REG_TRU0_SSR2)                   /*  Slave Select Register */
#define pREG_TRU0_SSR3                   ((volatile  uint32_t *) REG_TRU0_SSR3)                   /*  Slave Select Register */
#define pREG_TRU0_SSR4                   ((volatile  uint32_t *) REG_TRU0_SSR4)                   /*  Slave Select Register */
#define pREG_TRU0_SSR5                   ((volatile  uint32_t *) REG_TRU0_SSR5)                   /*  Slave Select Register */
#define pREG_TRU0_SSR6                   ((volatile  uint32_t *) REG_TRU0_SSR6)                   /*  Slave Select Register */
#define pREG_TRU0_SSR7                   ((volatile  uint32_t *) REG_TRU0_SSR7)                   /*  Slave Select Register */
#define pREG_TRU0_SSR8                   ((volatile  uint32_t *) REG_TRU0_SSR8)                   /*  Slave Select Register */
#define pREG_TRU0_SSR9                   ((volatile  uint32_t *) REG_TRU0_SSR9)                   /*  Slave Select Register */
#define pREG_TRU0_SSR10                  ((volatile  uint32_t *) REG_TRU0_SSR10)                  /*  Slave Select Register */
#define pREG_TRU0_SSR11                  ((volatile  uint32_t *) REG_TRU0_SSR11)                  /*  Slave Select Register */
#define pREG_TRU0_SSR12                  ((volatile  uint32_t *) REG_TRU0_SSR12)                  /*  Slave Select Register */
#define pREG_TRU0_SSR13                  ((volatile  uint32_t *) REG_TRU0_SSR13)                  /*  Slave Select Register */
#define pREG_TRU0_SSR14                  ((volatile  uint32_t *) REG_TRU0_SSR14)                  /*  Slave Select Register */
#define pREG_TRU0_SSR15                  ((volatile  uint32_t *) REG_TRU0_SSR15)                  /*  Slave Select Register */
#define pREG_TRU0_SSR16                  ((volatile  uint32_t *) REG_TRU0_SSR16)                  /*  Slave Select Register */
#define pREG_TRU0_SSR17                  ((volatile  uint32_t *) REG_TRU0_SSR17)                  /*  Slave Select Register */
#define pREG_TRU0_SSR18                  ((volatile  uint32_t *) REG_TRU0_SSR18)                  /*  Slave Select Register */
#define pREG_TRU0_SSR19                  ((volatile  uint32_t *) REG_TRU0_SSR19)                  /*  Slave Select Register */
#define pREG_TRU0_SSR20                  ((volatile  uint32_t *) REG_TRU0_SSR20)                  /*  Slave Select Register */
#define pREG_TRU0_SSR21                  ((volatile  uint32_t *) REG_TRU0_SSR21)                  /*  Slave Select Register */
#define pREG_TRU0_SSR22                  ((volatile  uint32_t *) REG_TRU0_SSR22)                  /*  Slave Select Register */
#define pREG_TRU0_SSR23                  ((volatile  uint32_t *) REG_TRU0_SSR23)                  /*  Slave Select Register */
#define pREG_TRU0_SSR24                  ((volatile  uint32_t *) REG_TRU0_SSR24)                  /*  Slave Select Register */
#define pREG_TRU0_SSR25                  ((volatile  uint32_t *) REG_TRU0_SSR25)                  /*  Slave Select Register */
#define pREG_TRU0_SSR26                  ((volatile  uint32_t *) REG_TRU0_SSR26)                  /*  Slave Select Register */
#define pREG_TRU0_SSR27                  ((volatile  uint32_t *) REG_TRU0_SSR27)                  /*  Slave Select Register */
#define pREG_TRU0_SSR28                  ((volatile  uint32_t *) REG_TRU0_SSR28)                  /*  Slave Select Register */
#define pREG_TRU0_SSR29                  ((volatile  uint32_t *) REG_TRU0_SSR29)                  /*  Slave Select Register */
#define pREG_TRU0_SSR30                  ((volatile  uint32_t *) REG_TRU0_SSR30)                  /*  Slave Select Register */
#define pREG_TRU0_SSR31                  ((volatile  uint32_t *) REG_TRU0_SSR31)                  /*  Slave Select Register */
#define pREG_TRU0_SSR32                  ((volatile  uint32_t *) REG_TRU0_SSR32)                  /*  Slave Select Register */
#define pREG_TRU0_SSR33                  ((volatile  uint32_t *) REG_TRU0_SSR33)                  /*  Slave Select Register */
#define pREG_TRU0_SSR34                  ((volatile  uint32_t *) REG_TRU0_SSR34)                  /*  Slave Select Register */
#define pREG_TRU0_SSR35                  ((volatile  uint32_t *) REG_TRU0_SSR35)                  /*  Slave Select Register */
#define pREG_TRU0_SSR36                  ((volatile  uint32_t *) REG_TRU0_SSR36)                  /*  Slave Select Register */
#define pREG_TRU0_SSR37                  ((volatile  uint32_t *) REG_TRU0_SSR37)                  /*  Slave Select Register */
#define pREG_TRU0_SSR38                  ((volatile  uint32_t *) REG_TRU0_SSR38)                  /*  Slave Select Register */
#define pREG_TRU0_SSR39                  ((volatile  uint32_t *) REG_TRU0_SSR39)                  /*  Slave Select Register */
#define pREG_TRU0_SSR40                  ((volatile  uint32_t *) REG_TRU0_SSR40)                  /*  Slave Select Register */
#define pREG_TRU0_SSR41                  ((volatile  uint32_t *) REG_TRU0_SSR41)                  /*  Slave Select Register */
#define pREG_TRU0_SSR42                  ((volatile  uint32_t *) REG_TRU0_SSR42)                  /*  Slave Select Register */
#define pREG_TRU0_SSR43                  ((volatile  uint32_t *) REG_TRU0_SSR43)                  /*  Slave Select Register */
#define pREG_TRU0_SSR44                  ((volatile  uint32_t *) REG_TRU0_SSR44)                  /*  Slave Select Register */
#define pREG_TRU0_SSR45                  ((volatile  uint32_t *) REG_TRU0_SSR45)                  /*  Slave Select Register */
#define pREG_TRU0_SSR46                  ((volatile  uint32_t *) REG_TRU0_SSR46)                  /*  Slave Select Register */
#define pREG_TRU0_MTR                    ((volatile  uint32_t *) REG_TRU0_MTR)                    /*  Master Trigger Register */
#define pREG_TRU0_ERRADDR                ((volatile  uint32_t *) REG_TRU0_ERRADDR)                /*  Error Address Register */
#define pREG_TRU0_STAT                   ((volatile  uint32_t *) REG_TRU0_STAT)                   /*  Status Information Register */
#define pREG_TRU0_GCTL                   ((volatile  uint32_t *) REG_TRU0_GCTL)                   /*  Global Control Register */

/*  =================================================================================
 *      System Memory Protection Unit (SMPU0)
 *  ================================================================================= */
#define pREG_SMPU0_CTL                   ((volatile  uint32_t *) REG_SMPU0_CTL)                   /*  SMPU Control Register */
#define pREG_SMPU0_STAT                  ((volatile  uint32_t *) REG_SMPU0_STAT)                  /*  SMPU Status Register */
#define pREG_SMPU0_IADDR                 ((volatile  uint32_t *) REG_SMPU0_IADDR)                 /*  Interrupt Address Register */
#define pREG_SMPU0_IDTLS                 ((volatile  uint32_t *) REG_SMPU0_IDTLS)                 /*  Interrupt Details Register */
#define pREG_SMPU0_BADDR                 ((volatile  uint32_t *) REG_SMPU0_BADDR)                 /*  Bus Error Address Register */
#define pREG_SMPU0_BDTLS                 ((volatile  uint32_t *) REG_SMPU0_BDTLS)                 /*  Bus Error Details Register */
#define pREG_SMPU0_RCTL0                 ((volatile  uint32_t *) REG_SMPU0_RCTL0)                 /*  Region n Control Register */
#define pREG_SMPU0_RADDR0                ((volatile  uint32_t *) REG_SMPU0_RADDR0)                /*  Region n Address Register */
#define pREG_SMPU0_RIDA0                 ((volatile  uint32_t *) REG_SMPU0_RIDA0)                 /*  Region n ID A Register */
#define pREG_SMPU0_RIDMSKA0              ((volatile  uint32_t *) REG_SMPU0_RIDMSKA0)              /*  Region n ID Mask A Register */
#define pREG_SMPU0_RIDB0                 ((volatile  uint32_t *) REG_SMPU0_RIDB0)                 /*  Region n ID B Register */
#define pREG_SMPU0_RIDMSKB0              ((volatile  uint32_t *) REG_SMPU0_RIDMSKB0)              /*  Region n ID Mask B Register */
#define pREG_SMPU0_RCTL1                 ((volatile  uint32_t *) REG_SMPU0_RCTL1)                 /*  Region n Control Register */
#define pREG_SMPU0_RADDR1                ((volatile  uint32_t *) REG_SMPU0_RADDR1)                /*  Region n Address Register */
#define pREG_SMPU0_RIDA1                 ((volatile  uint32_t *) REG_SMPU0_RIDA1)                 /*  Region n ID A Register */
#define pREG_SMPU0_RIDMSKA1              ((volatile  uint32_t *) REG_SMPU0_RIDMSKA1)              /*  Region n ID Mask A Register */
#define pREG_SMPU0_RIDB1                 ((volatile  uint32_t *) REG_SMPU0_RIDB1)                 /*  Region n ID B Register */
#define pREG_SMPU0_RIDMSKB1              ((volatile  uint32_t *) REG_SMPU0_RIDMSKB1)              /*  Region n ID Mask B Register */
#define pREG_SMPU0_RCTL2                 ((volatile  uint32_t *) REG_SMPU0_RCTL2)                 /*  Region n Control Register */
#define pREG_SMPU0_RADDR2                ((volatile  uint32_t *) REG_SMPU0_RADDR2)                /*  Region n Address Register */
#define pREG_SMPU0_RIDA2                 ((volatile  uint32_t *) REG_SMPU0_RIDA2)                 /*  Region n ID A Register */
#define pREG_SMPU0_RIDMSKA2              ((volatile  uint32_t *) REG_SMPU0_RIDMSKA2)              /*  Region n ID Mask A Register */
#define pREG_SMPU0_RIDB2                 ((volatile  uint32_t *) REG_SMPU0_RIDB2)                 /*  Region n ID B Register */
#define pREG_SMPU0_RIDMSKB2              ((volatile  uint32_t *) REG_SMPU0_RIDMSKB2)              /*  Region n ID Mask B Register */
#define pREG_SMPU0_RCTL3                 ((volatile  uint32_t *) REG_SMPU0_RCTL3)                 /*  Region n Control Register */
#define pREG_SMPU0_RADDR3                ((volatile  uint32_t *) REG_SMPU0_RADDR3)                /*  Region n Address Register */
#define pREG_SMPU0_RIDA3                 ((volatile  uint32_t *) REG_SMPU0_RIDA3)                 /*  Region n ID A Register */
#define pREG_SMPU0_RIDMSKA3              ((volatile  uint32_t *) REG_SMPU0_RIDMSKA3)              /*  Region n ID Mask A Register */
#define pREG_SMPU0_RIDB3                 ((volatile  uint32_t *) REG_SMPU0_RIDB3)                 /*  Region n ID B Register */
#define pREG_SMPU0_RIDMSKB3              ((volatile  uint32_t *) REG_SMPU0_RIDMSKB3)              /*  Region n ID Mask B Register */
#define pREG_SMPU0_REVID                 ((volatile  uint32_t *) REG_SMPU0_REVID)                 /*  SMPU Revision ID Register */
#define pREG_SMPU0_SECURECTL             ((volatile  uint32_t *) REG_SMPU0_SECURECTL)             /*  SMPU Control Secure Accesses Register */
#define pREG_SMPU0_SECURERCTL0           ((volatile  uint32_t *) REG_SMPU0_SECURERCTL0)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU0_SECURERCTL1           ((volatile  uint32_t *) REG_SMPU0_SECURERCTL1)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU0_SECURERCTL2           ((volatile  uint32_t *) REG_SMPU0_SECURERCTL2)           /*  Region n Control Secure Accesses Register */
#define pREG_SMPU0_SECURERCTL3           ((volatile  uint32_t *) REG_SMPU0_SECURERCTL3)           /*  Region n Control Secure Accesses Register */

/*  =================================================================================
 *      System Protection Unit (SPU0)
 *  ================================================================================= */
#define pREG_SPU0_CTL                    ((volatile  uint32_t *) REG_SPU0_CTL)                    /*  Control Register */
#define pREG_SPU0_STAT                   ((volatile  uint32_t *) REG_SPU0_STAT)                   /*  Status Register */
#define pREG_SPU0_TIMEOUT                ((volatile  uint32_t *) REG_SPU0_TIMEOUT)                /*  Timeout Register */
#define pREG_SPU0_WP0                    ((volatile  uint32_t *) REG_SPU0_WP0)                    /*  Write Protect Register n */
#define pREG_SPU0_WP1                    ((volatile  uint32_t *) REG_SPU0_WP1)                    /*  Write Protect Register n */
#define pREG_SPU0_WP2                    ((volatile  uint32_t *) REG_SPU0_WP2)                    /*  Write Protect Register n */
#define pREG_SPU0_WP3                    ((volatile  uint32_t *) REG_SPU0_WP3)                    /*  Write Protect Register n */
#define pREG_SPU0_WP4                    ((volatile  uint32_t *) REG_SPU0_WP4)                    /*  Write Protect Register n */
#define pREG_SPU0_WP5                    ((volatile  uint32_t *) REG_SPU0_WP5)                    /*  Write Protect Register n */
#define pREG_SPU0_WP6                    ((volatile  uint32_t *) REG_SPU0_WP6)                    /*  Write Protect Register n */
#define pREG_SPU0_WP7                    ((volatile  uint32_t *) REG_SPU0_WP7)                    /*  Write Protect Register n */
#define pREG_SPU0_WP8                    ((volatile  uint32_t *) REG_SPU0_WP8)                    /*  Write Protect Register n */
#define pREG_SPU0_WP9                    ((volatile  uint32_t *) REG_SPU0_WP9)                    /*  Write Protect Register n */
#define pREG_SPU0_WP10                   ((volatile  uint32_t *) REG_SPU0_WP10)                   /*  Write Protect Register n */
#define pREG_SPU0_WP11                   ((volatile  uint32_t *) REG_SPU0_WP11)                   /*  Write Protect Register n */
#define pREG_SPU0_WP12                   ((volatile  uint32_t *) REG_SPU0_WP12)                   /*  Write Protect Register n */
#define pREG_SPU0_WP13                   ((volatile  uint32_t *) REG_SPU0_WP13)                   /*  Write Protect Register n */
#define pREG_SPU0_WP14                   ((volatile  uint32_t *) REG_SPU0_WP14)                   /*  Write Protect Register n */
#define pREG_SPU0_WP15                   ((volatile  uint32_t *) REG_SPU0_WP15)                   /*  Write Protect Register n */
#define pREG_SPU0_WP16                   ((volatile  uint32_t *) REG_SPU0_WP16)                   /*  Write Protect Register n */
#define pREG_SPU0_WP17                   ((volatile  uint32_t *) REG_SPU0_WP17)                   /*  Write Protect Register n */
#define pREG_SPU0_WP18                   ((volatile  uint32_t *) REG_SPU0_WP18)                   /*  Write Protect Register n */
#define pREG_SPU0_WP19                   ((volatile  uint32_t *) REG_SPU0_WP19)                   /*  Write Protect Register n */
#define pREG_SPU0_AP0                    ((volatile  uint32_t *) REG_SPU0_AP0)                    /*  Access Protect Register n */
#define pREG_SPU0_AP1                    ((volatile  uint32_t *) REG_SPU0_AP1)                    /*  Access Protect Register n */
#define pREG_SPU0_AP2                    ((volatile  uint32_t *) REG_SPU0_AP2)                    /*  Access Protect Register n */
#define pREG_SPU0_AP3                    ((volatile  uint32_t *) REG_SPU0_AP3)                    /*  Access Protect Register n */
#define pREG_SPU0_AP4                    ((volatile  uint32_t *) REG_SPU0_AP4)                    /*  Access Protect Register n */
#define pREG_SPU0_AP5                    ((volatile  uint32_t *) REG_SPU0_AP5)                    /*  Access Protect Register n */
#define pREG_SPU0_AP6                    ((volatile  uint32_t *) REG_SPU0_AP6)                    /*  Access Protect Register n */
#define pREG_SPU0_AP7                    ((volatile  uint32_t *) REG_SPU0_AP7)                    /*  Access Protect Register n */
#define pREG_SPU0_AP8                    ((volatile  uint32_t *) REG_SPU0_AP8)                    /*  Access Protect Register n */
#define pREG_SPU0_AP9                    ((volatile  uint32_t *) REG_SPU0_AP9)                    /*  Access Protect Register n */
#define pREG_SPU0_AP10                   ((volatile  uint32_t *) REG_SPU0_AP10)                   /*  Access Protect Register n */
#define pREG_SPU0_AP11                   ((volatile  uint32_t *) REG_SPU0_AP11)                   /*  Access Protect Register n */
#define pREG_SPU0_AP12                   ((volatile  uint32_t *) REG_SPU0_AP12)                   /*  Access Protect Register n */
#define pREG_SPU0_AP13                   ((volatile  uint32_t *) REG_SPU0_AP13)                   /*  Access Protect Register n */
#define pREG_SPU0_AP14                   ((volatile  uint32_t *) REG_SPU0_AP14)                   /*  Access Protect Register n */
#define pREG_SPU0_AP15                   ((volatile  uint32_t *) REG_SPU0_AP15)                   /*  Access Protect Register n */
#define pREG_SPU0_AP16                   ((volatile  uint32_t *) REG_SPU0_AP16)                   /*  Access Protect Register n */
#define pREG_SPU0_AP17                   ((volatile  uint32_t *) REG_SPU0_AP17)                   /*  Access Protect Register n */
#define pREG_SPU0_AP18                   ((volatile  uint32_t *) REG_SPU0_AP18)                   /*  Access Protect Register n */
#define pREG_SPU0_AP19                   ((volatile  uint32_t *) REG_SPU0_AP19)                   /*  Access Protect Register n */
#define pREG_SPU0_IDTLS                  ((volatile  uint32_t *) REG_SPU0_IDTLS)                  /*  Interrupt Details Register */
#define pREG_SPU0_IADDR                  ((volatile  uint32_t *) REG_SPU0_IADDR)                  /*  Interrupt Address Register */
#define pREG_SPU0_DEVID                  ((volatile  uint32_t *) REG_SPU0_DEVID)                  /*  Device Configuration Register */
#define pREG_SPU0_DEVTYPE                ((volatile  uint32_t *) REG_SPU0_DEVTYPE)                /*  Device Type Identifier Register */
#define pREG_SPU0_PID4                   ((volatile  uint32_t *) REG_SPU0_PID4)                   /*  Peripheral ID4 Register */
#define pREG_SPU0_PID5                   ((volatile  uint32_t *) REG_SPU0_PID5)                   /*  Peripheral ID5 Register */
#define pREG_SPU0_PID6                   ((volatile  uint32_t *) REG_SPU0_PID6)                   /*  Peripheral ID6 Register */
#define pREG_SPU0_PID7                   ((volatile  uint32_t *) REG_SPU0_PID7)                   /*  Peripheral ID7 Register */
#define pREG_SPU0_PID0                   ((volatile  uint32_t *) REG_SPU0_PID0)                   /*  Peripheral ID0 Register */
#define pREG_SPU0_PID1                   ((volatile  uint32_t *) REG_SPU0_PID1)                   /*  Peripheral ID1 Register */
#define pREG_SPU0_PID2                   ((volatile  uint32_t *) REG_SPU0_PID2)                   /*  Peripheral ID2 Register */
#define pREG_SPU0_PID3                   ((volatile  uint32_t *) REG_SPU0_PID3)                   /*  Peripheral ID3 Register */
#define pREG_SPU0_CID0                   ((volatile  uint32_t *) REG_SPU0_CID0)                   /*  Component ID0 Register */
#define pREG_SPU0_CID1                   ((volatile  uint32_t *) REG_SPU0_CID1)                   /*  Component ID1 Register */
#define pREG_SPU0_CID2                   ((volatile  uint32_t *) REG_SPU0_CID2)                   /*  Component ID2 Register */
#define pREG_SPU0_CID3                   ((volatile  uint32_t *) REG_SPU0_CID3)                   /*  Component ID3 Register */

/*  =================================================================================
 *      System Crossbar (SCB0)
 *  ================================================================================= */
#define pREG_SCB0_PERIPH_ID_4            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_4)            /*  Periph Id 4 */
#define pREG_SCB0_PERIPH_ID_5            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_5)            /*  Periph Id 5 */
#define pREG_SCB0_PERIPH_ID_6            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_6)            /*  Periph Id 6 */
#define pREG_SCB0_PERIPH_ID_7            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_7)            /*  Periph Id 7 */
#define pREG_SCB0_PERIPH_ID_0            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_0)            /*  Periph Id 0 */
#define pREG_SCB0_PERIPH_ID_1            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_1)            /*  Periph Id 1 */
#define pREG_SCB0_PERIPH_ID_2            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_2)            /*  Periph Id 2 */
#define pREG_SCB0_PERIPH_ID_3            ((volatile  uint32_t *) REG_SCB0_PERIPH_ID_3)            /*  Periph Id 3 */
#define pREG_SCB0_COMP_ID_0              ((volatile  uint32_t *) REG_SCB0_COMP_ID_0)              /*  Comp Id 0 */
#define pREG_SCB0_COMP_ID_1              ((volatile  uint32_t *) REG_SCB0_COMP_ID_1)              /*  Comp Id 1 */
#define pREG_SCB0_COMP_ID_2              ((volatile  uint32_t *) REG_SCB0_COMP_ID_2)              /*  Comp Id 2 */
#define pREG_SCB0_COMP_ID_3              ((volatile  uint32_t *) REG_SCB0_COMP_ID_3)              /*  Comp Id 3 */
#define pREG_SCB0_DMA0_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA0_READ_QOS)          /*  Dma0.read Qos */
#define pREG_SCB0_DMA0_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA0_WRITE_QOS)         /*  Dma0.write Qos */
#define pREG_SCB0_DMA0_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA0_FN_MOD)            /*  Dma0.fn Mod */
#define pREG_SCB0_DMA1_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA1_READ_QOS)          /*  Dma1.read Qos */
#define pREG_SCB0_DMA1_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA1_WRITE_QOS)         /*  Dma1.write Qos */
#define pREG_SCB0_DMA1_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA1_FN_MOD)            /*  Dma1.fn Mod */
#define pREG_SCB0_DMA2_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA2_READ_QOS)          /*  Dma2.read Qos */
#define pREG_SCB0_DMA2_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA2_WRITE_QOS)         /*  Dma2.write Qos */
#define pREG_SCB0_DMA2_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA2_FN_MOD)            /*  Dma2.fn Mod */
#define pREG_SCB0_DMA3_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA3_READ_QOS)          /*  Dma3.read Qos */
#define pREG_SCB0_DMA3_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA3_WRITE_QOS)         /*  Dma3.write Qos */
#define pREG_SCB0_DMA3_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA3_FN_MOD)            /*  Dma3.fn Mod */
#define pREG_SCB0_DMA4_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA4_READ_QOS)          /*  Dma4.read Qos */
#define pREG_SCB0_DMA4_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA4_WRITE_QOS)         /*  Dma4.write Qos */
#define pREG_SCB0_DMA4_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA4_FN_MOD)            /*  Dma4.fn Mod */
#define pREG_SCB0_DMA5_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA5_READ_QOS)          /*  Dma5.read Qos */
#define pREG_SCB0_DMA5_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA5_WRITE_QOS)         /*  Dma5.write Qos */
#define pREG_SCB0_DMA5_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA5_FN_MOD)            /*  Dma5.fn Mod */
#define pREG_SCB0_DMA6_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA6_READ_QOS)          /*  Dma6.read Qos */
#define pREG_SCB0_DMA6_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA6_WRITE_QOS)         /*  Dma6.write Qos */
#define pREG_SCB0_DMA6_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA6_FN_MOD)            /*  Dma6.fn Mod */
#define pREG_SCB0_DMA7_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA7_READ_QOS)          /*  Dma7.read Qos */
#define pREG_SCB0_DMA7_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA7_WRITE_QOS)         /*  Dma7.write Qos */
#define pREG_SCB0_DMA7_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA7_FN_MOD)            /*  Dma7.fn Mod */
#define pREG_SCB0_DMA8_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA8_READ_QOS)          /*  Dma8.read Qos */
#define pREG_SCB0_DMA8_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA8_WRITE_QOS)         /*  Dma8.write Qos */
#define pREG_SCB0_DMA8_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA8_FN_MOD)            /*  Dma8.fn Mod */
#define pREG_SCB0_DMA9_READ_QOS          ((volatile  uint32_t *) REG_SCB0_DMA9_READ_QOS)          /*  Dma9.read Qos */
#define pREG_SCB0_DMA9_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_DMA9_WRITE_QOS)         /*  Dma9.write Qos */
#define pREG_SCB0_DMA9_FN_MOD            ((volatile  uint32_t *) REG_SCB0_DMA9_FN_MOD)            /*  Dma9.fn Mod */
#define pREG_SCB0_AFE0_READ_QOS          ((volatile  uint32_t *) REG_SCB0_AFE0_READ_QOS)          /*  Afe0.read Qos */
#define pREG_SCB0_AFE0_WRITE_QOS         ((volatile  uint32_t *) REG_SCB0_AFE0_WRITE_QOS)         /*  Afe0.write Qos */
#define pREG_SCB0_AFE0_FN_MOD            ((volatile  uint32_t *) REG_SCB0_AFE0_FN_MOD)            /*  Afe0.fn Mod */
#define pREG_SCB0_FFT0_MST_READ_QOS      ((volatile  uint32_t *) REG_SCB0_FFT0_MST_READ_QOS)      /*  Fft0 Mst.read Qos */
#define pREG_SCB0_FFT0_MST_WRITE_QOS     ((volatile  uint32_t *) REG_SCB0_FFT0_MST_WRITE_QOS)     /*  Fft0 Mst.write Qos */
#define pREG_SCB0_FFT0_MST_FN_MOD        ((volatile  uint32_t *) REG_SCB0_FFT0_MST_FN_MOD)        /*  Fft0 Mst.fn Mod */
#define pREG_SCB0_CONT_SYS_FN_MOD_AHB    ((volatile  uint32_t *) REG_SCB0_CONT_SYS_FN_MOD_AHB)    /*  Cont Sys.fn Mod Ahb */
#define pREG_SCB0_CONT_SYS_READ_QOS      ((volatile  uint32_t *) REG_SCB0_CONT_SYS_READ_QOS)      /*  Cont Sys.read Qos */
#define pREG_SCB0_CONT_SYS_WRITE_QOS     ((volatile  uint32_t *) REG_SCB0_CONT_SYS_WRITE_QOS)     /*  Cont Sys.write Qos */
#define pREG_SCB0_CONT_SYS_FN_MOD        ((volatile  uint32_t *) REG_SCB0_CONT_SYS_FN_MOD)        /*  Cont Sys.fn Mod */
#define pREG_SCB0_SUPER_AXI_READ_QOS     ((volatile  uint32_t *) REG_SCB0_SUPER_AXI_READ_QOS)     /*  Super Axi.read Qos */
#define pREG_SCB0_SUPER_AXI_WRITE_QOS    ((volatile  uint32_t *) REG_SCB0_SUPER_AXI_WRITE_QOS)    /*  Super Axi.write Qos */
#define pREG_SCB0_SUPER_AXI_FN_MOD       ((volatile  uint32_t *) REG_SCB0_SUPER_AXI_FN_MOD)       /*  Super Axi.fn Mod */
#define pREG_SCB0_SINC0_MST_READ_QOS     ((volatile  uint32_t *) REG_SCB0_SINC0_MST_READ_QOS)     /*  Sinc0 Mst.read Qos */
#define pREG_SCB0_SINC0_MST_WRITE_QOS    ((volatile  uint32_t *) REG_SCB0_SINC0_MST_WRITE_QOS)    /*  Sinc0 Mst.write Qos */
#define pREG_SCB0_SINC0_MST_FN_MOD       ((volatile  uint32_t *) REG_SCB0_SINC0_MST_FN_MOD)       /*  Sinc0 Mst.fn Mod */

/*  =================================================================================
 *      Data watchpoint unit (DWT1)
 *  ================================================================================= */
#define pREG_DWT1_DWT_CTRL               ((volatile  uint32_t *) REG_DWT1_DWT_CTRL)               /*  Dwt Ctrl */
#define pREG_DWT1_DWT_PCSR               ((volatile  uint32_t *) REG_DWT1_DWT_PCSR)               /*  Dwt Pcsr */
#define pREG_DWT1_DWT_COMP0              ((volatile  uint32_t *) REG_DWT1_DWT_COMP0)              /*  Dwt Comp0 */
#define pREG_DWT1_DWT_MASK0              ((volatile  uint32_t *) REG_DWT1_DWT_MASK0)              /*  Dwt Mask0 */
#define pREG_DWT1_DWT_FUNCTION0          ((volatile  uint32_t *) REG_DWT1_DWT_FUNCTION0)          /*  Dwt Function0 */
#define pREG_DWT1_DWT_COMP1              ((volatile  uint32_t *) REG_DWT1_DWT_COMP1)              /*  Dwt Comp1 */
#define pREG_DWT1_DWT_MASK1              ((volatile  uint32_t *) REG_DWT1_DWT_MASK1)              /*  Dwt Mask1 */
#define pREG_DWT1_DWT_FUNCTION1          ((volatile  uint32_t *) REG_DWT1_DWT_FUNCTION1)          /*  Dwt Function1 */

/*  =================================================================================
 *      Breakpoint unit (BKPT1)
 *  ================================================================================= */
#define pREG_BKPT1_BP_CTRL               ((volatile  uint32_t *) REG_BKPT1_BP_CTRL)               /*  Bp Ctrl */
#define pREG_BKPT1_BP_COMP0              ((volatile  uint32_t *) REG_BKPT1_BP_COMP0)              /*  Bp Comp0 */
#define pREG_BKPT1_BP_COMP1              ((volatile  uint32_t *) REG_BKPT1_BP_COMP1)              /*  Bp Comp1 */
#define pREG_BKPT1_BP_COMP2              ((volatile  uint32_t *) REG_BKPT1_BP_COMP2)              /*  Bp Comp2 */
#define pREG_BKPT1_BP_COMP3              ((volatile  uint32_t *) REG_BKPT1_BP_COMP3)              /*  Bp Comp3 */

/*  =================================================================================
 *      NVIC and SysTick  (SCS1)
 *  ================================================================================= */
#define pREG_SCS1_ACTLR                  ((volatile  uint32_t *) REG_SCS1_ACTLR)                  /*   */
#define pREG_SCS1_STCSR                  ((volatile  uint32_t *) REG_SCS1_STCSR)                  /*   */
#define pREG_SCS1_STRVR                  ((volatile  uint32_t *) REG_SCS1_STRVR)                  /*   */
#define pREG_SCS1_STCVR                  ((volatile  uint32_t *) REG_SCS1_STCVR)                  /*   */
#define pREG_SCS1_STCR                   ((volatile  uint32_t *) REG_SCS1_STCR)                   /*   */
#define pREG_SCS1_ISER                   ((volatile  uint32_t *) REG_SCS1_ISER)                   /*   */
#define pREG_SCS1_ICER                   ((volatile  uint32_t *) REG_SCS1_ICER)                   /*   */
#define pREG_SCS1_ISPR                   ((volatile  uint32_t *) REG_SCS1_ISPR)                   /*   */
#define pREG_SCS1_ICPR                   ((volatile  uint32_t *) REG_SCS1_ICPR)                   /*   */
#define pREG_SCS1_IPR0                   ((volatile  uint32_t *) REG_SCS1_IPR0)                   /*   */
#define pREG_SCS1_IPR1                   ((volatile  uint32_t *) REG_SCS1_IPR1)                   /*   */
#define pREG_SCS1_IPR2                   ((volatile  uint32_t *) REG_SCS1_IPR2)                   /*   */
#define pREG_SCS1_IPR3                   ((volatile  uint32_t *) REG_SCS1_IPR3)                   /*   */
#define pREG_SCS1_IPR4                   ((volatile  uint32_t *) REG_SCS1_IPR4)                   /*   */
#define pREG_SCS1_IPR5                   ((volatile  uint32_t *) REG_SCS1_IPR5)                   /*   */
#define pREG_SCS1_IPR6                   ((volatile  uint32_t *) REG_SCS1_IPR6)                   /*   */
#define pREG_SCS1_IPR7                   ((volatile  uint32_t *) REG_SCS1_IPR7)                   /*   */

/*  =================================================================================
 *      System and Debug Control  (SDCTRL)
 *  ================================================================================= */
#define pREG_SDCTRL_CPUID                ((volatile  uint32_t *) REG_SDCTRL_CPUID)                /*  CPU ID Base Register */
#define pREG_SDCTRL_ICSR                 ((volatile  uint32_t *) REG_SDCTRL_ICSR)                 /*  Interrupt Control State Register */
#define pREG_SDCTRL_AIRCR                ((volatile  uint32_t *) REG_SDCTRL_AIRCR)                /*  Application Interrupt and Reset Control Register */
#define pREG_SDCTRL_SCR                  ((volatile  uint32_t *) REG_SDCTRL_SCR)                  /*  System Control Register */
#define pREG_SDCTRL_CCR                  ((volatile  uint32_t *) REG_SDCTRL_CCR)                  /*  Configuration and Control Register */
#define pREG_SDCTRL_SHPR2                ((volatile  uint32_t *) REG_SDCTRL_SHPR2)                /*  System Handler Priority Register 2 */
#define pREG_SDCTRL_SHPR3                ((volatile  uint32_t *) REG_SDCTRL_SHPR3)                /*  System Handler Priority Register 3 */
#define pREG_SDCTRL_SHCSR                ((volatile  uint32_t *) REG_SDCTRL_SHCSR)                /*  System Handler Control and State Register */
#define pREG_SDCTRL_DFSR                 ((volatile  uint32_t *) REG_SDCTRL_DFSR)                 /*  Debug Fault Status Register */
#define pREG_SDCTRL_DHCSR                ((volatile  uint32_t *) REG_SDCTRL_DHCSR)                /*  Debug Halting Control and Status Register */
#define pREG_SDCTRL_DCRSR                ((volatile  uint32_t *) REG_SDCTRL_DCRSR)                /*  Debug Core Register Selector Register */
#define pREG_SDCTRL_DCRDR                ((volatile  uint32_t *) REG_SDCTRL_DCRDR)                /*  Debug Core Register Data Register */
#define pREG_SDCTRL_DEMCR                ((volatile  uint32_t *) REG_SDCTRL_DEMCR)                /*  Debug Exception and Monitor Control Register */

#endif

