/* ================================================================================

     Project      :   CM41X_M0
     File         :   CM41X_M0_typedefs.h
     Description  :   C Register Structures

     Date         :   Feb 27, 2015

     Copyright (c) Analog Devices, Inc.  All Rights Reserved.
     This software is proprietary and confidential to Analog Devices, Inc. and
     its licensors.

     This file was auto-generated. Do not make local changes to this file.

   ================================================================================ */

/** @defgroup DMA_MUXCTL Peripheral DMA Multiplexer Control (DMA_MUXCTL) Register
 *  Peripheral DMA Multiplexer Control (DMA_MUXCTL) Register.
 *
 *  
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_C_CFG0_DMA_MUXCTL_SEL6
 *! \brief  Mux select for DMA6 (SEL6) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_DMA_MUXCTL_SPI1_TXDMA  = 0,  /**< Select SPI[1] TXDMA port  */
  C_DMA_MUXCTL_UART2_TXDMA = 1   /**< Select UART[2] TXDMA port */
} ADI_C_CFG0_DMA_MUXCTL_SEL6;


/*  =========================================================================
 *! \enum   ADI_C_CFG0_DMA_MUXCTL_SEL7
 *! \brief  Mux select for DMA7 (SEL7) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_DMA_MUXCTL_SPI1_RXDMA  = 0,  /**< Select SPI[1] RXDMA port  */
  C_DMA_MUXCTL_UART2_RXDMA = 1   /**< Select UART[2] RXDMA port */
} ADI_C_CFG0_DMA_MUXCTL_SEL7;


/*  =========================================================================
 *! \enum   ADI_C_CFG0_DMA_MUXCTL_SEL8
 *! \brief  Mux select for DMA8 (SEL8) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_DMA_MUXCTL_HAE0_RXDMA_CH0 = 0,  /**< Select HAE[0] RXDMA_CH0 port */
  C_DMA_MUXCTL_UART3_TXDMA    = 1   /**< Select UART[3] TXDMA port    */
} ADI_C_CFG0_DMA_MUXCTL_SEL8;


/*  =========================================================================
 *! \enum   ADI_C_CFG0_DMA_MUXCTL_SEL9
 *! \brief  Mux select for DMA9 (SEL9) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_DMA_MUXCTL_HAE0_TXDMA  = 0,  /**< Select HAE[0] TXDMA port  */
  C_DMA_MUXCTL_UART3_RXDMA = 1   /**< Select UART[3] RXDMA port */
} ADI_C_CFG0_DMA_MUXCTL_SEL9;


/*  =========================================================================
 *! \enum   ADI_C_CFG0_DMA_MUXCTL_SEL10
 *! \brief  Mux select for DMA10 (SEL10) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_DMA_MUXCTL_HAE0_RXDMA_CH1 = 0,  /**< Select HAE[0] RXDMA_CH1 port */
  C_DMA_MUXCTL_SPORT0_A_DMA   = 1,  /**< Select SPORT[0] A_DMA port   */
  C_DMA_MUXCTL_UART4_TXDMA    = 2   /**< Select UART[4] TXDMA port    */
} ADI_C_CFG0_DMA_MUXCTL_SEL10;


/*  =========================================================================
 *! \enum   ADI_C_CFG0_DMA_MUXCTL_SEL11
 *! \brief  Mux select for DMA11 (SEL11) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_DMA_MUXCTL_SPORT0_B_DMA = 0,  /**< Select SPORT[0] B_DMA port */
  C_DMA_MUXCTL_UART4_RXDMA  = 1   /**< Select UART[4] RXDMA port  */
} ADI_C_CFG0_DMA_MUXCTL_SEL11;


/* ==========================================================================
 *! \struct ADI_C_CFG0_DMA_MUXCTL_Struct
 *! \brief  Peripheral DMA Multiplexer Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_DMA_MUXCTL_t {
  union {
    struct {
      unsigned int SEL6       :  1;  /**< Mux select for DMA6 */
      unsigned int SEL7       :  1;  /**< Mux select for DMA7 */
      unsigned int SEL8       :  1;  /**< Mux select for DMA8 */
      unsigned int SEL9       :  1;  /**< Mux select for DMA9 */
      unsigned int SEL10      :  2;  /**< Mux select for DMA10 */
      unsigned int SEL11      :  1;  /**< Mux select for DMA11 */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_DMA_MUXCTL_t;

/*@}*/

/** @defgroup PWM_SYS_CFG PWM System Configuration Register (PWM_SYS_CFG) Register
 *  PWM System Configuration Register (PWM_SYS_CFG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_PWM_SYS_CFG_Struct
 *! \brief  PWM System Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_PWM_SYS_CFG_t {
  union {
    struct {
      unsigned int PWM0TRIPMX :  3;  /**< PWM0 Trip Multiplexer Select */
      unsigned int reserved3    :  1;
      unsigned int AFEOKTRIPEN0 :  1;  /**< Analog Front End  Not OK PWM Trip Enable 0 */
      unsigned int PWM1TRIPMX   :  3;  /**< PWM1 Trip Multiplexer Select */
      unsigned int reserved8    :  1;
      unsigned int AFEOKTRIPEN1 :  1;  /**< Analog Front End Not OK PWM Trip Enable 1 */
      unsigned int PWM2TRIPMX   :  3;  /**< PWM2 Trip Multiplexer Select */
      unsigned int reserved13   :  1;
      unsigned int AFEOKTRIPEN2 :  1;  /**< Analog Front End Not OK PWM Trip Enable 2 */
      unsigned int reserved15   :  4;
      unsigned int HPPWMDIS0    :  1;  /**< High Precision PWM Block0 Disable (Reverts HPPWM to Medium Precision) */
      unsigned int HPPWMDIS1    :  1;  /**< High Precision PWM  Block1 Disable (Reverts HPPWM to Medium Precision) */
      unsigned int HPPWMDIS2    :  1;  /**< High Precision PWM Block2 Disable (Reverts HPPWM to Medium Precision) */
      unsigned int reserved22   :  2;
      unsigned int PWM0SYNCOE   :  1;  /**< PWM0 SYNC OUT secondary enable */
      unsigned int PWM1SYNCOE   :  1;  /**< PWM1 SYNC OUT secondary enable */
      unsigned int PWM2SYNCOE   :  1;  /**< PWM2 SYNC OUT secondary enable */
      unsigned int reserved27   :  5;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_PWM_SYS_CFG_t;

/*@}*/

/** @defgroup MBIST_CTL MBIST Control Register (MBIST_CTL) Register
 *  MBIST Control Register (MBIST_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_MBIST_CTL_Struct
 *! \brief  MBIST Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_MBIST_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< USER MBIST Enable */
      unsigned int RUN        :  1;  /**< Run Control Bit */
      unsigned int BUSY       :  1;  /**< Busy Status */
      unsigned int FAIL       :  1;  /**< Test Pass/Fail Status */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_MBIST_CTL_t;

/*@}*/

/** @defgroup SINC_TEST SINC Test Register (SINC_TEST) Register
 *  SINC Test Register (SINC_TEST) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_SINC_TEST_Struct
 *! \brief  SINC Test Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_SINC_TEST_t {
  union {
    struct {
      unsigned int EN         :  4;  /**< SINC Test Enable */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_SINC_TEST_t;

/*@}*/

/** @defgroup SYSSTAT System Status Register (SYSSTAT) Register
 *  System Status Register (SYSSTAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_SYSSTAT_Struct
 *! \brief  System Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_SYSSTAT_t {
  union {
    struct {
      unsigned int AFE_OK     :  1;  /**< Status of AFE_OK signal */
      unsigned int AFE_LIMIT  :  1;  /**< Status of AFE_LIMIT signal */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_SYSSTAT_t;

/*@}*/

/** @defgroup CLKNG_TRIPEN Clock Not Good Trip Register (CLKNG_TRIPEN) Register
 *  Clock Not Good Trip Register (CLKNG_TRIPEN) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_CLKNG_TRIPEN_Struct
 *! \brief  Clock Not Good Trip Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_CLKNG_TRIPEN_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int OCU0CLK    :  1;  /**< Oscillator Compare Unit Dead Clock Trip Enable */
      unsigned int OCU0FAULT  :  1;  /**< Oscillator Compare Unit Asynchronous Fault Trip Enable */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_CLKNG_TRIPEN_t;

/*@}*/

/** @defgroup FAULT_TRIPEN Fault Trip Register (FAULT_TRIPEN) Register
 *  Fault Trip Register (FAULT_TRIPEN) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_FAULT_TRIPEN_Struct
 *! \brief  Fault Trip Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_FAULT_TRIPEN_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int OCU0CLK    :  1;  /**< Oscillator Compare Unit Dead Clock Trip Enable */
      unsigned int OCU0FAULT  :  1;  /**< Oscillator Compare Unit Asynchronous Fault Trip Enable */
      unsigned int OSC0CLK    :  1;  /**< System Oscillator Clock No Good Trip Enable */
      unsigned int OSC0FAULT  :  1;  /**< System Oscillator Asynchronous Fault Trip Enable */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_FAULT_TRIPEN_t;

/*@}*/

/** @defgroup ROT_UPDN_CFG Rotary Counter Up/Down Configuration Register (ROT_UPDN_CFG) Register
 *  Rotary Counter Up/Down Configuration Register (ROT_UPDN_CFG) Register.
 *
 *  
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_C_CFG0_ROT_UPDN_CFG_SELA
 *! \brief  Input selector for Rotary CNT0 Phase A input (SELA) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_ROT_UPDN_CFG_PAD_TO_A  = 0,  /**< Select Pad as input to Rotary Counter           */
  C_ROT_UPDN_CFG_TRIG_TO_A = 1,  /**< Select Trigger Slave as input to Rotary Counter */
  C_ROT_UPDN_CFG_LBA_TO_A  = 2,  /**< Select LBA as input to Rotary Counter           */
  C_ROT_UPDN_CFG_LBA2_TO_A = 3   /**< Select LBA as input to Rotary Counter           */
} ADI_C_CFG0_ROT_UPDN_CFG_SELA;


/*  =========================================================================
 *! \enum   ADI_C_CFG0_ROT_UPDN_CFG_SELB
 *! \brief  Input selector for Rotary CNT0 Phase B input (SELB) Enumerations
 *  ========================================================================= */
typedef enum
{
  C_ROT_UPDN_CFG_PAD_TO_B  = 0,  /**< Input selects PAD connection           */
  C_ROT_UPDN_CFG_TRIG_TO_B = 1,  /**< Input selects Trigger Slave connection */
  C_ROT_UPDN_CFG_LBA_TO_B  = 2,  /**< Input selects LBA output connection    */
  C_ROT_UPDN_CFG_LBA2_TO_B = 3   /**< Input selects LBA output connection    */
} ADI_C_CFG0_ROT_UPDN_CFG_SELB;


/* ==========================================================================
 *! \struct ADI_C_CFG0_ROT_UPDN_CFG_Struct
 *! \brief  Rotary Counter Up/Down Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_ROT_UPDN_CFG_t {
  union {
    struct {
      unsigned int SELA       :  2;  /**< Input selector for Rotary CNT0 Phase A input */
      unsigned int SELB       :  2;  /**< Input selector for Rotary CNT0 Phase B input */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_ROT_UPDN_CFG_t;

/*@}*/

/** @defgroup AHB_RESP_CFG AHB Response Configuration Register (AHB_RESP_CFG) Register
 *  AHB Response Configuration Register (AHB_RESP_CFG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_AHB_RESP_CFG_Struct
 *! \brief  AHB Response Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_AHB_RESP_CFG_t {
  union {
    struct {
      unsigned int TOENA      :  1;  /**< Enable AHB Timeout Interrupt */
      unsigned int TOERR      :  1;  /**< Status Error bit indicating AHB bus has timed out */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_AHB_RESP_CFG_t;

/*@}*/

/** @defgroup AHB_TIMEOUT_VALUE AHB Timeout Value Register (AHB_TIMEOUT_VALUE) Register
 *  AHB Timeout Value Register (AHB_TIMEOUT_VALUE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_AHB_TIMEOUT_VALUE_Struct
 *! \brief  AHB Timeout Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_AHB_TIMEOUT_VALUE_t {
  union {
    struct {
      unsigned int DATA       : 16;  /**< Timeout Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_AHB_TIMEOUT_VALUE_t;

/*@}*/

/** @defgroup ENG_MODE_CFG0 Engineering Mode Configuration Register 0 (ENG_MODE_CFG0) Register
 *  Engineering Mode Configuration Register 0 (ENG_MODE_CFG0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_ENG_MODE_CFG0_Struct
 *! \brief  Engineering Mode Configuration Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_ENG_MODE_CFG0_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Data Value */
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_ENG_MODE_CFG0_t;

/*@}*/

/** @defgroup LROM_STAT Logic ROM status register (LROM_STAT) Register
 *  Logic ROM status register (LROM_STAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG0_LROM_STAT_Struct
 *! \brief  Logic ROM status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG0_LROM_STAT_t {
  union {
    struct {
      unsigned int reserved0  : 16;
      unsigned int FLT_UEXC   :  1;  /**< BCODE_ERR Fault: Unexpected Exception */
      unsigned int FLT_FKTMO  :  1;  /**< BCODE_ERR Fault: Efuse/Flash Key Timeout */
      unsigned int FLT_EFS_ECC :  1;  /**< BCODE_ERR Fault: Efuse ECC Error */
      unsigned int FLT_FKEY_ERR :  1;  /**< BCODE_ERR Fault: Flash Key Invalid */
      unsigned int FLT_RINIT_ERR :  1;  /**< BCODE_ERR Fault: CRC error in RINIT structure */
      unsigned int FLT_RFUNC_ERR :  1;  /**< BCODE_ERR Fault: CRC error in RFUNC code section */
      unsigned int FLT_ROM_ERR   :  1;  /**< BCODE_ERR Fault: CRC error in Array Boot ROM */
      unsigned int reserved23    :  1;
      unsigned int FLT_BROM      :  4;  /**< BCODE_ERR fault, Boot ROM fault code */
      unsigned int reserved28    :  4;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG0_LROM_STAT_t;

/*@}*/

/** @defgroup PCFG0 Peripheral Configuration0 Register (PCFG0) Register
 *  Peripheral Configuration0 Register (PCFG0) Register.
 *
 *  The PCFG0 register provides several configuration options for various peripherals.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_PCFG0_Struct
 *! \brief  Peripheral Configuration0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_PCFG0_t {
  union {
    struct {
      unsigned int reserved0  :  9;
      unsigned int TWI0VSEL   :  3;  /**< Drive/tolerate for TWI0 Pins SCL & SDA */
      unsigned int PUE        :  1;  /**< Pull-Up Enable */
      unsigned int reserved13 :  3;
      unsigned int AUXTRMEN   :  1;  /**< Enable for 3V Auxiliary Watchdog Oscillator  latches which control trim values */
      unsigned int reserved17 :  1;
      unsigned int AFETYPE    :  1;  /**< Analog Front End Type Select, (0=Tesla AFE, 1=Slater AFE) */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_PCFG0_t;

/*@}*/

/** @defgroup FOCP_DIV Fast Over Current Protection Clock Divisor (FOCP_DIV) Register
 *  Fast Over Current Protection Clock Divisor (FOCP_DIV) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_FOCP_DIV_Struct
 *! \brief  Fast Over Current Protection Clock Divisor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_FOCP_DIV_t {
  union {
    struct {
      unsigned int EN         :  1;
      unsigned int reserved1  :  3;
      unsigned int DAT        :  4;  /**< Divisor for FOCP_CLK output */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_FOCP_DIV_t;

/*@}*/

/** @defgroup DBC_PRESCALE Debounce Prescale Register (DBC_PRESCALE) Register
 *  Debounce Prescale Register (DBC_PRESCALE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_DBC_PRESCALE_Struct
 *! \brief  Debounce Prescale Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_DBC_PRESCALE_t {
  union {
    struct {
      unsigned int DATA       : 16;  /**< Debounce Clock Prescale Divisor */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_DBC_PRESCALE_t;

/*@}*/

/** @defgroup DBC_CTL Debounce  Control Register(s) (DBC_CTL) Register
 *  Debounce  Control Register(s) (DBC_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_DBC_CTL_Struct
 *! \brief  Debounce  Control Register(s) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_DBC_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Debounce Filter Enable(Input is bypassed directly to output if disabled) */
      unsigned int DEC        :  1;  /**< Debounce Filter Decimating(or Continuous) Sample Mode */
      unsigned int PRECLKSEL  :  1;  /**< Prescale Clock Select(or System Clock=Default) */
      unsigned int ACCMODE    :  1;  /**< Accumulator Mode(Counter Mode is Default) */
      unsigned int reserved4  :  4;
      unsigned int THRESH     :  8;  /**< Debounce Counter or Accumulator Threshold */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_DBC_CTL_t;

/*@}*/

/** @defgroup VMU_CTL Voltage Monitor Unit Control Register (VMU_CTL) Register
 *  Voltage Monitor Unit Control Register (VMU_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_VMU_CTL_Struct
 *! \brief  Voltage Monitor Unit Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_VMU_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< VMU Block Enable */
      unsigned int IVDDCOMPEN :  1;  /**< 1 Volt Over/Under Voltage Compare Enable */
      unsigned int EVDDCOMPEN :  1;  /**< 3Volt Over/Under Voltage Compare Enable */
      unsigned int FCEN       :  1;  /**< Fast Comparator Enable */
      unsigned int REFPRG     :  2;  /**< Comparator Reference Select */
      unsigned int reserved6  :  2;
      unsigned int FAULTDLY   :  4;  /**< Fault Delay Count in AUX_CLK ticks */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_VMU_CTL_t;

/*@}*/

/** @defgroup VMU_TEST Voltage Monitor Unit Test Register (VMU_TEST) Register
 *  Voltage Monitor Unit Test Register (VMU_TEST) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_VMU_TEST_Struct
 *! \brief  Voltage Monitor Unit Test Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_VMU_TEST_t {
  union {
    struct {
      unsigned int TRIM       : 11;  /**< VMU TRIM Bits */
      unsigned int TM         :  4;  /**< VMU Test Mode Bits */
      unsigned int TEST_CLK   :  1;  /**< VMU Test Clock */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_VMU_TEST_t;

/*@}*/

/** @defgroup VMU_TRIPEN Voltage Monitor Unit Trip Enable Register (VMU_TRIPEN) Register
 *  Voltage Monitor Unit Trip Enable Register (VMU_TRIPEN) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_VMU_TRIPEN_Struct
 *! \brief  Voltage Monitor Unit Trip Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_VMU_TRIPEN_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int OCU0CLK    :  1;  /**< Oscillator Compare Unit Dead Clock Trip Enable */
      unsigned int OCU0FAULT  :  1;  /**< Oscillator Compare Unit Asynchronous Fault Trip Enable */
      unsigned int OSC0CLK    :  1;  /**< System Oscillator Clock No Good Trip Enable */
      unsigned int OSC0FAULT  :  1;  /**< System Oscillator Asynchronous Fault Trip Enable */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_VMU_TRIPEN_t;

/*@}*/

/** @defgroup NVWR_RSTCTL Non-Volatile Write Reset Control Register (NVWR_RSTCTL) Register
 *  Non-Volatile Write Reset Control Register (NVWR_RSTCTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_NVWR_RSTCTL_Struct
 *! \brief  Non-Volatile Write Reset Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_NVWR_RSTCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable for NonVolatile Write Logic  (Default State is Disabled and in Reset) */
      unsigned int reserved1  : 31;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_NVWR_RSTCTL_t;

/*@}*/

/** @defgroup MONOSC_CFG Monitor Oscillator Control Register (MONOSC_CFG) Register
 *  Monitor Oscillator Control Register (MONOSC_CFG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_MONOSC_CFG_Struct
 *! \brief  Monitor Oscillator Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_MONOSC_CFG_t {
  union {
    struct {
      unsigned int CFG        :  4;  /**< Monitor Oscillator Configuration Data */
      unsigned int SMODE      :  2;  /**< Sleep Mode Configuration Data */
      unsigned int reserved6  : 26;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_MONOSC_CFG_t;

/*@}*/

/** @defgroup PORT_DS Multiport Drive Strength Register (PORT_DS) Register
 *  Multiport Drive Strength Register (PORT_DS) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_PORT_DS_Struct
 *! \brief  Multiport Drive Strength Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_PORT_DS_t {
  union {
    struct {
      unsigned int GPIO_DS    : 16;  /**< Port Drive Strength */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_PORT_DS_t;

/*@}*/

/** @defgroup PORT_RCTL Multiport Pullup/Pulldown Resistor Control Register (PORT_RCTL) Register
 *  Multiport Pullup/Pulldown Resistor Control Register (PORT_RCTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_PORT_RCTL_Struct
 *! \brief  Multiport Pullup/Pulldown Resistor Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_PORT_RCTL_t {
  union {
    struct {
      unsigned int REN_CTL    : 16;  /**< Port Resistor Enable Control */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_PORT_RCTL_t;

/*@}*/

/** @defgroup PORT_TRIPST Multiport Trip State Register (PORT_TRIPST) Register
 *  Multiport Trip State Register (PORT_TRIPST) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_PORT_TRIPST_Struct
 *! \brief  Multiport Trip State Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_PORT_TRIPST_t {
  union {
    struct {
      unsigned int TS0        :  2;  /**< Port IO_0 Trip State */
      unsigned int TS1        :  2;  /**< Port IO 1 Trip State */
      unsigned int TS2        :  2;  /**< Port IO 2 Trip State */
      unsigned int TS3        :  2;  /**< Port IO 3 Trip State */
      unsigned int TS4        :  2;  /**< Port IO 4 Trip State */
      unsigned int TS5        :  2;  /**< Port IO 5 Trip State */
      unsigned int TS6        :  2;  /**< Port IO 6 Trip State */
      unsigned int TS7        :  2;  /**< Port IO 7 Trip State */
      unsigned int TS8        :  2;  /**< Port IO 8 Trip State */
      unsigned int TS9        :  2;  /**< Port IO 9 Trip State */
      unsigned int TS10       :  2;  /**< Port IO 10 Trip State */
      unsigned int TS11       :  2;  /**< Port IO 11 Trip State */
      unsigned int TS12       :  2;  /**< Port IO 12 Trip State */
      unsigned int TS13       :  2;  /**< Port IO 13 Trip State */
      unsigned int TS14       :  2;  /**< Port IO 14 Trip State */
      unsigned int TS15       :  2;  /**< Port IO 15 Trip State */
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_PORT_TRIPST_t;

/*@}*/

/** @defgroup PORT_TRIPSEL Multiport Trip Select (PORT_TRIPSEL) Register
 *  Multiport Trip Select (PORT_TRIPSEL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG0_PORT_TRIPSEL_Struct
 *! \brief  Multiport Trip Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG0_PORT_TRIPSEL_t {
  union {
    struct {
      unsigned int SEL        : 16;  /**< Trip A/B Mux Select */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG0_PORT_TRIPSEL_t;

/*@}*/

/** @defgroup ADIID Analog Devices Identification (ADIID) Register
 *  Analog Devices Identification (ADIID) Register.
 *
 *  CHIP ID registers required for ARM Mx systems. 
 *  These registers must be located at 0x4000 2020 and 0x4000_2024 in order for various 3rd-party ARM emulators provided by special purchase through ADI to work. These emulators are programmed to check the above addresses for the special codes 0x4144 and 0x0300.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_EMUID_ADIID_Struct
 *! \brief  Analog Devices Identification Register bit field structure
 * ========================================================================== */
typedef struct _ADI_EMUID_ADIID_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< VALUE */
    };
    uint16_t VALUE16;
  };
} ADI_EMUID_ADIID_t;

/*@}*/

/** @defgroup CHIPID Chip Identification (CHIPID) Register
 *  Chip Identification (CHIPID) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_EMUID_CHIPID_Struct
 *! \brief  Chip Identification Register bit field structure
 * ========================================================================== */
typedef struct _ADI_EMUID_CHIPID_t {
  union {
    struct {
      unsigned int REVID      :  4;  /**< REVID */
      unsigned int PARTID     : 12;  /**< PARTID */
    };
    uint16_t VALUE16;
  };
} ADI_EMUID_CHIPID_t;

/*@}*/

/** @defgroup MSK_SET Pint Mask Set Register (MSK_SET) Register
 *  Pint Mask Set Register (MSK_SET) Register.
 *
 *  The MSK_SET register permits unmasking (enabling) of interrupts. Writing 1 to a bit in MSK_SET unmasks the corresponding pin interrupt.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_MSK_SET_Struct
 *! \brief  Pint Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_MSK_SET_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Unmask */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Unmask */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Unmask */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Unmask */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Unmask */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Unmask */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Unmask */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Unmask */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Unmask */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Unmask */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Unmask */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Unmask */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Unmask */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Unmask */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Unmask */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Unmask */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Unmask */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Unmask */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Unmask */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Unmask */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Unmask */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Unmask */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Unmask */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Unmask */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Unmask */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Unmask */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Unmask */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Unmask */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Unmask */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Unmask */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Unmask */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Unmask */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_MSK_SET_t;

/*@}*/

/** @defgroup MSK_CLR Pint Mask Clear Register (MSK_CLR) Register
 *  Pint Mask Clear Register (MSK_CLR) Register.
 *
 *  The MSK_CLR register permits masking (disabling) of interrupts. Writing 1 to a bit in MSK_CLR masks the corresponding pin interrupt.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_MSK_CLR_Struct
 *! \brief  Pint Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_MSK_CLR_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Mask */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Mask */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Mask */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Mask */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Mask */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Mask */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Mask */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Mask */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Mask */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Mask */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Mask */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Mask */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Mask */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Mask */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Mask */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Mask */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Mask */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Mask */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Mask */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Mask */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Mask */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Mask */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Mask */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Mask */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Mask */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Mask */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Mask */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Mask */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Mask */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Mask */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Mask */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Mask */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_MSK_CLR_t;

/*@}*/

/** @defgroup REQ Pint Request Register (REQ) Register
 *  Pint Request Register (REQ) Register.
 *
 *  The REQ register indicates interrupt request status for pin interrupts. When set, an interrupt request is pending. When cleared, there is no interrupt request pending. 
 *  Both the REQ and LATCH registers indicate whether an interrupt request is latched on the respective pin. The LATCH register is a latch that operates regardless of the interrupt masks. Bits of the REQ register depend on the mask register. The REQ register is a logical AND of the LATCH register and the interrupt mask.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_REQ_Struct
 *! \brief  Pint Request Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_REQ_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Request */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Request */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Request */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Request */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Request */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Request */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Request */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Request */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Request */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Request */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Request */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Request */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Request */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Request */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Request */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Request */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Request */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Request */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Request */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Request */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Request */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Request */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Request */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Request */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Request */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Request */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Request */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Request */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Request */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Request */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Request */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Request */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_REQ_t;

/*@}*/

/** @defgroup ASSIGN Pint Assign Register (ASSIGN) Register
 *  Pint Assign Register (ASSIGN) Register.
 *
 *  The ASSIGN register controls the pin-to-interrupt assignment in a byte-wide manner. This register consists of four control bytes that each function as a multiplexer control. 
 *  The PINT ports are subdivided into 8-bit half ports, resulting in lower and upper half 8-bit units. Using the multiplexers controlled by the ASSIGN register, the lower half units of eight pins can be forwarded to either byte 0 or byte 2 of either associated PINT block, and the upper half units can be forwarded to either byte 1 or byte 3 of the PINT block, without further restrictions.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_ASSIGN_Struct
 *! \brief  Pint Assign Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_ASSIGN_t {
  union {
    struct {
      unsigned int B0MAP      :  8;  /**< Byte 0 Mapping */
      unsigned int B1MAP      :  8;  /**< Byte 1 Mapping */
      unsigned int B2MAP      :  8;  /**< Byte 2 Mapping */
      unsigned int B3MAP      :  8;  /**< Byte 3 Mapping */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_ASSIGN_t;

/*@}*/

/** @defgroup EDGE_SET Pint Edge Set Register (EDGE_SET) Register
 *  Pint Edge Set Register (EDGE_SET) Register.
 *
 *  The EDGE_SET register permits selecting edge-sensitive interrupts. Writing 1 to a bit in EDGE_SET enables edge sensitivity for the corresponding pin interrupt.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_EDGE_SET_Struct
 *! \brief  Pint Edge Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_EDGE_SET_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Edge */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Edge */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Edge */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Edge */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Edge */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Edge */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Edge */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Edge */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Edge */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Edge */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Edge */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Edge */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Edge */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Edge */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Edge */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Edge */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Edge */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Edge */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Edge */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Edge */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Edge */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Edge */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Edge */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Edge */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Edge */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Edge */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Edge */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Edge */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Edge */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Edge */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Edge */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Edge */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_EDGE_SET_t;

/*@}*/

/** @defgroup EDGE_CLR Pint Edge Clear Register (EDGE_CLR) Register
 *  Pint Edge Clear Register (EDGE_CLR) Register.
 *
 *  The EDGE_CLR register permits selecting level-sensitive interrupts. Writing 1 to a bit in EDGE_CLR enables level sensitivity for the corresponding pin interrupt.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_EDGE_CLR_Struct
 *! \brief  Pint Edge Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_EDGE_CLR_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Level */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Level */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Level */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Level */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Level */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Level */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Level */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Level */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Level */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Level */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Level */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Level */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Level */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Level */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Level */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Level */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Level */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Level */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Level */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Level */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Level */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Level */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Level */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Level */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Level */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Level */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Level */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Level */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Level */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Level */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Level */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Level */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_EDGE_CLR_t;

/*@}*/

/** @defgroup INV_SET Pint Invert Set Register (INV_SET) Register
 *  Pint Invert Set Register (INV_SET) Register.
 *
 *  The INV_SET register enables inverting input polarity. Writing 1 to a bit in INV_SET enables an inverter for input on the corresponding pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_INV_SET_Struct
 *! \brief  Pint Invert Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_INV_SET_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Invert */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Invert */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Invert */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Invert */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Invert */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Invert */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Invert */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Invert */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Invert */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Invert */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Invert */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Invert */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Invert */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Invert */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Invert */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Invert */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Invert */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Invert */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Invert */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Invert */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Invert */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Invert */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Invert */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Invert */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Invert */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Invert */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Invert */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Invert */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Invert */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Invert */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Invert */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Invert */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_INV_SET_t;

/*@}*/

/** @defgroup INV_CLR Pint Invert Clear Register (INV_CLR) Register
 *  Pint Invert Clear Register (INV_CLR) Register.
 *
 *  The INV_CLR register disables inverting input polarity. Writing 1 to a bit in INV_CLR disables an inverter for input on the corresponding pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_INV_CLR_Struct
 *! \brief  Pint Invert Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_INV_CLR_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 No Invert */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 No Invert */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 No Invert */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 No Invert */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 No Invert */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 No Invert */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 No Invert */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 No Invert */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 No Invert */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 No Invert */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 No Invert */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 No Invert */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 No Invert */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 No Invert */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 No Invert */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 No Invert */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 No Invert */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 No Invert */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 No Invert */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 No Invert */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 No Invert */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 No Invert */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 No Invert */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 No Invert */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 No Invert */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 No Invert */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 No Invert */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 No Invert */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 No Invert */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 No Invert */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 No Invert */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 No Invert */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_INV_CLR_t;

/*@}*/

/** @defgroup PINSTATE Pint Pinstate Register (PINSTATE) Register
 *  Pint Pinstate Register (PINSTATE) Register.
 *
 *  When a half port is assigned to a byte in any PINT block, the state of the eight pins (regardless of GPIO or function, input or output) can be seen in the PINSTATE register.  While neither input nor output drivers of the pin are enabled, reads of the pin state in PINSTATE return zero.  The PINSTATE register reports the inverted state of the pin if the signal inverter is activated by the INV_SET register.  The inverter can be enabled on a individual bit by bit basis. Every bit in the INV_SET and INV_CLR register pair represents a pin signal. 
 *  The pin interrupt pin state registers enable the service routine to read the current state of the pin without reading from GPIO space. If there was an edge-sensitive interrupt, the service routine can check whether the state of the pin is still high or turned low.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_PINSTATE_Struct
 *! \brief  Pint Pinstate Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_PINSTATE_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 State */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 State */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 State */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 State */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 State */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 State */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 State */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 State */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 State */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 State */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 State */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 State */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 State */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 State */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 State */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 State */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 State */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 State */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 State */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 State */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 State */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 State */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 State */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 State */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 State */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 State */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 State */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 State */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 State */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 State */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 State */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 State */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_PINSTATE_t;

/*@}*/

/** @defgroup LATCH Pint Latch Register (LATCH) Register
 *  Pint Latch Register (LATCH) Register.
 *
 *  The LATCH register indicates interrupt latch status for pin interrupts. When set, an interrupt request is latched. When cleared, there is no interrupt request latched. 
 *  Both the REQ and LATCH registers indicate whether an interrupt request is latched on the respective pin. The LATCH register is a latch that operates regardless of the interrupt masks. Bits of the REQ register depend on the mask register. The REQ register is a logical AND of the LATCH register and the interrupt mask. 
 *  Having two separate registers here enables the user to interrogate certain pins in polling mode while others work in interrupt mode. The LATCH registers can be used for edge detection or pin activity detection. 
 *  Both registers have W1C behavior. Writing a 1 to either clears respective bits in both registers. For interrupt operation, the user may prefer to W1C the REQ register (address still loaded in Px pointer). In polling mode it might be cleaner to W1C the LATCH register. 
 *  Regardless whether in edge-sensitive mode or level-sensitive mode, LATCH bits are never cleared by hardware except at system reset. Even in level-sensitive mode, the LATCH register functions as latch.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PINT_LATCH_Struct
 *! \brief  Pint Latch Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PINT_LATCH_t {
  union {
    struct {
      unsigned int PIQ0       :  1;  /**< Pin Interrupt 0 Latch */
      unsigned int PIQ1       :  1;  /**< Pin Interrupt 1 Latch */
      unsigned int PIQ2       :  1;  /**< Pin Interrupt 2 Latch */
      unsigned int PIQ3       :  1;  /**< Pin Interrupt 3 Latch */
      unsigned int PIQ4       :  1;  /**< Pin Interrupt 4 Latch */
      unsigned int PIQ5       :  1;  /**< Pin Interrupt 5 Latch */
      unsigned int PIQ6       :  1;  /**< Pin Interrupt 6 Latch */
      unsigned int PIQ7       :  1;  /**< Pin Interrupt 7 Latch */
      unsigned int PIQ8       :  1;  /**< Pin Interrupt 8 Latch */
      unsigned int PIQ9       :  1;  /**< Pin Interrupt 9 Latch */
      unsigned int PIQ10      :  1;  /**< Pin Interrupt 10 Latch */
      unsigned int PIQ11      :  1;  /**< Pin Interrupt 11 Latch */
      unsigned int PIQ12      :  1;  /**< Pin Interrupt 12 Latch */
      unsigned int PIQ13      :  1;  /**< Pin Interrupt 13 Latch */
      unsigned int PIQ14      :  1;  /**< Pin Interrupt 14 Latch */
      unsigned int PIQ15      :  1;  /**< Pin Interrupt 15 Latch */
      unsigned int PIQ16      :  1;  /**< Pin Interrupt 16 Latch */
      unsigned int PIQ17      :  1;  /**< Pin Interrupt 17 Latch */
      unsigned int PIQ18      :  1;  /**< Pin Interrupt 18 Latch */
      unsigned int PIQ19      :  1;  /**< Pin Interrupt 19 Latch */
      unsigned int PIQ20      :  1;  /**< Pin Interrupt 20 Latch */
      unsigned int PIQ21      :  1;  /**< Pin Interrupt 21 Latch */
      unsigned int PIQ22      :  1;  /**< Pin Interrupt 22 Latch */
      unsigned int PIQ23      :  1;  /**< Pin Interrupt 23 Latch */
      unsigned int PIQ24      :  1;  /**< Pin Interrupt 24 Latch */
      unsigned int PIQ25      :  1;  /**< Pin Interrupt 25 Latch */
      unsigned int PIQ26      :  1;  /**< Pin Interrupt 26 Latch */
      unsigned int PIQ27      :  1;  /**< Pin Interrupt 27 Latch */
      unsigned int PIQ28      :  1;  /**< Pin Interrupt 28 Latch */
      unsigned int PIQ29      :  1;  /**< Pin Interrupt 29 Latch */
      unsigned int PIQ30      :  1;  /**< Pin Interrupt 30 Latch */
      unsigned int PIQ31      :  1;  /**< Pin Interrupt 31 Latch */
    };
    uint32_t VALUE32;
  };
} ADI_PINT_LATCH_t;

/*@}*/

/** @defgroup FER Port x Function Enable Register (FER) Register
 *  Port x Function Enable Register (FER) Register.
 *
 *  The FER register bits indicate each port bit's operating mode: general purpose I/O mode or peripheral mode. After reset, all pins default to GPIO mode. Setting a bit in the FER registers enables a peripheral module to take ownership of the pin. The function enable bits impact output control only. Regardless of the setting of the function enable bits, both GPIO and peripherals can still sense the pin input. After a function is enabled, it is up to the MUX registers as to which peripheral takes control.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_FER_Struct
 *! \brief  Port x Function Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_FER_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Mode */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Mode */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Mode */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Mode */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Mode */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Mode */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Mode */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Mode */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Mode */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Mode */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Mode */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Mode */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Mode */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Mode */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Mode */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Mode */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_FER_t;

/*@}*/

/** @defgroup FER_SET Port x Function Enable Set Register (FER_SET) Register
 *  Port x Function Enable Set Register (FER_SET) Register.
 *
 *  The FER_SET register permits enabling peripheral mode for each bit and corresponding GPIO pin. Writing 1 to a bit in FER_SET enables peripheral mode for the corresponding pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_FER_SET_Struct
 *! \brief  Port x Function Enable Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_FER_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Mode Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Mode Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Mode Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Mode Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Mode Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Mode Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Mode Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Mode Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Mode Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Mode Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Mode Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Mode Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Mode Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Mode Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Mode Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Mode Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_FER_SET_t;

/*@}*/

/** @defgroup FER_CLR Port x Function Enable Clear Register (FER_CLR) Register
 *  Port x Function Enable Clear Register (FER_CLR) Register.
 *
 *  The FER_CLR register permits enabling GPIO mode for each bit and corresponding GPIO pin. Writing 1 to a bit in FER_CLR enables GPIO mode for the corresponding pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_FER_CLR_Struct
 *! \brief  Port x Function Enable Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_FER_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Mode Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Mode Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Mode Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Mode Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Mode Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Mode Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Mode Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Mode Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Mode Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Mode Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Mode Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Mode Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Mode Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Mode Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Mode Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Mode Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_FER_CLR_t;

/*@}*/

/** @defgroup DATA Port x GPIO Data Register (DATA) Register
 *  Port x GPIO Data Register (DATA) Register.
 *
 *  The DATA register operates differently for port bits/pins, depending on whether the bit/pin is in output mode or input mode. In both modes, a set bit in the DATA register corresponds to a signal high on a GPIO pin, and a cleared bit in the DATA register corresponds to a signal low on a GPIO pin. 
 *  The DATA, DATA_SET, and DATA_CLR registers control the state of GPIO pins in output mode. To enable output mode (and output drivers), use the DIR_SET and DIR_CLR registers. 
 *  Writes to the DATA register affect the state of all pins of the port that are in output mode. To set or clear specific pins without impacting other pins of the port, use the DATA_SET and DATA_CLR registers. 
 *  When the GPIO pins are in input mode (input driver is enabled with the INEN register), reads from the DATA, DATA_SET, and DATA_CLR registers return the state of the respective GPIO pins.  
 *  Note that when the input driver is not enabled, reads from the DATA, DATA_SET, and DATA_CLR registers return the value previously written to the registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DATA_Struct
 *! \brief  Port x GPIO Data Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DATA_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Data */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Data */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Data */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Data */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Data */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Data */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Data */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Data */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Data */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Data */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Data */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Data */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Data */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Data */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Data */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Data */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DATA_t;

/*@}*/

/** @defgroup DATA_SET Port x GPIO Data Set Register (DATA_SET) Register
 *  Port x GPIO Data Set Register (DATA_SET) Register.
 *
 *  The DATA_SET register operates differently for port bits/pins, depending on whether the bit/pin is output mode or input mode. For more information, see the DATA register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DATA_SET_Struct
 *! \brief  Port x GPIO Data Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DATA_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Data Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Data Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Data Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Data Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Data Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Data Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Data Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Data Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Data Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Data Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Data Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Data Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Data Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Data Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Data Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Data Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DATA_SET_t;

/*@}*/

/** @defgroup DATA_CLR Port x GPIO Data Clear Register (DATA_CLR) Register
 *  Port x GPIO Data Clear Register (DATA_CLR) Register.
 *
 *  The DATA_CLR register operates differently for port bits/pins, depending on whether the bit/pin is output mode or input mode. For more information, see the DATA register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DATA_CLR_Struct
 *! \brief  Port x GPIO Data Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DATA_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Data Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Data Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Data Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Data Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Data Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Data Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Data Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Data Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Data Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Data Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Data Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Data Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Data Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Data Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Data Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Data Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DATA_CLR_t;

/*@}*/

/** @defgroup DIR Port x GPIO Direction Register (DIR) Register
 *  Port x GPIO Direction Register (DIR) Register.
 *
 *  The DIR, DIR_SET, and DIR_CLR registers select output or input mode for GPIO pins and enable output drivers. Use the INEN, INEN_SET, and INEN_CLR registers to enable or disable input drivers. 
 *  Writes to the DIR register affect the state of all pins of the port. To select direction for specific pins without impacting other pins of the port, use the DIR_SET and DIR_CLR registers. 
 *  Setting a bit in the DIR register enables output mode on the corresponding a GPIO pin, and a clearing a bit in the DIR register disables output mode on the corresponding GPIO pin. 
 *  Input Mode - The default mode of every GPIO pin after reset is input mode, but the input drivers are not enabled. To enable any GPIO input drivers, set the corresponding bits in INEN register. When enabled, a read from the DATA register returns the logical state of the input pin. The input signal does not overwrite the state of the bit used for the output case. That state can only be altered by software. If the input driver is enabled, a write to the DATA register can alter the state of the bit, but the change cannot be read back. 
 *  Output Mode - Any GPIO pin can be configured for output mode. The GPIO output drivers are enabled by setting the corresponding bits in the DIR, DIR_SET, or DIR_CLR registers.  By using the DIR_SET and DIR_CLR registers, direction of the signal flow of individual GPIO pins can be altered by separate software threads without mutually impacting other GPIOs on the same port. Both registers return the same value when read. Because the state of the GPIO output can already be controlled before the output driver is enabled, it is recommended to first set or clear the bit (using the DATA, DATA_SET, or DATA_CLR registers) to avoid any volatile levels on the output. 
 *  Open-Drain Mode- Every GPIO can also be used in open-drain mode. To accomplish this, first, clear the respective bit in the DATA or DATA_CLR register then set the one bit in the INEN register. Reads from the DATA register then return the status from the pin and do not return the state of the internal flip-flop. By toggling the output driver through the DIR_SET and DIR_CLR register pair, the output signal can be pulled low or three-stated as required. Note that the polarity of the driven signal can be inverted when the internal flip-flop is set instead. When a GPIO port is used in open-drain mode, care must be taken not to exceed the V$[sub$]IH$[/sub$] operating condition associated with the respective pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DIR_Struct
 *! \brief  Port x GPIO Direction Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DIR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Direction */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Direction */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Direction */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Direction */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Direction */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Direction */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Direction */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Direction */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Direction */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Direction */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Direction */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Direction */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Direction */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Direction */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Direction */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Direction */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DIR_t;

/*@}*/

/** @defgroup DIR_SET Port x GPIO Direction Set Register (DIR_SET) Register
 *  Port x GPIO Direction Set Register (DIR_SET) Register.
 *
 *  The DIR_SET register enable output mode and enables output drivers for GPIO pins. For more information, see the DIR register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DIR_SET_Struct
 *! \brief  Port x GPIO Direction Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DIR_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Direction Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Direction Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Direction Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Direction Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Direction Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Direction Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Direction Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Direction Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Direction Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Direction Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Direction Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Direction Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Direction Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Direction Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Direction Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Direction Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DIR_SET_t;

/*@}*/

/** @defgroup DIR_CLR Port x GPIO Direction Clear Register (DIR_CLR) Register
 *  Port x GPIO Direction Clear Register (DIR_CLR) Register.
 *
 *  The DIR_CLR register disables output mode and disables output drivers for GPIO pins. For more information, see the DIR register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DIR_CLR_Struct
 *! \brief  Port x GPIO Direction Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DIR_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Direction Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Direction Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Direction Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Direction Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Direction Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Direction Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Direction Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Direction Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Direction Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Direction Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Direction Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Direction Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Direction Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Direction Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Direction Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Direction Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DIR_CLR_t;

/*@}*/

/** @defgroup INEN Port x GPIO Input Enable Register (INEN) Register
 *  Port x GPIO Input Enable Register (INEN) Register.
 *
 *  The INEN, INEN_SET, and INEN_CLR registers enable or disable input drivers, which are required for using a GPIO pin in input mode. 
 *  Writes to the INEN register affect the input drivers for all pins of the port. To set or clear specific pin drivers without impacting other pin drivers of the port, use the INEN_SET and INEN_CLR registers. 
 *  If the input is enabled, reads from the DATA, DATA_SET, or DATA_CLR registers return the state of the pins. However, the state of the output is not overwritten by the input. It is altered by software writes only. Input and output drivers can be enabled at the same time. In this case, a read of the data register returns the true value of the data register and not the pin state. 
 *  For more information see the DATA register description and the DIR register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_INEN_Struct
 *! \brief  Port x GPIO Input Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_INEN_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Input Enable */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Input Enable */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Input Enable */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Input Enable */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Input Enable */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Input Enable */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Input Enable */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Input Enable */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Input Enable */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Input Enable */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Input Enable */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Input Enable */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Input Enable */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Input Enable */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Input Enable */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Input Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_INEN_t;

/*@}*/

/** @defgroup INEN_SET Port x GPIO Input Enable Set Register (INEN_SET) Register
 *  Port x GPIO Input Enable Set Register (INEN_SET) Register.
 *
 *  The INEN_SET register enables input drivers for GPIO pins. For more information, see the INEN register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_INEN_SET_Struct
 *! \brief  Port x GPIO Input Enable Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_INEN_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Input Enable Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Input Enable Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Input Enable Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Input Enable Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Input Enable Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Input Enable Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Input Enable Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Input Enable Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Input Enable Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Input Enable Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Input Enable Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Input Enable Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Input Enable Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Input Enable Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Input Enable Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Input Enable Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_INEN_SET_t;

/*@}*/

/** @defgroup INEN_CLR Port x GPIO Input Enable Clear Register (INEN_CLR) Register
 *  Port x GPIO Input Enable Clear Register (INEN_CLR) Register.
 *
 *  The INEN_CLR register disables input drivers for GPIO pins. For more information, see the INEN register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_INEN_CLR_Struct
 *! \brief  Port x GPIO Input Enable Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_INEN_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Input Enable Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Input Enable Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Input Enable Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Input Enable Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Input Enable Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Input Enable Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Input Enable Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Input Enable Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Input Enable Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Input Enable Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Input Enable Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Input Enable Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Input Enable Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Input Enable Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Input Enable Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Input Enable Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_INEN_CLR_t;

/*@}*/

/** @defgroup MUX Port x Multiplexer Control Register (MUX) Register
 *  Port x Multiplexer Control Register (MUX) Register.
 *
 *  When a pin is in peripheral mode (not GPIO mode), the MUX register controls which peripheral takes ownership of a pin. Ports may have multiple, different peripheral functions. Two bits are required to describe every multiplexer on an individual pin-by-pin scheme. For example, Bit 0 and Bit 1 of the MUX register control the multiplexer of Pin 0, Bit 2 and Bit 3 of MUX control the multiplexer of Pin 1, and so on. The value of any MUX bit has no effect on the port pins when the associated bit in the FER register is 0 (selects GPIO mode). Even if a port has only one function, the MUX register is still present. For single function ports (no multiplexing is needed), leave the MUX bits at 0 (default). For all MUX bit fields: 00 = default/reset peripheral option, 01 = first alternate peripheral option, 10 = second alternate peripheral option, and 11 = third alternate peripheral option.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_MUX_Struct
 *! \brief  Port x Multiplexer Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_MUX_t {
  union {
    struct {
      unsigned int MUX0       :  2;  /**< Mux for Port x Bit 0 */
      unsigned int MUX1       :  2;  /**< Mux for Port x Bit 1 */
      unsigned int MUX2       :  2;  /**< Mux for Port x Bit 2 */
      unsigned int MUX3       :  2;  /**< Mux for Port x Bit 3 */
      unsigned int MUX4       :  2;  /**< Mux for Port x Bit 4 */
      unsigned int MUX5       :  2;  /**< Mux for Port x Bit 5 */
      unsigned int MUX6       :  2;  /**< Mux for Port x Bit 6 */
      unsigned int MUX7       :  2;  /**< Mux for Port x Bit 7 */
      unsigned int MUX8       :  2;  /**< Mux for Port x Bit 8 */
      unsigned int MUX9       :  2;  /**< Mux for Port x Bit 9 */
      unsigned int MUX10      :  2;  /**< Mux for Port x Bit 10 */
      unsigned int MUX11      :  2;  /**< Mux for Port x Bit 11 */
      unsigned int MUX12      :  2;  /**< Mux for Port x Bit 12 */
      unsigned int MUX13      :  2;  /**< Mux for Port x Bit 13 */
      unsigned int MUX14      :  2;  /**< Mux for Port x Bit 14 */
      unsigned int MUX15      :  2;  /**< Mux for Port x Bit 15 */
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_MUX_t;

/*@}*/

/** @defgroup DATA_TGL Port x GPIO Input Enable Toggle Register (DATA_TGL) Register
 *  Port x GPIO Input Enable Toggle Register (DATA_TGL) Register.
 *
 *  The DATA_TGL register permits toggling the state of output GPIO pins. Setting bits in the DATA_TGL register affects the state of specific pins without impacting other pins of the port. 
 *  Reading the DATA_TGL returns the state of the DATA register output pin state, but does not return the input pin/signal state.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_DATA_TGL_Struct
 *! \brief  Port x GPIO Input Enable Toggle Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_DATA_TGL_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Toggle */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Toggle */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Toggle */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Toggle */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Toggle */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Toggle */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Toggle */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Toggle */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Toggle */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Toggle */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Toggle */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Toggle */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Toggle */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Toggle */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Toggle */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Toggle */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_DATA_TGL_t;

/*@}*/

/** @defgroup POL Port x GPIO Polarity Invert Register (POL) Register
 *  Port x GPIO Polarity Invert Register (POL) Register.
 *
 *  The POL, POL_SET, and POL_CLR registers enable or disable inverting polarity of GPIO signals. To invert polarity of peripheral signals, use the inversion selection programming in the signal's corresponding module.  
 *  Writes to the POL register affect the polarity inversion selection of all pins of the port. To enable or disable polarity inversion for specific pins without impacting other pins of the port, use the POL_SET and POL_CLR registers. 
 *  Setting a bit in the POL register enables polarity inversion on the corresponding inversion GPIO pin, making the pin active-low or falling-edge sensitive. Clearing a bit in the POL register disables polarity (default state) on the corresponding GPIO pin, making it active-high or rising-edge sensitive.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_POL_Struct
 *! \brief  Port x GPIO Polarity Invert Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_POL_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Polarity Invert */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Polarity Invert */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Polarity Invert */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Polarity Invert */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Polarity Invert */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Polarity Invert */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Polarity Invert */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Polarity Invert */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Polarity Invert */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Polarity Invert */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Polarity Invert */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Polarity Invert */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Polarity Invert */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Polarity Invert */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Polarity Invert */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Polarity Invert */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_POL_t;

/*@}*/

/** @defgroup POL_SET Port x GPIO Polarity Invert Set Register (POL_SET) Register
 *  Port x GPIO Polarity Invert Set Register (POL_SET) Register.
 *
 *  The POL_SET register enables polarity inversion for GPIO pins. For more information, see the POL register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_POL_SET_Struct
 *! \brief  Port x GPIO Polarity Invert Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_POL_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Polarity Invert Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Polarity Invert Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Polarity Invert Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Polarity Invert Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Polarity Invert Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Polarity Invert Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Polarity Invert Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Polarity Invert Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Polarity Invert Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Polarity Invert Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Polarity Invert Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Polarity Invert Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Polarity Invert Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Polarity Invert Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Polarity Invert Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Polarity Invert Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_POL_SET_t;

/*@}*/

/** @defgroup POL_CLR Port x GPIO Polarity Invert Clear Register (POL_CLR) Register
 *  Port x GPIO Polarity Invert Clear Register (POL_CLR) Register.
 *
 *  The POL_CLR register disables polarity inversion for GPIO pins. For more information, see the POL register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_POL_CLR_Struct
 *! \brief  Port x GPIO Polarity Invert Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_POL_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Polarity Invert Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Polarity Invert Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Polarity Invert Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Polarity Invert Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Polarity Invert Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Polarity Invert Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Polarity Invert Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Polarity Invert Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Polarity Invert Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Polarity Invert Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Polarity Invert Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Polarity Invert Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Polarity Invert Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Polarity Invert Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Polarity Invert Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Polarity Invert Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_POL_CLR_t;

/*@}*/

/** @defgroup LOCK Port x GPIO Lock Register (LOCK) Register
 *  Port x GPIO Lock Register (LOCK) Register.
 *
 *  The LOCK register enables (unlocks) or disables (locks) write access selectively for the PORT_CFG0 control registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_LOCK_Struct
 *! \brief  Port x GPIO Lock Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_LOCK_t {
  union {
    struct {
      unsigned int FER        :  1;  /**< Function Enable Lock */
      unsigned int MUX        :  1;  /**< Function Multiplexer Lock */
      unsigned int DATA       :  1;  /**< Data, TGL Lock */
      unsigned int DIR        :  1;  /**< Direction Lock */
      unsigned int INEN       :  1;  /**< Input Enable Lock */
      unsigned int POLAR      :  1;  /**< Polarity Lock */
      unsigned int reserved6  : 25;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_LOCK_t;

/*@}*/

/** @defgroup TRIG_TGL Port x GPIO Trigger Toggle Register (TRIG_TGL) Register
 *  Port x GPIO Trigger Toggle Register (TRIG_TGL) Register.
 *
 *  The TRIG_TGL register is reserved for internal ADI usage only.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG0_TRIG_TGL_Struct
 *! \brief  Port x GPIO Trigger Toggle Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG0_TRIG_TGL_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< PX0 Data Toggle on Trigger */
      unsigned int PX1        :  1;  /**< PX1 Data Toggle on Trigger */
      unsigned int PX2        :  1;  /**< PX2 Data Toggle on Trigger */
      unsigned int PX3        :  1;  /**< PX3 Data Toggle on Trigger */
      unsigned int PX4        :  1;  /**< PX4 Data Toggle on Trigger */
      unsigned int PX5        :  1;  /**< PX5 Data Toggle on Trigger */
      unsigned int PX6        :  1;  /**< PX6 Data Toggle on Trigger */
      unsigned int PX7        :  1;  /**< PX7 Data Toggle on Trigger */
      unsigned int PX8        :  1;  /**< PX8 Data Toggle on Trigger */
      unsigned int PX9        :  1;  /**< PX9 Data Toggle on Trigger */
      unsigned int PX10       :  1;  /**< PX10 Data Toggle on Trigger */
      unsigned int PX11       :  1;  /**< PX11 Data Toggle on Trigger */
      unsigned int PX12       :  1;  /**< PX12 Data Toggle on Trigger */
      unsigned int PX13       :  1;  /**< PX13 Data Toggle on Trigger */
      unsigned int PX14       :  1;  /**< PX14 Data Toggle on Trigger */
      unsigned int PX15       :  1;  /**< PX15 Data Toggle on Trigger */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG0_TRIG_TGL_t;

/*@}*/

/** @defgroup CLK_CTL Logic Block Array Clock Divisor (CLK_CTL) Register
 *  Logic Block Array Clock Divisor (CLK_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_CLK_CTL_Struct
 *! \brief  Logic Block Array Clock Divisor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_CLK_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Clock Divisor Enable */
      unsigned int reserved1  :  3;
      unsigned int DIVDAT     :  4;  /**< Divisor for LBA_CLK output */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_CLK_CTL_t;

/*@}*/

/** @defgroup DIR Logic Block Array Pin Direction (DIR) Register
 *  Logic Block Array Pin Direction (DIR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_DIR_Struct
 *! \brief  Logic Block Array Pin Direction Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_DIR_t {
  union {
    struct {
      unsigned int PIN0       :  1;  /**< Output Enable for PIN0(input is disabled if output is enabled) */
      unsigned int PIN1       :  1;  /**< Output Enable for PIN1(input is disabled if output is enabled) */
      unsigned int PIN2       :  1;  /**< Output Enable for PIN2(input is disabled if output is enabled) */
      unsigned int PIN3       :  1;  /**< Output Enable for PIN3(input is disabled if output is enabled) */
      unsigned int PIN4       :  1;  /**< Output Enable for PIN4(input is disabled if output is enabled) */
      unsigned int PIN5       :  1;  /**< Output Enable for PIN5(input is disabled if output is enabled) */
      unsigned int PIN6       :  1;  /**< Output Enable for PIN6(input is disabled if output is enabled) */
      unsigned int PIN7       :  1;  /**< Output Enable for PIN7(input is disabled if output is enabled) */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_DIR_t;

/*@}*/

/** @defgroup DIN Logic Block Array Data Input (DIN) Register
 *  Logic Block Array Data Input (DIN) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_DIN_Struct
 *! \brief  Logic Block Array Data Input Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_DIN_t {
  union {
    struct {
      unsigned int DATA       :  8;  /**< Data Input Field (optional data source which can be selected by input multiplexer) */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_DIN_t;

/*@}*/

/** @defgroup DOUT Logic Block Array Data Output (DOUT) Register
 *  Logic Block Array Data Output (DOUT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_DOUT_Struct
 *! \brief  Logic Block Array Data Output Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_DOUT_t {
  union {
    struct {
      unsigned int DATA       :  8;  /**< Registered data outputs from each Logic Block */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_DOUT_t;

/*@}*/

/** @defgroup CFG Logic Block Array Configuration Register (CFG) Register
 *  Logic Block Array Configuration Register (CFG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_CFG_Struct
 *! \brief  Logic Block Array Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_CFG_t {
  union {
    struct {
      unsigned int A0MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A0 input */
      unsigned int A1MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A1 input */
      unsigned int A2MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A2 input */
      unsigned int A3MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A3 input */
      unsigned int A4MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A4 input */
      unsigned int A5MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A5 input */
      unsigned int A6MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A6 input */
      unsigned int A7MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for A7 input */
      unsigned int B0MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B0 input */
      unsigned int B1MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B1 input */
      unsigned int B2MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B2 input */
      unsigned int B3MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B3 input */
      unsigned int B4MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B4 input */
      unsigned int B5MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B5 input */
      unsigned int B6MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B6 input */
      unsigned int B7MXSEL    :  2;  /**< 4:1 Input Multiplexer Select for B7 input */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_CFG_t;

/*@}*/

/** @defgroup SYNC_CTL Logic Block Array GPIO Input Synchronization Control (SYNC_CTL) Register
 *  Logic Block Array GPIO Input Synchronization Control (SYNC_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_SYNC_CTL_Struct
 *! \brief  Logic Block Array GPIO Input Synchronization Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_SYNC_CTL_t {
  union {
    struct {
      unsigned int SYNCIN     :  8;  /**< Synchronizer Select for each GPIO input */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_SYNC_CTL_t;

/*@}*/

/** @defgroup BLK_CTL Logic Block Control Register (BLK_CTL) Register
 *  Logic Block Control Register (BLK_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_CTL_Struct
 *! \brief  Logic Block Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int PTA        :  1;  /**< Product-Term -Array Mode(default is Look-Up-Table Mode) */
      unsigned int REGOUT     :  1;  /**< Registered Output Select */
      unsigned int CINSEL     :  1;  /**< Cascade Input Select (From Previous Block) replaces A7  input */
      unsigned int OUTINV     :  1;  /**< Invert  Logic Block Output */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_CTL_t;

/*@}*/

/** @defgroup BLK_FN0 Logic Block Function 0 Register (BLK_FN0) Register
 *  Logic Block Function 0 Register (BLK_FN0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN0_Struct
 *! \brief  Logic Block Function 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN0_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product Term Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN0_t;

/*@}*/

/** @defgroup BLK_FN1 Logic Block Function 1 Register (BLK_FN1) Register
 *  Logic Block Function 1 Register (BLK_FN1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN1_Struct
 *! \brief  Logic Block Function 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN1_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product Term Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN1_t;

/*@}*/

/** @defgroup BLK_FN2 Logic Block Function 2 Register (BLK_FN2) Register
 *  Logic Block Function 2 Register (BLK_FN2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN2_Struct
 *! \brief  Logic Block Function 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN2_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product Term Array Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN2_t;

/*@}*/

/** @defgroup BLK_FN3 Logic Block Function 3 Register (BLK_FN3) Register
 *  Logic Block Function 3 Register (BLK_FN3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN3_Struct
 *! \brief  Logic Block Function 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN3_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product-Term-Array Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN3_t;

/*@}*/

/** @defgroup BLK_FN4 Logic Block Function 4 Register (BLK_FN4) Register
 *  Logic Block Function 4 Register (BLK_FN4) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN4_Struct
 *! \brief  Logic Block Function 4 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN4_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product-Term-Array Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN4_t;

/*@}*/

/** @defgroup BLK_FN5 Logic Block Function 5 Register (BLK_FN5) Register
 *  Logic Block Function 5 Register (BLK_FN5) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN5_Struct
 *! \brief  Logic Block Function 5 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN5_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product-Term-Array Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN5_t;

/*@}*/

/** @defgroup BLK_FN6 Logic Block Function 6 Register (BLK_FN6) Register
 *  Logic Block Function 6 Register (BLK_FN6) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN6_Struct
 *! \brief  Logic Block Function 6 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN6_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product-Term-Array Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN6_t;

/*@}*/

/** @defgroup BLK_FN7 Logic Block Function 7 Register (BLK_FN7) Register
 *  Logic Block Function 7 Register (BLK_FN7) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_LBA0_BLK_FN7_Struct
 *! \brief  Logic Block Function 7 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_LBA0_BLK_FN7_t {
  union {
    struct {
      unsigned int DAT        : 32;  /**< Look-Up-Table or Product-Term-Array Function Data */
    };
    uint32_t VALUE32;
  };
} ADI_LBA0_BLK_FN7_t;

/*@}*/

/** @defgroup SCTL Source Control Register n (SCTL) Register
 *  Source Control Register n (SCTL) Register.
 *
 *  The SEC_CFG0 source control register (SCTL[n]) contains control bits to configure the SEC_CFG0 event sources. This register controls the configuration of the corresponding SEC event source.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SCTL_FEN
 *! \brief  Fault Enable (FEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SCTL_FAULT_DIS = 0,  /**< Disable */
  SEC_SCTL_FAULT_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_SCTL_FEN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SCTL_SEN
 *! \brief  Source (signal) Enable (SEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SCTL_SRC_DIS = 0,  /**< Disable */
  SEC_SCTL_SRC_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_SCTL_SEN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SCTL_ES
 *! \brief  Edge Select (ES) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SCTL_LEVEL = 0,  /**< Level Sensitive */
  SEC_SCTL_EDGE  = 1   /**< Edge Sensitive  */
} ADI_SEC_CFG0_SCTL_ES;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SCTL_ERREN
 *! \brief  Error Enable (ERREN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SCTL_ERR_DIS = 0,  /**< Disable */
  SEC_SCTL_ERR_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_SCTL_ERREN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SCTL_LOCK
 *! \brief  Lock (LOCK) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SCTL_UNLOCK = 0,  /**< Unlock */
  SEC_SCTL_LOCK   = 1   /**< Lock   */
} ADI_SEC_CFG0_SCTL_LOCK;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_SCTL_Struct
 *! \brief  Source Control Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_SCTL_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int FEN        :  1;  /**< Fault Enable */
      unsigned int SEN        :  1;  /**< Source (signal) Enable */
      unsigned int ES         :  1;  /**< Edge Select */
      unsigned int ERREN      :  1;  /**< Error Enable */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_SCTL_t;

/*@}*/

/** @defgroup SSTAT Source Status Register n (SSTAT) Register
 *  Source Status Register n (SSTAT) Register.
 *
 *  The SEC_CFG0 event source status register (SSTAT[n]) contains bits indicating the status of the corresponding event source n. An event source may be: pending, active, active and pending, or neither pending nor active.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SSTAT_ERR
 *! \brief  Error (ERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SSTAT_NO_ERR = 0,  /**< No Error       */
  SEC_SSTAT_ERR    = 1   /**< Error Occurred */
} ADI_SEC_CFG0_SSTAT_ERR;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SSTAT_ERRC
 *! \brief  Error Cause (ERRC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SSTAT_SOVFERR = 0,  /**< Source Overflow Error */
  SEC_SSTAT_ENDERR  = 2   /**< End Error             */
} ADI_SEC_CFG0_SSTAT_ERRC;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_SSTAT_PND
 *! \brief  Pending Source (PND) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_SSTAT_NOTPENDING = 0,  /**< Not Pending */
  SEC_SSTAT_PENDING    = 1   /**< Pending     */
} ADI_SEC_CFG0_SSTAT_PND;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_SSTAT_Struct
 *! \brief  Source Status Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_SSTAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int ERR        :  1;  /**< Error */
      unsigned int reserved2  :  2;
      unsigned int ERRC       :  2;  /**< Error Cause */
      unsigned int reserved6  :  2;
      unsigned int PND        :  1;  /**< Pending Source */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_SSTAT_t;

/*@}*/

/** @defgroup FCTL Fault Control Register (FCTL) Register
 *  Fault Control Register (FCTL) Register.
 *
 *  The SEC_CFG0 fault control register (FCTL) contains fault control bits for all SEC_CFG0 channels. This register controls the operation of the System Fault Management Interface (SFI).
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_EN
 *! \brief  Enable (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_DIS = 0,  /**< Disable */
  SEC_FCTL_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_FCTL_EN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_RESET
 *! \brief  Reset (RESET) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_NO_RESET = 0,  /**< No Action */
  SEC_FCTL_RESET    = 1   /**< Reset     */
} ADI_SEC_CFG0_FCTL_RESET;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_FOEN
 *! \brief  Fault Output Enable (FOEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_FLTOUT_DIS = 0,  /**< Disable */
  SEC_FCTL_FLTOUT_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_FCTL_FOEN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_TOEN
 *! \brief  Trigger Output Enable (TOEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_TRGOUT_DIS = 0,  /**< Disable */
  SEC_FCTL_TRGOUT_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_FCTL_TOEN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_SREN
 *! \brief  System Reset Enable (SREN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_SYSRST_DIS = 0,  /**< Disable */
  SEC_FCTL_SYSRST_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_FCTL_SREN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_FIEN
 *! \brief  Fault Input Enable (FIEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_FLTIN_DIS = 0,  /**< Disable */
  SEC_FCTL_FLTIN_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_FCTL_FIEN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_CMS
 *! \brief  COP Mode Select (CMS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_FLT_MODE = 0,  /**< Fault Mode */
  SEC_FCTL_COP_MODE = 1   /**< COP Mode   */
} ADI_SEC_CFG0_FCTL_CMS;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_TES
 *! \brief  Trigger Event Select (TES) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_FLTACT_MODE = 0,  /**< Fault Active Mode  */
  SEC_FCTL_FLTPND_MODE = 1   /**< Fault Pending Mode */
} ADI_SEC_CFG0_FCTL_TES;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FCTL_LOCK
 *! \brief  Lock (LOCK) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FCTL_UNLOCK = 0,  /**< UnLock */
  SEC_FCTL_LOCK   = 1   /**< Lock   */
} ADI_SEC_CFG0_FCTL_LOCK;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FCTL_Struct
 *! \brief  Fault Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int RESET      :  1;  /**< Reset */
      unsigned int reserved2  :  2;
      unsigned int FOEN       :  1;  /**< Fault Output Enable */
      unsigned int TOEN       :  1;  /**< Trigger Output Enable */
      unsigned int SREN       :  1;  /**< System Reset Enable */
      unsigned int FIEN       :  1;  /**< Fault Input Enable */
      unsigned int reserved8  :  4;
      unsigned int CMS        :  1;  /**< COP Mode Select */
      unsigned int TES        :  1;  /**< Trigger Event Select */
      unsigned int reserved14 : 17;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FCTL_t;

/*@}*/

/** @defgroup FSTAT Fault Status Register (FSTAT) Register
 *  Fault Status Register (FSTAT) Register.
 *
 *  The SEC_CFG0 fault status register (FSTAT) indicates the operational status of the SFI.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FSTAT_ERR
 *! \brief  Error (ERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FSTAT_NO_ERR = 0,  /**< No Error       */
  SEC_FSTAT_ERR    = 1   /**< Error Occurred */
} ADI_SEC_CFG0_FSTAT_ERR;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FSTAT_ERRC
 *! \brief  Error Cause (ERRC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FSTAT_ENDERR = 2   /**< End Error */
} ADI_SEC_CFG0_FSTAT_ERRC;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FSTAT_PND
 *! \brief  Pending Fault (PND) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FSTAT_NO_FLTPND = 0,  /**< Not Pending */
  SEC_FSTAT_FLTPND    = 1   /**< Pending     */
} ADI_SEC_CFG0_FSTAT_PND;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FSTAT_ACT
 *! \brief  Fault Active (ACT) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FSTAT_NO_FLTACT = 0,  /**< No Fault     */
  SEC_FSTAT_FLTACT    = 1   /**< Active Fault */
} ADI_SEC_CFG0_FSTAT_ACT;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FSTAT_NPND
 *! \brief  Next Pending Fault (NPND) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FSTAT_NO_NXTFLT = 0,  /**< Not Pending */
  SEC_FSTAT_NXTFLT    = 1   /**< Pending     */
} ADI_SEC_CFG0_FSTAT_NPND;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FSTAT_Struct
 *! \brief  Fault Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FSTAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int ERR        :  1;  /**< Error */
      unsigned int reserved2  :  2;
      unsigned int ERRC       :  2;  /**< Error Cause */
      unsigned int reserved6  :  2;
      unsigned int PND        :  1;  /**< Pending Fault */
      unsigned int ACT        :  1;  /**< Fault Active */
      unsigned int NPND       :  1;  /**< Next Pending Fault */
      unsigned int reserved11 : 21;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FSTAT_t;

/*@}*/

/** @defgroup FSID Fault Source ID Register (FSID) Register
 *  Fault Source ID Register (FSID) Register.
 *
 *  The SEC_CFG0 fault source ID register (FSID) contains a fault source ID and internal/external fields.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FSID_FEXT
 *! \brief  Fault External (FEXT) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FSID_SRC_INTFLT = 0,  /**< Fault Internal */
  SEC_FSID_SRC_EXTFLT = 1   /**< Fault External */
} ADI_SEC_CFG0_FSID_FEXT;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FSID_Struct
 *! \brief  Fault Source ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FSID_t {
  union {
    struct {
      unsigned int SID        :  8;  /**< Source ID */
      unsigned int reserved8  :  8;
      unsigned int FEXT       :  1;  /**< Fault External */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FSID_t;

/*@}*/

/** @defgroup FEND Fault End Register (FEND) Register
 *  Fault End Register (FEND) Register.
 *
 *  The SEC_CFG0 fault end register (FEND) contains fault source ID and internal/external fields. This register receives fault end indication from a core.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_FEND_FEXT
 *! \brief  Fault External (FEXT) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_FEND_END_INTFLT = 0,  /**< Fault Internal */
  SEC_FEND_END_EXTFLT = 1   /**< Fault External */
} ADI_SEC_CFG0_FEND_FEXT;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FEND_Struct
 *! \brief  Fault End Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FEND_t {
  union {
    struct {
      unsigned int SID        :  8;  /**< Source ID */
      unsigned int reserved8  :  8;
      unsigned int FEXT       :  1;  /**< Fault External */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FEND_t;

/*@}*/

/** @defgroup FDLY Fault Delay Register (FDLY) Register
 *  Fault Delay Register (FDLY) Register.
 *
 *  The SEC_CFG0 fault delay register (FDLY) contains the number (COUNT field) of (SEC) clock periods to delay from fault pending to fault active, when actions are enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FDLY_Struct
 *! \brief  Fault Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FDLY_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FDLY_t;

/*@}*/

/** @defgroup FDLY_CUR Fault Delay Current Register (FDLY_CUR) Register
 *  Fault Delay Current Register (FDLY_CUR) Register.
 *
 *  The SEC_CFG0 fault delay current register (FDLY_CUR) contains the active count (COUNT field) in (SEC) clock periods for the delay from fault pending to fault active, when actions are enabled. The count is loaded from the FDLY register when a fault becomes pending (FSTAT:PND bit is set). The SEC_CFG0 decrements the value in FDLY_CUR each (SEC) clock cycle while the FSTAT:PND bit is set.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FDLY_CUR_Struct
 *! \brief  Fault Delay Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FDLY_CUR_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FDLY_CUR_t;

/*@}*/

/** @defgroup FSRDLY Fault System Reset Delay Register (FSRDLY) Register
 *  Fault System Reset Delay Register (FSRDLY) Register.
 *
 *  The SEC_CFG0 fault system reset delay register (FSRDLY) contains the number (COUNT field) of (SEC) clock periods for the delay from a fault becoming active to system reset request assertion, if enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FSRDLY_Struct
 *! \brief  Fault System Reset Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FSRDLY_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault System Reset Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FSRDLY_t;

/*@}*/

/** @defgroup FSRDLY_CUR Fault System Reset Delay Current Register (FSRDLY_CUR) Register
 *  Fault System Reset Delay Current Register (FSRDLY_CUR) Register.
 *
 *  The SEC_CFG0 fault system reset delay current register (FSRDLY_CUR) contains the active count (COUNT field) in (SEC) clock periods for the delay from fault active to system reset assertion, if enabled. The count is loaded from the FSRDLY register when a fault becomes active (FSTAT:ACT bit is set). The SEC_CFG0 decrements the value in FSRDLY_CUR each (SEC) clock cycle while the FSTAT:ACT bit is set.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FSRDLY_CUR_Struct
 *! \brief  Fault System Reset Delay Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FSRDLY_CUR_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault System Reset Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FSRDLY_CUR_t;

/*@}*/

/** @defgroup FCOPP Fault COP Period Register (FCOPP) Register
 *  Fault COP Period Register (FCOPP) Register.
 *
 *  The SEC_CFG0 fault COP period register (FCOPP) contains the width value (count in (SEC) clock cycles) for the high and low phase of the computer operating properly (COP) toggled output on the COP pin. Note that the actual high/low phase is value is the COUNT programmed value plus 1.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FCOPP_Struct
 *! \brief  Fault COP Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FCOPP_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault COP Period */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FCOPP_t;

/*@}*/

/** @defgroup FCOPP_CUR Fault COP Period Current Register (FCOPP_CUR) Register
 *  Fault COP Period Current Register (FCOPP_CUR) Register.
 *
 *  The SEC_CFG0 fault COP period current register (FCOPP_CUR) contains the active count (in (SEC) clock periods) for the current phase (high or low) of the computer operating properly (COP) toggled output on the COP pin. The SEC_CFG0 loads the FCOPP_CUR register from the FCOPP register when the COUNT field is cleared and the SEC_CFG0 is in COP mode (FCTL:CMS bit =1). The SEC_CFG0 decrements the FCOPP_CUR count each (SEC) clock cycle while FCTL:CMS is set and the FSTAT:ACT bit is not set.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_FCOPP_CUR_Struct
 *! \brief  Fault COP Period Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_FCOPP_CUR_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault COP Period */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_FCOPP_CUR_t;

/*@}*/

/** @defgroup GCTL Global Control Register (GCTL) Register
 *  Global Control Register (GCTL) Register.
 *
 *  The SEC_CFG0 global control register (GCTL) provides register locking, reset, and enable for the SEC_CFG0 module.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GCTL_EN
 *! \brief  Enable (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GCTL_DIS = 0,  /**< Disable */
  SEC_GCTL_EN  = 1   /**< Enable  */
} ADI_SEC_CFG0_GCTL_EN;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GCTL_RESET
 *! \brief  Reset (RESET) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GCTL_NO_RESET = 0,  /**< No Action */
  SEC_GCTL_RESET    = 1   /**< Reset     */
} ADI_SEC_CFG0_GCTL_RESET;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GCTL_LOCK
 *! \brief  Lock (LOCK) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GCTL_UNLOCK = 0,  /**< Unlock */
  SEC_GCTL_LOCK   = 1   /**< Lock   */
} ADI_SEC_CFG0_GCTL_LOCK;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_GCTL_Struct
 *! \brief  Global Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_GCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int RESET      :  1;  /**< Reset */
      unsigned int reserved2  : 29;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_GCTL_t;

/*@}*/

/** @defgroup GSTAT Global Status Register (GSTAT) Register
 *  Global Status Register (GSTAT) Register.
 *
 *  The SEC_CFG0 global status register (GSTAT) contains global status bits for the SEC_CFG0.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GSTAT_ERR
 *! \brief  Error (ERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GSTAT_NO_ERR = 0,  /**< No Error       */
  SEC_GSTAT_ERR    = 1   /**< Error Occurred */
} ADI_SEC_CFG0_GSTAT_ERR;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GSTAT_ERRC
 *! \brief  Error Cause (ERRC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GSTAT_SFIERR = 0,  /**< SFI Error */
  SEC_GSTAT_SSIERR = 2   /**< SSI Error */
} ADI_SEC_CFG0_GSTAT_ERRC;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GSTAT_ADRERR
 *! \brief  Address Error (ADRERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GSTAT_NO_ADRERR = 0,  /**< No Error       */
  SEC_GSTAT_ADRERR    = 1   /**< Error Occurred */
} ADI_SEC_CFG0_GSTAT_ADRERR;


/*  =========================================================================
 *! \enum   ADI_SEC_CFG0_GSTAT_LWERR
 *! \brief  Lock Write Error (LWERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SEC_GSTAT_NO_LWERR = 0,  /**< No Error       */
  SEC_GSTAT_LWERR    = 1   /**< Error Occurred */
} ADI_SEC_CFG0_GSTAT_LWERR;


/* ==========================================================================
 *! \struct ADI_SEC_CFG0_GSTAT_Struct
 *! \brief  Global Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_GSTAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int ERR        :  1;  /**< Error */
      unsigned int reserved2  :  2;
      unsigned int ERRC       :  2;  /**< Error Cause */
      unsigned int reserved6  : 24;
      unsigned int ADRERR     :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_GSTAT_t;

/*@}*/

/** @defgroup RAISE Global Raise Register (RAISE) Register
 *  Global Raise Register (RAISE) Register.
 *
 *  The SEC_CFG0 global raise register (RAISE) contains a source ID event set-to-pending field (SID). When a source ID value is written to this field, the SEC_CFG0 raises the source's event status to pending.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG0_RAISE_Struct
 *! \brief  Global Raise Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG0_RAISE_t {
  union {
    struct {
      unsigned int SID        :  8;  /**< Source ID of event that is set to Pending status */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG0_RAISE_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register controls the watch dog timer. This register supports enabling/disabling the watch dog timer and supports checking the timer rollover status. Note that when the processor is in emulation mode, the watch dog timer counter will not decrement even if it is enabled.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_WDOG_CTL_WDRO
 *! \brief  Watch Dog Rollover (WDRO) Enumerations
 *  ========================================================================= */
typedef enum
{
  WDOG_CTL_WDTEXP = 1   /**< WDT has expired */
} ADI_WDOG_CTL_WDRO;


/* ==========================================================================
 *! \struct ADI_WDOG_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_WDOG_CTL_t {
  union {
    struct {
      unsigned int reserved0  :  4;
      unsigned int WDEN       :  8;  /**< Watch Dog Enable */
      unsigned int reserved12 :  3;
      unsigned int WDRO       :  1;  /**< Watch Dog Rollover */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_WDOG_CTL_t;

/*@}*/

/** @defgroup CNT Count Register (CNT) Register
 *  Count Register (CNT) Register.
 *
 *  The CNT register holds the programmable, unsigned count value. A valid write to this register also pre-loads the WDOG counter. For added safety, the CNT register can be updated only when the WDOG timer is disabled. A write to the CNT register while the timer is enabled does not modify the contents of this register. This register must be accessed with 32-bit read/writes only.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_WDOG_CNT_Struct
 *! \brief  Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_WDOG_CNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Count Value */
    };
    uint32_t VALUE32;
  };
} ADI_WDOG_CNT_t;

/*@}*/

/** @defgroup STAT Watchdog Timer Status Register (STAT) Register
 *  Watchdog Timer Status Register (STAT) Register.
 *
 *  The STAT contains the current count value of the watch dog timer. Reads of this register return the current count value. When the watch dog timer is enabled, STAT is decremented by 1 on each SCLK cycle. When count value reaches 0, the watch dog timer stops counting, and the expiry event is generated. STAT is a 32-bit unsigned system MMR that must be accessed with 32-bit reads and writes. 
 *  Values cannot be stored directly in STAT, but are instead copied from the CNT register. This copy process can happen in two ways:
 *  $[ul$] $[li$]While the watch dog timer is disabled, writing the CNT register pre-loads the STAT register.
 *  $[/li$] $[li$]While the watch dog timer is enabled, writing the STAT register loads it with the value in CNT.
 *  $[/li$]$[/ul$]When the processor executes a write (of an arbitrary value) to STAT, the value in CNT is copied into STAT. Typically, software sets the value of CNT at initialization, then periodically writes to STAT before the watch dog timer expires. This reloads the watch dog timer with the value from CNT and prevents generation of the expiry event.
 *  If the user does not reload the counter before SCLK*Count register cycles, an expiry event is generated, and the CTL:WDRO bit is set. When this happens, the counter will stop decrementing and will remain at zero.If the counter is enabled with a zero loaded to the counter, the CTL:WDRO bit is set immediately and the counter remains at zero and does not decrement.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_WDOG_STAT_Struct
 *! \brief  Watchdog Timer Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_WDOG_STAT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Current Count Value (Status) */
    };
    uint32_t VALUE32;
  };
} ADI_WDOG_STAT_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The RCU control register (CTL) provides a register lock, enables for the core and system reset requests inputs and control for the Reset Output pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_CTL_t {
  union {
    struct {
      unsigned int SYSRST     :  1;  /**< System Reset */
      unsigned int RSTOUTASRT :  1;  /**< Reset Out Assert */
      unsigned int RSTOUTDSRT :  1;  /**< Reset Out Deassert */
      unsigned int reserved3  :  5;
      unsigned int SRSTREQEN  :  1;  /**< System Reset Request Enabled */
      unsigned int CRSTREQEN  :  1;  /**< Core Reset Request Enabled */
      unsigned int CRSTMSKSEL :  1;  /**< Core Reset System Reset Mask Select */
      unsigned int reserved11 : 20;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_CTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The RCU status register (STAT) contains status bits for all RCU reset sources, reset status, and boot mode inputs. Status bits for reset sources are sticky and can cleared by software. Error status bits are cleared by any reset event.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_STAT_t {
  union {
    struct {
      unsigned int HWRST      :  1;  /**< Hardware Reset */
      unsigned int reserved1  :  1;
      unsigned int SSRST      :  1;  /**< System Source Reset */
      unsigned int SWRST      :  1;  /**< Software Reset */
      unsigned int reserved4  :  1;
      unsigned int RSTOUT     :  1;  /**< Reset Out Status */
      unsigned int reserved6  :  2;
      unsigned int BMODE      :  4;  /**< Boot Mode */
      unsigned int reserved12 :  4;
      unsigned int ADDRERR    :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
      unsigned int RSTOUTERR  :  1;  /**< Reset Out Error */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_RCU_STAT_t;

/*@}*/

/** @defgroup CRCTL Core Reset outputs Control Register (CRCTL) Register
 *  Core Reset outputs Control Register (CRCTL) Register.
 *
 *  The RCU core reset control n registers (CRCTL) include a lock bit (LOCK) and a core reset bit (CRn) for each core reset signal on the product. Only bits enabled by the CORE_DISABLE_MASK can be written. Bits disabled by the CORE_DISABLE_MASK are read as "1" and cannot be modified by software.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_CRCTL_Struct
 *! \brief  Core Reset outputs Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_CRCTL_t {
  union {
    struct {
      unsigned int CR0        :  1;  /**< Core Reset Outputs */
      unsigned int CR1        :  1;  /**< Core Reset Outputs */
      unsigned int CR2        :  1;  /**< Core Reset Outputs */
      unsigned int reserved3  : 28;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_CRCTL_t;

/*@}*/

/** @defgroup CRSTAT Core Reset outputs Status Register (CRSTAT) Register
 *  Core Reset outputs Status Register (CRSTAT) Register.
 *
 *  The RCU core reset status register (CRSTAT) contains status bits, indicating which core reset signals have been asserted.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_CRSTAT_Struct
 *! \brief  Core Reset outputs Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_CRSTAT_t {
  union {
    struct {
      unsigned int CR0        :  1;  /**< Core Reset Outputs */
      unsigned int CR1        :  1;  /**< Core Reset Outputs */
      unsigned int CR2        :  1;  /**< Core Reset Outputs */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_RCU_CRSTAT_t;

/*@}*/

/** @defgroup SRRQSTAT System Reset Request Status (SRRQSTAT) Register
 *  System Reset Request Status (SRRQSTAT) Register.
 *
 *  The RCU system reset request status register (SRRQSTAT) contains status bits, indicating which system reset request input triggered System Reset. This register is set to its default values by Hard Reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_SRRQSTAT_Struct
 *! \brief  System Reset Request Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_SRRQSTAT_t {
  union {
    struct {
      unsigned int SRRQ       :  8;  /**< System Reset triggered by System Reset Request [n] */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_RCU_SRRQSTAT_t;

/*@}*/

/** @defgroup SVECT_LCK SVECT Lock Register (SVECT_LCK) Register
 *  SVECT Lock Register (SVECT_LCK) Register.
 *
 *  The RCU software vector lock register (SVECT_LCK) provides a register lock and software vector n enable bits for each processor core on the product. This register is set to its default values by Hard Reset or any System Reset event.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_SVECT_LCK_Struct
 *! \brief  SVECT Lock Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_SVECT_LCK_t {
  union {
    struct {
      unsigned int SVECT0     :  1;  /**< If the global lock bit is set (GLCK bit =1) and the SVECT[n] bit is set, the RCU0_SVECTn register is read only (locked). */
      unsigned int SVECT1     :  1;  /**< If the global lock bit is set (GLCK bit =1) and the SVECT[n] bit is set, the RCU0_SVECTn register is read only (locked). */
      unsigned int reserved2  : 29;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_SVECT_LCK_t;

/*@}*/

/** @defgroup BCODE Boot Code Register (BCODE) Register
 *  Boot Code Register (BCODE) Register.
 *
 *  The BCODE register can be used to determine if and how core boots. This register is set to its default values by RESET or after hibernate.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_BCODE_Struct
 *! \brief  Boot Code Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_BCODE_t {
  union {
    struct {
      unsigned int NOKERNEL   :  1;  /**< No Boot Kernel */
      unsigned int NOVECTINIT :  1;  /**< No Vector Initialize */
      unsigned int HALT       :  1;  /**< Halt */
      unsigned int HBTOVW     :  1;  /**< Execute Wakeup */
      unsigned int NOMEMINIT  :  1;  /**< No Memory Initialization */
      unsigned int NOCACHE    :  1;  /**< No Cache */
      unsigned int NOFAULTS   :  1;  /**< No Faults */
      unsigned int reserved7  :  2;
      unsigned int NOPREBOOT  :  1;  /**< No Preboot */
      unsigned int NOHOOK     :  1;  /**< No Hook */
      unsigned int reserved11 :  1;
      unsigned int NOL2CONFIG :  1;  /**< No L2 Configuration */
      unsigned int IDLEONENTRY :  1;  /**< Idle On Entry */
      unsigned int reserved14  :  3;
      unsigned int NOCORE1     :  1;  /**< No Core 1 Present */
      unsigned int NOCORE2     :  1;  /**< No Core 2 Present */
      unsigned int NOCORE3     :  1;  /**< No Core 3 Present */
      unsigned int reserved20  : 11;
      unsigned int LOCK        :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_BCODE_t;

/*@}*/

/** @defgroup SVECT0 Software Vector Register 0 (SVECT0) Register
 *  Software Vector Register 0 (SVECT0) Register.
 *
 *  The SVECT0 register contains the default location of the first instruction to execute after a reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_SVECT0_Struct
 *! \brief  Software Vector Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_SVECT0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Reset Vector */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_SVECT0_t;

/*@}*/

/** @defgroup SVECT1 Software Vector Register 1 (SVECT1) Register
 *  Software Vector Register 1 (SVECT1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_SVECT1_Struct
 *! \brief  Software Vector Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_SVECT1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Reset Vector */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_SVECT1_t;

/*@}*/

/** @defgroup MSG Message Register (MSG) Register
 *  Message Register (MSG) Register.
 *
 *  The MSG is a general-purpose register. It is intended to provide flexibility for Boot ROM code and to pass predefined variables to the debugger. Please see the Booting chapter for product-specific details.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_MSG_Struct
 *! \brief  Message Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_MSG_t {
  union {
    struct {
      unsigned int reserved0  : 16;
      unsigned int C0L1INIT   :  1;  /**< Core 0 L1 Initialized */
      unsigned int C1L1INIT   :  1;  /**< Core 1 L1 Initialized */
      unsigned int reserved18 :  4;
      unsigned int L2INIT     :  1;  /**< L2 Initialized */
      unsigned int L3INIT     :  1;  /**< L3 Initialized */
      unsigned int HALTONAPP  :  1;  /**< Halt on Application Call */
      unsigned int HALTONINIT :  1;  /**< Halt on Initcode Call */
      unsigned int HALTONCALL :  1;  /**< Halt on Callback Call */
      unsigned int HALTONERR  :  1;  /**< Halt on Error Call */
      unsigned int CALLAPP    :  1;  /**< Call Application Flag */
      unsigned int CALLINIT   :  1;  /**< Call Initcode Flag */
      unsigned int CALLBACK   :  1;  /**< Callback Call Flag */
      unsigned int CALLERR    :  1;  /**< Call Error Flag */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_MSG_t;

/*@}*/

/** @defgroup MSG_SET Message Set Bits Register (MSG_SET) Register
 *  Message Set Bits Register (MSG_SET) Register.
 *
 *  The MSG_SET register is used to set bits in MSG register. Reading this register returns 0x00000000.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_MSG_SET_Struct
 *! \brief  Message Set Bits Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_MSG_SET_t {
  union {
    struct {
      unsigned int SET0       :  1;  /**< Set Message Bits */
      unsigned int SET1       :  1;  /**< Set Message Bits */
      unsigned int SET2       :  1;  /**< Set Message Bits */
      unsigned int SET3       :  1;  /**< Set Message Bits */
      unsigned int SET4       :  1;  /**< Set Message Bits */
      unsigned int SET5       :  1;  /**< Set Message Bits */
      unsigned int SET6       :  1;  /**< Set Message Bits */
      unsigned int SET7       :  1;  /**< Set Message Bits */
      unsigned int SET8       :  1;  /**< Set Message Bits */
      unsigned int SET9       :  1;  /**< Set Message Bits */
      unsigned int SET10      :  1;  /**< Set Message Bits */
      unsigned int SET11      :  1;  /**< Set Message Bits */
      unsigned int SET12      :  1;  /**< Set Message Bits */
      unsigned int SET13      :  1;  /**< Set Message Bits */
      unsigned int SET14      :  1;  /**< Set Message Bits */
      unsigned int SET15      :  1;  /**< Set Message Bits */
      unsigned int SET16      :  1;  /**< Set Message Bits */
      unsigned int SET17      :  1;  /**< Set Message Bits */
      unsigned int SET18      :  1;  /**< Set Message Bits */
      unsigned int SET19      :  1;  /**< Set Message Bits */
      unsigned int SET20      :  1;  /**< Set Message Bits */
      unsigned int SET21      :  1;  /**< Set Message Bits */
      unsigned int SET22      :  1;  /**< Set Message Bits */
      unsigned int SET23      :  1;  /**< Set Message Bits */
      unsigned int SET24      :  1;  /**< Set Message Bits */
      unsigned int SET25      :  1;  /**< Set Message Bits */
      unsigned int SET26      :  1;  /**< Set Message Bits */
      unsigned int SET27      :  1;  /**< Set Message Bits */
      unsigned int SET28      :  1;  /**< Set Message Bits */
      unsigned int SET29      :  1;  /**< Set Message Bits */
      unsigned int SET30      :  1;  /**< Set Message Bits */
      unsigned int SET31      :  1;  /**< Set Message Bits */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_MSG_SET_t;

/*@}*/

/** @defgroup MSG_CLR Message Clear Bits Register (MSG_CLR) Register
 *  Message Clear Bits Register (MSG_CLR) Register.
 *
 *  The MSG_CLR register is used to clear bits in MSG register. Reading this register returns 0x00000000.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_MSG_CLR_Struct
 *! \brief  Message Clear Bits Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_MSG_CLR_t {
  union {
    struct {
      unsigned int CLR0       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR1       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR2       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR3       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR4       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR5       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR6       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR7       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR8       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR9       :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR10      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR11      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR12      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR13      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR14      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR15      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR16      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR17      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR18      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR19      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR20      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR21      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR22      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR23      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR24      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR25      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR26      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR27      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR28      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR29      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR30      :  1;  /**< Clear MSG Register Bits */
      unsigned int CLR31      :  1;  /**< Clear MSG Register Bits */
    };
    uint32_t VALUE32;
  };
} ADI_RCU_MSG_CLR_t;

/*@}*/

/** @defgroup REVID Revision ID Register (REVID) Register
 *  Revision ID Register (REVID) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_RCU_REVID_Struct
 *! \brief  Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_RCU_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Incremental Version ID */
      unsigned int MAJOR      :  4;  /**< Major Version ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_RCU_REVID_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register controls sleep modes selections and PLL operations of the DPM. A write protect feature permits locking out changes to this register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_CTL_t {
  union {
    struct {
      unsigned int reserved0  :  3;
      unsigned int DEEPSLEEP  :  1;  /**< Deep Sleep */
      unsigned int reserved4  : 27;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_DPM_CTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_STAT_t {
  union {
    struct {
      unsigned int CURMODE    :  4;  /**< Current Mode */
      unsigned int PRVMODE    :  4;  /**< Previous Mode */
      unsigned int reserved8  :  1;
      unsigned int HVBSY      :  1;  /**< HV Busy */
      unsigned int reserved10 :  6;
      unsigned int ADDRERR    :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
      unsigned int HVBSYERR   :  1;  /**< HV Busy Error */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_DPM_STAT_t;

/*@}*/

/** @defgroup WAKE_EN Wakeup Enable Register (WAKE_EN) Register
 *  Wakeup Enable Register (WAKE_EN) Register.
 *
 *  The WAKE_EN register enables the wakeup event sources for exiting deep sleep mode. The number of wakeup sources varies with the processor design, with bit 0 corresponding to wakeup source 0, bit 1 corresponding to wakeup source 1, and so on. This register includes a write protection lock. For information about wakeup source assignments, see the DPM Wakeup Sources topic.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_WAKE_EN_Struct
 *! \brief  Wakeup Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_WAKE_EN_t {
  union {
    struct {
      unsigned int WS0        :  1;  /**< Wakeup Source n Enable */
      unsigned int WS1        :  1;  /**< Wakeup Source n Enable */
      unsigned int WS2        :  1;  /**< Wakeup Source n Enable */
      unsigned int WS3        :  1;  /**< Wakeup Source n Enable */
      unsigned int WS4        :  1;  /**< Wakeup Source n Enable */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_DPM_WAKE_EN_t;

/*@}*/

/** @defgroup WAKE_POL Wakeup Polarity Register (WAKE_POL) Register
 *  Wakeup Polarity Register (WAKE_POL) Register.
 *
 *  The WAKE_POL register select polarity (active high or low) of the wakeup event sources for exiting deep sleep mode. The number of wakeup sources varies with the processor design, with bit 0 corresponding to wakeup source 0, bit 1 corresponding to wakeup source 1, and so on. This register includes a write protection lock. For information about wakeup source assignments, see the DPM Wakeup Sources topic.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_WAKE_POL_Struct
 *! \brief  Wakeup Polarity Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_WAKE_POL_t {
  union {
    struct {
      unsigned int WS0        :  1;  /**< Wakeup Source n Polarity */
      unsigned int WS1        :  1;  /**< Wakeup Source n Polarity */
      unsigned int WS2        :  1;  /**< Wakeup Source n Polarity */
      unsigned int WS3        :  1;  /**< Wakeup Source n Polarity */
      unsigned int WS4        :  1;  /**< Wakeup Source n Polarity */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_DPM_WAKE_POL_t;

/*@}*/

/** @defgroup WAKE_STAT Wakeup Status Register (WAKE_STAT) Register
 *  Wakeup Status Register (WAKE_STAT) Register.
 *
 *  The WAKE_STAT register indicates the enabled and active status of the wakeup event sources for exiting deep sleep mode. The number of wakeup sources varies with the processor design, with bit 0 corresponding to wakeup source 0, bit 1 corresponding to wakeup source 1, and so on. For information about wakeup source assignments, see the DPM Wakeup Sources topic.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_WAKE_STAT_Struct
 *! \brief  Wakeup Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_WAKE_STAT_t {
  union {
    struct {
      unsigned int WS0        :  1;  /**< Wakeup Source n Status */
      unsigned int WS1        :  1;  /**< Wakeup Source n Status */
      unsigned int WS2        :  1;  /**< Wakeup Source n Status */
      unsigned int WS3        :  1;  /**< Wakeup Source n Status */
      unsigned int WS4        :  1;  /**< Wakeup Source n Status */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_DPM_WAKE_STAT_t;

/*@}*/

/** @defgroup PER_DIS0 Peripherals Disable Register 0 (PER_DIS0) Register
 *  Peripherals Disable Register 0 (PER_DIS0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_PER_DIS0_Struct
 *! \brief  Peripherals Disable Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_PER_DIS0_t {
  union {
    struct {
      unsigned int VALUE      :  1;  /**< Peripheral Disable */
      unsigned int reserved1  : 30;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_DPM_PER_DIS0_t;

/*@}*/

/** @defgroup REVID Revision ID (REVID) Register
 *  Revision ID (REVID) Register.
 *
 *  The REVID register provides the revision of the DPM module.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DPM_REVID_Struct
 *! \brief  Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DPM_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Incremental Version ID */
      unsigned int MAJOR      :  4;  /**< Major Version ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_DPM_REVID_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL controls the clock generation divisors for SYS_CLKIN and the PLL. Read after write accesses to the CTL register returns the new value even if the clock's frequency change is still in progress.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_CTL_t {
  union {
    struct {
      unsigned int DF         :  1;  /**< Divide Frequency */
      unsigned int reserved1  :  7;
      unsigned int MSEL       :  7;  /**< Multiplier Select */
      unsigned int reserved15 : 15;
      unsigned int WFI        :  1;  /**< Wait For Idle */
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_CTL_t;

/*@}*/

/** @defgroup PLLCTL PLL Control Register (PLLCTL) Register
 *  PLL Control Register (PLLCTL) Register.
 *
 *  The PLLCTL register contains bits that enable and disable the PLL as well as control its function.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_PLLCTL_Struct
 *! \brief  PLL Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_PLLCTL_t {
  union {
    struct {
      unsigned int PLLBPST    :  1;  /**< PLL Bypass Set */
      unsigned int PLLBPCL    :  1;  /**< PLL Bypass Clear */
      unsigned int PLLDIS     :  1;  /**< PLL Disable */
      unsigned int PLLEN      :  1;  /**< PLL Enable */
      unsigned int reserved4  : 27;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_PLLCTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register reflects the PLL status and errors detected during the PLL configuration. This register may be cleared asynchronously by a reset signal from the RCU module. All bits---except those defined as W1C (write-1-to-clear)---are read only.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_STAT_t {
  union {
    struct {
      unsigned int PLLEN      :  1;  /**< PLL Enable */
      unsigned int PLLBP      :  1;  /**< PLL Bypass */
      unsigned int PLOCK      :  1;  /**< PLL Lock */
      unsigned int CLKSALGN   :  1;  /**< Clock Alignment */
      unsigned int reserved4  : 12;
      unsigned int ADDRERR    :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
      unsigned int reserved18 :  1;
      unsigned int WDFMSERR   :  1;  /**< Write to DF or MSEL Error */
      unsigned int WDIVERR    :  1;  /**< Write to DIV Error */
      unsigned int PCFGERR    :  1;  /**< PLL Configuration Error */
      unsigned int reserved22 : 10;
    };
    uint32_t VALUE32;
  };
} ADI_CGU_STAT_t;

/*@}*/

/** @defgroup DIV Clocks Divisor Register (DIV) Register
 *  Clocks Divisor Register (DIV) Register.
 *
 *  The DIV register controls clock divisors for core clocks, system clocks, external (off core) memory clocks, and output clock. Read after write accesses to the DIV register returns the new value even if the clock's frequency change is still in progress.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_DIV_Struct
 *! \brief  Clocks Divisor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_DIV_t {
  union {
    struct {
      unsigned int CSEL       :  5;  /**< CCLK Divisor */
      unsigned int S0SEL      :  3;  /**< SCLK 0 Divisor */
      unsigned int SYSSEL     :  5;  /**< SYSCLK Divisor */
      unsigned int S1SEL      :  3;  /**< Short Clocks Alignment Time */
      unsigned int DSEL       :  5;  /**< DCLK Divisor */
      unsigned int reserved21 :  1;
      unsigned int OSEL       :  7;  /**< OUTCLK Divisor */
      unsigned int ALGN       :  1;  /**< Align */
      unsigned int UPDT       :  1;  /**< Update Clock Divisors */
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_DIV_t;

/*@}*/

/** @defgroup CLKOUTSEL CLKOUT Select Register (CLKOUTSEL) Register
 *  CLKOUT Select Register (CLKOUTSEL) Register.
 *
 *  The CLKOUTSEL selects the signal that the CGU drives through the CLKOUT multiplexer. Also, this register selects the divisor for the USBCLK output.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_CLKOUTSEL_Struct
 *! \brief  CLKOUT Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_CLKOUTSEL_t {
  union {
    struct {
      unsigned int CLKOUTSEL  :  5;  /**< CLKOUT Select */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_CLKOUTSEL_t;

/*@}*/

/** @defgroup OSCWDCTL Oscillator Watchdog Register (OSCWDCTL) Register
 *  Oscillator Watchdog Register (OSCWDCTL) Register.
 *
 *  The OSCWDCTL register configures the CGU to allow the detection of the absence of input clock transitions and provides a fault warning via the SYS_FAULT pin. The OSCWDCTL register also detects and reports input oscillator frequencies above and below specified limits, in order to specifically detect harmonic or sub-harmonic crystal oscillator behavior. This detection is achieved by using an internal asynchronous, local 1 MHz oscillator combined with a series of programmable counters.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_OSCWDCTL_Struct
 *! \brief  Oscillator Watchdog Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_OSCWDCTL_t {
  union {
    struct {
      unsigned int HODF       :  6;  /**< Watchdog lower frequency limit */
      unsigned int HODEN      :  1;  /**< Harmonic Oscillation Detection enabled */
      unsigned int CNGEN      :  1;  /**< Clock not Good enabled */
      unsigned int BOUF       :  5;  /**< Bad Oscillator Upper Frequency limit */
      unsigned int BOUEN      :  1;  /**< Bad Oscillator Upper Frequency limit detection enabled */
      unsigned int FAULTEN    :  1;  /**< Fault enabled */
      unsigned int MONDIS     :  1;  /**< Oscillator Watchdog Monitor functions disabled */
      unsigned int reserved16  :  7;
      unsigned int FAULTPINDIS :  1;  /**< Fault Pin disabled */
      unsigned int reserved24  :  7;
      unsigned int LOCK        :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_OSCWDCTL_t;

/*@}*/

/** @defgroup TSCTL Timestamp Control Register (TSCTL) Register
 *  Timestamp Control Register (TSCTL) Register.
 *
 *  The TSCTL register controls the operation of the CoreSight Timestamp counter.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_TSCTL_Struct
 *! \brief  Timestamp Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_TSCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Counter Enable */
      unsigned int LOAD       :  1;  /**< Load Counter */
      unsigned int reserved2  :  2;
      unsigned int TSDIV      :  4;  /**< Counter's Clock Divider */
      unsigned int reserved8  : 23;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_TSCTL_t;

/*@}*/

/** @defgroup TSVALUE0 Timestamp Counter Initial 32 LSB Value Register (TSVALUE0) Register
 *  Timestamp Counter Initial 32 LSB Value Register (TSVALUE0) Register.
 *
 *  The TSVALUE0 register holds the least significant bits (bits [31:0]) value that is initially loaded to the CoreSight timestamp counter.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_TSVALUE0_Struct
 *! \brief  Timestamp Counter Initial 32 LSB Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_TSVALUE0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< TSVALUE0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_TSVALUE0_t;

/*@}*/

/** @defgroup TSVALUE1 Timestamp Counter Initial MSB Value Register (TSVALUE1) Register
 *  Timestamp Counter Initial MSB Value Register (TSVALUE1) Register.
 *
 *  The TSVALUE1 register holds the most significant bits (bits [63:32]) value that is initially loaded to the CoreSight timestamp counter.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_TSVALUE1_Struct
 *! \brief  Timestamp Counter Initial MSB Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_TSVALUE1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Counter's Initial 32 MSB Value */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_TSVALUE1_t;

/*@}*/

/** @defgroup TSCOUNT0 Time Stamp Counter 32 LSB Register (TSCOUNT0) Register
 *  Time Stamp Counter 32 LSB Register (TSCOUNT0) Register.
 *
 *  The TSCOUNT0 register address is used to read the CoreSight Timestamp counter LSB 32-bit (bits [31:0]) value.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_TSCOUNT0_Struct
 *! \brief  Time Stamp Counter 32 LSB Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_TSCOUNT0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< TSCOUNT0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_TSCOUNT0_t;

/*@}*/

/** @defgroup TSCOUNT1 Time Stamp Counter 32 MSB Register (TSCOUNT1) Register
 *  Time Stamp Counter 32 MSB Register (TSCOUNT1) Register.
 *
 *  The TSCOUNT1 register address is used to read the CoreSight Timestamp counter MSB 32-bit (bits [63:32]) value.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_TSCOUNT1_Struct
 *! \brief  Time Stamp Counter 32 MSB Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_TSCOUNT1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Timestamp Counter 32 MSB */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_TSCOUNT1_t;

/*@}*/

/** @defgroup CCBF_DIS Core Clock Buffer Disable Register (CCBF_DIS) Register
 *  Core Clock Buffer Disable Register (CCBF_DIS) Register.
 *
 *  The CCBF_DIS register controls each core's clock buffer to determine if the CCLK is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_CCBF_DIS_Struct
 *! \brief  Core Clock Buffer Disable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_CCBF_DIS_t {
  union {
    struct {
      unsigned int CCBF0      :  1;  /**< Core Clock Buffer 0 */
      unsigned int reserved1  : 30;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_CCBF_DIS_t;

/*@}*/

/** @defgroup CCBF_STAT Core Clock Buffer Status Register (CCBF_STAT) Register
 *  Core Clock Buffer Status Register (CCBF_STAT) Register.
 *
 *  The CCBF_STAT register shows which core clock buffer(s) are disabled. For example clearing the CCBF_DIS:CCBF0 bit clears the CCBF0 bit after a number of cycles. To guarantee that the correct value is read, this register should be read twice and the second result used.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_CCBF_STAT_Struct
 *! \brief  Core Clock Buffer Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_CCBF_STAT_t {
  union {
    struct {
      unsigned int CCBF0      :  1;  /**< Core Clock Buffer 0 */
      unsigned int reserved1  : 31;
    };
    uint32_t VALUE32;
  };
} ADI_CGU_CCBF_STAT_t;

/*@}*/

/** @defgroup SCBF_DIS System Clock Buffer Disable Register (SCBF_DIS) Register
 *  System Clock Buffer Disable Register (SCBF_DIS) Register.
 *
 *  The SCBF_DIS register controls each system's clock buffer to determine if the SCLK buffer is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_SCBF_DIS_Struct
 *! \brief  System Clock Buffer Disable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_SCBF_DIS_t {
  union {
    struct {
      unsigned int SCLK0BF    :  1;  /**< System Clock 0 Buffer */
      unsigned int reserved1  :  1;
      unsigned int DCLKBF     :  1;  /**< DCLK Buffer */
      unsigned int OUTCLKBF   :  1;  /**< Output Clock Buffer */
      unsigned int reserved4  : 27;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_CGU_SCBF_DIS_t;

/*@}*/

/** @defgroup SCBF_STAT System Clock Buffer Status Register (SCBF_STAT) Register
 *  System Clock Buffer Status Register (SCBF_STAT) Register.
 *
 *  The SCBF_STAT register shows which system clock buffer(s) are disabled. For example clearing the CCBF_DIS:CCBF0 bit clears the SCLK0BF bit after a number of cycles. To guarantee that the correct value is read, this register should be read twice and the second result used.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_SCBF_STAT_Struct
 *! \brief  System Clock Buffer Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_SCBF_STAT_t {
  union {
    struct {
      unsigned int SCLK0BF    :  1;  /**< System Clock 0 Buffer */
      unsigned int reserved1  :  1;
      unsigned int DCLKBF     :  1;  /**< DClock 1 Buffer */
      unsigned int OCLKBF     :  1;  /**< Output Clock 1 Buffer */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_CGU_SCBF_STAT_t;

/*@}*/

/** @defgroup REVID Revision ID Register (REVID) Register
 *  Revision ID Register (REVID) Register.
 *
 *  The REVID register reports the version of the CGU.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CGU_REVID_Struct
 *! \brief  Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CGU_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Incremental Version ID */
      unsigned int MAJOR      :  4;  /**< Major Version */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CGU_REVID_t;

/*@}*/

/** @defgroup CTL Control register (CTL) Register
 *  Control register (CTL) Register.
 *
 *  OCU control register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CTL_t {
  union {
    struct {
      unsigned int MEASURE    :  1;  /**< Start a freq. measurement cycle */
      unsigned int AUTO_EN    :  1;  /**< Enable continous freq. monitoring */
      unsigned int FREQ_FAULT_EN :  1;  /**< Freq. fault enable */
      unsigned int CMON_FAULT_EN :  1;  /**< Clkin monitor fault status enable */
      unsigned int LMON_FAULT_EN :  1;  /**< LFO monitor fault enable */
      unsigned int DEAD_CLOCK_EN :  1;  /**< Asynchronous fault output enable */
      unsigned int LFO_OSC_DIS   :  1;  /**< Disable the external LFO oscillator */
      unsigned int reserved7     : 23;
      unsigned int TEST          :  1;  /**< Enable OCU Functional Test Mode */
      unsigned int LOCK          :  1;  /**< Enable LOCK function */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CTL_t;

/*@}*/

/** @defgroup STAT Status register (STAT) Register
 *  Status register (STAT) Register.
 *
 *  OCU status register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_STAT_t {
  union {
    struct {
      unsigned int FREQ_FAULT :  1;  /**< Freq. fault status */
      unsigned int LMON_FAULT :  1;  /**< LFO monitor fault status */
      unsigned int CMON_FAULT :  1;  /**< Clkin monitor fault status */
      unsigned int OVERFLOW   :  1;  /**< Freq. measurement overflow status */
      unsigned int BUSY       :  1;  /**< Freq. measurement in progress */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_STAT_t;

/*@}*/

/** @defgroup CLKCNT Freq. measured count register (CLKCNT) Register
 *  Freq. measured count register (CLKCNT) Register.
 *
 *  Contains clock count after count sequence has completed.   The input clock counter is an up counter which starts at zero.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CLKCNT_Struct
 *! \brief  Freq. measured count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CLKCNT_t {
  union {
    struct {
      unsigned int CLK_COUNT  : 32;  /**< Input clock counter value. */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CLKCNT_t;

/*@}*/

/** @defgroup REFCNT Freq measurement reference count register (REFCNT) Register
 *  Freq measurement reference count register (REFCNT) Register.
 *
 *  Specifies the number of LFO clock periods in a input clock measurement cycle
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_REFCNT_Struct
 *! \brief  Freq measurement reference count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_REFCNT_t {
  union {
    struct {
      unsigned int REF_COUNT  : 32;  /**< Freq. measurement reference count */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_REFCNT_t;

/*@}*/

/** @defgroup MINCNT Min. limit register (MINCNT) Register
 *  Min. limit register (MINCNT) Register.
 *
 *  Contains software supplied lower count limit.  If OCU_CLKCNT register is less than this value, an out of bounds signal is generated.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_MINCNT_Struct
 *! \brief  Min. limit Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_MINCNT_t {
  union {
    struct {
      unsigned int MIN_COUNT  : 32;  /**< Freq. measure LOW limit */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_MINCNT_t;

/*@}*/

/** @defgroup MAXCNT Max. limit register (MAXCNT) Register
 *  Max. limit register (MAXCNT) Register.
 *
 *  Contains software supplied upper count limit.  If OCU_CLKCNT register is more than this value, an out of bounds signal is generated.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_MAXCNT_Struct
 *! \brief  Max. limit Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_MAXCNT_t {
  union {
    struct {
      unsigned int MAX_COUNT  : 32;  /**< Freq. measure HIGH limit */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_MAXCNT_t;

/*@}*/

/** @defgroup LMONCNT LFO monitor reference count (LMONCNT) Register
 *  LFO monitor reference count (LMONCNT) Register.
 *
 *  Specifies the number of system clock periods in the LFO "dead clock" handshake delay.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_LMONCNT_Struct
 *! \brief  LFO monitor reference count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_LMONCNT_t {
  union {
    struct {
      unsigned int LMON_COUNT : 32;  /**< LFO monitor count */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_LMONCNT_t;

/*@}*/

/** @defgroup CMONCNT Clkin monitor reference count (CMONCNT) Register
 *  Clkin monitor reference count (CMONCNT) Register.
 *
 *  Specifies the number of LFO periods in the input "dead clock" handshake delay.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CMONCNT_Struct
 *! \brief  Clkin monitor reference count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CMONCNT_t {
  union {
    struct {
      unsigned int CMON_COUNT : 32;  /**< Clkin monitor count */
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CMONCNT_t;

/*@}*/

/** @defgroup PID4 Peripheral ID4Register (PID4) Register
 *  Peripheral ID4Register (PID4) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID4_Struct
 *! \brief  Peripheral ID4 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID4_t {
  union {
    struct {
      unsigned int JEOP106CC  :  4;  /**< JEOP106 continuation code (number of leading 0x7Fs) */
      unsigned int SIZE       :  4;  /**< Number of 4K Blocks */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID4_t;

/*@}*/

/** @defgroup PID5 Peripheral ID5Register (PID5) Register
 *  Peripheral ID5Register (PID5) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID5_Struct
 *! \brief  Peripheral ID5 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID5_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For Future Use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID5_t;

/*@}*/

/** @defgroup PID6 Peripheral ID6Register (PID6) Register
 *  Peripheral ID6Register (PID6) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID6_Struct
 *! \brief  Peripheral ID6 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID6_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For Future Use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID6_t;

/*@}*/

/** @defgroup PID7 Peripheral ID7Register (PID7) Register
 *  Peripheral ID7Register (PID7) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID7_Struct
 *! \brief  Peripheral ID7 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID7_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For Future Use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID7_t;

/*@}*/

/** @defgroup PID0 Peripheral ID0Register (PID0) Register
 *  Peripheral ID0Register (PID0) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID0_Struct
 *! \brief  Peripheral ID0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID0_t {
  union {
    struct {
      unsigned int PARTNUM    :  8;  /**< PARTNUM[7:0] Part Number */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID0_t;

/*@}*/

/** @defgroup PID1 Peripheral ID1Register (PID1) Register
 *  Peripheral ID1Register (PID1) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID1_Struct
 *! \brief  Peripheral ID1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID1_t {
  union {
    struct {
      unsigned int PARTNUM    :  4;  /**< PARTNUM[11:8] Part Number */
      unsigned int JEP106     :  4;  /**< JEP106[3:0] JEDEC JEP106 Maufacturer ID code */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID1_t;

/*@}*/

/** @defgroup PID2 Peripheral ID3Register (PID2) Register
 *  Peripheral ID3Register (PID2) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID2_Struct
 *! \brief  Peripheral ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID2_t {
  union {
    struct {
      unsigned int JEP106     :  3;  /**< JEP106[6:4] JEDEC JEP106 Maufacturer ID code */
      unsigned int JEDECASGN  :  1;  /**< A JEDEC Assigned Value is Used */
      unsigned int REV        :  4;  /**< Peripheral Revision */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID2_t;

/*@}*/

/** @defgroup PID3 Peripheral ID3Register (PID3) Register
 *  Peripheral ID3Register (PID3) Register.
 *
 *  Holds peripheral identification information
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_PID3_Struct
 *! \brief  Peripheral ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_PID3_t {
  union {
    struct {
      unsigned int CUSTMOD    :  4;  /**< Customer Modified */
      unsigned int REVAND     :  4;  /**< Field to mark metal fix revision */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_PID3_t;

/*@}*/

/** @defgroup CID0 Component ID0 Register (CID0) Register
 *  Component ID0 Register (CID0) Register.
 *
 *  Holds sections of the CoreSight Component ID for OCU
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CID0_Struct
 *! \brief  Component ID0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CID0_t {
  union {
    struct {
      unsigned int COMPID     :  8;  /**< COMPID[7:0] Component ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CID0_t;

/*@}*/

/** @defgroup CID1 Component ID1 Register (CID1) Register
 *  Component ID1 Register (CID1) Register.
 *
 *  Holds sections of the CoreSight Component ID for OCU
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CID1_Struct
 *! \brief  Component ID1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CID1_t {
  union {
    struct {
      unsigned int COMPID     :  8;  /**< COMPID[15:8] Component ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CID1_t;

/*@}*/

/** @defgroup CID2 Component ID2 Register (CID2) Register
 *  Component ID2 Register (CID2) Register.
 *
 *  Holds sections of the CoreSight Component ID for OCU
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CID2_Struct
 *! \brief  Component ID2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CID2_t {
  union {
    struct {
      unsigned int COMPID     :  8;  /**< COMPID[23:16] Component ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CID2_t;

/*@}*/

/** @defgroup CID3 Component ID3 Register (CID3) Register
 *  Component ID3 Register (CID3) Register.
 *
 *  Holds sections of the CoreSight Component ID for OCU
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_OCU_CID3_Struct
 *! \brief  Component ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_OCU_CID3_t {
  union {
    struct {
      unsigned int COMPID     :  8;  /**< COMPID[31:24] Component ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_OCU_CID3_t;

/*@}*/

/** @defgroup IDCODE IDCODE Register (IDCODE) Register
 *  IDCODE Register (IDCODE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_IDCODE_Struct
 *! \brief  IDCODE Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_IDCODE_t {
  union {
    struct {
      unsigned int LSB        :  1;  /**< IDCODE LSB */
      unsigned int MNFID      : 11;  /**< Manufacturer ID */
      unsigned int JTAGID     : 16;  /**< JTAG ID */
      unsigned int REVID      :  4;  /**< Revision ID */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_IDCODE_t;

/*@}*/

/** @defgroup USERCODE USERCODE Register (USERCODE) Register
 *  USERCODE Register (USERCODE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_USERCODE_Struct
 *! \brief  USERCODE Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_USERCODE_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< USERCODE[31:0] */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_USERCODE_t;

/*@}*/

/** @defgroup SDBGKEY_CTL Secure Debug Key Control Register (SDBGKEY_CTL) Register
 *  Secure Debug Key Control Register (SDBGKEY_CTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEY_CTL_Struct
 *! \brief  Secure Debug Key Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEY_CTL_t {
  union {
    struct {
      unsigned int VALID      :  1;  /**< SDBGKEY Valid bit */
      unsigned int reserved1  : 31;
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEY_CTL_t;

/*@}*/

/** @defgroup SDBGKEY_STAT Secure Debug Key Status Register (SDBGKEY_STAT) Register
 *  Secure Debug Key Status Register (SDBGKEY_STAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEY_STAT_Struct
 *! \brief  Secure Debug Key Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEY_STAT_t {
  union {
    struct {
      unsigned int PASS       :  1;  /**< SDBGKEY MATCH PASSED */
      unsigned int FAIL       :  1;  /**< SDBGKEY MATCH FAILED */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEY_STAT_t;

/*@}*/

/** @defgroup SDBGKEY0 Secure Debug Key 0 Register (SDBGKEY0) Register
 *  Secure Debug Key 0 Register (SDBGKEY0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEY0_Struct
 *! \brief  Secure Debug Key 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEY0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< VALUE[31:0] SDBGKEY */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEY0_t;

/*@}*/

/** @defgroup SDBGKEY1 Secure Debug Key 1 Register (SDBGKEY1) Register
 *  Secure Debug Key 1 Register (SDBGKEY1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEY1_Struct
 *! \brief  Secure Debug Key 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEY1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< VALUE[63:32] SDBGKEY */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEY1_t;

/*@}*/

/** @defgroup SDBGKEY2 Secure Debug Key 2 Register (SDBGKEY2) Register
 *  Secure Debug Key 2 Register (SDBGKEY2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEY2_Struct
 *! \brief  Secure Debug Key 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEY2_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< VALUE[95:64] SDBGKEY */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEY2_t;

/*@}*/

/** @defgroup SDBGKEY3 Secure Debug Key 3 Register (SDBGKEY3) Register
 *  Secure Debug Key 3 Register (SDBGKEY3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEY3_Struct
 *! \brief  Secure Debug Key 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEY3_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< VALUE[127:96] SDBGKEY */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEY3_t;

/*@}*/

/** @defgroup TESTKEY0 TESTKEY Value Register (TESTKEY0) Register
 *  TESTKEY Value Register (TESTKEY0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_TESTKEY0_Struct
 *! \brief  TESTKEY Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_TESTKEY0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Key Value */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_TESTKEY0_t;

/*@}*/

/** @defgroup DBGCTL Debug Control (DBGCTL) Register
 *  Debug Control (DBGCTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_DBGCTL_Struct
 *! \brief  Debug Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_DBGCTL_t {
  union {
    struct {
      unsigned int reserved0  :  2;
      unsigned int SPIDENDAP  :  1;  /**< SPIDEN for DAP */
      unsigned int reserved3  :  1;
      unsigned int DBGENC0    :  1;  /**< DBGEN for Core 0 */
      unsigned int reserved5  :  3;
      unsigned int DBGENSTM   :  1;  /**< DBGEN for STM */
      unsigned int NIDENSTM   :  1;  /**< NIDEN for STM */
      unsigned int SPNIDENSTM :  1;  /**< SPNIDEN for STM */
      unsigned int SPIDENSTM  :  1;  /**< SPIDEN for STM */
      unsigned int DBGENCTISYS :  1;  /**< DBGEN for CTISYS */
      unsigned int NIDENCTISYS :  1;  /**< NIDEN for CTISYS */
      unsigned int reserved14  :  2;
      unsigned int DBGENTRACE  :  1;  /**< DBGEN for trace blocks */
      unsigned int NIDENTRACE  :  1;  /**< NIDEN for trace blocks */
      unsigned int SPIDENTRACE :  1;  /**< SPIDEN for ETR */
      unsigned int reserved19  : 13;
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_DBGCTL_t;

/*@}*/

/** @defgroup DBGSTAT Debug Status Register (DBGSTAT) Register
 *  Debug Status Register (DBGSTAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_DBGSTAT_Struct
 *! \brief  Debug Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_DBGSTAT_t {
  union {
    struct {
      unsigned int SRSTSTAT   :  1;  /**< Set is swk block initiated a hwrst */
      unsigned int IDRDSTAT   :  1;  /**< Set if JTAG tap controller did a capture of the IDCODE register */
      unsigned int RCCTERR    :  1;  /**< JTAG connection has multiple active messages to system domain */
      unsigned int RCCSERR    :  1;  /**< Serial wire connection had multiple active messages to system domain. */
      unsigned int RCWRERR    :  1;  /**< RCMSG register had multiple updates requested on same system cycle */
      unsigned int SDKEYERR   :  1;  /**< Concurrent transfers to tclk domain */
      unsigned int TRSTDET    :  1;  /**< tapc has had a valid reset applied, is in known state */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_DBGSTAT_t;

/*@}*/

/** @defgroup SDBGKEYCMP0 Secure Debug Key 0 key compare register (SDBGKEYCMP0) Register
 *  Secure Debug Key 0 key compare register (SDBGKEYCMP0) Register.
 *
 *  User Comparison Key word 0. Entered by user to unlock the part, if successful match to SDBGKEYn.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYCMP0_Struct
 *! \brief  Secure Debug Key 0 key compare Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYCMP0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< SDBGKEYCMP word 0 */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYCMP0_t;

/*@}*/

/** @defgroup SDBGKEYCMP1 Secure Debug Key 1 key compare register (SDBGKEYCMP1) Register
 *  Secure Debug Key 1 key compare register (SDBGKEYCMP1) Register.
 *
 *  User Comparison Key word 0. Entered by user to unlock the part, if successful match to SDBGKEYn.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYCMP1_Struct
 *! \brief  Secure Debug Key 1 key compare Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYCMP1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< SDBGKEYCMP word 1 */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYCMP1_t;

/*@}*/

/** @defgroup SDBGKEYCMP2 Secure Debug Key 2 key compare register (SDBGKEYCMP2) Register
 *  Secure Debug Key 2 key compare register (SDBGKEYCMP2) Register.
 *
 *  User Comparison Key word 0. Entered by user to unlock the part, if successful match to SDBGKEYn.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYCMP2_Struct
 *! \brief  Secure Debug Key 2 key compare Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYCMP2_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< SDBGKEYCMP word 2 */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYCMP2_t;

/*@}*/

/** @defgroup SDBGKEYCMP3 Secure Debug Key 3 key compare register (SDBGKEYCMP3) Register
 *  Secure Debug Key 3 key compare register (SDBGKEYCMP3) Register.
 *
 *  User Comparison Key word 0. Entered by user to unlock the part, if successful match to SDBGKEYn.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYCMP3_Struct
 *! \brief  Secure Debug Key 3 key compare Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYCMP3_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< SDBGKEYCMP word 3 */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYCMP3_t;

/*@}*/

/** @defgroup SDBGKEYID0 Secure Debug Key 0 key identification register (SDBGKEYID0) Register
 *  Secure Debug Key 0 key identification register (SDBGKEYID0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYID0_Struct
 *! \brief  Secure Debug Key 0 key identification Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYID0_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Part Specific User Key Identification Code */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYID0_t;

/*@}*/

/** @defgroup SDBGKEYID1 Secure Debug Key 1 key identification register (SDBGKEYID1) Register
 *  Secure Debug Key 1 key identification register (SDBGKEYID1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYID1_Struct
 *! \brief  Secure Debug Key 1 key identification Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYID1_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Part Specific User Key Identification Code */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYID1_t;

/*@}*/

/** @defgroup SDBGKEYID2 Secure Debug Key 2 key identification register (SDBGKEYID2) Register
 *  Secure Debug Key 2 key identification register (SDBGKEYID2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYID2_Struct
 *! \brief  Secure Debug Key 2 key identification Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYID2_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Part Specific User Key Identification Code */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYID2_t;

/*@}*/

/** @defgroup SDBGKEYID3 Secure Debug Key 3 key identification register (SDBGKEYID3) Register
 *  Secure Debug Key 3 key identification register (SDBGKEYID3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SDBGKEYID3_Struct
 *! \brief  Secure Debug Key 3 key identification Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SDBGKEYID3_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Part Specific User Key Identification Code */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SDBGKEYID3_t;

/*@}*/

/** @defgroup SCMSG Secure Run Control Message register (SCMSG) Register
 *  Secure Run Control Message register (SCMSG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SCMSG_Struct
 *! \brief  Secure Run Control Message Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SCMSG_t {
  union {
    struct {
      unsigned int VALUE0     :  1;  /**< SC Message bits */
      unsigned int VALUE1     :  1;  /**< SC Message bits */
      unsigned int VALUE2     :  1;  /**< SC Message bits */
      unsigned int VALUE3     :  1;  /**< SC Message bits */
      unsigned int VALUE4     :  1;  /**< SC Message bits */
      unsigned int VALUE5     :  1;  /**< SC Message bits */
      unsigned int VALUE6     :  1;  /**< SC Message bits */
      unsigned int VALUE7     :  1;  /**< SC Message bits */
      unsigned int VALUE8     :  1;  /**< SC Message bits */
      unsigned int VALUE9     :  1;  /**< SC Message bits */
      unsigned int VALUE10    :  1;  /**< SC Message bits */
      unsigned int VALUE11    :  1;  /**< SC Message bits */
      unsigned int VALUE12    :  1;  /**< SC Message bits */
      unsigned int VALUE13    :  1;  /**< SC Message bits */
      unsigned int VALUE14    :  1;  /**< SC Message bits */
      unsigned int VALUE15    :  1;  /**< SC Message bits */
      unsigned int VALUE16    :  1;  /**< SC Message bits */
      unsigned int VALUE17    :  1;  /**< SC Message bits */
      unsigned int VALUE18    :  1;  /**< SC Message bits */
      unsigned int VALUE19    :  1;  /**< SC Message bits */
      unsigned int VALUE20    :  1;  /**< SC Message bits */
      unsigned int VALUE21    :  1;  /**< SC Message bits */
      unsigned int VALUE22    :  1;  /**< SC Message bits */
      unsigned int VALUE23    :  1;  /**< SC Message bits */
      unsigned int VALUE24    :  1;  /**< SC Message bits */
      unsigned int VALUE25    :  1;  /**< SC Message bits */
      unsigned int VALUE26    :  1;  /**< SC Message bits */
      unsigned int VALUE27    :  1;  /**< SC Message bits */
      unsigned int VALUE28    :  1;  /**< SC Message bits */
      unsigned int VALUE29    :  1;  /**< SC Message bits */
      unsigned int VALUE30    :  1;  /**< SC Message bits */
      unsigned int VALUE31    :  1;  /**< SC Message bits */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SCMSG_t;

/*@}*/

/** @defgroup SCMSG_SET Secure Run Control Message Set register (SCMSG_SET) Register
 *  Secure Run Control Message Set register (SCMSG_SET) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SCMSG_SET_Struct
 *! \brief  Secure Run Control Message Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SCMSG_SET_t {
  union {
    struct {
      unsigned int VALUE0     :  1;  /**< SC Message bits */
      unsigned int VALUE1     :  1;  /**< SC Message bits */
      unsigned int VALUE2     :  1;  /**< SC Message bits */
      unsigned int VALUE3     :  1;  /**< SC Message bits */
      unsigned int VALUE4     :  1;  /**< SC Message bits */
      unsigned int VALUE5     :  1;  /**< SC Message bits */
      unsigned int VALUE6     :  1;  /**< SC Message bits */
      unsigned int VALUE7     :  1;  /**< SC Message bits */
      unsigned int VALUE8     :  1;  /**< SC Message bits */
      unsigned int VALUE9     :  1;  /**< SC Message bits */
      unsigned int VALUE10    :  1;  /**< SC Message bits */
      unsigned int VALUE11    :  1;  /**< SC Message bits */
      unsigned int VALUE12    :  1;  /**< SC Message bits */
      unsigned int VALUE13    :  1;  /**< SC Message bits */
      unsigned int VALUE14    :  1;  /**< SC Message bits */
      unsigned int VALUE15    :  1;  /**< SC Message bits */
      unsigned int VALUE16    :  1;  /**< SC Message bits */
      unsigned int VALUE17    :  1;  /**< SC Message bits */
      unsigned int VALUE18    :  1;  /**< SC Message bits */
      unsigned int VALUE19    :  1;  /**< SC Message bits */
      unsigned int VALUE20    :  1;  /**< SC Message bits */
      unsigned int VALUE21    :  1;  /**< SC Message bits */
      unsigned int VALUE22    :  1;  /**< SC Message bits */
      unsigned int VALUE23    :  1;  /**< SC Message bits */
      unsigned int VALUE24    :  1;  /**< SC Message bits */
      unsigned int VALUE25    :  1;  /**< SC Message bits */
      unsigned int VALUE26    :  1;  /**< SC Message bits */
      unsigned int VALUE27    :  1;  /**< SC Message bits */
      unsigned int VALUE28    :  1;  /**< SC Message bits */
      unsigned int VALUE29    :  1;  /**< SC Message bits */
      unsigned int VALUE30    :  1;  /**< SC Message bits */
      unsigned int VALUE31    :  1;  /**< SC Message bits */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SCMSG_SET_t;

/*@}*/

/** @defgroup SCMSG_CLR Secure Run Control Message Clear register (SCMSG_CLR) Register
 *  Secure Run Control Message Clear register (SCMSG_CLR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SCMSG_CLR_Struct
 *! \brief  Secure Run Control Message Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SCMSG_CLR_t {
  union {
    struct {
      unsigned int VALUE0     :  1;  /**< SC Message bits */
      unsigned int VALUE1     :  1;  /**< SC Message bits */
      unsigned int VALUE2     :  1;  /**< SC Message bits */
      unsigned int VALUE3     :  1;  /**< SC Message bits */
      unsigned int VALUE4     :  1;  /**< SC Message bits */
      unsigned int VALUE5     :  1;  /**< SC Message bits */
      unsigned int VALUE6     :  1;  /**< SC Message bits */
      unsigned int VALUE7     :  1;  /**< SC Message bits */
      unsigned int VALUE8     :  1;  /**< SC Message bits */
      unsigned int VALUE9     :  1;  /**< SC Message bits */
      unsigned int VALUE10    :  1;  /**< SC Message bits */
      unsigned int VALUE11    :  1;  /**< SC Message bits */
      unsigned int VALUE12    :  1;  /**< SC Message bits */
      unsigned int VALUE13    :  1;  /**< SC Message bits */
      unsigned int VALUE14    :  1;  /**< SC Message bits */
      unsigned int VALUE15    :  1;  /**< SC Message bits */
      unsigned int VALUE16    :  1;  /**< SC Message bits */
      unsigned int VALUE17    :  1;  /**< SC Message bits */
      unsigned int VALUE18    :  1;  /**< SC Message bits */
      unsigned int VALUE19    :  1;  /**< SC Message bits */
      unsigned int VALUE20    :  1;  /**< SC Message bits */
      unsigned int VALUE21    :  1;  /**< SC Message bits */
      unsigned int VALUE22    :  1;  /**< SC Message bits */
      unsigned int VALUE23    :  1;  /**< SC Message bits */
      unsigned int VALUE24    :  1;  /**< SC Message bits */
      unsigned int VALUE25    :  1;  /**< SC Message bits */
      unsigned int VALUE26    :  1;  /**< SC Message bits */
      unsigned int VALUE27    :  1;  /**< SC Message bits */
      unsigned int VALUE28    :  1;  /**< SC Message bits */
      unsigned int VALUE29    :  1;  /**< SC Message bits */
      unsigned int VALUE30    :  1;  /**< SC Message bits */
      unsigned int VALUE31    :  1;  /**< SC Message bits */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SCMSG_CLR_t;

/*@}*/

/** @defgroup SCMSG_TGL Secure Run Control Message Toggle register (SCMSG_TGL) Register
 *  Secure Run Control Message Toggle register (SCMSG_TGL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_SCMSG_TGL_Struct
 *! \brief  Secure Run Control Message Toggle Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_SCMSG_TGL_t {
  union {
    struct {
      unsigned int VALUE0     :  1;  /**< SC Message bits */
      unsigned int VALUE1     :  1;  /**< SC Message bits */
      unsigned int VALUE2     :  1;  /**< SC Message bits */
      unsigned int VALUE3     :  1;  /**< SC Message bits */
      unsigned int VALUE4     :  1;  /**< SC Message bits */
      unsigned int VALUE5     :  1;  /**< SC Message bits */
      unsigned int VALUE6     :  1;  /**< SC Message bits */
      unsigned int VALUE7     :  1;  /**< SC Message bits */
      unsigned int VALUE8     :  1;  /**< SC Message bits */
      unsigned int VALUE9     :  1;  /**< SC Message bits */
      unsigned int VALUE10    :  1;  /**< SC Message bits */
      unsigned int VALUE11    :  1;  /**< SC Message bits */
      unsigned int VALUE12    :  1;  /**< SC Message bits */
      unsigned int VALUE13    :  1;  /**< SC Message bits */
      unsigned int VALUE14    :  1;  /**< SC Message bits */
      unsigned int VALUE15    :  1;  /**< SC Message bits */
      unsigned int VALUE16    :  1;  /**< SC Message bits */
      unsigned int VALUE17    :  1;  /**< SC Message bits */
      unsigned int VALUE18    :  1;  /**< SC Message bits */
      unsigned int VALUE19    :  1;  /**< SC Message bits */
      unsigned int VALUE20    :  1;  /**< SC Message bits */
      unsigned int VALUE21    :  1;  /**< SC Message bits */
      unsigned int VALUE22    :  1;  /**< SC Message bits */
      unsigned int VALUE23    :  1;  /**< SC Message bits */
      unsigned int VALUE24    :  1;  /**< SC Message bits */
      unsigned int VALUE25    :  1;  /**< SC Message bits */
      unsigned int VALUE26    :  1;  /**< SC Message bits */
      unsigned int VALUE27    :  1;  /**< SC Message bits */
      unsigned int VALUE28    :  1;  /**< SC Message bits */
      unsigned int VALUE29    :  1;  /**< SC Message bits */
      unsigned int VALUE30    :  1;  /**< SC Message bits */
      unsigned int VALUE31    :  1;  /**< SC Message bits */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_SCMSG_TGL_t;

/*@}*/

/** @defgroup RCMSG Run Control Message register (RCMSG) Register
 *  Run Control Message register (RCMSG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_RCMSG_Struct
 *! \brief  Run Control Message Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_RCMSG_t {
  union {
    struct {
      unsigned int RCMSG00    :  1;  /**< Reserved */
      unsigned int RCMSG01    :  1;  /**< Reserved */
      unsigned int RCMSG02    :  1;  /**< Reserved */
      unsigned int RCMSG03    :  1;  /**< Reserved */
      unsigned int NOMEMINIT  :  1;  /**< Do not initialize memory (Main M4 SRAM and MBOX memories) */
      unsigned int RCMSG05    :  1;  /**< Reserved */
      unsigned int RCMSG06    :  1;  /**< Reserved */
      unsigned int RCMSG07    :  1;  /**< Reserved */
      unsigned int RCMSG08    :  1;  /**< Reserved */
      unsigned int RCMSG09    :  1;  /**< Reserved */
      unsigned int RCMSG10    :  1;  /**< Reserved */
      unsigned int NOFACTORYPREBOOT :  1;  /**< Do not perform factory preboot */
      unsigned int NOL2CONFIG       :  1;  /**< Do not configure L2 */
      unsigned int HALTONENTRY      :  1;  /**< Enter idle, or wfi, on entry */
      unsigned int RCMSG14          :  1;  /**< Reserved */
      unsigned int RCMSG15          :  1;  /**< Reserved */
      unsigned int ACRC             :  1;  /**< Enable CRC of the application (first 4K of flash) */
      unsigned int RCMSG17          :  1;  /**< Reserved */
      unsigned int RCMSG18          :  1;  /**< Reserved */
      unsigned int RCMSG19          :  1;  /**< Reserved */
      unsigned int NOCRC            :  1;  /**< Disable CRC checking of ROM Image */
      unsigned int MBISTEN          :  1;  /**< MBIST should run ( not controlled by ROM ) */
      unsigned int MBISTFIN         :  1;  /**< MBIST successfully finished ( not controlled by ROM ) */
      unsigned int RCMSG23          :  1;  /**< Reserved */
      unsigned int BOOT_DONE        :  1;  /**< 1 indicates that initial Booting and initializations are complete */
      unsigned int M0EN             :  1;  /**< Enable M0 out of reset into idle (wfi) state */
      unsigned int RCMSG26          :  1;  /**< Reserved */
      unsigned int RCMSG27          :  1;  /**< Reserved */
      unsigned int RCMSG28          :  1;  /**< Reserved */
      unsigned int RCMSG29          :  1;  /**< Reserved */
      unsigned int RCMSG30          :  1;  /**< Reserved */
      unsigned int RCMSG31          :  1;  /**< Reserved */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_RCMSG_t;

/*@}*/

/** @defgroup RCMSG_SET Run Control Message Set register (RCMSG_SET) Register
 *  Run Control Message Set register (RCMSG_SET) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_RCMSG_SET_Struct
 *! \brief  Run Control Message Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_RCMSG_SET_t {
  union {
    struct {
      unsigned int RCMSG00    :  1;  /**< Reserved */
      unsigned int RCMSG01    :  1;  /**< Reserved */
      unsigned int RCMSG02    :  1;  /**< Reserved */
      unsigned int RCMSG03    :  1;  /**< Reserved */
      unsigned int NOMEMINIT  :  1;  /**< Do not initialize memory (Main M4 SRAM and MBOX memories) */
      unsigned int RCMSG05    :  1;  /**< Reserved */
      unsigned int RCMSG06    :  1;  /**< Reserved */
      unsigned int RCMSG07    :  1;  /**< Reserved */
      unsigned int RCMSG08    :  1;  /**< Reserved */
      unsigned int RCMSG09    :  1;  /**< Reserved */
      unsigned int RCMSG10    :  1;  /**< Reserved */
      unsigned int NOFACTORYPREBOOT :  1;  /**< Do not perform factory preboot */
      unsigned int NOL2CONFIG       :  1;  /**< Do not configure L2 */
      unsigned int HALTONENTRY      :  1;  /**< Enter idle, or wfi, on entry */
      unsigned int RCMSG14          :  1;  /**< Reserved */
      unsigned int RCMSG15          :  1;  /**< Reserved */
      unsigned int ACRC             :  1;  /**< Enable CRC of the application (first 4K of flash) */
      unsigned int RCMSG17          :  1;  /**< Reserved */
      unsigned int RCMSG18          :  1;  /**< Reserved */
      unsigned int RCMSG19          :  1;  /**< Reserved */
      unsigned int NOCRC            :  1;  /**< Disable CRC checking of ROM Image */
      unsigned int MBISTEN          :  1;  /**< MBIST should run ( not controlled by ROM ) */
      unsigned int MBISTFIN         :  1;  /**< MBIST successfully finished ( not controlled by ROM ) */
      unsigned int RCMSG23          :  1;  /**< Reserved */
      unsigned int BOOT_DONE        :  1;  /**< 1 indicates that initial Booting and initializations are complete */
      unsigned int M0EN             :  1;  /**< Enable M0 out of reset into idle (wfi) state */
      unsigned int RCMSG26          :  1;  /**< Reserved */
      unsigned int RCMSG27          :  1;  /**< Reserved */
      unsigned int RCMSG28          :  1;  /**< Reserved */
      unsigned int RCMSG29          :  1;  /**< Reserved */
      unsigned int RCMSG30          :  1;  /**< Reserved */
      unsigned int RCMSG31          :  1;  /**< Reserved */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_RCMSG_SET_t;

/*@}*/

/** @defgroup RCMSG_CLR Run Control Message Clear register (RCMSG_CLR) Register
 *  Run Control Message Clear register (RCMSG_CLR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_RCMSG_CLR_Struct
 *! \brief  Run Control Message Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_RCMSG_CLR_t {
  union {
    struct {
      unsigned int RCMSG00    :  1;  /**< Reserved */
      unsigned int RCMSG01    :  1;  /**< Reserved */
      unsigned int RCMSG02    :  1;  /**< Reserved */
      unsigned int RCMSG03    :  1;  /**< Reserved */
      unsigned int NOMEMINIT  :  1;  /**< Do not initialize memory (Main M4 SRAM and MBOX memories) */
      unsigned int RCMSG05    :  1;  /**< Reserved */
      unsigned int RCMSG06    :  1;  /**< Reserved */
      unsigned int RCMSG07    :  1;  /**< Reserved */
      unsigned int RCMSG08    :  1;  /**< Reserved */
      unsigned int RCMSG09    :  1;  /**< Reserved */
      unsigned int RCMSG10    :  1;  /**< Reserved */
      unsigned int NOFACTORYPREBOOT :  1;  /**< Do not perform factory preboot */
      unsigned int NOL2CONFIG       :  1;  /**< Do not configure L2 */
      unsigned int HALTONENTRY      :  1;  /**< Enter idle, or wfi, on entry */
      unsigned int RCMSG14          :  1;  /**< Reserved */
      unsigned int RCMSG15          :  1;  /**< Reserved */
      unsigned int ACRC             :  1;  /**< Enable CRC of the application (first 4K of flash) */
      unsigned int RCMSG17          :  1;  /**< Reserved */
      unsigned int RCMSG18          :  1;  /**< Reserved */
      unsigned int RCMSG19          :  1;  /**< Reserved */
      unsigned int NOCRC            :  1;  /**< Disable CRC checking of ROM Image */
      unsigned int MBISTEN          :  1;  /**< MBIST should run ( not controlled by ROM ) */
      unsigned int MBISTFIN         :  1;  /**< MBIST successfully finished ( not controlled by ROM ) */
      unsigned int RCMSG23          :  1;  /**< Reserved */
      unsigned int BOOT_DONE        :  1;  /**< 1 indicates that initial Booting and initializations are complete */
      unsigned int M0EN             :  1;  /**< Enable M0 out of reset into idle (wfi) state */
      unsigned int RCMSG26          :  1;  /**< Reserved */
      unsigned int RCMSG27          :  1;  /**< Reserved */
      unsigned int RCMSG28          :  1;  /**< Reserved */
      unsigned int RCMSG29          :  1;  /**< Reserved */
      unsigned int RCMSG30          :  1;  /**< Reserved */
      unsigned int RCMSG31          :  1;  /**< Reserved */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_RCMSG_CLR_t;

/*@}*/

/** @defgroup RCMSG_TGL Run Control Message Toggle register (RCMSG_TGL) Register
 *  Run Control Message Toggle register (RCMSG_TGL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TAPC_RCMSG_TGL_Struct
 *! \brief  Run Control Message Toggle Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TAPC_RCMSG_TGL_t {
  union {
    struct {
      unsigned int RCMSG00    :  1;  /**< Reserved */
      unsigned int RCMSG01    :  1;  /**< Reserved */
      unsigned int RCMSG02    :  1;  /**< Reserved */
      unsigned int RCMSG03    :  1;  /**< Reserved */
      unsigned int NOMEMINIT  :  1;  /**< Do not initialize memory (Main M4 SRAM and MBOX memories) */
      unsigned int RCMSG05    :  1;  /**< Reserved */
      unsigned int RCMSG06    :  1;  /**< Reserved */
      unsigned int RCMSG07    :  1;  /**< Reserved */
      unsigned int RCMSG08    :  1;  /**< Reserved */
      unsigned int RCMSG09    :  1;  /**< Reserved */
      unsigned int RCMSG10    :  1;  /**< Reserved */
      unsigned int NOFACTORYPREBOOT :  1;  /**< Do not perform factory preboot */
      unsigned int NOL2CONFIG       :  1;  /**< Do not configure L2 */
      unsigned int HALTONENTRY      :  1;  /**< Enter idle, or wfi, on entry */
      unsigned int RCMSG14          :  1;  /**< Reserved */
      unsigned int RCMSG15          :  1;  /**< Reserved */
      unsigned int ACRC             :  1;  /**< Enable CRC of the application (first 4K of flash) */
      unsigned int RCMSG17          :  1;  /**< Reserved */
      unsigned int RCMSG18          :  1;  /**< Reserved */
      unsigned int RCMSG19          :  1;  /**< Reserved */
      unsigned int NOCRC            :  1;  /**< Disable CRC checking of ROM Image */
      unsigned int MBISTEN          :  1;  /**< MBIST should run ( not controlled by ROM ) */
      unsigned int MBISTFIN         :  1;  /**< MBIST successfully finished ( not controlled by ROM ) */
      unsigned int RCMSG23          :  1;  /**< Reserved */
      unsigned int BOOT_DONE        :  1;  /**< 1 indicates that initial Booting and initializations are complete */
      unsigned int M0EN             :  1;  /**< Enable M0 out of reset into idle (wfi) state */
      unsigned int RCMSG26          :  1;  /**< Reserved */
      unsigned int RCMSG27          :  1;  /**< Reserved */
      unsigned int RCMSG28          :  1;  /**< Reserved */
      unsigned int RCMSG29          :  1;  /**< Reserved */
      unsigned int RCMSG30          :  1;  /**< Reserved */
      unsigned int RCMSG31          :  1;  /**< Reserved */
    };
    uint32_t VALUE32;
  };
} ADI_TAPC_RCMSG_TGL_t;

/*@}*/

/** @defgroup MTR Master Trigger Register (MTR) Register
 *  Master Trigger Register (MTR) Register.
 *
 *  The TRU_CFG0 master trigger register (MTR) permits trigger generation through software by writing a trigger master ID value to one of the four fields in the MTR register. If the global lock is enabled SPU:CTL:GLCK bit =1) and the GCTL:LOCK bit is set, the MTR register is read only.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG0_MTR_Struct
 *! \brief  Master Trigger Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG0_MTR_t {
  union {
    struct {
      unsigned int MTR0       :  7;  /**< Master Trigger Register 0 */
      unsigned int reserved7  :  1;
      unsigned int MTR1       :  7;  /**< Master Trigger Register 1 */
      unsigned int reserved15 :  1;
      unsigned int MTR2       :  7;  /**< Master Trigger Register 2 */
      unsigned int reserved23 :  1;
      unsigned int MTR3       :  7;  /**< Master Trigger Register 3 */
      unsigned int reserved31 :  1;
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG0_MTR_t;

/*@}*/

/** @defgroup ERRADDR Error Address Register (ERRADDR) Register
 *  Error Address Register (ERRADDR) Register.
 *
 *  The TRU_CFG0 error address register (ERRADDR) holds the address from the memory mapped register access generating an access error of TRU_CFG0 registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG0_ERRADDR_Struct
 *! \brief  Error Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG0_ERRADDR_t {
  union {
    struct {
      unsigned int ADDR       : 12;  /**< Error Address */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG0_ERRADDR_t;

/*@}*/

/** @defgroup STAT Status Information Register (STAT) Register
 *  Status Information Register (STAT) Register.
 *
 *  The TRU_CFG0 status register (STAT) contains the status of MTR and SSRn register writes and status of bus read/write errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG0_STAT_Struct
 *! \brief  Status Information Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG0_STAT_t {
  union {
    struct {
      unsigned int LWERR      :  1;  /**< Lock Write Error Status */
      unsigned int ADDRERR    :  1;  /**< Address Error Status */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG0_STAT_t;

/*@}*/

/** @defgroup GCTL Global Control Register (GCTL) Register
 *  Global Control Register (GCTL) Register.
 *
 *  The TRU_CFG0 global control register (GCTL) provides register locking, TRU_CFG0 reset, and TRU_CFG0 enable.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG0_GCTL_Struct
 *! \brief  Global Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG0_GCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Non-MMR Enable */
      unsigned int RESET      :  1;  /**< Soft Reset */
      unsigned int MTRL       :  1;  /**< MTR Lock Bit */
      unsigned int reserved3  : 28;
      unsigned int LOCK       :  1;  /**< GCTL Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG0_GCTL_t;

/*@}*/

/** @defgroup SSR Slave Select Register (SSR) Register
 *  Slave Select Register (SSR) Register.
 *
 *  The TRU_CFG0 slave select registers (SSR[n]) each provide slave selection and register locking.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG0_SSR_Struct
 *! \brief  Slave Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG0_SSR_t {
  union {
    struct {
      unsigned int SSR        :  7;  /**< SSRn Slave Select */
      unsigned int reserved7  : 24;
      unsigned int LOCK       :  1;  /**< SSRn Lock */
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG0_SSR_t;

/*@}*/

/** @defgroup RUN Run Register (RUN) Register
 *  Run Register (RUN) Register.
 *
 *  The RUN allows all timers to be enabled simultaneously, permitting them to run synchronously. For each timer, there is a single start/stop control bit. Writing a 1 to this bit starts the corresponding timer; writing a 0 stops the timer with mechanism specified in the timer stop configuration STOP_CFG register. 
 *  The start/stop control bits can be set/reset individually or  in any combination. While starting or stopping one particular timer directly with this register, software must perform a read-modify write, so the bits corresponding to other timers remain unchanged. To avoid this need, software can use the RUN_CLR register.
 *  Reading the RUN register shows the start status for the corresponding timer. A 1 indicates that the timer is running.
 *  If a timer is in run state (corresponding run bit is =1), a software write of 1 in this bit does not have any effect on the timer state. The write does not result in restarting the timer. 
 *  Note that the RUN register is not used in PININT mode. PININT mode starts as soon as the TMRn_CFG:TMODE bits are set to 111.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_RUN_Struct
 *! \brief  Run Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_RUN_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR01      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR02      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR03      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR04      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR05      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR06      :  1;  /**< Start/Stop Timer n */
      unsigned int TMR07      :  1;  /**< Start/Stop Timer n */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_RUN_t;

/*@}*/

/** @defgroup RUN_SET Run Set Register (RUN_SET) Register
 *  Run Set Register (RUN_SET) Register.
 *
 *  The RUN_SET register is an alias register, providing a mechanism to set a specific start/stop bit in the RUN register without affecting other bits in RUN. To start a particular timer, software must write a 1 into the corresponding RUN_SET bit. Writing a zero has no effect. For an example, to start timer 3 without affecting any other timer, write 0x0008 into RUN_SET. Because RUN_SET is a write-only register, the result of any write to this register must be checked by reading the RUN register. A read of the RUN_SET returns 0x0000.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_RUN_SET_Struct
 *! \brief  Run Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_RUN_SET_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< RUN Set Alias */
      unsigned int TMR01      :  1;  /**< RUN Set Alias */
      unsigned int TMR02      :  1;  /**< RUN Set Alias */
      unsigned int TMR03      :  1;  /**< RUN Set Alias */
      unsigned int TMR04      :  1;  /**< RUN Set Alias */
      unsigned int TMR05      :  1;  /**< RUN Set Alias */
      unsigned int TMR06      :  1;  /**< RUN Set Alias */
      unsigned int TMR07      :  1;  /**< RUN Set Alias */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_RUN_SET_t;

/*@}*/

/** @defgroup RUN_CLR Run Clear Register (RUN_CLR) Register
 *  Run Clear Register (RUN_CLR) Register.
 *
 *  The RUN_CLR register is an alias register, providing a mechanism to clear a specific start/stop bit in the RUN register without affecting other bits in RUN. To stop a particular timer, software must write a 1 into the corresponding RUN_CLR bit. Writing a 0 has no effect. Because RUN_CLR is a write-only register, the result of any write to this register must be checked by reading the RUN register. A read of the RUN_CLR returns 0x0000. 
 *  
 *  Note that the stopping mechanism of a timer may be abrupt or graceful (after completion of current waveform period) depending on the selection in the STOP_CFG register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_RUN_CLR_Struct
 *! \brief  Run Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_RUN_CLR_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< RUN Clear Alias */
      unsigned int TMR01      :  1;  /**< RUN Clear Alias */
      unsigned int TMR02      :  1;  /**< RUN Clear Alias */
      unsigned int TMR03      :  1;  /**< RUN Clear Alias */
      unsigned int TMR04      :  1;  /**< RUN Clear Alias */
      unsigned int TMR05      :  1;  /**< RUN Clear Alias */
      unsigned int TMR06      :  1;  /**< RUN Clear Alias */
      unsigned int TMR07      :  1;  /**< RUN Clear Alias */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_RUN_CLR_t;

/*@}*/

/** @defgroup STOP_CFG Stop Configuration Register (STOP_CFG) Register
 *  Stop Configuration Register (STOP_CFG) Register.
 *
 *  The STOP_CFG register selects the stop mode for each timer. Timers may be stopped abruptly (immediate halt - all modes) or gracefully in PWMOUT modes (single pulse and continuous). The halt is achieved through either a write =0 to the corresponding bit in RUN or a write =1 to the corresponding bit in RUN_CLR. A read of STOP_CFG returns the last value written.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_STOP_CFG_Struct
 *! \brief  Stop Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_STOP_CFG_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Stop Mode Select */
      unsigned int TMR01      :  1;  /**< Stop Mode Select */
      unsigned int TMR02      :  1;  /**< Stop Mode Select */
      unsigned int TMR03      :  1;  /**< Stop Mode Select */
      unsigned int TMR04      :  1;  /**< Stop Mode Select */
      unsigned int TMR05      :  1;  /**< Stop Mode Select */
      unsigned int TMR06      :  1;  /**< Stop Mode Select */
      unsigned int TMR07      :  1;  /**< Stop Mode Select */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_STOP_CFG_t;

/*@}*/

/** @defgroup STOP_CFG_SET Stop Configuration Set Register (STOP_CFG_SET) Register
 *  Stop Configuration Set Register (STOP_CFG_SET) Register.
 *
 *  This is an alias register, providing a mechanism to set a specific bit in the STOP_CFG register without affecting other bits in STOP_CFG. To set a bit in the STOP_CFG register, software must write a 1 to the corresponding bit of the STOP_CFG_SET register. Writing a zero has no effect. Because the STOP_CFG_SET register is a write-only register, the result of any write to this register must be checked by reading the STOP_CFG register. A read of the STOP_CFG_SET register returns 0x0000.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_STOP_CFG_SET_Struct
 *! \brief  Stop Configuration Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_STOP_CFG_SET_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR01      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR02      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR03      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR04      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR05      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR06      :  1;  /**< STOP_CFG Set Alias */
      unsigned int TMR07      :  1;  /**< STOP_CFG Set Alias */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_STOP_CFG_SET_t;

/*@}*/

/** @defgroup STOP_CFG_CLR Stop Configuration Clear Register (STOP_CFG_CLR) Register
 *  Stop Configuration Clear Register (STOP_CFG_CLR) Register.
 *
 *  This is an alias register, providing a mechanism to clear a specific bit in the STOP_CFG register without affecting other bits in STOP_CFG. To clear a bit in STOP_CFG, software must write a 1 to the corresponding bit of STOP_CFG_CLR register. Writing a zero has no effect. Because the STOP_CFG_CLR register is a write-only register, the result of any write to this register must be checked by reading the STOP_CFG register. A read of the STOP_CFG_CLR register returns 0x0000.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_STOP_CFG_CLR_Struct
 *! \brief  Stop Configuration Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_STOP_CFG_CLR_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR01      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR02      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR03      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR04      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR05      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR06      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int TMR07      :  1;  /**< STOP_CFG Clear Alias */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_STOP_CFG_CLR_t;

/*@}*/

/** @defgroup DATA_IMSK Data Interrupt Mask Register (DATA_IMSK) Register
 *  Data Interrupt Mask Register (DATA_IMSK) Register.
 *
 *  Each timer may generate a unique processor data interrupt request signal. The DATA_IMSK register contains an interrupt mask for these requests, masking (disabling) or unmasking (enabling) the interrupts as programmed. The reset value of the DATA_IMSK register is 0xFFFF, masking these interrupts after reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_DATA_IMSK_Struct
 *! \brief  Data Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_DATA_IMSK_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR01      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR02      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR03      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR04      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR05      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR06      :  1;  /**< Data Interrupt Mask */
      unsigned int TMR07      :  1;  /**< Data Interrupt Mask */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_DATA_IMSK_t;

/*@}*/

/** @defgroup STAT_IMSK Status Interrupt Mask Register (STAT_IMSK) Register
 *  Status Interrupt Mask Register (STAT_IMSK) Register.
 *
 *  While each timer may generate a status interrupt request, these requests are OR'ed to generate a single status interrupt signal to the System Event Controller. The STAT_IMSK register contains an interrupt mask for these requests, masking (disabling) or unmasking (enabling) the interrupts as programmed. The reset value of the STAT_IMSK register is 0xFFFF, masking these interrupts after reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_STAT_IMSK_Struct
 *! \brief  Status Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_STAT_IMSK_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR01      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR02      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR03      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR04      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR05      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR06      :  1;  /**< Status Interrupt Mask */
      unsigned int TMR07      :  1;  /**< Status Interrupt Mask */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_STAT_IMSK_t;

/*@}*/

/** @defgroup TRG_MSK Trigger Master Mask Register (TRG_MSK) Register
 *  Trigger Master Mask Register (TRG_MSK) Register.
 *
 *  As a trigger master, each timer can generate a unique data trigger pulse signal. The TRG_MSK register contains a trigger mask for these outputs, masking (disabling) or unmasking (enabling) the triggers as programmed. The reset value of the TRG_MSK register is 0xFFFF, masking these triggers after reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TRG_MSK_Struct
 *! \brief  Trigger Master Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TRG_MSK_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Trigger Output Mask */
      unsigned int TMR01      :  1;  /**< Trigger Output Mask */
      unsigned int TMR02      :  1;  /**< Trigger Output Mask */
      unsigned int TMR03      :  1;  /**< Trigger Output Mask */
      unsigned int TMR04      :  1;  /**< Trigger Output Mask */
      unsigned int TMR05      :  1;  /**< Trigger Output Mask */
      unsigned int TMR06      :  1;  /**< Trigger Output Mask */
      unsigned int TMR07      :  1;  /**< Trigger Output Mask */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TRG_MSK_t;

/*@}*/

/** @defgroup TRG_IE Trigger Slave Enable Register (TRG_IE) Register
 *  Trigger Slave Enable Register (TRG_IE) Register.
 *
 *  As a trigger slave, each timer can generate a unique data trigger pulse signal. The TRG_IE contains trigger input enable bits for these signals, disabling or enabling the triggers as programmed. The reset value of the TRG_IE register is 0xFFFF, masking these triggers after reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TRG_IE_Struct
 *! \brief  Trigger Slave Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TRG_IE_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Trigger Input Enable */
      unsigned int TMR01      :  1;  /**< Trigger Input Enable */
      unsigned int TMR02      :  1;  /**< Trigger Input Enable */
      unsigned int TMR03      :  1;  /**< Trigger Input Enable */
      unsigned int TMR04      :  1;  /**< Trigger Input Enable */
      unsigned int TMR05      :  1;  /**< Trigger Input Enable */
      unsigned int TMR06      :  1;  /**< Trigger Input Enable */
      unsigned int TMR07      :  1;  /**< Trigger Input Enable */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TRG_IE_t;

/*@}*/

/** @defgroup DATA_ILAT Data Interrupt Latch Register (DATA_ILAT) Register
 *  Data Interrupt Latch Register (DATA_ILAT) Register.
 *
 *  The DATA_ILAT holds the latched interrupt status for interrupt requests that have been unmasked (enabled) by the DATA_IMSK register and generated according to the conditions selected by the TMRn_CFG:IRQMODE bits. If a bit in DATA_ILAT is already set and the corresponding interrupt is masked in DATA_IMSK, the latch holds its old value, leaving the interrupt asserted until it is reset by software with a W1C operation. 
 *  
 *  Note that interrupt service routines (ISRs) should clear the appropriate bits in DATA_ILAT before returning from the ISR, to ensure that the interrupt is not re-issued. To make sure that no timer event is missed, the latch should be reset at the very beginning of the ISR when in EXTCLK mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_DATA_ILAT_Struct
 *! \brief  Data Interrupt Latch Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_DATA_ILAT_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR01      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR02      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR03      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR04      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR05      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR06      :  1;  /**< Data Interrupt Latch */
      unsigned int TMR07      :  1;  /**< Data Interrupt Latch */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_DATA_ILAT_t;

/*@}*/

/** @defgroup STAT_ILAT Status Interrupt Latch Register (STAT_ILAT) Register
 *  Status Interrupt Latch Register (STAT_ILAT) Register.
 *
 *  The STAT_ILAT holds the latched interrupt status for error interrupts, indicating a timer overflow condition or indicating that prohibited programming has occurred for a timer. These interrupt status bits are sticky and are W1C. The bits in the STAT_ILAT register provide information regarding each timer interrupt source.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_STAT_ILAT_Struct
 *! \brief  Status Interrupt Latch Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_STAT_ILAT_t {
  union {
    struct {
      unsigned int TMR00      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR01      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR02      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR03      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR04      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR05      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR06      :  1;  /**< Status Interrupt Latch */
      unsigned int TMR07      :  1;  /**< Status Interrupt Latch */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_STAT_ILAT_t;

/*@}*/

/** @defgroup ERR_TYPE Error Type Status Register (ERR_TYPE) Register
 *  Error Type Status Register (ERR_TYPE) Register.
 *
 *  The ERR_TYPE register contains Error Type status bits for each timer. These bits indicate the type of error (if any) in a running timer. This register is read-only. These status bits are cleared at reset and when a particular timer is enabled. 
 *  
 *  Each time an error interrupt is latched in the STAT_ILAT register the corresponding TERRx bits in the ERR_TYPE register are loaded with a code that identifies the type of error that was detected. This status value is held until the next error or until a particular timer is restarted. No bus error is generated if a write is performed on the ERR_TYPE register.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR0
 *! \brief  Error type for Timer 0 (TERR0) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR0   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF0   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG0   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG0 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR0;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR1
 *! \brief  Error type for Timer 1 (TERR1) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR1   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF1   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG1   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG1 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR1;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR2
 *! \brief  Error type for Timer 2 (TERR2) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR2   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF2   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG2   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG2 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR2;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR3
 *! \brief  Error type for Timer 3 (TERR3) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR3   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF3   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG3   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG3 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR3;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR4
 *! \brief  Error type for Timer 4 (TERR4) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR4   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF4   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG4   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG4 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR4;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR5
 *! \brief  Error type for Timer 5 (TERR5) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR5   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF5   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG5   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG5 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR5;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR6
 *! \brief  Error type for Timer 6 (TERR6) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR6   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF6   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG6   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG6 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR6;


/*  =========================================================================
 *! \enum   ADI_TIMER_ERR_TYPE_TERR7
 *! \brief  Error type for Timer 7 (TERR7) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_ERR_TYPE_NO_ERR7   = 0,  /**< No Error                              */
  TIMER_ERR_TYPE_CNTOVF7   = 1,  /**< Counter Overflow Error                */
  TIMER_ERR_TYPE_PERPRG7   = 2,  /**< PER Register Programming Error        */
  TIMER_ERR_TYPE_PULSEPRG7 = 3   /**< WID or DLY Register Programming Error */
} ADI_TIMER_ERR_TYPE_TERR7;


/* ==========================================================================
 *! \struct ADI_TIMER_ERR_TYPE_Struct
 *! \brief  Error Type Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_ERR_TYPE_t {
  union {
    struct {
      unsigned int TERR0      :  2;  /**< Error type for Timer 0 */
      unsigned int TERR1      :  2;  /**< Error type for Timer 1 */
      unsigned int TERR2      :  2;  /**< Error type for Timer 2 */
      unsigned int TERR3      :  2;  /**< Error type for Timer 3 */
      unsigned int TERR4      :  2;  /**< Error type for Timer 4 */
      unsigned int TERR5      :  2;  /**< Error type for Timer 5 */
      unsigned int TERR6      :  2;  /**< Error type for Timer 6 */
      unsigned int TERR7      :  2;  /**< Error type for Timer 7 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_ERR_TYPE_t;

/*@}*/

/** @defgroup BCAST_PER Broadcast Period Register (BCAST_PER) Register
 *  Broadcast Period Register (BCAST_PER) Register.
 *
 *  For timers with TMRn_CFG:BPEREN enabled, a write to BCAST_PER concurrently updates the  period (TMRn_PER) registers of only those timers. A read of BCAST_PER returns 0x00000000, and no bus error is generated. To read back a written value, read that TMR's TMRn_PER register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_BCAST_PER_Struct
 *! \brief  Broadcast Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_BCAST_PER_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Broadcast Period Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_BCAST_PER_t;

/*@}*/

/** @defgroup BCAST_WID Broadcast Width Register (BCAST_WID) Register
 *  Broadcast Width Register (BCAST_WID) Register.
 *
 *  For timers with TMRn_CFG:BWIDEN enabled, a write to the BCAST_WID register concurrently updates the' width (TMRn_WID) registers of only those timers. A read of the BCAST_WID register returns 0x00000000, and no bus error is generated.  To read back a written value, read that TMR's TMRn_WID register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_BCAST_WID_Struct
 *! \brief  Broadcast Width Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_BCAST_WID_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Broadcast Width Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_BCAST_WID_t;

/*@}*/

/** @defgroup BCAST_DLY Broadcast Delay Register (BCAST_DLY) Register
 *  Broadcast Delay Register (BCAST_DLY) Register.
 *
 *  For timers with TMRn_CFG:BDLYEN enabled, a write to the BCAST_DLY register concurrently updates the delay (TMRn_DLY) registers of only those timers. A read of the BCAST_DLY register returns 0x00000000, and no bus error is generated.  To read back a written value, read that TMR's TMRn_DLY register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_BCAST_DLY_Struct
 *! \brief  Broadcast Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_BCAST_DLY_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Broadcast Delay Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_BCAST_DLY_t;

/*@}*/

/** @defgroup TMR_CFG Timer n Configuration Register (TMR_CFG) Register
 *  Timer n Configuration Register (TMR_CFG) Register.
 *
 *  Each timer has a TMR[n]_CFG register that specifies its operating mode. Only write to a TMR[n]_CFG register when the corresponding timer is not running. 
 *  After disabling a timer operating in PWMOUT mode, verify that the timer has stopped running by checking the start/stop status of the timer in the RUN register before writing to the timer's TMR[n]_CFG register. 
 *  Note that a timer's TMR[n]_CFG register may be read at any time.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_TMODE
 *! \brief  Timer Mode Select (TMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_IDLE_MODE0   = 0,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE1   = 1,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE2   = 2,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE3   = 3,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE4   = 4,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE5   = 5,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE6   = 6,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_IDLE_MODE7   = 7,   /**< Idle Mode                                           */
  TIMER_TMR_CFG_WDPER_MODE   = 8,   /**< Period Watchdog Mode                                */
  TIMER_TMR_CFG_WDWID_MODE   = 9,   /**< Width Watchdog Mode                                 */
  TIMER_TMR_CFG_WIDCAP0_MODE = 10,  /**< Measurement report at asserting edge of waveform    */
  TIMER_TMR_CFG_WIDCAP1_MODE = 11,  /**< Measurement report at de-asserting edge of waveform */
  TIMER_TMR_CFG_PWMCONT_MODE = 12,  /**< Continuous PWMOUT mode                              */
  TIMER_TMR_CFG_PWMSING_MODE = 13,  /**< Single pulse PWMOUT mode                            */
  TIMER_TMR_CFG_EXTCLK_MODE  = 14,  /**< EXTCLK mode                                         */
  TIMER_TMR_CFG_PININT_MODE  = 15   /**< PININT (pin interrupt) mode                         */
} ADI_TIMER_TMR_CFG_TMODE;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_IRQMODE
 *! \brief  Interrupt Modes (IRQMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_IRQMODE0 = 0,  /**< Active Edge Mode              */
  TIMER_TMR_CFG_IRQMODE1 = 1,  /**< Delay Expired Mode            */
  TIMER_TMR_CFG_IRQMODE2 = 2,  /**< Width Plus Delay Expired Mode */
  TIMER_TMR_CFG_IRQMODE3 = 3   /**< Period Expired Mode           */
} ADI_TIMER_TMR_CFG_IRQMODE;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_SLAVETRIG
 *! \brief  Slave Trigger Response (SLAVETRIG) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_TRIGSTOP  = 0,  /**< Pulse stops timer if it is running  */
  TIMER_TMR_CFG_TRIGSTART = 1   /**< Pulse starts timer if it is stopped */
} ADI_TIMER_TMR_CFG_SLAVETRIG;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_PULSEHI
 *! \brief  Polarity Response Select (PULSEHI) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_NEG_EDGE = 0,  /**< Negative Response/Pulse */
  TIMER_TMR_CFG_POS_EDGE = 1   /**< Positive Response/Pulse */
} ADI_TIMER_TMR_CFG_PULSEHI;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_CLKSEL
 *! \brief  Clock Select (CLKSEL) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_CLKSEL_SCLK = 0,  /**< Use SCLK                          */
  TIMER_TMR_CFG_CLKSEL_ALT0 = 1,  /**< Use TMR_ALT_CLK0 as the TMR clock */
  TIMER_TMR_CFG_CLKSEL_ALT1 = 3   /**< Use TMR_ALT_CLK1 as the TMR clock */
} ADI_TIMER_TMR_CFG_CLKSEL;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_TINSEL
 *! \brief  Timer Input Select (for WIDCAP, WATCHDOG, PININT modes) (TINSEL) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_TINSEL_TMR = 0,  /**< Use TMR pin input               */
  TIMER_TMR_CFG_TINSEL_AUX = 1   /**< Use TMR Alternate Capture Input */
} ADI_TIMER_TMR_CFG_TINSEL;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_OUTDIS
 *! \brief  Output Disable (OUTDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_PADOUT_EN  = 0,  /**< Enable TMR pin output buffer  */
  TIMER_TMR_CFG_PADOUT_DIS = 1   /**< Disable TMR pin output buffer */
} ADI_TIMER_TMR_CFG_OUTDIS;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_BDLYEN
 *! \brief  Broadcast Delay Enable (BDLYEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_BCASTDLY_DIS = 0,  /**< Disable Broadcast to DLY Register */
  TIMER_TMR_CFG_BCASTDLY_EN  = 1   /**< Enable Broadcast to DLY Register  */
} ADI_TIMER_TMR_CFG_BDLYEN;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_BWIDEN
 *! \brief  Broadcast Width Enable (BWIDEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_BCASTWID_DIS = 0,  /**< Disable Broadcast to WID Register */
  TIMER_TMR_CFG_BCASTWID_EN  = 1   /**< Enable Broadcast to WID Register  */
} ADI_TIMER_TMR_CFG_BWIDEN;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_BPEREN
 *! \brief  Broadcast Period Enable (BPEREN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_BCASTPER_DIS = 0,  /**< Disable Broadcast to PER Register */
  TIMER_TMR_CFG_BCASTPER_EN  = 1   /**< Enable Broadcast to PER Register  */
} ADI_TIMER_TMR_CFG_BPEREN;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_EMURUN
 *! \brief  Run Timer (Counter) During Emulation (EMURUN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_EMU_NOCNT = 0,  /**< Stop Timer During Emulation */
  TIMER_TMR_CFG_EMU_CNT   = 1   /**< Run Timer During Emulation  */
} ADI_TIMER_TMR_CFG_EMURUN;


/*  =========================================================================
 *! \enum   ADI_TIMER_TMR_CFG_TGLTRIG
 *! \brief  Slave Trigger Toggle Enable (TGLTRIG) Enumerations
 *  ========================================================================= */
typedef enum
{
  TIMER_TMR_CFG_TGLTRIG0 = 0,  /**< Slave trigger response depends on SLAVETRIG bit setting */
  TIMER_TMR_CFG_TGLTRIG1 = 1   /**< Slave trigger toggles timer state                       */
} ADI_TIMER_TMR_CFG_TGLTRIG;


/* ==========================================================================
 *! \struct ADI_TIMER_TMR_CFG_Struct
 *! \brief  Timer n Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TMR_CFG_t {
  union {
    struct {
      unsigned int TMODE      :  4;  /**< Timer Mode Select */
      unsigned int IRQMODE    :  2;  /**< Interrupt Modes */
      unsigned int SLAVETRIG  :  1;  /**< Slave Trigger Response */
      unsigned int PULSEHI    :  1;  /**< Polarity Response Select */
      unsigned int CLKSEL     :  2;  /**< Clock Select */
      unsigned int TINSEL     :  1;  /**< Timer Input Select (for WIDCAP, WATCHDOG, PININT modes) */
      unsigned int OUTDIS     :  1;  /**< Output Disable */
      unsigned int BDLYEN     :  1;  /**< Broadcast Delay Enable */
      unsigned int BWIDEN     :  1;  /**< Broadcast Width Enable */
      unsigned int BPEREN     :  1;  /**< Broadcast Period Enable */
      unsigned int EMURUN     :  1;  /**< Run Timer (Counter) During Emulation */
      unsigned int TGLTRIG    :  1;  /**< Slave Trigger Toggle Enable */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TMR_CFG_t;

/*@}*/

/** @defgroup TMR_CNT Timer n Counter Register (TMR_CNT) Register
 *  Timer n Counter Register (TMR_CNT) Register.
 *
 *  The TMR[n]_CNT register holds the current timer count. After enabling, the count is re-initialized to either 0x0 or 0x1, depending on the configuration and mode. The TMR[n]_CNT is read only and may be read at any time (whether the timer is running or stopped). Reading the TMR[n]_CNT register returns an atomic 32-bit value. 
 *  Depending on the timer operation mode, the counter increment can be clocked by a number of sources, including SCLK, the TMR or Alternate Capture input pins, ACLK[n]. The counter retains its value after the timer is disabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TMR_CNT_Struct
 *! \brief  Timer n Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TMR_CNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Counter Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TMR_CNT_t;

/*@}*/

/** @defgroup TMR_PER Timer n Period Register (TMR_PER) Register
 *  Timer n Period Register (TMR_PER) Register.
 *
 *  The TMR[n]_PER register holds the period value for the corresponding timer. This register's use is based on the selected timer mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TMR_PER_Struct
 *! \brief  Timer n Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TMR_PER_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Period Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TMR_PER_t;

/*@}*/

/** @defgroup TMR_WID Timer n Width Register (TMR_WID) Register
 *  Timer n Width Register (TMR_WID) Register.
 *
 *  The TMR[n]_WID register holds the width value for the corresponding timer. This register's use is based on the selected timer mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TMR_WID_Struct
 *! \brief  Timer n Width Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TMR_WID_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Width Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TMR_WID_t;

/*@}*/

/** @defgroup TMR_DLY Timer n Delay Register (TMR_DLY) Register
 *  Timer n Delay Register (TMR_DLY) Register.
 *
 *  The TMR[n]_DLY register holds the delay value for the corresponding timer. This register's use is based on the selected timer mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TIMER_TMR_DLY_Struct
 *! \brief  Timer n Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TIMER_TMR_DLY_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Delay Value */
    };
    uint32_t VALUE32;
  };
} ADI_TIMER_TMR_DLY_t;

/*@}*/

/** @defgroup CFG Configuration Register (CFG) Register
 *  Configuration Register (CFG) Register.
 *
 *  The CFG register configures counter modes, configures input pins, and enable the CNT.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_CNT_CFG_EN
 *! \brief  Counter Enable (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_CNTDIS = 0,  /**< Counter Disable */
  CNT_CFG_CNTEN  = 1   /**< Counter Enable  */
} ADI_CNT_CFG_EN;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_DEBEN
 *! \brief  Debounce Enable (DEBEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_DEBDIS = 0,  /**< Disable */
  CNT_CFG_DEBEN  = 1   /**< Enable  */
} ADI_CNT_CFG_DEBEN;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_CDGINV
 *! \brief  CDG Pin Polarity Invert (CDGINV) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_CDGINV_AHI = 0,  /**< Active High, Rising Edge */
  CNT_CFG_CDGINV_ALO = 1   /**< Active Low, Falling Edge */
} ADI_CNT_CFG_CDGINV;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_CUDINV
 *! \brief  CUD Pin Polarity Invert (CUDINV) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_CUDINV_AHI = 0,  /**< Active High, Rising Edge */
  CNT_CFG_CUDINV_ALO = 1   /**< Active Low, Falling Edge */
} ADI_CNT_CFG_CUDINV;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_CZMINV
 *! \brief  CZM Pin Polarity Invert (CZMINV) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_CZMINV_AHI = 0,  /**< Active High, Rising Edge */
  CNT_CFG_CZMINV_ALO = 1   /**< Active Low, Falling Edge */
} ADI_CNT_CFG_CZMINV;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_CNTMODE
 *! \brief  Counter Operating Mode (CNTMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_CNTMODE_QUADENC = 0,  /**< QUAD_ENC */
  CNT_CFG_CNTMODE_BINENC  = 1,  /**< BIN_ENC  */
  CNT_CFG_CNTMODE_UDCNT   = 2,  /**< UD_CNT   */
  CNT_CFG_CNTMODE_DIRCNT  = 4,  /**< DIR_CNT  */
  CNT_CFG_CNTMODE_DIRTMR  = 5   /**< DIR_TMR  */
} ADI_CNT_CFG_CNTMODE;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_ZMZC
 *! \brief  CZM Zeroes Counter Enable (ZMZC) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_ZMZC_DIS = 0,  /**< Disable */
  CNT_CFG_ZMZC_EN  = 1   /**< Enable  */
} ADI_CNT_CFG_ZMZC;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_BNDMODE
 *! \brief  Boundary Register Mode (BNDMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_BNDMODE_BNDCOMP = 0,  /**< BND_COMP */
  CNT_CFG_BNDMODE_BINENC  = 1,  /**< BIN_ENC  */
  CNT_CFG_BNDMODE_BNDCAPT = 2,  /**< BND_CAPT */
  CNT_CFG_BNDMODE_BNDAEXT = 3   /**< BND_AEXT */
} ADI_CNT_CFG_BNDMODE;


/*  =========================================================================
 *! \enum   ADI_CNT_CFG_INPDIS
 *! \brief  CUD and CDG Pin Input Disable (INPDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_CFG_NO_INPDIS = 0,  /**< Enable            */
  CNT_CFG_INPDIS    = 1   /**< Pin Input Disable */
} ADI_CNT_CFG_INPDIS;


/* ==========================================================================
 *! \struct ADI_CNT_CFG_Struct
 *! \brief  Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_CFG_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Counter Enable */
      unsigned int DEBEN      :  1;  /**< Debounce Enable */
      unsigned int DIVEN      :  1;  /**< Divider Enable */
      unsigned int DIVNTV     :  1;  /**< Non-debounced Inputs to Divider Enable */
      unsigned int CDGINV     :  1;  /**< CDG Pin Polarity Invert */
      unsigned int CUDINV     :  1;  /**< CUD Pin Polarity Invert */
      unsigned int CZMINV     :  1;  /**< CZM Pin Polarity Invert */
      unsigned int DIVMODE    :  1;  /**< Divider mode */
      unsigned int CNTMODE    :  3;  /**< Counter Operating Mode */
      unsigned int ZMZC       :  1;  /**< CZM Zeroes Counter Enable */
      unsigned int BNDMODE    :  2;  /**< Boundary Register Mode */
      unsigned int reserved14 :  1;
      unsigned int INPDIS     :  1;  /**< CUD and CDG Pin Input Disable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_CFG_t;

/*@}*/

/** @defgroup IMSK Interrupt Mask Register (IMSK) Register
 *  Interrupt Mask Register (IMSK) Register.
 *
 *  The IMSK register supports enabling (unmasking) interrupt request generation from each of the CNT events. 
 *  All bits in IMSK either disable/mask an interrupt (if bit cleared) or enable/unmask an interrupt (if bit set).
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_IC
 *! \brief  Illegal Gray/Binary Code Interrupt Enable (IC) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_IC_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_IC_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_IC;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_UC
 *! \brief  Upcount Interrupt Enable (UC) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_UC_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_UC_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_UC;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_DC
 *! \brief  Downcount Interrupt Enable (DC) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_DC_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_DC_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_DC;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_MINC
 *! \brief  Min Count Interrupt Enable (MINC) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_MINC_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_MINC_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_MINC;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_MAXC
 *! \brief  Max Count Interrupt Enable (MAXC) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_MAXC_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_MAXC_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_MAXC;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_COV31
 *! \brief  Bit 31 Overflow Interrupt Enable (COV31) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_COV31_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_COV31_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_COV31;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_COV15
 *! \brief  Bit 15 Overflow Interrupt Enable (COV15) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_COV15_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_COV15_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_COV15;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_CZERO
 *! \brief  CNT_CNTR Counts To Zero Interrupt Enable (CZERO) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_CZERO_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_CZERO_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_CZERO;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_CZM
 *! \brief  CZM Pin/Pushbutton Interrupt Enable (CZM) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_CZM_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_CZM_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_CZM;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_CZME
 *! \brief  Zero Marker Error Interrupt Enable (CZME) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_CZME_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_CZME_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_CZME;


/*  =========================================================================
 *! \enum   ADI_CNT_IMSK_CZMZ
 *! \brief  Counter Zeroed by Zero Marker Interrupt Enable (CZMZ) Enumerations
 *  ========================================================================= */
typedef enum
{
  CNT_IMSK_CZMZ_MSK  = 0,  /**< Mask Interrupt   */
  CNT_IMSK_CZMZ_UMSK = 1   /**< Unmask Interrupt */
} ADI_CNT_IMSK_CZMZ;


/* ==========================================================================
 *! \struct ADI_CNT_IMSK_Struct
 *! \brief  Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_IMSK_t {
  union {
    struct {
      unsigned int IC         :  1;  /**< Illegal Gray/Binary Code Interrupt Enable */
      unsigned int UC         :  1;  /**< Upcount Interrupt Enable */
      unsigned int DC         :  1;  /**< Downcount Interrupt Enable */
      unsigned int MINC       :  1;  /**< Min Count Interrupt Enable */
      unsigned int MAXC       :  1;  /**< Max Count Interrupt Enable */
      unsigned int COV31      :  1;  /**< Bit 31 Overflow Interrupt Enable */
      unsigned int COV15      :  1;  /**< Bit 15 Overflow Interrupt Enable */
      unsigned int CZERO      :  1;  /**< CNT_CNTR Counts To Zero Interrupt Enable */
      unsigned int CZM        :  1;  /**< CZM Pin/Pushbutton Interrupt Enable */
      unsigned int CZME       :  1;  /**< Zero Marker Error Interrupt Enable */
      unsigned int CZMZ       :  1;  /**< Counter Zeroed by Zero Marker Interrupt Enable */
      unsigned int STP        :  1;  /**< Stop Detect Interrupt Enable */
      unsigned int MERR       :  1;  /**< M Value Programming Error Interrupt Enable */
      unsigned int DERR       :  1;  /**< Direction Error Interrupt Enable */
      unsigned int DCHNG      :  1;  /**< Direction Change Interrupt Enable */
      unsigned int reserved15 : 17;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_IMSK_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register provides status information for each of the CNT events as configured in the IMSK register. When a CNT event is detected, the corresponding bit in this register is set. It remains set until either software writes a 1 to the bit (write-1-to-clear) or the CNT is disabled.. 
 *  All bits in STAT indicate either no interrupt pending (if bit cleared) or an interrupt pending (if bit set).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_STAT_t {
  union {
    struct {
      unsigned int IC         :  1;  /**< Illegal Gray/Binary Code Interrupt */
      unsigned int UC         :  1;  /**< Up Count Interrupt */
      unsigned int DC         :  1;  /**< Down Count Interrupt */
      unsigned int MINC       :  1;  /**< Min Count Interrupt */
      unsigned int MAXC       :  1;  /**< Max Count Interrupt */
      unsigned int COV31      :  1;  /**< Bit 31 Overflow Interrupt */
      unsigned int COV15      :  1;  /**< Bit 15 Overflow Interrupt */
      unsigned int CZERO      :  1;  /**< CNT_CNTR Counts To Zero Interrupt */
      unsigned int CZM        :  1;  /**< CZM Pin/Pushbutton Interrupt */
      unsigned int CZME       :  1;  /**< Zero Marker Error Interrupt */
      unsigned int CZMZ       :  1;  /**< Counter Zeroed By Zero Marker Interrupt */
      unsigned int STP        :  1;  /**< Stop Detect Interrupt */
      unsigned int MERR       :  1;  /**< M Value Programming Error Interrupt */
      unsigned int DERR       :  1;  /**< Direction Error Interrupt */
      unsigned int DCHNG      :  1;  /**< Direction Change Interrupt Enable */
      unsigned int reserved15 : 17;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_STAT_t;

/*@}*/

/** @defgroup CMD Command Register (CMD) Register
 *  Command Register (CMD) Register.
 *
 *  The CMD register configures the CNT, enabling operations such as zeroing a counter register and copying or swapping boundary registers. These actions are taken by setting the appropriate bit. 
 *  Read operations from this register do not return meaningful values, with the exception of the W1ZMONCE bit, where a set bit indicates that the bit has been set by software before, but a zero marker event has not yet been detected on the ZM pin yet. For more information, see the CNT functional description. 
 *  The CNTR, MIN, and MAX registers can be initialized to zero by setting the W1LCNTZERO, W1LMINZERO, and W1LMAXZERO bits. In addition to clearing registers, CMD permits modifying the MIN and MAX boundary registers in a number of ways. The current counter value in CNTR can be captured and loaded into either of the two boundary registers to create new boundary limits. This operation is performed by setting the W1LMAXCNT and W1LMINCNT bits. Alternatively, the counter can be loaded from MAX or MIN using the W1LCNTMAX and W1LCNTMIN bits. It is also possible to transfer the current MAX value into MIN (or vice versa) through the W1LMINMAX and W1LMAXMIN bits.
 *  
 *  Another counter operation is the ability to only have the zero marker clear the CNTR register once. 
 *  
 *  For more information, see the CNT functional description. 
 *  It is possible for multiple actions to be performed simultaneously by setting multiple bits in the CMD register, but there are restrictions. The bits associated with each command have been grouped together such that all bits that involve a write to the CNTR, MAX, or MIN are located within bits 4-bit groups of the CMD register. 
 *  Note that a maximum of three commands can be issued at any one time, excluding the W1ZMONCE command. Also note that W1LCNTMIN, W1LCNTMAX, and W1LCNTZERO bits have to be used exclusively. Never set more than one of them at the same time.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_CMD_Struct
 *! \brief  Command Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_CMD_t {
  union {
    struct {
      unsigned int W1LCNTZERO :  1;  /**< Write 1 CNTR to Zero */
      unsigned int reserved1  :  1;
      unsigned int W1LCNTMIN  :  1;  /**< Write 1 CNTR Load from MIN */
      unsigned int W1LCNTMAX  :  1;  /**< Write 1 CNTR Load from MAX */
      unsigned int W1LMINZERO :  1;  /**< Write 1 MIN to Zero */
      unsigned int W1LMINCNT  :  1;  /**< Write 1 MIN Capture from CNTR */
      unsigned int reserved6  :  1;
      unsigned int W1LMINMAX  :  1;  /**< Write 1 MIN Copy from MAX */
      unsigned int W1LMAXZERO :  1;  /**< Write 1 MAX to Zero */
      unsigned int W1LMAXCNT  :  1;  /**< Write 1 MAX Capture from CNTR */
      unsigned int W1LMAXMIN  :  1;  /**< Write 1 MAX Copy from MIN */
      unsigned int reserved11 :  1;
      unsigned int W1ZMONCE   :  1;  /**< Write 1 Zero Marker Clear Once Enable */
      unsigned int reserved13 : 19;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_CMD_t;

/*@}*/

/** @defgroup DEBNCE Debounce Register (DEBNCE) Register
 *  Debounce Register (DEBNCE) Register.
 *
 *  The DEBNCE register selects the noise filtering characteristic of the three input pins according to the formula: 
 *  t$[sub$]filter$[/sub$] = 128 x (2$[sup$]DPRESCALE$[/sup$]/SCLK)
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_DEBNCE_Struct
 *! \brief  Debounce Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_DEBNCE_t {
  union {
    struct {
      unsigned int DPRESCALE  :  5;  /**< Debounce Prescale */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_DEBNCE_t;

/*@}*/

/** @defgroup CNTR Counter Register (CNTR) Register
 *  Counter Register (CNTR) Register.
 *
 *  The CNTR register holds the 32-bit, twos-complement count value. It can be read and written at any time. Hardware ensures that reads and write are atomic, by providing respective shadow registers. This register can be accessed with either 32-bit or 16-bit operations. This allows use of the CNTas a 16-bit counter if sufficient for the application.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_CNTR_Struct
 *! \brief  Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_CNTR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< CNTR Value */
    };
    uint32_t VALUE32;
  };
} ADI_CNT_CNTR_t;

/*@}*/

/** @defgroup MAX Maximum Count Register (MAX) Register
 *  Maximum Count Register (MAX) Register.
 *
 *  The MAX register holds the 32-bit, twos-complement, higher boundary value. It can be read and written at any time. Hardware ensures that reads and write are atomic, by providing respective shadow registers. This register can be accessed with either 32-bit or 16-bit operations. This allows for using the CNT as a 16-bit counter if sufficient for the application.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_MAX_Struct
 *! \brief  Maximum Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_MAX_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< MAX Value */
    };
    uint32_t VALUE32;
  };
} ADI_CNT_MAX_t;

/*@}*/

/** @defgroup MIN Minimum Count Register (MIN) Register
 *  Minimum Count Register (MIN) Register.
 *
 *  The MIN register holds the 32-bit, twos-complement, lower boundary value. It can be read and written at any time. Hardware ensures that reads and write are atomic, by providing respective shadow registers. This register can be accessed with either 32-bit or 16-bit operations. This allows for using the CNT as a 16-bit counter if sufficient for the application.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_MIN_Struct
 *! \brief  Minimum Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_MIN_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< MIN Value */
    };
    uint32_t VALUE32;
  };
} ADI_CNT_MIN_t;

/*@}*/

/** @defgroup MDIV M Value for Divider (MDIV) Register
 *  M Value for Divider (MDIV) Register.
 *
 *  The MDIV register determines the M value for the M/N division of the QEP inputs that are provided on the UD/DG pins.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_MDIV_Struct
 *! \brief  M Value for Divider Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_MDIV_t {
  union {
    struct {
      unsigned int MDIV       : 16;  /**< M Value for Divider */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_MDIV_t;

/*@}*/

/** @defgroup NDIV N Value for Divider (NDIV) Register
 *  N Value for Divider (NDIV) Register.
 *
 *  The NDIV register determines the N value for the M/N division of the QEP inputs that are provided on the UD/DG pins.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CNT_NDIV_Struct
 *! \brief  N Value for Divider Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CNT_NDIV_t {
  union {
    struct {
      unsigned int NDIV       : 16;  /**< N Value for Divider */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CNT_NDIV_t;

/*@}*/

/** @defgroup CLKDIV SCL Clock Divider Register (CLKDIV) Register
 *  SCL Clock Divider Register (CLKDIV) Register.
 *
 *  During master mode operation, the CLKDIV holds values, which the TWI uses to create the high and low durations of the serial clock (SCL). The clock signal SCL is an output in master mode and an input in slave mode. The values in the CLKLO and CLKHI fields add up to the CLKDIV value the following equation. 
 *  
 *  CLKDIV = TWI SCL period / 10 MHz time reference 
 *  
 *  Serial clock frequencies can vary from 400 KHz to less than 20 KHz. The resolution of the clock generated is 1/10 MHz or 100 ns. For example, for an SCL of 400 KHz (period = 1/400 KHz = 2500 ns) and an internal time reference of 10 MHz (period = 100 ns): 
 *  
 *  CLKDIV = 2500 ns / 100 ns = 25 
 *  
 *  For an SCL with a 30% duty cycle, use CLKLO = 17 and CLKHI = 8.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_CLKDIV_Struct
 *! \brief  SCL Clock Divider Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_CLKDIV_t {
  union {
    struct {
      unsigned int CLKLO      :  8;  /**< SCL Clock Low Periods */
      unsigned int CLKHI      :  8;  /**< SCL Clock High Periods */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_CLKDIV_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL enables the TWI, establishes a relationship between the system clock (SCLK) and the TWI controller's internally timed events, and enables SCCB compatibility.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_CTL_EN
 *! \brief  Enable Module (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_CTL_DIS = 0,  /**< Disable */
  TWI_CTL_EN  = 1   /**< Enable  */
} ADI_TWI_CTL_EN;


/*  =========================================================================
 *! \enum   ADI_TWI_CTL_SCCB
 *! \brief  SCCB Compatibility (SCCB) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_CTL_SCCB_DIS = 0,  /**< Disable SCCB compatibility */
  TWI_CTL_SCCB_EN  = 1   /**< Enable SCCB compatibility  */
} ADI_TWI_CTL_SCCB;


/* ==========================================================================
 *! \struct ADI_TWI_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_CTL_t {
  union {
    struct {
      unsigned int PRESCALE   :  7;  /**< SCLK Prescale Value */
      unsigned int EN         :  1;  /**< Enable Module */
      unsigned int reserved8  :  1;
      unsigned int SCCB       :  1;  /**< SCCB Compatibility */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_CTL_t;

/*@}*/

/** @defgroup SLVCTL Slave Mode Control Register (SLVCTL) Register
 *  Slave Mode Control Register (SLVCTL) Register.
 *
 *  The SLVCTL controls the logic associated with slave mode operation. Settings in this register do not affect master mode operation and should not be modified to control master mode functionality.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_SLVCTL_EN
 *! \brief  Enable Slave Mode (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_SLVCTL_DIS = 0,  /**< Disable */
  TWI_SLVCTL_EN  = 1   /**< Enable  */
} ADI_TWI_SLVCTL_EN;


/*  =========================================================================
 *! \enum   ADI_TWI_SLVCTL_TDVAL
 *! \brief  Transmit Data Valid for Slave (TDVAL) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_SLVCTL_INVALID = 0,  /**< Data Invalid for Slave Tx */
  TWI_SLVCTL_VALID   = 1   /**< Data Valid for Slave Tx   */
} ADI_TWI_SLVCTL_TDVAL;


/*  =========================================================================
 *! \enum   ADI_TWI_SLVCTL_NAK
 *! \brief  Not Acknowledge (NAK) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_SLVCTL_ACKGEN = 0,  /**< Generate ACK */
  TWI_SLVCTL_NAKGEN = 1   /**< Generate NAK */
} ADI_TWI_SLVCTL_NAK;


/*  =========================================================================
 *! \enum   ADI_TWI_SLVCTL_GEN
 *! \brief  General Call Enable (GEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_SLVCTL_GDIS = 0,  /**< Disable General Call Matching */
  TWI_SLVCTL_GEN  = 1   /**< Enable General Call Matching  */
} ADI_TWI_SLVCTL_GEN;


/* ==========================================================================
 *! \struct ADI_TWI_SLVCTL_Struct
 *! \brief  Slave Mode Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_SLVCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable Slave Mode */
      unsigned int reserved1  :  1;
      unsigned int TDVAL      :  1;  /**< Transmit Data Valid for Slave */
      unsigned int NAK        :  1;  /**< Not Acknowledge */
      unsigned int GEN        :  1;  /**< General Call Enable */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_SLVCTL_t;

/*@}*/

/** @defgroup SLVSTAT Slave Mode Status Register (SLVSTAT) Register
 *  Slave Mode Status Register (SLVSTAT) Register.
 *
 *  During and at the conclusion of register slave mode transfers, the SLVSTAT holds information on the current transfer. Generally slave mode status bits are not associated with the generation of interrupts. Master mode operation does not affect slave mode status bits.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_SLVSTAT_DIR
 *! \brief  Transfer Direction for Slave (DIR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_SLVSTAT_RX = 0,  /**< Slave Receive  */
  TWI_SLVSTAT_TX = 1   /**< Slave Transmit */
} ADI_TWI_SLVSTAT_DIR;


/*  =========================================================================
 *! \enum   ADI_TWI_SLVSTAT_GCALL
 *! \brief  General Call (GCALL) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_SLVSTAT_NO  = 0,  /**< Not a General Call Address */
  TWI_SLVSTAT_YES = 1   /**< General Call Address       */
} ADI_TWI_SLVSTAT_GCALL;


/* ==========================================================================
 *! \struct ADI_TWI_SLVSTAT_Struct
 *! \brief  Slave Mode Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_SLVSTAT_t {
  union {
    struct {
      unsigned int DIR        :  1;  /**< Transfer Direction for Slave */
      unsigned int GCALL      :  1;  /**< General Call */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_SLVSTAT_t;

/*@}*/

/** @defgroup SLVADDR Slave Mode Address Register (SLVADDR) Register
 *  Slave Mode Address Register (SLVADDR) Register.
 *
 *  The SLVADDR holds the slave mode address, which is the valid address to which the slave-enabled TWI controller responds. The TWI controller compares this value with the received address during the addressing phase of a transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_SLVADDR_Struct
 *! \brief  Slave Mode Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_SLVADDR_t {
  union {
    struct {
      unsigned int ADDR       :  7;  /**< Slave Mode Address */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_SLVADDR_t;

/*@}*/

/** @defgroup MSTRCTL Master Mode Control Registers (MSTRCTL) Register
 *  Master Mode Control Registers (MSTRCTL) Register.
 *
 *  The MSTRCTL controls the logic associated with master mode operation. Bits in this register do not affect slave mode operation and should not be modified to control slave mode functionality.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_EN
 *! \brief  Enable Master Mode (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_DIS = 0,  /**< Disable */
  TWI_MSTRCTL_EN  = 1   /**< Enable  */
} ADI_TWI_MSTRCTL_EN;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_DIR
 *! \brief  Transfer Direction for Master (DIR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_TX = 0,  /**< Master Transmit */
  TWI_MSTRCTL_RX = 1   /**< Master Receive  */
} ADI_TWI_MSTRCTL_DIR;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_FAST
 *! \brief  Fast Mode (FAST) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_SMODE = 0,  /**< Select Standard Mode */
  TWI_MSTRCTL_FAST  = 1   /**< Select Fast Mode     */
} ADI_TWI_MSTRCTL_FAST;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_STOP
 *! \brief  Issue Stop Condition (STOP) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_NORM = 0,  /**< Permit Normal Operation */
  TWI_MSTRCTL_STOP = 1   /**< Issue Stop              */
} ADI_TWI_MSTRCTL_STOP;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_RSTART
 *! \brief  Repeat Start (RSTART) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_END = 0,  /**< Disable Repeat Start */
  TWI_MSTRCTL_RPT = 1   /**< Enable Repeat Start  */
} ADI_TWI_MSTRCTL_RSTART;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_SDAOVR
 *! \brief  Serial Data Override (SDAOVR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_SDANORM = 0,  /**< Permit Normal SDA Operation   */
  TWI_MSTRCTL_SDAOVER = 1   /**< Override Normal SDA Operation */
} ADI_TWI_MSTRCTL_SDAOVR;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRCTL_SCLOVR
 *! \brief  Serial Clock Override (SCLOVR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRCTL_SCLNORM = 0,  /**< Permit Normal SCL Operation   */
  TWI_MSTRCTL_SCLOVER = 1   /**< Override Normal SCL Operation */
} ADI_TWI_MSTRCTL_SCLOVR;


/* ==========================================================================
 *! \struct ADI_TWI_MSTRCTL_Struct
 *! \brief  Master Mode Control Registers Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_MSTRCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable Master Mode */
      unsigned int reserved1  :  1;
      unsigned int DIR        :  1;  /**< Transfer Direction for Master */
      unsigned int FAST       :  1;  /**< Fast Mode */
      unsigned int STOP       :  1;  /**< Issue Stop Condition */
      unsigned int RSTART     :  1;  /**< Repeat Start */
      unsigned int DCNT       :  8;  /**< Data Transfer Count */
      unsigned int SDAOVR     :  1;  /**< Serial Data Override */
      unsigned int SCLOVR     :  1;  /**< Serial Clock Override */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_MSTRCTL_t;

/*@}*/

/** @defgroup MSTRSTAT Master Mode Status Register (MSTRSTAT) Register
 *  Master Mode Status Register (MSTRSTAT) Register.
 *
 *  The MSTRSTAT holds information during master mode transfers and at their conclusion. Generally, master mode status bits are not directly associated with the generation of interrupts, but these bits offer information on the current transfer. Slave mode operation does not affect master mode status bits. 
 *  
 *  Note that while SCLSEN is set (this condition could be due to having no pull-up resistor on SCL or another agent is driving SCL low), the acknowledge bits (ANAK and DNAK) do not update. This result occurs because the acknowledge conditions are sampled during the high phase of SCL.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_MPROG
 *! \brief  Master Transfer in Progress (MPROG) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_MPROG_NO  = 0,  /**< No Status                   */
  TWI_MSTRSTAT_MPROG_YES = 1   /**< Master Transfer in Progress */
} ADI_TWI_MSTRSTAT_MPROG;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_LOSTARB
 *! \brief  Lost Arbitration (LOSTARB) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_LOSTARB_NO  = 0,  /**< No Status        */
  TWI_MSTRSTAT_LOSTARB_YES = 1   /**< Lost Arbitration */
} ADI_TWI_MSTRSTAT_LOSTARB;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_ANAK
 *! \brief  Address Not Acknowledged (ANAK) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_ANAK_NO  = 0,  /**< No Status   */
  TWI_MSTRSTAT_ANAK_YES = 1   /**< Address NAK */
} ADI_TWI_MSTRSTAT_ANAK;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_DNAK
 *! \brief  Data Not Acknowledged (DNAK) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_DNAK_NO  = 0,  /**< No Status */
  TWI_MSTRSTAT_DNAK_YES = 1   /**< Data NAK  */
} ADI_TWI_MSTRSTAT_DNAK;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_BUFRDERR
 *! \brief  Buffer Read Error (BUFRDERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_BUFRDERR_NO  = 0,  /**< No Status         */
  TWI_MSTRSTAT_BUFRDERR_YES = 1   /**< Buffer Read Error */
} ADI_TWI_MSTRSTAT_BUFRDERR;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_BUFWRERR
 *! \brief  Buffer Write Error (BUFWRERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_BUFWRERR_NO  = 0,  /**< No Status          */
  TWI_MSTRSTAT_BUFWRERR_YES = 1   /**< Buffer Write Error */
} ADI_TWI_MSTRSTAT_BUFWRERR;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_SDASEN
 *! \brief  Serial Data Sense (SDASEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_SDASEN_NO  = 0,  /**< SDA Inactive "One" */
  TWI_MSTRSTAT_SDASEN_YES = 1   /**< SDA Active "Zero"  */
} ADI_TWI_MSTRSTAT_SDASEN;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_SCLSEN
 *! \brief  Serial Clock Sense (SCLSEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_SCLSEN_NO  = 0,  /**< SCL Inactive "One" */
  TWI_MSTRSTAT_SCLSEN_YES = 1   /**< SCL Active "Zero"  */
} ADI_TWI_MSTRSTAT_SCLSEN;


/*  =========================================================================
 *! \enum   ADI_TWI_MSTRSTAT_BUSBUSY
 *! \brief  Bus Busy (BUSBUSY) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_MSTRSTAT_FREE = 0,  /**< Bus Free */
  TWI_MSTRSTAT_BUSY = 1   /**< Bus Busy */
} ADI_TWI_MSTRSTAT_BUSBUSY;


/* ==========================================================================
 *! \struct ADI_TWI_MSTRSTAT_Struct
 *! \brief  Master Mode Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_MSTRSTAT_t {
  union {
    struct {
      unsigned int MPROG      :  1;  /**< Master Transfer in Progress */
      unsigned int LOSTARB    :  1;  /**< Lost Arbitration */
      unsigned int ANAK       :  1;  /**< Address Not Acknowledged */
      unsigned int DNAK       :  1;  /**< Data Not Acknowledged */
      unsigned int BUFRDERR   :  1;  /**< Buffer Read Error */
      unsigned int BUFWRERR   :  1;  /**< Buffer Write Error */
      unsigned int SDASEN     :  1;  /**< Serial Data Sense */
      unsigned int SCLSEN     :  1;  /**< Serial Clock Sense */
      unsigned int BUSBUSY    :  1;  /**< Bus Busy */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_MSTRSTAT_t;

/*@}*/

/** @defgroup MSTRADDR Master Mode Address Register (MSTRADDR) Register
 *  Master Mode Address Register (MSTRADDR) Register.
 *
 *  During the addressing phase of a transfer, the TWI controller, with its master enabled, transmits the contents of MSTRADDR. When programming this register, omit the read/write bit. That is, only the upper 7 bits that make up the slave address should be written to this register. For example, if the slave address is b#1010000X, where X is the read/write bit, the MSTRADDR is programmed with b#1010000, which corresponds to 0x50. When sending out the address on the bus, the TWI controller appends the read/write bit as appropriate based on the state of the MSTRCTL:DIR bit.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_MSTRADDR_Struct
 *! \brief  Master Mode Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_MSTRADDR_t {
  union {
    struct {
      unsigned int ADDR       :  7;  /**< Master Mode Address */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_MSTRADDR_t;

/*@}*/

/** @defgroup ISTAT Interrupt Status Register (ISTAT) Register
 *  Interrupt Status Register (ISTAT) Register.
 *
 *  The ISTAT contains information about functional areas requiring servicing. Many of the bits serve as an indicator to further read and service various status registers. After servicing the interrupt source associated with a bit, the user must clear that interrupt source bit by writing a 1 to it.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_SINIT
 *! \brief  Slave Transfer Initiated (SINIT) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_SINIT_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_SINIT_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_SINIT;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_SCOMP
 *! \brief  Slave Transfer Complete (SCOMP) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_SCOMP_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_SCOMP_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_SCOMP;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_SERR
 *! \brief  Slave Transfer Error (SERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_SERR_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_SERR_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_SERR;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_SOVF
 *! \brief  Slave Overflow (SOVF) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_SOVF_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_SOVF_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_SOVF;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_MCOMP
 *! \brief  Master Transfer Complete (MCOMP) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_MCOMP_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_MCOMP_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_MCOMP;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_MERR
 *! \brief  Master Transfer Error (MERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_MERR_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_MERR_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_MERR;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_TXSERV
 *! \brief  Tx FIFO Service (TXSERV) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_TXSERV_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_TXSERV_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_TXSERV;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_RXSERV
 *! \brief  Rx FIFO Service (RXSERV) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_RXSERV_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_RXSERV_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_RXSERV;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_SDAI
 *! \brief  Serial Data Interrupt (SDAI) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_SDAI_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_SDAI_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_SDAI;


/*  =========================================================================
 *! \enum   ADI_TWI_ISTAT_SCLI
 *! \brief  Serial Clock Interrupt (SCLI) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_ISTAT_SCLI_NO  = 0,  /**< No Interrupt       */
  TWI_ISTAT_SCLI_YES = 1   /**< Interrupt Detected */
} ADI_TWI_ISTAT_SCLI;


/* ==========================================================================
 *! \struct ADI_TWI_ISTAT_Struct
 *! \brief  Interrupt Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_ISTAT_t {
  union {
    struct {
      unsigned int SINIT      :  1;  /**< Slave Transfer Initiated */
      unsigned int SCOMP      :  1;  /**< Slave Transfer Complete */
      unsigned int SERR       :  1;  /**< Slave Transfer Error */
      unsigned int SOVF       :  1;  /**< Slave Overflow */
      unsigned int MCOMP      :  1;  /**< Master Transfer Complete */
      unsigned int MERR       :  1;  /**< Master Transfer Error */
      unsigned int TXSERV     :  1;  /**< Tx FIFO Service */
      unsigned int RXSERV     :  1;  /**< Rx FIFO Service */
      unsigned int reserved8  :  6;
      unsigned int SDAI       :  1;  /**< Serial Data Interrupt */
      unsigned int SCLI       :  1;  /**< Serial Clock Interrupt */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_ISTAT_t;

/*@}*/

/** @defgroup IMSK Interrupt Mask Register (IMSK) Register
 *  Interrupt Mask Register (IMSK) Register.
 *
 *  The IMSK enables interrupt sources to assert the interrupt output. Each mask bit corresponds with one interrupt source bit in ISTAT. Reading and writing IMSK does not affect the contents of the ISTAT.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_SINIT
 *! \brief  Slave Transfer Initiated Interrupt Mask (SINIT) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_SINIT_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_SINIT_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_SINIT;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_SCOMP
 *! \brief  Slave Transfer Complete Interrupt Mask (SCOMP) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_SCOMP_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_SCOMP_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_SCOMP;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_SERR
 *! \brief  Slave Transfer Error Interrupt Mask (SERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_SERR_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_SERR_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_SERR;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_SOVF
 *! \brief  Slave Overflow Interrupt Mask (SOVF) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_SOVF_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_SOVF_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_SOVF;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_MCOMP
 *! \brief  Master Transfer Complete Interrupt Mask (MCOMP) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_MCOMP_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_MCOMP_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_MCOMP;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_MERR
 *! \brief  Master Transfer Error Interrupt Mask (MERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_MERR_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_MERR_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_MERR;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_TXSERV
 *! \brief  Tx FIFO Service Interrupt Mask (TXSERV) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_TXSERV_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_TXSERV_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_TXSERV;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_RXSERV
 *! \brief  Rx FIFO Service Interrupt Mask (RXSERV) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_RXSERV_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_RXSERV_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_RXSERV;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_SDAI
 *! \brief  Serial Data Interrupt Mask (SDAI) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_SDAI_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_SDAI_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_SDAI;


/*  =========================================================================
 *! \enum   ADI_TWI_IMSK_SCLI
 *! \brief  Serial Clock Interrupt Mask (SCLI) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_IMSK_SCLI_MSK  = 0,  /**< Mask (Disable) Interrupt  */
  TWI_IMSK_SCLI_UMSK = 1   /**< Unmask (Enable) Interrupt */
} ADI_TWI_IMSK_SCLI;


/* ==========================================================================
 *! \struct ADI_TWI_IMSK_Struct
 *! \brief  Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_IMSK_t {
  union {
    struct {
      unsigned int SINIT      :  1;  /**< Slave Transfer Initiated Interrupt Mask */
      unsigned int SCOMP      :  1;  /**< Slave Transfer Complete Interrupt Mask */
      unsigned int SERR       :  1;  /**< Slave Transfer Error Interrupt Mask */
      unsigned int SOVF       :  1;  /**< Slave Overflow Interrupt Mask */
      unsigned int MCOMP      :  1;  /**< Master Transfer Complete Interrupt Mask */
      unsigned int MERR       :  1;  /**< Master Transfer Error Interrupt Mask */
      unsigned int TXSERV     :  1;  /**< Tx FIFO Service Interrupt Mask */
      unsigned int RXSERV     :  1;  /**< Rx FIFO Service Interrupt Mask */
      unsigned int reserved8  :  6;
      unsigned int SDAI       :  1;  /**< Serial Data Interrupt Mask */
      unsigned int SCLI       :  1;  /**< Serial Clock Interrupt Mask */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_IMSK_t;

/*@}*/

/** @defgroup FIFOCTL FIFO Control Register (FIFOCTL) Register
 *  FIFO Control Register (FIFOCTL) Register.
 *
 *  The FIFOCTL control bits affect only the FIFO and are not tied in any way with master or slave mode operation.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_TWI_FIFOCTL_TXFLUSH
 *! \brief  Tx Buffer Flush (TXFLUSH) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_FIFOCTL_TXNORM  = 0,  /**< Normal Operation of Tx Buffer */
  TWI_FIFOCTL_TXFLUSH = 1   /**< Flush Tx Buffer               */
} ADI_TWI_FIFOCTL_TXFLUSH;


/*  =========================================================================
 *! \enum   ADI_TWI_FIFOCTL_RXFLUSH
 *! \brief  Rx Buffer Flush (RXFLUSH) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_FIFOCTL_RXNORM  = 0,  /**< Normal Operation of Rx Buffer */
  TWI_FIFOCTL_RXFLUSH = 1   /**< Flush Rx Buffer               */
} ADI_TWI_FIFOCTL_RXFLUSH;


/*  =========================================================================
 *! \enum   ADI_TWI_FIFOCTL_TXILEN
 *! \brief  Tx Buffer Interrupt Length (TXILEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_FIFOCTL_TXONEBYTE = 0,  /**< TXSERVI on 1 Byte of FIFO Empty  */
  TWI_FIFOCTL_TXTWOBYTE = 1   /**< TXSERVI on 2 Bytes of FIFO Empty */
} ADI_TWI_FIFOCTL_TXILEN;


/*  =========================================================================
 *! \enum   ADI_TWI_FIFOCTL_RXILEN
 *! \brief  Rx Buffer Interrupt Length (RXILEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  TWI_FIFOCTL_RXONEBYTE = 0,  /**< RXSERVI on 1 or 2 Bytes in FIFO */
  TWI_FIFOCTL_RXTWOBYTE = 1   /**< RXSERVI on 2 Bytes in FIFO      */
} ADI_TWI_FIFOCTL_RXILEN;


/* ==========================================================================
 *! \struct ADI_TWI_FIFOCTL_Struct
 *! \brief  FIFO Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_FIFOCTL_t {
  union {
    struct {
      unsigned int TXFLUSH    :  1;  /**< Tx Buffer Flush */
      unsigned int RXFLUSH    :  1;  /**< Rx Buffer Flush */
      unsigned int TXILEN     :  1;  /**< Tx Buffer Interrupt Length */
      unsigned int RXILEN     :  1;  /**< Rx Buffer Interrupt Length */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_FIFOCTL_t;

/*@}*/

/** @defgroup FIFOSTAT FIFO Status Register (FIFOSTAT) Register
 *  FIFO Status Register (FIFOSTAT) Register.
 *
 *  The FIFOSTAT fields indicate the state of the FIFO buffers' receive and transmit contents. The FIFO buffers do not discriminate between master data and slave data. By using the status and control bits provided, the FIFO can be managed to allow simultaneous master and slave operation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_FIFOSTAT_Struct
 *! \brief  FIFO Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_FIFOSTAT_t {
  union {
    struct {
      unsigned int TXSTAT     :  2;  /**< Tx FIFO Status */
      unsigned int RXSTAT     :  2;  /**< Rx FIFO Status */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_FIFOSTAT_t;

/*@}*/

/** @defgroup TXDATA8 Tx Data Single-Byte Register (TXDATA8) Register
 *  Tx Data Single-Byte Register (TXDATA8) Register.
 *
 *  The TXDATA8 register holds an 8-bit data value written into the FIFO buffer. Transmit data is entered into the corresponding transmit buffer in a first-in first-out order. For 16-bit peripheral bus writes, a write access to this register adds only one transmit data byte to the FIFO buffer. With each access, the transmit status (FIFOSTAT:TXSTAT) field is updated. If an access is performed while the FIFO buffer is full, the write is ignored and the existing FIFO buffer data and its status remains unchanged. This register returns zero when read back.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_TXDATA8_Struct
 *! \brief  Tx Data Single-Byte Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_TXDATA8_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< Tx Data 8-Bit Value */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_TXDATA8_t;

/*@}*/

/** @defgroup TXDATA16 Tx Data Double-Byte Register (TXDATA16) Register
 *  Tx Data Double-Byte Register (TXDATA16) Register.
 *
 *  The TXDATA16 register holds a 16-bit data value written into the FIFO buffer. To reduce interrupt output rates and peripheral bus access times, a double byte transfer data access can be done. Two data bytes can be written, effectively filling the transmit FIFO buffer with a single access. 
 *  
 *  The data is written in little endian byte order, where byte 0 is the first byte to be transferred and byte 1 is the second byte to be transferred. With each access, the transmit status (FIFOSTAT:TXSTAT) field is updated. If an access is performed while the FIFO buffer is not empty, the write is ignored and the existing FIFO buffer data and its status remains unchanged. This register when read back returns zero.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_TXDATA16_Struct
 *! \brief  Tx Data Double-Byte Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_TXDATA16_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Tx Data 16-Bit Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_TXDATA16_t;

/*@}*/

/** @defgroup RXDATA8 Rx Data Single-Byte Register (RXDATA8) Register
 *  Rx Data Single-Byte Register (RXDATA8) Register.
 *
 *  The RXDATA8 holds an 8-bit data value read from the FIFO buffer. Receive data is read from the corresponding receive buffer in a first-in first-out order. Although peripheral bus reads are 16 bits, a read access to RXDATA8 accesses only one transmit data byte from the FIFO buffer. With each access, the receive status (FIFOSTAT:RXSTAT) field is updated. If an access is performed while the FIFO buffer is empty, the data is unknown and the FIFO buffer status remains indicating it is empty.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_RXDATA8_Struct
 *! \brief  Rx Data Single-Byte Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_RXDATA8_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< Rx Data 8-Bit Value */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_RXDATA8_t;

/*@}*/

/** @defgroup RXDATA16 Rx Data Double-Byte Register (RXDATA16) Register
 *  Rx Data Double-Byte Register (RXDATA16) Register.
 *
 *  The RXDATA16 holds a 16-bit data value read from the FIFO buffer. To reduce interrupt output rates and peripheral bus access times, a double byte receive data access can be performed. Two data bytes can be read, effectively emptying the receive FIFO buffer with a single access. 
 *  
 *  The data is read in little endian byte order, where byte 0 is the first byte received and byte 1 is the second byte received. With each access, the receive status (FIFOSTAT:RXSTAT) field is updated to indicate it is empty. If an access is performed while the FIFO buffer is not full, the read data is unknown and the existing FIFO buffer data and its status remains unchanged.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TWI_RXDATA16_Struct
 *! \brief  Rx Data Double-Byte Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TWI_RXDATA16_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Rx Data 16-Bit Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TWI_RXDATA16_t;

/*@}*/

/** @defgroup MC1 Mailbox Configuration 1 Register (MC1) Register
 *  Mailbox Configuration 1 Register (MC1) Register.
 *
 *  The MC1 register enables mailboxes 0 through 15. Each bit in this register enables or disables the corresponding mailbox. For all bits, set the bit (=1) to enable the mailbox, and clear the bit (=0) to disable the mailbox. 
 *  Enabling and disabling mailboxes has an impact on transmit requests. Setting the TRS1 bit associated with a disabled mailbox may result in erroneous behavior. Similarly, disabling a mailbox before the associated TRS1 bit is reset by the internal logic can cause unpredictable results.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MC1_Struct
 *! \brief  Mailbox Configuration 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MC1_t {
  union {
    struct {
      unsigned int MB0        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB1        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB2        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB3        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB4        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB5        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB6        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB7        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB8        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB9        :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB10       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB11       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB12       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB13       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB14       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB15       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MC1_t;

/*@}*/

/** @defgroup MD1 Mailbox Direction 1 Register (MD1) Register
 *  Mailbox Direction 1 Register (MD1) Register.
 *
 *  The MD1 register selects the data transfer direction for mailboxes 0 through 15. Each bit in this register selects receive mode or transmit mode for the corresponding mailbox. For all bits, set the bit (=1) for receive mode from the mailbox, and clear the bit (=0) for transmit mode to the mailbox. Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MD1_Struct
 *! \brief  Mailbox Direction 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MD1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB9        :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB10       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB11       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB12       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB13       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB14       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB15       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MD1_t;

/*@}*/

/** @defgroup TRS1 Transmission Request Set 1 Register (TRS1) Register
 *  Transmission Request Set 1 Register (TRS1) Register.
 *
 *  The TRS1 register requests transmit for mailboxes 8 through 15. Bits in this register request transmit for the corresponding mailbox when set (=1). After writing the data and the identifier into the mailbox area, the message is sent after mailbox n is enabled (with the corresponding bit in MC1 = 1}, and (subsequently) the corresponding transmit request bit is set (in TRS1). When a transmission completes, the corresponding bits in TRS1 and in the transmit request reset register (TRR1) are cleared. Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TRS1_Struct
 *! \brief  Transmission Request Set 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TRS1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB9        :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB10       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB11       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB12       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB13       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB14       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB15       :  1;  /**< Mailbox n Transmit Request */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TRS1_t;

/*@}*/

/** @defgroup TRR1 Transmission Request Reset 1 Register (TRR1) Register
 *  Transmission Request Reset 1 Register (TRR1) Register.
 *
 *  The TRR1 register requests transmit abort for mailboxes 8 through 15. Bits in this register request transmit abort for the corresponding mailbox when set (=1). When a transmission completes, the corresponding bits in the transmit request set register (TRS1) and in the TRR1 are cleared. Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TRR1_Struct
 *! \brief  Transmission Request Reset 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TRR1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB9        :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB10       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB11       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB12       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB13       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB14       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB15       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TRR1_t;

/*@}*/

/** @defgroup TA1 Transmission Acknowledge 1 Register (TA1) Register
 *  Transmission Acknowledge 1 Register (TA1) Register.
 *
 *  The TA1 register indicates transmission success for mailboxes 8 through 15. Each bit in this register indicates transmission success for the corresponding mailbox when set (=1). Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TA1_Struct
 *! \brief  Transmission Acknowledge 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TA1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB9        :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB10       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB11       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB12       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB13       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB14       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB15       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TA1_t;

/*@}*/

/** @defgroup AA1 Abort Acknowledge 1 Register (AA1) Register
 *  Abort Acknowledge 1 Register (AA1) Register.
 *
 *  The AA1 register indicates transmission abort (due to lost arbitration or a CAN error) for mailboxes 8 through 15. Each bit in this register indicates transmission abort for the corresponding mailbox when set (=1). Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_AA1_Struct
 *! \brief  Abort Acknowledge 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_AA1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB9        :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB10       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB11       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB12       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB13       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB14       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB15       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_AA1_t;

/*@}*/

/** @defgroup RMP1 Receive Message Pending 1 Register (RMP1) Register
 *  Receive Message Pending 1 Register (RMP1) Register.
 *
 *  The RMP1 register indicates when a message is pending (unread data) for mailboxes 0 through 15. Each bit in this register indicates the message pending status for the corresponding mailbox when set (=1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_RMP1_Struct
 *! \brief  Receive Message Pending 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_RMP1_t {
  union {
    struct {
      unsigned int MB0        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB1        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB2        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB3        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB4        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB5        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB6        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB7        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB8        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB9        :  1;  /**< Mailbox n Message Pending */
      unsigned int MB10       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB11       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB12       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB13       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB14       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB15       :  1;  /**< Mailbox n Message Pending */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_RMP1_t;

/*@}*/

/** @defgroup RML1 Receive Message Lost 1 Register (RML1) Register
 *  Receive Message Lost 1 Register (RML1) Register.
 *
 *  The RML1 register indicates when a message is lost---due to a message coming while there is pending data (corresponding RMP1 bit set) and overwrite protection is disabled (OPSS1 bit cleared)---for mailboxes 0 through 15. Each bit in this register indicates the message lost status for the corresponding mailbox when set (=1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_RML1_Struct
 *! \brief  Receive Message Lost 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_RML1_t {
  union {
    struct {
      unsigned int MB0        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB1        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB2        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB3        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB4        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB5        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB6        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB7        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB8        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB9        :  1;  /**< Mailbox n Message Lost */
      unsigned int MB10       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB11       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB12       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB13       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB14       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB15       :  1;  /**< Mailbox n Message Lost */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_RML1_t;

/*@}*/

/** @defgroup MBTIF1 Mailbox Transmit Interrupt Flag 1 Register (MBTIF1) Register
 *  Mailbox Transmit Interrupt Flag 1 Register (MBTIF1) Register.
 *
 *  The MBTIF1 register indicates when a transmit interrupt is pending---due to successful transmission (corresponding TA1 bit set) and the interrupt is enabled (corresponding MBIM1 bit set)---for mailboxes 8 through 15. Each bit in this register indicates the transmit interrupt pending status for the corresponding mailbox when set (=1). When any bit in MBTIF1 is set, the CAN transmit interrupt request is raised (INT:MBTIRQ bit set). To clear the interrupt request, all of the set bits in MBTIF1 must be cleared by software (W1C). Also, software must clear the associated bits set in TA1 or set the associated bits in TRS1 bit to clear the interrupt source asserting the bits in MBTIF1. Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBTIF1_Struct
 *! \brief  Mailbox Transmit Interrupt Flag 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBTIF1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB9        :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB10       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB11       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB12       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB13       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB14       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB15       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBTIF1_t;

/*@}*/

/** @defgroup MBRIF1 Mailbox Receive Interrupt Flag 1 Register (MBRIF1) Register
 *  Mailbox Receive Interrupt Flag 1 Register (MBRIF1) Register.
 *
 *  The MBRIF1 register indicates when a receive interrupt is pending---due to successful reception (corresponding RMP1 bit set) and the interrupt is enabled (corresponding MBIM1 bit set)---for mailboxes 0 through 15. Each bit in this register indicates the receive interrupt pending status for the corresponding mailbox when set (=1). When any bit in MBRIF1 is set, the CAN receive interrupt request is raised (INT:MBRIRQ bit set). To clear the interrupt request, all of the set bits in RMP1 must be cleared by software, then the associated bits set in MBRIF1 must be cleared (W1C).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBRIF1_Struct
 *! \brief  Mailbox Receive Interrupt Flag 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBRIF1_t {
  union {
    struct {
      unsigned int MB0        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB1        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB2        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB3        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB4        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB5        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB6        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB7        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB8        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB9        :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB10       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB11       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB12       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB13       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB14       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB15       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBRIF1_t;

/*@}*/

/** @defgroup MBIM1 Mailbox Interrupt Mask 1 Register (MBIM1) Register
 *  Mailbox Interrupt Mask 1 Register (MBIM1) Register.
 *
 *  The MBIM1 register enables transmit and receive interrupts for mailboxes 0 through 15. Each bit in this register requests enables the transmit or receive interrupt for the corresponding mailbox when set (=1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBIM1_Struct
 *! \brief  Mailbox Interrupt Mask 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBIM1_t {
  union {
    struct {
      unsigned int MB0        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB1        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB2        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB3        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB4        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB5        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB6        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB7        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB8        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB9        :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB10       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB11       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB12       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB13       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB14       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB15       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBIM1_t;

/*@}*/

/** @defgroup RFH1 Remote Frame Handling 1 Register (RFH1) Register
 *  Remote Frame Handling 1 Register (RFH1) Register.
 *
 *  The RFH1 register enables remote frame handling for mailboxes 8 through 15. Each bit in this register enables remote frame handling for the corresponding mailbox when set (=1). Note that enabling this bit affects transmit and receive operations for mailboxes. For more information about remote frame handling, see the CAN Operating Modes sections, describing transmit and receive operations. Bits 0 through 7 are read-only, as the corresponding mailboxes are receive-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_RFH1_Struct
 *! \brief  Remote Frame Handling 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_RFH1_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int MB8        :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB9        :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB10       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB11       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB12       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB13       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB14       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB15       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_RFH1_t;

/*@}*/

/** @defgroup OPSS1 Overwrite Protection/Single Shot Transmission 1 Register (OPSS1) Register
 *  Overwrite Protection/Single Shot Transmission 1 Register (OPSS1) Register.
 *
 *  The OPSS1 register enables overwrite protection for mailboxes 0 through 15. Each bit in this register enables overwrite protection for the corresponding mailbox when set (=1). Note that enabling this bit affects transmit and receive operations for mailboxes. For more information about remote overwrite protection, see the detailed feature description in the CAN Functional Description section. For more information about how this feature affects transmit and receive operations, see the CAN Operating Modes sections, describing transmit and receive operations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_OPSS1_Struct
 *! \brief  Overwrite Protection/Single Shot Transmission 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_OPSS1_t {
  union {
    struct {
      unsigned int MB0        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB1        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB2        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB3        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB4        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB5        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB6        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB7        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB8        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB9        :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB10       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB11       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB12       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB13       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB14       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB15       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_OPSS1_t;

/*@}*/

/** @defgroup MC2 Mailbox Configuration 2 Register (MC2) Register
 *  Mailbox Configuration 2 Register (MC2) Register.
 *
 *  The MC2 register enables mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register enables or disables the corresponding mailbox. For all bits, set the bit (=1) to enable the mailbox, and clear the bit (=0) to disable the mailbox. 
 *  Enabling and disabling mailboxes has an impact on transmit requests. Setting the TRS2 bit associated with a disabled mailbox may result in erroneous behavior. Similarly, disabling a mailbox before the associated TRS2 bit is reset by the internal logic can cause unpredictable results.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MC2_Struct
 *! \brief  Mailbox Configuration 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MC2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB17       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB18       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB19       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB20       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB21       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB22       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB23       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB24       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB25       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB26       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB27       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB28       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB29       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB30       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int MB31       :  1;  /**< Mailbox n Enable/Disable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MC2_t;

/*@}*/

/** @defgroup MD2 Mailbox Direction 2 Register (MD2) Register
 *  Mailbox Direction 2 Register (MD2) Register.
 *
 *  The MD2 register selects the data transfer direction for mailboxes 16 (bit 0) through 23 (bit 7). Each bit in this register selects receive mode or transmit mode for the corresponding mailbox. For all bits, set the bit (=1) for receive mode from the mailbox, and clear the bit (=0) for transmit mode to the mailbox. Bits 8 through 15 are read-only, as the corresponding mailboxes (24 through 31) are transmit-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MD2_Struct
 *! \brief  Mailbox Direction 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MD2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB17       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB18       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB19       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB20       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB21       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB22       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int MB23       :  1;  /**< Mailbox n Transmit/Receive */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MD2_t;

/*@}*/

/** @defgroup TRS2 Transmission Request Set 2 Register (TRS2) Register
 *  Transmission Request Set 2 Register (TRS2) Register.
 *
 *  The TRS2 register requests transmit for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register requests transmit for the corresponding mailbox when set (=1). After writing the data and the identifier into the mailbox area, the message is sent after mailbox n is enabled (with the corresponding bit in MC2 = 1}, and (subsequently) the corresponding transmit request bit is set (in TRS2). When a transmission completes, the corresponding bits in TRS2 and in the transmit request reset register (TRR2) are cleared.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TRS2_Struct
 *! \brief  Transmission Request Set 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TRS2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB17       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB18       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB19       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB20       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB21       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB22       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB23       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB24       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB25       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB26       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB27       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB28       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB29       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB30       :  1;  /**< Mailbox n Transmit Request */
      unsigned int MB31       :  1;  /**< Mailbox n Transmit Request */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TRS2_t;

/*@}*/

/** @defgroup TRR2 Transmission Request Reset 2 Register (TRR2) Register
 *  Transmission Request Reset 2 Register (TRR2) Register.
 *
 *  The TRR2 register requests transmit abort for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register requests transmit abort for the corresponding mailbox when set (=1). When a transmission completes, the corresponding bits in the transmit request set register (TRS2) and in the TRR2 are cleared.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TRR2_Struct
 *! \brief  Transmission Request Reset 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TRR2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB17       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB18       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB19       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB20       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB21       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB22       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB23       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB24       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB25       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB26       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB27       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB28       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB29       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB30       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int MB31       :  1;  /**< Mailbox n Transmit Abort */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TRR2_t;

/*@}*/

/** @defgroup TA2 Transmission Acknowledge 2 Register (TA2) Register
 *  Transmission Acknowledge 2 Register (TA2) Register.
 *
 *  The TA2 register indicates transmission success for mailboxes 16 (bit 0)  through 31 (bit 15). Each bit in this register indicates transmission success for the corresponding mailbox when set (=1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TA2_Struct
 *! \brief  Transmission Acknowledge 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TA2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB17       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB18       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB19       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB20       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB21       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB22       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB23       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB24       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB25       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB26       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB27       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB28       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB29       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB30       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int MB31       :  1;  /**< Mailbox n Transmit Acknowledge */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TA2_t;

/*@}*/

/** @defgroup AA2 Abort Acknowledge 2 Register (AA2) Register
 *  Abort Acknowledge 2 Register (AA2) Register.
 *
 *  The AA2 register indicates transmission abort (due to lost arbitration or a CAN error) for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register indicates transmission abort for the corresponding mailbox when set (=1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_AA2_Struct
 *! \brief  Abort Acknowledge 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_AA2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB17       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB18       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB19       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB20       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB21       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB22       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB23       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB24       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB25       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB26       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB27       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB28       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB29       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB30       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int MB31       :  1;  /**< Mailbox n Abort Acknowledge */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_AA2_t;

/*@}*/

/** @defgroup RMP2 Receive Message Pending 2 Register (RMP2) Register
 *  Receive Message Pending 2 Register (RMP2) Register.
 *
 *  The RMP2 register indicates when a message is pending (unread data) for mailboxes 16 (bit 0) through 23 (bit 7). Each bit in this register indicates the message pending status for the corresponding mailbox when set (=1). Bits 8 through 15 are reserved, as the corresponding mailboxes (24 through 31) are transmit-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_RMP2_Struct
 *! \brief  Receive Message Pending 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_RMP2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB17       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB18       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB19       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB20       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB21       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB22       :  1;  /**< Mailbox n Message Pending */
      unsigned int MB23       :  1;  /**< Mailbox n Message Pending */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_RMP2_t;

/*@}*/

/** @defgroup RML2 Receive Message Lost 2 Register (RML2) Register
 *  Receive Message Lost 2 Register (RML2) Register.
 *
 *  The RML2 register indicates when a message is lost---due to a message coming while there is pending data (corresponding RMP2 bit set) and overwrite protection is disabled (OPSS2 bit cleared)---for mailboxes 16 (bit 0) through 23 (bit 7). Each bit in this register indicates the message lost status for the corresponding mailbox when set (=1). Bits 8 through 15 are reserved, as the corresponding mailboxes (24 through 31) are transmit-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_RML2_Struct
 *! \brief  Receive Message Lost 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_RML2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB17       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB18       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB19       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB20       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB21       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB22       :  1;  /**< Mailbox n Message Lost */
      unsigned int MB23       :  1;  /**< Mailbox n Message Lost */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_RML2_t;

/*@}*/

/** @defgroup MBTIF2 Mailbox Transmit Interrupt Flag 2 Register (MBTIF2) Register
 *  Mailbox Transmit Interrupt Flag 2 Register (MBTIF2) Register.
 *
 *  The MBTIF2 register indicates when a transmit interrupt is pending---due to successful transmission (corresponding TA2 bit set) and the interrupt is enabled (corresponding MBIM2 bit set)---for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register indicates the transmit interrupt pending status for the corresponding mailbox when set (=1). When any bit in MBTIF2 is set, the CAN transmit interrupt request is raised (INT:MBTIRQ bit set). To clear the interrupt request, all of the set bits in MBTIF2 must be cleared by software (W1C). Also, software must clear the associated bits set in TA2 or set the associated bits in TRS2 bit to clear the interrupt source asserting the bits in MBTIF2.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBTIF2_Struct
 *! \brief  Mailbox Transmit Interrupt Flag 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBTIF2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB17       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB18       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB19       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB20       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB21       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB22       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB23       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB24       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB25       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB26       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB27       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB28       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB29       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB30       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int MB31       :  1;  /**< Mailbox n Transmit Interrupt Pending */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBTIF2_t;

/*@}*/

/** @defgroup MBRIF2 Mailbox Receive Interrupt Flag 2 Register (MBRIF2) Register
 *  Mailbox Receive Interrupt Flag 2 Register (MBRIF2) Register.
 *
 *  The MBRIF2 register indicates when a receive interrupt is pending---due to successful reception (corresponding RMP2 bit set) and the interrupt is enabled (corresponding MBIM2 bit set)---for mailboxes 16 (bit 0) through 23 (bit 7). Each bit in this register indicates the receive interrupt pending status for the corresponding mailbox when set (=1). When any bit in MBRIF2 is set, the CAN receive interrupt request is raised (INT:MBRIRQ bit set). To clear the interrupt request, all of the set bits in RMP2 must be cleared by software, then the associated bits set in MBRIF2 must be cleared (W1C). Bits 8 through 15 are reserved and read-only, as the corresponding mailboxes (24 through 31) are transmit-only mailboxes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBRIF2_Struct
 *! \brief  Mailbox Receive Interrupt Flag 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBRIF2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB17       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB18       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB19       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB20       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB21       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB22       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int MB23       :  1;  /**< Mailbox n Receive Interrupt Pending */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBRIF2_t;

/*@}*/

/** @defgroup MBIM2 Mailbox Interrupt Mask 2 Register (MBIM2) Register
 *  Mailbox Interrupt Mask 2 Register (MBIM2) Register.
 *
 *  The MBIM2 register enables transmit and receive interrupts for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register requests enables the transmit or receive interrupt for the corresponding mailbox when set (=1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBIM2_Struct
 *! \brief  Mailbox Interrupt Mask 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBIM2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB17       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB18       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB19       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB20       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB21       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB22       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB23       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB24       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB25       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB26       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB27       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB28       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB29       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB30       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int MB31       :  1;  /**< Mailbox n Transmit and Receive Interrupt Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBIM2_t;

/*@}*/

/** @defgroup RFH2 Remote Frame Handling 2 Register (RFH2) Register
 *  Remote Frame Handling 2 Register (RFH2) Register.
 *
 *  The RFH2 register enables remote frame handling for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register enables remote frame handling for the corresponding mailbox when set (=1). Note that enabling this bit affects transmit and receive operations for mailboxes. For more information about remote frame handling, see the CAN Operating Modes sections, describing transmit and receive operations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_RFH2_Struct
 *! \brief  Remote Frame Handling 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_RFH2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB17       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB18       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB19       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB20       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB21       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB22       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int MB23       :  1;  /**< Mailbox n Remote Frame Handling Enable */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_RFH2_t;

/*@}*/

/** @defgroup OPSS2 Overwrite Protection/Single Shot Transmission 2 Register (OPSS2) Register
 *  Overwrite Protection/Single Shot Transmission 2 Register (OPSS2) Register.
 *
 *  The OPSS2 register enables overwrite protection for mailboxes 16 (bit 0) through 31 (bit 15). Each bit in this register enables overwrite protection for the corresponding mailbox when set (=1). Note that enabling this bit affects transmit and receive operations for mailboxes. For more information about remote overwrite protection, see the detailed feature description in the CAN Functional Description section. For more information about how this feature affects transmit and receive operations, see the CAN Operating Modes sections, describing transmit and receive operations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_OPSS2_Struct
 *! \brief  Overwrite Protection/Single Shot Transmission 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_OPSS2_t {
  union {
    struct {
      unsigned int MB16       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB17       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB18       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB19       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB20       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB21       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB22       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB23       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB24       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB25       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB26       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB27       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB28       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB29       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB30       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int MB31       :  1;  /**< Mailbox n Overwrite Protection Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_OPSS2_t;

/*@}*/

/** @defgroup CLK Clock Register (CLK) Register
 *  Clock Register (CLK) Register.
 *
 *  The CLK register select the bit rate prescaler for calculating the time quantum (TQ), which is used to derive the CAN clock from the system clock (SCLK). For more information about bit timing and clock operation, see the CAN Operating Modes section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_CLK_Struct
 *! \brief  Clock Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_CLK_t {
  union {
    struct {
      unsigned int BRP        : 10;  /**< Bit Rate Prescaler */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_CLK_t;

/*@}*/

/** @defgroup TIMING Timing Register (TIMING) Register
 *  Timing Register (TIMING) Register.
 *
 *  The TIMING register select the time segments, sampling, and synchronization for CAN bit timing. For more information about bit timing and clock operation, see the CAN Operating Modes section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_TIMING_Struct
 *! \brief  Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_TIMING_t {
  union {
    struct {
      unsigned int TSEG1      :  4;  /**< Time Segment 1 */
      unsigned int TSEG2      :  3;  /**< Time Segment 2 */
      unsigned int SAM        :  1;  /**< Sampling */
      unsigned int SJW        :  2;  /**< Synchronization Jump Width */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_TIMING_t;

/*@}*/

/** @defgroup DBG Debug Register (DBG) Register
 *  Debug Register (DBG) Register.
 *
 *  The DBG register controls CAN debug modes, including TX and RX pin enable/disable.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_DBG_Struct
 *! \brief  Debug Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_DBG_t {
  union {
    struct {
      unsigned int DEC        :  1;  /**< Disable Transmit and Receive Error Counters */
      unsigned int DRI        :  1;  /**< Disable Receive Input Pin */
      unsigned int DTO        :  1;  /**< Disable Tx Output Pin */
      unsigned int DIL        :  1;  /**< Disable Internal Loop */
      unsigned int MAA        :  1;  /**< Mode Auto Acknowledge */
      unsigned int MRB        :  1;  /**< Mode Read Back */
      unsigned int reserved6  :  9;
      unsigned int CDE        :  1;  /**< CAN Debug Mode Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_DBG_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates status for CAN modes and error conditions.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_STAT_t {
  union {
    struct {
      unsigned int WT         :  1;  /**< CAN Transmit Warning Flag */
      unsigned int WR         :  1;  /**< CAN Receive Warning Flag */
      unsigned int EP         :  1;  /**< CAN Error Passive Mode */
      unsigned int EBO        :  1;  /**< CAN Error Bus Off Mode */
      unsigned int reserved4  :  2;
      unsigned int CSA        :  1;  /**< CAN Suspend Mode Acknowledge */
      unsigned int CCA        :  1;  /**< CAN Configuration Mode Acknowledge */
      unsigned int MBPTR      :  5;  /**< Mailbox Pointer */
      unsigned int reserved13 :  1;
      unsigned int TRM        :  1;  /**< Transmit Mode */
      unsigned int REC        :  1;  /**< Receive Mode */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_STAT_t;

/*@}*/

/** @defgroup CEC Error Counter Register (CEC) Register
 *  Error Counter Register (CEC) Register.
 *
 *  The CEC register , ESR register, and EWR register control CAN warnings and errors. For detailed information about error and warning operations, see the Event Control section. 
 *  The CEC register holds an error counter for transmit (TXECNT) and an error counter for receive (RXECNT). After initialization, both counters are 0. Each time a bus error occurs, one of the counters is incremented by either 1 or 8, depending on the error situation (documented in Version 2.0 of CAN Specification). Successful transmit and receive operations decrement the respective counter by 1.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_CEC_Struct
 *! \brief  Error Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_CEC_t {
  union {
    struct {
      unsigned int RXECNT     :  8;  /**< Receive Error Counter */
      unsigned int TXECNT     :  8;  /**< Transmit Error Counter */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_CEC_t;

/*@}*/

/** @defgroup GIS Global CAN Interrupt Status Register (GIS) Register
 *  Global CAN Interrupt Status Register (GIS) Register.
 *
 *  The GIS register, GIF register, and GIM register control CAN interrupts. For detailed information about interrupt operations, see the Event Control section. 
 *  The GIS register holds the interrupt status. All bits in this register are W1C.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_GIS_Struct
 *! \brief  Global CAN Interrupt Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_GIS_t {
  union {
    struct {
      unsigned int EWTIS      :  1;  /**< Error Warning Transmit Interrupt Status */
      unsigned int EWRIS      :  1;  /**< Error Warning Receive  Interrupt Status */
      unsigned int EPIS       :  1;  /**< Error Passive Interrupt Status */
      unsigned int BOIS       :  1;  /**< Bus Off Interrupt Status */
      unsigned int WUIS       :  1;  /**< Wake Up Interrupt Status */
      unsigned int UIAIS      :  1;  /**< Unimplemented Address Interrupt Status */
      unsigned int AAIS       :  1;  /**< Abort Acknowledge Interrupt Status */
      unsigned int RMLIS      :  1;  /**< Receive Message Lost Interrupt Status */
      unsigned int UCEIS      :  1;  /**< Universal Counter Exceeded Interrupt Status */
      unsigned int reserved9  :  1;
      unsigned int ADIS       :  1;  /**< Access Denied Interrupt Status */
      unsigned int reserved11 : 21;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_GIS_t;

/*@}*/

/** @defgroup GIM Global CAN Interrupt Mask Register (GIM) Register
 *  Global CAN Interrupt Mask Register (GIM) Register.
 *
 *  The GIM register, GIF register, and GIF register control CAN interrupts. For detailed information about interrupt operations, see the Event Control section. 
 *  The GIM register holds the interrupt mask. The interrupt mask bits only affect the content of the GIF register. If the mask bit is not set (enabled/unmasked), the corresponding flag bit is not set when the event occurs.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_GIM_Struct
 *! \brief  Global CAN Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_GIM_t {
  union {
    struct {
      unsigned int EWTIM      :  1;  /**< Error Warning Transmit Interrupt Mask */
      unsigned int EWRIM      :  1;  /**< Error Warning Receive Interrupt Mask */
      unsigned int EPIM       :  1;  /**< Error Passive Interrupt Mask */
      unsigned int BOIM       :  1;  /**< Bus Off Interrupt Mask */
      unsigned int WUIM       :  1;  /**< Wake Up Interrupt Mask */
      unsigned int UIAIM      :  1;  /**< Unimplemented Address Interrupt Mask */
      unsigned int AAIM       :  1;  /**< Abort Acknowledge Interrupt Mask */
      unsigned int RMLIM      :  1;  /**< Receive Message Lost Interrupt Mask */
      unsigned int UCEIM      :  1;  /**< Universal Counter Exceeded Interrupt Mask */
      unsigned int reserved9  :  1;
      unsigned int ADIM       :  1;  /**< Access Denied Interrupt Mask */
      unsigned int reserved11 : 21;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_GIM_t;

/*@}*/

/** @defgroup GIF Global CAN Interrupt Flag Register (GIF) Register
 *  Global CAN Interrupt Flag Register (GIF) Register.
 *
 *  The GIF register, GIF register, and GIM register control CAN interrupts. For detailed information about interrupt operations, see the Event Control section. 
 *  The GIF register holds the interrupt flag. The INT:GIRQ bit is only asserted if a bit in the GIF is set. The INT:GIRQ bit remains set as long as at least one bit in the GIF register is set.All bits in this register are W1C.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_GIF_Struct
 *! \brief  Global CAN Interrupt Flag Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_GIF_t {
  union {
    struct {
      unsigned int EWTIF      :  1;  /**< Error Warning Transmit Interrupt Flag */
      unsigned int EWRIF      :  1;  /**< Error Warning Receive Interrupt Flag */
      unsigned int EPIF       :  1;  /**< Error Passive Interrupt Flag */
      unsigned int BOIF       :  1;  /**< Bus Off Interrupt Flag */
      unsigned int WUIF       :  1;  /**< Wake Up Interrupt Flag */
      unsigned int UIAIF      :  1;  /**< Unimplemented Address Interrupt Flag */
      unsigned int AAIF       :  1;  /**< Abort Acknowledge Interrupt Flag */
      unsigned int RMLIF      :  1;  /**< Receive Message Lost Interrupt Flag */
      unsigned int UCEIF      :  1;  /**< Universal Counter Exceeded Interrupt Flag */
      unsigned int reserved9  :  1;
      unsigned int ADIF       :  1;  /**< Access Denied Interrupt Flag */
      unsigned int reserved11 : 21;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_GIF_t;

/*@}*/

/** @defgroup CTL CAN Master Control Register (CTL) Register
 *  CAN Master Control Register (CTL) Register.
 *
 *  The CTL register controls CAN mode requests, including soft reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_CTL_Struct
 *! \brief  CAN Master Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_CTL_t {
  union {
    struct {
      unsigned int SRS        :  1;  /**< Software Reset */
      unsigned int DNM        :  1;  /**< Device Net Mode */
      unsigned int ABO        :  1;  /**< Auto Bus On */
      unsigned int reserved3  :  1;
      unsigned int WBA        :  1;  /**< Wake Up on CAN Bus Activity */
      unsigned int SMR        :  1;  /**< Sleep Mode Request */
      unsigned int CSR        :  1;  /**< CAN Suspend Mode Request */
      unsigned int CCR        :  1;  /**< CAN Configuration Mode Request */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_CTL_t;

/*@}*/

/** @defgroup INT Interrupt Pending Register (INT) Register
 *  Interrupt Pending Register (INT) Register.
 *
 *  The INT register indicates the status of pending CAN interrupts and indicates the state of the RX and TX pins. Though this register is read-only, a write is allowed to exit the built-in sleep mode of the module on processors supporting this feature.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_INT_Struct
 *! \brief  Interrupt Pending Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_INT_t {
  union {
    struct {
      unsigned int MBRIRQ     :  1;  /**< Mailbox Receive Interrupt Output */
      unsigned int MBTIRQ     :  1;  /**< Mailbox Transmit Interrupt Output */
      unsigned int GIRQ       :  1;  /**< Global CAN Interrupt Output */
      unsigned int SMACK      :  1;  /**< Sleep Mode Acknowledge */
      unsigned int reserved4  :  2;
      unsigned int CANTX      :  1;  /**< Serial Input To Transceiver */
      unsigned int CANRX      :  1;  /**< Serial Input From Transceiver */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_INT_t;

/*@}*/

/** @defgroup MBTD Temporary Mailbox Disable Register (MBTD) Register
 *  Temporary Mailbox Disable Register (MBTD) Register.
 *
 *  The MBTD register supports temporarily and selectively disabling CAN mailboxes. For more information about this feature, see the Operating Modes section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MBTD_Struct
 *! \brief  Temporary Mailbox Disable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MBTD_t {
  union {
    struct {
      unsigned int TDPTR      :  5;  /**< Temporary Disable Pointer */
      unsigned int reserved5  :  1;
      unsigned int TDA        :  1;  /**< Temporary Disable Acknowledge */
      unsigned int TDR        :  1;  /**< Temporary Disable Request */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MBTD_t;

/*@}*/

/** @defgroup EWR Error Counter Warning Level Register (EWR) Register
 *  Error Counter Warning Level Register (EWR) Register.
 *
 *  The EWR register, CEC register, and ESR register control CAN warnings and errors. For detailed information about error and warning operations, see the Operating Modes section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_EWR_Struct
 *! \brief  Error Counter Warning Level Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_EWR_t {
  union {
    struct {
      unsigned int EWLREC     :  8;  /**< Receive Error Warning Limit */
      unsigned int EWLTEC     :  8;  /**< Transmit Error Warning Limit */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_EWR_t;

/*@}*/

/** @defgroup ESR Error Status Register (ESR) Register
 *  Error Status Register (ESR) Register.
 *
 *  The ESR register, CEC register, and EWR register control CAN warnings and errors. All bits in the ESR are W1C. Note that the CAN updates the CEC register when error status is detected in the ESR register. For detailed information about error and warning operations, see the Operating Modes section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_ESR_Struct
 *! \brief  Error Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_ESR_t {
  union {
    struct {
      unsigned int reserved0  :  2;
      unsigned int ACKE       :  1;  /**< Acknowledge Error */
      unsigned int SER        :  1;  /**< Stuff Bit Error */
      unsigned int CRCE       :  1;  /**< CRC Error */
      unsigned int SAO        :  1;  /**< Stuck at Dominant */
      unsigned int BEF        :  1;  /**< Bit Error Flag */
      unsigned int FER        :  1;  /**< Form Error */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_ESR_t;

/*@}*/

/** @defgroup UCCNT Universal Counter Register (UCCNT) Register
 *  Universal Counter Register (UCCNT) Register.
 *
 *  The UCCNT register holds the current universal count. This register is re-loaded from the UCRC register when the decrements to zero in auto-transmit mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_UCCNT_Struct
 *! \brief  Universal Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_UCCNT_t {
  union {
    struct {
      unsigned int COUNT      : 16;  /**< Count Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_UCCNT_t;

/*@}*/

/** @defgroup UCRC Universal Counter Reload/Capture Register (UCRC) Register
 *  Universal Counter Reload/Capture Register (UCRC) Register.
 *
 *  The UCRC register holds the period value (universal count), which is used in auto-transmit mode as the period for sending the message in mailbox 11 (broadcast heartbeat) to all CAN nodes. Accordingly, messages sent this way usually have high priority. 
 *  The period value is written to the UCRC register. When auto-transmit mode is enabled (UCCNF:UCCNF = 0x3), the CAN loads the counter with the value in UCRC. The counter decrements to 0 at the CAN bit clock rate, then is reloaded. Each time the counter decrements to 0, the CAN sets the TRS1:MB bit for mailbox 11 and sends the corresponding message from mailbox 11. 
 *  Note that for auto-transmit mode, mailbox 11 must be configured as a transmit mailbox and must contain valid data (identifier, control bits, and data). This setup must occur before the counter first expires after this mode is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_UCRC_Struct
 *! \brief  Universal Counter Reload/Capture Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_UCRC_t {
  union {
    struct {
      unsigned int UCVAL      : 16;  /**< Universal Counter Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_UCRC_t;

/*@}*/

/** @defgroup UCCNF Universal Counter Configuration Mode Register (UCCNF) Register
 *  Universal Counter Configuration Mode Register (UCCNF) Register.
 *
 *  The UCCNF register controls the operation of the universal counter, including counter enable and counter mode selection.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_UCCNF_Struct
 *! \brief  Universal Counter Configuration Mode Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_UCCNF_t {
  union {
    struct {
      unsigned int UCCNF      :  4;  /**< Universal Counter Configuration */
      unsigned int reserved4  :  1;
      unsigned int UCRC       :  1;  /**< Universal Counter Reload/Clear */
      unsigned int UCCT       :  1;  /**< Universal Counter CAN Trigger */
      unsigned int UCE        :  1;  /**< Universal Counter Enable */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_UCCNF_t;

/*@}*/

/** @defgroup AML Acceptance Mask (L) Register (AML) Register
 *  Acceptance Mask (L) Register (AML) Register.
 *
 *  The AM[nn]L register and AMnnH register manage acceptance mask operation. For information about acceptance mask operation, see the Receive Operation section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_AML_Struct
 *! \brief  Acceptance Mask (L) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_AML_t {
  union {
    struct {
      unsigned int EXTID      : 16;  /**< Extended Identifier/Data Field Mask */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_AML_t;

/*@}*/

/** @defgroup AMH Acceptance Mask (H) Register (AMH) Register
 *  Acceptance Mask (H) Register (AMH) Register.
 *
 *  The AM[nn]H register and AMnnL register manage acceptance mask operation. For information about acceptance mask operation, see the Receive Operation section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_AMH_Struct
 *! \brief  Acceptance Mask (H) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_AMH_t {
  union {
    struct {
      unsigned int EXTID      :  2;  /**< Extended Identifier */
      unsigned int BASEID     : 11;  /**< Base Identifier */
      unsigned int AMIDE      :  1;  /**< Acceptance Mask Identifier Extension */
      unsigned int FMD        :  1;  /**< Full Mask Data */
      unsigned int FDF        :  1;  /**< Filter on Delay Field */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_AMH_t;

/*@}*/

/** @defgroup MB_DATA0 Mailbox Word 0 Register (MB_DATA0) Register
 *  Mailbox Word 0 Register (MB_DATA0) Register.
 *
 *  The MB[nn]_DATA0 register holds mailbox data bytes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_DATA0_Struct
 *! \brief  Mailbox Word 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_DATA0_t {
  union {
    struct {
      unsigned int DFB7       :  8;  /**< Data Field Byte 7 */
      unsigned int DFB6       :  8;  /**< Data Field Byte 6 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_DATA0_t;

/*@}*/

/** @defgroup MB_DATA1 Mailbox Word 1 Register (MB_DATA1) Register
 *  Mailbox Word 1 Register (MB_DATA1) Register.
 *
 *  The MB[nn]_DATA1 register holds mailbox data bytes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_DATA1_Struct
 *! \brief  Mailbox Word 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_DATA1_t {
  union {
    struct {
      unsigned int DFB5       :  8;  /**< Data Field Byte 5 */
      unsigned int DFB4       :  8;  /**< Data Field Byte 4 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_DATA1_t;

/*@}*/

/** @defgroup MB_DATA2 Mailbox Word 2 Register (MB_DATA2) Register
 *  Mailbox Word 2 Register (MB_DATA2) Register.
 *
 *  The MB[nn]_DATA2 register holds mailbox data bytes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_DATA2_Struct
 *! \brief  Mailbox Word 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_DATA2_t {
  union {
    struct {
      unsigned int DFB3       :  8;  /**< Data Field Byte 3 */
      unsigned int DFB2       :  8;  /**< Data Field Byte 2 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_DATA2_t;

/*@}*/

/** @defgroup MB_DATA3 Mailbox Word 3 Register (MB_DATA3) Register
 *  Mailbox Word 3 Register (MB_DATA3) Register.
 *
 *  The MB[nn]_DATA3 register holds mailbox data bytes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_DATA3_Struct
 *! \brief  Mailbox Word 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_DATA3_t {
  union {
    struct {
      unsigned int DFB1       :  8;  /**< Data Field Byte 1 */
      unsigned int DFB0       :  8;  /**< Data Field Byte 0 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_DATA3_t;

/*@}*/

/** @defgroup MB_LENGTH Mailbox Length Register (MB_LENGTH) Register
 *  Mailbox Length Register (MB_LENGTH) Register.
 *
 *  The MB[nn]_LENGTH register holds the data length code for the received remote frame. For more information about remote frames, see the Remote Frame Handling section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_LENGTH_Struct
 *! \brief  Mailbox Length Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_LENGTH_t {
  union {
    struct {
      unsigned int DLC        :  4;  /**< Data Length Code */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_LENGTH_t;

/*@}*/

/** @defgroup MB_TIMESTAMP Mailbox Timestamp Register (MB_TIMESTAMP) Register
 *  Mailbox Timestamp Register (MB_TIMESTAMP) Register.
 *
 *  The MB[nn]_TIMESTAMP register holds an indication of the time of reception or transmission for each message, when the universal counter is in time stamp mode (UCCNF:UCCNF =0x1). In this mode, the CAN writes the value of the counter (UCCNT) to the MB[nn]_TIMESTAMP register when a received message is stored or a message is transmitted. For more information about timestamps, see the Time Stamps section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_TIMESTAMP_Struct
 *! \brief  Mailbox Timestamp Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_TIMESTAMP_t {
  union {
    struct {
      unsigned int TSV        : 16;  /**< Time Stamp Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_TIMESTAMP_t;

/*@}*/

/** @defgroup MB_ID0 Mailbox ID 0 Register (MB_ID0) Register
 *  Mailbox ID 0 Register (MB_ID0) Register.
 *
 *  The MB[nn]_ID0 register contains the lower 16 bits of the 18-bit extended identifier.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_ID0_Struct
 *! \brief  Mailbox ID 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_ID0_t {
  union {
    struct {
      unsigned int EXTID      : 16;  /**< Extended Identifier/Data Field Acceptance Code */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_ID0_t;

/*@}*/

/** @defgroup MB_ID1 Mailbox ID 1 Register (MB_ID1) Register
 *  Mailbox ID 1 Register (MB_ID1) Register.
 *
 *  The MB[nn]_ID1 register contains the identifier bits of mailbox. The 11-bit BASE_ID is mapped to The BASEID field. It also enables the extended identification and contains upper two bits of 18-bit extended identifier.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CAN_MB_ID1_Struct
 *! \brief  Mailbox ID 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CAN_MB_ID1_t {
  union {
    struct {
      unsigned int EXTID      :  2;  /**< Extended Identifier */
      unsigned int BASEID     : 11;  /**< Base Identifier */
      unsigned int IDE        :  1;  /**< Identifier Extension */
      unsigned int RTR        :  1;  /**< Remote Transmission Request */
      unsigned int AME        :  1;  /**< Acceptance Mask Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_CAN_MB_ID1_t;

/*@}*/

/** @defgroup RUN Run (RUN) Register
 *  Run (RUN) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_RUN_Struct
 *! \brief  Run Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_RUN_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Run */
      unsigned int CPT01      :  1;  /**< Run */
      unsigned int CPT02      :  1;  /**< Run */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_RUN_t;

/*@}*/

/** @defgroup RUN_SET Run Set (RUN_SET) Register
 *  Run Set (RUN_SET) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_RUN_SET_Struct
 *! \brief  Run Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_RUN_SET_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Run Set */
      unsigned int CPT01      :  1;  /**< Run Set */
      unsigned int CPT02      :  1;  /**< Run Set */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_RUN_SET_t;

/*@}*/

/** @defgroup RUN_CLR Run Clear (RUN_CLR) Register
 *  Run Clear (RUN_CLR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_RUN_CLR_Struct
 *! \brief  Run Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_RUN_CLR_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Run Clear */
      unsigned int CPT01      :  1;  /**< Run Clear */
      unsigned int CPT02      :  1;  /**< Run Clear */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_RUN_CLR_t;

/*@}*/

/** @defgroup DATA_IMSK Data Imask (DATA_IMSK) Register
 *  Data Imask (DATA_IMSK) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_DATA_IMSK_Struct
 *! \brief  Data Imask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_DATA_IMSK_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Data Interrupt Mask */
      unsigned int CPT01      :  1;  /**< Data Interrupt Mask */
      unsigned int CPT02      :  1;  /**< Data Interrupt Mask */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_DATA_IMSK_t;

/*@}*/

/** @defgroup DATA_IMSK_SET Data Imask Set (DATA_IMSK_SET) Register
 *  Data Imask Set (DATA_IMSK_SET) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_DATA_IMSK_SET_Struct
 *! \brief  Data Imask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_DATA_IMSK_SET_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Data Imask Set */
      unsigned int CPT01      :  1;  /**< Data Imask Set */
      unsigned int CPT02      :  1;  /**< Data Imask Set */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_DATA_IMSK_SET_t;

/*@}*/

/** @defgroup DATA_IMSK_CLR Data Imask Clear (DATA_IMSK_CLR) Register
 *  Data Imask Clear (DATA_IMSK_CLR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_DATA_IMSK_CLR_Struct
 *! \brief  Data Imask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_DATA_IMSK_CLR_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Data Imask Clear */
      unsigned int CPT01      :  1;  /**< Data Imask Clear */
      unsigned int CPT02      :  1;  /**< Data Imask Clear */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_DATA_IMSK_CLR_t;

/*@}*/

/** @defgroup STAT_IMSK Status Imask (STAT_IMSK) Register
 *  Status Imask (STAT_IMSK) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_STAT_IMSK_Struct
 *! \brief  Status Imask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_STAT_IMSK_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Status Interrupt Mask */
      unsigned int CPT01      :  1;  /**< Status Interrupt Mask */
      unsigned int CPT02      :  1;  /**< Status Interrupt Mask */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_STAT_IMSK_t;

/*@}*/

/** @defgroup STAT_IMSK_SET Status Imask Set (STAT_IMSK_SET) Register
 *  Status Imask Set (STAT_IMSK_SET) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_STAT_IMSK_SET_Struct
 *! \brief  Status Imask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_STAT_IMSK_SET_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Status Imask Set */
      unsigned int CPT01      :  1;  /**< Status Imask Set */
      unsigned int CPT02      :  1;  /**< Status Imask Set */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_STAT_IMSK_SET_t;

/*@}*/

/** @defgroup STAT_IMSK_CLR Status Imask Clear (STAT_IMSK_CLR) Register
 *  Status Imask Clear (STAT_IMSK_CLR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_STAT_IMSK_CLR_Struct
 *! \brief  Status Imask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_STAT_IMSK_CLR_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Status Imask Clear */
      unsigned int CPT01      :  1;  /**< Status Imask Clear */
      unsigned int CPT02      :  1;  /**< Status Imask Clear */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_STAT_IMSK_CLR_t;

/*@}*/

/** @defgroup DATA_ILAT Data Ilat (DATA_ILAT) Register
 *  Data Ilat (DATA_ILAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_DATA_ILAT_Struct
 *! \brief  Data Ilat Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_DATA_ILAT_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Data Interrupt Latch */
      unsigned int CPT01      :  1;  /**< Data Interrupt Latch */
      unsigned int CPT02      :  1;  /**< Data Interrupt Latch */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_DATA_ILAT_t;

/*@}*/

/** @defgroup STAT_ILAT Status Ilat (STAT_ILAT) Register
 *  Status Ilat (STAT_ILAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_STAT_ILAT_Struct
 *! \brief  Status Ilat Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_STAT_ILAT_t {
  union {
    struct {
      unsigned int CPT00      :  1;  /**< Status Interrupt Latch */
      unsigned int CPT01      :  1;  /**< Status Interrupt Latch */
      unsigned int CPT02      :  1;  /**< Status Interrupt Latch */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_STAT_ILAT_t;

/*@}*/

/** @defgroup CFG Configuration (CFG) Register
 *  Configuration (CFG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_CFG_Struct
 *! \brief  Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_CFG_t {
  union {
    struct {
      unsigned int TINSEL     :  1;  /**< Input Select */
      unsigned int TRIGSEL    :  1;  /**< Trigger Select */
      unsigned int TINPOL     :  1;  /**< Input Polarity */
      unsigned int TRIGPOL    :  1;  /**< Trigger Polarity */
      unsigned int TIN_INEN   :  1;  /**< Timer input enable bit */
      unsigned int AUX_TIN_INEN :  1;  /**< Aux timer input enable bit */
      unsigned int TRIG_INEN    :  1;  /**< Trigger input enable bit */
      unsigned int AUX_TRIG_INEN :  1;  /**< Aux trigger input enable bit */
      unsigned int reserved8     : 24;
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_CFG_t;

/*@}*/

/** @defgroup CNT Counter (CNT) Register
 *  Counter (CNT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_CNT_Struct
 *! \brief  Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_CNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Counter Value */
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_CNT_t;

/*@}*/

/** @defgroup TON On Time Capture (TON) Register
 *  On Time Capture (TON) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CPTMR_TON_Struct
 *! \brief  On Time Capture Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CPTMR_TON_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< On-Time Value */
    };
    uint32_t VALUE32;
  };
} ADI_CPTMR_TON_t;

/*@}*/


/*  =========================================================================
 *! \enum   ENHPBH
 *! \brief  Channel B heightened-precision enable for high side Output (ENHPBH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_HPBH_DIS = 0,  /**< Disable HP Output Channel B High */
  PWM_HPBH_EN  = 1   /**< Enable HP Output Channel B High  */
} ENHPBH;


/*  =========================================================================
 *! \enum   FLTTRIPA
 *! \brief  Fault Trip Status for Channel A (FLTTRIPA) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_FLTA_NOTRIP = 0,  /**< Channel A Fault Trip Status is "not tripped" */
  PWM_FLTA_TRIP   = 1   /**< Channel A Fault Trip Status is "tripped"     */
} FLTTRIPA;


/*  =========================================================================
 *! \enum   SWTRIP
 *! \brief  Software Trip (SWTRIP) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_FORCE_TRIP = 1   /**< Force a Fault Trip Condition */
} SWTRIP;


/*  =========================================================================
 *! \enum   MODE0A
 *! \brief  Mode of TRIP0 for Channel A (MODE0A) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0A_FLT   = 0,  /**< Fault Trip on TRIP0 Input   */
  PWM_TRIP0A_RSTRT = 1   /**< Self Restart on TRIP0 Input */
} MODE0A;


/*  =========================================================================
 *! \enum   EN1AL
 *! \brief  Enable TRIP1 as a trip source for Channel A Low Side (EN1AL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0AL_DIS = 0,  /**< Disable Trip0 for Channel A Low Side */
  PWM_TRIP0AL_EN  = 1   /**< Enable Trip0 for Channel A Low Side  */
} EN1AL;


/*  =========================================================================
 *! \enum   DISHI
 *! \brief  Channel High Side Output Disable (DISHI) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_HI_DIS = 0,  /**< Disable High Side Output */
  PWM_HI_EN  = 1   /**< Enable High Side Output  */
} DISHI;


/*  =========================================================================
 *! \enum   HPRDY
 *! \brief  Heightened-Precision Ready Status (HPRDY) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_NOT_HPRDY = 0,  /**< HPPWM Not Ready For Operation */
  PWM_HPRDY     = 1   /**< HPPWM Ready For Operation     */
} HPRDY;


/*  =========================================================================
 *! \enum   TMR1PHASE
 *! \brief  PWMTMR1 Phase Status (TMR1PHASE) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TMR1PH1 = 0,  /**< 1st Half Phase */
  PWM_TMR1PH2 = 1   /**< 2nd Half Phase */
} TMR1PHASE;


/*  =========================================================================
 *! \enum   DLYBEN
 *! \brief  Enable Delay Counter for Channel B (DLYBEN) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DLYB_DIS = 0,  /**< Disable */
  PWM_DLYB_EN  = 1   /**< Enable  */
} DLYBEN;


/*  =========================================================================
 *! \enum   MODE0D
 *! \brief  Mode of TRIP0 for Channel D (MODE0D) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0D_FLT   = 0,  /**< Fault Trip on TRIP0 Input   */
  PWM_TRIP0D_RSTRT = 1   /**< Self Restart on TRIP0 Input */
} MODE0D;


/*  =========================================================================
 *! \enum   EN1D
 *! \brief  Enable TRIP1 as a trip source for Channel D (EN1D) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1D_DIS = 0,  /**< Disable TRIP1 for Channel D */
  PWM_TRIP1D_EN  = 1   /**< Enable TRIP1 for Channel D  */
} EN1D;


/*  =========================================================================
 *! \enum   TMR3PHASE
 *! \brief  PWMTMR3 Phase Status (TMR3PHASE) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TMR3PH1 = 0,  /**< 1st Half Phase */
  PWM_TMR3PH2 = 1   /**< 2nd Half Phase */
} TMR3PHASE;


/*  =========================================================================
 *! \enum   DLYAEN
 *! \brief  Enable Delay Counter for Channel A (DLYAEN) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DLYA_DIS = 0,  /**< Disable */
  PWM_DLYA_EN  = 1   /**< Enable  */
} DLYAEN;


/*  =========================================================================
 *! \enum   ENCHOPAL
 *! \brief  Channel A Gate Chopping Enable Low Side (ENCHOPAL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPAL_DIS = 0,  /**< Disable Chopping Channel A Low Side */
  PWM_CHOPAL_EN  = 1   /**< Enable Chopping Channel A Low Side  */
} ENCHOPAL;


/*  =========================================================================
 *! \enum   FLTTRIPD
 *! \brief  Fault Trip Status for Channel D (FLTTRIPD) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_FLTD_NOTRIP = 0,  /**< Channel D Fault Trip Status is "not tripped" */
  PWM_FLTD_TRIP   = 1   /**< Channel D Fault Trip Status is "tripped"     */
} FLTTRIPD;


/*  =========================================================================
 *! \enum   MODELSA
 *! \brief  Channel A Mode of low Side Output (MODELSA) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_LOA_INVHI = 0,  /**< Invert of high output */
  PWM_LOA_IND   = 1   /**< Independent control   */
} MODELSA;


/*  =========================================================================
 *! \enum   RAWTRIP0
 *! \brief  Raw Trip 0 Status (RAWTRIP0) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0LVL_LO = 0,  /**< TRIP0 Level is Low  */
  PWM_TRIP0LVL_HI = 1   /**< TRIP0 Level is High */
} RAWTRIP0;


/*  =========================================================================
 *! \enum   DISLO
 *! \brief  Channel Low Side Output Disable (DISLO) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_LO_DIS = 0,  /**< Disable Low Side Output */
  PWM_LO_EN  = 1   /**< Enable Low Side Output  */
} DISLO;


/*  =========================================================================
 *! \enum   MODE1D
 *! \brief  Mode of TRIP1 for Channel D (MODE1D) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1D_FLT   = 0,  /**< Fault Trip on TRIP1 Input   */
  PWM_TRIP1D_RSTRT = 1   /**< Self Restart on TRIP1 Input */
} MODE1D;


/*  =========================================================================
 *! \enum   SRTRIPD
 *! \brief  Self-Restart Trip Status for Channel D (SRTRIPD) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SRD_NOTRIP = 0,  /**< Channel D Self-Restart Trip Status is "not tripped" */
  PWM_SRD_TRIP   = 1   /**< Channel D Self-Restart Trip Status is "tripped"     */
} SRTRIPD;


/*  =========================================================================
 *! \enum   REFTMRD
 *! \brief  Channel D Timer Reference (REFTMRD) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_REFTMRD_0 = 0,  /**< PWMTMR0 is Channel D reference */
  PWM_REFTMRD_1 = 1   /**< PWMTMR1 is Channel D reference */
} REFTMRD;


/*  =========================================================================
 *! \enum   EN1SELA
 *! \brief  TRIP1 Enable Select for Channel A Low Side (EN1SELA) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SEL_EN0A  = 0,  /**< Select EN0A for Channel A Low Side Trip0 Enable  */
  PWM_SEL_EN0AL = 1   /**< Select EN0AL for Channel A Low Side Trip0 Enable */
} EN1SELA;


/*  =========================================================================
 *! \enum   ENHPAH
 *! \brief  Channel A heightened-precision enable for high side Output (ENHPAH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_HPAH_DIS = 0,  /**< Disable HP Output Channel A High */
  PWM_HPAH_EN  = 1   /**< Enable HP Output Channel A High  */
} ENHPAH;


/*  =========================================================================
 *! \enum   MODE1B
 *! \brief  Mode of TRIP1 for Channel B (MODE1B) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1B_FLT   = 0,  /**< Fault Trip on TRIP1 Input   */
  PWM_TRIP1B_RSTRT = 1   /**< Self Restart on TRIP1 Input */
} MODE1B;


/*  =========================================================================
 *! \enum   DLYDEN
 *! \brief  Enable Delay Counter for Channel D (DLYDEN) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DLYD_DIS = 0,  /**< Disable */
  PWM_DLYD_EN  = 1   /**< Enable  */
} DLYDEN;


/*  =========================================================================
 *! \enum   TMR2PHASE
 *! \brief  PWMTMR2 Phase Status (TMR2PHASE) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TMR2PH1 = 0,  /**< 1st Half Phase */
  PWM_TMR2PH2 = 1   /**< 2nd Half Phase */
} TMR2PHASE;


/*  =========================================================================
 *! \enum   EN0DL
 *! \brief  Enable TRIP0 as a trip source for Channel D Low Side (EN0DL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0DL_DIS = 0,  /**< Disable Trip0 for Channel D Low Side */
  PWM_TRIP0DL_EN  = 1   /**< Enable Trip0 for Channel D Low Side  */
} EN0DL;


/*  =========================================================================
 *! \enum   EN1CL
 *! \brief  Enable TRIP1 as a trip source for Channel C Low Side (EN1CL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0CL_DIS = 0,  /**< Disable Trip0 for Channel C Low Side */
  PWM_TRIP0CL_EN  = 1   /**< Enable Trip0 for Channel C Low Side  */
} EN1CL;


/*  =========================================================================
 *! \enum   ENCHOPBH
 *! \brief  Channel B Gate Chopping Enable High Side (ENCHOPBH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPBH_DIS = 0,  /**< Disable Chopping Channel B High Side */
  PWM_CHOPBH_EN  = 1   /**< Enable Chopping Channel B High Side  */
} ENCHOPBH;


/*  =========================================================================
 *! \enum   EN0D
 *! \brief  Enable TRIP0 as a trip source for Channel D (EN0D) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0D_DIS = 0,  /**< Disable TRIP0 for Channel D */
  PWM_TRIP0D_EN  = 1   /**< Enable TRIP0 for Channel D  */
} EN0D;


/*  =========================================================================
 *! \enum   SRTRIPB
 *! \brief  Self-Restart Trip Status for Channel B (SRTRIPB) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SRB_NOTRIP = 0,  /**< Channel B Self-Restart Trip Status is "not tripped" */
  PWM_SRB_TRIP   = 1   /**< Channel B Self-Restart Trip Status is "tripped"     */
} SRTRIPB;


/*  =========================================================================
 *! \enum   ENCHOPCH
 *! \brief  Channel C Gate Chopping Enable High Side (ENCHOPCH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPCH_DIS = 0,  /**< Disable Chopping Channel C High Side */
  PWM_CHOPCH_EN  = 1   /**< Enable Chopping Channel C High Side  */
} ENCHOPCH;


/*  =========================================================================
 *! \enum   EN1C
 *! \brief  Enable TRIP1 as a trip source for Channel C (EN1C) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1C_DIS = 0,  /**< Disable TRIP1 for Channel C */
  PWM_TRIP1C_EN  = 1   /**< Enable TRIP1 for Channel C  */
} EN1C;


/*  =========================================================================
 *! \enum   XOVR
 *! \brief  high-low Crossover Enable (XOVR) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_XOVR_DIS = 0,  /**< Disable Crossover */
  PWM_XOVR_EN  = 1   /**< Enable Crossover  */
} XOVR;


/*  =========================================================================
 *! \enum   EXTSYNCSEL
 *! \brief  External Sync Select (EXTSYNCSEL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_EXTSYNC_ASYNC = 0,  /**< Asynchronous External Sync */
  PWM_EXTSYNC_SYNC  = 1   /**< Synchronous External Sync  */
} EXTSYNCSEL;


/*  =========================================================================
 *! \enum   POLDL
 *! \brief  Channel D low side Polarity (POLDL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DL_ACTLO = 0,  /**< Active Low  */
  PWM_DL_ACTHI = 1   /**< Active High */
} POLDL;


/*  =========================================================================
 *! \enum   EN0SELC
 *! \brief  TRIP0 Enable Select for Channel C Low Side (EN0SELC) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SEL_EN0C  = 0,  /**< Select EN0C for Channel C Low Side Trip0 Enable  */
  PWM_SEL_EN0CL = 1   /**< Select EN0CL for Channel C Low Side Trip0 Enable */
} EN0SELC;


/*  =========================================================================
 *! \enum   TMR0PHASE
 *! \brief  PWMTMR0 Phase Status (TMR0PHASE) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TMR0PH1 = 0,  /**< 1st Half Phase */
  PWM_TMR0PH2 = 1   /**< 2nd Half Phase */
} TMR0PHASE;


/*  =========================================================================
 *! \enum   ENHPDH
 *! \brief  Channel D heightened-precision enable for high side Output (ENHPDH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_HPDH_DIS = 0,  /**< Disable HP Output Channel D High */
  PWM_HPDH_EN  = 1   /**< Enable HP Output Channel D High  */
} ENHPDH;


/*  =========================================================================
 *! \enum   ENCHOPCL
 *! \brief  Channel C Gate Chopping Enable Low Side (ENCHOPCL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPCL_DIS = 0,  /**< Disable Chopping Channel C Low Side */
  PWM_CHOPCL_EN  = 1   /**< Enable Chopping Channel C Low Side  */
} ENCHOPCL;


/*  =========================================================================
 *! \enum   MODE0C
 *! \brief  Mode of TRIP0 for Channel C (MODE0C) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0C_FLT   = 0,  /**< Fault Trip on TRIP0 Input   */
  PWM_TRIP0C_RSTRT = 1   /**< Self Restart on TRIP0 Input */
} MODE0C;


/*  =========================================================================
 *! \enum   EN0B
 *! \brief  Enable TRIP0 as a trip source for Channel B (EN0B) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0B_DIS = 0,  /**< Disable TRIP0 for Channel B */
  PWM_TRIP0B_EN  = 1   /**< Enable TRIP0 for Channel B  */
} EN0B;


/*  =========================================================================
 *! \enum   INTSYNCREF
 *! \brief  Timer reference for Internal Sync (INTSYNCREF) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_INTSYNC_0 = 0,  /**< PWMTMR0 provides sync reference */
  PWM_INTSYNC_1 = 1,  /**< PWMTMR1 provides sync reference */
  PWM_INTSYNC_2 = 2,  /**< PWMTMR2 provides sync reference */
  PWM_INTSYNC_3 = 3,  /**< PWMTMR3 provides sync reference */
  PWM_INTSYNC_4 = 4   /**< PWMTMR4 provides sync reference */
} INTSYNCREF;


/*  =========================================================================
 *! \enum   RAWTRIP1
 *! \brief  Raw Trip 1 Status (RAWTRIP1) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1LVL_LO = 0,  /**< TRIP1 Level is Low  */
  PWM_TRIP1LVL_HI = 1   /**< TRIP1 Level is High */
} RAWTRIP1;


/*  =========================================================================
 *! \enum   FLTTRIPC
 *! \brief  Fault Trip Status for Channel C (FLTTRIPC) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_FLTC_NOTRIP = 0,  /**< Channel C Fault Trip Status is "not tripped" */
  PWM_FLTC_TRIP   = 1   /**< Channel C Fault Trip Status is "tripped"     */
} FLTTRIPC;


/*  =========================================================================
 *! \enum   PULSEMODEHI
 *! \brief  High Side Output Pulse Position (PULSEMODEHI) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SYM_HI   = 0,  /**< Symmetrical  */
  PWM_ASYM_HI  = 1,  /**< Asymmetrical */
  PWM_LEFT_HI  = 2,  /**< Left Half    */
  PWM_RIGHT_HI = 3   /**< Right Half   */
} PULSEMODEHI;


/*  =========================================================================
 *! \enum   MODE1A
 *! \brief  Mode of TRIP1 for Channel A (MODE1A) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1A_FLT   = 0,  /**< Fault Trip on TRIP1 Input   */
  PWM_TRIP1A_RSTRT = 1   /**< Self Restart on TRIP1 Input */
} MODE1A;


/*  =========================================================================
 *! \enum   FLTTRIPB
 *! \brief  Fault Trip Status for Channel B (FLTTRIPB) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_FLTB_NOTRIP = 0,  /**< Channel B Fault Trip Status is "not tripped" */
  PWM_FLTB_TRIP   = 1   /**< Channel A Fault Trip Status is "tripped"     */
} FLTTRIPB;


/*  =========================================================================
 *! \enum   POLCH
 *! \brief  Channel C High side Polarity (POLCH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CH_ACTLO = 0,  /**< Active Low  */
  PWM_CH_ACTHI = 1   /**< Active High */
} POLCH;


/*  =========================================================================
 *! \enum   PULSEMODELO
 *! \brief  Low Side Output Pulse Position (PULSEMODELO) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SYM_LO   = 0,  /**< Symmetrical  */
  PWM_ASYM_LO  = 1,  /**< Asymmetrical */
  PWM_LEFT_LO  = 2,  /**< Left Half    */
  PWM_RIGHT_LO = 3   /**< Right Half   */
} PULSEMODELO;


/*  =========================================================================
 *! \enum   REFTMRB
 *! \brief  Channel B Timer Reference (REFTMRB) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_REFTMRB_0 = 0,  /**< PWMTMR0 is Channel B reference  */
  PWM_REFTMRB_1 = 1   /**< PWMTMR1 is Channel B reference  */
} REFTMRB;


/*  =========================================================================
 *! \enum   EN1SELD
 *! \brief  TRIP1 Enable Select for Channel D Low Side (EN1SELD) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SEL_EN0D  = 0,  /**< Select EN0D for Channel D Low Side Trip0 Enable  */
  PWM_SEL_EN0DL = 1   /**< Select EN0DL for Channel D Low Side Trip0 Enable */
} EN1SELD;


/*  =========================================================================
 *! \enum   ENCHOPDL
 *! \brief  Channel D Gate Chopping Enable Low Side (ENCHOPDL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPDL_DIS = 0,  /**< Disable Chopping Channel D Low Side */
  PWM_CHOPDL_EN  = 1   /**< Enable Chopping Channel D Low Side  */
} ENCHOPDL;


/*  =========================================================================
 *! \enum   REFTMRC
 *! \brief  Channel C Timer Reference (REFTMRC) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_REFTMRC_0 = 0,  /**< PWMTMR0 is Channel C reference */
  PWM_REFTMRC_1 = 1   /**< PWMTMR1 is Channel C reference */
} REFTMRC;


/*  =========================================================================
 *! \enum   DLYCEN
 *! \brief  Enable Delay Counter for Channel C (DLYCEN) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DLYC_DIS = 0,  /**< Disable */
  PWM_DLYC_EN  = 1   /**< Enable  */
} DLYCEN;


/*  =========================================================================
 *! \enum   POLDH
 *! \brief  Channel D High side Polarity (POLDH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DH_ACTLO = 0,  /**< Active Low  */
  PWM_DH_ACTHI = 1   /**< Active High */
} POLDH;


/*  =========================================================================
 *! \enum   REFTMRA
 *! \brief  Channel A Timer Reference (REFTMRA) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_REFTMRA_0 = 0,  /**< PWMTMR0 is Channel A reference */
  PWM_REFTMRA_1 = 1   /**< PWMTMR1 is Channel A reference */
} REFTMRA;


/*  =========================================================================
 *! \enum   TMR4PHASE
 *! \brief  PWMTMR4 Phase Status (TMR4PHASE) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TMR4PH1 = 0,  /**< 1st Half Phase */
  PWM_TMR4PH2 = 1   /**< 2nd Half Phase */
} TMR4PHASE;


/*  =========================================================================
 *! \enum   ENCHOPAH
 *! \brief  Channel A Gate Chopping Enable High Side (ENCHOPAH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPAH_DIS = 0,  /**< Disable Chopping Channel A High Side */
  PWM_CHOPAH_EN  = 1   /**< Enable Chopping Channel A High Side  */
} ENCHOPAH;


/*  =========================================================================
 *! \enum   EXTSYNC
 *! \brief  External Sync (EXTSYNC) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_INTSYNC = 0,  /**< Internal sync used */
  PWM_EXTSYNC = 1   /**< External sync used */
} EXTSYNC;


/*  =========================================================================
 *! \enum   GLOBEN
 *! \brief  Module Enable (GLOBEN) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_PWM_DIS = 0,  /**< Disable */
  PWM_PWM_EN  = 1   /**< Enable  */
} GLOBEN;


/*  =========================================================================
 *! \enum   POLAL
 *! \brief  Channel A low side Polarity (POLAL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_AL_ACTLO = 0,  /**< Active Low  */
  PWM_AL_ACTHI = 1   /**< Active High */
} POLAL;


/*  =========================================================================
 *! \enum   SRTRIPC
 *! \brief  Self-Restart Trip Status for Channel C (SRTRIPC) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SRC_NOTRIP = 0,  /**< Channel C Self-Restart Trip Status is "not tripped" */
  PWM_SRC_TRIP   = 1   /**< Channel C Self-Restart Trip Status is "tripped"     */
} SRTRIPC;


/*  =========================================================================
 *! \enum   EN1A
 *! \brief  Enable TRIP1 as a trip source for Channel A (EN1A) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1A_DIS = 0,  /**< Disable TRIP1 for Channel A */
  PWM_TRIP1A_EN  = 1   /**< Enable TRIP1 for Channel A  */
} EN1A;


/*  =========================================================================
 *! \enum   MODELSD
 *! \brief  Channel D Mode of low Side Output (MODELSD) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_LOD_INVHI = 0,  /**< Invert of high output */
  PWM_LOD_IND   = 1   /**< Independent control   */
} MODELSD;


/*  =========================================================================
 *! \enum   EN1SELB
 *! \brief  TRIP1 Enable Select for Channel B Low Side (EN1SELB) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SEL_EN0B  = 0,  /**< Select EN0B for Channel B Low Side Trip0 Enable  */
  PWM_SEL_EN0BL = 1   /**< Select EN0BL for Channel B Low Side Trip0 Enable */
} EN1SELB;


/*  =========================================================================
 *! \enum   POLBH
 *! \brief  Channel B High side Polarity (POLBH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_BH_ACTLO = 0,  /**< Active Low  */
  PWM_BH_ACTHI = 1   /**< Active High */
} POLBH;


/*  =========================================================================
 *! \enum   POLCL
 *! \brief  Channel C low side Polarity (POLCL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CL_ACTLO = 0,  /**< Active Low  */
  PWM_CL_ACTHI = 1   /**< Active High */
} POLCL;


/*  =========================================================================
 *! \enum   ENCHOPDH
 *! \brief  Channel D Gate Chopping Enable High Side (ENCHOPDH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPDH_DIS = 0,  /**< Disable Chopping Channel D High Side */
  PWM_CHOPDH_EN  = 1   /**< Enable Chopping Channel D High Side  */
} ENCHOPDH;


/*  =========================================================================
 *! \enum   POLBL
 *! \brief  Channel B low side Polarity (POLBL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_BL_ACTLO = 0,  /**< Active Low  */
  PWM_BL_ACTHI = 1   /**< Active High */
} POLBL;


/*  =========================================================================
 *! \enum   EN0A
 *! \brief  Enable TRIP0 as a trip source for Channel A (EN0A) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0A_DIS = 0,  /**< Disable TRIP0 for Channel A */
  PWM_TRIP0A_EN  = 1   /**< Enable TRIP0 for Channel A  */
} EN0A;


/*  =========================================================================
 *! \enum   TPOLDH
 *! \brief  Channel D High Side Trip Polarity (TPOLDH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_DIS = 0,  /**< Set to Inactive Polarity upon Trip */
  PWM_EN  = 1,  /**< Set to Active Polarity upon Trip   */
  PWM_HIZ = 2   /**< Set to High Impedance upon Trip    */
} TPOLDH;


/*  =========================================================================
 *! \enum   MODELSB
 *! \brief  Channel B Mode of low Side Output (MODELSB) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_LOB_INV = 0,  /**< Invert of high output */
  PWM_LOB_IND = 1   /**< Independent control   */
} MODELSB;


/*  =========================================================================
 *! \enum   EN0C
 *! \brief  Enable TRIP0 as a trip source for Channel C (EN0C) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0C_DIS = 0,  /**< Disable TRIP0 for Channel C */
  PWM_TRIP0C_EN  = 1   /**< Enable TRIP0 for Channel C  */
} EN0C;


/*  =========================================================================
 *! \enum   ENCHOPBL
 *! \brief  Channel B Gate Chopping Enable Low Side (ENCHOPBL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_CHOPBL_DIS = 0,  /**< Disable Chopping Channel B Low Side */
  PWM_CHOPBL_EN  = 1   /**< Enable Chopping Channel B Low Side  */
} ENCHOPBL;


/*  =========================================================================
 *! \enum   EN1B
 *! \brief  Enable TRIP1 as a trip source for Channel B (EN1B) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1B_DIS = 0,  /**< Disable TRIP1 for Channel B */
  PWM_TRIP1B_EN  = 1   /**< Enable TRIP1 for Channel B  */
} EN1B;


/*  =========================================================================
 *! \enum   MODE0B
 *! \brief  Mode of TRIP0 for Channel B (MODE0B) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0B_FLT   = 0,  /**< Fault Trip on TRIP0 Input   */
  PWM_TRIP0B_RSTRT = 1   /**< Self Restart on TRIP0 Input */
} MODE0B;


/*  =========================================================================
 *! \enum   MODELSC
 *! \brief  Channel C Mode of low Side Output (MODELSC) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_LOC_INVHI = 0,  /**< Invert of high output */
  PWM_LOC_IND   = 1   /**< Independent control   */
} MODELSC;


/*  =========================================================================
 *! \enum   POLAH
 *! \brief  Channel A High side Polarity (POLAH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_AH_ACTLO = 0,  /**< Active Low  */
  PWM_AH_ACTHI = 1   /**< Active High */
} POLAH;


/*  =========================================================================
 *! \enum   SRTRIPA
 *! \brief  Self-Restart Trip Status for Channel A (SRTRIPA) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_SRA_NOTRIP = 0,  /**< Channel A Self-Restart Trip Status is "not tripped" */
  PWM_SRA_TRIP   = 1   /**< Channel A Self-Restart Trip Status is "tripped"     */
} SRTRIPA;


/*  =========================================================================
 *! \enum   EMURUN
 *! \brief  Output Behavior During Emulation Mode (EMURUN) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_EMURUN_DIS = 0,  /**< Disable Outputs */
  PWM_EMURUN_EN  = 1   /**< Enable Outputs  */
} EMURUN;


/*  =========================================================================
 *! \enum   ENHPCH
 *! \brief  Channel C heightened-precision enable for high side Output (ENHPCH) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_HPCH_DIS = 0,  /**< Disable HP Output Channel C High */
  PWM_HPCH_EN  = 1   /**< Enable HP Output Channel C High  */
} ENHPCH;


/*  =========================================================================
 *! \enum   EN0BL
 *! \brief  Enable TRIP0 as a trip source for Channel B Low Side (EN0BL) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP0BL_DIS = 0,  /**< Disable Trip0 for Channel B Low Side */
  PWM_TRIP0BL_EN  = 1   /**< Enable Trip0 for Channel B Low Side  */
} EN0BL;


/*  =========================================================================
 *! \enum   MODE1C
 *! \brief  Mode of TRIP1 for Channel C (MODE1C) GLOBAL Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_TRIP1C_FLT   = 0,  /**< Fault Trip on TRIP1 Input   */
  PWM_TRIP1C_RSTRT = 1   /**< Self Restart on TRIP1 Input */
} MODE1C;

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register enables the PWM, enables delay counters for the channels, and configures sync features. This register also provides support for tripping a PWM fault condition through software.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CTL_t {
  union {
    struct {
      unsigned int GLOBEN     :  1;  /**< Module Enable */
      unsigned int EMURUN     :  1;  /**< Output Behavior During Emulation Mode */
      unsigned int SWTRIP     :  1;  /**< Software Trip */
      unsigned int DUEN       :  1;  /**< Double Update Mode Enable */
      unsigned int DLYAEN     :  1;  /**< Enable Delay Counter for Channel A */
      unsigned int DLYBEN     :  1;  /**< Enable Delay Counter for Channel B */
      unsigned int DLYCEN     :  1;  /**< Enable Delay Counter for Channel C */
      unsigned int DLYDEN     :  1;  /**< Enable Delay Counter for Channel D */
      unsigned int ADEN       :  1;  /**< Asymmetric Dead-time Enable */
      unsigned int reserved9  :  7;
      unsigned int EXTSYNC    :  1;  /**< External Sync */
      unsigned int EXTSYNCSEL :  1;  /**< External Sync Select */
      unsigned int INTSYNCREF :  3;  /**< Timer reference for Internal Sync */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CTL_t;

/*@}*/

/** @defgroup CHANCFG Channel Config Register (CHANCFG) Register
 *  Channel Config Register (CHANCFG) Register.
 *
 *  The CHANCFG register configures Channel A, B, C, and D reference timer selection, high and low side output features, and enables high frequency chopping operation. Do not change the value of any bits in the PWM register while the PWM is enabled (CTL:GLOBEN =1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CHANCFG_Struct
 *! \brief  Channel Config Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CHANCFG_t {
  union {
    struct {
      unsigned int REFTMRA    :  1;  /**< Channel A Timer Reference */
      unsigned int MODELSA    :  1;  /**< Channel A Mode of low Side Output */
      unsigned int POLAH      :  1;  /**< Channel A High side Polarity */
      unsigned int ENCHOPAH   :  1;  /**< Channel A Gate Chopping Enable High Side */
      unsigned int ENHPAH     :  1;  /**< Channel A heightened-precision enable for high side Output */
      unsigned int POLAL      :  1;  /**< Channel A low side Polarity */
      unsigned int ENCHOPAL   :  1;  /**< Channel A Gate Chopping Enable Low Side */
      unsigned int reserved7  :  1;
      unsigned int REFTMRB    :  1;  /**< Channel B Timer Reference */
      unsigned int MODELSB    :  1;  /**< Channel B Mode of low Side Output */
      unsigned int POLBH      :  1;  /**< Channel B High side Polarity */
      unsigned int ENCHOPBH   :  1;  /**< Channel B Gate Chopping Enable High Side */
      unsigned int ENHPBH     :  1;  /**< Channel B heightened-precision enable for high side Output */
      unsigned int POLBL      :  1;  /**< Channel B low side Polarity */
      unsigned int ENCHOPBL   :  1;  /**< Channel B Gate Chopping Enable Low Side */
      unsigned int reserved15 :  1;
      unsigned int REFTMRC    :  1;  /**< Channel C Timer Reference */
      unsigned int MODELSC    :  1;  /**< Channel C Mode of low Side Output */
      unsigned int POLCH      :  1;  /**< Channel C High side Polarity */
      unsigned int ENCHOPCH   :  1;  /**< Channel C Gate Chopping Enable High Side */
      unsigned int ENHPCH     :  1;  /**< Channel C heightened-precision enable for high side Output */
      unsigned int POLCL      :  1;  /**< Channel C low side Polarity */
      unsigned int ENCHOPCL   :  1;  /**< Channel C Gate Chopping Enable Low Side */
      unsigned int reserved23 :  1;
      unsigned int REFTMRD    :  1;  /**< Channel D Timer Reference */
      unsigned int MODELSD    :  1;  /**< Channel D Mode of low Side Output */
      unsigned int POLDH      :  1;  /**< Channel D High side Polarity */
      unsigned int ENCHOPDH   :  1;  /**< Channel D Gate Chopping Enable High Side */
      unsigned int ENHPDH     :  1;  /**< Channel D heightened-precision enable for high side Output */
      unsigned int POLDL      :  1;  /**< Channel D low side Polarity */
      unsigned int ENCHOPDL   :  1;  /**< Channel D Gate Chopping Enable Low Side */
      unsigned int reserved31 :  1;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CHANCFG_t;

/*@}*/

/** @defgroup TRIPCFG Trip Config Register (TRIPCFG) Register
 *  Trip Config Register (TRIPCFG) Register.
 *
 *  The TRIPCFG register configures Channel A, B, C, and D trip operation for trip inputs TRIP0 and TRIP1.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TRIPCFG_Struct
 *! \brief  Trip Config Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TRIPCFG_t {
  union {
    struct {
      unsigned int EN0A       :  1;  /**< Enable TRIP0 as a trip source for Channel A */
      unsigned int MODE0A     :  1;  /**< Mode of TRIP0 for Channel A */
      unsigned int EN1A       :  1;  /**< Enable TRIP1 as a trip source for Channel A */
      unsigned int MODE1A     :  1;  /**< Mode of TRIP1 for Channel A */
      unsigned int EN0AL      :  1;  /**< Enable TRIP0 as a trip source for Channel A Low Side */
      unsigned int EN0SELA    :  1;  /**< TRIP0 Enable Select for Channel A Low Side */
      unsigned int EN1AL      :  1;  /**< Enable TRIP1 as a trip source for Channel A Low Side */
      unsigned int EN1SELA    :  1;  /**< TRIP1 Enable Select for Channel A Low Side */
      unsigned int EN0B       :  1;  /**< Enable TRIP0 as a trip source for Channel B */
      unsigned int MODE0B     :  1;  /**< Mode of TRIP0 for Channel B */
      unsigned int EN1B       :  1;  /**< Enable TRIP1 as a trip source for Channel B */
      unsigned int MODE1B     :  1;  /**< Mode of TRIP1 for Channel B */
      unsigned int EN0BL      :  1;  /**< Enable TRIP0 as a trip source for Channel B Low Side */
      unsigned int EN0SELB    :  1;  /**< TRIP0 Enable Select for Channel B Low Side */
      unsigned int EN1BL      :  1;  /**< Enable TRIP1 as a trip source for Channel B Low Side */
      unsigned int EN1SELB    :  1;  /**< TRIP1 Enable Select for Channel B Low Side */
      unsigned int EN0C       :  1;  /**< Enable TRIP0 as a trip source for Channel C */
      unsigned int MODE0C     :  1;  /**< Mode of TRIP0 for Channel C */
      unsigned int EN1C       :  1;  /**< Enable TRIP1 as a trip source for Channel C */
      unsigned int MODE1C     :  1;  /**< Mode of TRIP1 for Channel C */
      unsigned int EN0CL      :  1;  /**< Enable TRIP0 as a trip source for Channel C Low Side */
      unsigned int EN0SELC    :  1;  /**< TRIP0 Enable Select for Channel C Low Side */
      unsigned int EN1CL      :  1;  /**< Enable TRIP1 as a trip source for Channel C Low Side */
      unsigned int EN1SELC    :  1;  /**< TRIP1 Enable Select for Channel C Low Side */
      unsigned int EN0D       :  1;  /**< Enable TRIP0 as a trip source for Channel D */
      unsigned int MODE0D     :  1;  /**< Mode of TRIP0 for Channel D */
      unsigned int EN1D       :  1;  /**< Enable TRIP1 as a trip source for Channel D */
      unsigned int MODE1D     :  1;  /**< Mode of TRIP1 for Channel D */
      unsigned int EN0DL      :  1;  /**< Enable TRIP0 as a trip source for Channel D Low Side */
      unsigned int EN0SELD    :  1;  /**< TRIP0 Enable Select for Channel D Low Side */
      unsigned int EN1DL      :  1;  /**< Enable TRIP1 as a trip source for Channel D Low Side */
      unsigned int EN1SELD    :  1;  /**< TRIP1 Enable Select for Channel D Low Side */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TRIPCFG_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates the PWM PWMTRIP1-0 fault and input level status, indicates the Channel A-D fault and self-restart status, and indicates the PWMTMR4-0 phase.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TRIP0
 *! \brief  Status bit set when TRIP0 is active low (TRIP0) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NO_TRIP0 = 0,  /**< TRIP0 status is "not tripped"          */
  PWM_STAT_TRIP0    = 1   /**< TRIP0 status is "tripped" (active low) */
} ADI_PWM_STAT_TRIP0;


/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TRIP1
 *! \brief  Status bit set when TRIP1 is active low (TRIP1) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NO_TRIP1 = 0,  /**< TRIP1 status is "not tripped"          */
  PWM_STAT_TRIP1    = 1   /**< TRIP1 status is "tripped" (active low) */
} ADI_PWM_STAT_TRIP1;


/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TMR0PER
 *! \brief  PWMTMR0 Period Boundary Status (TMR0PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NOT_PER0 = 0,  /**< PWMTMR0 period boundary not reached */
  PWM_STAT_PER0     = 1   /**< PWMTMR0 period boundary reached     */
} ADI_PWM_STAT_TMR0PER;


/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TMR1PER
 *! \brief  PWMTMR1 Period Boundary Status (TMR1PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NOT_PER1 = 0,  /**< PWMTMR1 period boundary not reached */
  PWM_STAT_PER1     = 1   /**< PWMTMR1 period boundary reached     */
} ADI_PWM_STAT_TMR1PER;


/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TMR2PER
 *! \brief  PWMTMR2 Period Boundary Status (TMR2PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NOT_PER2 = 0,  /**< PWMTMR2 period boundary not reached */
  PWM_STAT_PER2     = 1   /**< PWMTMR2 period boundary reached     */
} ADI_PWM_STAT_TMR2PER;


/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TMR3PER
 *! \brief  PWMTMR3 Period Boundary Status (TMR3PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NOT_PER3 = 0,  /**< PWMTMR3 period boundary not reached */
  PWM_STAT_PER3     = 1   /**< PWMTMR3 period boundary reached     */
} ADI_PWM_STAT_TMR3PER;


/*  =========================================================================
 *! \enum   ADI_PWM_STAT_TMR4PER
 *! \brief  PWMTMR4 Period Boundary Status (TMR4PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_STAT_NOT_PER4 = 0,  /**< PWMTMR4 period boundary not reached */
  PWM_STAT_PER4     = 1   /**< PWMTMR4 period boundary reached     */
} ADI_PWM_STAT_TMR4PER;


/* ==========================================================================
 *! \struct ADI_PWM_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_STAT_t {
  union {
    struct {
      unsigned int TRIP0      :  1;  /**< Status bit set when TRIP0 is active low */
      unsigned int TRIP1      :  1;  /**< Status bit set when TRIP1 is active low */
      unsigned int RAWTRIP0   :  1;  /**< Raw Trip 0 Status */
      unsigned int RAWTRIP1   :  1;  /**< Raw Trip 1 Status */
      unsigned int FLTTRIPA   :  1;  /**< Fault Trip Status for Channel A */
      unsigned int SRTRIPA    :  1;  /**< Self-Restart Trip Status for Channel A */
      unsigned int FLTTRIPB   :  1;  /**< Fault Trip Status for Channel B */
      unsigned int SRTRIPB    :  1;  /**< Self-Restart Trip Status for Channel B */
      unsigned int FLTTRIPC   :  1;  /**< Fault Trip Status for Channel C */
      unsigned int SRTRIPC    :  1;  /**< Self-Restart Trip Status for Channel C */
      unsigned int FLTTRIPD   :  1;  /**< Fault Trip Status for Channel D */
      unsigned int SRTRIPD    :  1;  /**< Self-Restart Trip Status for Channel D */
      unsigned int reserved12 :  4;
      unsigned int TMR0PER    :  1;  /**< PWMTMR0 Period Boundary Status */
      unsigned int TMR1PER    :  1;  /**< PWMTMR1 Period Boundary Status */
      unsigned int TMR2PER    :  1;  /**< PWMTMR2 Period Boundary Status */
      unsigned int TMR3PER    :  1;  /**< PWMTMR3 Period Boundary Status */
      unsigned int TMR4PER    :  1;  /**< PWMTMR4 Period Boundary Status */
      unsigned int reserved21 :  3;
      unsigned int TMR0PHASE  :  1;  /**< PWMTMR0 Phase Status */
      unsigned int TMR1PHASE  :  1;  /**< PWMTMR1 Phase Status */
      unsigned int TMR2PHASE  :  1;  /**< PWMTMR2 Phase Status */
      unsigned int TMR3PHASE  :  1;  /**< PWMTMR3 Phase Status */
      unsigned int TMR4PHASE  :  1;  /**< PWMTMR4 Phase Status */
      unsigned int reserved29 :  1;
      unsigned int EMU        :  1;  /**< Emulator Status */
      unsigned int HPRDY      :  1;  /**< Heightened-Precision Ready Status */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_STAT_t;

/*@}*/

/** @defgroup IMSK Interrupt Mask Register (IMSK) Register
 *  Interrupt Mask Register (IMSK) Register.
 *
 *  The IMSK register masks (disables) or unmasks (enables) PWM interrupts. When an unmasked interrupt occurs, the PWM latches the interrupt status in the ILAT register.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TRIP0
 *! \brief  TRIP0 Interrupt Enable (TRIP0) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_TRIP0_MSK  = 0,  /**< Mask TRIP0 Interrupt   */
  PWM_IMSK_TRIP0_UMSK = 1   /**< Unmask TRIP0 Interrupt */
} ADI_PWM_IMSK_TRIP0;


/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TRIP1
 *! \brief  TRIP1 Interrupt Enable (TRIP1) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_TRIP1_MSK  = 0,  /**< Mask TRIP1 Interrupt   */
  PWM_IMSK_TRIP1_UMSK = 1   /**< Unmask TRIP1 Interrupt */
} ADI_PWM_IMSK_TRIP1;


/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TMR0PER
 *! \brief  PWMTMR0 Period Boundary Interrupt Enable (TMR0PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_PER0_MSK  = 0,  /**< Mask PWMTMR0 Period Interrupt   */
  PWM_IMSK_PER0_UMSK = 1   /**< Unmask PWMTMR0 Period Interrupt */
} ADI_PWM_IMSK_TMR0PER;


/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TMR1PER
 *! \brief  PWMTMR1 Period Boundary Interrupt Enable (TMR1PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_PER1_MSK  = 0,  /**< Mask PWMTMR1 Period Interrupt   */
  PWM_IMSK_PER1_UMSK = 1   /**< Unmask PWMTMR1 Period Interrupt */
} ADI_PWM_IMSK_TMR1PER;


/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TMR2PER
 *! \brief  PWMTMR2 Period Boundary Interrupt Enable (TMR2PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_PER2_MSK  = 0,  /**< Mask PWMTMR2 Period Interrupt   */
  PWM_IMSK_PER2_UMSK = 1   /**< Unmask PWMTMR2 Period Interrupt */
} ADI_PWM_IMSK_TMR2PER;


/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TMR3PER
 *! \brief  PWMTMR3 Period Boundary Interrupt Enable (TMR3PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_PER3_MSK  = 0,  /**< Mask PWMTMR3 Period Interrupt   */
  PWM_IMSK_PER3_UMSK = 1   /**< Unmask PWMTMR3 Period Interrupt */
} ADI_PWM_IMSK_TMR3PER;


/*  =========================================================================
 *! \enum   ADI_PWM_IMSK_TMR4PER
 *! \brief  PWMTMR4 Period Boundary Interrupt Enable (TMR4PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_IMSK_PER4_MSK  = 0,  /**< Mask PWMTMR4 Period Interrupt   */
  PWM_IMSK_PER4_UMSK = 1   /**< Unmask PWMTMR4 Period Interrupt */
} ADI_PWM_IMSK_TMR4PER;


/* ==========================================================================
 *! \struct ADI_PWM_IMSK_Struct
 *! \brief  Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_IMSK_t {
  union {
    struct {
      unsigned int TRIP0      :  1;  /**< TRIP0 Interrupt Enable */
      unsigned int TRIP1      :  1;  /**< TRIP1 Interrupt Enable */
      unsigned int reserved2  : 14;
      unsigned int TMR0PER    :  1;  /**< PWMTMR0 Period Boundary Interrupt Enable */
      unsigned int TMR1PER    :  1;  /**< PWMTMR1 Period Boundary Interrupt Enable */
      unsigned int TMR2PER    :  1;  /**< PWMTMR2 Period Boundary Interrupt Enable */
      unsigned int TMR3PER    :  1;  /**< PWMTMR3 Period Boundary Interrupt Enable */
      unsigned int TMR4PER    :  1;  /**< PWMTMR4 Period Boundary Interrupt Enable */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_IMSK_t;

/*@}*/

/** @defgroup ILAT Interrupt Latch Register (ILAT) Register
 *  Interrupt Latch Register (ILAT) Register.
 *
 *  The ILAT register latches the occurrence of unmasked (enabled) PWM interrupts. These interrupts are unmasked or masked with the IMSK register.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TRIP0
 *! \brief  TRIP0 Interrupt Latched Status (TRIP0) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_TRIP0_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_TRIP0_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TRIP0;


/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TRIP1
 *! \brief  TRIP1 Interrupt Latched Status (TRIP1) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_TRIP1_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_TRIP1_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TRIP1;


/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TMR0PER
 *! \brief  PWMTMR0 Period Boundary Interrupt Latched Status (TMR0PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_PER0_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_PER0_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TMR0PER;


/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TMR1PER
 *! \brief  PWMTMR1 Period Latched Interrupt Status (TMR1PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_PER1_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_PER1_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TMR1PER;


/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TMR2PER
 *! \brief  PWMTMR2 Period Latched Interrupt Status (TMR2PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_PER2_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_PER2_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TMR2PER;


/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TMR3PER
 *! \brief  PWMTMR3 Period Latched Interrupt Status (TMR3PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_PER3_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_PER3_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TMR3PER;


/*  =========================================================================
 *! \enum   ADI_PWM_ILAT_TMR4PER
 *! \brief  PWMTMR4 Period Latched Interrupt Status (TMR4PER) Enumerations
 *  ========================================================================= */
typedef enum
{
  PWM_ILAT_PER4_INTLO = 0,  /**< No Interrupt Latched */
  PWM_ILAT_PER4_INTHI = 1   /**< Interrupt Latched    */
} ADI_PWM_ILAT_TMR4PER;


/* ==========================================================================
 *! \struct ADI_PWM_ILAT_Struct
 *! \brief  Interrupt Latch Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_ILAT_t {
  union {
    struct {
      unsigned int TRIP0      :  1;  /**< TRIP0 Interrupt Latched Status */
      unsigned int TRIP1      :  1;  /**< TRIP1 Interrupt Latched Status */
      unsigned int reserved2  : 14;
      unsigned int TMR0PER    :  1;  /**< PWMTMR0 Period Boundary Interrupt Latched Status */
      unsigned int TMR1PER    :  1;  /**< PWMTMR1 Period Latched Interrupt Status */
      unsigned int TMR2PER    :  1;  /**< PWMTMR2 Period Latched Interrupt Status */
      unsigned int TMR3PER    :  1;  /**< PWMTMR3 Period Latched Interrupt Status */
      unsigned int TMR4PER    :  1;  /**< PWMTMR4 Period Latched Interrupt Status */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_ILAT_t;

/*@}*/

/** @defgroup CHOPCFG Chop Configuration Register (CHOPCFG) Register
 *  Chop Configuration Register (CHOPCFG) Register.
 *
 *  The CHOPCFG register holds a divisor value that controls the chopping frequency. The PWM permits a mixing of the output signals with a high-frequency chopping signal to aid with interfacing to pulse transformers. Also note that high-frequency chopping may be independently enabled for each channel's high-side and the low-side outputs using channel control bits. (For example, control chopping for Channel A with the CHANCFG:ENCHOPAH and CHANCFG:ENCHOPAH bits.)
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CHOPCFG_Struct
 *! \brief  Chop Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CHOPCFG_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< Gate Chopping Divisor */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CHOPCFG_t;

/*@}*/

/** @defgroup SYNC_WID Sync Pulse Width Register (SYNC_WID) Register
 *  Sync Pulse Width Register (SYNC_WID) Register.
 *
 *  The SYNC_WID register selects the pulse width for the external sync pulse available on the SYNC pin. The relation between the SYNC_WID register value and the pulse width (T$[sub$]PWM_SYNC$[/sub$]) is give by the formula: 
 *  PWM_SYNC_WID = (T$[sub$]PWM_SYNC$[/sub$] / t$[sub$]CK$[/sub$]) -1 
 *  For more information about applying the sync pulse width, see the PWM Functional Description section. Note that if the pulse width is changed in between sync pulses, the PWM applies the changed width on the next internal sync pulse. If, while the sync pulse is active, the chosen timer reaches its period boundary, the changed pulse width takes effect on that period boundary.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_SYNC_WID_Struct
 *! \brief  Sync Pulse Width Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_SYNC_WID_t {
  union {
    struct {
      unsigned int VALUE      : 10;  /**< Sync Pulse Width */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_SYNC_WID_t;

/*@}*/

/** @defgroup TM0 Timer 0 Period Register (TM0) Register
 *  Timer 0 Period Register (TM0) Register.
 *
 *  The TM0 register controls the switch period (T$[sub$]SP$[/sub$] of the PWMTMR0 timer. The TM0 value is in units of t$[sub$]CK$[/sub$] (the period of the peripheral clock) and the and is given by the formula: 
 *  
 *  PWM_TM0= (T$[sub$]SP$[/sub$]) / 2 x t$[sub$]CK$[/sub$] 
 *  
 *  The value written to the register is effectively the number of t$[sub$]CK$[/sub$] clock increments in half the period of the respective timer. For more information about applying the switch period, see the PWM Functional Description section. Note that TM0 values of 0 and 1 are not defined and must not be used when the PWM is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TM0_Struct
 *! \brief  Timer 0 Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TM0_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timer PWMTMR0 Period Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TM0_t;

/*@}*/

/** @defgroup TM1 Timer 1 Period Register (TM1) Register
 *  Timer 1 Period Register (TM1) Register.
 *
 *  The TM1 register controls the switch period (T$[sub$]SP$[/sub$] of the PWMTMR1 timer. The TM1 value is in units of t$[sub$]CK$[/sub$] (the period of the peripheral clock) and the and is given by the formula: 
 *  
 *  PWM_TM1= (T$[sub$]SP$[/sub$]) / 2 x t$[sub$]CK$[/sub$] 
 *  
 *  The value written to the register is effectively the number of t$[sub$]CK$[/sub$] clock increments in half the period of the respective timer. For more information about applying the switch period, see the PWM Functional Description section. Note that TM1 values of 0 and 1 are not defined and must not be used when the PWM is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TM1_Struct
 *! \brief  Timer 1 Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TM1_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timer PWMTMR1 Period Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TM1_t;

/*@}*/

/** @defgroup TM2 Timer 2 Period Register (TM2) Register
 *  Timer 2 Period Register (TM2) Register.
 *
 *  The TM2 register controls the switch period (T$[sub$]SP$[/sub$] of the PWMTMR2 timer. The TM2 value is in units of t$[sub$]CK$[/sub$] (the period of the peripheral clock) and the and is given by the formula: 
 *  
 *  PWM_TM1= (T$[sub$]SP$[/sub$]) / 2 x t$[sub$]CK$[/sub$] 
 *  
 *  The value written to the register is effectively the number of t$[sub$]CK$[/sub$] clock increments in half the period of the respective timer. For more information about applying the switch period, see the PWM Functional Description section. Note that TM2 values of 0 and 1 are not defined and must not be used when the PWM is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TM2_Struct
 *! \brief  Timer 2 Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TM2_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timer PWMTMR2 Period Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TM2_t;

/*@}*/

/** @defgroup TM3 Timer 3 Period Register (TM3) Register
 *  Timer 3 Period Register (TM3) Register.
 *
 *  The TM3 register controls the switch period (T$[sub$]SP$[/sub$] of the PWMTMR3 timer. The TM3 value is in units of t$[sub$]CK$[/sub$] (the period of the peripheral clock) and the and is given by the formula: 
 *  
 *  PWM_TM3= (T$[sub$]SP$[/sub$]) / 2 x t$[sub$]CK$[/sub$] 
 *  
 *  The value written to the register is effectively the number of t$[sub$]CK$[/sub$] clock increments in half the period of the respective timer. For more information about applying the switch period, see the PWM Functional Description section. Note that TM3 values of 0 and 1 are not defined and must not be used when the PWM is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TM3_Struct
 *! \brief  Timer 3 Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TM3_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timer PWMTMR3 Period Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TM3_t;

/*@}*/

/** @defgroup TM4 Timer 4 Period Register (TM4) Register
 *  Timer 4 Period Register (TM4) Register.
 *
 *  The TM4 register controls the switch period (T$[sub$]SP$[/sub$] of the PWMTMR4 timer. The TM4 value is in units of t$[sub$]CK$[/sub$] (the period of the peripheral clock) and the and is given by the formula: 
 *  
 *  PWM_TM4= (T$[sub$]SP$[/sub$]) / 2 x t$[sub$]CK$[/sub$] 
 *  
 *  The value written to the register is effectively the number of t$[sub$]CK$[/sub$] clock increments in half the period of the respective timer. For more information about applying the switch period, see the PWM Functional Description section. Note that TM4 values of 0 and 1 are not defined and must not be used when the PWM is enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TM4_Struct
 *! \brief  Timer 4 Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TM4_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timer PWMTMR4 Period Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TM4_t;

/*@}*/

/** @defgroup DLYA Channel A Delay Register (DLYA) Register
 *  Channel A Delay Register (DLYA) Register.
 *
 *  The DLYA register controls a delay for the Channel A timer (only PWMTMR1, PWMTMR2, PWMTMR3 or PWMTMR4) with reference to the main timer (PWMTMR0). To use apply this delay, the delay must be enabled (CTL:DLYAEN =1}. For more information about applying the delay, see the PWM Functional Description section. Note that the DLYA delay value must be less that less that twice the period value of the timer being used for the channel (for example, if PWMTMR1 is used, DLYA must be less than 2xPWMTMR1). Also, note that the period of the main timer must be an integer multiple of the timer being used for the channel (for example, if PWMTMR1 is used, PWMTMR0 = NxPWMTMR1, where N is an integer).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DLYA_Struct
 *! \brief  Channel A Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DLYA_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Channel A Delay Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DLYA_t;

/*@}*/

/** @defgroup DLYB Channel B Delay Register (DLYB) Register
 *  Channel B Delay Register (DLYB) Register.
 *
 *  The DLYB register controls a delay for the Channel B timer (only PWMTMR1, PWMTMR2, PWMTMR3 or PWMTMR4) with reference to the main timer (PWMTMR0). To use apply this delay, the delay must be enabled (CTL:DLYBEN =1}. For more information about applying the delay, see the PWM Functional Description section. Note that the DLYB delay value must be less that less that twice the period value of the timer being used for the channel (for example, if PWMTMR1 is used, DLYB must be less than 2xPWMTMR1). Also, note that the period of the main timer must be an integer multiple of the timer being used for the channel (for example, if PWMTMR1 is used, PWMTMR0 = NxPWMTMR1, where N is an integer).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DLYB_Struct
 *! \brief  Channel B Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DLYB_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Channel B Delay Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DLYB_t;

/*@}*/

/** @defgroup DLYC Channel C Delay Register (DLYC) Register
 *  Channel C Delay Register (DLYC) Register.
 *
 *  The DLYC register controls a delay for the Channel C timer (only PWMTMR1, PWMTMR2, PWMTMR3 or PWMTMR4) with reference to the main timer (PWMTMR0). To use apply this delay, the delay must be enabled (CTL:DLYCEN =1}. For more information about applying the delay, see the PWM Functional Description section. Note that the DLYC delay value must be less that less that twice the period value of the timer being used for the channel (for example, if PWMTMR1 is used, DLYC must be less than 2xPWMTMR1). Also, note that the period of the main timer must be an integer multiple of the timer being used for the channel (for example, if PWMTMR1 is used, PWMTMR0 = NxPWMTMR1, where N is an integer).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DLYC_Struct
 *! \brief  Channel C Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DLYC_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Channel C Delay Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DLYC_t;

/*@}*/

/** @defgroup DLYD Channel D Delay Register (DLYD) Register
 *  Channel D Delay Register (DLYD) Register.
 *
 *  The DLYD register controls a delay for the Channel D timer (only PWMTMR1, PWMTMR2, PWMTMR3 or PWMTMR4) with reference to the main timer (PWMTMR0). To use apply this delay, the delay must be enabled (CTL:DLYDEN =1}. For more information about applying the delay, see the PWM Functional Description section. Note that the DLYD delay value must be less that less that twice the period value of the timer being used for the channel (for example, if PWMTMR1 is used, DLYD must be less than 2xPWMTMR1). Also, note that the period of the main timer must be an integer multiple of the timer being used for the channel (for example, if PWMTMR1 is used, PWMTMR0 = NxPWMTMR1, where N is an integer).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DLYD_Struct
 *! \brief  Channel D Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DLYD_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Channel D Delay Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DLYD_t;

/*@}*/

/** @defgroup ACTL Channel A Control Register (ACTL) Register
 *  Channel A Control Register (ACTL) Register.
 *
 *  The ACTL register selects the low and high side output pulse mode, enables low and high side output, and enables low/high side output crossover.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_ACTL_Struct
 *! \brief  Channel A Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_ACTL_t {
  union {
    struct {
      unsigned int DISHI      :  1;  /**< Channel High Side Output Disable */
      unsigned int DISLO      :  1;  /**< Channel Low Side Output Disable */
      unsigned int XOVR       :  1;  /**< high-low Crossover Enable */
      unsigned int reserved3   :  5;
      unsigned int PULSEMODEHI :  2;  /**< High Side Output Pulse Position */
      unsigned int PULSEMODELO :  2;  /**< Low Side Output Pulse Position */
      unsigned int reserved12  : 20;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_ACTL_t;

/*@}*/

/** @defgroup AH0 Channel A-High Duty-0 Register (AH0) Register
 *  Channel A-High Duty-0 Register (AH0) Register.
 *
 *  The AH0 and AH1 registers determine the width for the high side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the high side output pulses for the Channel A duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the ACTL:PULSEMODEHI bits. When the pulse mode is symmetrical, the PWM uses the value in the AH0 register to determine the assertion and de-assertion count for the high side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel A high pulse output for count less than AH0 and de-asserts this output for count greater than AH1. 
 *  The value range for the AH0 and AH1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for AH0 and AH1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the AH0 or AH1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AH0_Struct
 *! \brief  Channel A-High Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AH0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AH0_t;

/*@}*/

/** @defgroup AH1 Channel A-High Duty-1 Register (AH1) Register
 *  Channel A-High Duty-1 Register (AH1) Register.
 *
 *  The AH0 and AH1 registers determine the width for the high side output pulses. For more information, see the AH0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AH1_Struct
 *! \brief  Channel A-High Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AH1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AH1_t;

/*@}*/

/** @defgroup AH0_HP Channel A-High Heightened-Precision Duty-0 Register (AH0_HP) Register
 *  Channel A-High Heightened-Precision Duty-0 Register (AH0_HP) Register.
 *
 *  The AH0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the AH0 register, allows programs to specify fractional duty cycles.The AH0_HP register and the AH0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the AH0_HP and the AH0 registers are also present in the single full duty register (AH_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AH0_HP_Struct
 *! \brief  Channel A-High Heightened-Precision Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AH0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AH0_HP_t;

/*@}*/

/** @defgroup AH1_HP Channel A-High Heightened-Precision Duty-1 Register (AH1_HP) Register
 *  Channel A-High Heightened-Precision Duty-1 Register (AH1_HP) Register.
 *
 *  The AH1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the AH0 register, allows programs to specify fractional duty cycles.The AH1_HP register and the AH1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the AH1_HP and the AH1 registers are also present in the single full duty register (AH_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AH1_HP_Struct
 *! \brief  Channel A-High Heightened-Precision Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AH1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AH1_HP_t;

/*@}*/

/** @defgroup AL0 Channel A-Low Duty-0 Register (AL0) Register
 *  Channel A-Low Duty-0 Register (AL0) Register.
 *
 *  The AL0 and AL1 registers determine the width for the low side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the low side output pulses for the Channel A duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the ACTL:PULSEMODELO bits. When the pulse mode is symmetrical, the PWM uses the value in the AL0 register to determine the assertion and de-assertion count for the low side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel A low pulse output for count less than AL0 and de-asserts this output for count greater than AL1. 
 *  The value range for the AL0 and AL1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for AL0 and AL1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the AL0 or AL1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AL0_Struct
 *! \brief  Channel A-Low Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AL0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AL0_t;

/*@}*/

/** @defgroup AL1 Channel A-Low Duty-1 Register (AL1) Register
 *  Channel A-Low Duty-1 Register (AL1) Register.
 *
 *  The AL0 and AL1 registers determine the width for the low side output pulses. For more information, see the AL0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AL1_Struct
 *! \brief  Channel A-Low Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AL1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AL1_t;

/*@}*/

/** @defgroup AL0_HP Channel A-Low Heightened-Precision Duty-0 Register (AL0_HP) Register
 *  Channel A-Low Heightened-Precision Duty-0 Register (AL0_HP) Register.
 *
 *  The AL0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the AL0 register, allows programs to specify fractional duty cycles.The AL0_HP register and the AL0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  Note that the bit fields in the AL0_HP and the AL0 registers are also present in the single full duty register (AL_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AL0_HP_Struct
 *! \brief  Channel A-Low Heightened-Precision Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AL0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AL0_HP_t;

/*@}*/

/** @defgroup AL1_HP Channel A-Low Heightened-Precision Duty-1 Register (AL1_HP) Register
 *  Channel A-Low Heightened-Precision Duty-1 Register (AL1_HP) Register.
 *
 *  The AL1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the AL1 register, allows programs to specify fractional duty cycles.The AL1_HP register and the AL1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  Note that the bit fields in the AL1_HP and the AL1 registers are also present in the single full duty register (AL_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AL1_HP_Struct
 *! \brief  Channel A-Low Heightened-Precision Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AL1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AL1_HP_t;

/*@}*/

/** @defgroup BCTL Channel B Control Register (BCTL) Register
 *  Channel B Control Register (BCTL) Register.
 *
 *  The BCTL register selects the low and high side output pulse mode, enables low and high side output, and enables low/high side output crossover.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BCTL_Struct
 *! \brief  Channel B Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BCTL_t {
  union {
    struct {
      unsigned int DISHI      :  1;  /**< Channel High Side Output Disable */
      unsigned int DISLO      :  1;  /**< Channel Low Side Output Disable */
      unsigned int XOVR       :  1;  /**< high-low Crossover Enable */
      unsigned int reserved3   :  5;
      unsigned int PULSEMODEHI :  2;  /**< High Side Output Pulse Position */
      unsigned int PULSEMODELO :  2;  /**< Low Side Output Pulse Position */
      unsigned int reserved12  : 20;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BCTL_t;

/*@}*/

/** @defgroup BH0 Channel B-High Duty-0 Register (BH0) Register
 *  Channel B-High Duty-0 Register (BH0) Register.
 *
 *  The BH0 and BH1 registers determine the width for the high side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the high side output pulses for the Channel B duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the BCTL:PULSEMODEHI bits. When the pulse mode is symmetrical, the PWM uses the value in the BH0 register to determine the assertion and de-assertion count for the high side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel B high pulse output for count less than BH0 and de-asserts this output for count greater than BH1. 
 *  The value range for the BH0 and BH1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for BH0 and BH1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the BH0 or BH1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BH0_Struct
 *! \brief  Channel B-High Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BH0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BH0_t;

/*@}*/

/** @defgroup BH1 Channel B-High Duty-1 Register (BH1) Register
 *  Channel B-High Duty-1 Register (BH1) Register.
 *
 *  The BH0 and BH1 registers determine the width for the high side output pulses. For more information, see the BH0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BH1_Struct
 *! \brief  Channel B-High Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BH1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BH1_t;

/*@}*/

/** @defgroup BH0_HP Channel B-High Heightened-Precision Duty-0 Register (BH0_HP) Register
 *  Channel B-High Heightened-Precision Duty-0 Register (BH0_HP) Register.
 *
 *  The BH0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the BH0 register, allows programs to specify fractional duty cycles. The BH0_HP register and the BH0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the BH0_HP and the BH0 registers are also present in the single full duty register (BH_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BH0_HP_Struct
 *! \brief  Channel B-High Heightened-Precision Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BH0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BH0_HP_t;

/*@}*/

/** @defgroup BH1_HP Channel B-High Heightened-Precision Duty-1 Register (BH1_HP) Register
 *  Channel B-High Heightened-Precision Duty-1 Register (BH1_HP) Register.
 *
 *  The BH1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the BH1 register, allows programs to specify fractional duty cycles. The BH1_HP register and the BH1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the BH1_HP and the BH1 registers are also present in the single full duty register (BH_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BH1_HP_Struct
 *! \brief  Channel B-High Heightened-Precision Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BH1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BH1_HP_t;

/*@}*/

/** @defgroup BL0 Channel B-Low Duty-0 Register (BL0) Register
 *  Channel B-Low Duty-0 Register (BL0) Register.
 *
 *  The BL0 and BL1 registers determine the width for the low side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the low side output pulses for the Channel B duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the BCTL:PULSEMODELO bits. When the pulse mode is symmetrical, the PWM uses the value in the BL0 register to determine the assertion and de-assertion count for the low side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel B low pulse output for count less than BL0 and de-asserts this output for count greater than BL1. 
 *  The value range for the BL0 and BL1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for BL0 and BL1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the BL0 or BL1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BL0_Struct
 *! \brief  Channel B-Low Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BL0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BL0_t;

/*@}*/

/** @defgroup BL1 Channel B-Low Duty-1 Register (BL1) Register
 *  Channel B-Low Duty-1 Register (BL1) Register.
 *
 *  The BL0 and BL1 registers determine the width for the low side output pulses. For more information, see the BL0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BL1_Struct
 *! \brief  Channel B-Low Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BL1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BL1_t;

/*@}*/

/** @defgroup BL0_HP Channel B-Low Heightened-Precision Duty-0 Register (BL0_HP) Register
 *  Channel B-Low Heightened-Precision Duty-0 Register (BL0_HP) Register.
 *
 *  The BL0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the BL0 register, allows programs to specify fractional duty cycles. The BL0_HP register and the BL0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the BL0_HP and the BL0 registers are also present in the single full duty register (BL_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BL0_HP_Struct
 *! \brief  Channel B-Low Heightened-Precision Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BL0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BL0_HP_t;

/*@}*/

/** @defgroup BL1_HP Channel B-Low Heightened-Precision Duty-1 Register (BL1_HP) Register
 *  Channel B-Low Heightened-Precision Duty-1 Register (BL1_HP) Register.
 *
 *  The BL1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the BL1 register, allows programs to specify fractional duty cycles. The BL1_HP register and the BL1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the BL1_HP and the BL1 registers are also present in the single full duty register (BL_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BL1_HP_Struct
 *! \brief  Channel B-Low Heightened-Precision Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BL1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BL1_HP_t;

/*@}*/

/** @defgroup CCTL Channel C Control Register (CCTL) Register
 *  Channel C Control Register (CCTL) Register.
 *
 *  The CCTL register selects the low and high side output pulse mode, enables low and high side output, and enables low/high side output crossover.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CCTL_Struct
 *! \brief  Channel C Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CCTL_t {
  union {
    struct {
      unsigned int DISHI      :  1;  /**< Channel High Side Output Disable */
      unsigned int DISLO      :  1;  /**< Channel Low Side Output Disable */
      unsigned int XOVR       :  1;  /**< high-low Crossover Enable */
      unsigned int reserved3   :  5;
      unsigned int PULSEMODEHI :  2;  /**< High Side Output Pulse Position */
      unsigned int PULSEMODELO :  2;  /**< Low Side Output Pulse Position */
      unsigned int reserved12  : 20;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CCTL_t;

/*@}*/

/** @defgroup CH0 Channel C-High Pulse Duty Register 0 (CH0) Register
 *  Channel C-High Pulse Duty Register 0 (CH0) Register.
 *
 *  The CH0 and CH1 registers determine the width for the high side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the high side output pulses for the Channel C duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the CCTL:PULSEMODEHI bits. When the pulse mode is symmetrical, the PWM uses the value in the CH0 register to determine the assertion and de-assertion count for the high side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel C high pulse output for count less than CH0 and de-asserts this output for count greater than CH1. 
 *  The value range for the CH0 and CH1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for CH0 and CH1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the CH0 or CH1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CH0_Struct
 *! \brief  Channel C-High Pulse Duty Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CH0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CH0_t;

/*@}*/

/** @defgroup CH1 Channel C-High Pulse Duty Register 1 (CH1) Register
 *  Channel C-High Pulse Duty Register 1 (CH1) Register.
 *
 *  The CH0 and CH1 registers determine the width for the high side output pulses. For more information, see the CH0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CH1_Struct
 *! \brief  Channel C-High Pulse Duty Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CH1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CH1_t;

/*@}*/

/** @defgroup CH0_HP Channel C-High Pulse Heightened-Precision Duty Register 0 (CH0_HP) Register
 *  Channel C-High Pulse Heightened-Precision Duty Register 0 (CH0_HP) Register.
 *
 *  The CH0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the CH0 register, allows programs to specify fractional duty cycles. The CH0_HP register and the CH0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the CH0_HP and the CH0 registers are also present in the single full duty register (CH_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CH0_HP_Struct
 *! \brief  Channel C-High Pulse Heightened-Precision Duty Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CH0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CH0_HP_t;

/*@}*/

/** @defgroup CH1_HP Channel C-High Pulse Heightened-Precision Duty Register 1 (CH1_HP) Register
 *  Channel C-High Pulse Heightened-Precision Duty Register 1 (CH1_HP) Register.
 *
 *  The CH1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the CH1 register, allows programs to specify fractional duty cycles. The CH1_HP register and the CH1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the CH1_HP and the CH1 registers are also present in the single full duty register (CH_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CH1_HP_Struct
 *! \brief  Channel C-High Pulse Heightened-Precision Duty Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CH1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CH1_HP_t;

/*@}*/

/** @defgroup CL0 Channel C-Low Pulse Duty Register 0 (CL0) Register
 *  Channel C-Low Pulse Duty Register 0 (CL0) Register.
 *
 *  The CL0 and CL1 registers determine the width for the low side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the low side output pulses for the Channel C duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the CCTL:PULSEMODELO bits. When the pulse mode is symmetrical, the PWM uses the value in the CL0 register to determine the assertion and de-assertion count for the low side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel C low pulse output for count less than CL0 and de-asserts this output for count greater than CL1. 
 *  The value range for the CL0 and CL1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for CL0 and CL1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the CL0 or CL1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CL0_Struct
 *! \brief  Channel C-Low Pulse Duty Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CL0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CL0_t;

/*@}*/

/** @defgroup CL1 Channel C-Low Duty-1 Register (CL1) Register
 *  Channel C-Low Duty-1 Register (CL1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CL1_Struct
 *! \brief  Channel C-Low Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CL1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CL1_t;

/*@}*/

/** @defgroup CL0_HP Channel C-Low Pulse Duty Register 1 (CL0_HP) Register
 *  Channel C-Low Pulse Duty Register 1 (CL0_HP) Register.
 *
 *  The CL0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the CL0 register, allows programs to specify fractional duty cycles. The CL0_HP register and the CL0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the CL0_HP and the CL0 registers are also present in the single full duty register (CL_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CL0_HP_Struct
 *! \brief  Channel C-Low Pulse Duty Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CL0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CL0_HP_t;

/*@}*/

/** @defgroup CL1_HP Channel C-Low Heightened-Precision Duty-1 Register (CL1_HP) Register
 *  Channel C-Low Heightened-Precision Duty-1 Register (CL1_HP) Register.
 *
 *  The CL1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the CL1 register, allows programs to specify fractional duty cycles. The CL1_HP register and the CL1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the CL1_HP and the CL1 registers are also present in the single full duty register (CL_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CL1_HP_Struct
 *! \brief  Channel C-Low Heightened-Precision Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CL1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CL1_HP_t;

/*@}*/

/** @defgroup DCTL Channel D Control Register (DCTL) Register
 *  Channel D Control Register (DCTL) Register.
 *
 *  The DCTL register selects the low and high side output pulse mode, enables low and high side output, and enables low/high side output crossover.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DCTL_Struct
 *! \brief  Channel D Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DCTL_t {
  union {
    struct {
      unsigned int DISHI      :  1;  /**< Channel High Side Output Disable */
      unsigned int DISLO      :  1;  /**< Channel Low Side Output Disable */
      unsigned int XOVR       :  1;  /**< high-low Crossover Enable */
      unsigned int reserved3   :  5;
      unsigned int PULSEMODEHI :  2;  /**< High Side Output Pulse Position */
      unsigned int PULSEMODELO :  2;  /**< Low Side Output Pulse Position */
      unsigned int reserved12  : 20;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DCTL_t;

/*@}*/

/** @defgroup DH0 Channel D-High Duty-0 Register (DH0) Register
 *  Channel D-High Duty-0 Register (DH0) Register.
 *
 *  The DH0 and DH1 registers determine the width for the high side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the high side output pulses for the Channel D duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the DCTL:PULSEMODEHI bits. When the pulse mode is symmetrical, the PWM uses the value in the DH0 register to determine the assertion and de-assertion count for the high side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel D high pulse output for count less than DH0 and de-asserts this output for count greater than DH1. 
 *  The value range for the DH0 and DH1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for DH0 and DH1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the DH0 or DH1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DH0_Struct
 *! \brief  Channel D-High Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DH0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DH0_t;

/*@}*/

/** @defgroup DH1 Channel D-High Pulse Duty Register 1 (DH1) Register
 *  Channel D-High Pulse Duty Register 1 (DH1) Register.
 *
 *  The DH0 and DH1 registers determine the width for the high side output pulses. For more information, see the DH0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DH1_Struct
 *! \brief  Channel D-High Pulse Duty Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DH1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DH1_t;

/*@}*/

/** @defgroup DH0_HP Channel D-High Pulse Heightened-Precision Duty Register 0 (DH0_HP) Register
 *  Channel D-High Pulse Heightened-Precision Duty Register 0 (DH0_HP) Register.
 *
 *  The DH0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the DH0 register, allows programs to specify fractional duty cycles. The DH0_HP register and the DH0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the DH0_HP and the DH0 registers are also present in the single full duty register (DH_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DH0_HP_Struct
 *! \brief  Channel D-High Pulse Heightened-Precision Duty Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DH0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DH0_HP_t;

/*@}*/

/** @defgroup DH1_HP Channel D High Pulse Heightened-Precision Duty Register 1 (DH1_HP) Register
 *  Channel D High Pulse Heightened-Precision Duty Register 1 (DH1_HP) Register.
 *
 *  The DH1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the DH1 register, allows programs to specify fractional duty cycles. The DH1_HP register and the DH1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the DH1_HP and the DH1 registers are also present in the single full duty register (DH_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DH1_HP_Struct
 *! \brief  Channel D High Pulse Heightened-Precision Duty Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DH1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DH1_HP_t;

/*@}*/

/** @defgroup DL0 Channel D-Low Pulse Duty Register 0 (DL0) Register
 *  Channel D-Low Pulse Duty Register 0 (DL0) Register.
 *
 *  The DL0 and DL1 registers determine the width for the low side output pulses. The values in these registers select the assertion count (in terms of t$[sub$]CK$[/sub$]) of the low side output pulses for the Channel D duty cycle. 
 *  The operation of the duty-cycle registers varies, depending on the pulse mode selected with the DCTL:PULSEMODELO bits. When the pulse mode is symmetrical, the PWM uses the value in the DL0 register to determine the assertion and de-assertion count for the low side output pulses. When the pulse mode is asymmetrical, left half, or right half, the PWM asserts Channel D low pulse output for count less than DL0 and de-asserts this output for count greater than DL1. 
 *  The value range for the DL0 and DL1 registers depends on the period of the timer being used by the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 (two's complement) and +TM0/2, when dead time (DT) is not considered. 
 *  When dead time is considered for symmetrical and asymmetrical pulse modes, the value range for DL0 and DL1 depends on the period of the time being used by the channel and the amount of dead time applied to the channel. For example, if TM0 is used, the duty cycle values may be between -TM0/2 + DT (two's complement) to +TM0/2 + DT. 
 *  When dead time is considered for left half or right half pulse modes, if TM0 is used, the duty cycle values may be between TM0/2 + DT (two's complement) to -TM0/2 - DT. 
 *  Note that using values in the DL0 or DL1 registers that fall outside these limits causes PWM over or under modulation. 
 *  For more information about pulse modes and duty cycle selection, see the Functional Description section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DL0_Struct
 *! \brief  Channel D-Low Pulse Duty Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DL0_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DL0_t;

/*@}*/

/** @defgroup DL1 Channel D-Low Pulse Duty Register 1 (DL1) Register
 *  Channel D-Low Pulse Duty Register 1 (DL1) Register.
 *
 *  The DL0 and DL1 registers determine the width for the low side output pulses. For more information, see the DL0 register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DL1_Struct
 *! \brief  Channel D-Low Pulse Duty Register 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DL1_t {
  union {
    struct {
      unsigned int DUTY       : 16;  /**< Duty Cycle De-Asserted Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DL1_t;

/*@}*/

/** @defgroup DL0_HP Channel D-Low Heightened-Precision Duty-0 Register (DL0_HP) Register
 *  Channel D-Low Heightened-Precision Duty-0 Register (DL0_HP) Register.
 *
 *  The DL0_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the DL0 register, allows programs to specify fractional duty cycles. The DL0_HP register and the DL0 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the DL0_HP and the DL0 registers are also present in the single full duty register (DL_DUTY0).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DL0_HP_Struct
 *! \brief  Channel D-Low Heightened-Precision Duty-0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DL0_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DL0_HP_t;

/*@}*/

/** @defgroup DL1_HP Channel D-Low Heightened-Precision Duty-1 Register (DL1_HP) Register
 *  Channel D-Low Heightened-Precision Duty-1 Register (DL1_HP) Register.
 *
 *  The DL1_HP register provides a fine-grained edge placement within the system clock period. This register, in conjunction with the DL1 register, allows programs to specify fractional duty cycles. The DL1_HP register and the DL1 register work together in a Q15.8 signed two's complement fixed-point format. 
 *  
 *  Note that the bit fields in the DL1_HP and the DL1 registers are also present in the single full duty register (DL_DUTY1).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DL1_HP_Struct
 *! \brief  Channel D-Low Heightened-Precision Duty-1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DL1_HP_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DL1_HP_t;

/*@}*/

/** @defgroup AH_DUTY0 Channel A-High Full Duty0 Register (AH_DUTY0) Register
 *  Channel A-High Full Duty0 Register (AH_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The AH_DUTY0 register contains the DUTY bit field from the AH0 register and the ENHDIV bit field from the AH0_HP register.
 *  
 *  Note that the AH_DUTY0 register reads the AH0 and the AH0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AH_DUTY0_Struct
 *! \brief  Channel A-High Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AH_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AH_DUTY0_t;

/*@}*/

/** @defgroup AH_DUTY1 Channel A-High Full Duty1 Register (AH_DUTY1) Register
 *  Channel A-High Full Duty1 Register (AH_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The AH_DUTY1 register contains the DUTY bit field from the AH1 register and the ENHDIV bit field from the AH1_HP register.
 *  
 *  Note that the AH_DUTY1 register reads the AH1 and the AH1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AH_DUTY1_Struct
 *! \brief  Channel A-High Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AH_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AH_DUTY1_t;

/*@}*/

/** @defgroup AL_DUTY0 Channel A-Low Full Duty0 Register (AL_DUTY0) Register
 *  Channel A-Low Full Duty0 Register (AL_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The AL_DUTY0 register contains the DUTY bit field from the AL0 register and the ENHDIV bit field from the AL0_HP register.
 *  
 *  Note that the AL_DUTY0 register reads the AL0 and the AL0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AL_DUTY0_Struct
 *! \brief  Channel A-Low Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AL_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AL_DUTY0_t;

/*@}*/

/** @defgroup AL_DUTY1 Channel A-Low Full Duty1 Register (AL_DUTY1) Register
 *  Channel A-Low Full Duty1 Register (AL_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The AL_DUTY1 register contains the DUTY bit field from the AL1 register and the ENHDIV bit field from the AH0_HP register.
 *  
 *  Note that the AL_DUTY1 register reads the AL1 and the AL1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_AL_DUTY1_Struct
 *! \brief  Channel A-Low Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_AL_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_AL_DUTY1_t;

/*@}*/

/** @defgroup BH_DUTY0 Channel B-High Full Duty0 Register (BH_DUTY0) Register
 *  Channel B-High Full Duty0 Register (BH_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The BH_DUTY0 register contains the DUTY bit field from the BH0 register and the ENHDIV bit field from the BH0_HP register.
 *  
 *  Note that the BH_DUTY0 register reads the BH0 and the BH0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BH_DUTY0_Struct
 *! \brief  Channel B-High Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BH_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BH_DUTY0_t;

/*@}*/

/** @defgroup BH_DUTY1 Channel B-High Full Duty1 Register (BH_DUTY1) Register
 *  Channel B-High Full Duty1 Register (BH_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The BH_DUTY1 register contains the DUTY bit field from the BH1 register and the ENHDIV bit field from the BH1_HP register.
 *  
 *  Note that the BH_DUTY1 register reads the BH1 and the BH1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BH_DUTY1_Struct
 *! \brief  Channel B-High Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BH_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BH_DUTY1_t;

/*@}*/

/** @defgroup BL_DUTY0 Channel B-Low Full Duty0 Register (BL_DUTY0) Register
 *  Channel B-Low Full Duty0 Register (BL_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The BL_DUTY0 register contains the DUTY bit field from the BL0 register and the ENHDIV bit field from the BL0_HP register.
 *  
 *  Note that the BL_DUTY0 register reads the BL0 and the BL0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BL_DUTY0_Struct
 *! \brief  Channel B-Low Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BL_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BL_DUTY0_t;

/*@}*/

/** @defgroup BL_DUTY1 Channel B-Low Full Duty1 Register (BL_DUTY1) Register
 *  Channel B-Low Full Duty1 Register (BL_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The BL_DUTY1 register contains the DUTY bit field from the BL1 register and the ENHDIV bit field from the BL1_HP register.
 *  
 *  Note that the BL_DUTY1 register reads the BL1 and the BL1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_BL_DUTY1_Struct
 *! \brief  Channel B-Low Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_BL_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_BL_DUTY1_t;

/*@}*/

/** @defgroup CH_DUTY0 Channel C-High Full Duty0 Register (CH_DUTY0) Register
 *  Channel C-High Full Duty0 Register (CH_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The CH_DUTY0 register contains the DUTY bit field from the CH0 register and the ENHDIV bit field from the CH0_HP register.
 *  
 *  Note that the CH_DUTY0 register reads the CH0 and the CH0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CH_DUTY0_Struct
 *! \brief  Channel C-High Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CH_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CH_DUTY0_t;

/*@}*/

/** @defgroup CH_DUTY1 Channel C-High Full Duty1 Register (CH_DUTY1) Register
 *  Channel C-High Full Duty1 Register (CH_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The CH_DUTY1 register contains the DUTY bit field from the CH1 register and the ENHDIV bit field from the CH1_HP register.
 *  
 *  Note that the CH_DUTY1 register reads the CH1 and the CH1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CH_DUTY1_Struct
 *! \brief  Channel C-High Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CH_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CH_DUTY1_t;

/*@}*/

/** @defgroup CL_DUTY0 Channel C-Low Full Duty0 Register (CL_DUTY0) Register
 *  Channel C-Low Full Duty0 Register (CL_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The CL_DUTY0 register contains the DUTY bit field from the CL0 register and the ENHDIV bit field from the CL0_HP register.
 *  
 *  Note that the CL_DUTY0 register reads the CL0 and the CL0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CL_DUTY0_Struct
 *! \brief  Channel C-Low Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CL_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CL_DUTY0_t;

/*@}*/

/** @defgroup CL_DUTY1 Channel C-Low Full Duty1 Register (CL_DUTY1) Register
 *  Channel C-Low Full Duty1 Register (CL_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The CL_DUTY1 register contains the DUTY bit field from the CL1 register and the ENHDIV bit field from the CL1_HP register.
 *  
 *  Note that the CL_DUTY1 register reads the CL1 and the CL1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CL_DUTY1_Struct
 *! \brief  Channel C-Low Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CL_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CL_DUTY1_t;

/*@}*/

/** @defgroup DH_DUTY0 Channel D-High Full Duty0 Register (DH_DUTY0) Register
 *  Channel D-High Full Duty0 Register (DH_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The DH_DUTY0 register contains the DUTY bit field from the DH0 register and the ENHDIV bit field from the DH0_HP register.
 *  
 *  Note that the DH_DUTY0 register reads the DH0 and the DH0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DH_DUTY0_Struct
 *! \brief  Channel D-High Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DH_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DH_DUTY0_t;

/*@}*/

/** @defgroup DH_DUTY1 Channel D-High Full Duty1 Register (DH_DUTY1) Register
 *  Channel D-High Full Duty1 Register (DH_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The DH_DUTY1 register contains the DUTY bit field from the DH1 register and the ENHDIV bit field from the DH1_HP register.
 *  
 *  Note that the DH_DUTY1 register reads the DH1 and the DH1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DH_DUTY1_Struct
 *! \brief  Channel D-High Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DH_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DH_DUTY1_t;

/*@}*/

/** @defgroup DL_DUTY0 Channel D-Low Full Duty0 Register (DL_DUTY0) Register
 *  Channel D-Low Full Duty0 Register (DL_DUTY0) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The DL_DUTY0 register contains the DUTY bit field from the DL0 register and the ENHDIV bit field from the DL0_HP register.
 *  
 *  Note that the DL_DUTY0 register reads the DL0 and the DL0_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DL_DUTY0_Struct
 *! \brief  Channel D-Low Full Duty0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DL_DUTY0_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DL_DUTY0_t;

/*@}*/

/** @defgroup DL_DUTY1 Channel D-Low Full Duty1 Register (DL_DUTY1) Register
 *  Channel D-Low Full Duty1 Register (DL_DUTY1) Register.
 *
 *  The full duty registers can be used instead of the combined duty and heightened-precision duty registers.The DL_DUTY1 register contains the DUTY bit field from the DL1 register and the ENHDIV bit field from the DL1_HP register.
 *  
 *  Note that the DL_DUTY1 register reads the DL1 and the DL1_HP register values and visa-versa.
 *  
 *  When heightened-precision edge placement is enabled, bits [15:8] of these registers form the decimal part of a non-integer, fixed-point duty cycle value in Q15.8 format. The lowest bits are ignored.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_DL_DUTY1_Struct
 *! \brief  Channel D-Low Full Duty1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_DL_DUTY1_t {
  union {
    struct {
      unsigned int reserved0  : 14;
      unsigned int ENHDIV     :  2;  /**< Enhanced Precision Divider Bits */
      unsigned int DUTY       : 16;  /**< Coarse Duty Value */
    };
    uint32_t VALUE32;
  };
} ADI_PWM_DL_DUTY1_t;

/*@}*/

/** @defgroup CHA_DT Channel A Dead-time register (CHA_DT) Register
 *  Channel A Dead-time register (CHA_DT) Register.
 *
 *  Controls the value of dead-time for channel A independently
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CHA_DT_Struct
 *! \brief  Channel A Dead-time Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CHA_DT_t {
  union {
    struct {
      unsigned int VALUE      : 10;  /**< Dead-time value */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CHA_DT_t;

/*@}*/

/** @defgroup CHB_DT Channel B Dead-time register (CHB_DT) Register
 *  Channel B Dead-time register (CHB_DT) Register.
 *
 *  Controls the Dead-time value of channel B independently
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CHB_DT_Struct
 *! \brief  Channel B Dead-time Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CHB_DT_t {
  union {
    struct {
      unsigned int VALUE      : 10;  /**< Dead-time value */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CHB_DT_t;

/*@}*/

/** @defgroup CHC_DT Channel C Dead-time register (CHC_DT) Register
 *  Channel C Dead-time register (CHC_DT) Register.
 *
 *  Controls the dead-time value of Channel C independently
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CHC_DT_Struct
 *! \brief  Channel C Dead-time Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CHC_DT_t {
  union {
    struct {
      unsigned int VALUE      : 10;  /**< Dead-time value */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CHC_DT_t;

/*@}*/

/** @defgroup CHD_DT Channel D Dead-time register (CHD_DT) Register
 *  Channel D Dead-time register (CHD_DT) Register.
 *
 *  Controls the dead-time value of Channel D independently
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_CHD_DT_Struct
 *! \brief  Channel D Dead-time Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_CHD_DT_t {
  union {
    struct {
      unsigned int VALUE      : 10;  /**< Dead-time value */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_CHD_DT_t;

/*@}*/

/** @defgroup SWTRIP Software Trip Register (SWTRIP) Register
 *  Software Trip Register (SWTRIP) Register.
 *
 *  The SWTRIP register has individual, independent control for software trip of all PWM Channels. Unlike the Global SWTRIP bit, each channel (High and Low) has its own SWTRIP bit.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_SWTRIP_Struct
 *! \brief  Software Trip Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_SWTRIP_t {
  union {
    struct {
      unsigned int SWTRIPAL   :  1;  /**< Software Trip Bit for Channel A Low Side */
      unsigned int SWTRIPBL   :  1;  /**< Software Trip Bit for Channel B Low Side */
      unsigned int SWTRIPCL   :  1;  /**< Software Trip Bit for Channel C Low Side */
      unsigned int SWTRIPDL   :  1;  /**< Software Trip Bit for Channel D Low Side */
      unsigned int reserved4  : 12;
      unsigned int SWTRIPAH   :  1;  /**< Software Trip Bit for Channel A High Side */
      unsigned int SWTRIPBH   :  1;  /**< Software Trip Bit for Channel B High Side */
      unsigned int SWTRIPCH   :  1;  /**< Software Trip Bit for Channel C High Side */
      unsigned int SWTRIPDH   :  1;  /**< Software Trip Bit for Channel D High Side */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_SWTRIP_t;

/*@}*/

/** @defgroup TRIP_POL Trip Polarity Register (TRIP_POL) Register
 *  Trip Polarity Register (TRIP_POL) Register.
 *
 *  The TRIP_POL register controls the Channel Polarity upon tripping for each PWM Channel independently.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PWM_TRIP_POL_Struct
 *! \brief  Trip Polarity Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PWM_TRIP_POL_t {
  union {
    struct {
      unsigned int TPOLAL     :  2;  /**< Channel A Low Side Trip Polarity */
      unsigned int TPOLBL     :  2;  /**< Channel B Low Side Trip Polarity */
      unsigned int TPOLCL     :  2;  /**< Channel C Low Side Trip Polarity */
      unsigned int TPOLDL     :  2;  /**< Channel D Low Side Trip Polarity */
      unsigned int reserved8  :  8;
      unsigned int TPOLAH     :  2;  /**< Channel A High Side Trip Polarity */
      unsigned int TPOLBH     :  2;  /**< Channel B High Side Trip Polarity */
      unsigned int TPOLCH     :  2;  /**< Channel C High Side Trip Polarity */
      unsigned int TPOLDH     :  2;  /**< Channel D High Side Trip Polarity */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_PWM_TRIP_POL_t;

/*@}*/

/** @defgroup CTL TTU Control Register (CTL) Register
 *  TTU Control Register (CTL) Register.
 *
 *  Global controls for the Trigger Timing unit.
 *  
 *  This register contains individual enable and mode bits for each TTU counter.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_CTL_Struct
 *! \brief  TTU Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_CTL_t {
  union {
    struct {
      unsigned int CNTREN0    :  1;  /**< Enable Counter n. */
      unsigned int CNTREN1    :  1;  /**< Enable Counter n. */
      unsigned int CNTREN2    :  1;  /**< Enable Counter n. */
      unsigned int CNTREN3    :  1;  /**< Enable Counter n. */
      unsigned int reserved4  : 12;
      unsigned int EMURUN0    :  1;  /**< Debug Emulation Run Mode */
      unsigned int EMURUN1    :  1;  /**< Debug Emulation Run Mode */
      unsigned int EMURUN2    :  1;  /**< Debug Emulation Run Mode */
      unsigned int EMURUN3    :  1;  /**< Debug Emulation Run Mode */
      unsigned int reserved20 : 11;
      unsigned int LOCK       :  1;  /**< Configuration Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_TTU_CTL_t;

/*@}*/

/** @defgroup REVID Revision ID Register (REVID) Register
 *  Revision ID Register (REVID) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_REVID_Struct
 *! \brief  Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Minor Revision Level */
      unsigned int MAJOR      :  4;  /**< Major revision level */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_REVID_t;

/*@}*/

/** @defgroup STOP Counter Stop Request Register (STOP) Register
 *  Counter Stop Request Register (STOP) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_STOP_Struct
 *! \brief  Counter Stop Request Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_STOP_t {
  union {
    struct {
      unsigned int STOPREQ0   :  1;  /**< Stop Counter request */
      unsigned int STOPREQ1   :  1;  /**< Stop Counter request */
      unsigned int STOPREQ2   :  1;  /**< Stop Counter request */
      unsigned int STOPREQ3   :  1;  /**< Stop Counter request */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_STOP_t;

/*@}*/

/** @defgroup STAT Counter Status register (STAT) Register
 *  Counter Status register (STAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_STAT_Struct
 *! \brief  Counter Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_STAT_t {
  union {
    struct {
      unsigned int RUN0       :  1;  /**< Counter Running status. */
      unsigned int RUN1       :  1;  /**< Counter Running status. */
      unsigned int RUN2       :  1;  /**< Counter Running status. */
      unsigned int RUN3       :  1;  /**< Counter Running status. */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_STAT_t;

/*@}*/

/** @defgroup TST Counter Testmode Register (TST) Register
 *  Counter Testmode Register (TST) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_TST_Struct
 *! \brief  Counter Testmode Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_TST_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Counter Test */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_TST_t;

/*@}*/

/** @defgroup CNT Counter Current Value (CNT) Register
 *  Counter Current Value (CNT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_CNT_Struct
 *! \brief  Counter Current Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_CNT_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Trigger Counter Value */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_CNT_t;

/*@}*/

/** @defgroup PER Counter Period Register (PER) Register
 *  Counter Period Register (PER) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_PER_Struct
 *! \brief  Counter Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_PER_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Counter Period */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_PER_t;

/*@}*/

/** @defgroup DLY Trigger Output Delay Register (DLY) Register
 *  Trigger Output Delay Register (DLY) Register.
 *
 *  The DELAY register specifies the output delay of output trigger m relative to the counter's input trigger.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_DLY_Struct
 *! \brief  Trigger Output Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_DLY_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Trigger output delay */
      unsigned int DSEXT      :  7;  /**< Trigger output sign extension */
      unsigned int DSIGN      :  1;  /**< Trigger output delay sign */
    };
    uint32_t VALUE32;
  };
} ADI_TTU_DLY_t;

/*@}*/

/** @defgroup DGRP Trigger Output Counter Assignment (DGRP) Register
 *  Trigger Output Counter Assignment (DGRP) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TTU_DGRP_Struct
 *! \brief  Trigger Output Counter Assignment Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TTU_DGRP_t {
  union {
    struct {
      unsigned int VALUE      :  2;  /**< Trigger Output Counter Assignment */
      unsigned int reserved2  :  2;
      unsigned int TRIGEN     :  1;  /**< Enable trigger output */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_TTU_DGRP_t;

/*@}*/

/** @defgroup B0CTL Bank 0 Control Register (B0CTL) Register
 *  Bank 0 Control Register (B0CTL) Register.
 *
 *  The B0CTL register enables bank 0 accesses and configures the memory access features for this bank.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B0CTL_Struct
 *! \brief  Bank 0 Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B0CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Bank 0 Enable */
      unsigned int reserved1  :  3;
      unsigned int MODE       :  2;  /**< Memory Access Mode */
      unsigned int reserved6  :  2;
      unsigned int SELCTRL    :  2;  /**< Select Control */
      unsigned int reserved10 :  2;
      unsigned int RDYEN      :  1;  /**< ARDY Enable */
      unsigned int RDYPOL     :  1;  /**< ARDY Polarity */
      unsigned int RDYABTEN   :  1;  /**< ARDY Abort Enable */
      unsigned int reserved15 :  5;
      unsigned int PGSZ       :  2;  /**< Flash Page Size */
      unsigned int reserved22 : 10;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B0CTL_t;

/*@}*/

/** @defgroup B0TIM Bank 0 Timing Register (B0TIM) Register
 *  Bank 0 Timing Register (B0TIM) Register.
 *
 *  The B0TIM register configures bank 0 read and write access, setup, and hold timing for this bank. Note that read and write timing configurations are independent and may differ.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B0TIM_Struct
 *! \brief  Bank 0 Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B0TIM_t {
  union {
    struct {
      unsigned int WST        :  3;  /**< Write Setup Time */
      unsigned int reserved3  :  1;
      unsigned int WHT        :  3;  /**< Write Hold Time */
      unsigned int reserved7  :  1;
      unsigned int WAT        :  6;  /**< Write Access Time */
      unsigned int reserved14 :  2;
      unsigned int RST        :  3;  /**< Read Setup Time */
      unsigned int reserved19 :  1;
      unsigned int RHT        :  3;  /**< Read Hold Time */
      unsigned int reserved23 :  1;
      unsigned int RAT        :  6;  /**< Read Access Time */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B0TIM_t;

/*@}*/

/** @defgroup B0ETIM Bank 0 Extended Timing Register (B0ETIM) Register
 *  Bank 0 Extended Timing Register (B0ETIM) Register.
 *
 *  The B0ETIM register configures extensions to access times and idle times, augmenting the setup, hold, and access times configured with the B0TIM register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B0ETIM_Struct
 *! \brief  Bank 0 Extended Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B0ETIM_t {
  union {
    struct {
      unsigned int PREST      :  2;  /**< Pre Setup Time */
      unsigned int reserved2  :  2;
      unsigned int PREAT      :  2;  /**< Pre Access Time */
      unsigned int reserved6  :  2;
      unsigned int TT         :  3;  /**< Transition Time */
      unsigned int reserved11 :  1;
      unsigned int IT         :  3;  /**< Idle Time */
      unsigned int reserved15 :  1;
      unsigned int PGWS       :  4;  /**< Page Wait States */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B0ETIM_t;

/*@}*/

/** @defgroup B1CTL Bank 1 Control Register (B1CTL) Register
 *  Bank 1 Control Register (B1CTL) Register.
 *
 *  The B1CTL register enables bank 1 accesses and configures the memory access features for this bank.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B1CTL_Struct
 *! \brief  Bank 1 Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B1CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Bank 1 Enable */
      unsigned int reserved1  :  3;
      unsigned int MODE       :  2;  /**< Memory Access Mode */
      unsigned int reserved6  :  2;
      unsigned int SELCTRL    :  2;  /**< Select Control */
      unsigned int reserved10 :  2;
      unsigned int RDYEN      :  1;  /**< ARDY Enable */
      unsigned int RDYPOL     :  1;  /**< ARDY Polarity */
      unsigned int RDYABTEN   :  1;  /**< ARDY Abort Enable */
      unsigned int reserved15 :  5;
      unsigned int PGSZ       :  2;  /**< Flash Page Size */
      unsigned int reserved22 : 10;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B1CTL_t;

/*@}*/

/** @defgroup B1TIM Bank 1 Timing Register (B1TIM) Register
 *  Bank 1 Timing Register (B1TIM) Register.
 *
 *  The B1TIM register configures bank 1 read and write access, setup, and hold timing for this bank. Note that read and write timing configurations are independent and may differ.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B1TIM_Struct
 *! \brief  Bank 1 Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B1TIM_t {
  union {
    struct {
      unsigned int WST        :  3;  /**< Write Setup Time */
      unsigned int reserved3  :  1;
      unsigned int WHT        :  3;  /**< Write Hold Time */
      unsigned int reserved7  :  1;
      unsigned int WAT        :  6;  /**< Write Access Time */
      unsigned int reserved14 :  2;
      unsigned int RST        :  3;  /**< Read Setup Time */
      unsigned int reserved19 :  1;
      unsigned int RHT        :  3;  /**< Read Hold Time */
      unsigned int reserved23 :  1;
      unsigned int RAT        :  6;  /**< Read Access Time */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B1TIM_t;

/*@}*/

/** @defgroup B1ETIM Bank 1 Extended Timing Register (B1ETIM) Register
 *  Bank 1 Extended Timing Register (B1ETIM) Register.
 *
 *  The B1ETIM register configures extensions to access times and idle times, augmenting the setup, hold, and access times configured with the B1TIM register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B1ETIM_Struct
 *! \brief  Bank 1 Extended Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B1ETIM_t {
  union {
    struct {
      unsigned int PREST      :  2;  /**< Pre Setup Time */
      unsigned int reserved2  :  2;
      unsigned int PREAT      :  2;  /**< Pre Access Time */
      unsigned int reserved6  :  2;
      unsigned int TT         :  3;  /**< Transition Time */
      unsigned int reserved11 :  1;
      unsigned int IT         :  3;  /**< Idle Time */
      unsigned int reserved15 :  1;
      unsigned int PGWS       :  4;  /**< Page Wait States */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B1ETIM_t;

/*@}*/

/** @defgroup B2CTL Bank 2 Control Register (B2CTL) Register
 *  Bank 2 Control Register (B2CTL) Register.
 *
 *  The B2CTL register enables bank 2 accesses and configures the memory access features for this bank.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B2CTL_Struct
 *! \brief  Bank 2 Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B2CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Bank 2 Enable */
      unsigned int reserved1  :  3;
      unsigned int MODE       :  2;  /**< Memory Access Mode */
      unsigned int reserved6  :  2;
      unsigned int SELCTRL    :  2;  /**< Select Control */
      unsigned int reserved10 :  2;
      unsigned int RDYEN      :  1;  /**< ARDY Enable */
      unsigned int RDYPOL     :  1;  /**< ARDY Polarity */
      unsigned int RDYABTEN   :  1;  /**< ARDY Abort Enable */
      unsigned int reserved15 :  5;
      unsigned int PGSZ       :  2;  /**< Flash Page Size */
      unsigned int reserved22 : 10;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B2CTL_t;

/*@}*/

/** @defgroup B2TIM Bank 2 Timing Register (B2TIM) Register
 *  Bank 2 Timing Register (B2TIM) Register.
 *
 *  The B2TIM register configures bank 2 read and write access, setup, and hold timing for this bank. Note that read and write timing configurations are independent and may differ.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B2TIM_Struct
 *! \brief  Bank 2 Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B2TIM_t {
  union {
    struct {
      unsigned int WST        :  3;  /**< Write Setup Time */
      unsigned int reserved3  :  1;
      unsigned int WHT        :  3;  /**< Write Hold Time */
      unsigned int reserved7  :  1;
      unsigned int WAT        :  6;  /**< Write Access Time */
      unsigned int reserved14 :  2;
      unsigned int RST        :  3;  /**< Read Setup Time */
      unsigned int reserved19 :  1;
      unsigned int RHT        :  3;  /**< Read Hold Time */
      unsigned int reserved23 :  1;
      unsigned int RAT        :  6;  /**< Read Access Time */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B2TIM_t;

/*@}*/

/** @defgroup B2ETIM Bank 2 Extended Timing Register (B2ETIM) Register
 *  Bank 2 Extended Timing Register (B2ETIM) Register.
 *
 *  The B2ETIM register configures extensions to access times and idle times, augmenting the setup, hold, and access times configured with the B2TIM register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B2ETIM_Struct
 *! \brief  Bank 2 Extended Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B2ETIM_t {
  union {
    struct {
      unsigned int PREST      :  2;  /**< Pre Setup Time */
      unsigned int reserved2  :  2;
      unsigned int PREAT      :  2;  /**< Pre Access Time */
      unsigned int reserved6  :  2;
      unsigned int TT         :  3;  /**< Transition Time */
      unsigned int reserved11 :  1;
      unsigned int IT         :  3;  /**< Idle Time */
      unsigned int reserved15 :  1;
      unsigned int PGWS       :  4;  /**< Page Wait States */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B2ETIM_t;

/*@}*/

/** @defgroup B3CTL Bank 3 Control Register (B3CTL) Register
 *  Bank 3 Control Register (B3CTL) Register.
 *
 *  The B3CTL register enables bank 3 accesses and configures the memory access features for this bank.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B3CTL_Struct
 *! \brief  Bank 3 Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B3CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Bank 3 Enable */
      unsigned int reserved1  :  3;
      unsigned int MODE       :  2;  /**< Memory Access Mode */
      unsigned int reserved6  :  2;
      unsigned int SELCTRL    :  2;  /**< Select Control */
      unsigned int reserved10 :  2;
      unsigned int RDYEN      :  1;  /**< ARDY Enable */
      unsigned int RDYPOL     :  1;  /**< ARDY Polarity */
      unsigned int RDYABTEN   :  1;  /**< ARDY Abort Enable */
      unsigned int reserved15 :  5;
      unsigned int PGSZ       :  2;  /**< Flash Page Size */
      unsigned int reserved22 : 10;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B3CTL_t;

/*@}*/

/** @defgroup B3TIM Bank 3 Timing Register (B3TIM) Register
 *  Bank 3 Timing Register (B3TIM) Register.
 *
 *  The B3TIM register configures bank 3 read and write access, setup, and hold timing for this bank. Note that read and write timing configurations are independent and may differ.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B3TIM_Struct
 *! \brief  Bank 3 Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B3TIM_t {
  union {
    struct {
      unsigned int WST        :  3;  /**< Write Setup Time */
      unsigned int reserved3  :  1;
      unsigned int WHT        :  3;  /**< Write Hold Time */
      unsigned int reserved7  :  1;
      unsigned int WAT        :  6;  /**< Write Access Time */
      unsigned int reserved14 :  2;
      unsigned int RST        :  3;  /**< Read Setup Time */
      unsigned int reserved19 :  1;
      unsigned int RHT        :  3;  /**< Read Hold Time */
      unsigned int reserved23 :  1;
      unsigned int RAT        :  6;  /**< Read Access Time */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B3TIM_t;

/*@}*/

/** @defgroup B3ETIM Bank 3 Extended Timing Register (B3ETIM) Register
 *  Bank 3 Extended Timing Register (B3ETIM) Register.
 *
 *  The B3ETIM register configures extensions to access times and idle times, augmenting the setup, hold, and access times configured with the B3TIM register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMC_B3ETIM_Struct
 *! \brief  Bank 3 Extended Timing Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMC_B3ETIM_t {
  union {
    struct {
      unsigned int PREST      :  2;  /**< Pre Setup Time */
      unsigned int reserved2  :  2;
      unsigned int PREAT      :  2;  /**< Pre Access Time */
      unsigned int reserved6  :  2;
      unsigned int TT         :  3;  /**< Transition Time */
      unsigned int reserved11 :  1;
      unsigned int IT         :  3;  /**< Idle Time */
      unsigned int reserved15 :  1;
      unsigned int PGWS       :  4;  /**< Page Wait States */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SMC_B3ETIM_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register enables the SPI and configures settings for operating modes, communication protocols, and buffer operations.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_CTL_EN
 *! \brief  Enable (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_DIS = 0,  /**< Disable SPI module */
  SPI_CTL_EN  = 1   /**< Enable             */
} ADI_SPI_CTL_EN;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_MSTR
 *! \brief  Master/Slave (MSTR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_SLAVE  = 0,  /**< Slave  */
  SPI_CTL_MASTER = 1   /**< Master */
} ADI_SPI_CTL_MSTR;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_PSSE
 *! \brief  Protected Slave Select Enable (PSSE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_PSSE_DIS = 0,  /**< Disable */
  SPI_CTL_PSSE_EN  = 1   /**< Enable  */
} ADI_SPI_CTL_PSSE;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_ODM
 *! \brief  Open Drain Mode (ODM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_ODM_DIS = 0,  /**< Disable */
  SPI_CTL_ODM_EN  = 1   /**< Enable  */
} ADI_SPI_CTL_ODM;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_CPHA
 *! \brief  Clock Phase (CPHA) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_SCKMID = 0,  /**< SPI CLK toggles from middle */
  SPI_CTL_SCKBEG = 1   /**< SPI CLK toggles from start  */
} ADI_SPI_CTL_CPHA;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_CPOL
 *! \brief  Clock Polarity (CPOL) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_SCKHI = 0,  /**< Active-high SPI CLK */
  SPI_CTL_SCKLO = 1   /**< Active-low SPI CLK  */
} ADI_SPI_CTL_CPOL;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_ASSEL
 *! \brief  Slave Select Pin Control (ASSEL) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_SW_SSEL = 0,  /**< Software Slave Select Control */
  SPI_CTL_HW_SSEL = 1   /**< Hardware Slave Select Control */
} ADI_SPI_CTL_ASSEL;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_SELST
 *! \brief  Slave Select Polarity Between Transfers (SELST) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_DEASSRT_SSEL = 0,  /**< De-assert slave select (high) */
  SPI_CTL_ASSRT_SSEL   = 1   /**< Assert slave select (low)     */
} ADI_SPI_CTL_SELST;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_EMISO
 *! \brief  Enable MISO (EMISO) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_MISO_DIS = 0,  /**< Disable */
  SPI_CTL_MISO_EN  = 1   /**< Enable  */
} ADI_SPI_CTL_EMISO;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_SIZE
 *! \brief  Word Transfer Size (SIZE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_SIZE08 = 0,  /**< 8-bit word  */
  SPI_CTL_SIZE16 = 1,  /**< 16-bit word */
  SPI_CTL_SIZE32 = 2   /**< 32-bit word */
} ADI_SPI_CTL_SIZE;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_LSBF
 *! \brief  Least Significant Bit First (LSBF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_MSB_FIRST = 0,  /**< MSB sent/received first (big endian)    */
  SPI_CTL_LSB_FIRST = 1   /**< LSB sent/received first (little endian) */
} ADI_SPI_CTL_LSBF;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_FCEN
 *! \brief  Flow Control Enable (FCEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_FLOW_DIS = 0,  /**< Disable */
  SPI_CTL_FLOW_EN  = 1   /**< Enable  */
} ADI_SPI_CTL_FCEN;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_FCCH
 *! \brief  Flow Control Channel Selection (FCCH) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_FLOW_RX = 0,  /**< Flow control on RX buffer */
  SPI_CTL_FLOW_TX = 1   /**< Flow control on TX buffer */
} ADI_SPI_CTL_FCCH;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_FCPL
 *! \brief  Flow Control Polarity (FCPL) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_FLOW_LO = 0,  /**< Active-low RDY  */
  SPI_CTL_FLOW_HI = 1   /**< Active-high RDY */
} ADI_SPI_CTL_FCPL;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_FCWM
 *! \brief  Flow Control Watermark (FCWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_FIFO0 = 0,  /**< TFIFO empty or RFIFO full                          */
  SPI_CTL_FIFO1 = 1,  /**< TFIFO 75% or more empty, or RFIFO 75% or more full */
  SPI_CTL_FIFO2 = 2   /**< TFIFO 50% or more empty, or RFIFO 50% or more full */
} ADI_SPI_CTL_FCWM;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_FMODE
 *! \brief  Fast-Mode Enable (FMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_FAST_DIS = 0,  /**< Disable */
  SPI_CTL_FAST_EN  = 1   /**< Enable  */
} ADI_SPI_CTL_FMODE;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_MIOM
 *! \brief  Multiple I/O Mode (MIOM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_MIO_DIS  = 0,  /**< No MIOM (disabled) */
  SPI_CTL_MIO_DUAL = 1,  /**< DIOM operation     */
  SPI_CTL_MIO_QUAD = 2   /**< QIOM operation     */
} ADI_SPI_CTL_MIOM;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_SOSI
 *! \brief  Start on MOSI (SOSI) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_STMISO = 0,  /**< Start on MISO (DIOM) or start on SPIQ3 (QSPI) */
  SPI_CTL_STMOSI = 1   /**< Start on MOSI                                 */
} ADI_SPI_CTL_SOSI;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_MMWEM
 *! \brief  Memory Mapped Write Error Mask (MMWEM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_WEM_UNMSK = 0,  /**< Write error response returned upon write attempts to memory-mapped SPI memory              */
  SPI_CTL_WEM_MSK   = 1   /**< Write error response masked (not returned) upon write attempts to memory-mapped SPI memory */
} ADI_SPI_CTL_MMWEM;


/*  =========================================================================
 *! \enum   ADI_SPI_CTL_MMSE
 *! \brief  Memory-Mapped SPI Enable (MMSE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_CTL_MM_DIS = 0,  /**< Hardware automated access of memory-mapped SPI memory disabled. */
  SPI_CTL_MM_EN  = 1   /**< Hardware-automated access of memory-mapped SPI memory enabled.  */
} ADI_SPI_CTL_MMSE;


/* ==========================================================================
 *! \struct ADI_SPI_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int MSTR       :  1;  /**< Master/Slave */
      unsigned int PSSE       :  1;  /**< Protected Slave Select Enable */
      unsigned int ODM        :  1;  /**< Open Drain Mode */
      unsigned int CPHA       :  1;  /**< Clock Phase */
      unsigned int CPOL       :  1;  /**< Clock Polarity */
      unsigned int ASSEL      :  1;  /**< Slave Select Pin Control */
      unsigned int SELST      :  1;  /**< Slave Select Polarity Between Transfers */
      unsigned int EMISO      :  1;  /**< Enable MISO */
      unsigned int SIZE       :  2;  /**< Word Transfer Size */
      unsigned int reserved11 :  1;
      unsigned int LSBF       :  1;  /**< Least Significant Bit First */
      unsigned int FCEN       :  1;  /**< Flow Control Enable */
      unsigned int FCCH       :  1;  /**< Flow Control Channel Selection */
      unsigned int FCPL       :  1;  /**< Flow Control Polarity */
      unsigned int FCWM       :  2;  /**< Flow Control Watermark */
      unsigned int FMODE      :  1;  /**< Fast-Mode Enable */
      unsigned int reserved19 :  1;
      unsigned int MIOM       :  2;  /**< Multiple I/O Mode */
      unsigned int SOSI       :  1;  /**< Start on MOSI */
      unsigned int reserved23 :  7;
      unsigned int MMWEM      :  1;  /**< Memory Mapped Write Error Mask */
      unsigned int MMSE       :  1;  /**< Memory-Mapped SPI Enable */
    };
    uint32_t VALUE32;
  };
} ADI_SPI_CTL_t;

/*@}*/

/** @defgroup RXCTL Receive Control Register (RXCTL) Register
 *  Receive Control Register (RXCTL) Register.
 *
 *  The RXCTL register enables the SPI receive channel, initiates receive transfers, and configures RFIFO buffer watermark settings.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_REN
 *! \brief  Receive Enable (REN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_RX_DIS = 0,  /**< Disable */
  SPI_RXCTL_RX_EN  = 1   /**< Enable  */
} ADI_SPI_RXCTL_REN;


/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_RTI
 *! \brief  Receive Transfer Initiate (RTI) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_RTI_DIS = 0,  /**< Disable */
  SPI_RXCTL_RTI_EN  = 1   /**< Enable  */
} ADI_SPI_RXCTL_RTI;


/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_RWCEN
 *! \brief  Receive Word Counter Enable (RWCEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_RWC_DIS = 0,  /**< Disable */
  SPI_RXCTL_RWC_EN  = 1   /**< Enable  */
} ADI_SPI_RXCTL_RWCEN;


/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_RDR
 *! \brief  Receive Data Request (RDR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_RDR_DIS  = 0,  /**< Disabled        */
  SPI_RXCTL_RDR_NE   = 1,  /**< Not empty RFIFO */
  SPI_RXCTL_RDR_25   = 2,  /**< 25% full RFIFO  */
  SPI_RXCTL_RDR_50   = 3,  /**< 50% full RFIFO  */
  SPI_RXCTL_RDR_75   = 4,  /**< 75% full RFIFO  */
  SPI_RXCTL_RDR_FULL = 5   /**< Full RFIFO      */
} ADI_SPI_RXCTL_RDR;


/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_RDO
 *! \brief  Receive Data Overrun (RDO) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_DISCARD   = 0,  /**< Discard incoming data if SPI_RFIFO is full */
  SPI_RXCTL_OVERWRITE = 1   /**< Overwrite old data if SPI_RFIFO is full    */
} ADI_SPI_RXCTL_RDO;


/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_RRWM
 *! \brief  Receive FIFO Regular Watermark (RRWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_RWM_0  = 0,  /**< Empty RFIFO              */
  SPI_RXCTL_RWM_25 = 1,  /**< RFIFO less than 25% full */
  SPI_RXCTL_RWM_50 = 2,  /**< RFIFO less than 50% full */
  SPI_RXCTL_RWM_75 = 3   /**< RFIFO less than 75% full */
} ADI_SPI_RXCTL_RRWM;


/*  =========================================================================
 *! \enum   ADI_SPI_RXCTL_RUWM
 *! \brief  Receive FIFO Urgent Watermark (RUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_RXCTL_UWM_DIS  = 0,  /**< Disabled       */
  SPI_RXCTL_UWM_25   = 1,  /**< 25% full RFIFO */
  SPI_RXCTL_UWM_50   = 2,  /**< 50% full RFIFO */
  SPI_RXCTL_UWM_75   = 3,  /**< 75% full RFIFO */
  SPI_RXCTL_UWM_FULL = 4   /**< Full RFIFO     */
} ADI_SPI_RXCTL_RUWM;


/* ==========================================================================
 *! \struct ADI_SPI_RXCTL_Struct
 *! \brief  Receive Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_RXCTL_t {
  union {
    struct {
      unsigned int REN        :  1;  /**< Receive Enable */
      unsigned int reserved1  :  1;
      unsigned int RTI        :  1;  /**< Receive Transfer Initiate */
      unsigned int RWCEN      :  1;  /**< Receive Word Counter Enable */
      unsigned int RDR        :  3;  /**< Receive Data Request */
      unsigned int reserved7  :  1;
      unsigned int RDO        :  1;  /**< Receive Data Overrun */
      unsigned int reserved9  :  3;
      unsigned int RRWM       :  2;  /**< Receive FIFO Regular Watermark */
      unsigned int reserved14 :  2;
      unsigned int RUWM       :  3;  /**< Receive FIFO Urgent Watermark */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_RXCTL_t;

/*@}*/

/** @defgroup TXCTL Transmit Control Register (TXCTL) Register
 *  Transmit Control Register (TXCTL) Register.
 *
 *  The TXCTL register enables the SPI transmit channel, initiates transmit transfers, and configures TFIFO buffer watermark settings.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TEN
 *! \brief  Transmit Enable (TEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_TX_DIS = 0,  /**< Disable */
  SPI_TXCTL_TX_EN  = 1   /**< Enable  */
} ADI_SPI_TXCTL_TEN;


/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TTI
 *! \brief  Transmit Transfer Initiate (TTI) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_TTI_DIS = 0,  /**< Disable */
  SPI_TXCTL_TTI_EN  = 1   /**< Enable  */
} ADI_SPI_TXCTL_TTI;


/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TWCEN
 *! \brief  Transmit Word Counter Enable (TWCEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_TWC_DIS = 0,  /**< Disable */
  SPI_TXCTL_TWC_EN  = 1   /**< Enable  */
} ADI_SPI_TXCTL_TWCEN;


/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TDR
 *! \brief  Transmit Data Request (TDR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_TDR_DIS   = 0,  /**< Disabled        */
  SPI_TXCTL_TDR_NF    = 1,  /**< Not full TFIFO  */
  SPI_TXCTL_TDR_25    = 2,  /**< 25% empty TFIFO */
  SPI_TXCTL_TDR_50    = 3,  /**< 50% empty TFIFO */
  SPI_TXCTL_TDR_75    = 4,  /**< 75% empty TFIFO */
  SPI_TXCTL_TDR_EMPTY = 5   /**< Empty TFIFO     */
} ADI_SPI_TXCTL_TDR;


/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TDU
 *! \brief  Transmit Data Under-run (TDU) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_LASTWD = 0,  /**< Send last word when SPI_TFIFO is empty */
  SPI_TXCTL_ZERO   = 1   /**< Send zeros when SPI_TFIFO is empty     */
} ADI_SPI_TXCTL_TDU;


/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TRWM
 *! \brief  FIFO Regular Watermark (TRWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_RWM_FULL = 0,  /**< Full TFIFO                */
  SPI_TXCTL_RWM_25   = 1,  /**< TFIFO less than 25% empty */
  SPI_TXCTL_RWM_50   = 2,  /**< TFIFO less than 50% empty */
  SPI_TXCTL_RWM_75   = 3   /**< TFIFO less than 75% empty */
} ADI_SPI_TXCTL_TRWM;


/*  =========================================================================
 *! \enum   ADI_SPI_TXCTL_TUWM
 *! \brief  FIFO Urgent Watermark (TUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_TXCTL_UWM_DIS   = 0,  /**< Disabled        */
  SPI_TXCTL_UWM_25    = 1,  /**< 25% empty TFIFO */
  SPI_TXCTL_UWM_50    = 2,  /**< 50% empty TFIFO */
  SPI_TXCTL_UWM_75    = 3,  /**< 75% empty TFIFO */
  SPI_TXCTL_UWM_EMPTY = 4   /**< Empty TFIFO     */
} ADI_SPI_TXCTL_TUWM;


/* ==========================================================================
 *! \struct ADI_SPI_TXCTL_Struct
 *! \brief  Transmit Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_TXCTL_t {
  union {
    struct {
      unsigned int TEN        :  1;  /**< Transmit Enable */
      unsigned int reserved1  :  1;
      unsigned int TTI        :  1;  /**< Transmit Transfer Initiate */
      unsigned int TWCEN      :  1;  /**< Transmit Word Counter Enable */
      unsigned int TDR        :  3;  /**< Transmit Data Request */
      unsigned int reserved7  :  1;
      unsigned int TDU        :  1;  /**< Transmit Data Under-run */
      unsigned int reserved9  :  3;
      unsigned int TRWM       :  2;  /**< FIFO Regular Watermark */
      unsigned int reserved14 :  2;
      unsigned int TUWM       :  3;  /**< FIFO Urgent Watermark */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_TXCTL_t;

/*@}*/

/** @defgroup CLK Clock Rate Register (CLK) Register
 *  Clock Rate Register (CLK) Register.
 *
 *  The CLK register selects the baud rate for SPI data transfers, relating this rate to the SPI serial clock (SCK) and the system clock (SCLK).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_CLK_Struct
 *! \brief  Clock Rate Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_CLK_t {
  union {
    struct {
      unsigned int BAUD       : 16;  /**< Baud Rate */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_CLK_t;

/*@}*/

/** @defgroup DLY Delay Register (DLY) Register
 *  Delay Register (DLY) Register.
 *
 *  The DLY register selects a transfer delay and the lead/lag timing between slave select signals and SPI clock edge assertion/de-assertion.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_DLY_Struct
 *! \brief  Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_DLY_t {
  union {
    struct {
      unsigned int STOP       :  8;  /**< Transfer delay time in multiples of SPI clock period */
      unsigned int LEADX      :  1;  /**< Extended SPI Clock Lead Control */
      unsigned int LAGX       :  1;  /**< Extended SPI Clock Lag Control */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_DLY_t;

/*@}*/

/** @defgroup SLVSEL Slave Select Register (SLVSEL) Register
 *  Slave Select Register (SLVSEL) Register.
 *
 *  The SLVSEL register enables the ~SELn pins for input and indicates the state (high or low) of these pins when enabled.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE1
 *! \brief  Slave Select 1 Enable (SSE1) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL1_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL1_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE1;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE2
 *! \brief  Slave Select 2 Enable (SSE2) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL2_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL2_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE2;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE3
 *! \brief  Slave Select 3 Enable (SSE3) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL3_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL3_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE3;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE4
 *! \brief  Slave Select 4 Enable (SSE4) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL4_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL4_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE4;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE5
 *! \brief  Slave Select 5 Enable (SSE5) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL5_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL5_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE5;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE6
 *! \brief  Slave Select 6 Enable (SSE6) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL6_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL6_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE6;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSE7
 *! \brief  Slave Select 7 Enable (SSE7) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL7_DIS = 0,  /**< Disable */
  SPI_SLVSEL_SSEL7_EN  = 1   /**< Enable  */
} ADI_SPI_SLVSEL_SSE7;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL1
 *! \brief  Slave Select 1 Input (SSEL1) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL1_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL1_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL1;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL2
 *! \brief  Slave Select 2 Input (SSEL2) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL2_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL2_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL2;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL3
 *! \brief  Slave Select 3 Input (SSEL3) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL3_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL3_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL3;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL4
 *! \brief  Slave Select 4 Input (SSEL4) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL4_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL4_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL4;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL5
 *! \brief  Slave Select 5 Input (SSEL5) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL5_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL5_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL5;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL6
 *! \brief  Slave Select 6 Input (SSEL6) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL6_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL6_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL6;


/*  =========================================================================
 *! \enum   ADI_SPI_SLVSEL_SSEL7
 *! \brief  Slave Select 7 Input (SSEL7) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_SLVSEL_SSEL7_LO = 0,  /**< Low  */
  SPI_SLVSEL_SSEL7_HI = 1   /**< High */
} ADI_SPI_SLVSEL_SSEL7;


/* ==========================================================================
 *! \struct ADI_SPI_SLVSEL_Struct
 *! \brief  Slave Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_SLVSEL_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int SSE1       :  1;  /**< Slave Select 1 Enable */
      unsigned int SSE2       :  1;  /**< Slave Select 2 Enable */
      unsigned int SSE3       :  1;  /**< Slave Select 3 Enable */
      unsigned int SSE4       :  1;  /**< Slave Select 4 Enable */
      unsigned int SSE5       :  1;  /**< Slave Select 5 Enable */
      unsigned int SSE6       :  1;  /**< Slave Select 6 Enable */
      unsigned int SSE7       :  1;  /**< Slave Select 7 Enable */
      unsigned int reserved8  :  1;
      unsigned int SSEL1      :  1;  /**< Slave Select 1 Input */
      unsigned int SSEL2      :  1;  /**< Slave Select 2 Input */
      unsigned int SSEL3      :  1;  /**< Slave Select 3 Input */
      unsigned int SSEL4      :  1;  /**< Slave Select 4 Input */
      unsigned int SSEL5      :  1;  /**< Slave Select 5 Input */
      unsigned int SSEL6      :  1;  /**< Slave Select 6 Input */
      unsigned int SSEL7      :  1;  /**< Slave Select 7 Input */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_SLVSEL_t;

/*@}*/

/** @defgroup RWC Received Word Count Register (RWC) Register
 *  Received Word Count Register (RWC) Register.
 *
 *  The RWC register holds a count of the number of words remaining to be received by the SPI. To start the decrement of the word count in RWC, enable the receive word counter (RXCTL:RWCEN =1). The SPI uses the word count to control the duration of transfers and to signal the completion of a burst of transfers with the receive finish interrupt (ILAT:RF). In DMA mode, the SPI uses the RWC to ensure that the number of frames received during a DMA transfer is equal to the number of words programmed in the DMA channel controller. The values programmed into the RWC registers should match the word count in the DMA configuration. The RWC maintains the number of frames to be received in a transfer. The RWC should only be changed when the counter is disabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_RWC_Struct
 *! \brief  Received Word Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_RWC_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Received Word Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_RWC_t;

/*@}*/

/** @defgroup RWCR Received Word Count Reload Register (RWCR) Register
 *  Received Word Count Reload Register (RWCR) Register.
 *
 *  The RWCR register holds the receive word count value that the SPI loads into the RWC register when the transfer count decrements to zero. To prevent the SPI from reloading the counter, use zero for the reload count value. The RWCR should only be changed when the counter is disabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_RWCR_Struct
 *! \brief  Received Word Count Reload Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_RWCR_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Received Word Count Reload */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_RWCR_t;

/*@}*/

/** @defgroup TWC Transmitted Word Count Register (TWC) Register
 *  Transmitted Word Count Register (TWC) Register.
 *
 *  The TWC register holds a count of the number of words remaining to be transmitted by the SPI. To start the decrement of the word count in TWC, enable the transmit word counter (TXCTL:TWCEN =1). The SPI uses the word count to control the duration of transfers and to signal the completion of a burst of transfers with the transmit finish interrupt. In DMA mode, the SPI uses the TWC to ensure that the number of frames transmitted during a DMA transfer is equal to the number of words programmed in the DMA channel controller. The values programmed into the TWC registers should match the word count in the DMA configuration. The TWC maintains the number of frames to be transmitted in a transfer. The TWC should only be changed when the counter is disabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_TWC_Struct
 *! \brief  Transmitted Word Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_TWC_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Transmitted Word Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_TWC_t;

/*@}*/

/** @defgroup TWCR Transmitted Word Count Reload Register (TWCR) Register
 *  Transmitted Word Count Reload Register (TWCR) Register.
 *
 *  The TWCR register holds the transmit word count value that the SPI loads into the TWC register when the transfer count decrements to zero. To prevent the SPI from reloading the counter, use zero for the reload count value. The TWCR should only be changed when the counter is disabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_TWCR_Struct
 *! \brief  Transmitted Word Count Reload Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_TWCR_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Transmitted Word Count Reload */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_TWCR_t;

/*@}*/

/** @defgroup IMSK Interrupt Mask Register (IMSK) Register
 *  Interrupt Mask Register (IMSK) Register.
 *
 *  The IMSK register unmasks (enables) or masks (disables) SPI interrupts. When a condition is indicated by a bit in the STAT register and the corresponding interrupt is unmasked in IMSK, the SPI latches the interrupt's bit in the ILAT register, queuing the interrupt for service.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_RUWM
 *! \brief  Receive Urgent Watermark Interrupt Mask (RUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_RUWM_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_RUWM_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_RUWM;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_TUWM
 *! \brief  Transmit Urgent Watermark Interrupt Mask (TUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_TUWM_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_TUWM_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_TUWM;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_ROR
 *! \brief  Receive Overrun Interrupt Mask (ROR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_ROR_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_ROR_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_ROR;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_TUR
 *! \brief  Transmit Underrun Interrupt Mask (TUR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_TUR_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_TUR_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_TUR;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_TC
 *! \brief  Transmit Collision Interrupt Mask (TC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_TC_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_TC_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_TC;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_MF
 *! \brief  Mode Fault Interrupt Mask (MF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_MF_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_MF_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_MF;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_RS
 *! \brief  Receive Start Interrupt Mask (RS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_RS_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_RS_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_RS;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_TS
 *! \brief  Transmit Start Interrupt Mask (TS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_TS_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_TS_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_TS;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_RF
 *! \brief  Receive Finish Interrupt Mask (RF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_RF_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_RF_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_RF;


/*  =========================================================================
 *! \enum   ADI_SPI_IMSK_TF
 *! \brief  Transmit Finish Interrupt Mask (TF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_IMSK_TF_LO = 0,  /**< Disable (mask) interrupt  */
  SPI_IMSK_TF_HI = 1   /**< Enable (unmask) interrupt */
} ADI_SPI_IMSK_TF;


/* ==========================================================================
 *! \struct ADI_SPI_IMSK_Struct
 *! \brief  Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_IMSK_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int RUWM       :  1;  /**< Receive Urgent Watermark Interrupt Mask */
      unsigned int TUWM       :  1;  /**< Transmit Urgent Watermark Interrupt Mask */
      unsigned int reserved3  :  1;
      unsigned int ROR        :  1;  /**< Receive Overrun Interrupt Mask */
      unsigned int TUR        :  1;  /**< Transmit Underrun Interrupt Mask */
      unsigned int TC         :  1;  /**< Transmit Collision Interrupt Mask */
      unsigned int MF         :  1;  /**< Mode Fault Interrupt Mask */
      unsigned int RS         :  1;  /**< Receive Start Interrupt Mask */
      unsigned int TS         :  1;  /**< Transmit Start Interrupt Mask */
      unsigned int RF         :  1;  /**< Receive Finish Interrupt Mask */
      unsigned int TF         :  1;  /**< Transmit Finish Interrupt Mask */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_IMSK_t;

/*@}*/

/** @defgroup IMSK_CLR Interrupt Mask Clear Register (IMSK_CLR) Register
 *  Interrupt Mask Clear Register (IMSK_CLR) Register.
 *
 *  The IMSK_CLR register permits clearing individual mask bits in the IMSK register without affecting other bits in the register. Use write-1-to-clear on a bit in IMSK_CLR to clear the corresponding bit in the IMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_IMSK_CLR_Struct
 *! \brief  Interrupt Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_IMSK_CLR_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int RUWM       :  1;  /**< Clear Receive Urgent Watermark Interrupt Mask */
      unsigned int TUWM       :  1;  /**< Clear Transmit Urgent Watermark Interrupt Mask */
      unsigned int reserved3  :  1;
      unsigned int ROR        :  1;  /**< Clear Receive Overrun Interrupt Mask */
      unsigned int TUR        :  1;  /**< Clear Transmit Under-run Interrupt Mask */
      unsigned int TC         :  1;  /**< Clear Transmit Collision Interrupt Mask */
      unsigned int MF         :  1;  /**< Clear Mode Fault Interrupt Mask */
      unsigned int RS         :  1;  /**< Clear Receive Start Interrupt Mask */
      unsigned int TS         :  1;  /**< Clear Transmit Start Interrupt Mask */
      unsigned int RF         :  1;  /**< Clear Receive Finish Interrupt Mask */
      unsigned int TF         :  1;  /**< Clear Transmit Finish Interrupt Mask */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_IMSK_CLR_t;

/*@}*/

/** @defgroup IMSK_SET Interrupt Mask Set Register (IMSK_SET) Register
 *  Interrupt Mask Set Register (IMSK_SET) Register.
 *
 *  The IMSK_SET register permits setting individual mask bits in the IMSK register without affecting other bits in the register. Use write-1-to-set on a bit in IMSK_SET to set the corresponding bit in the IMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_IMSK_SET_Struct
 *! \brief  Interrupt Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_IMSK_SET_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int RUWM       :  1;  /**< Set Receive Urgent Watermark Interrupt Mask */
      unsigned int TUWM       :  1;  /**< Set Transmit Urgent Watermark Interrupt Mask */
      unsigned int reserved3  :  1;
      unsigned int ROR        :  1;  /**< Set Receive Overrun Interrupt Mask */
      unsigned int TUR        :  1;  /**< Set Transmit Under-run  Interrupt Mask */
      unsigned int TC         :  1;  /**< Set Transmit Collision Interrupt Mask */
      unsigned int MF         :  1;  /**< Set Mode Fault Interrupt Mask */
      unsigned int RS         :  1;  /**< Set Receive Start Interrupt Mask */
      unsigned int TS         :  1;  /**< Set Transmit Start Interrupt Mask */
      unsigned int RF         :  1;  /**< Set Receive Finish Interrupt Mask */
      unsigned int TF         :  1;  /**< Set Transmit Finish Interrupt Mask */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_IMSK_SET_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates SPI status including FIFO status, error conditions, and interrupt conditions. When an interrupt condition from this register is unmasked (enabled) by the corresponding bit in the IMSK register, the interrupt is latched into the corresponding bit in the ILAT register.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_STAT_SPIF
 *! \brief  SPI Finished (SPIF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_SPIF_LO = 0,  /**< No status                      */
  SPI_STAT_SPIF_HI = 1   /**< Completed single-word transfer */
} ADI_SPI_STAT_SPIF;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_RUWM
 *! \brief  Receive Urgent Watermark Breached (RUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_RUWM_LO = 0,  /**< RX Regular Watermark reached */
  SPI_STAT_RUWM_HI = 1   /**< RX Urgent Watermark breached */
} ADI_SPI_STAT_RUWM;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TUWM
 *! \brief  Transmit Urgent Watermark Breached (TUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TUWM_LO = 0,  /**< TX Regular Watermark reached */
  SPI_STAT_TUWM_HI = 1   /**< TX Urgent Watermark breached */
} ADI_SPI_STAT_TUWM;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_ROR
 *! \brief  Receive Overrun Indication (ROR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_ROR_LO = 0,  /**< No status                */
  SPI_STAT_ROR_HI = 1   /**< Receive overrun occurred */
} ADI_SPI_STAT_ROR;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TUR
 *! \brief  Transmit Underrun Indication (TUR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TUR_LO = 0,  /**< No status                  */
  SPI_STAT_TUR_HI = 1   /**< Transmit underrun occurred */
} ADI_SPI_STAT_TUR;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TC
 *! \brief  Transmit Collision Indication (TC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TC_LO = 0,  /**< No status                   */
  SPI_STAT_TC_HI = 1   /**< Transmit collision occurred */
} ADI_SPI_STAT_TC;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_MF
 *! \brief  Mode Fault Indication (MF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_MF_LO = 0,  /**< No status           */
  SPI_STAT_MF_HI = 1   /**< Mode fault occurred */
} ADI_SPI_STAT_MF;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_RS
 *! \brief  Receive Start (RS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_RS_LO = 0,  /**< No status              */
  SPI_STAT_RS_HI = 1   /**< Receive start detected */
} ADI_SPI_STAT_RS;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TS
 *! \brief  Transmit Start (TS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TS_LO = 0,  /**< No status               */
  SPI_STAT_TS_HI = 1   /**< Transmit start detected */
} ADI_SPI_STAT_TS;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_RF
 *! \brief  Receive Finish Indication (RF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_RF_LO = 0,  /**< No status               */
  SPI_STAT_RF_HI = 1   /**< Receive finish detected */
} ADI_SPI_STAT_RF;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TF
 *! \brief  Transmit Finish Indication (TF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TF_LO = 0,  /**< No status                */
  SPI_STAT_TF_HI = 1   /**< Transmit finish detected */
} ADI_SPI_STAT_TF;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_RFS
 *! \brief  SPI_RFIFO Status (RFS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_RFIFO_EMPTY = 0,  /**< Empty RFIFO    */
  SPI_STAT_RFIFO_25    = 1,  /**< 25% full RFIFO */
  SPI_STAT_RFIFO_50    = 2,  /**< 50% full RFIFO */
  SPI_STAT_RFIFO_75    = 3,  /**< 75% full RFIFO */
  SPI_STAT_RFIFO_FULL  = 4   /**< Full RFIFO     */
} ADI_SPI_STAT_RFS;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TFS
 *! \brief  SPI_TFIFO Status (TFS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TFIFO_FULL  = 0,  /**< Full TFIFO      */
  SPI_STAT_TFIFO_25    = 1,  /**< 25% empty TFIFO */
  SPI_STAT_TFIFO_50    = 2,  /**< 50% empty TFIFO */
  SPI_STAT_TFIFO_75    = 3,  /**< 75% empty TFIFO */
  SPI_STAT_TFIFO_EMPTY = 4   /**< Empty TFIFO     */
} ADI_SPI_STAT_TFS;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_FCS
 *! \brief  Flow Control Stall Indication (FCS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_STALL   = 0,  /**< No Stall (RDY pin asserted) */
  SPI_STAT_NOSTALL = 1   /**< Stall (RDY pin de-asserted) */
} ADI_SPI_STAT_FCS;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_RFE
 *! \brief  SPI_RFIFO Empty (RFE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_RFIFO_NE = 0,  /**< RX FIFO not empty */
  SPI_STAT_RFIFO_E  = 1   /**< RX FIFO empty     */
} ADI_SPI_STAT_RFE;


/*  =========================================================================
 *! \enum   ADI_SPI_STAT_TFF
 *! \brief  SPI_TFIFO Full (TFF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_STAT_TFIFO_NF = 0,  /**< Not full Tx FIFO */
  SPI_STAT_TFIFO_F  = 1   /**< Full Tx FIFO     */
} ADI_SPI_STAT_TFF;


/* ==========================================================================
 *! \struct ADI_SPI_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_STAT_t {
  union {
    struct {
      unsigned int SPIF       :  1;  /**< SPI Finished */
      unsigned int RUWM       :  1;  /**< Receive Urgent Watermark Breached */
      unsigned int TUWM       :  1;  /**< Transmit Urgent Watermark Breached */
      unsigned int reserved3  :  1;
      unsigned int ROR        :  1;  /**< Receive Overrun Indication */
      unsigned int TUR        :  1;  /**< Transmit Underrun Indication */
      unsigned int TC         :  1;  /**< Transmit Collision Indication */
      unsigned int MF         :  1;  /**< Mode Fault Indication */
      unsigned int RS         :  1;  /**< Receive Start */
      unsigned int TS         :  1;  /**< Transmit Start */
      unsigned int RF         :  1;  /**< Receive Finish Indication */
      unsigned int TF         :  1;  /**< Transmit Finish Indication */
      unsigned int RFS        :  3;  /**< SPI_RFIFO Status */
      unsigned int reserved15 :  1;
      unsigned int TFS        :  3;  /**< SPI_TFIFO Status */
      unsigned int reserved19 :  1;
      unsigned int FCS        :  1;  /**< Flow Control Stall Indication */
      unsigned int reserved21 :  1;
      unsigned int RFE        :  1;  /**< SPI_RFIFO Empty */
      unsigned int TFF        :  1;  /**< SPI_TFIFO Full */
      unsigned int reserved24 :  4;
      unsigned int MMWE       :  1;  /**< Memory Mapped Write Error */
      unsigned int MMRE       :  1;  /**< Memory Mapped Read Error */
      unsigned int reserved30 :  1;
      unsigned int MMAE       :  1;  /**< Memory Mapped Access Error */
    };
    uint32_t VALUE32;
  };
} ADI_SPI_STAT_t;

/*@}*/

/** @defgroup ILAT Masked Interrupt Condition Register (ILAT) Register
 *  Masked Interrupt Condition Register (ILAT) Register.
 *
 *  The ILAT register latches interrupts, queuing the interrupts for service. When a condition is indicated by a bit in the STAT register and the corresponding interrupt is unmasked in IMSK, the SPI latches the interrupt's bit in ILAT.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_RUWM
 *! \brief  Receive Urgent Watermark Interrupt Latch (RUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_RUWM_LO = 0,  /**< No interrupt      */
  SPI_ILAT_RUWM_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_RUWM;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_TUWM
 *! \brief  Transmit Urgent Watermark Interrupt Latch (TUWM) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_TUWM_LO = 0,  /**< No interrupt      */
  SPI_ILAT_TUWM_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_TUWM;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_ROR
 *! \brief  Receive Overrun Interrupt Latch (ROR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_ROR_LO = 0,  /**< No interrupt      */
  SPI_ILAT_ROR_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_ROR;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_TUR
 *! \brief  Transmit Under-run Interrupt Latch (TUR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_TUR_LO = 0,  /**< No interrupt      */
  SPI_ILAT_TUR_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_TUR;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_TC
 *! \brief  Transmit Collision Interrupt Latch (TC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_TC_LO = 0,  /**< No interrupt      */
  SPI_ILAT_TC_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_TC;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_MF
 *! \brief  Mode Fault Interrupt Latch (MF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_MF_LO = 0,  /**< No interrupt      */
  SPI_ILAT_MF_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_MF;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_RS
 *! \brief  Receive Start Interrupt Latch (RS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_RS_LO = 0,  /**< No interrupt      */
  SPI_ILAT_RS_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_RS;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_TS
 *! \brief  Transmit Start Interrupt Latch (TS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_TS_LO = 0,  /**< No interrupt      */
  SPI_ILAT_TS_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_TS;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_RF
 *! \brief  Receive Finish Interrupt Latch (RF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_RF_LO = 0,  /**< No interrupt      */
  SPI_ILAT_RF_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_RF;


/*  =========================================================================
 *! \enum   ADI_SPI_ILAT_TF
 *! \brief  Transmit Finish Interrupt Latch (TF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPI_ILAT_TF_LO = 0,  /**< No interrupt      */
  SPI_ILAT_TF_HI = 1   /**< Latched interrupt */
} ADI_SPI_ILAT_TF;


/* ==========================================================================
 *! \struct ADI_SPI_ILAT_Struct
 *! \brief  Masked Interrupt Condition Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_ILAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int RUWM       :  1;  /**< Receive Urgent Watermark Interrupt Latch */
      unsigned int TUWM       :  1;  /**< Transmit Urgent Watermark Interrupt Latch */
      unsigned int reserved3  :  1;
      unsigned int ROR        :  1;  /**< Receive Overrun Interrupt Latch */
      unsigned int TUR        :  1;  /**< Transmit Under-run Interrupt Latch */
      unsigned int TC         :  1;  /**< Transmit Collision Interrupt Latch */
      unsigned int MF         :  1;  /**< Mode Fault Interrupt Latch */
      unsigned int RS         :  1;  /**< Receive Start Interrupt Latch */
      unsigned int TS         :  1;  /**< Transmit Start Interrupt Latch */
      unsigned int RF         :  1;  /**< Receive Finish Interrupt Latch */
      unsigned int TF         :  1;  /**< Transmit Finish Interrupt Latch */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_ILAT_t;

/*@}*/

/** @defgroup ILAT_CLR Masked Interrupt Clear Register (ILAT_CLR) Register
 *  Masked Interrupt Clear Register (ILAT_CLR) Register.
 *
 *  The ILAT_CLR register permits clearing individual mask bits in the ILAT register without affecting other bits in the register. Use write-1-to-clear on a bit in ILAT_CLR to clear the corresponding bit in the ILAT register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_ILAT_CLR_Struct
 *! \brief  Masked Interrupt Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_ILAT_CLR_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int RUWM       :  1;  /**< Clear Receive Urgent Watermark Interrupt Latch */
      unsigned int TUWM       :  1;  /**< Clear Transmit Urgent Watermark Interrupt Latch */
      unsigned int reserved3  :  1;
      unsigned int ROR        :  1;  /**< Clear Receive Overrun Interrupt Latch */
      unsigned int TUR        :  1;  /**< Clear Transmit Under-run Interrupt Latch */
      unsigned int TC         :  1;  /**< Clear Transmit Collision Interrupt Latch */
      unsigned int MF         :  1;  /**< Clear Mode Fault Interrupt Latch */
      unsigned int RS         :  1;  /**< Clear Receive Start Interrupt Latch */
      unsigned int TS         :  1;  /**< Clear Transmit Start Interrupt Latch */
      unsigned int RF         :  1;  /**< Clear Receive Finish Interrupt Latch */
      unsigned int TF         :  1;  /**< Clear Transmit Finish Interrupt Latch */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_ILAT_CLR_t;

/*@}*/

/** @defgroup RFIFO Receive FIFO Data Register (RFIFO) Register
 *  Receive FIFO Data Register (RFIFO) Register.
 *
 *  The RFIFO register has an interface to the receive shift register in the SPI and has an interface to the processor's data buses. The top level of the buffer is visible to programs as the 32-bit RFIFO register, but the size (number of word locations) of the receive FIFO is actually flexible with transfer word size. The size of the receive FIFO is 8 if word size is 8-bit, or the size is 4 if word size is 16-bit, or the size is 2 if word size is 32-bit. 
 *  Both masters and slaves may stop or stall receive transfers based on FIFO status. When the receive FIFO is full, the SPI master stops initiating new transfers on the SPI if RXCTL:RTI is enabled. A slave may stall the SPI interface when the content of the FIFO crosses the selected watermark. If data reception continues after RFIFO is full, the data in the receive FIFO is invalid, and the SPI indicates this condition with receive overrun (STAT:ROR). This condition is possible when RXCTL:RTI =0 and RXCTL:REN =1 for a master, or for a slave that does not exercise flow control. 
 *  Note that the receive FIFO is reset (cleared) when the SPI is disabled after being enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_RFIFO_Struct
 *! \brief  Receive FIFO Data Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_RFIFO_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Receive FIFO Data */
    };
    uint32_t VALUE32;
  };
} ADI_SPI_RFIFO_t;

/*@}*/

/** @defgroup TFIFO Transmit FIFO Data Register (TFIFO) Register
 *  Transmit FIFO Data Register (TFIFO) Register.
 *
 *  The TFIFO register has an interface to the transmit shift register in the SPI and has an interface to the processor's data buses. The top level of the buffer is visible to programs as the 32-bit TFIFO register, but the size (number of word locations) of the transmit FIFO is actually flexible with transfer word size. The size of the transmit FIFO is 8 if word size is 8-bit, or the size is 4 if word size is 16-bit, or the size is 2 if word size is 32-bit. 
 *  Both masters and slaves may stop or stall transmit transfers based on FIFO status. When the transmit FIFO is empty, the SPI master stops initiating new transfers on the SPI if TXCTL:TTI is enabled. A slave may stall the SPI interface when the content of the FIFO crosses the selected watermark. If data transmit requests continue after TFIFO is empty, the data sent from the transmit FIFO is invalid, and the SPI indicates this condition with transmit underrun (STAT:TUR). This condition is possible when TXCTL:TTI =0 and TXCTL:TEN =1 for a master, or for a slave that does not exercise flow control. 
 *  Note that the transmit FIFO is reset (cleared) when the SPI is disabled after being enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_TFIFO_Struct
 *! \brief  Transmit FIFO Data Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_TFIFO_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Transmit FIFO Data */
    };
    uint32_t VALUE32;
  };
} ADI_SPI_TFIFO_t;

/*@}*/

/** @defgroup MMRDH Memory Mapped Read Header (MMRDH) Register
 *  Memory Mapped Read Header (MMRDH) Register.
 *
 *  The MMRDH register enables the use of memory-mapped mode. This mode allows direct memory-mapped read accesses of a SPI memory device and is primarily used to directly execute instructions from a SPI FLASH memory without using a low-level software driver. All overhead tasks such as transmission of the read header, pin turnaround timing and receive data sizing are handled in hardware. 
 *  
 *  The memory-mapped access mode is enabled by setting the CTL:MMSE bit. The features within the MMRDH register include a command skip mode, variable length byte addressing, and independent multi-pin support for command transmission, address transmission and data reception. In addition the command op-code and mode bytes are fully programmable. 
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_MMRDH_Struct
 *! \brief  Memory Mapped Read Header Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_MMRDH_t {
  union {
    struct {
      unsigned int OPCODE     :  8;  /**< Read Opcode */
      unsigned int ADRSIZE    :  3;  /**< Bytes of Read Address */
      unsigned int ADRPINS    :  1;  /**< Pins Used for Address */
      unsigned int DMYSIZE    :  3;  /**< Bytes of Dummy/Mode */
      unsigned int reserved15 :  1;
      unsigned int MODE       :  8;  /**< Mode Field */
      unsigned int TRIDMY     :  2;  /**< Tristate Dummy Timing */
      unsigned int MERGE      :  1;  /**< Merge Enable */
      unsigned int WRAP       :  1;  /**< SPI Memory Wrap Indicator */
      unsigned int CMDSKIP    :  1;  /**< Command Skip Enable */
      unsigned int CMDPINS    :  1;  /**< Pins Used for Command */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_SPI_MMRDH_t;

/*@}*/

/** @defgroup MMTOP SPI Memory Top Address (MMTOP) Register
 *  SPI Memory Top Address (MMTOP) Register.
 *
 *  The MMTOP register specifies the top populated address of a connected SPI memory device.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPI_MMTOP_Struct
 *! \brief  SPI Memory Top Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPI_MMTOP_t {
  union {
    struct {
      unsigned int TOPADR     : 32;  /**< SPI Memory Top Address */
    };
    uint32_t VALUE32;
  };
} ADI_SPI_MMTOP_t;

/*@}*/

/** @defgroup CTL_A Half SPORT 'A' Control Register (CTL_A) Register
 *  Half SPORT 'A' Control Register (CTL_A) Register.
 *
 *  The CTL_A contains transmit and receive control bits for SPORT half 'A', including serial port mode selection for the half SPORT's primary and secondary channels. The function of some bits in CTL_A vary, depending on the SPORT's operating mode. For more information, see the SPORT operating modes description. If reading reserved bits, the read value is the last written value to these bits or is the reset value of these bits.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_SPENPRI
 *! \brief  Serial Port Enable (Primary) (SPENPRI) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_DIS = 0,  /**< Disable */
  SPORT_CTL_A_CTL_EN  = 1   /**< Enable  */
} ADI_SPORT_CTL_A_SPENPRI;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_DTYPE
 *! \brief  Data Type (DTYPE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_RJUSTIFY_ZFILL = 0,  /**< Right-justify data, zero-fill unused MSBs   */
  SPORT_CTL_A_CTL_RJUSTIFY_SFILL = 1,  /**< Right-justify data, sign-extend unused MSBs */
  SPORT_CTL_A_CTL_USE_U_LAW      = 2,  /**< m-law compand data                          */
  SPORT_CTL_A_CTL_USE_A_LAW      = 3   /**< A-law compand data                          */
} ADI_SPORT_CTL_A_DTYPE;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_LSBF
 *! \brief  Least-Significant Bit First (LSBF) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_MSB_FIRST = 0,  /**< MSB first sent/received (big endian)    */
  SPORT_CTL_A_CTL_LSB_FIRST = 1   /**< LSB first sent/received (little endian) */
} ADI_SPORT_CTL_A_LSBF;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_PACK
 *! \brief  Packing Enable (PACK) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_PACK_DIS = 0,  /**< Disable */
  SPORT_CTL_A_CTL_PACK_EN  = 1   /**< Enable  */
} ADI_SPORT_CTL_A_PACK;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_ICLK
 *! \brief  Internal Clock (ICLK) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_EXTERNAL_CLK = 0,  /**< External clock */
  SPORT_CTL_A_CTL_INTERNAL_CLK = 1   /**< Internal clock */
} ADI_SPORT_CTL_A_ICLK;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_OPMODE
 *! \brief  Operation mode (OPMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_SERIAL_MC_MODE = 0,  /**< DSP standard/multi-channel mode */
  SPORT_CTL_A_CTL_I2S_MODE       = 1   /**< I2S/packed/left-justified mode  */
} ADI_SPORT_CTL_A_OPMODE;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_CKRE
 *! \brief  Clock Rising Edge (CKRE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_CLK_FALL_EDGE = 0,  /**< Clock falling edge */
  SPORT_CTL_A_CTL_CLK_RISE_EDGE = 1   /**< Clock rising edge  */
} ADI_SPORT_CTL_A_CKRE;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_FSR
 *! \brief  Frame Sync Required (FSR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_FS_NOT_REQ = 0,  /**< No frame sync required */
  SPORT_CTL_A_CTL_FS_REQ     = 1   /**< Frame sync required    */
} ADI_SPORT_CTL_A_FSR;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_IFS
 *! \brief  Internal Frame Sync (IFS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_EXTERNAL_FS = 0,  /**< External frame sync */
  SPORT_CTL_A_CTL_INTERNAL_FS = 1   /**< Internal frame sync */
} ADI_SPORT_CTL_A_IFS;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_DIFS
 *! \brief  Data-Independent Frame Sync (DIFS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_DATA_DEP_FS  = 0,  /**< Data-dependent frame sync   */
  SPORT_CTL_A_CTL_DATA_INDP_FS = 1   /**< Data-independent frame sync */
} ADI_SPORT_CTL_A_DIFS;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_LFS
 *! \brief  Active-Low Frame Sync / L_FIRST / PLFS (LFS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_FS_LO = 0,  /**< Active high frame sync (DSP standard mode) */
  SPORT_CTL_A_CTL_FS_HI = 1   /**< Active low frame sync (DSP standard mode)  */
} ADI_SPORT_CTL_A_LFS;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_LAFS
 *! \brief  Late Frame Sync / OPMODE2 (LAFS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_EARLY_FS = 0,  /**< Early frame sync */
  SPORT_CTL_A_CTL_LATE_FS  = 1   /**< Late frame sync  */
} ADI_SPORT_CTL_A_LAFS;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_RJUST
 *! \brief  Right-Justified Operation Mode (RJUST) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_RJUST_DIS = 0,  /**< Disable */
  SPORT_CTL_A_CTL_RJUST_EN  = 1   /**< Enable  */
} ADI_SPORT_CTL_A_RJUST;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_FSED
 *! \brief  Frame Sync Edge Detect (FSED) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_LEVEL_FS = 0,  /**< Level detect frame sync */
  SPORT_CTL_A_CTL_EDGE_FS  = 1   /**< Edge detect frame sync  */
} ADI_SPORT_CTL_A_FSED;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_TFIEN
 *! \brief  Transmit Finish Interrupt Enable (TFIEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_TXFIN_DIS = 0,  /**< Last word sent (DMA count done) interrupt */
  SPORT_CTL_A_CTL_TXFIN_EN  = 1   /**< Last bit sent (Tx buffer done) interrupt  */
} ADI_SPORT_CTL_A_TFIEN;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_GCLKEN
 *! \brief  Gated Clock Enable (GCLKEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_GCLK_DIS = 0,  /**< Disable */
  SPORT_CTL_A_CTL_GCLK_EN  = 1   /**< Enable  */
} ADI_SPORT_CTL_A_GCLKEN;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_SPENSEC
 *! \brief  Serial Port Enable (Secondary) (SPENSEC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_SECONDARY_DIS = 0,  /**< Disable */
  SPORT_CTL_A_CTL_SECONDARY_EN  = 1   /**< Enable  */
} ADI_SPORT_CTL_A_SPENSEC;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_SPTRAN
 *! \brief  Serial Port Transfer Direction (SPTRAN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_RX = 0,  /**< Receive  */
  SPORT_CTL_A_CTL_TX = 1   /**< Transmit */
} ADI_SPORT_CTL_A_SPTRAN;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_DERRSEC
 *! \brief  Data Error Status (Secondary) (DERRSEC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_SEC_NO_ERR = 0,  /**< No error                            */
  SPORT_CTL_A_CTL_SEC_ERR    = 1   /**< Error (Tx underflow or Rx overflow) */
} ADI_SPORT_CTL_A_DERRSEC;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_DXSSEC
 *! \brief  Data Transfer Buffer Status (Secondary) (DXSSEC) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_SEC_EMPTY     = 0,  /**< Empty          */
  SPORT_CTL_A_CTL_SEC_PART_FULL = 2,  /**< Partially full */
  SPORT_CTL_A_CTL_SEC_FULL      = 3   /**< Full           */
} ADI_SPORT_CTL_A_DXSSEC;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_DERRPRI
 *! \brief  Data Error Status (Primary) (DERRPRI) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_PRM_NO_ERR = 0,  /**< No error                            */
  SPORT_CTL_A_CTL_PRM_ERR    = 1   /**< Error (Tx underflow or Rx overflow) */
} ADI_SPORT_CTL_A_DERRPRI;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL_A_DXSPRI
 *! \brief  Data Transfer Buffer Status (Primary) (DXSPRI) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL_A_CTL_PRM_EMPTY     = 0,  /**< Empty          */
  SPORT_CTL_A_CTL_PRM_PART_FULL = 2,  /**< Partially full */
  SPORT_CTL_A_CTL_PRM_FULL      = 3   /**< Full           */
} ADI_SPORT_CTL_A_DXSPRI;


/* ==========================================================================
 *! \struct ADI_SPORT_CTL_A_Struct
 *! \brief  Half SPORT 'A' Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CTL_A_t {
  union {
    struct {
      unsigned int SPENPRI    :  1;  /**< Serial Port Enable (Primary) */
      unsigned int DTYPE      :  2;  /**< Data Type */
      unsigned int LSBF       :  1;  /**< Least-Significant Bit First */
      unsigned int SLEN       :  5;  /**< Serial Word Length */
      unsigned int PACK       :  1;  /**< Packing Enable */
      unsigned int ICLK       :  1;  /**< Internal Clock */
      unsigned int OPMODE     :  1;  /**< Operation mode */
      unsigned int CKRE       :  1;  /**< Clock Rising Edge */
      unsigned int FSR        :  1;  /**< Frame Sync Required */
      unsigned int IFS        :  1;  /**< Internal Frame Sync */
      unsigned int DIFS       :  1;  /**< Data-Independent Frame Sync */
      unsigned int LFS        :  1;  /**< Active-Low Frame Sync / L_FIRST / PLFS */
      unsigned int LAFS       :  1;  /**< Late Frame Sync / OPMODE2 */
      unsigned int RJUST      :  1;  /**< Right-Justified Operation Mode */
      unsigned int FSED       :  1;  /**< Frame Sync Edge Detect */
      unsigned int TFIEN      :  1;  /**< Transmit Finish Interrupt Enable */
      unsigned int GCLKEN     :  1;  /**< Gated Clock Enable */
      unsigned int reserved22 :  2;
      unsigned int SPENSEC    :  1;  /**< Serial Port Enable (Secondary) */
      unsigned int SPTRAN     :  1;  /**< Serial Port Transfer Direction */
      unsigned int DERRSEC    :  1;  /**< Data Error Status (Secondary) */
      unsigned int DXSSEC     :  2;  /**< Data Transfer Buffer Status (Secondary) */
      unsigned int DERRPRI    :  1;  /**< Data Error Status (Primary) */
      unsigned int DXSPRI     :  2;  /**< Data Transfer Buffer Status (Primary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CTL_A_t;

/*@}*/

/** @defgroup DIV_A Half SPORT 'A' Divisor Register (DIV_A) Register
 *  Half SPORT 'A' Divisor Register (DIV_A) Register.
 *
 *  The DIV_A contains divisor values that determine frequencies of internally-generated clocks and frame syncs for half SPORT  'A'.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_DIV_A_Struct
 *! \brief  Half SPORT 'A' Divisor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_DIV_A_t {
  union {
    struct {
      unsigned int CLKDIV     : 16;  /**< Clock Divisor */
      unsigned int FSDIV      : 16;  /**< Frame Sync Divisor */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_DIV_A_t;

/*@}*/

/** @defgroup MCTL_A Half SPORT 'A' Multi-channel Control Register (MCTL_A) Register
 *  Half SPORT 'A' Multi-channel Control Register (MCTL_A) Register.
 *
 *  The MCTL_A register controls the half SPORT's multi-channel operations. This register enables multi-channel operation, enables multi-channel data packing, selects the multi-channel frame delay, selects the number of multi-channel slots, and selects the multi-channel window offset size.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPORT_MCTL_A_MCE
 *! \brief  Multichannel enable (MCE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_MCTL_A_MCTL_DIS = 0,  /**< Disable */
  SPORT_MCTL_A_MCTL_EN  = 1   /**< Enable  */
} ADI_SPORT_MCTL_A_MCE;


/*  =========================================================================
 *! \enum   ADI_SPORT_MCTL_A_MCPDE
 *! \brief  Multi-Channel Packing DMA Enable (MCPDE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_MCTL_A_MCTL_MCPD_DIS = 0,  /**< Disable */
  SPORT_MCTL_A_MCTL_MCPD_EN  = 1   /**< Enable  */
} ADI_SPORT_MCTL_A_MCPDE;


/* ==========================================================================
 *! \struct ADI_SPORT_MCTL_A_Struct
 *! \brief  Half SPORT 'A' Multi-channel Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_MCTL_A_t {
  union {
    struct {
      unsigned int MCE        :  1;  /**< Multichannel enable */
      unsigned int reserved1  :  1;
      unsigned int MCPDE      :  1;  /**< Multi-Channel Packing DMA Enable */
      unsigned int reserved3  :  1;
      unsigned int MFD        :  4;  /**< Multi-channel Frame Delay */
      unsigned int WSIZE      :  7;  /**< Window Size */
      unsigned int reserved15 :  1;
      unsigned int WOFFSET    : 10;  /**< Window Offset */
      unsigned int reserved26 :  6;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_MCTL_A_t;

/*@}*/

/** @defgroup CS0_A Half SPORT 'A' Multi-channel 0-31 Select Register (CS0_A) Register
 *  Half SPORT 'A' Multi-channel 0-31 Select Register (CS0_A) Register.
 *
 *  The CS0_A register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS0_A_Struct
 *! \brief  Half SPORT 'A' Multi-channel 0-31 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS0_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 0 Thru 31 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS0_A_t;

/*@}*/

/** @defgroup CS1_A Half SPORT 'A' Multi-channel 32-63 Select Register (CS1_A) Register
 *  Half SPORT 'A' Multi-channel 32-63 Select Register (CS1_A) Register.
 *
 *  The CS1_A register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS1_A_Struct
 *! \brief  Half SPORT 'A' Multi-channel 32-63 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS1_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 32 Thru 63 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS1_A_t;

/*@}*/

/** @defgroup CS2_A Half SPORT 'A' Multi-channel 64-95 Select Register (CS2_A) Register
 *  Half SPORT 'A' Multi-channel 64-95 Select Register (CS2_A) Register.
 *
 *  The CS2_A register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS2_A_Struct
 *! \brief  Half SPORT 'A' Multi-channel 64-95 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS2_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 64 Thru 95 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS2_A_t;

/*@}*/

/** @defgroup CS3_A Half SPORT 'A' Multi-channel 96-127 Select Register (CS3_A) Register
 *  Half SPORT 'A' Multi-channel 96-127 Select Register (CS3_A) Register.
 *
 *  The CS3_A register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS3_A_Struct
 *! \brief  Half SPORT 'A' Multi-channel 96-127 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS3_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 96 Thru 127 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS3_A_t;

/*@}*/

/** @defgroup ERR_A Half SPORT 'A' Error Register (ERR_A) Register
 *  Half SPORT 'A' Error Register (ERR_A) Register.
 *
 *  The ERR_A contains error status and error interrupt mask bits for SPORT half 'A', including error handling bits for the half SPORT's primary and secondary channels and frame sync. Detected errors are frame sync violations or buffer over/underflow conditions.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_ERR_A_Struct
 *! \brief  Half SPORT 'A' Error Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_ERR_A_t {
  union {
    struct {
      unsigned int DERRPMSK   :  1;  /**< Data Error Primary (Interrupt) Mask */
      unsigned int DERRSMSK   :  1;  /**< Data Error Secondary (Interrupt) Mask */
      unsigned int FSERRMSK   :  1;  /**< Frame Sync Error (Interrupt) Mask */
      unsigned int reserved3  :  1;
      unsigned int DERRPSTAT  :  1;  /**< Data Error Primary Status */
      unsigned int DERRSSTAT  :  1;  /**< Data Error Secondary Status */
      unsigned int FSERRSTAT  :  1;  /**< Frame Sync Error Status */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_ERR_A_t;

/*@}*/

/** @defgroup MSTAT_A Half SPORT 'A' Multi-channel Status Register (MSTAT_A) Register
 *  Half SPORT 'A' Multi-channel Status Register (MSTAT_A) Register.
 *
 *  The MSTAT_A register indicates the current multi-channel being serviced among the half SPORT's active channels in multi-channel mode. The half SPORT increments the value by one in this register as each channel is serviced. The value in the MSTAT_A register restarts at 0 at each frame sync.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_MSTAT_A_Struct
 *! \brief  Half SPORT 'A' Multi-channel Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_MSTAT_A_t {
  union {
    struct {
      unsigned int CURCHAN    : 10;  /**< Current Channel */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_MSTAT_A_t;

/*@}*/

/** @defgroup CTL2_A Half SPORT 'A' Control 2 Register (CTL2_A) Register
 *  Half SPORT 'A' Control 2 Register (CTL2_A) Register.
 *
 *  The CTL2_A register controls multiplexing options for sharing serial clock and frame sync signals across the related half SPORTs.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SPORT_CTL2_A_FSMUXSEL
 *! \brief  Frame Sync Multiplexer Select (FSMUXSEL) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL2_A_CTL2_FS_MUX_DIS = 0,  /**< Disable frame sync multiplexing */
  SPORT_CTL2_A_CTL2_FS_MUX_EN  = 1   /**< Enable frame sync multiplexing  */
} ADI_SPORT_CTL2_A_FSMUXSEL;


/*  =========================================================================
 *! \enum   ADI_SPORT_CTL2_A_CKMUXSEL
 *! \brief  Clock Multiplexer Select (CKMUXSEL) Enumerations
 *  ========================================================================= */
typedef enum
{
  SPORT_CTL2_A_CTL2_CLK_MUX_DIS = 0,  /**< Disable serial clock multiplexing */
  SPORT_CTL2_A_CTL2_CLK_MUX_EN  = 1   /**< Enable serial clock multiplexing  */
} ADI_SPORT_CTL2_A_CKMUXSEL;


/* ==========================================================================
 *! \struct ADI_SPORT_CTL2_A_Struct
 *! \brief  Half SPORT 'A' Control 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CTL2_A_t {
  union {
    struct {
      unsigned int FSMUXSEL   :  1;  /**< Frame Sync Multiplexer Select */
      unsigned int CKMUXSEL   :  1;  /**< Clock Multiplexer Select */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CTL2_A_t;

/*@}*/

/** @defgroup TXPRI_A Half SPORT 'A' Tx Buffer (Primary) Register (TXPRI_A) Register
 *  Half SPORT 'A' Tx Buffer (Primary) Register (TXPRI_A) Register.
 *
 *  The TXPRI_A register buffers the half SPORT's primary channel transmit data. This register must be loaded with the data to be transmitted if the half SPORT is configured to transmit on the primary channel. Either a program running on the processor core may load the data into the buffer (word-by-word process) or the DMA controller may automatically load the data into the buffer (DMA process). 
 *  The TXPRI_A register acts as a three location buffer if SPORT data packing is disabled (CTL_A:PACK =0); while it acts as two location buffer when packing is enabled (CTL_A:PACK =1). So depending on PACK bit setting, two 32-bit words or three 32-bit words may be stored in the transmit queue at any time. When the transmit register is loaded and any previous word has been transmitted, the TXPRI_A register contents are automatically loaded into the output shifter. The half SPORT may issue an interrupt (transmit buffer is not full) when it has loaded the output transmit shifter, signifying that the transmit buffer is ready to accept the next word. This interrupt does not occur when the half SPORT is executing a DMA-based transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_TXPRI_A_Struct
 *! \brief  Half SPORT 'A' Tx Buffer (Primary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_TXPRI_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Transmit Buffer (Primary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_TXPRI_A_t;

/*@}*/

/** @defgroup RXPRI_A Half SPORT 'A' Rx Buffer (Primary) Register (RXPRI_A) Register
 *  Half SPORT 'A' Rx Buffer (Primary) Register (RXPRI_A) Register.
 *
 *  The RXPRI_A register buffers the half SPORT's primary channel receive data. This buffer becomes active when the half SPORT is configured to receive data on the primary channel. After a complete word has been received in receive shifter, it is placed into the RXPRI_A register. This data can be read in core mode (in interrupt-based or polling-based mechanism) or directly DMA'd into processor memory using DMA controller. With a data buffer and input shift register, the RXPRI_A register acts as a two-location buffer. So, the SPORT can keep Two 32-bit received words at max in any one time (independent of the CTL_A:PACK bit setting).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_RXPRI_A_Struct
 *! \brief  Half SPORT 'A' Rx Buffer (Primary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_RXPRI_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Receive Buffer (Primary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_RXPRI_A_t;

/*@}*/

/** @defgroup TXSEC_A Half SPORT 'A' Tx Buffer (Secondary) Register (TXSEC_A) Register
 *  Half SPORT 'A' Tx Buffer (Secondary) Register (TXSEC_A) Register.
 *
 *  The TXSEC_A register buffers the half SPORT's secondary channel transmit data. This register must be loaded with the data to be transmitted if the half SPORT is configured to transmit on the secondary channel. Either a program running on the processor core may load the data into the buffer (word-by-word process) or the DMA controller may automatically load the data into the buffer (DMA process). 
 *  The TXSEC_A register acts as a three location buffer if SPORT data packing is disabled (CTL_A:PACK =0); while it acts as two location buffer when packing is enabled (CTL_A:PACK =1). So depending on PACK bit setting, two 32-bit words or three 32-bit words may be stored in the transmit queue at any time. When the transmit register is loaded and any previous word has been transmitted, the TXSEC_A register contents are automatically loaded into the output shifter. The half SPORT may issue an interrupt (transmit buffer is not full) when it has loaded the output transmit shifter, signifying that the transmit buffer is ready to accept the next word. This interrupt does not occur when the half SPORT is executing a DMA-based transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_TXSEC_A_Struct
 *! \brief  Half SPORT 'A' Tx Buffer (Secondary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_TXSEC_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Transmit Buffer (Secondary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_TXSEC_A_t;

/*@}*/

/** @defgroup RXSEC_A Half SPORT 'A' Rx Buffer (Secondary) Register (RXSEC_A) Register
 *  Half SPORT 'A' Rx Buffer (Secondary) Register (RXSEC_A) Register.
 *
 *  The RXSEC_A register buffers the half SPORT's primary channel receive data. This buffer becomes active when the half SPORT is configured to receive data on the primary channel. After a complete word has been received in receive shifter, it is placed into the RXSEC_A register. This data can be read in core mode (in interrupt-based or polling-based mechanism) or directly DMA'd into processor memory using DMA controller. With a data buffer and input shift register, the RXSEC_A register acts as a two-location buffer. So, the SPORT can keep Two 32-bit received words at max in any one time (independent of the CTL_A:PACK bit setting).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_RXSEC_A_Struct
 *! \brief  Half SPORT 'A' Rx Buffer (Secondary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_RXSEC_A_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Receive Buffer (Secondary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_RXSEC_A_t;

/*@}*/

/** @defgroup CTL_B Half SPORT 'B' Control Register (CTL_B) Register
 *  Half SPORT 'B' Control Register (CTL_B) Register.
 *
 *  The CTL_B contains transmit and receive control bits for SPORT half 'B', including serial port mode selection for the half SPORT's primary and secondary channels. The function of some bits in CTL_B vary, depending on the SPORT's operating mode. For more information, see the SPORT operating modes description. If reading reserved bits, the read value is the last written value to these bits or is the reset value of these bits.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CTL_B_Struct
 *! \brief  Half SPORT 'B' Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CTL_B_t {
  union {
    struct {
      unsigned int SPENPRI    :  1;  /**< Serial Port Enable (Primary) */
      unsigned int DTYPE      :  2;  /**< Data Type */
      unsigned int LSBF       :  1;  /**< Least-Significant Bit First */
      unsigned int SLEN       :  5;  /**< Serial Word Length */
      unsigned int PACK       :  1;  /**< Packing Enable */
      unsigned int ICLK       :  1;  /**< Internal Clock */
      unsigned int OPMODE     :  1;  /**< Operation mode */
      unsigned int CKRE       :  1;  /**< Clock Rising Edge */
      unsigned int FSR        :  1;  /**< Frame Sync Required */
      unsigned int IFS        :  1;  /**< Internal Frame Sync */
      unsigned int DIFS       :  1;  /**< Data-Independent Frame Sync */
      unsigned int LFS        :  1;  /**< Active-Low Frame Sync / L_FIRST / PLFS */
      unsigned int LAFS       :  1;  /**< Late Frame Sync / OPMODE2 */
      unsigned int RJUST      :  1;  /**< Right-Justified Operation Mode */
      unsigned int FSED       :  1;  /**< Frame Sync Edge Detect */
      unsigned int TFIEN      :  1;  /**< Transmit Finish Interrupt Enable */
      unsigned int GCLKEN     :  1;  /**< Gated Clock Enable */
      unsigned int reserved22 :  2;
      unsigned int SPENSEC    :  1;  /**< Serial Port Enable (Secondary) */
      unsigned int SPTRAN     :  1;  /**< Serial Port Transfer Direction */
      unsigned int DERRSEC    :  1;  /**< Data Error Status (Secondary) */
      unsigned int DXSSEC     :  2;  /**< Data Transfer Buffer Status (Secondary) */
      unsigned int DERRPRI    :  1;  /**< Data Error Status (Primary) */
      unsigned int DXSPRI     :  2;  /**< Data Transfer Buffer Status (Primary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CTL_B_t;

/*@}*/

/** @defgroup DIV_B Half SPORT 'B' Divisor Register (DIV_B) Register
 *  Half SPORT 'B' Divisor Register (DIV_B) Register.
 *
 *  The DIV_B contains divisor values that determine frequencies of internally-generated clocks and frame syncs for SPORT half 'B'.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_DIV_B_Struct
 *! \brief  Half SPORT 'B' Divisor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_DIV_B_t {
  union {
    struct {
      unsigned int CLKDIV     : 16;  /**< Clock Divisor */
      unsigned int FSDIV      : 16;  /**< Frame Sync Divisor */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_DIV_B_t;

/*@}*/

/** @defgroup MCTL_B Half SPORT 'B' Multi-channel Control Register (MCTL_B) Register
 *  Half SPORT 'B' Multi-channel Control Register (MCTL_B) Register.
 *
 *  The MCTL_B register controls the half SPORT's multi-channel operations. This register enables multi-channel operation, enables multi-channel data packing, selects the multi-channel frame delay, selects the number of multi-channel slots, and selects the multi-channel window offset size.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_MCTL_B_Struct
 *! \brief  Half SPORT 'B' Multi-channel Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_MCTL_B_t {
  union {
    struct {
      unsigned int MCE        :  1;  /**< Multi-Channel Enable */
      unsigned int reserved1  :  1;
      unsigned int MCPDE      :  1;  /**< Multi-Channel Packing DMA Enable */
      unsigned int reserved3  :  1;
      unsigned int MFD        :  4;  /**< Multi-channel Frame Delay */
      unsigned int WSIZE      :  7;  /**< Window Size */
      unsigned int reserved15 :  1;
      unsigned int WOFFSET    : 10;  /**< Window Offset */
      unsigned int reserved26 :  6;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_MCTL_B_t;

/*@}*/

/** @defgroup CS0_B Half SPORT 'B' Multi-channel 0-31 Select Register (CS0_B) Register
 *  Half SPORT 'B' Multi-channel 0-31 Select Register (CS0_B) Register.
 *
 *  The CS0_B register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS0_B_Struct
 *! \brief  Half SPORT 'B' Multi-channel 0-31 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS0_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 0 Thru 31 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS0_B_t;

/*@}*/

/** @defgroup CS1_B Half SPORT 'B' Multi-channel 32-63 Select Register (CS1_B) Register
 *  Half SPORT 'B' Multi-channel 32-63 Select Register (CS1_B) Register.
 *
 *  The CS1_B register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS1_B_Struct
 *! \brief  Half SPORT 'B' Multi-channel 32-63 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS1_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 32 Thru 63 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS1_B_t;

/*@}*/

/** @defgroup CS2_B Half SPORT 'B' Multichannel 64-95 Select Register (CS2_B) Register
 *  Half SPORT 'B' Multichannel 64-95 Select Register (CS2_B) Register.
 *
 *  The CS2_B register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS2_B_Struct
 *! \brief  Half SPORT 'B' Multichannel 64-95 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS2_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 64 Thru 95 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS2_B_t;

/*@}*/

/** @defgroup CS3_B Half SPORT 'B' Multichannel 96-127 Select Register (CS3_B) Register
 *  Half SPORT 'B' Multichannel 96-127 Select Register (CS3_B) Register.
 *
 *  The CS3_B register's bits (when set, =1) each corresponds to an active channel for the half SPORT in multi-channel mode. When the register activates a channel (corresponding bit =1), the half SPORT transmits or receives the word in that channel's position of the data stream. When the register de-activates a channel (corresponding bit =0), the half SPORT either three-states its data transmit pin (during the channel's transmit time slot) or ignores incoming data (during the channel's receive time slot).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CS3_B_Struct
 *! \brief  Half SPORT 'B' Multichannel 96-127 Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CS3_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Channel Enable 96 Thru 127 */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CS3_B_t;

/*@}*/

/** @defgroup ERR_B Half SPORT 'B' Error Register (ERR_B) Register
 *  Half SPORT 'B' Error Register (ERR_B) Register.
 *
 *  The ERR_B contains error status and error interrupt mask bits for SPORT half 'B', including error handling bits for the half SPORT's primary and secondary channels and frame sync. Detected errors are frame sync violations or buffer over/underflow conditions.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_ERR_B_Struct
 *! \brief  Half SPORT 'B' Error Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_ERR_B_t {
  union {
    struct {
      unsigned int DERRPMSK   :  1;  /**< Data Error Primary (Interrupt) Mask */
      unsigned int DERRSMSK   :  1;  /**< Data Error Secondary (Interrupt) Mask */
      unsigned int FSERRMSK   :  1;  /**< Frame Sync Error (Interrupt) Mask */
      unsigned int reserved3  :  1;
      unsigned int DERRPSTAT  :  1;  /**< Data Error Primary Status */
      unsigned int DERRSSTAT  :  1;  /**< Data Error Secondary Status */
      unsigned int FSERRSTAT  :  1;  /**< Frame Sync Error Status */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_ERR_B_t;

/*@}*/

/** @defgroup MSTAT_B Half SPORT 'B' Multi-channel Status Register (MSTAT_B) Register
 *  Half SPORT 'B' Multi-channel Status Register (MSTAT_B) Register.
 *
 *  The MSTAT_B register indicates the current multi-channel being serviced among the half SPORT's active channels in multi-channel mode. The half SPORT increments the value by one in this register as each channel is serviced. The value in the MSTAT_B register restarts at 0 at each frame sync.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_MSTAT_B_Struct
 *! \brief  Half SPORT 'B' Multi-channel Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_MSTAT_B_t {
  union {
    struct {
      unsigned int CURCHAN    : 10;  /**< Current Channel */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_MSTAT_B_t;

/*@}*/

/** @defgroup CTL2_B Half SPORT 'B' Control 2 Register (CTL2_B) Register
 *  Half SPORT 'B' Control 2 Register (CTL2_B) Register.
 *
 *  The CTL2_B register controls multiplexing options for sharing serial clock and frame sync signals across the related half SPORTs.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_CTL2_B_Struct
 *! \brief  Half SPORT 'B' Control 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_CTL2_B_t {
  union {
    struct {
      unsigned int FSMUXSEL   :  1;  /**< Frame Sync Multiplexer Select */
      unsigned int CKMUXSEL   :  1;  /**< Clock Multiplexer Select */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_CTL2_B_t;

/*@}*/

/** @defgroup TXPRI_B Half SPORT 'B' Tx Buffer (Primary) Register (TXPRI_B) Register
 *  Half SPORT 'B' Tx Buffer (Primary) Register (TXPRI_B) Register.
 *
 *  The TXPRI_B register buffers the half SPORT's primary channel transmit data. This register must be loaded with the data to be transmitted if the half SPORT is configured to transmit on the primary channel. Either a program running on the processor core may load the data into the buffer (word-by-word process) or the DMA controller may automatically load the data into the buffer (DMA process). 
 *  The TXPRI_B register acts as a three location buffer if SPORT data packing is disabled (CTL_B:PACK =0); while it acts as two location buffer when packing is enabled (CTL_B:PACK =1). So depending on PACK bit setting, two 32-bit words or three 32-bit words may be stored in the transmit queue at any time. When the transmit register is loaded and any previous word has been transmitted, the TXPRI_B register contents are automatically loaded into the output shifter. The half SPORT may issue an interrupt (transmit buffer is not full) when it has loaded the output transmit shifter, signifying that the transmit buffer is ready to accept the next word. This interrupt does not occur when the half SPORT is executing a DMA-based transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_TXPRI_B_Struct
 *! \brief  Half SPORT 'B' Tx Buffer (Primary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_TXPRI_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Transmit Buffer (Primary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_TXPRI_B_t;

/*@}*/

/** @defgroup RXPRI_B Half SPORT 'B' Rx Buffer (Primary) Register (RXPRI_B) Register
 *  Half SPORT 'B' Rx Buffer (Primary) Register (RXPRI_B) Register.
 *
 *  The RXPRI_B register buffers the half SPORT's primary channel receive data. This buffer becomes active when the half SPORT is configured to receive data on the primary channel. After a complete word has been received in receive shifter, it is placed into the RXPRI_B register. This data can be read in core mode (in interrupt-based or polling-based mechanism) or directly DMA'd into processor memory using DMA controller. With a data buffer and input shift register, the RXPRI_B register acts as a two-location buffer. So, the SPORT can keep Two 32-bit received words at max in any one time (independent of the CTL_A:PACK bit setting).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_RXPRI_B_Struct
 *! \brief  Half SPORT 'B' Rx Buffer (Primary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_RXPRI_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Receive Buffer (Primary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_RXPRI_B_t;

/*@}*/

/** @defgroup TXSEC_B Half SPORT 'B' Tx Buffer (Secondary) Register (TXSEC_B) Register
 *  Half SPORT 'B' Tx Buffer (Secondary) Register (TXSEC_B) Register.
 *
 *  The TXSEC_B register buffers the half SPORT's secondary channel transmit data. This register must be loaded with the data to be transmitted if the half SPORT is configured to transmit on the secondary channel. Either a program running on the processor core may load the data into the buffer (word-by-word process) or the DMA controller may automatically load the data into the buffer (DMA process). 
 *  The TXSEC_B register acts as a three location buffer if SPORT data packing is disabled (CTL_B:PACK =0); while it acts as two location buffer when packing is enabled (CTL_B:PACK =1). So depending on PACK bit setting, two 32-bit words or three 32-bit words may be stored in the transmit queue at any time. When the transmit register is loaded and any previous word has been transmitted, the TXSEC_B register contents are automatically loaded into the output shifter. The half SPORT may issue an interrupt (transmit buffer is not full) when it has loaded the output transmit shifter, signifying that the transmit buffer is ready to accept the next word. This interrupt does not occur when the half SPORT is executing a DMA-based transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_TXSEC_B_Struct
 *! \brief  Half SPORT 'B' Tx Buffer (Secondary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_TXSEC_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Transmit Buffer (Secondary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_TXSEC_B_t;

/*@}*/

/** @defgroup RXSEC_B Half SPORT 'B' Rx Buffer (Secondary) Register (RXSEC_B) Register
 *  Half SPORT 'B' Rx Buffer (Secondary) Register (RXSEC_B) Register.
 *
 *  The RXSEC_B register buffers the half SPORT's primary channel receive data. This buffer becomes active when the half SPORT is configured to receive data on the primary channel. After a complete word has been received in receive shifter, it is placed into the RXSEC_B register. This data can be read in core mode (in interrupt-based or polling-based mechanism) or directly DMA'd into processor memory using DMA controller. With a data buffer and input shift register, the RXSEC_B register acts as a two-location buffer. So, the SPORT can keep Two 32-bit received words at max in any one time (independent of the CTL_A:PACK bit setting).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPORT_RXSEC_B_Struct
 *! \brief  Half SPORT 'B' Rx Buffer (Secondary) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPORT_RXSEC_B_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Receive Buffer (Secondary) */
    };
    uint32_t VALUE32;
  };
} ADI_SPORT_RXSEC_B_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register provides enable/disable control for internal UART and for the IrDA mode of operation. This register also provides UART line control, permitting selection of the format of received and transmitted character frames. Modem feature control also is available from this register, including partial modem functionality to allow for hardware flow control and loopback mode.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_UART_CTL_EN
 *! \brief  Enable UART (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_CLK_DIS = 0,  /**< Disable */
  UART_CTL_CLK_EN  = 1   /**< Enable  */
} ADI_UART_CTL_EN;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_LOOP_EN
 *! \brief  Loopback Enable (LOOP_EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_LOOP_DIS = 0,  /**< Disable */
  UART_CTL_LOOP_EN  = 1   /**< Enable  */
} ADI_UART_CTL_LOOP_EN;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_MOD
 *! \brief  Mode of Operation (MOD) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_UART_MODE = 0,  /**< UART Mode     */
  UART_CTL_MDB_MODE  = 1,  /**< MDB Mode      */
  UART_CTL_IRDA_MODE = 2   /**< IrDA SIR Mode */
} ADI_UART_CTL_MOD;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_WLS
 *! \brief  Word Length Select (WLS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_WL5BITS = 0,  /**< 5-bit Word */
  UART_CTL_WL6BITS = 1,  /**< 6-bit Word */
  UART_CTL_WL7BITS = 2,  /**< 7-bit Word */
  UART_CTL_WL8BITS = 3   /**< 8-bit Word */
} ADI_UART_CTL_WLS;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_STB
 *! \brief  Stop Bits (STB) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_NO_EXTRA_STB  = 0,  /**< 1 stop bit  */
  UART_CTL_ONE_EXTRA_STB = 1   /**< 2 stop bits */
} ADI_UART_CTL_STB;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_STBH
 *! \brief  Stop Bits (Half Bit Time) (STBH) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_NO_EXTRA_STBH  = 0,  /**< 0 half-bit-time stop bit */
  UART_CTL_ONE_EXTRA_STBH = 1   /**< 1 half-bit-time stop bit */
} ADI_UART_CTL_STBH;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_PEN
 *! \brief  Parity Enable (PEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_PARITY_DIS = 0,  /**< Disable                          */
  UART_CTL_PARITY_EN  = 1   /**< Enable parity transmit and check */
} ADI_UART_CTL_PEN;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_EPS
 *! \brief  Even Parity Select (EPS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_ODD_PARITY  = 0,  /**< Odd parity  */
  UART_CTL_EVEN_PARITY = 1   /**< Even parity */
} ADI_UART_CTL_EPS;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_STP
 *! \brief  Sticky Parity (STP) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_NORM_PARITY   = 0,  /**< No Forced Parity                                 */
  UART_CTL_STICKY_PARITY = 1   /**< Force (Stick) Parity to Defined Value (if PEN=1) */
} ADI_UART_CTL_STP;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_FPE
 *! \brief  Force Parity Error on Transmit (FPE) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_NORM_PARITY_ERR  = 0,  /**< Normal operation   */
  UART_CTL_FORCE_PARITY_ERR = 1   /**< Force parity error */
} ADI_UART_CTL_FPE;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_FFE
 *! \brief  Force Framing Error on Transmit (FFE) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_NORM_FRM_ERR  = 0,  /**< Normal operation */
  UART_CTL_FORCE_FRM_ERR = 1   /**< Force error      */
} ADI_UART_CTL_FFE;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_SB
 *! \brief  Set Break (SB) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_NORM_BREAK  = 0,  /**< No force          */
  UART_CTL_FORCE_BREAK = 1   /**< Force TX pin to 0 */
} ADI_UART_CTL_SB;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_FCPOL
 *! \brief  Flow Control Pin Polarity (FCPOL) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_FCPOL_LO = 0,  /**< Active low CTS/RTS  */
  UART_CTL_FCPOL_HI = 1   /**< Active high CTS/RTS */
} ADI_UART_CTL_FCPOL;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_RPOLC
 *! \brief  IrDA RX Polarity Change (RPOLC) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_RPOLC_LO = 0,  /**< Active-low RX polarity setting  */
  UART_CTL_RPOLC_HI = 1   /**< Active-high RX polarity setting */
} ADI_UART_CTL_RPOLC;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_TPOLC
 *! \brief  IrDA TX Polarity Change (TPOLC) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_TPOLC_LO = 0,  /**< Active-low TX polarity setting  */
  UART_CTL_TPOLC_HI = 1   /**< Active-high TX polarity setting */
} ADI_UART_CTL_TPOLC;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_MRTS
 *! \brief  Manual Request to Send (MRTS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_RTS_DEASSERT = 0,  /**< De-assert RTS pin when ARTS=0 */
  UART_CTL_RTS_ASSERT   = 1   /**< Assert RTS pin when ARTS=0    */
} ADI_UART_CTL_MRTS;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_XOFF
 *! \brief  Transmitter off (XOFF) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_TX_ON  = 0,  /**< Transmission ON, if ACTS=0  */
  UART_CTL_TX_OFF = 1   /**< Transmission OFF, if ACTS=0 */
} ADI_UART_CTL_XOFF;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_ARTS
 *! \brief  Automatic RTS (ARTS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_RTS_MAN  = 0,  /**< Disable RX handshaking protocol. */
  UART_CTL_RTS_AUTO = 1   /**< Enable RX handshaking protocol.  */
} ADI_UART_CTL_ARTS;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_ACTS
 *! \brief  Automatic CTS (ACTS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_CTS_MAN  = 0,  /**< Disable TX handshaking protocol */
  UART_CTL_CTS_AUTO = 1   /**< Enable TX handshaking protocol  */
} ADI_UART_CTL_ACTS;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_RFIT
 *! \brief  Receive FIFO IRQ Threshold (RFIT) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_RX_IRQ_TH4 = 0,  /**< Set RFCS=1 if RX FIFO count >= 4 */
  UART_CTL_RX_IRQ_TH7 = 1   /**< Set RFCS=1 if RX FIFO count >= 7 */
} ADI_UART_CTL_RFIT;


/*  =========================================================================
 *! \enum   ADI_UART_CTL_RFRT
 *! \brief  Receive FIFO RTS Threshold (RFRT) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CTL_RX_RTS_TH4 = 0,  /**< De-assert RTS if RX FIFO word count > 4; assert if <= 4 */
  UART_CTL_RX_RTS_TH7 = 1   /**< De-assert RTS if RX FIFO word count > 7; assert if <= 7 */
} ADI_UART_CTL_RFRT;


/* ==========================================================================
 *! \struct ADI_UART_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable UART */
      unsigned int LOOP_EN    :  1;  /**< Loopback Enable */
      unsigned int reserved2  :  2;
      unsigned int MOD        :  2;  /**< Mode of Operation */
      unsigned int reserved6  :  2;
      unsigned int WLS        :  2;  /**< Word Length Select */
      unsigned int reserved10 :  2;
      unsigned int STB        :  1;  /**< Stop Bits */
      unsigned int STBH       :  1;  /**< Stop Bits (Half Bit Time) */
      unsigned int PEN        :  1;  /**< Parity Enable */
      unsigned int EPS        :  1;  /**< Even Parity Select */
      unsigned int STP        :  1;  /**< Sticky Parity */
      unsigned int FPE        :  1;  /**< Force Parity Error on Transmit */
      unsigned int FFE        :  1;  /**< Force Framing Error on Transmit */
      unsigned int SB         :  1;  /**< Set Break */
      unsigned int reserved20 :  2;
      unsigned int FCPOL      :  1;  /**< Flow Control Pin Polarity */
      unsigned int RPOLC      :  1;  /**< IrDA RX Polarity Change */
      unsigned int TPOLC      :  1;  /**< IrDA TX Polarity Change */
      unsigned int MRTS       :  1;  /**< Manual Request to Send */
      unsigned int XOFF       :  1;  /**< Transmitter off */
      unsigned int ARTS       :  1;  /**< Automatic RTS */
      unsigned int ACTS       :  1;  /**< Automatic CTS */
      unsigned int RFIT       :  1;  /**< Receive FIFO IRQ Threshold */
      unsigned int RFRT       :  1;  /**< Receive FIFO RTS Threshold */
      unsigned int reserved31 :  1;
    };
    uint32_t VALUE32;
  };
} ADI_UART_CTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register contains the UART line status and UART modem status, as indicated by the current states of the UART's CTS pin and internal receive buffers. Writes to this register can perform write-one-to-clear (W1C) operations on most status bits. Reading this register has no side effects.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_UART_STAT_DR
 *! \brief  Data Ready (DR) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_NO_DATA  = 0,  /**< No new data     */
  UART_STAT_NEW_DATA = 1   /**< New data in RBR */
} ADI_UART_STAT_DR;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_OE
 *! \brief  Overrun Error (OE) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_NO_OVR_ERR = 0,  /**< No overrun    */
  UART_STAT_OVR_ERR    = 1   /**< Overrun error */
} ADI_UART_STAT_OE;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_PE
 *! \brief  Parity Error (PE) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_NO_PARITY_ERR = 0,  /**< No parity error */
  UART_STAT_PARITY_ERR    = 1   /**< Parity error    */
} ADI_UART_STAT_PE;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_FE
 *! \brief  Framing Error (FE) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_NO_FRAMING_ERR = 0,  /**< No error               */
  UART_STAT_FRAMING_ERR    = 1   /**< Invalid stop bit error */
} ADI_UART_STAT_FE;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_BI
 *! \brief  Break Indicator (BI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_NO_BREAK_INT = 0,  /**< No break interrupt */
  UART_STAT_BREAK_INT    = 1   /**< Break interrupt    */
} ADI_UART_STAT_BI;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_THRE
 *! \brief  Transmit Hold Register Empty (THRE) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_THR_NOT_EMPTY = 0,  /**< Not empty THR/TAIP */
  UART_STAT_THR_EMPTY     = 1   /**< Empty THR/TAIP     */
} ADI_UART_STAT_THRE;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_TEMT
 *! \brief  TSR and THR Empty (TEMT) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_TX_NOT_EMPTY = 0,  /**< Not empty TSR/THR */
  UART_STAT_TX_EMPTY     = 1   /**< TSR/THR Empty     */
} ADI_UART_STAT_TEMT;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_TFI
 *! \brief  Transmission Finished Indicator (TFI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_TX_NOT_DONE = 0,  /**< TEMT did not transition from 0 to 1 */
  UART_STAT_TX_DONE     = 1   /**< TEMT transition from 0 to 1         */
} ADI_UART_STAT_TFI;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_ASTKY
 *! \brief  Address Sticky (ASTKY) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_ADDR_LO_STKY = 0,  /**< ADDR bit has not been set */
  UART_STAT_ADDR_HI_STKY = 1   /**< ADDR bit has been set     */
} ADI_UART_STAT_ASTKY;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_ADDR
 *! \brief  Address Bit Status (ADDR) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_ADDR_LO = 0,  /**< Address bit is low  */
  UART_STAT_ADDR_HI = 1   /**< Address bit is high */
} ADI_UART_STAT_ADDR;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_RO
 *! \brief  Reception On-going (RO) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_NO_RX_PROGRESS = 0,  /**< No data reception in progress */
  UART_STAT_RX_PROGRESS    = 1   /**< Data reception in progress    */
} ADI_UART_STAT_RO;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_SCTS
 *! \brief  Sticky CTS (SCTS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_CTS_LO_STKY = 0,  /**< CTS has not transitioned from low to high */
  UART_STAT_CTS_HI_STKY = 1   /**< CTS has transitioned from low to high     */
} ADI_UART_STAT_SCTS;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_CTS
 *! \brief  Clear to Send (CTS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_CTS_LO = 0,  /**< Not clear to send (External device not ready to receive) */
  UART_STAT_CTS_HI = 1   /**< Clear to send (External device ready to receive)         */
} ADI_UART_STAT_CTS;


/*  =========================================================================
 *! \enum   ADI_UART_STAT_RFCS
 *! \brief  Receive FIFO Count Status (RFCS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_STAT_RFCS_LO = 0,  /**< RX FIFO has less than 4 (7) entries when RFIT=0 (1) */
  UART_STAT_RFCS_HI = 1   /**< RX FIFO has at least 4 (7) entries when RFIT=0 (1)  */
} ADI_UART_STAT_RFCS;


/* ==========================================================================
 *! \struct ADI_UART_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_STAT_t {
  union {
    struct {
      unsigned int DR         :  1;  /**< Data Ready */
      unsigned int OE         :  1;  /**< Overrun Error */
      unsigned int PE         :  1;  /**< Parity Error */
      unsigned int FE         :  1;  /**< Framing Error */
      unsigned int BI         :  1;  /**< Break Indicator */
      unsigned int THRE       :  1;  /**< Transmit Hold Register Empty */
      unsigned int reserved6  :  1;
      unsigned int TEMT       :  1;  /**< TSR and THR Empty */
      unsigned int TFI        :  1;  /**< Transmission Finished Indicator */
      unsigned int ASTKY      :  1;  /**< Address Sticky */
      unsigned int ADDR       :  1;  /**< Address Bit Status */
      unsigned int RO         :  1;  /**< Reception On-going */
      unsigned int SCTS       :  1;  /**< Sticky CTS */
      unsigned int reserved13 :  3;
      unsigned int CTS        :  1;  /**< Clear to Send */
      unsigned int RFCS       :  1;  /**< Receive FIFO Count Status */
      unsigned int reserved18 : 14;
    };
    uint32_t VALUE32;
  };
} ADI_UART_STAT_t;

/*@}*/

/** @defgroup SCR Scratch Register (SCR) Register
 *  Scratch Register (SCR) Register.
 *
 *  The SCR registers contain 8-bit scratch pad data. These registers are used for general purpose data storage and do not control the UART hardware in any way.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_SCR_Struct
 *! \brief  Scratch Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_SCR_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< Stored 8-bit Data */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_UART_SCR_t;

/*@}*/

/** @defgroup CLK Clock Rate Register (CLK) Register
 *  Clock Rate Register (CLK) Register.
 *
 *  The CLK register divides the system clock (SCLK) down to the bit clock.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_UART_CLK_EDBO
 *! \brief  Enable Divide By One (EDBO) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_CLK_DIS_DIV_BY_ONE = 0,  /**< Bit clock prescaler = 16 */
  UART_CLK_EN_DIV_BY_ONE  = 1   /**< Bit clock prescaler = 1  */
} ADI_UART_CLK_EDBO;


/* ==========================================================================
 *! \struct ADI_UART_CLK_Struct
 *! \brief  Clock Rate Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_CLK_t {
  union {
    struct {
      unsigned int DIV        : 16;  /**< Divisor */
      unsigned int reserved16 : 15;
      unsigned int EDBO       :  1;  /**< Enable Divide By One */
    };
    uint32_t VALUE32;
  };
} ADI_UART_CLK_t;

/*@}*/

/** @defgroup IMSK Interrupt Mask Register (IMSK) Register
 *  Interrupt Mask Register (IMSK) Register.
 *
 *  The IMSK indicates interrupt mask status (unmasked if set, masked if cleared) of UART status interrupts. This register is not a data register. Instead it is controlled by the IMSK_SET and IMSK_CLR register pair. Writing ones to IMSK_SET enables (unmasks) interrupts, and writing ones to IMSK_CLR disables (masks) them. Reads from either register return the enabled bits. 
 *  The IMSK register is used to enable requests for system handling of empty or full states of UART data registers. Unless polling is used as a means of action, the ERBFI and/or ETBEI bits are normally set. Setting this register without enabling system DMA causes the UART to notify the processor of data inventory state by means of interrupts. For proper operation in this mode, system interrupts must be enabled, and appropriate interrupt handling routines must be present. 
 *  Each UART features three separate interrupt channels to handle data transmit, data receive, and line status events independently, regardless whether DMA is enabled or not. If no DMA channels are assigned to the UART, set the ELSI bit to reroute transmit and receive interrupts to the status interrupt output. 
 *  With system DMA enabled, the UART uses DMA to transfer data to or from the processor. Dedicated DMA channels are available to receive and transmit operation. Line error handling can be configured completely independently from the receive/transmit setup. 
 *  The UART's DMA is enabled by first setting up the system DMA control registers and then enabling the ERBFI and/or ETBEI interrupts. This is because the interrupt request lines double as DMA request lines. Depending on whether DMA is enabled or not, upon receiving these requests, the DMA control unit either generates a direct memory access or passes the UART interrupt on to the system interrupt handling unit. However, UART's error interrupt goes directly to the system interrupt handling unit, bypassing the DMA unit completely.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ERBFI
 *! \brief  Enable Receive Buffer Full Interrupt Mask Status (ERBFI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ERBFI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ERBFI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ERBFI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ETBEI
 *! \brief  Enable Transmit Buffer Empty Interrupt Mask Status (ETBEI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ETBEI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ETBEI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ETBEI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ELSI
 *! \brief  Enable Line Status Interrupt Mask Status (ELSI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ELSI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ELSI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ELSI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_EDSSI
 *! \brief  Enable Modem Status Interrupt Mask Status (EDSSI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_EDSSI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_EDSSI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_EDSSI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_EDTPTI
 *! \brief  Enable DMA TX Peripheral Trigerred Interrupt Mask Status (EDTPTI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_EDTPTI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_EDTPTI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_EDTPTI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ETFI
 *! \brief  Enable Transmission Finished Interrupt Mask Status (ETFI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ETFI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ETFI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ETFI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ERFCI
 *! \brief  Enable Receive FIFO Count Interrupt Mask Status (ERFCI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ERFCI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ERFCI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ERFCI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_EAWI
 *! \brief  Enable Address Word Interrupt Mask Status (EAWI) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_EAWI_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_EAWI_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_EAWI;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ERXS
 *! \brief  Enable RX to Status Interrupt Mask Status (ERXS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ERXS_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ERXS_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ERXS;


/*  =========================================================================
 *! \enum   ADI_UART_IMSK_ETXS
 *! \brief  Enable TX to Status Interrupt Mask Status (ETXS) Enumerations
 *  ========================================================================= */
typedef enum
{
  UART_IMSK_ETXS_LO = 0,  /**< Interrupt is masked   */
  UART_IMSK_ETXS_HI = 1   /**< Interrupt is unmasked */
} ADI_UART_IMSK_ETXS;


/* ==========================================================================
 *! \struct ADI_UART_IMSK_Struct
 *! \brief  Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_IMSK_t {
  union {
    struct {
      unsigned int ERBFI      :  1;  /**< Enable Receive Buffer Full Interrupt Mask Status */
      unsigned int ETBEI      :  1;  /**< Enable Transmit Buffer Empty Interrupt Mask Status */
      unsigned int ELSI       :  1;  /**< Enable Line Status Interrupt Mask Status */
      unsigned int EDSSI      :  1;  /**< Enable Modem Status Interrupt Mask Status */
      unsigned int EDTPTI     :  1;  /**< Enable DMA TX Peripheral Trigerred Interrupt Mask Status */
      unsigned int ETFI       :  1;  /**< Enable Transmission Finished Interrupt Mask Status */
      unsigned int ERFCI      :  1;  /**< Enable Receive FIFO Count Interrupt Mask Status */
      unsigned int EAWI       :  1;  /**< Enable Address Word Interrupt Mask Status */
      unsigned int ERXS       :  1;  /**< Enable RX to Status Interrupt Mask Status */
      unsigned int ETXS       :  1;  /**< Enable TX to Status Interrupt Mask Status */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_UART_IMSK_t;

/*@}*/

/** @defgroup IMSK_SET Interrupt Mask Set Register (IMSK_SET) Register
 *  Interrupt Mask Set Register (IMSK_SET) Register.
 *
 *  The IMSK indicates interrupt mask status (unmasked if set, masked if cleared) of UART status interrupts. This register is not a data register. Instead it is controlled by the IMSK_SET and IMSK_CLR register pair. Writing ones to IMSK_SET enables (unmasks) interrupts, and writing ones to IMSK_CLR disables (masks) them. Reads from either register return the enabled bits. For more information, see the IMSK register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_IMSK_SET_Struct
 *! \brief  Interrupt Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_IMSK_SET_t {
  union {
    struct {
      unsigned int ERBFI      :  1;  /**< Enable Receive Buffer Full Interrupt Mask Set */
      unsigned int ETBEI      :  1;  /**< Enable Transmit Buffer Empty Interrupt Mask Set */
      unsigned int ELSI       :  1;  /**< Enable Line Status Interrupt Mask Set */
      unsigned int EDSSI      :  1;  /**< Enable Modem Status Interrupt Mask Set */
      unsigned int EDTPTI     :  1;  /**< Enable DMA TX Peripheral Triggered Interrupt Mask Set */
      unsigned int ETFI       :  1;  /**< Enable Transmission Finished Interrupt Mask Set */
      unsigned int ERFCI      :  1;  /**< Enable Receive FIFO Count Interrupt Mask Set */
      unsigned int EAWI       :  1;  /**< Enable Address Word Interrupt Mask Set */
      unsigned int ERXS       :  1;  /**< Enable RX to Status Interrupt Mask Set */
      unsigned int ETXS       :  1;  /**< Enable TX to Status Interrupt Mask Set */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_UART_IMSK_SET_t;

/*@}*/

/** @defgroup IMSK_CLR Interrupt Mask Clear Register (IMSK_CLR) Register
 *  Interrupt Mask Clear Register (IMSK_CLR) Register.
 *
 *  The IMSK indicates interrupt mask status (unmasked if set, masked if cleared) of UART status interrupts. This register is not a data register. Instead it is controlled by the IMSK_SET and IMSK_CLR register pair. Writing ones to IMSK_SET enables (unmasks) interrupts, and writing ones to IMSK_CLR disables (masks) them. Reads from either register return the enabled bits. For more information, see the IMSK register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_IMSK_CLR_Struct
 *! \brief  Interrupt Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_IMSK_CLR_t {
  union {
    struct {
      unsigned int ERBFI      :  1;  /**< Enable Receive Buffer Full Interrupt Mask Clear */
      unsigned int ETBEI      :  1;  /**< Enable Transmit Buffer Empty Interrupt Mask Clear */
      unsigned int ELSI       :  1;  /**< Enable Line Status Interrupt Mask Clear */
      unsigned int EDSSI      :  1;  /**< Enable Modem Status Interrupt Mask Clear */
      unsigned int EDTPTI     :  1;  /**< Enable DMA TX Peripheral Triggered Interrupt Mask Clear */
      unsigned int ETFI       :  1;  /**< Enable Transmission Finished Interrupt Mask Clear */
      unsigned int ERFCI      :  1;  /**< Enable Receive FIFO Count Interrupt Mask Clear */
      unsigned int EAWI       :  1;  /**< Enable Address Word Interrupt Mask Clear */
      unsigned int ERXS       :  1;  /**< Enable RX to Status Interrupt Mask Clear */
      unsigned int ETXS       :  1;  /**< Enable TX to Status Interrupt Mask Clear */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_UART_IMSK_CLR_t;

/*@}*/

/** @defgroup RBR Receive Buffer Register (RBR) Register
 *  Receive Buffer Register (RBR) Register.
 *
 *  The read-only RBR register is the UART's receive buffer. It is updated when there is pending data in the receive FIFO. Newly available data is signaled by the STAT:DR bit.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_RBR_Struct
 *! \brief  Receive Buffer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_RBR_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< 8-bit data */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_UART_RBR_t;

/*@}*/

/** @defgroup THR Transmit Hold Register (THR) Register
 *  Transmit Hold Register (THR) Register.
 *
 *  The write-only THR register is the UART's transmit buffer. The STAT:THRE bit indicates whether data can be written to THR. Writes to this register automatically propagate to the internal TSR register as soon as TSR is ready. Then, transmit operation is initiated immediately.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_THR_Struct
 *! \brief  Transmit Hold Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_THR_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< 8 bit data */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_UART_THR_t;

/*@}*/

/** @defgroup TAIP Transmit Address/Insert Pulse Register (TAIP) Register
 *  Transmit Address/Insert Pulse Register (TAIP) Register.
 *
 *  The TAIP register and the THR register share the same physical register, but TAIP has different effect than the THR register when TAIP is written to in MDB and UART modes. 
 *  In MDB mode, data written to the TAIP register is transmitted as an address frame (as with the CTL:MOD bit set). 
 *  In UART mode, a write to TAIP causes a pulse of value TAIP [7] for a duration of TAIP [6:0] x bit time. (There is additional inversion if the CTL:TPOLC bit is set). 
 *  Bit time is defined by the CLK register. The transmission of the pulse is followed by stop bit transmission as specified by the CTL:STB and CTL:STBH bits. This could be used for supporting line break command and inter-frame gap. 
 *  In IrDA mode, writes to TAIP is treated the same as writes to THR. 
 *  Accesses to the TAIP register have the same affects as the THR register with respect to the STAT:THRE, STAT:TEMT, and STAT:TFI flags.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_TAIP_Struct
 *! \brief  Transmit Address/Insert Pulse Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_TAIP_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< 8-bit data */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_UART_TAIP_t;

/*@}*/

/** @defgroup TSR Transmit Shift Register (TSR) Register
 *  Transmit Shift Register (TSR) Register.
 *
 *  The read only TSR register which returns the content of the UART's transmit shift register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_TSR_Struct
 *! \brief  Transmit Shift Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_TSR_t {
  union {
    struct {
      unsigned int VALUE      : 11;  /**< Contents of TSR */
      unsigned int reserved11 : 21;
    };
    uint32_t VALUE32;
  };
} ADI_UART_TSR_t;

/*@}*/

/** @defgroup RSR Receive Shift Register (RSR) Register
 *  Receive Shift Register (RSR) Register.
 *
 *  The read only RSR register which returns the content of the UART's receive shift register. 
 *  The frame data is moved into this shift register after polarity inversion, if any (including the native polarity inversion in the IrDA case). 
 *  In the case of the longest frame (MDB, with parity mode, and 8 bit data word-length), the start bit may be shifted out and not available for reading at the end of the frame reception. This register is NOT reset at the start of frame. If read, in the middle of a frame reception, data corresponding the previous frame may not have entirely shifted out (for example, the read data that have been read may NOT correspond entirely to the frame being received).
 *  Because the UART is receiving only 1 stop bit, the RSR contains only 1 stop bit even if more than one stop bit is present in the actual transfer. This register may be considered as storing the 10 most recently received bits (taking into consideration the stop bit receive limitation above).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_RSR_Struct
 *! \brief  Receive Shift Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_RSR_t {
  union {
    struct {
      unsigned int VALUE      : 10;  /**< Contents of RSR */
      unsigned int reserved10 : 22;
    };
    uint32_t VALUE32;
  };
} ADI_UART_RSR_t;

/*@}*/

/** @defgroup TXCNT Transmit Counter Register (TXCNT) Register
 *  Transmit Counter Register (TXCNT) Register.
 *
 *  The TXCNT read only register returns the content of 16-bit counter in the UART transmitter. This count is used for baud rate clock generation (the lower [15:0] is the count data).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_TXCNT_Struct
 *! \brief  Transmit Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_TXCNT_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< 16-bit Counter Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_UART_TXCNT_t;

/*@}*/

/** @defgroup RXCNT Receive Counter Register (RXCNT) Register
 *  Receive Counter Register (RXCNT) Register.
 *
 *  The RXCNT register returns the content of 16-bit counter in the UART receiver. This count is used for baud rate clock generation (the lower [15:0] is the count data).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_UART_RXCNT_Struct
 *! \brief  Receive Counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_UART_RXCNT_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< 16-bit Counter Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_UART_RXCNT_t;

/*@}*/

/** @defgroup CTL FFTB control register (CTL) Register
 *  FFTB control register (CTL) Register.
 *
 *  The FFTB control register contains all the field needed to control the functionality of the FFTB block.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_FFTB_CTL_TRIGMODE
 *! \brief  Triggering Mode (TRIGMODE) Enumerations
 *  ========================================================================= */
typedef enum
{
  FFTB_CTL_MANUAL    = 0,  /**< Manual Triggering    */
  FFTB_CTL_AUTO      = 1,  /**< Auto Triggering      */
  FFTB_CTL_TRIG_ONE  = 2,  /**< Triggered One Shot   */
  FFTB_CTL_TRIG_CONT = 3   /**< Triggered Continuous */
} ADI_FFTB_CTL_TRIGMODE;


/*  =========================================================================
 *! \enum   ADI_FFTB_CTL_CHEN
 *! \brief  Channel Enables (CHEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  FFTB_CTL_CH0 = 0,  /**< Channel 0 is enabled              */
  FFTB_CTL_CH1 = 1,  /**< Channel 0 and 1 are enabled       */
  FFTB_CTL_CH2 = 2,  /**< Channel 0, 1 and 2 are enabled    */
  FFTB_CTL_CH3 = 3   /**< Channel 0, 1, 2 and 3 are enabled */
} ADI_FFTB_CTL_CHEN;


/*  =========================================================================
 *! \enum   ADI_FFTB_CTL_AVG
 *! \brief  Averaging select (AVG) Enumerations
 *  ========================================================================= */
typedef enum
{
  FFTB_CTL_NO_AVG = 0,  /**< Spectrum averaging is disabled.           */
  FFTB_CTL_AVG_2  = 1,  /**< Average the spectrum of 2 input vectors.  */
  FFTB_CTL_AVG_4  = 2,  /**< Average the spectrum of 4 input vectors.  */
  FFTB_CTL_AVG_8  = 3,  /**< Average the spectrum of 8 input vectors.  */
  FFTB_CTL_AVG_16 = 4   /**< Average the spectrum of 16 input vectors. */
} ADI_FFTB_CTL_AVG;


/*  =========================================================================
 *! \enum   ADI_FFTB_CTL_SZ
 *! \brief  FFT size (SZ) Enumerations
 *  ========================================================================= */
typedef enum
{
  FFTB_CTL_FFTSZ_32  = 5,  /**< The size of the input vector is 32 points.  */
  FFTB_CTL_FFTSZ_64  = 6,  /**< The size of the input vector is 64 points.  */
  FFTB_CTL_FFTSZ_128 = 7,  /**< The size of the input vector is 128 points. */
  FFTB_CTL_FFTSZ_256 = 8,  /**< The size of the input vector is 256 points. */
  FFTB_CTL_FFTSZ_512 = 9   /**< The size of the input vector is 512 points. */
} ADI_FFTB_CTL_SZ;


/* ==========================================================================
 *! \struct ADI_FFTB_CTL_Struct
 *! \brief  FFTB control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< FFT Enable */
      unsigned int START      :  1;  /**< FFT start */
      unsigned int STOP       :  1;  /**< FFT stop */
      unsigned int reserved3  :  1;
      unsigned int TRIGSEL    :  1;  /**< Trigger select mask */
      unsigned int reserved5  :  3;
      unsigned int TRIGMODE   :  2;  /**< Triggering Mode */
      unsigned int CHEN       :  2;  /**< Channel Enables */
      unsigned int AVG        :  3;  /**< Averaging select */
      unsigned int reserved15 :  1;
      unsigned int WND        :  1;  /**< Windowing enable */
      unsigned int CMP        :  1;  /**< Compare enable */
      unsigned int DMAOUT     :  1;  /**< DMA output enable */
      unsigned int reserved19 :  1;
      unsigned int SZ         :  4;  /**< FFT size */
      unsigned int DONEIRQ    :  1;  /**< Done interrupt enable */
      unsigned int CHDONEIRQ  :  1;  /**< Channel done interrupt enable */
      unsigned int LIMIRQ     :  1;  /**< Limit interrupt enable */
      unsigned int DPEIRQ     :  1;  /**< Data Parity error interrupt enable */
      unsigned int SPEIRQ     :  1;  /**< Setup Parity error interrupt enable */
      unsigned int reserved29 :  1;
      unsigned int PETST      :  1;  /**< Enable parity testmode */
      unsigned int LOCK       :  1;  /**< Lock enable */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_CTL_t;

/*@}*/

/** @defgroup STAT FFTB Status register (STAT) Register
 *  FFTB Status register (STAT) Register.
 *
 *  The FFTB status register contains all fields that report the status of the FFTB functionality.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_FFTB_STAT_ACTCH
 *! \brief  Active channel. (ACTCH) Enumerations
 *  ========================================================================= */
typedef enum
{
  FFTB_STAT_CHACT_0 = 0,  /**< Channel 0 active */
  FFTB_STAT_CHACT_1 = 1,  /**< Channel 1 active */
  FFTB_STAT_CHACT_2 = 2,  /**< Channel 2 active */
  FFTB_STAT_CHACT_3 = 3   /**< Channel 3 active */
} ADI_FFTB_STAT_ACTCH;


/* ==========================================================================
 *! \struct ADI_FFTB_STAT_Struct
 *! \brief  FFTB Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_STAT_t {
  union {
    struct {
      unsigned int ACT        :  1;  /**< Active status */
      unsigned int IPND       :  1;  /**< Input capture pending */
      unsigned int SPND       :  1;  /**< Spectrum calculation pending */
      unsigned int OPND       :  1;  /**< DMA output pending */
      unsigned int DONE       :  1;  /**< FFT done */
      unsigned int CHDONE     :  1;  /**< Channel done */
      unsigned int reserved6  :  2;
      unsigned int AVGPND     :  4;  /**< Averaging pending */
      unsigned int reserved12 :  4;
      unsigned int DPERR      :  1;  /**< Data parity error */
      unsigned int SPERR      :  1;  /**< Setup parity error */
      unsigned int LIMERR     :  1;  /**< Limit error */
      unsigned int reserved19 :  1;
      unsigned int ACTCH      :  2;  /**< Active channel. */
      unsigned int reserved22 : 10;
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_STAT_t;

/*@}*/

/** @defgroup FMTCTL Format converter control register (FMTCTL) Register
 *  Format converter control register (FMTCTL) Register.
 *
 *  Contains control fields to guide in processing the input stream before writing it to the input buffer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_FMTCTL_Struct
 *! \brief  Format converter control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_FMTCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Format converter enable */
      unsigned int UNPK       :  1;  /**< Unpack input stream */
      unsigned int SGN        :  1;  /**< Signed input */
      unsigned int SAT        :  1;  /**< Saturation enable */
      unsigned int FLDSZ      :  4;  /**< Field size */
      unsigned int IMSB       :  4;  /**< Input MSB */
      unsigned int OMSB       :  4;  /**< Output MSB */
      unsigned int reserved16 : 15;
      unsigned int LOCK       :  1;  /**< format converter lock enable */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_FMTCTL_t;

/*@}*/

/** @defgroup INOFST Input offset register (INOFST) Register
 *  Input offset register (INOFST) Register.
 *
 *  The offset value to be used by the format converter. If the format converter is enabled (FMTCTL.EN = 1'b1), this offset value is added to the processed input value.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_INOFST_Struct
 *! \brief  Input offset Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_INOFST_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Input offset */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_INOFST_t;

/*@}*/

/** @defgroup COMB FFTB Input Comb Filter Control (COMB) Register
 *  FFTB Input Comb Filter Control (COMB) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_COMB_Struct
 *! \brief  FFTB Input Comb Filter Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_COMB_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Comb Filter Enable */
      unsigned int reserved1  :  3;
      unsigned int SGN        :  1;  /**< Comb Filter sign */
      unsigned int reserved5  :  3;
      unsigned int LEN        :  9;  /**< Comb Filter Length */
      unsigned int reserved17 : 14;
      unsigned int LOCK       :  1;  /**< comb filter lock enable */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_COMB_t;

/*@}*/

/** @defgroup DMABASE DMA output base address (DMABASE) Register
 *  DMA output base address (DMABASE) Register.
 *
 *  When (CTL.DMAOUT = 0x1), the DMABASE.ADDR is use as the initial value of DMAWR.ADDR for DMA out.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_DMABASE_Struct
 *! \brief  DMA output base address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_DMABASE_t {
  union {
    struct {
      unsigned int LOCK       :  1;  /**< DMA Address Lock Enable */
      unsigned int reserved1  :  1;
      unsigned int ADDR       : 30;  /**< DMA output base address */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_DMABASE_t;

/*@}*/

/** @defgroup DMAWR DMA output write address (DMAWR) Register
 *  DMA output write address (DMAWR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_DMAWR_Struct
 *! \brief  DMA output write address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_DMAWR_t {
  union {
    struct {
      unsigned int ADDR       : 32;  /**< The current address of the DMA output. */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_DMAWR_t;

/*@}*/

/** @defgroup MAGSEL Magnitude pin select registers (MAGSEL) Register
 *  Magnitude pin select registers (MAGSEL) Register.
 *
 *  Contains one control bit for each power spectrum density point, if that bit is set the corresponding point will be used in Power Spectrum Density comparison, and finding the minimum, and maximum values.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_MAGSEL_Struct
 *! \brief  Magnitude pin select registers Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_MAGSEL_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Magnitude select */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_MAGSEL_t;

/*@}*/

/** @defgroup LIMSTAT Limit status registers (LIMSTAT) Register
 *  Limit status registers (LIMSTAT) Register.
 *
 *  Contains one status bit for each power spectrum density point comparison in half the FFT spectrum.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_LIMSTAT_Struct
 *! \brief  Limit status registers Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_LIMSTAT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Over limit status */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_LIMSTAT_t;

/*@}*/

/** @defgroup MAXMAG Maximum magnitude register (MAXMAG) Register
 *  Maximum magnitude register (MAXMAG) Register.
 *
 *  Contains the maximum value of the spectrum magnitude square (Power Spectrum Density).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_MAXMAG_Struct
 *! \brief  Maximum magnitude Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_MAXMAG_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Maximum magnitude square of the spectrum magnitude. */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_MAXMAG_t;

/*@}*/

/** @defgroup MINMAG Minimum magnitude register (MINMAG) Register
 *  Minimum magnitude register (MINMAG) Register.
 *
 *  Contains the minimum value of the spectrum magnitude square (Power Spectrum Density).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_FFTB_MINMAG_Struct
 *! \brief  Minimum magnitude Register bit field structure
 * ========================================================================== */
typedef struct _ADI_FFTB_MINMAG_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Minimum magnitude square of the spectrum magnitude. */
    };
    uint32_t VALUE32;
  };
} ADI_FFTB_MINMAG_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register masks (disables) and unmasks (enables) SINC high-level interrupt signals triggered by fault events. The register also enables and assigns SINC filter pairs to one of two control groups.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SINC_CTL_EN0
 *! \brief  Enable Filter Pair 0 (EN0) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_CTL_C0DIS    = 0,  /**< Disable                      */
  SINC_CTL_C0ENGRP0 = 2   /**< Enable and Assign to Group 0 */
} ADI_SINC_CTL_EN0;


/*  =========================================================================
 *! \enum   ADI_SINC_CTL_EN1
 *! \brief  Enable Filter Pair 1 (EN1) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_CTL_C1DIS    = 0,  /**< Disable                      */
  SINC_CTL_C1ENGRP0 = 2   /**< Enable and Assign to Group 0 */
} ADI_SINC_CTL_EN1;


/*  =========================================================================
 *! \enum   ADI_SINC_CTL_EN2
 *! \brief  Enable Filter Pair 2 (EN2) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_CTL_C2DIS    = 0,  /**< Disable                      */
  SINC_CTL_C2ENGRP0 = 2   /**< Enable and Assign to Group 0 */
} ADI_SINC_CTL_EN2;


/*  =========================================================================
 *! \enum   ADI_SINC_CTL_EN3
 *! \brief  Enable Filter Pair 3 (EN3) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_CTL_C3DIS    = 0,  /**< Disable                      */
  SINC_CTL_C3ENGRP0 = 2   /**< Enable and Assign to Group 0 */
} ADI_SINC_CTL_EN3;


/* ==========================================================================
 *! \struct ADI_SINC_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_CTL_t {
  union {
    struct {
      unsigned int EN0        :  2;  /**< Enable Filter Pair 0 */
      unsigned int EN1        :  2;  /**< Enable Filter Pair 1 */
      unsigned int EN2        :  2;  /**< Enable Filter Pair 2 */
      unsigned int EN3        :  2;  /**< Enable Filter Pair 3 */
      unsigned int reserved8  :  4;
      unsigned int EFOVF0     :  1;  /**< Enable FIFO Overflow for Group 0 */
      unsigned int EPCNT0     :  1;  /**< Enable Primary Count for Group 0 */
      unsigned int ESAT0      :  1;  /**< Enable Saturation for Group 0 */
      unsigned int ELIM0      :  1;  /**< Enable Limit for Group 0 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SINC_CTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates status for SINC output saturation, amplitude and duration limits, overload conditions, and data transfer errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_STAT_t {
  union {
    struct {
      unsigned int MIN0       :  1;  /**< Minimum for Secondary Filter 0 Status */
      unsigned int MIN1       :  1;  /**< Minimum for Secondary Filter 1 Status */
      unsigned int MIN2       :  1;  /**< Minimum for Secondary Filter 2 Status */
      unsigned int MIN3       :  1;  /**< Minimum for Secondary Filter 3 Status */
      unsigned int reserved4  :  7;
      unsigned int PFAB0      :  1;  /**< Primary (Filter) Fabric Error for Group 0 Status */
      unsigned int FOVF0      :  1;  /**< FIFO Overflow for Group 0 Status */
      unsigned int PCNT0      :  1;  /**< Primary (Filter) Count for Group 0 Status */
      unsigned int GSAT0      :  1;  /**< Group 0 Saturation Status */
      unsigned int GLIM0      :  1;  /**< Group 0 Limit Status */
      unsigned int MAX0       :  1;  /**< Maximum for Secondary Filter 0 Status */
      unsigned int MAX1       :  1;  /**< Maximum for Secondary Filter 1 Status */
      unsigned int MAX2       :  1;  /**< Maximum for Secondary Filter 2 Status */
      unsigned int MAX3       :  1;  /**< Maximum for Secondary Filter 3 Status */
      unsigned int PSAT0      :  1;  /**< Primary (Filter) 0 Saturation Status */
      unsigned int PSAT1      :  1;  /**< Primary (Filter) 1 Saturation Status */
      unsigned int PSAT2      :  1;  /**< Primary (Filter) 2 Saturation Status */
      unsigned int PSAT3      :  1;  /**< Primary (Filter) 3 Saturation Status */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_SINC_STAT_t;

/*@}*/

/** @defgroup CLK Clock Control Register (CLK) Register
 *  Clock Control Register (CLK) Register.
 *
 *  The CLK register generates and enables two SINC modulator clocks. The register also controls each clock's output, frequency, phase, and start-up behavior.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_CLK_Struct
 *! \brief  Clock Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_CLK_t {
  union {
    struct {
      unsigned int MCEN0      :  2;  /**< Modulator (Clock) Enable for Group 0 */
      unsigned int MADJ0      :  6;  /**< Modulator (Clock) Adjustment for Group 0 */
      unsigned int MREQ0      :  1;  /**< Modulator (Clock) Request for Group 0 Status */
      unsigned int reserved9  :  1;
      unsigned int MDIV0      :  6;  /**< Modulator (Clock) Divider for Group 0 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SINC_CLK_t;

/*@}*/

/** @defgroup RATE0 Rate Control for Group 0 Register (RATE0) Register
 *  Rate Control for Group 0 Register (RATE0) Register.
 *
 *  The RATE0 register controls phase adjustments and decimation rates for primary and secondary SINC filters assigned to group 0.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_RATE0_Struct
 *! \brief  Rate Control for Group 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_RATE0_t {
  union {
    struct {
      unsigned int PDEC       :  9;  /**< Primary (Filter) Decimation Rate */
      unsigned int SDEC       :  6;  /**< Secondary (Filter) Decimation Rate */
      unsigned int reserved15 :  1;
      unsigned int PADJ       :  9;  /**< Primary (Filter) Adjustment */
      unsigned int SADJ       :  6;  /**< Secondary (Filter) Adjustment */
      unsigned int reserved31 :  1;
    };
    uint32_t VALUE32;
  };
} ADI_SINC_RATE0_t;

/*@}*/

/** @defgroup LEVEL0 Level Control for Group 0 Register (LEVEL0) Register
 *  Level Control for Group 0 Register (LEVEL0) Register.
 *
 *  The LEVEL0 register controls output scaling and count, excursion limit and window, as well as orders for primary and secondary SINC filters assigned to group 0.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_LEVEL0_Struct
 *! \brief  Level Control for Group 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_LEVEL0_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int LWIN       :  3;  /**< (Excursion) Limit Window */
      unsigned int LCNT       :  3;  /**< (Excursion) Limit Count */
      unsigned int SORD       :  1;  /**< Secondary (Filter) Order Select */
      unsigned int reserved15 :  1;
      unsigned int PCNT       :  8;  /**< Primary (Filter) Count */
      unsigned int PSCALE     :  6;  /**< Primary (Filter) Scaling */
      unsigned int PORD       :  1;  /**< Primary (Filter) Order */
      unsigned int reserved31 :  1;
    };
    uint32_t VALUE32;
  };
} ADI_SINC_LEVEL0_t;

/*@}*/

/** @defgroup LIMIT0 (Amplitude) Limits for Secondary Filter 0 Register (LIMIT0) Register
 *  (Amplitude) Limits for Secondary Filter 0 Register (LIMIT0) Register.
 *
 *  The LIMIT0 register controls amplitude limits for a secondary filter of SINC pair 0.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_LIMIT0_Struct
 *! \brief  (Amplitude) Limits for Secondary Filter 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_LIMIT0_t {
  union {
    struct {
      unsigned int LMIN       : 16;  /**< Limit Minimum for Secondary Filter 0 */
      unsigned int LMAX       : 16;  /**< Limit Maximum for Secondary Filter 0 */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_LIMIT0_t;

/*@}*/

/** @defgroup LIMIT1 (Amplitude) Limits for Secondary Filter 1 Register (LIMIT1) Register
 *  (Amplitude) Limits for Secondary Filter 1 Register (LIMIT1) Register.
 *
 *  The LIMIT1 register controls amplitude limits for a secondary filter of SINC pair 1.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_LIMIT1_Struct
 *! \brief  (Amplitude) Limits for Secondary Filter 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_LIMIT1_t {
  union {
    struct {
      unsigned int LMIN       : 16;  /**< Limit Minimum for Secondary Filter 1 */
      unsigned int LMAX       : 16;  /**< Limit Maximum for Secondary Filter 1 */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_LIMIT1_t;

/*@}*/

/** @defgroup LIMIT2 (Amplitude) Limits for Secondary Filter 2 Register (LIMIT2) Register
 *  (Amplitude) Limits for Secondary Filter 2 Register (LIMIT2) Register.
 *
 *  The LIMIT2 register controls amplitude limits for a secondary filter of SINC pair 2.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_LIMIT2_Struct
 *! \brief  (Amplitude) Limits for Secondary Filter 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_LIMIT2_t {
  union {
    struct {
      unsigned int LMIN       : 16;  /**< Limit Minimum for Secondary Filter 2 */
      unsigned int LMAX       : 16;  /**< Limit Maximum for Secondary Filter 2 */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_LIMIT2_t;

/*@}*/

/** @defgroup LIMIT3 (Amplitude) Limits for Secondary Filter 3 Register (LIMIT3) Register
 *  (Amplitude) Limits for Secondary Filter 3 Register (LIMIT3) Register.
 *
 *  The LIMIT3 register controls amplitude limits for a secondary filter of SINC pair 3.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_LIMIT3_Struct
 *! \brief  (Amplitude) Limits for Secondary Filter 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_LIMIT3_t {
  union {
    struct {
      unsigned int LMIN       : 16;  /**< Limit Minimum for Secondary Filter 3 */
      unsigned int LMAX       : 16;  /**< Limit Maximum for Secondary Filter 3 */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_LIMIT3_t;

/*@}*/

/** @defgroup BIAS0 Bias for Group 0 Register (BIAS0) Register
 *  Bias for Group 0 Register (BIAS0) Register.
 *
 *  The BIAS0 register controls an output bias added to primary SINC filters of group 0.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_BIAS0_Struct
 *! \brief  Bias for Group 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_BIAS0_t {
  union {
    struct {
      unsigned int BIAS       : 32;  /**< Bias for Group 0 Primary Filters */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_BIAS0_t;

/*@}*/

/** @defgroup PPTR0 Primary (Filters) Pointer for Group 0 Register (PPTR0) Register
 *  Primary (Filters) Pointer for Group 0 Register (PPTR0) Register.
 *
 *  The PPTR0 read-only register points to a circular buffer holding the most recent results of primary SINC filters, according to control group 0 assignments.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_PPTR0_Struct
 *! \brief  Primary (Filters) Pointer for Group 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_PPTR0_t {
  union {
    struct {
      unsigned int PPTR       : 32;  /**< Primary (Filter) Pointer */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_PPTR0_t;

/*@}*/

/** @defgroup PHEAD0 Primary (Filters) Head for Group 0 Register (PHEAD0) Register
 *  Primary (Filters) Head for Group 0 Register (PHEAD0) Register.
 *
 *  The PHEAD0 register stores the head address for a circular buffer in data memory to which to transfer the primary SINC filter outputs (according to control group 0 assignments).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_PHEAD0_Struct
 *! \brief  Primary (Filters) Head for Group 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_PHEAD0_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int PHEAD      : 31;  /**< Primary (Filter) Head Pointer */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_PHEAD0_t;

/*@}*/

/** @defgroup PTAIL0 Primary (Filters) Tail for Group 0 Register (PTAIL0) Register
 *  Primary (Filters) Tail for Group 0 Register (PTAIL0) Register.
 *
 *  The PTAIL0 register stores the tail address for a circular buffer in data memory to which to transfer the primary SINC filter outputs (according to control group 1 assignments).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_PTAIL0_Struct
 *! \brief  Primary (Filters) Tail for Group 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_PTAIL0_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int PTAIL      : 31;  /**< Primary (Filter) Tail Pointer */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_PTAIL0_t;

/*@}*/

/** @defgroup HIS_STAT History Status Register (HIS_STAT) Register
 *  History Status Register (HIS_STAT) Register.
 *
 *  The HIS_STAT provides status for data histories of secondary SINC filters, in the corresponding history buffer registers. The SINC history buffer registers save the most recent filter samples once an overload fault signal is detected.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SINC_HIS_STAT_P0HISPTR
 *! \brief  Pair 0 History Pointer (P0HISPTR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_HIS_STAT_P0HIS0_H = 0,  /**< History Register 3, MS */
  SINC_HIS_STAT_P0HIS1_L = 1,  /**< History Register 0, LS */
  SINC_HIS_STAT_P0HIS1_H = 2,  /**< History Register 0, MS */
  SINC_HIS_STAT_P0HIS2_L = 3,  /**< History Register 1, LS */
  SINC_HIS_STAT_P0HIS2_H = 4,  /**< History Register 1, MS */
  SINC_HIS_STAT_P0HIS3_L = 5,  /**< History Register 2, LS */
  SINC_HIS_STAT_P0HIS3_H = 6,  /**< History Register 2, MS */
  SINC_HIS_STAT_P0HIS0_L = 7   /**< History Register 3, LS */
} ADI_SINC_HIS_STAT_P0HISPTR;


/*  =========================================================================
 *! \enum   ADI_SINC_HIS_STAT_P1HISPTR
 *! \brief  Pair 1 History Pointer (P1HISPTR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_HIS_STAT_P1HIS0_H = 0,  /**< History Register 3, MS */
  SINC_HIS_STAT_P1HIS1_L = 1,  /**< History Register, LS   */
  SINC_HIS_STAT_P1HIS1_H = 2,  /**< History Register 0, MS */
  SINC_HIS_STAT_P1HIS2_L = 3,  /**< History Register 1, LS */
  SINC_HIS_STAT_P1HIS2_H = 4,  /**< History Register 1, MS */
  SINC_HIS_STAT_P1HIS3_L = 5,  /**< History Register 2, LS */
  SINC_HIS_STAT_P1HIS3_H = 6,  /**< History Register 2, MS */
  SINC_HIS_STAT_P1HIS0_L = 7   /**< History Register 3, LS */
} ADI_SINC_HIS_STAT_P1HISPTR;


/*  =========================================================================
 *! \enum   ADI_SINC_HIS_STAT_P2HISPTR
 *! \brief  Pair 2 History Pointer (P2HISPTR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_HIS_STAT_P2HIS0_H = 0,  /**< History Register 3, MS */
  SINC_HIS_STAT_P2HIS1_L = 1,  /**< History Register 0, LS */
  SINC_HIS_STAT_P2HIS1_H = 2,  /**< History Register 0, MS */
  SINC_HIS_STAT_P2HIS2_L = 3,  /**< History Register 1, LS */
  SINC_HIS_STAT_P2HIS2_H = 4,  /**< History Register 1, MS */
  SINC_HIS_STAT_P2HIS3_L = 5,  /**< History Register 2, LS */
  SINC_HIS_STAT_P2HIS3_H = 6,  /**< History Register 2, MS */
  SINC_HIS_STAT_P2HIS0_L = 7   /**< History Register 3, LS */
} ADI_SINC_HIS_STAT_P2HISPTR;


/*  =========================================================================
 *! \enum   ADI_SINC_HIS_STAT_P3HISPTR
 *! \brief  Pair 3 History Pointer (P3HISPTR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SINC_HIS_STAT_P3HIS0_H = 0,  /**< History Register 3, MS */
  SINC_HIS_STAT_P3HIS1_L = 1,  /**< History Register 0, LS */
  SINC_HIS_STAT_P3HIS1_H = 2,  /**< History Register 0, MS */
  SINC_HIS_STAT_P3HIS2_L = 3,  /**< History Register 1, LS */
  SINC_HIS_STAT_P3HIS2_H = 4,  /**< History Register 1, MS */
  SINC_HIS_STAT_P3HIS3_L = 5,  /**< History Register 2, LS */
  SINC_HIS_STAT_P3HIS3_H = 6,  /**< History Register 2, MS */
  SINC_HIS_STAT_P3HIS0_L = 7   /**< History Register 3, LS */
} ADI_SINC_HIS_STAT_P3HISPTR;


/* ==========================================================================
 *! \struct ADI_SINC_HIS_STAT_Struct
 *! \brief  History Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_HIS_STAT_t {
  union {
    struct {
      unsigned int P0HISPTR   :  3;  /**< Pair 0 History Pointer */
      unsigned int reserved3  :  1;
      unsigned int P1HISPTR   :  3;  /**< Pair 1 History Pointer */
      unsigned int reserved7  :  1;
      unsigned int P2HISPTR   :  3;  /**< Pair 2 History Pointer */
      unsigned int reserved11 :  1;
      unsigned int P3HISPTR   :  3;  /**< Pair 3 History Pointer */
      unsigned int reserved15 : 17;
    };
    uint32_t VALUE32;
  };
} ADI_SINC_HIS_STAT_t;

/*@}*/

/** @defgroup P0SEC_HIST Pair 0 Secondary (Filter) History n Register (P0SEC_HIST) Register
 *  Pair 0 Secondary (Filter) History n Register (P0SEC_HIST) Register.
 *
 *  The P0SEC_HIST[n] read-only register provides the eight most recent samples produced by secondary SINC filter 0. The 16-bit samples are stored in the 32-bit register in circular manner, starting with the low-order field of the first P0SEC_HIST[n] register. The stored values, one compared to the limit, count, and window settings, set the STAT:MAX0 and STAT:MIN0 bits.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_P0SEC_HIST_Struct
 *! \brief  Pair 0 Secondary (Filter) History n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_P0SEC_HIST_t {
  union {
    struct {
      unsigned int LO         : 16;  /**< Low Data Word */
      unsigned int HI         : 16;  /**< High Data Word */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_P0SEC_HIST_t;

/*@}*/

/** @defgroup P1SEC_HIST Pair 1 Secondary (Filter) History n Register (P1SEC_HIST) Register
 *  Pair 1 Secondary (Filter) History n Register (P1SEC_HIST) Register.
 *
 *  The P1SEC_HIST[n] read-only register provides the eight most recent samples produced by secondary SINC filter 1. The 16-bit samples are stored in the 32-bit register in circular manner, starting with the low-order field of the first P1SEC_HIST[n] register. The stored values, compared to the limit, count, and window settings, set the STAT:MAX1 and STAT:MIN1 bits.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_P1SEC_HIST_Struct
 *! \brief  Pair 1 Secondary (Filter) History n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_P1SEC_HIST_t {
  union {
    struct {
      unsigned int LO         : 16;  /**< Low Data Word */
      unsigned int HI         : 16;  /**< High Data Word */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_P1SEC_HIST_t;

/*@}*/

/** @defgroup P2SEC_HIST Pair 2 Secondary (Filter) History n Register (P2SEC_HIST) Register
 *  Pair 2 Secondary (Filter) History n Register (P2SEC_HIST) Register.
 *
 *  The P2SEC_HIST[n] read-only register provides the eight most recent samples produced by secondary SINC filter 2. The 16-bit samples are stored in the 32-bit register in circular manner, starting with the low-order field of the first P2SEC_HIST[n] register. The stored values, compared to the limit, count, and window settings, set the STAT:MAX2 and STAT:MIN2 bits.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_P2SEC_HIST_Struct
 *! \brief  Pair 2 Secondary (Filter) History n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_P2SEC_HIST_t {
  union {
    struct {
      unsigned int LO         : 16;  /**< Low Data Word */
      unsigned int HI         : 16;  /**< High Data Word */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_P2SEC_HIST_t;

/*@}*/

/** @defgroup P3SEC_HIST Pair 3 Secondary (Filter) History n Register (P3SEC_HIST) Register
 *  Pair 3 Secondary (Filter) History n Register (P3SEC_HIST) Register.
 *
 *  The P3SEC_HIST[n] read-only register provides the eight most recent samples produced by secondary SINC filter 3. The 16-bit samples are stored in the 32-bit register in circular manner, starting with the low-order field of the first P3SEC_HIST[n] register. The stored values, compared to the limit, count, and window settings, set the STAT:MAX3 and STAT:MIN3 bits.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SINC_P3SEC_HIST_Struct
 *! \brief  Pair 3 Secondary (Filter) History n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SINC_P3SEC_HIST_t {
  union {
    struct {
      unsigned int LO         : 16;  /**< Low Data Word */
      unsigned int HI         : 16;  /**< High Data Word */
    };
    uint32_t VALUE32;
  };
} ADI_SINC_P3SEC_HIST_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL register enables ADCC operation and configures a number of ADC0 and ADC1 interface features.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable ADCC Operation */
      unsigned int TMR1EN     :  1;  /**< Timer 1 Enable */
      unsigned int DMAEN      :  1;  /**< DMA Enable */
      unsigned int SLBTESLA   :  1;  /**< Slater/Tesla Selection */
      unsigned int CSIZE      :  1;  /**< Control Data Size */
      unsigned int DSIZE      :  1;  /**< Data Size */
      unsigned int TRGOE0     :  1;  /**< Trigger Output Enable 0 */
      unsigned int TRGOE1     :  1;  /**< Trigger Output Enable 1 */
      unsigned int TRGSEL0    :  3;  /**< Trigger Select 0 */
      unsigned int TRGPOL0    :  1;  /**< Trigger Polarity 0 */
      unsigned int TRGSEL1    :  3;  /**< Trigger Select 1 */
      unsigned int TRGPOL1    :  1;  /**< Trigger Polarity 1 */
      unsigned int CKPOL0     :  1;  /**< Clock Polarity 0 */
      unsigned int CKPOL1     :  1;  /**< Clock Polarity 1 */
      unsigned int CSPOL0     :  1;  /**< Chip Select Polarity 0 */
      unsigned int CSPOL1     :  1;  /**< Chip Select Polarity 1 */
      unsigned int TIDLE0     :  1;  /**< Transmit Idle 0 */
      unsigned int TIDLE1     :  1;  /**< Transmit Idle 0 */
      unsigned int DSWP0      :  1;  /**< Data Swap 0 */
      unsigned int DSWP1      :  1;  /**< Data Swap 1 */
      unsigned int LSBF0      :  1;  /**< LSB First 0 */
      unsigned int LSBF1      :  1;  /**< LSB First 1 */
      unsigned int reserved26 :  2;
      unsigned int TRGIE0     :  1;  /**< Trigger Input Enable 0 */
      unsigned int TRGIE1     :  1;  /**< Trigger Input Enable 1 */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_CTL_t;

/*@}*/

/** @defgroup ERRSTAT Error Status Register (ERRSTAT) Register
 *  Error Status Register (ERRSTAT) Register.
 *
 *  The ERRSTAT register indicates status for errors relating to trigger overruns, bandwidth monitoring, memory responses, and events.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ERRSTAT_Struct
 *! \brief  Error Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ERRSTAT_t {
  union {
    struct {
      unsigned int TRGOV0     :  1;  /**< Trigger Overrun 0 Status */
      unsigned int TRGOV1     :  1;  /**< Trigger Overrun 1 Status */
      unsigned int BWERR0     :  1;  /**< Bandwidth Monitor Error 0 Status */
      unsigned int BWERR1     :  1;  /**< Bandwidth Monitor Error 1 Status */
      unsigned int MERR0      :  1;  /**< Memory Response Error 0 Status */
      unsigned int MERR1      :  1;  /**< Memory Response Error 1 Status */
      unsigned int ECOL       :  1;  /**< Event Collision Error Status */
      unsigned int EMIS       :  1;  /**< Event Miss Error Status */
      unsigned int DATOVF     :  1;  /**< Event data Overflow Error Status */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ERRSTAT_t;

/*@}*/

/** @defgroup ERRMSK Error Mask Register (ERRMSK) Register
 *  Error Mask Register (ERRMSK) Register.
 *
 *  The ERRMSK register masks (disables) or unmasks (enables) reporting of ADC related errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ERRMSK_Struct
 *! \brief  Error Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ERRMSK_t {
  union {
    struct {
      unsigned int TRGOV0     :  1;  /**< Trigger Overrun 0 Error Mask */
      unsigned int TRGOV1     :  1;  /**< Trigger Overrun 1 Error Mask */
      unsigned int BWERR0     :  1;  /**< Bandwidth Monitor Error 0 Mask */
      unsigned int BWERR1     :  1;  /**< Bandwidth Monitor Error 1 Mask */
      unsigned int MERR0      :  1;  /**< Memory Response Error 0 Mask */
      unsigned int MERR1      :  1;  /**< Memory Response Error 1 Mask */
      unsigned int ECOL       :  1;  /**< Event Collision Error Mask */
      unsigned int EMIS       :  1;  /**< Event Miss Error Mask */
      unsigned int DATOVF     :  1;  /**< Event data Overflow Error Mask */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ERRMSK_t;

/*@}*/

/** @defgroup ERRMSK_SET Error Mask Set Register (ERRMSK_SET) Register
 *  Error Mask Set Register (ERRMSK_SET) Register.
 *
 *  The ERRMSK_SET register can be used to selectively set bits in the ERRMSK register without affecting other bits in the register. Writing a 1 to any bit position in ERRMSK_SET sets the corresponding bit in ERRMSK. Reading the ERRMSK_SET register returns the data present in the ERRMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ERRMSK_SET_Struct
 *! \brief  Error Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ERRMSK_SET_t {
  union {
    struct {
      unsigned int TRGOV0     :  1;  /**< Trigger Overrun 0 Mask Set */
      unsigned int TRGOV1     :  1;  /**< Trigger Overrun 1 Mask Set */
      unsigned int BWERR0     :  1;  /**< Bandwidth Monitor Error 0 Mask Set */
      unsigned int BWERR1     :  1;  /**< Bandwidth Monitor Error 1 Mask Set */
      unsigned int MERR0      :  1;  /**< Memory Response Error 0 Mask Set */
      unsigned int MERR1      :  1;  /**< Memory Response Error 1 Mask Set */
      unsigned int ECOL       :  1;  /**< Event Collision Error Mask Set */
      unsigned int EMIS       :  1;  /**< Event Miss Error Mask Set */
      unsigned int DATOVF     :  1;  /**< Event data Overflow Error Mask Set */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ERRMSK_SET_t;

/*@}*/

/** @defgroup ERRMSK_CLR Error Mask Clear Register (ERRMSK_CLR) Register
 *  Error Mask Clear Register (ERRMSK_CLR) Register.
 *
 *  The ERRMSK_CLR register can be used to selectively clear bits in the ERRMSK register without affecting other bits in the register. Writing a 1 to any bit position in ERRMSK_CLR clears the corresponding bit in ERRMSK. Reading the ERRMSK_CLR register returns the data present in the ERRMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ERRMSK_CLR_Struct
 *! \brief  Error Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ERRMSK_CLR_t {
  union {
    struct {
      unsigned int TRGOV0     :  1;  /**< Trigger Overrun 0 Mask Clear */
      unsigned int TRGOV1     :  1;  /**< Trigger Overrun 1 Mask Clear */
      unsigned int BWERR0     :  1;  /**< Bandwidth Monitor Error 0 Mask Clear */
      unsigned int BWERR1     :  1;  /**< Bandwidth Monitor Error 1 Mask Clear */
      unsigned int MERR0      :  1;  /**< Memory Response Error 0 Mask Clear */
      unsigned int MERR1      :  1;  /**< Memory Response Error 1 Mask Clear */
      unsigned int ECOL       :  1;  /**< Event Collision Error Mask Clear */
      unsigned int EMIS       :  1;  /**< Event Miss Error Mask Clear */
      unsigned int DATOVF     :  1;  /**< Event data OVerflow Error Mask Clear */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ERRMSK_CLR_t;

/*@}*/

/** @defgroup EISTAT Event Interrupt Status Register (EISTAT) Register
 *  Event Interrupt Status Register (EISTAT) Register.
 *
 *  The EISTAT register indicates the interrupt status bits for ADCC events. Based on the EVCTLnn:TMRSEL bit selection, the ADCC generates the corresponding TMR0_EVT or TMR1_EVT event interrupts. Each of these interrupts can be optionally masked (disable interrupt output) using the bits in EIMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EISTAT_Struct
 *! \brief  Event Interrupt Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EISTAT_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Interrupt */
      unsigned int EVT01      :  1;  /**< Event n Interrupt */
      unsigned int EVT02      :  1;  /**< Event n Interrupt */
      unsigned int EVT03      :  1;  /**< Event n Interrupt */
      unsigned int EVT04      :  1;  /**< Event n Interrupt */
      unsigned int EVT05      :  1;  /**< Event n Interrupt */
      unsigned int EVT06      :  1;  /**< Event n Interrupt */
      unsigned int EVT07      :  1;  /**< Event n Interrupt */
      unsigned int EVT08      :  1;  /**< Event n Interrupt */
      unsigned int EVT09      :  1;  /**< Event n Interrupt */
      unsigned int EVT10      :  1;  /**< Event n Interrupt */
      unsigned int EVT11      :  1;  /**< Event n Interrupt */
      unsigned int EVT12      :  1;  /**< Event n Interrupt */
      unsigned int EVT13      :  1;  /**< Event n Interrupt */
      unsigned int EVT14      :  1;  /**< Event n Interrupt */
      unsigned int EVT15      :  1;  /**< Event n Interrupt */
      unsigned int EVT16      :  1;  /**< Event n Interrupt */
      unsigned int EVT17      :  1;  /**< Event n Interrupt */
      unsigned int EVT18      :  1;  /**< Event n Interrupt */
      unsigned int EVT19      :  1;  /**< Event n Interrupt */
      unsigned int EVT20      :  1;  /**< Event n Interrupt */
      unsigned int EVT21      :  1;  /**< Event n Interrupt */
      unsigned int EVT22      :  1;  /**< Event n Interrupt */
      unsigned int EVT23      :  1;  /**< Event n Interrupt */
      unsigned int EVT24      :  1;  /**< Event n Interrupt */
      unsigned int EVT25      :  1;  /**< Event n Interrupt */
      unsigned int EVT26      :  1;  /**< Event n Interrupt */
      unsigned int EVT27      :  1;  /**< Event n Interrupt */
      unsigned int EVT28      :  1;  /**< Event n Interrupt */
      unsigned int EVT29      :  1;  /**< Event n Interrupt */
      unsigned int EVT30      :  1;  /**< Event n Interrupt */
      unsigned int EVT31      :  1;  /**< Event n Interrupt */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EISTAT_t;

/*@}*/

/** @defgroup EIMSK Event Interrupt Mask Register (EIMSK) Register
 *  Event Interrupt Mask Register (EIMSK) Register.
 *
 *  The EIMSK register masks (disables) generation of TMR0_EVT or TMR1_EVT event interrupts based on status in the EISTAT register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EIMSK_Struct
 *! \brief  Event Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EIMSK_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT01      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT02      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT03      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT04      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT05      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT06      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT07      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT08      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT09      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT10      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT11      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT12      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT13      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT14      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT15      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT16      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT17      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT18      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT19      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT20      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT21      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT22      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT23      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT24      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT25      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT26      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT27      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT28      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT29      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT30      :  1;  /**< Event n Interrupt Mask */
      unsigned int EVT31      :  1;  /**< Event n Interrupt Mask */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EIMSK_t;

/*@}*/

/** @defgroup EIMSK_SET Event Interrupt Mask Set Register (EIMSK_SET) Register
 *  Event Interrupt Mask Set Register (EIMSK_SET) Register.
 *
 *  The EIMSK_SET register can be used to selectively set bits in the EIMSK register without affecting other bits in the register. Writing a 1 to any bit position in EIMSK_SET sets the corresponding bit in EIMSK. Reading the EIMSK_SET register returns the data present in the EIMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EIMSK_SET_Struct
 *! \brief  Event Interrupt Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EIMSK_SET_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT01      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT02      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT03      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT04      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT05      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT06      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT07      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT08      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT09      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT10      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT11      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT12      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT13      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT14      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT15      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT16      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT17      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT18      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT19      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT20      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT21      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT22      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT23      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT24      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT25      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT26      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT27      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT28      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT29      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT30      :  1;  /**< Event n Interrupt Mask Set */
      unsigned int EVT31      :  1;  /**< Event n Interrupt Mask Set */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EIMSK_SET_t;

/*@}*/

/** @defgroup EIMSK_CLR Event Interrupt Mask Clear Register (EIMSK_CLR) Register
 *  Event Interrupt Mask Clear Register (EIMSK_CLR) Register.
 *
 *  The EIMSK_CLR register can be used to selectively clear bits in the EIMSK register without affecting other bits in the register. Writing a 1 to any bit position in EIMSK_CLR clears the corresponding bit in EIMSK. Reading the EIMSK_CLR register returns the data present in the EIMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EIMSK_CLR_Struct
 *! \brief  Event Interrupt Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EIMSK_CLR_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT01      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT02      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT03      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT04      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT05      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT06      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT07      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT08      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT09      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT10      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT11      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT12      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT13      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT14      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT15      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT16      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT17      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT18      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT19      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT20      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT21      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT22      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT23      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT24      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT25      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT26      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT27      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT28      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT29      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT30      :  1;  /**< Event n Interrupt Mask Clear */
      unsigned int EVT31      :  1;  /**< Event n Interrupt Mask Clear */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EIMSK_CLR_t;

/*@}*/

/** @defgroup FISTAT Frame Interrupt Status Register (FISTAT) Register
 *  Frame Interrupt Status Register (FISTAT) Register.
 *
 *  The FISTAT register indicates frame interrupt status. The ADCC generates interrupts corresponding to Timer 0 on the TMR0_EVT output and generates the interrupts corresponding to Timer 1 on the TMR1_EVT output.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_FISTAT_Struct
 *! \brief  Frame Interrupt Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_FISTAT_t {
  union {
    struct {
      unsigned int FINT0      :  1;  /**< Frame Interrupt 0 */
      unsigned int FINT1      :  1;  /**< Frame Interrupt 1 */
      unsigned int LFINT0     :  1;  /**< Last Frame Interrupt 0 */
      unsigned int LFINT1     :  1;  /**< Last Frame Interrupt 1 */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_FISTAT_t;

/*@}*/

/** @defgroup FIMSK Frame Interrupt Mask Register (FIMSK) Register
 *  Frame Interrupt Mask Register (FIMSK) Register.
 *
 *  The FIMSK register masks (disables) generation of TMR0_EVT or TMR1_EVT event interrupts based on status in the FISTAT register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_FIMSK_Struct
 *! \brief  Frame Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_FIMSK_t {
  union {
    struct {
      unsigned int FINT0      :  1;  /**< Frame Interrupt 0 Mask */
      unsigned int FINT1      :  1;  /**< Frame Interrupt 1 Mask */
      unsigned int LFINT0     :  1;  /**< Last Frame Interrupt 0 Mask */
      unsigned int LFINT1     :  1;  /**< Last Frame Interrupt 1 Mask */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_FIMSK_t;

/*@}*/

/** @defgroup FIMSK_SET Frame Interrupt Mask Set Register (FIMSK_SET) Register
 *  Frame Interrupt Mask Set Register (FIMSK_SET) Register.
 *
 *  The FIMSK_SET register can be used to selectively set bits in the FIMSK register without affecting other bits in the register. Writing a 1 to any bit position in FIMSK_SET sets the corresponding bit in FIMSK. Reading the FIMSK_SET register returns the data present in the FIMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_FIMSK_SET_Struct
 *! \brief  Frame Interrupt Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_FIMSK_SET_t {
  union {
    struct {
      unsigned int FINT0      :  1;  /**< Frame Interrupt 0 Mask Set */
      unsigned int FINT1      :  1;  /**< Frame Interrupt 1 Mask Set */
      unsigned int LFINT0     :  1;  /**< Last Frame Interrupt 0 Mask */
      unsigned int LFINT1     :  1;  /**< Last Frame Interrupt 1 Mask */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_FIMSK_SET_t;

/*@}*/

/** @defgroup FIMSK_CLR Frame Interrupt Mask Clear Register (FIMSK_CLR) Register
 *  Frame Interrupt Mask Clear Register (FIMSK_CLR) Register.
 *
 *  The FIMSK_CLR register can be used to selectively clear bits in the FIMSK register without affecting other bits in the register. Writing a 1 to any bit position in FIMSK_CLR clears the corresponding bit in FIMSK. Reading the FIMSK_CLR register returns the data present in the FIMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_FIMSK_CLR_Struct
 *! \brief  Frame Interrupt Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_FIMSK_CLR_t {
  union {
    struct {
      unsigned int FINT0      :  1;  /**< Frame Interrupt 0 Mask Clear */
      unsigned int FINT1      :  1;  /**< Frame Interrupt 1 Mask Clear */
      unsigned int LFINT0     :  1;  /**< Last Frame Interrupt 0 Mask */
      unsigned int LFINT1     :  1;  /**< Last Frame Interrupt 1 Mask */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_FIMSK_CLR_t;

/*@}*/

/** @defgroup EVTEN Event Enable Register (EVTEN) Register
 *  Event Enable Register (EVTEN) Register.
 *
 *  The EVTEN register enables detection of individual ADCC events. Based on the EVCTLnn:TMRSEL bit selection, the ADCC generates the corresponding TMR0_EVT or TMR0_EVT event interrupts. Note that the events corresponding to a frame must be enabled before the trigger corresponding to the frame arrives.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVTEN_Struct
 *! \brief  Event Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVTEN_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Enable */
      unsigned int EVT01      :  1;  /**< Event n Enable */
      unsigned int EVT02      :  1;  /**< Event n Enable */
      unsigned int EVT03      :  1;  /**< Event n Enable */
      unsigned int EVT04      :  1;  /**< Event n Enable */
      unsigned int EVT05      :  1;  /**< Event n Enable */
      unsigned int EVT06      :  1;  /**< Event n Enable */
      unsigned int EVT07      :  1;  /**< Event n Enable */
      unsigned int EVT08      :  1;  /**< Event n Enable */
      unsigned int EVT09      :  1;  /**< Event n Enable */
      unsigned int EVT10      :  1;  /**< Event n Enable */
      unsigned int EVT11      :  1;  /**< Event n Enable */
      unsigned int EVT12      :  1;  /**< Event n Enable */
      unsigned int EVT13      :  1;  /**< Event n Enable */
      unsigned int EVT14      :  1;  /**< Event n Enable */
      unsigned int EVT15      :  1;  /**< Event n Enable */
      unsigned int EVT16      :  1;  /**< Event n Enable */
      unsigned int EVT17      :  1;  /**< Event n Enable */
      unsigned int EVT18      :  1;  /**< Event n Enable */
      unsigned int EVT19      :  1;  /**< Event n Enable */
      unsigned int EVT20      :  1;  /**< Event n Enable */
      unsigned int EVT21      :  1;  /**< Event n Enable */
      unsigned int EVT22      :  1;  /**< Event n Enable */
      unsigned int EVT23      :  1;  /**< Event n Enable */
      unsigned int EVT24      :  1;  /**< Event n Enable */
      unsigned int EVT25      :  1;  /**< Event n Enable */
      unsigned int EVT26      :  1;  /**< Event n Enable */
      unsigned int EVT27      :  1;  /**< Event n Enable */
      unsigned int EVT28      :  1;  /**< Event n Enable */
      unsigned int EVT29      :  1;  /**< Event n Enable */
      unsigned int EVT30      :  1;  /**< Event n Enable */
      unsigned int EVT31      :  1;  /**< Event n Enable */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVTEN_t;

/*@}*/

/** @defgroup EVTEN_SET Event Enable Set Register (EVTEN_SET) Register
 *  Event Enable Set Register (EVTEN_SET) Register.
 *
 *  The EVTEN_SET register can be used to selectively set bits in the EVTEN register without affecting other bits in the register. Writing a 1 to any bit position in EVTEN_SET sets the corresponding bit in EVTEN. Reading the EVTEN_SET register returns the data present in the EVTEN register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVTEN_SET_Struct
 *! \brief  Event Enable Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVTEN_SET_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Enable Set */
      unsigned int EVT01      :  1;  /**< Event n Enable Set */
      unsigned int EVT02      :  1;  /**< Event n Enable Set */
      unsigned int EVT03      :  1;  /**< Event n Enable Set */
      unsigned int EVT04      :  1;  /**< Event n Enable Set */
      unsigned int EVT05      :  1;  /**< Event n Enable Set */
      unsigned int EVT06      :  1;  /**< Event n Enable Set */
      unsigned int EVT07      :  1;  /**< Event n Enable Set */
      unsigned int EVT08      :  1;  /**< Event n Enable Set */
      unsigned int EVT09      :  1;  /**< Event n Enable Set */
      unsigned int EVT10      :  1;  /**< Event n Enable Set */
      unsigned int EVT11      :  1;  /**< Event n Enable Set */
      unsigned int EVT12      :  1;  /**< Event n Enable Set */
      unsigned int EVT13      :  1;  /**< Event n Enable Set */
      unsigned int EVT14      :  1;  /**< Event n Enable Set */
      unsigned int EVT15      :  1;  /**< Event n Enable Set */
      unsigned int EVT16      :  1;  /**< Event n Enable Set */
      unsigned int EVT17      :  1;  /**< Event n Enable Set */
      unsigned int EVT18      :  1;  /**< Event n Enable Set */
      unsigned int EVT19      :  1;  /**< Event n Enable Set */
      unsigned int EVT20      :  1;  /**< Event n Enable Set */
      unsigned int EVT21      :  1;  /**< Event n Enable Set */
      unsigned int EVT22      :  1;  /**< Event n Enable Set */
      unsigned int EVT23      :  1;  /**< Event n Enable Set */
      unsigned int EVT24      :  1;  /**< Event n Enable Set */
      unsigned int EVT25      :  1;  /**< Event n Enable Set */
      unsigned int EVT26      :  1;  /**< Event n Enable Set */
      unsigned int EVT27      :  1;  /**< Event n Enable Set */
      unsigned int EVT28      :  1;  /**< Event n Enable Set */
      unsigned int EVT29      :  1;  /**< Event n Enable Set */
      unsigned int EVT30      :  1;  /**< Event n Enable Set */
      unsigned int EVT31      :  1;  /**< Event n Enable Set */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVTEN_SET_t;

/*@}*/

/** @defgroup EVTEN_CLR Event Enable Clear Register (EVTEN_CLR) Register
 *  Event Enable Clear Register (EVTEN_CLR) Register.
 *
 *  The EVTEN_CLR register can be used to selectively clear bits in the EVTEN register without affecting other bits in the register. Writing a 1 to any bit position in EVTEN_CLR clears the corresponding bit in EVTEN. Reading the EVTEN_CLR register returns the data present in the EVTEN register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVTEN_CLR_Struct
 *! \brief  Event Enable Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVTEN_CLR_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Enable Clear */
      unsigned int EVT01      :  1;  /**< Event n Enable Clear */
      unsigned int EVT02      :  1;  /**< Event n Enable Clear */
      unsigned int EVT03      :  1;  /**< Event n Enable Clear */
      unsigned int EVT04      :  1;  /**< Event n Enable Clear */
      unsigned int EVT05      :  1;  /**< Event n Enable Clear */
      unsigned int EVT06      :  1;  /**< Event n Enable Clear */
      unsigned int EVT07      :  1;  /**< Event n Enable Clear */
      unsigned int EVT08      :  1;  /**< Event n Enable Clear */
      unsigned int EVT09      :  1;  /**< Event n Enable Clear */
      unsigned int EVT10      :  1;  /**< Event n Enable Clear */
      unsigned int EVT11      :  1;  /**< Event n Enable Clear */
      unsigned int EVT12      :  1;  /**< Event n Enable Clear */
      unsigned int EVT13      :  1;  /**< Event n Enable Clear */
      unsigned int EVT14      :  1;  /**< Event n Enable Clear */
      unsigned int EVT15      :  1;  /**< Event n Enable Clear */
      unsigned int EVT16      :  1;  /**< Event n Enable Clear */
      unsigned int EVT17      :  1;  /**< Event n Enable Clear */
      unsigned int EVT18      :  1;  /**< Event n Enable Clear */
      unsigned int EVT19      :  1;  /**< Event n Enable Clear */
      unsigned int EVT20      :  1;  /**< Event n Enable Clear */
      unsigned int EVT21      :  1;  /**< Event n Enable Clear */
      unsigned int EVT22      :  1;  /**< Event n Enable Clear */
      unsigned int EVT23      :  1;  /**< Event n Enable Clear */
      unsigned int EVT24      :  1;  /**< Event n Enable Clear */
      unsigned int EVT25      :  1;  /**< Event n Enable Clear */
      unsigned int EVT26      :  1;  /**< Event n Enable Clear */
      unsigned int EVT27      :  1;  /**< Event n Enable Clear */
      unsigned int EVT28      :  1;  /**< Event n Enable Clear */
      unsigned int EVT29      :  1;  /**< Event n Enable Clear */
      unsigned int EVT30      :  1;  /**< Event n Enable Clear */
      unsigned int EVT31      :  1;  /**< Event n Enable Clear */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVTEN_CLR_t;

/*@}*/

/** @defgroup ECOL Event Collision Status Register (ECOL) Register
 *  Event Collision Status Register (ECOL) Register.
 *
 *  The ECOL register indicates the collision status for ADCC events. When any bit in this register is set, the ERRSTAT:ECOL bit is set, which may optionally cause the ADCC to generate output on the ERR pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ECOL_Struct
 *! \brief  Event Collision Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ECOL_t {
  union {
    struct {
      unsigned int EVT0       :  1;  /**< Event n Collision Status */
      unsigned int EVT1       :  1;  /**< Event n Collision Status */
      unsigned int EVT2       :  1;  /**< Event n Collision Status */
      unsigned int EVT3       :  1;  /**< Event n Collision Status */
      unsigned int EVT4       :  1;  /**< Event n Collision Status */
      unsigned int EVT5       :  1;  /**< Event n Collision Status */
      unsigned int EVT6       :  1;  /**< Event n Collision Status */
      unsigned int EVT7       :  1;  /**< Event n Collision Status */
      unsigned int EVT8       :  1;  /**< Event n Collision Status */
      unsigned int EVT9       :  1;  /**< Event n Collision Status */
      unsigned int EVT10      :  1;  /**< Event n Collision Status */
      unsigned int EVT11      :  1;  /**< Event n Collision Status */
      unsigned int EVT12      :  1;  /**< Event n Collision Status */
      unsigned int EVT13      :  1;  /**< Event n Collision Status */
      unsigned int EVT14      :  1;  /**< Event n Collision Status */
      unsigned int EVT15      :  1;  /**< Event n Collision Status */
      unsigned int EVT16      :  1;  /**< Event n Collision Status */
      unsigned int EVT17      :  1;  /**< Event n Collision Status */
      unsigned int EVT18      :  1;  /**< Event n Collision Status */
      unsigned int EVT19      :  1;  /**< Event n Collision Status */
      unsigned int EVT20      :  1;  /**< Event n Collision Status */
      unsigned int EVT21      :  1;  /**< Event n Collision Status */
      unsigned int EVT22      :  1;  /**< Event n Collision Status */
      unsigned int EVT23      :  1;  /**< Event n Collision Status */
      unsigned int EVT24      :  1;  /**< Event n Collision Status */
      unsigned int EVT25      :  1;  /**< Event n Collision Status */
      unsigned int EVT26      :  1;  /**< Event n Collision Status */
      unsigned int EVT27      :  1;  /**< Event n Collision Status */
      unsigned int EVT28      :  1;  /**< Event n Collision Status */
      unsigned int EVT29      :  1;  /**< Event n Collision Status */
      unsigned int EVT30      :  1;  /**< Event n Collision Status */
      unsigned int EVT31      :  1;  /**< Event n Collision Status */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ECOL_t;

/*@}*/

/** @defgroup EMISS Event Miss Status Register (EMISS) Register
 *  Event Miss Status Register (EMISS) Register.
 *
 *  The EMISS register indicates the miss status for ADCC events. When any bit in this register is set, the ERRSTAT:EMIS bit is set, which may optionally cause the ADCC to generate output on the ERR pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EMISS_Struct
 *! \brief  Event Miss Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EMISS_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Miss Status */
      unsigned int EVT01      :  1;  /**< Event n Miss Status */
      unsigned int EVT02      :  1;  /**< Event n Miss Status */
      unsigned int EVT03      :  1;  /**< Event n Miss Status */
      unsigned int EVT04      :  1;  /**< Event n Miss Status */
      unsigned int EVT05      :  1;  /**< Event n Miss Status */
      unsigned int EVT06      :  1;  /**< Event n Miss Status */
      unsigned int EVT07      :  1;  /**< Event n Miss Status */
      unsigned int EVT08      :  1;  /**< Event n Miss Status */
      unsigned int EVT09      :  1;  /**< Event n Miss Status */
      unsigned int EVT10      :  1;  /**< Event n Miss Status */
      unsigned int EVT11      :  1;  /**< Event n Miss Status */
      unsigned int EVT12      :  1;  /**< Event n Miss Status */
      unsigned int EVT13      :  1;  /**< Event n Miss Status */
      unsigned int EVT14      :  1;  /**< Event n Miss Status */
      unsigned int EVT15      :  1;  /**< Event n Miss Status */
      unsigned int EVT16      :  1;  /**< Event n Miss Status */
      unsigned int EVT17      :  1;  /**< Event n Miss Status */
      unsigned int EVT18      :  1;  /**< Event n Miss Status */
      unsigned int EVT19      :  1;  /**< Event n Miss Status */
      unsigned int EVT20      :  1;  /**< Event n Miss Status */
      unsigned int EVT21      :  1;  /**< Event n Miss Status */
      unsigned int EVT22      :  1;  /**< Event n Miss Status */
      unsigned int EVT23      :  1;  /**< Event n Miss Status */
      unsigned int EVT24      :  1;  /**< Event n Miss Status */
      unsigned int EVT25      :  1;  /**< Event n Miss Status */
      unsigned int EVT26      :  1;  /**< Event n Miss Status */
      unsigned int EVT27      :  1;  /**< Event n Miss Status */
      unsigned int EVT28      :  1;  /**< Event n Miss Status */
      unsigned int EVT29      :  1;  /**< Event n Miss Status */
      unsigned int EVT30      :  1;  /**< Event n Miss Status */
      unsigned int EVT31      :  1;  /**< Event n Miss Status */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EMISS_t;

/*@}*/

/** @defgroup BPTR0 Base Pointer 0 Register (BPTR0) Register
 *  Base Pointer 0 Register (BPTR0) Register.
 *
 *  The BPTR0 register provides the base pointer (address) used for placing the first Timer 0 frame's event-data into memory through DMA. The value of base address (pointer) in the BPTR0 register at the time of the trigger pulse (start of frame) corresponds to one of the following Timer 0 related frames:
 *  $[ul$]$[li$]The first frame after ADCC is enabled
 *  $[/li$]$[li$]The first frame after the BPTR0 register is written by core (in linear DMA mode)
 *  $[/li$]$[li$]The first frame after a loop back occurs in circular buffering mode
 *  $[/li$]$[/ul$]The data from the first frame's events is placed in memory, starting at the address indicated with the value of the frame base address. Each of the event data are placed in a location (BPTR0 + EVCTLnn:EVTOFS), where EVCTLnn:EVTOFS is a programmable offset for each event.
 *   The second frame's base address (pointer) is calculated as (BPTR0 + FRINC0).
 *  The third frame's base address (pointer) is calculated as (BPTR0 + (2 x FRINC0)).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_BPTR0_Struct
 *! \brief  Base Pointer 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_BPTR0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Base Pointer 0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_BPTR0_t;

/*@}*/

/** @defgroup FRINC0 Frame Increment 0 Register (FRINC0) Register
 *  Frame Increment 0 Register (FRINC0) Register.
 *
 *  The FRINC0 register contains the address increment applied between the base-address of consecutive Timer 0 frames of DMA data (unless a fresh write of the BPTR0 register occurred in between). The value is a signed, two's complement byte address increment.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_FRINC0_Struct
 *! \brief  Frame Increment 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_FRINC0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Frame Increment 0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_FRINC0_t;

/*@}*/

/** @defgroup CBSIZ0 Circular Buffer Size 0 Register (CBSIZ0) Register
 *  Circular Buffer Size 0 Register (CBSIZ0) Register.
 *
 *  The CBSIZ0 register holds the circular buffer size to be used for the Timer 0 frames of DMA. If the VALUE bit field is programmed as 0, the ADCC performs only linear buffering is for the Timer 0 frames. For more information about ADCC linear and circular buffering, see the ADCC functional description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_CBSIZ0_Struct
 *! \brief  Circular Buffer Size 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_CBSIZ0_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Circular Buffer Size 0 Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_CBSIZ0_t;

/*@}*/

/** @defgroup TCA0 Timing Control A (ADC0) Register (TCA0) Register
 *  Timing Control A (ADC0) Register (TCA0) Register.
 *
 *  The TCA0 register controls timing related to the ADC0 interface clock and chip select signals.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TCA0_Struct
 *! \brief  Timing Control A (ADC0) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TCA0_t {
  union {
    struct {
      unsigned int CKDIV      : 16;  /**< Clock Divisor */
      unsigned int NCK        :  4;  /**< Number of Clocks */
      unsigned int SYNCCK     :  1;  /**< Enable bit for Clock synchronization based on trigger */
      unsigned int CKTRGRE    :  1;  /**< Trigger polarity for SYNCCK feature */
      unsigned int reserved22 :  2;
      unsigned int CKTRGSEL   :  3;  /**< Trigger selection for SYNCCK feature */
      unsigned int reserved27 :  5;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TCA0_t;

/*@}*/

/** @defgroup TCB0 Timing Control B (ADC0) Register (TCB0) Register
 *  Timing Control B (ADC0) Register (TCB0) Register.
 *
 *  The TCB0 register controls parameter values for timing relationships between the ACS and ACLK pin signals in the ADC0 interface. For a timing diagram illustrating these timing relationships, see the ADCC functional description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TCB0_Struct
 *! \brief  Timing Control B (ADC0) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TCB0_t {
  union {
    struct {
      unsigned int TCSCK      :  8;  /**< Time CS to CK Setup */
      unsigned int TCKCS      :  8;  /**< Time CK to CS Hold */
      unsigned int TCSCS      :  8;  /**< Timing CS to CS Delay */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TCB0_t;

/*@}*/

/** @defgroup BWMON0 Bandwidth Monitor 0 Register (BWMON0) Register
 *  Bandwidth Monitor 0 Register (BWMON0) Register.
 *
 *  The BWMON0 register monitors the Timer 0 count and can be used to signal an error if the count exceeds the CNT value in DMA mode. This checks whether the DMA transfer of all events in the frame are completed before a certain count of the timer. To monitor for completion of all events and their DMA before n SCLK cycles after the trigger, program the value n in the CNT field. When the timer count exceeds n, the ADCC issues an error interrupt and indicates the status with the ERRSTAT:BWERR0 bit. The Timer stops only when all DMA transfers are complete and responses received, in DMA mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_BWMON0_Struct
 *! \brief  Bandwidth Monitor 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_BWMON0_t {
  union {
    struct {
      unsigned int CNT        : 32;  /**< Bandwidth Monitor Count */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_BWMON0_t;

/*@}*/

/** @defgroup BPTR1 DMA Base Pointer 1 Register (BPTR1) Register
 *  DMA Base Pointer 1 Register (BPTR1) Register.
 *
 *  The BPTR1 register provides the base pointer (address) used for placing the first Timer 1 frame's event-data into memory through DMA. The value of base address (pointer) in the BPTR1 register at the time of the trigger pulse (start of frame) corresponds to one of the following Timer 1 related frames:
 *  $[ul$]$[li$]The first frame after ADCC is enabled
 *  $[/li$]$[li$]The first frame after the BPTR1 register is written by core (in linear DMA mode)
 *  $[/li$]$[li$]The first frame after a loop back occurs in circular buffering mode
 *  $[/li$]$[/ul$]The data from the first frame's events is placed in memory, starting at the address indicated with the value of the frame base address. Each of the event data are placed in a location (BPTR1 + EVCTLnn:EVTOFS), where EVCTLnn:EVTOFS is a programmable offset for each event.
 *   The second frame's base address (pointer) is calculated as (BPTR1 + FRINC0).
 *  The third frame's base address (pointer) is calculated as (BPTR1 + (2 x FRINC0)).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_BPTR1_Struct
 *! \brief  DMA Base Pointer 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_BPTR1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Base Pointer 1 Value */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_BPTR1_t;

/*@}*/

/** @defgroup FRINC1 Frame Increment 1 Register (FRINC1) Register
 *  Frame Increment 1 Register (FRINC1) Register.
 *
 *  The FRINC1 register contains the address increment applied between the base-address of consecutive Timer 1 frames of DMA data (unless a fresh write of the BPTR0 register occurred in between). The value is a signed, two's complement byte address increment.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_FRINC1_Struct
 *! \brief  Frame Increment 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_FRINC1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Frame Increment 1 Value */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_FRINC1_t;

/*@}*/

/** @defgroup CBSIZ1 Circular Buffer Size 1 Register (CBSIZ1) Register
 *  Circular Buffer Size 1 Register (CBSIZ1) Register.
 *
 *  The CBSIZ1 register holds the circular buffer size to be used for the Timer 1 frames of DMA. If the VALUE bit field is programmed as 0, the ADCC performs only linear buffering is for the Timer 1 frames. For more information about ADCC linear and circular buffering, see the ADCC functional description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_CBSIZ1_Struct
 *! \brief  Circular Buffer Size 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_CBSIZ1_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Circular Buffer Size 1 Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_CBSIZ1_t;

/*@}*/

/** @defgroup TCA1 Timing Control A (ADC1) Register (TCA1) Register
 *  Timing Control A (ADC1) Register (TCA1) Register.
 *
 *  The TCA1 register controls timing related to the ADC1 interface clock and chip select signals.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TCA1_Struct
 *! \brief  Timing Control A (ADC1) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TCA1_t {
  union {
    struct {
      unsigned int CKDIV      : 16;  /**< Clock Divisor */
      unsigned int NCK        :  4;  /**< Number of Clocks */
      unsigned int SYNCCK     :  1;  /**< Enable bit for Clock synchronization based on trigger */
      unsigned int CKTRGRE    :  1;  /**< Trigger polarity for SYNCCK feature */
      unsigned int reserved22 :  2;
      unsigned int CKTRGSEL   :  3;  /**< Trigger selection for SYNCCK feature */
      unsigned int reserved27 :  5;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TCA1_t;

/*@}*/

/** @defgroup TCB1 Timing Control B (ADC1) Register (TCB1) Register
 *  Timing Control B (ADC1) Register (TCB1) Register.
 *
 *  The TCB1 register controls parameter values for timing relationships between the BCS and BCLK pin signals in the BDC0 interface. For a timing diagram illustrating these timing relationships, see the ADCC functional description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TCB1_Struct
 *! \brief  Timing Control B (ADC1) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TCB1_t {
  union {
    struct {
      unsigned int TCSCK      :  8;  /**< Time CS to CK Setup */
      unsigned int TCKCS      :  8;  /**< Time CK to CS Hold */
      unsigned int TCSCS      :  8;  /**< Timing CS to CS Delay */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TCB1_t;

/*@}*/

/** @defgroup BWMON1 Bandwidth Monitor 1 Register (BWMON1) Register
 *  Bandwidth Monitor 1 Register (BWMON1) Register.
 *
 *  The BWMON1 register monitors the Timer 1 count and can be used to signal an error if the count exceeds the CNT value in DMA mode. This checks whether the DMA transfer of all events in the frame are completed before a certain count of the timer. To monitor for completion of all events and their DMA before n SCLK cycles after the trigger, program the value n in the CNT field. When the timer count exceeds n, the ADCC issues an error interrupt and indicates the status with the ERRSTAT:BWERR1 bit. The Timer stops only when all DMA transfers are complete and responses received, in DMA mode.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_BWMON1_Struct
 *! \brief  Bandwidth Monitor 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_BWMON1_t {
  union {
    struct {
      unsigned int CNT        : 32;  /**< Bandwidth Monitor Count */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_BWMON1_t;

/*@}*/

/** @defgroup NUMFRAM0 Timer0 Frame Limit count for firing FINT0 (NUMFRAM0) Register
 *  Timer0 Frame Limit count for firing FINT0 (NUMFRAM0) Register.
 *
 *  The NUMFRAM0 register allows programming number of TIMER0 frames before LFINT0.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_NUMFRAM0_Struct
 *! \brief  Timer0 Frame Limit count for firing FINT0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_NUMFRAM0_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Number of TIMER frames after which FINT gets fired */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_NUMFRAM0_t;

/*@}*/

/** @defgroup NUMFRAM1 Timer1 Frame Limit count for firing FINT1 (NUMFRAM1) Register
 *  Timer1 Frame Limit count for firing FINT1 (NUMFRAM1) Register.
 *
 *  The NUMFRAM1 register allows programming number of TIMER1 frames before LFINT0.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_NUMFRAM1_Struct
 *! \brief  Timer1 Frame Limit count for firing FINT1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_NUMFRAM1_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Number of TIMER frames after which FINT gets fired */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_NUMFRAM1_t;

/*@}*/

/** @defgroup DATOVF Data overflow indication register (DATOVF) Register
 *  Data overflow indication register (DATOVF) Register.
 *
 *  The DATOVF register indicates the overflow status of various events
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_DATOVF_Struct
 *! \brief  Data overflow indication Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_DATOVF_t {
  union {
    struct {
      unsigned int EVT0       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT1       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT2       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT3       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT4       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT5       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT6       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT7       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT8       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT9       :  1;  /**< Event n data Overflow Status */
      unsigned int EVT10      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT11      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT12      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT13      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT14      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT15      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT16      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT17      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT18      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT19      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT20      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT21      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT22      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT23      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT24      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT25      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT26      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT27      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT28      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT29      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT30      :  1;  /**< Event n data Overflow Status */
      unsigned int EVT31      :  1;  /**< Event n data Overflow Status */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_DATOVF_t;

/*@}*/

/** @defgroup EPND Pending Events Status Register (EPND) Register
 *  Pending Events Status Register (EPND) Register.
 *
 *  The EPND register indicates which events within the current frames are pending (waiting for data transfer). Each of the EVTnn bits from 0 to 23 corresponds to an events from 0 to 23. When the trigger pulse initiating a frame (corresponding to a Timer) is detected, all the status pending bits corresponding to enabled events in that frame are set. The ADCC clears each status bit on receiving the data from ADC for the corresponding event. If a pending event is missed, the ADCC clears the corresponding status bit.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EPND_Struct
 *! \brief  Pending Events Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EPND_t {
  union {
    struct {
      unsigned int EVT00      :  1;  /**< Event n Pending Status */
      unsigned int EVT01      :  1;  /**< Event n Pending Status */
      unsigned int EVT02      :  1;  /**< Event n Pending Status */
      unsigned int EVT03      :  1;  /**< Event n Pending Status */
      unsigned int EVT04      :  1;  /**< Event n Pending Status */
      unsigned int EVT05      :  1;  /**< Event n Pending Status */
      unsigned int EVT06      :  1;  /**< Event n Pending Status */
      unsigned int EVT07      :  1;  /**< Event n Pending Status */
      unsigned int EVT08      :  1;  /**< Event n Pending Status */
      unsigned int EVT09      :  1;  /**< Event n Pending Status */
      unsigned int EVT10      :  1;  /**< Event n Pending Status */
      unsigned int EVT11      :  1;  /**< Event n Pending Status */
      unsigned int EVT12      :  1;  /**< Event n Pending Status */
      unsigned int EVT13      :  1;  /**< Event n Pending Status */
      unsigned int EVT14      :  1;  /**< Event n Pending Status */
      unsigned int EVT15      :  1;  /**< Event n Pending Status */
      unsigned int EVT16      :  1;  /**< Event n Pending Status */
      unsigned int EVT17      :  1;  /**< Event n Pending Status */
      unsigned int EVT18      :  1;  /**< Event n Pending Status */
      unsigned int EVT19      :  1;  /**< Event n Pending Status */
      unsigned int EVT20      :  1;  /**< Event n Pending Status */
      unsigned int EVT21      :  1;  /**< Event n Pending Status */
      unsigned int EVT22      :  1;  /**< Event n Pending Status */
      unsigned int EVT23      :  1;  /**< Event n Pending Status */
      unsigned int EVT24      :  1;  /**< Event n Pending Status */
      unsigned int EVT25      :  1;  /**< Event n Pending Status */
      unsigned int EVT26      :  1;  /**< Event n Pending Status */
      unsigned int EVT27      :  1;  /**< Event n Pending Status */
      unsigned int EVT28      :  1;  /**< Event n Pending Status */
      unsigned int EVT29      :  1;  /**< Event n Pending Status */
      unsigned int EVT30      :  1;  /**< Event n Pending Status */
      unsigned int EVT31      :  1;  /**< Event n Pending Status */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EPND_t;

/*@}*/

/** @defgroup T0STAT Timer 0 Status Register (T0STAT) Register
 *  Timer 0 Status Register (T0STAT) Register.
 *
 *  The T0STAT register indicates Timer 0 related status for the ADCC operation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_T0STAT_Struct
 *! \brief  Timer 0 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_T0STAT_t {
  union {
    struct {
      unsigned int CURFR      : 16;  /**< Current Frame Count */
      unsigned int DPND       :  1;  /**< DMA Pending Status */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_T0STAT_t;

/*@}*/

/** @defgroup TMR0 Timer 0 Current Count Register (TMR0) Register
 *  Timer 0 Current Count Register (TMR0) Register.
 *
 *  The TMR0 register holds the current count of the Timer 0 while a frame is in progress. This register may be used to determine the current timer count, which indicates approximately how much of the frame has been completed. The timer is initiated by the trigger and counts up starting from 0. The timer increments every SCLK cycle until the frame completion. In DMA mode, the frame completion happens when event all data have been placed in memory and responses are received. In non-DMA mode, the frame completion happens when all events' data have been received from the ADC. If a frame is not in progress, the CNT field is reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TMR0_Struct
 *! \brief  Timer 0 Current Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TMR0_t {
  union {
    struct {
      unsigned int CNT        : 32;  /**< Current Count of Timer 0 */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TMR0_t;

/*@}*/

/** @defgroup T1STAT Timer 1 Status Register (T1STAT) Register
 *  Timer 1 Status Register (T1STAT) Register.
 *
 *  The T1STAT register indicates Timer 1 related status for the ADCC operation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_T1STAT_Struct
 *! \brief  Timer 1 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_T1STAT_t {
  union {
    struct {
      unsigned int CURFR      : 16;  /**< Current Frame Count */
      unsigned int DPND       :  1;  /**< DMA Pending Status */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_T1STAT_t;

/*@}*/

/** @defgroup TMR1 Timer 1 Current Count Register (TMR1) Register
 *  Timer 1 Current Count Register (TMR1) Register.
 *
 *  The TMR1 register holds the current count of the Timer 1 while a frame is in progress. This register may be used to determine the current timer count, which indicates approximately how much of the frame has been completed. The timer is initiated by the trigger and counts up starting from 0. The timer increments every SCLK cycle until the frame completion. In DMA mode, the frame completion happens when event all data have been placed in memory and responses are received. In non-DMA mode, the frame completion happens when all events' data have been received from the ADC. If a frame is not in progress, the CNT field is reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TMR1_Struct
 *! \brief  Timer 1 Current Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TMR1_t {
  union {
    struct {
      unsigned int CNT        : 32;  /**< Current Count of Timer 1 */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TMR1_t;

/*@}*/

/** @defgroup CBNUM0 Number of Wraps completed by TIMER0 Circular buffer DMA (CBNUM0) Register
 *  Number of Wraps completed by TIMER0 Circular buffer DMA (CBNUM0) Register.
 *
 *  The CBNUM0 register holds the number of wraps completed by TIMER0 in circular buffer DMA.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_CBNUM0_Struct
 *! \brief  Number of Wraps completed by TIMER0 Circular buffer DMA Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_CBNUM0_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Status indicating how many wraparounds have been completed in circular buffer DMA for the TIMER, after ADCC was enabled */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_CBNUM0_t;

/*@}*/

/** @defgroup CBNUM1 Number of Wraps completed by TIMER1 Circular buffer DMA (CBNUM1) Register
 *  Number of Wraps completed by TIMER1 Circular buffer DMA (CBNUM1) Register.
 *
 *  The CBNUM1 register holds the number of wraps completed by TIMER1 in circular buffer DMA.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_CBNUM1_Struct
 *! \brief  Number of Wraps completed by TIMER1 Circular buffer DMA Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_CBNUM1_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Status indicating how many wraparounds have been completed in circular buffer DMA for the TIMER, after ADCC was enabled */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_CBNUM1_t;

/*@}*/

/** @defgroup TRGCNT0 Trigger count of TIMER0 (TRGCNT0) Register
 *  Trigger count of TIMER0 (TRGCNT0) Register.
 *
 *  The TRGCNT0 register holds the trigger number being serviced at TIMER0
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TRGCNT0_Struct
 *! \brief  Trigger count of TIMER0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TRGCNT0_t {
  union {
    struct {
      unsigned int TRGCNT     : 16;  /**< Status indicating the trigger number being serviced by TIMER0 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TRGCNT0_t;

/*@}*/

/** @defgroup TRGCNT1 Trigger count of TIMER1 (TRGCNT1) Register
 *  Trigger count of TIMER1 (TRGCNT1) Register.
 *
 *  The TRGCNT1 register holds the trigger number being serviced at TIMER1
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_TRGCNT1_Struct
 *! \brief  Trigger count of TIMER1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_TRGCNT1_t {
  union {
    struct {
      unsigned int TRGCNT     : 16;  /**< Status indicating the trigger number being serviced by TIMER1 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_TRGCNT1_t;

/*@}*/

/** @defgroup ADCRW0 ADC0 Interface RW Access Register (ADCRW0) Register
 *  ADC0 Interface RW Access Register (ADCRW0) Register.
 *
 *  Read/Write access register for ADC0  interface
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ADCRW0_Struct
 *! \brief  ADC0 Interface RW Access Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ADCRW0_t {
  union {
    struct {
      unsigned int PND        :  1;  /**< Pending read/write status bit */
      unsigned int DAT        : 23;  /**< Read/Write data */
      unsigned int CTLW       :  8;  /**< Control word to be sent to the ADC */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ADCRW0_t;

/*@}*/

/** @defgroup ADCRW1 ADC1 Interface RW Access Register (ADCRW1) Register
 *  ADC1 Interface RW Access Register (ADCRW1) Register.
 *
 *  Read/Write access register for ADC1  interface
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_ADCRW1_Struct
 *! \brief  ADC1 Interface RW Access Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_ADCRW1_t {
  union {
    struct {
      unsigned int PND        :  1;  /**< Pending read/write status bit */
      unsigned int DAT        : 23;  /**< Read/Write data */
      unsigned int CTLW       :  8;  /**< Control word to be sent to the ADC */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_ADCRW1_t;

/*@}*/

/** @defgroup EVDAT Event n Data Register (EVDAT) Register
 *  Event n Data Register (EVDAT) Register.
 *
 *  The EVDAT[nn] register holds the data sampled from the ADC channel. The data from this register can be read by the core or transferred through DMA. If the data sample received is less than 16 bits wide (depends on value of corresponding TCA0:NCK or TCA1:NCK), the data is MSB aligned in the VALUE field, and the lower bits are zero filled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVDAT_Struct
 *! \brief  Event n Data Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVDAT_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Event Data Sampled from ADC */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVDAT_t;

/*@}*/

/** @defgroup EVT Event n Time Register (EVT) Register
 *  Event n Time Register (EVT) Register.
 *
 *  The EVT[nn] register holds the time (in terms SCLK cycles) at which to sample (the event) from ADC.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVT_Struct
 *! \brief  Event n Time Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVT_t {
  union {
    struct {
      unsigned int TIME       : 32;  /**< Time Value */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVT_t;

/*@}*/

/** @defgroup EVCTL Event n Control Register (EVCTL) Register
 *  Event n Control Register (EVCTL) Register.
 *
 *  The EVCTL[nn] register controls programmable features of the corresponding event.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVCTL_Struct
 *! \brief  Event n Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVCTL_t {
  union {
    struct {
      unsigned int CTLWD      : 16;  /**< Control Word for ADC */
      unsigned int ADCSEL     :  1;  /**< ADC Select */
      unsigned int SIMSAMP    :  1;  /**< Simultaneous Sampling Enable */
      unsigned int reserved18 :  1;
      unsigned int TMRSEL     :  1;  /**< Timer Select. */
      unsigned int EVTOFS     : 12;  /**< Event Offset */
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVCTL_t;

/*@}*/

/** @defgroup EVSTAT Event n Status Register (EVSTAT) Register
 *  Event n Status Register (EVSTAT) Register.
 *
 *  The EVSTAT[nn] register indicates event status for event n.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_ADCC_EVSTAT_Struct
 *! \brief  Event n Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_ADCC_EVSTAT_t {
  union {
    struct {
      unsigned int DLYCNT     : 16;  /**< Delay Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_ADCC_EVSTAT_t;

/*@}*/

/** @defgroup CTL0 Control 0 Register (CTL0) Register
 *  Control 0 Register (CTL0) Register.
 *
 *  The CTL0 register controls the DAC0 interface.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_CTL0_Struct
 *! \brief  Control 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_CTL0_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int reserved1  :  1;
      unsigned int DMAEN      :  1;  /**< DMA Enable */
      unsigned int DMAW       :  1;  /**< DMA Data Width */
      unsigned int LSBF       :  1;  /**< LSB-First Mode */
      unsigned int GCKEN      :  1;  /**< Gated Clock Enable */
      unsigned int CBUFEN     :  1;  /**< Circular Buffer Enable */
      unsigned int CINTEN     :  1;  /**< Circular Buffer Interrupt Enable */
      unsigned int DLEN       :  4;  /**< Data Length */
      unsigned int reserved12 :  4;
      unsigned int SYNCPOL    :  1;  /**< SYNC Polarity */
      unsigned int reserved17 :  1;
      unsigned int CKPOL      :  1;  /**< Clock Polarity */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_CTL0_t;

/*@}*/

/** @defgroup CTL1 Control 1 Register (CTL1) Register
 *  Control 1 Register (CTL1) Register.
 *
 *  The CTL1 register controls the DAC1 interface.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_CTL1_Struct
 *! \brief  Control 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_CTL1_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int reserved1  :  1;
      unsigned int DMAEN      :  1;  /**< DMA Enable */
      unsigned int DMAW       :  1;  /**< DMA Data Width */
      unsigned int LSBF       :  1;  /**< LSB-First Mode */
      unsigned int GCKEN      :  1;  /**< Gated Clock Enable */
      unsigned int CBUFEN     :  1;  /**< Circular Buffer Enable */
      unsigned int CINTEN     :  1;  /**< Circular Buffer Interrupt Enable */
      unsigned int DLEN       :  4;  /**< Data Length */
      unsigned int reserved12 :  4;
      unsigned int SYNCPOL    :  1;  /**< SYNC Polarity */
      unsigned int reserved17 :  1;
      unsigned int CKPOL      :  1;  /**< Clock Polarity */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_CTL1_t;

/*@}*/

/** @defgroup ERRSTAT Error Status Register (ERRSTAT) Register
 *  Error Status Register (ERRSTAT) Register.
 *
 *  The ERRSTAT register indicates error status for DACC operations. When any bit in this register is set, the DACC generates the ERR interrupt.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_ERRSTAT_Struct
 *! \brief  Error Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_ERRSTAT_t {
  union {
    struct {
      unsigned int DUVF0      :  1;  /**< DAC0 Underflow */
      unsigned int DUVF1      :  1;  /**< DAC Underflow 1 */
      unsigned int AER0       :  1;  /**< Address Alignment Error 0 */
      unsigned int AER1       :  1;  /**< Address Alignment Error 1 */
      unsigned int MER0       :  1;  /**< Memory Error 0 */
      unsigned int MER1       :  1;  /**< Memory Error 1 */
      unsigned int reserved6  : 26;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_ERRSTAT_t;

/*@}*/

/** @defgroup ERRMSK Error Mask Register (ERRMSK) Register
 *  Error Mask Register (ERRMSK) Register.
 *
 *  The ERRMSK register masks (disables) or unmasks (enables) reporting of DAC related errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_ERRMSK_Struct
 *! \brief  Error Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_ERRMSK_t {
  union {
    struct {
      unsigned int DUVF0      :  1;  /**< DAC Underflow 0 Mask */
      unsigned int DUVF1      :  1;  /**< DAC Underflow 1 Mask */
      unsigned int AER0       :  1;  /**< Address Alignment Error 0 Mask */
      unsigned int AER1       :  1;  /**< Address Alignment Error 1 Mask */
      unsigned int MER0       :  1;  /**< Memory Error 0 Mask */
      unsigned int MER1       :  1;  /**< Memory Error 1 Mask */
      unsigned int reserved6  : 26;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_ERRMSK_t;

/*@}*/

/** @defgroup ERRMSK_SET Error Mask Set Register (ERRMSK_SET) Register
 *  Error Mask Set Register (ERRMSK_SET) Register.
 *
 *  The ERRMSK_SET register can be used to selectively set bits in the ERRMSK register without affecting other bits in the register. Writing a 1 to any bit position in ERRMSK_SET sets the corresponding bit in ERRMSK. Reading the ERRMSK_SET register returns the data present in the ERRMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_ERRMSK_SET_Struct
 *! \brief  Error Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_ERRMSK_SET_t {
  union {
    struct {
      unsigned int DUVF0      :  1;  /**< DAC Underflow 0 Mask Set */
      unsigned int DUVF1      :  1;  /**< DAC Underflow 1 Mask Set */
      unsigned int AER0       :  1;  /**< Address Alignment Error 0 Mask Set */
      unsigned int AER1       :  1;  /**< Address Alignment Error 1 Mask Set */
      unsigned int MER0       :  1;  /**< Memory Error 0 Mask Set */
      unsigned int MER1       :  1;  /**< Memory Error 1 Mask Set */
      unsigned int reserved6  : 26;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_ERRMSK_SET_t;

/*@}*/

/** @defgroup ERRMSK_CLR Error Mask Clear Register (ERRMSK_CLR) Register
 *  Error Mask Clear Register (ERRMSK_CLR) Register.
 *
 *  The ERRMSK_CLR register can be used to selectively clear bits in the ERRMSK register without affecting other bits in the register. Writing a 1 to any bit position in ERRMSK_CLR clears the corresponding bit in ERRMSK. Reading the ERRMSK_CLR register returns the data present in the ERRMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_ERRMSK_CLR_Struct
 *! \brief  Error Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_ERRMSK_CLR_t {
  union {
    struct {
      unsigned int DUVF0      :  1;  /**< DAC Underflow 0 Mask Clear */
      unsigned int DUVF1      :  1;  /**< DAC Underflow 1 Mask Clear */
      unsigned int AER0       :  1;  /**< Address Alignment Error 0 Mask Clear */
      unsigned int AER1       :  1;  /**< Address Alignment Error 0 Mask Clear */
      unsigned int MER0       :  1;  /**< Memory Error 0 Mask Clear */
      unsigned int MER1       :  1;  /**< Memory Error 1 Mask Clear */
      unsigned int reserved6  : 26;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_ERRMSK_CLR_t;

/*@}*/

/** @defgroup ISTAT Interrupt Status Register (ISTAT) Register
 *  Interrupt Status Register (ISTAT) Register.
 *
 *  The ISTAT register indicates DAC0 and DAC1 interrupt status. The DACC generates interrupts corresponding to DAC 0 on the DAC0 output and generates the interrupts corresponding to DAC1 on the DAC1 output.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_ISTAT_Struct
 *! \brief  Interrupt Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_ISTAT_t {
  union {
    struct {
      unsigned int DINT0      :  1;  /**< DMA Complete Interrupt 0 */
      unsigned int DINT1      :  1;  /**< DMA Complete Interrupt 1 */
      unsigned int CINT0      :  1;  /**< Core Complete (Non-DMA) Interrupt 0 */
      unsigned int CINT1      :  1;  /**< Core Complete (Non-DMA) Interrupt */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_ISTAT_t;

/*@}*/

/** @defgroup IMSK Interrupt Mask Register (IMSK) Register
 *  Interrupt Mask Register (IMSK) Register.
 *
 *  The IMSK register masks (disables) generation of DAC0 or DAC1 interrupts based on status in the ISTAT register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_IMSK_Struct
 *! \brief  Interrupt Mask Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_IMSK_t {
  union {
    struct {
      unsigned int DINT0      :  1;  /**< DMA Complete Interrupt 0 Mask */
      unsigned int DINT1      :  1;  /**< DMA Complete Interrupt 1 Mask */
      unsigned int CINT0      :  1;  /**< Core Complete (Non-DMA) Interrupt 0 Mask */
      unsigned int CINT1      :  1;  /**< Core Complete (Non-DMA) Interrupt 1Mask */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_IMSK_t;

/*@}*/

/** @defgroup IMSK_SET Interrupt Mask Set Register (IMSK_SET) Register
 *  Interrupt Mask Set Register (IMSK_SET) Register.
 *
 *  The IMSK_SET register can be used to selectively set bits in the IMSK register without affecting other bits in the register. Writing a 1 to any bit position in IMSK_SET sets the corresponding bit in IMSK. Reading the IMSK_SET register returns the data present in the IMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_IMSK_SET_Struct
 *! \brief  Interrupt Mask Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_IMSK_SET_t {
  union {
    struct {
      unsigned int DINT0      :  1;  /**< DMA Complete Interrupt 0 Mask Set */
      unsigned int DINT1      :  1;  /**< DMA Complete Interrupt 1 Mask Set */
      unsigned int CINT0      :  1;  /**< Core Complete (Non-DMA) Interrupt 0 Mask Set */
      unsigned int CINT1      :  1;  /**< Core Complete (Non-DMA) Interrupt 1 Mask Set */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_IMSK_SET_t;

/*@}*/

/** @defgroup IMSK_CLR Interrupt Mask Clear Register (IMSK_CLR) Register
 *  Interrupt Mask Clear Register (IMSK_CLR) Register.
 *
 *  The IMSK_CLR register can be used to selectively clear bits in the IMSK register without affecting other bits in the register. Writing a 1 to any bit position in IMSK_CLR clears the corresponding bit in IMSK. Reading the IMSK_CLR register returns the data present in the IMSK register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_IMSK_CLR_Struct
 *! \brief  Interrupt Mask Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_IMSK_CLR_t {
  union {
    struct {
      unsigned int DINT0      :  1;  /**< DMA Complete Interrupt 0 Mask Clear */
      unsigned int DINT1      :  1;  /**< DMA Complete Interrupt 1 Mask Clear */
      unsigned int CINT0      :  1;  /**< Core Complete (Non-DMA) Interrupt 0 Mask Clear. */
      unsigned int CINT1      :  1;  /**< Core Complete (Non-DMA) Interrupt 1 Mask Clear */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_IMSK_CLR_t;

/*@}*/

/** @defgroup TC0 Timing Control 0 Register (TC0) Register
 *  Timing Control 0 Register (TC0) Register.
 *
 *  The TC0 register controls timing related to the DAC0 interface clock and sync signals.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_TC0_Struct
 *! \brief  Timing Control 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_TC0_t {
  union {
    struct {
      unsigned int CKDIV      : 16;  /**< Clock Divisor */
      unsigned int FSIDLE     : 16;  /**< Frame Sync Idle */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_TC0_t;

/*@}*/

/** @defgroup BPTR0 Base Pointer 0 Register (BPTR0) Register
 *  Base Pointer 0 Register (BPTR0) Register.
 *
 *  The BPTR0 register provides the base pointer (address) used by DMA read operations for the DAC0 interface. The value of base address (pointer) in the BPTR0 register at the start of the DMA work unit (start of frame) corresponds to one of the following transfers:
 *  $[ul$]$[li$]The first transfer after DACC is enabled in DMA mode
 *  $[/li$]$[li$]The first transfer after a wrap around occurs in circular buffering mode
 *  $[/li$]$[/ul$]The data for the first transfer is read from memory, starting at the address indicated with the value of the base address. Further DMA data is read from memory at addresses incremented by MOD0 bytes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_BPTR0_Struct
 *! \brief  Base Pointer 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_BPTR0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Base Pointer 0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_BPTR0_t;

/*@}*/

/** @defgroup MOD0 Modify 0 Register (MOD0) Register
 *  Modify 0 Register (MOD0) Register.
 *
 *  The MOD0 register contains the address increment applied between each DMA read from memory, starting at the base-address (BPTR0). The value is a signed, two's complement byte address increment.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_MOD0_Struct
 *! \brief  Modify 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_MOD0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Modify 0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_MOD0_t;

/*@}*/

/** @defgroup CNT0 Count 0 Register (CNT0) Register
 *  Count 0 Register (CNT0) Register.
 *
 *  In linear DMA mode, the CNT0 register holds the transfer count of a DMA work-unit for DAC0. The DMA fetches the indicated number of read data and generates an interrupt after transmitting all data to the DAC. After the data corresponding to the count is transmitted (in linear DMA mode), the DACC does not send further syncs to the DAC.
 *  In circular buffer mode, this register holds the count of DMA after which wrap around to the base pointer address ((BPTR0)) occurs. The DMA fetches the indicated number of read data and (optionally) generates an interrupt after receiving all data corresponding to one set of CNT0 counts (one circular buffer) from memory.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_CNT0_Struct
 *! \brief  Count 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_CNT0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Count 0 Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_CNT0_t;

/*@}*/

/** @defgroup DAT0 Data FIFO 0 Register (DAT0) Register
 *  Data FIFO 0 Register (DAT0) Register.
 *
 *  The DAT0 register provides a memory mapped register location for the DAC0 data FIFO. This location is used in non-DMA mode, permitting the core writes to transmit data to the DAC. Only the lower 16 bits are considered as DAC data; the upper 16 bits are ignored.
 *  The core should only write this register when no DAC DMA is in progress (ISTAT:DINT0 =1). If the core attempts a write into this register during an active DAC DMA (ISTAT:DINT0 =0), the DACC ignores the write transaction. Reads of DAT0 return the value of the top entry of the DAC0 FIFO.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_DAT0_Struct
 *! \brief  Data FIFO 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_DAT0_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Data FIFO 0 Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_DAT0_t;

/*@}*/

/** @defgroup TC1 Timing Control 1 Register (TC1) Register
 *  Timing Control 1 Register (TC1) Register.
 *
 *  The TC1 register controls timing related to the DAC1 interface clock and sync signals.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_TC1_Struct
 *! \brief  Timing Control 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_TC1_t {
  union {
    struct {
      unsigned int CKDIV      : 16;  /**< Clock Divisor */
      unsigned int FSIDLE     : 16;  /**< Frame Sync Idle */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_TC1_t;

/*@}*/

/** @defgroup BPTR1 Base Pointer 1 Register (BPTR1) Register
 *  Base Pointer 1 Register (BPTR1) Register.
 *
 *  The BPTR1 register provides the base pointer (address) used by DMA read operations for the DAC1 interface. The value of base address (pointer) in the BPTR1 register at the start of the DMA work unit (start of frame) corresponds to one of the following transfers:
 *  $[ul$]$[li$]The first transfer after DACC is enabled in DMA mode
 *  $[/li$]$[li$]The first transfer after a wrap around occurs in circular buffering mode
 *  $[/li$]$[/ul$]The data for the first transfer is read from memory, starting at the address indicated with the value of the base address. Further DMA data is read from memory at addresses incremented by MOD1 bytes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_BPTR1_Struct
 *! \brief  Base Pointer 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_BPTR1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Base Pointer 1 Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_BPTR1_t;

/*@}*/

/** @defgroup MOD1 Modify 1 Register (MOD1) Register
 *  Modify 1 Register (MOD1) Register.
 *
 *  The MOD1 register contains the address increment applied between each DMA read from memory, starting at the base-address (BPTR1). The value is a signed, two's complement byte address increment.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_MOD1_Struct
 *! \brief  Modify 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_MOD1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Modify 1 Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_MOD1_t;

/*@}*/

/** @defgroup CNT1 Count 1 Register (CNT1) Register
 *  Count 1 Register (CNT1) Register.
 *
 *  In linear DMA mode, the CNT1 register holds the transfer count of a DMA work-unit for DAC1. The DMA fetches the indicated number of read data and generates an interrupt after transmitting all data to the DAC. After the data corresponding to the count is transmitted (in linear DMA mode), the DACC does not send further syncs to the DAC.
 *  In circular buffer mode, this register holds the count of DMA after which wrap around to the base pointer address ((BPTR1)) occurs. The DMA fetches the indicated number of read data and (optionally) generates an interrupt after receiving all data corresponding to one set of CNT1 counts (one circular buffer) from memory.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_CNT1_Struct
 *! \brief  Count 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_CNT1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Count 1 Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_CNT1_t;

/*@}*/

/** @defgroup DAT1 Data FIFO 1 Register (DAT1) Register
 *  Data FIFO 1 Register (DAT1) Register.
 *
 *  The DAT1 register provides a memory mapped register location for the DAC1 data FIFO. This location is used in non-DMA mode, permitting the core writes to transmit data to the DAC. Only the lower 16 bits are considered as DAC data; the upper 16 bits are ignored.
 *  The core should only write this register when no DAC DMA is in progress (ISTAT:DINT1 =1). If the core attempts a write into this register during an active DAC DMA (ISTAT:DINT1 =0), the DACC ignores the write transaction. Reads of DAT1 return the value of the top entry of the DAC1 FIFO.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_DAT1_Struct
 *! \brief  Data FIFO 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_DAT1_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Data FIFO 1 Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_DAT1_t;

/*@}*/

/** @defgroup BCST_CTL Broadcast (Write) Control Register (BCST_CTL) Register
 *  Broadcast (Write) Control Register (BCST_CTL) Register.
 *
 *  The BCST_CTL register provides a broadcast write access to the CTL0 and CTL1 registers. A memory mapped register write to BCST_CTL writes the data to both control register. A memory mapped register read of the BCST_CTL register returns 0x0000.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_BCST_CTL_Struct
 *! \brief  Broadcast (Write) Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_BCST_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int reserved1  :  1;
      unsigned int DMAEN      :  1;  /**< DMA Enable */
      unsigned int DMAW       :  1;  /**< DMA Data Width */
      unsigned int LSBF       :  1;  /**< LSB-First Mode */
      unsigned int GCKEN      :  1;  /**< Gated Clock Enable */
      unsigned int CBUFEN     :  1;  /**< Circular Buffer Enable */
      unsigned int CINTEN     :  1;  /**< Circular Buffer Interrupt Enable */
      unsigned int DLEN       :  4;  /**< Data Length */
      unsigned int reserved12 :  4;
      unsigned int SYNCPOL    :  1;  /**< SYNC Polarity */
      unsigned int reserved17 :  1;
      unsigned int CKPOL      :  1;  /**< Clock Polarity */
      unsigned int reserved19 : 13;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_BCST_CTL_t;

/*@}*/

/** @defgroup CNTCUR0 Current Count 0 Register (CNTCUR0) Register
 *  Current Count 0 Register (CNTCUR0) Register.
 *
 *  The CNTCUR0 register holds the current count of the DMA work-unit of the DAC0 interface. This register is loaded from the CNT0 register when either of the following occur:
 *  $[ul$]$[li$]The DACC is enabled in DMA mode
 *  $[/li$]$[li$]A wrap around occurs in circular buffering mode
 *  $[/li$]$[/ul$]The count decrements with each DMA read from memory.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_CNTCUR0_Struct
 *! \brief  Current Count 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_CNTCUR0_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Current Count Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_CNTCUR0_t;

/*@}*/

/** @defgroup CNTCUR1 Current Count 1 Register (CNTCUR1) Register
 *  Current Count 1 Register (CNTCUR1) Register.
 *
 *  The CNTCUR1 register holds the current count of the DMA work-unit of the DAC1 interface. This register is loaded from the CNT1 register when either of the following occur:
 *  $[ul$]$[li$]The DACC is enabled in DMA mode
 *  $[/li$]$[li$]A wrap around occurs in circular buffering mode
 *  $[/li$]$[/ul$]The count decrements with each DMA read from memory.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_CNTCUR1_Struct
 *! \brief  Current Count 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_CNTCUR1_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Current Count Value */
    };
    uint32_t VALUE32;
  };
} ADI_DACC_CNTCUR1_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates status for DACC operations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DACC_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DACC_STAT_t {
  union {
    struct {
      unsigned int DPND0      :  1;  /**< Data Pending 0 */
      unsigned int reserved1  :  3;
      unsigned int DPND1      :  1;  /**< Data Pending 1 */
      unsigned int reserved5  :  3;
      unsigned int FSTAT0     :  4;  /**< FIFO Status 0 */
      unsigned int FSTAT1     :  4;  /**< FIFO Status 1 */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_DACC_STAT_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The CTL configures the operation modes and settings for the CRC.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_CTL_t {
  union {
    struct {
      unsigned int BLKEN      :  1;  /**< Block Enable */
      unsigned int reserved1  :  3;
      unsigned int OPMODE     :  4;  /**< Operation Mode */
      unsigned int AUTOCLRZ   :  1;  /**< Auto Clear to Zero */
      unsigned int AUTOCLRF   :  1;  /**< Auto Clear to One */
      unsigned int reserved10 :  2;
      unsigned int OBRSTALL   :  1;  /**< Output Buffer Ready Stall */
      unsigned int IRRSTALL   :  1;  /**< Intermediate Result Ready Stall */
      unsigned int reserved14 :  2;
      unsigned int BITMIRR    :  1;  /**< Bit Mirroring */
      unsigned int BYTMIRR    :  1;  /**< Byte Mirroring */
      unsigned int W16SWP     :  1;  /**< Word16 Swapping */
      unsigned int FDSEL      :  1;  /**< FIFO Data Select */
      unsigned int RSLTMIRR   :  1;  /**< Result Register Mirroring */
      unsigned int POLYMIRR   :  1;  /**< Polynomial Register Mirroring */
      unsigned int CMPMIRR    :  1;  /**< COMPARE Register Mirroring */
      unsigned int reserved23 :  9;
    };
    uint32_t VALUE32;
  };
} ADI_CRC_CTL_t;

/*@}*/

/** @defgroup DCNT Data Word Count Register (DCNT) Register
 *  Data Word Count Register (DCNT) Register.
 *
 *  The DCNT holds the word count that is used for the CRC operation. On transfer of every 32-bit word, the CRC decrements by 1 the content of this register. When the count decrements to zero, this event triggers a CRC compare action, and DCNT is automatically loaded from the DCNTRLD for the next CRC operation. Note that the initial value programmed into DCNT may be different from what is programmed in the DCNTRLD.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_DCNT_Struct
 *! \brief  Data Word Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_DCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Data Word Count */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_DCNT_t;

/*@}*/

/** @defgroup DCNTRLD Data Word Count Reload Register (DCNTRLD) Register
 *  Data Word Count Reload Register (DCNTRLD) Register.
 *
 *  The DCNTRLD holds the value that the CRC automatically loads into DCNT when the DCNT decrements to 0. At startup, the value programmed in DCNT and DCNTRLD could be different. So, for the first iteration, the CRC operation happens for the count initially programmed in the DCNT register. While for subsequent CRC operations, the count is taken from the DCNTRLD register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_DCNTRLD_Struct
 *! \brief  Data Word Count Reload Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_DCNTRLD_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Reload Value */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_DCNTRLD_t;

/*@}*/

/** @defgroup COMP Data Compare Register (COMP) Register
 *  Data Compare Register (COMP) Register.
 *
 *  The COMP contains the value corresponding to the expected CRC result or signature for the current data stream. At the end of the operation, the content of this register is used to compare against the result produced by the CRC operation. In data verify mode, each incoming data value is compared with the content of this register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_COMP_Struct
 *! \brief  Data Compare Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_COMP_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Expected CRC Result Value */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_COMP_t;

/*@}*/

/** @defgroup FILLVAL Fill Value Register (FILLVAL) Register
 *  Fill Value Register (FILLVAL) Register.
 *
 *  The FILLVAL holds the value that the CRC uses for the memory fill operation. In data fill mode, the value programmed in this register is used for the memory fill operation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_FILLVAL_Struct
 *! \brief  Fill Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_FILLVAL_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Memory Fill Value */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_FILLVAL_t;

/*@}*/

/** @defgroup DFIFO Data FIFO Register (DFIFO) Register
 *  Data FIFO Register (DFIFO) Register.
 *
 *  In memory transfer mode (non-data fill mode), the data from the DMA or processor core buses is written into the DFIFO on each input data grant (DMA grant or core write). Data is read from this FIFO on each output data grant (DMA grant or core read). FIFO status information is available in the STAT register. Whenever, the FIFO has valid data, output data requests are generated. 
 *  Note that---in non-memory transfer mode and in data fill mode---the input data actually does not get written into this FIFO. So, this register should not be read in these modes.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_DFIFO_Struct
 *! \brief  Data FIFO Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_DFIFO_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Data FIFO Value */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_DFIFO_t;

/*@}*/

/** @defgroup INEN Interrupt Enable Register (INEN) Register
 *  Interrupt Enable Register (INEN) Register.
 *
 *  The INEN unmasks (enables) or masks (disables) interrupt requests generated in the CRC from going to the processor core. Note that CRC interrupts are not disabled when the CRC is disabled (CTL:BLKEN =0).
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_CRC_INEN_CMPERR
 *! \brief  Compare Error Interrupt Enable (CMPERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  CRC_INEN_CMPERR_MSK  = 0,  /**< Disable (mask) interrupt  */
  CRC_INEN_CMPERR_UMSK = 1   /**< Enable (unmask) interrupt */
} ADI_CRC_INEN_CMPERR;


/*  =========================================================================
 *! \enum   ADI_CRC_INEN_DCNTEXP
 *! \brief  Data Count Expired (Status) Interrupt Enable (DCNTEXP) Enumerations
 *  ========================================================================= */
typedef enum
{
  CRC_INEN_DCNTEXP_MSK  = 0,  /**< Disable (mask) interrupt  */
  CRC_INEN_DCNTEXP_UMSK = 1   /**< Enable (unmask) interrupt */
} ADI_CRC_INEN_DCNTEXP;


/* ==========================================================================
 *! \struct ADI_CRC_INEN_Struct
 *! \brief  Interrupt Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_INEN_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int CMPERR     :  1;  /**< Compare Error Interrupt Enable */
      unsigned int reserved2  :  2;
      unsigned int DCNTEXP    :  1;  /**< Data Count Expired (Status) Interrupt Enable */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_CRC_INEN_t;

/*@}*/

/** @defgroup INEN_SET Interrupt Enable Set Register (INEN_SET) Register
 *  Interrupt Enable Set Register (INEN_SET) Register.
 *
 *  The INEN_SET permits setting individual bits in the INEN register without affecting other bits in the register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_INEN_SET_Struct
 *! \brief  Interrupt Enable Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_INEN_SET_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int CMPERR     :  1;  /**< Compare Error Interrupt */
      unsigned int reserved2  :  2;
      unsigned int DCNTEXP    :  1;  /**< Data Count Expired (Status) Interrupt Enable Set */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_CRC_INEN_SET_t;

/*@}*/

/** @defgroup INEN_CLR Interrupt Enable Clear Register (INEN_CLR) Register
 *  Interrupt Enable Clear Register (INEN_CLR) Register.
 *
 *  The INEN_CLR permits clearing individual bits in the INEN register without affecting other bits in the register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_INEN_CLR_Struct
 *! \brief  Interrupt Enable Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_INEN_CLR_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int CMPERR     :  1;  /**< Compare Error Clear */
      unsigned int reserved2  :  2;
      unsigned int DCNTEXP    :  1;  /**< Data Count Expired */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_CRC_INEN_CLR_t;

/*@}*/

/** @defgroup POLY Polynomial Register (POLY) Register
 *  Polynomial Register (POLY) Register.
 *
 *  The POLY holds a 32-bit polynomial for CRC operations. Bit 31 corresponds to coefficient of x31 of the CRC polynomial, bit 30 corresponds to coefficient of x30, and so on through to bit 0. Coefficient of x32 is assumed to be "1" for any polynomial that is selected. Based on the polynomial in POLY, the CRC generates a look-up table (LUT), which is used to compute the CRC of the incoming data stream.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_POLY_Struct
 *! \brief  Polynomial Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_POLY_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< CRC Polynomial Value */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_POLY_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT indicates status for CRC operations and interrupt generation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_STAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int CMPERR     :  1;  /**< Compare Error */
      unsigned int reserved2  :  2;
      unsigned int DCNTEXP    :  1;  /**< Data Count Expired */
      unsigned int reserved5  : 11;
      unsigned int IBR        :  1;  /**< Input Buffer Ready */
      unsigned int OBR        :  1;  /**< Output Buffer Ready */
      unsigned int IRR        :  1;  /**< Intermediate Result Ready */
      unsigned int LUTDONE    :  1;  /**< Look Up Table Done */
      unsigned int FSTAT      :  3;  /**< FIFO Status */
      unsigned int reserved23 :  9;
    };
    uint32_t VALUE32;
  };
} ADI_CRC_STAT_t;

/*@}*/

/** @defgroup DCNTCAP Data Count Capture Register (DCNTCAP) Register
 *  Data Count Capture Register (DCNTCAP) Register.
 *
 *  The DCNTCAP captures the DCNT value when a compare operation fails in data verify mode. This capture can be used to track the position of error in the data stream. Capture operation is enabled only if the STAT:CMPERR indicates no compare error. After an error occurs and data count is captured, no further errors are logged until the STAT:CMPERR bit is cleared. To obtain the position of error in the data stream, subtract the DCNTCAP value from the initial DCNT.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_DCNTCAP_Struct
 *! \brief  Data Count Capture Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_DCNTCAP_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Data Count Capture Value */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_DCNTCAP_t;

/*@}*/

/** @defgroup RESULT_FIN CRC Final Result Register (RESULT_FIN) Register
 *  CRC Final Result Register (RESULT_FIN) Register.
 *
 *  The RESULT_FIN holds the final CRC computed for a data stream. A data stream is a DMA of DCNT number of words into the CRC. When DCNT decrements to zero for each datastream, the CRC loads RESULT_FIN with the value from RESULT_CUR.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_RESULT_FIN_Struct
 *! \brief  CRC Final Result Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_RESULT_FIN_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Computed CRC */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_RESULT_FIN_t;

/*@}*/

/** @defgroup RESULT_CUR CRC Current Result Register (RESULT_CUR) Register
 *  CRC Current Result Register (RESULT_CUR) Register.
 *
 *  The RESULT_CUR holds the current or intermediate CRC result and is updated when new data is written into the CRC. Each time the DCNT expires, the CRC loads the value from this register into the RESULT_FIN. The RESULT_CUR may be set to auto clear to zero or auto clear to ones when DCNT expires by configuring the CTL:AUTOCLRZ and CTL:AUTOCLRF bits. Before starting a CRC operation, the RESULT_CUR should be programmed to the desired value. Note that this register can be read by the processor core at any time.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_CRC_RESULT_CUR_Struct
 *! \brief  CRC Current Result Register bit field structure
 * ========================================================================== */
typedef struct _ADI_CRC_RESULT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Intermediate CRC Result */
    };
    uint32_t VALUE32;
  };
} ADI_CRC_RESULT_CUR_t;

/*@}*/

/** @defgroup RUN Run Register (RUN) Register
 *  Run Register (RUN) Register.
 *
 *  The RUN register starts/idles HAE harmonic calculations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_RUN_Struct
 *! \brief  Run Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_RUN_t {
  union {
    struct {
      unsigned int RUN        :  1;  /**< Run/Stop */
      unsigned int reserved1  : 31;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_RUN_t;

/*@}*/

/** @defgroup CFG0 Configuration 0 Register (CFG0) Register
 *  Configuration 0 Register (CFG0) Register.
 *
 *  The CFG0 register configures high-level interrupts and specifies the line frequency for HAE operations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_CFG0_Struct
 *! \brief  Configuration 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_CFG0_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int LFREQ      :  1;  /**< Line Frequency Select */
      unsigned int reserved2  :  2;
      unsigned int CLR_PERR   :  1;  /**< Clear Parity Status */
      unsigned int PERR_EN    :  1;  /**< Parity Enable */
      unsigned int TXIRQEN    :  1;  /**< Transmit IRQ Enable */
      unsigned int RXIRQEN    :  1;  /**< Receive IRQ Enable */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_CFG0_t;

/*@}*/

/** @defgroup CFG1 Configuration 1 Register (CFG1) Register
 *  Configuration 1 Register (CFG1) Register.
 *
 *  The CFG1 register configures the HAE frequency (clock) divider.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_CFG1_Struct
 *! \brief  Configuration 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_CFG1_t {
  union {
    struct {
      unsigned int STARTDIV   : 15;  /**< Start (Clock) Divider */
      unsigned int reserved15 : 17;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_CFG1_t;

/*@}*/

/** @defgroup CFG2 Configuration 2 Register (CFG2) Register
 *  Configuration 2 Register (CFG2) Register.
 *
 *  The CFG2 register enables and configures HAE operations as related to output results.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_CFG2_Struct
 *! \brief  Configuration 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_CFG2_t {
  union {
    struct {
      unsigned int MODE       :  1;  /**< (Results) Mode Select */
      unsigned int SETTLE     :  2;  /**< Settle Period Select */
      unsigned int UPDATE     :  3;  /**< Update Rate Select */
      unsigned int EN         :  1;  /**< Enable Clock */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_CFG2_t;

/*@}*/

/** @defgroup CFG3 Configuration 3 Register (CFG3) Register
 *  Configuration 3 Register (CFG3) Register.
 *
 *  The CFG3 register configures HAE data transfer operations by selecting the fundamental and potential of twelve additional harmonic channels. The selected harmonics have their data (results) transferred to memory over the P2P bus: first, the fundamental; followed by the selected channel n, in the order from the lowest to the highest numbered channel. Each selected channel has its eight result words transferred.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_CFG3_Struct
 *! \brief  Configuration 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_CFG3_t {
  union {
    struct {
      unsigned int CHANEN     : 13;  /**< Channel n Enable */
      unsigned int reserved13 : 19;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_CFG3_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates status for the HAE module and its interrupts.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_STAT_t {
  union {
    struct {
      unsigned int TXIRQ      :  1;  /**< Transmit IRQ Status */
      unsigned int RXIRQ      :  1;  /**< Receive IRQ Status */
      unsigned int RDY        :  1;  /**< Ready Status */
      unsigned int PERR_STAT  :  1;  /**< Parity Error Status */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_STAT_t;

/*@}*/

/** @defgroup ISAMPLE I (Current) Sample Register (ISAMPLE) Register
 *  I (Current) Sample Register (ISAMPLE) Register.
 *
 *  The ISAMPLE register provides current (I) input samples for HAE calculations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_ISAMPLE_Struct
 *! \brief  I (Current) Sample Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_ISAMPLE_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Current Input Sample */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_ISAMPLE_t;

/*@}*/

/** @defgroup VSAMPLE V (Voltage) Sample Register (VSAMPLE) Register
 *  V (Voltage) Sample Register (VSAMPLE) Register.
 *
 *  The VSAMPLE register provides voltage (V) input samples for HAE calculations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_VSAMPLE_Struct
 *! \brief  V (Voltage) Sample Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_VSAMPLE_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Voltage Input Sample */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_VSAMPLE_t;

/*@}*/

/** @defgroup IWAVEFORM I (Current) Waveform Register (IWAVEFORM) Register
 *  I (Current) Waveform Register (IWAVEFORM) Register.
 *
 *  The IWAVEFORM register holds current waveforms produced by the HAE. After some amplitude and phase delay, the waveform follows a sample input.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_IWAVEFORM_Struct
 *! \brief  I (Current) Waveform Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_IWAVEFORM_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Current Waveform */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_IWAVEFORM_t;

/*@}*/

/** @defgroup VWAVEFORM V (Voltage) Waveform Register (VWAVEFORM) Register
 *  V (Voltage) Waveform Register (VWAVEFORM) Register.
 *
 *  The VWAVEFORM register contains voltage waveforms produced by the HAE. After some amplitude and phase delay, the waveform follows a sample input.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_VWAVEFORM_Struct
 *! \brief  V (Voltage) Waveform Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_VWAVEFORM_t {
  union {
    struct {
      unsigned int VALUE      : 24;  /**< Voltage Waveform */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_VWAVEFORM_t;

/*@}*/

/** @defgroup CFG4 Configuration 4 Register (CFG4) Register
 *  Configuration 4 Register (CFG4) Register.
 *
 *  The CFG4 register configures the internal digital integrator and high-pass filters (HPS) for HAE operations. The digital integrator is disabled and the filters are enabled by default.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_CFG4_Struct
 *! \brief  Configuration 4 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_CFG4_t {
  union {
    struct {
      unsigned int HPFEN      :  1;  /**< High-Pass Filter Enable */
      unsigned int DIDTEN     :  1;  /**< di/dt (Sensor) Enable */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_CFG4_t;

/*@}*/

/** @defgroup DIDT_GAIN DIDT Gain Register (DIDT_GAIN) Register
 *  DIDT Gain Register (DIDT_GAIN) Register.
 *
 *  The DIDT_GAIN register provides the di/dt sensor's gain.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_DIDT_GAIN_Struct
 *! \brief  DIDT Gain Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_DIDT_GAIN_t {
  union {
    struct {
      unsigned int VALUE      : 28;  /**< di/dt Sensor Gain */
      unsigned int reserved28 :  4;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_DIDT_GAIN_t;

/*@}*/

/** @defgroup DIDT_COEF DIDT Coefficient Register (DIDT_COEF) Register
 *  DIDT Coefficient Register (DIDT_COEF) Register.
 *
 *  The DIDT_COEF register sets the di/dt sensor's coefficient.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_DIDT_COEF_Struct
 *! \brief  DIDT Coefficient Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_DIDT_COEF_t {
  union {
    struct {
      unsigned int VALUE      : 28;  /**< di/dt Coefficient */
      unsigned int reserved28 :  4;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_DIDT_COEF_t;

/*@}*/

/** @defgroup VLEVEL Voltage Level Register (VLEVEL) Register
 *  Voltage Level Register (VLEVEL) Register.
 *
 *  The VLEVEL register is used to scale the fixed fundamental voltage level internally. This assists the HAE in locking onto the fundamental voltage channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_VLEVEL_Struct
 *! \brief  Voltage Level Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_VLEVEL_t {
  union {
    struct {
      unsigned int VALUE      : 28;  /**< Voltage Input Level */
      unsigned int reserved28 :  4;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_VLEVEL_t;

/*@}*/

/** @defgroup H_INDX Harmonic n Index Register (H_INDX) Register
 *  Harmonic n Index Register (H_INDX) Register.
 *
 *  The H[nn]_INDX registers select harmonics for HAE operations. The fundamental always is provided. The harmonic results appear in the results RAM (RESULTS_RAM register) based on the index.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_HAE_H_INDX_Struct
 *! \brief  Harmonic n Index Register bit field structure
 * ========================================================================== */
typedef struct _ADI_HAE_H_INDX_t {
  union {
    struct {
      unsigned int VALUE      :  6;  /**< Harmonic n Index */
      unsigned int reserved6  : 26;
    };
    uint32_t VALUE32;
  };
} ADI_HAE_H_INDX_t;

/*@}*/

/** @defgroup DSCPTR_NXT Pointer to Next Initial Descriptor (DSCPTR_NXT) Register
 *  Pointer to Next Initial Descriptor (DSCPTR_NXT) Register.
 *
 *  The DSCPTR_NXT register specifies the start location of the next descriptor set, which begins when the DMA activity specified by the current descriptor set completes. This register is read/write prior to enabling the channel, but is read-only after enabling channel. 
 *  
 *  The DSCPTR_NXT register is only used in descriptor list mode. At the start of a descriptor fetch in this mode, the DSCPTR_NXT register is copied into the DSCPTR_CUR register. During descriptor fetch, the DMA_CFG0 increments the DSCPTR_CUR register value after reading each element of the descriptor set.
 *  
 *  In descriptor list mode, the DSCPTR_NXT register (not the DSCPTR_CUR register) must be programmed directly through MMR access, before the DMA operation is started. In descriptor array mode, the DMA_CFG0 disregards the DSCPTR_NXT register and uses the DSCPTR_CUR register to control descriptor fetch.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_DSCPTR_NXT_Struct
 *! \brief  Pointer to Next Initial Descriptor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_DSCPTR_NXT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Pointer To Next Descriptor Set */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_DSCPTR_NXT_t;

/*@}*/

/** @defgroup ADDRSTART Start Address of Current Buffer (ADDRSTART) Register
 *  Start Address of Current Buffer (ADDRSTART) Register.
 *
 *  The ADDRSTART register contains the start address of the Work Unit currently targeted for DMA. This register is read/write prior to enabling the channel, but is  read-only after enabling channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_ADDRSTART_Struct
 *! \brief  Start Address of Current Buffer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_ADDRSTART_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit address start value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_ADDRSTART_t;

/*@}*/

/** @defgroup CFG Configuration Register (CFG) Register
 *  Configuration Register (CFG) Register.
 *
 *  The CFG sets up DMA parameters and operation modes. Other than clearing the EN bit, writing to the CFG register while a DMA process is already running cause a DMA error.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_EN
 *! \brief  DMA Channel Enable (EN) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_DIS = 0,  /**< Disable */
  DMA_CFG_EN  = 1   /**< Enable  */
} ADI_DMA_CFG0_CFG_EN;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_WNR
 *! \brief  Write/Read Channel Direction (WNR) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_READ  = 0,  /**< Transmit (Read from memory) */
  DMA_CFG_WRITE = 1   /**< Receive (Write to memory)   */
} ADI_DMA_CFG0_CFG_WNR;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_SYNC
 *! \brief  Synchronize Work Unit Transitions (SYNC) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_NO_SYNC = 0,  /**< No Synchronization   */
  DMA_CFG_SYNC    = 1   /**< Synchronize Channel  */
} ADI_DMA_CFG0_CFG_SYNC;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_CADDR
 *! \brief  Use Current Address (CADDR) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_LD_STARTADDR = 0,  /**< Load Starting Address */
  DMA_CFG_LD_CURADDR   = 1   /**< Use Current Address   */
} ADI_DMA_CFG0_CFG_CADDR;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_PSIZE
 *! \brief  Peripheral Transfer Word Size (PSIZE) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_PSIZE01 = 0,  /**< 1 Byte  */
  DMA_CFG_PSIZE02 = 1,  /**< 2 Bytes */
  DMA_CFG_PSIZE04 = 2,  /**< 4 Bytes */
  DMA_CFG_PSIZE08 = 3   /**< 8 Bytes */
} ADI_DMA_CFG0_CFG_PSIZE;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_MSIZE
 *! \brief  Memory Transfer Word Size (MSIZE) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_MSIZE01 = 0,  /**< 1 Byte   */
  DMA_CFG_MSIZE02 = 1,  /**< 2 Bytes  */
  DMA_CFG_MSIZE04 = 2,  /**< 4 Bytes  */
  DMA_CFG_MSIZE08 = 3,  /**< 8 Bytes  */
  DMA_CFG_MSIZE16 = 4,  /**< 16 Bytes */
  DMA_CFG_MSIZE32 = 5   /**< 32 Bytes */
} ADI_DMA_CFG0_CFG_MSIZE;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_FLOW
 *! \brief  Next Operation (FLOW) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_STOP     = 0,  /**< STOP - Stop                */
  DMA_CFG_AUTO     = 1,  /**< AUTO - Autobuffer          */
  DMA_CFG_DSCLIST  = 4,  /**< DSCL - Descriptor List     */
  DMA_CFG_DSCARRAY = 5,  /**< DSCA - Descriptor Array    */
  DMA_CFG_DODLIST  = 6,  /**< Descriptor On Demand List  */
  DMA_CFG_DODARRAY = 7   /**< Descriptor On Demand Array */
} ADI_DMA_CFG0_CFG_FLOW;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_TWAIT
 *! \brief  Wait for Trigger (TWAIT) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_NO_TRGWAIT = 0,  /**< Begin Work Unit Automatically (No Wait)  */
  DMA_CFG_TRGWAIT    = 1   /**< Wait for Trigger (Halt before Work Unit) */
} ADI_DMA_CFG0_CFG_TWAIT;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_NDSIZE
 *! \brief  Next Descriptor Set Size (NDSIZE) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_FETCH01 = 0,  /**< Fetch one Descriptor Element    */
  DMA_CFG_FETCH02 = 1,  /**< Fetch two Descriptor Elements   */
  DMA_CFG_FETCH03 = 2,  /**< Fetch three Descriptor Elements */
  DMA_CFG_FETCH04 = 3,  /**< Fetch four Descriptor Elements  */
  DMA_CFG_FETCH05 = 4,  /**< Fetch five Descriptor Elements  */
  DMA_CFG_FETCH06 = 5,  /**< Fetch six Descriptor Elements   */
  DMA_CFG_FETCH07 = 6   /**< Fetch seven Descriptor Elements */
} ADI_DMA_CFG0_CFG_NDSIZE;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_INT
 *! \brief  Generate Interrupt (INT) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_NO_INT     = 0,  /**< Never assert Interrupt         */
  DMA_CFG_XCNT_INT   = 1,  /**< Interrupt when X Count Expires */
  DMA_CFG_YCNT_INT   = 2,  /**< Interrupt when Y Count Expires */
  DMA_CFG_PERIPH_INT = 3   /**< Peripheral Interrupt           */
} ADI_DMA_CFG0_CFG_INT;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_TRIG
 *! \brief  Generate Outgoing Trigger (TRIG) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_NO_TRIG   = 0,  /**< Never assert Trigger           */
  DMA_CFG_XCNT_TRIG = 1,  /**< Trigger when XCNTCUR reaches 0 */
  DMA_CFG_YCNT_TRIG = 2   /**< Trigger when YCNTCUR reaches 0 */
} ADI_DMA_CFG0_CFG_TRIG;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_TOVEN
 *! \brief  Trigger Overrun Error Enable (TOVEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_TOV_DIS = 0,  /**< Ignore Trigger Overrun   */
  DMA_CFG_TOV_EN  = 1   /**< Error on Trigger Overrun */
} ADI_DMA_CFG0_CFG_TOVEN;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_DESCIDCPY
 *! \brief  Descriptor ID Copy Control (DESCIDCPY) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_NO_COPY = 0,  /**< Never Copy                 */
  DMA_CFG_COPY    = 1   /**< Copy on Work Unit Complete */
} ADI_DMA_CFG0_CFG_DESCIDCPY;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_TWOD
 *! \brief  Two Dimension Addressing Enable (TWOD) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_ADDR1D = 0,  /**< One-Dimensional Addressing */
  DMA_CFG_ADDR2D = 1   /**< Two-Dimensional Addressing */
} ADI_DMA_CFG0_CFG_TWOD;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_CFG_PDRF
 *! \brief  Peripheral Data Request Forward (PDRF) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_CFG_PDAT_NOTFWD = 0,  /**< Peripheral Data Request Not Forwarded */
  DMA_CFG_PDAT_FWD    = 1   /**< Peripheral Data Request Forwarded     */
} ADI_DMA_CFG0_CFG_PDRF;


/* ==========================================================================
 *! \struct ADI_DMA_CFG0_CFG_Struct
 *! \brief  Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_CFG_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< DMA Channel Enable */
      unsigned int WNR        :  1;  /**< Write/Read Channel Direction */
      unsigned int SYNC       :  1;  /**< Synchronize Work Unit Transitions */
      unsigned int CADDR      :  1;  /**< Use Current Address */
      unsigned int PSIZE      :  3;  /**< Peripheral Transfer Word Size */
      unsigned int reserved7  :  1;
      unsigned int MSIZE      :  3;  /**< Memory Transfer Word Size */
      unsigned int reserved11 :  1;
      unsigned int FLOW       :  3;  /**< Next Operation */
      unsigned int TWAIT      :  1;  /**< Wait for Trigger */
      unsigned int NDSIZE     :  3;  /**< Next Descriptor Set Size */
      unsigned int reserved19 :  1;
      unsigned int INT        :  2;  /**< Generate Interrupt */
      unsigned int TRIG       :  2;  /**< Generate Outgoing Trigger */
      unsigned int TOVEN      :  1;  /**< Trigger Overrun Error Enable */
      unsigned int DESCIDCPY  :  1;  /**< Descriptor ID Copy Control */
      unsigned int TWOD       :  1;  /**< Two Dimension Addressing Enable */
      unsigned int reserved27 :  1;
      unsigned int PDRF       :  1;  /**< Peripheral Data Request Forward */
      unsigned int reserved29 :  3;
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_CFG_t;

/*@}*/

/** @defgroup XCNT Inner Loop Count Start Value (XCNT) Register
 *  Inner Loop Count Start Value (XCNT) Register.
 *
 *  For 2D DMA, the XCNT contains the inner loop count. This value selects the number of CFG:MSIZE size data transfers to make up the length of a row. For 1D DMA, XCNT specifies the number of CFG:MSIZE size data transfers for the entire work unit. The XCNT register is read/write prior to enabling the channel, but is read-only after enabling channel. Note that the DMA_CFG0 generates a configuration error if XCNT is 0x0 when a work unit begins.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_XCNT_Struct
 *! \brief  Inner Loop Count Start Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_XCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit Inner Loop Counter Start Value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_XCNT_t;

/*@}*/

/** @defgroup XMOD Inner Loop Address Increment (XMOD) Register
 *  Inner Loop Address Increment (XMOD) Register.
 *
 *  The XMOD contains a signed, two's-complement byte address increment. In 1D DMA, this increment is the stride that is applied after each CFG:MSIZE size data transfer. The XMOD register is read/write prior to enabling the channel, but is read-only after enabling channel.
 *  
 *  The XMOD value is specified in bytes, regardless of the work unit size. In 2D DMA, this increment is applied after each CFG:MSIZE size data transfer in the inner loop, up to but not including the last CFG:MSIZE size data transfer in each inner loop. After the last CFG:MSIZE size data transfer in each inner loop, the YMOD register is applied instead, including the last CFG:MSIZE size data transfer of a work unit. 
 *  
 *  The XMOD field may be set to 0. In this case, DMA is performed repeatedly to or from the same address. This approach can be useful for transferring data between a data register and an external memory-mapped peripheral.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_XMOD_Struct
 *! \brief  Inner Loop Address Increment Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_XMOD_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Inner Loop Address Increment in Bytes */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_XMOD_t;

/*@}*/

/** @defgroup YCNT Outer Loop Count Start Value (2D only) (YCNT) Register
 *  Outer Loop Count Start Value (2D only) (YCNT) Register.
 *
 *  For 2D DMA, the YCNT contains the outer loop count. This register is not used in 1D DMA mode. The YCNT register specifies the number of rows in the outer loop of a 2D DMA sequence. The YCNT register is read/write prior to enabling the channel, but is read-only after enabling channel. Note that the DMA_CFG0 generates a configuration error if YCNT is 0x0 when a work unit begins.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_YCNT_Struct
 *! \brief  Outer Loop Count Start Value (2D only) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_YCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit Inner Loop Counter Current Value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_YCNT_t;

/*@}*/

/** @defgroup YMOD Outer Loop Address Increment (2D only) (YMOD) Register
 *  Outer Loop Address Increment (2D only) (YMOD) Register.
 *
 *  The YMOD contains a signed, two's-complement value. This byte address increment is applied after each decrement of the YCNT_CUR register. The value is the offset between the last word of one row and the first word of the next row. Note that YMOD is specified in bytes, regardless of the work unit size. The YMOD register is read/write prior to enabling the channel, but is read-only after enabling channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_YMOD_Struct
 *! \brief  Outer Loop Address Increment (2D only) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_YMOD_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Outer Loop Address Increment in Bytes */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_YMOD_t;

/*@}*/

/** @defgroup DSCPTR_CUR Current Descriptor Pointer (DSCPTR_CUR) Register
 *  Current Descriptor Pointer (DSCPTR_CUR) Register.
 *
 *  The DSCPTR_CUR contains the memory address for the next descriptor to be loaded. The DSCPTR_CUR register is read/write prior to enabling the channel, but is read-only after enabling channel. For CFG:FLOW mode settings that involve descriptor fetches, this register is used to read descriptors into appropriate MMRs before a work unit begins. For descriptor list mode, the DSCPTR_CUR is initialized from the DSCPTR_NXT register before fetching each descriptor set. Then, the address in the DSCPTR_CUR register increments as each descriptor is read in.
 *  
 *  When the entire descriptor set has been read, the DSCPTR_CUR register contains this value:
 *  
 *  DSCPTR_CUR = Descriptor Start Address + Descriptor Size (# of elements)
 *  
 *  For descriptor array mode, the DSCPTR_CUR register, and not the DSCPTR_NXT register, must be programmed by MMR access before starting DMA operation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_DSCPTR_CUR_Struct
 *! \brief  Current Descriptor Pointer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_DSCPTR_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Pointer for Current Descriptor Element */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_DSCPTR_CUR_t;

/*@}*/

/** @defgroup DSCPTR_PRV Previous Initial Descriptor Pointer (DSCPTR_PRV) Register
 *  Previous Initial Descriptor Pointer (DSCPTR_PRV) Register.
 *
 *  The DSCPTR_PRV contains the initial descriptor pointer for the previous work unit. If CFG:DESCIDCPY is set, the DMA_CFG0 copies the initial descriptor pointer to DSCPTR_PRV after the work unit completes. Otherwise, the value is not updated.
 *  
 *  To indicate an overrun, bit 0 of DSCPTR_PRV is used as a previous descriptor pointer overrun (PDPO) status bit. Due to aligned addressing combined with all descriptors being 32 bits in width, bits 0 and 1 of all descriptor pointers must be zero. Otherwise, an alignment error would occur when used for descriptor fetches. As a result, bit 1 and 0 of DSCPTR_PRV may be used for status. For more information, see the section on descriptor pointer capture in the DMA_CFG0 functional description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_DSCPTR_PRV_Struct
 *! \brief  Previous Initial Descriptor Pointer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_DSCPTR_PRV_t {
  union {
    struct {
      unsigned int PDPO       :  1;  /**< Previous Descriptor Pointer Overrun */
      unsigned int reserved1  :  1;
      unsigned int DESCPPREV  : 30;  /**< Pointer for Previous Descriptor Element */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_DSCPTR_PRV_t;

/*@}*/

/** @defgroup ADDR_CUR Current Address (ADDR_CUR) Register
 *  Current Address (ADDR_CUR) Register.
 *
 *  The ADDR_CUR contains the present memory transfer address for a given work unit. At the start of a work unit, the ADDR_CUR is loaded from the ADDRSTART register, and ADDR_CUR is incremented as each transfer occurs. The ADDR_CUR register is read/write prior to enabling the channel, but is read-only after enabling channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_ADDR_CUR_Struct
 *! \brief  Current Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_ADDR_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit current address value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_ADDR_CUR_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT indicates status of DMA work units, FIFO, errors, interrupts, and triggers.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_IRQDONE
 *! \brief  Work Unit/Row Done Interrupt (IRQDONE) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_NO_IRQ  = 0,  /**< Inactive */
  DMA_STAT_IRQDONE = 1   /**< Active   */
} ADI_DMA_CFG0_STAT_IRQDONE;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_IRQERR
 *! \brief  Error Interrupt (IRQERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_NO_IRQERR = 0,  /**< No Error       */
  DMA_STAT_IRQERR    = 1   /**< Error Occurred */
} ADI_DMA_CFG0_STAT_IRQERR;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_PIRQ
 *! \brief  Peripheral Interrupt Request (PIRQ) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_NO_PIRQ = 0,  /**< No Interrupt                     */
  DMA_STAT_PIRQ    = 1   /**< Interrupt Signaled by Peripheral */
} ADI_DMA_CFG0_STAT_PIRQ;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_ERRC
 *! \brief  Error Cause (ERRC) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_CFGERR   = 0,  /**< Configuration Error                          */
  DMA_STAT_ILLWRERR = 1,  /**< Illegal Write Occurred While Channel Running */
  DMA_STAT_ALGNERR  = 2,  /**< Address Alignment Error                      */
  DMA_STAT_MEMERR   = 3,  /**< Memory Access/Fabric Error                   */
  DMA_STAT_TRGOVERR = 5,  /**< Trigger Overrun                              */
  DMA_STAT_BWMONERR = 6   /**< Bandwidth Monitor Error                      */
} ADI_DMA_CFG0_STAT_ERRC;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_RUN
 *! \brief  Run Status (RUN) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_STOPPED  = 0,  /**< Idle/Stop State                                */
  DMA_STAT_DSCFETCH = 1,  /**< Descriptor Fetch                               */
  DMA_STAT_DATAXFER = 2,  /**< Data Transfer                                  */
  DMA_STAT_TRGWAIT  = 3,  /**< Waiting for Trigger                            */
  DMA_STAT_ACKWAIT  = 4   /**< Waiting for Write ACK/FIFO Drain to Peripheral */
} ADI_DMA_CFG0_STAT_RUN;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_PBWID
 *! \brief  Peripheral Bus Width (PBWID) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_PBUS01 = 0,  /**< 1 Byte  */
  DMA_STAT_PBUS02 = 1,  /**< 2 Bytes */
  DMA_STAT_PBUS04 = 2,  /**< 4 Bytes */
  DMA_STAT_PBUS08 = 3   /**< 8 Bytes */
} ADI_DMA_CFG0_STAT_PBWID;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_MBWID
 *! \brief  Memory Bus Width (MBWID) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_MBUS02 = 0,  /**< 2 Bytes  */
  DMA_STAT_MBUS04 = 1,  /**< 4 Bytes  */
  DMA_STAT_MBUS08 = 2,  /**< 8 Bytes  */
  DMA_STAT_MBUS16 = 3   /**< 16 Bytes */
} ADI_DMA_CFG0_STAT_MBWID;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_FIFOFILL
 *! \brief  FIFO Fill Status (FIFOFILL) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_FIFOEMPTY    = 0,  /**< Empty                      */
  DMA_STAT_FIFO25       = 1,  /**< Empty < FIFO = 1/4 Full    */
  DMA_STAT_FIFO50       = 2,  /**< 1/4 Full < FIFO = 1/2 Full */
  DMA_STAT_FIFO75       = 3,  /**< 1/2 Full < FIFO = 3/4 Full */
  DMA_STAT_FIFONEARFULL = 4,  /**< 3/4 Full < FIFO = Full     */
  DMA_STAT_FIFOFULL     = 7   /**< Full                       */
} ADI_DMA_CFG0_STAT_FIFOFILL;


/*  =========================================================================
 *! \enum   ADI_DMA_CFG0_STAT_TWAIT
 *! \brief  Trigger Wait Status (TWAIT) Enumerations
 *  ========================================================================= */
typedef enum
{
  DMA_STAT_NOTRIGRX = 0,  /**< No trigger received */
  DMA_STAT_TRIGRX   = 1   /**< Trigger received    */
} ADI_DMA_CFG0_STAT_TWAIT;


/* ==========================================================================
 *! \struct ADI_DMA_CFG0_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_STAT_t {
  union {
    struct {
      unsigned int IRQDONE    :  1;  /**< Work Unit/Row Done Interrupt */
      unsigned int IRQERR     :  1;  /**< Error Interrupt */
      unsigned int PIRQ       :  1;  /**< Peripheral Interrupt Request */
      unsigned int reserved3  :  1;
      unsigned int ERRC       :  3;  /**< Error Cause */
      unsigned int reserved7  :  1;
      unsigned int RUN        :  3;  /**< Run Status */
      unsigned int reserved11 :  1;
      unsigned int PBWID      :  2;  /**< Peripheral Bus Width */
      unsigned int MBWID      :  2;  /**< Memory Bus Width */
      unsigned int FIFOFILL   :  3;  /**< FIFO Fill Status */
      unsigned int reserved19 :  1;
      unsigned int TWAIT      :  1;  /**< Trigger Wait Status */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_STAT_t;

/*@}*/

/** @defgroup XCNT_CUR Current Count(1D) or intra-row XCNT (2D) (XCNT_CUR) Register
 *  Current Count(1D) or intra-row XCNT (2D) (XCNT_CUR) Register.
 *
 *  For 1D DMA, the DMA_CFG0 loads the XCNT_CUR from the XCNT register at the beginning of each work unit. For 2D DMA, the DMA_CFG0 loads XCNT_CUR from the XCNT register after the end of each row. The DMA_CFG0 decrements the value in XCNT_CUR each time a CFG:MSIZE size data transfer occurs. When the count in XCNT_CUR expires, the work unit is complete. In 2D DMA, the XCNT_CUR value is 0 only when the entire transfer is complete.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_XCNT_CUR_Struct
 *! \brief  Current Count(1D) or intra-row XCNT (2D) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_XCNT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit outer loop counter start value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_XCNT_CUR_t;

/*@}*/

/** @defgroup YCNT_CUR Current Row Count (2D only) (YCNT_CUR) Register
 *  Current Row Count (2D only) (YCNT_CUR) Register.
 *
 *  For 2D DMA, the DMA_CFG0 loads the YCNT_CUR from the YCNT register at the beginning of each 2D DMA session. The YCNT_CUR is not used for 1D DMA. The DMA_CFG0 decrements YCNT_CUR each time the XCNT_CUR expires during 2D DMA operation, signifying completion of an entire row transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG0_YCNT_CUR_Struct
 *! \brief  Current Row Count (2D only) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG0_YCNT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit outer loop counter current value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG0_YCNT_CUR_t;

/*@}*/

/** @defgroup DSCPTR_NXT Pointer to Next Initial Descriptor (DSCPTR_NXT) Register
 *  Pointer to Next Initial Descriptor (DSCPTR_NXT) Register.
 *
 *  The DSCPTR_NXT register specifies the start location of the next descriptor set, which begins when the DMA activity specified by the current descriptor set completes. This register is read/write prior to enabling the channel, but is read-only after enabling channel. 
 *  
 *  The DSCPTR_NXT register is only used in descriptor list mode. At the start of a descriptor fetch in this mode, the DSCPTR_NXT register is copied into the DSCPTR_CUR register. During descriptor fetch, the DMA_CFG1 increments the DSCPTR_CUR register value after reading each element of the descriptor set.
 *  
 *  In descriptor list mode, the DSCPTR_NXT register (not the DSCPTR_CUR register) must be programmed directly through MMR access, before the DMA operation is started. In descriptor array mode, the DMA_CFG1 disregards the DSCPTR_NXT register and uses the DSCPTR_CUR register to control descriptor fetch.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_DSCPTR_NXT_Struct
 *! \brief  Pointer to Next Initial Descriptor Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_DSCPTR_NXT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Pointer To Next Descriptor Set */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_DSCPTR_NXT_t;

/*@}*/

/** @defgroup ADDRSTART Start Address of Current Buffer (ADDRSTART) Register
 *  Start Address of Current Buffer (ADDRSTART) Register.
 *
 *  The ADDRSTART register contains the start address of the Work Unit currently targeted for DMA. This register is read/write prior to enabling the channel, but is  read-only after enabling channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_ADDRSTART_Struct
 *! \brief  Start Address of Current Buffer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_ADDRSTART_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit address start value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_ADDRSTART_t;

/*@}*/

/** @defgroup CFG Configuration Register (CFG) Register
 *  Configuration Register (CFG) Register.
 *
 *  The CFG sets up DMA parameters and operation modes. Other than clearing the EN bit, writing to the CFG register while a DMA process is already running cause a DMA error.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_CFG_Struct
 *! \brief  Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_CFG_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< DMA Channel Enable */
      unsigned int WNR        :  1;  /**< Write/Read Channel Direction */
      unsigned int SYNC       :  1;  /**< Synchronize Work Unit Transitions */
      unsigned int CADDR      :  1;  /**< Use Current Address */
      unsigned int PSIZE      :  3;  /**< Peripheral Transfer Word Size */
      unsigned int reserved7  :  1;
      unsigned int MSIZE      :  3;  /**< Memory Transfer Word Size */
      unsigned int reserved11 :  1;
      unsigned int FLOW       :  3;  /**< Next Operation */
      unsigned int TWAIT      :  1;  /**< Wait for Trigger */
      unsigned int NDSIZE     :  3;  /**< Next Descriptor Set Size */
      unsigned int reserved19 :  1;
      unsigned int INT        :  2;  /**< Generate Interrupt */
      unsigned int TRIG       :  2;  /**< Generate Outgoing Trigger */
      unsigned int TOVEN      :  1;  /**< Trigger Overrun Error Enable */
      unsigned int DESCIDCPY  :  1;  /**< Descriptor ID Copy Control */
      unsigned int TWOD       :  1;  /**< Two Dimension Addressing Enable */
      unsigned int reserved27 :  1;
      unsigned int PDRF       :  1;  /**< Peripheral Data Request Forward */
      unsigned int reserved29 :  3;
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_CFG_t;

/*@}*/

/** @defgroup XCNT Inner Loop Count Start Value (XCNT) Register
 *  Inner Loop Count Start Value (XCNT) Register.
 *
 *  For 2D DMA, the XCNT contains the inner loop count. This value selects the number of CFG:MSIZE size data transfers to make up the length of a row. For 1D DMA, XCNT specifies the number of CFG:MSIZE size data transfers for the entire work unit. The XCNT register is read/write prior to enabling the channel, but is read-only after enabling channel. Note that the DMA_CFG1 generates a configuration error if XCNT is 0x0 when a work unit begins.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_XCNT_Struct
 *! \brief  Inner Loop Count Start Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_XCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit Inner Loop Counter Start Value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_XCNT_t;

/*@}*/

/** @defgroup XMOD Inner Loop Address Increment (XMOD) Register
 *  Inner Loop Address Increment (XMOD) Register.
 *
 *  The XMOD contains a signed, two's-complement byte address increment. In 1D DMA, this increment is the stride that is applied after each CFG:MSIZE size data transfer. The XMOD register is read/write prior to enabling the channel, but is read-only after enabling channel.
 *  
 *  The XMOD value is specified in bytes, regardless of the work unit size. In 2D DMA, this increment is applied after each CFG:MSIZE size data transfer in the inner loop, up to but not including the last CFG:MSIZE size data transfer in each inner loop. After the last CFG:MSIZE size data transfer in each inner loop, the YMOD register is applied instead, including the last CFG:MSIZE size data transfer of a work unit. 
 *  
 *  The XMOD field may be set to 0. In this case, DMA is performed repeatedly to or from the same address. This approach can be useful for transferring data between a data register and an external memory-mapped peripheral.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_XMOD_Struct
 *! \brief  Inner Loop Address Increment Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_XMOD_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Inner Loop Address Increment in Bytes */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_XMOD_t;

/*@}*/

/** @defgroup YCNT Outer Loop Count Start Value (2D only) (YCNT) Register
 *  Outer Loop Count Start Value (2D only) (YCNT) Register.
 *
 *  For 2D DMA, the YCNT contains the outer loop count. This register is not used in 1D DMA mode. The YCNT register specifies the number of rows in the outer loop of a 2D DMA sequence. The YCNT register is read/write prior to enabling the channel, but is read-only after enabling channel. Note that the DMA_CFG1 generates a configuration error if YCNT is 0x0 when a work unit begins.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_YCNT_Struct
 *! \brief  Outer Loop Count Start Value (2D only) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_YCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit Inner Loop Counter Current Value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_YCNT_t;

/*@}*/

/** @defgroup YMOD Outer Loop Address Increment (2D only) (YMOD) Register
 *  Outer Loop Address Increment (2D only) (YMOD) Register.
 *
 *  The YMOD contains a signed, two's-complement value. This byte address increment is applied after each decrement of the YCNT_CUR register. The value is the offset between the last word of one row and the first word of the next row. Note that YMOD is specified in bytes, regardless of the work unit size. The YMOD register is read/write prior to enabling the channel, but is read-only after enabling channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_YMOD_Struct
 *! \brief  Outer Loop Address Increment (2D only) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_YMOD_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Outer Loop Address Increment in Bytes */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_YMOD_t;

/*@}*/

/** @defgroup DSCPTR_CUR Current Descriptor Pointer (DSCPTR_CUR) Register
 *  Current Descriptor Pointer (DSCPTR_CUR) Register.
 *
 *  The DSCPTR_CUR contains the memory address for the next descriptor to be loaded. The DSCPTR_CUR register is read/write prior to enabling the channel, but is read-only after enabling channel. For CFG:FLOW mode settings that involve descriptor fetches, this register is used to read descriptors into appropriate MMRs before a work unit begins. For descriptor list mode, the DSCPTR_CUR is initialized from the DSCPTR_NXT register before fetching each descriptor set. Then, the address in the DSCPTR_CUR register increments as each descriptor is read in.
 *  
 *  When the entire descriptor set has been read, the DSCPTR_CUR register contains this value:
 *  
 *  DSCPTR_CUR = Descriptor Start Address + Descriptor Size (# of elements)
 *  
 *  For descriptor array mode, the DSCPTR_CUR register, and not the DSCPTR_NXT register, must be programmed by MMR access before starting DMA operation.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_DSCPTR_CUR_Struct
 *! \brief  Current Descriptor Pointer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_DSCPTR_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Pointer for Current Descriptor Element */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_DSCPTR_CUR_t;

/*@}*/

/** @defgroup DSCPTR_PRV Previous Initial Descriptor Pointer (DSCPTR_PRV) Register
 *  Previous Initial Descriptor Pointer (DSCPTR_PRV) Register.
 *
 *  The DSCPTR_PRV contains the initial descriptor pointer for the previous work unit. If CFG:DESCIDCPY is set, the DMA_CFG1 copies the initial descriptor pointer to DSCPTR_PRV after the work unit completes. Otherwise, the value is not updated.
 *  
 *  To indicate an overrun, bit 0 of DSCPTR_PRV is used as a previous descriptor pointer overrun (PDPO) status bit. Due to aligned addressing combined with all descriptors being 32 bits in width, bits 0 and 1 of all descriptor pointers must be zero. Otherwise, an alignment error would occur when used for descriptor fetches. As a result, bit 1 and 0 of DSCPTR_PRV may be used for status. For more information, see the section on descriptor pointer capture in the DMA_CFG1 functional description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_DSCPTR_PRV_Struct
 *! \brief  Previous Initial Descriptor Pointer Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_DSCPTR_PRV_t {
  union {
    struct {
      unsigned int PDPO       :  1;  /**< Previous Descriptor Pointer Overrun */
      unsigned int reserved1  :  1;
      unsigned int DESCPPREV  : 30;  /**< Pointer for Previous Descriptor Element */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_DSCPTR_PRV_t;

/*@}*/

/** @defgroup ADDR_CUR Current Address (ADDR_CUR) Register
 *  Current Address (ADDR_CUR) Register.
 *
 *  The ADDR_CUR contains the present memory transfer address for a given work unit. At the start of a work unit, the ADDR_CUR is loaded from the ADDRSTART register, and ADDR_CUR is incremented as each transfer occurs. The ADDR_CUR register is read/write prior to enabling the channel, but is read-only after enabling channel.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_ADDR_CUR_Struct
 *! \brief  Current Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_ADDR_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit current address value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_ADDR_CUR_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT indicates status of DMA work units, FIFO, errors, interrupts, and triggers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_STAT_t {
  union {
    struct {
      unsigned int IRQDONE    :  1;  /**< Work Unit/Row Done Interrupt */
      unsigned int IRQERR     :  1;  /**< Error Interrupt */
      unsigned int PIRQ       :  1;  /**< Peripheral Interrupt Request */
      unsigned int reserved3  :  1;
      unsigned int ERRC       :  3;  /**< Error Cause */
      unsigned int reserved7  :  1;
      unsigned int RUN        :  3;  /**< Run Status */
      unsigned int reserved11 :  1;
      unsigned int PBWID      :  2;  /**< Peripheral Bus Width */
      unsigned int MBWID      :  2;  /**< Memory Bus Width */
      unsigned int FIFOFILL   :  3;  /**< FIFO Fill Status */
      unsigned int reserved19 :  1;
      unsigned int TWAIT      :  1;  /**< Trigger Wait Status */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_STAT_t;

/*@}*/

/** @defgroup XCNT_CUR Current Count(1D) or intra-row XCNT (2D) (XCNT_CUR) Register
 *  Current Count(1D) or intra-row XCNT (2D) (XCNT_CUR) Register.
 *
 *  For 1D DMA, the DMA_CFG1 loads the XCNT_CUR from the XCNT register at the beginning of each work unit. For 2D DMA, the DMA_CFG1 loads XCNT_CUR from the XCNT register after the end of each row. The DMA_CFG1 decrements the value in XCNT_CUR each time a CFG:MSIZE size data transfer occurs. When the count in XCNT_CUR expires, the work unit is complete. In 2D DMA, the XCNT_CUR value is 0 only when the entire transfer is complete.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_XCNT_CUR_Struct
 *! \brief  Current Count(1D) or intra-row XCNT (2D) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_XCNT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit outer loop counter start value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_XCNT_CUR_t;

/*@}*/

/** @defgroup YCNT_CUR Current Row Count (2D only) (YCNT_CUR) Register
 *  Current Row Count (2D only) (YCNT_CUR) Register.
 *
 *  For 2D DMA, the DMA_CFG1 loads the YCNT_CUR from the YCNT register at the beginning of each 2D DMA session. The YCNT_CUR is not used for 1D DMA. The DMA_CFG1 decrements YCNT_CUR each time the XCNT_CUR expires during 2D DMA operation, signifying completion of an entire row transfer.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_YCNT_CUR_Struct
 *! \brief  Current Row Count (2D only) Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_YCNT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Work Unit outer loop counter current value */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_YCNT_CUR_t;

/*@}*/

/** @defgroup BWLCNT Bandwidth Limit Count (BWLCNT) Register
 *  Bandwidth Limit Count (BWLCNT) Register.
 *
 *  The BWLCNT contains a count that determines how often the DMA_CFG1 issues memory transactions. The DMA_CFG1 loads the value from BWLCNT into BWLCNT_CUR and decrements the current value each SCLK cycle. When BWLCNT_CUR reaches 0x0000, the next request is issued, and the DMA_CFG1 reloads BWLCNT_CUR. This bandwidth limit functionality is not applied to descriptor fetch requests. Programming 0x0000 allows the DMA_CFG1 to request as often as possible. 0xFFFF is a special case and causes requests to stop.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_BWLCNT_Struct
 *! \brief  Bandwidth Limit Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_BWLCNT_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Bandwidth Limit Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_BWLCNT_t;

/*@}*/

/** @defgroup BWLCNT_CUR Bandwidth Limit Count Current (BWLCNT_CUR) Register
 *  Bandwidth Limit Count Current (BWLCNT_CUR) Register.
 *
 *  The BWLCNT_CUR contains the number of SCLK count cycles remaining before the next request is issued.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_BWLCNT_CUR_Struct
 *! \brief  Bandwidth Limit Count Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_BWLCNT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Bandwidth Limit Count Current */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_BWLCNT_CUR_t;

/*@}*/

/** @defgroup BWMCNT Bandwidth Monitor Count (BWMCNT) Register
 *  Bandwidth Monitor Count (BWMCNT) Register.
 *
 *  The BWMCNT contains the maximum number of SCLK cycles allowed for a work unit to complete. Each time the CFG register is written (MMR access only), a work unit ends, or an autobuffer wraps, the DMA_CFG1 loads the value in BWMCNT into BWMCNT_CUR. The DMA_CFG1 decrements BWMCNT_CUR every SCLK a work unit is active. If BWMCNT_CUR reaches 0x0000_0000, the STAT:IRQERR bit is set, and the STAT:ERRC is set to 0x6. The BWMCNT_CUR remains at 0x0000_0000 until it is reloaded when the work unit completes. Unlike other error causes, a bandwidth monitor error does not stop work unit processing. Programming 0x0000_0000 disables bandwidth monitor functionality.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_BWMCNT_Struct
 *! \brief  Bandwidth Monitor Count Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_BWMCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Bandwidth Monitor Count */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_BWMCNT_t;

/*@}*/

/** @defgroup BWMCNT_CUR Bandwidth Monitor Count Current (BWMCNT_CUR) Register
 *  Bandwidth Monitor Count Current (BWMCNT_CUR) Register.
 *
 *  The BWMCNT_CUR contains the number of cycles remaining for the current descriptor to complete.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DMA_CFG1_BWMCNT_CUR_Struct
 *! \brief  Bandwidth Monitor Count Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DMA_CFG1_BWMCNT_CUR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Bandwidth Monitor Count Current */
    };
    uint32_t VALUE32;
  };
} ADI_DMA_CFG1_BWMCNT_CUR_t;

/*@}*/

/** @defgroup CTL Port 0 control register (CTL) Register
 *  Port 0 control register (CTL) Register.
 *
 *  Port 0 control register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT0_CTL_Struct
 *! \brief  Port 0 control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT0_CTL_t {
  union {
    struct {
      unsigned int EERR       :  1;  /**< Enable interrupt on ECC multi-bit (> 1 bit) error detection for port 0 accesses. */
      unsigned int reserved1  : 15;
      unsigned int SWINT      :  1;  /**< Enable software interrupt to port 0. */
      unsigned int reserved17 : 14;
      unsigned int LOCK       :  1;  /**< Lock enable */
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT0_CTL_t;

/*@}*/

/** @defgroup FORCEIRQ Port 0 force IRQ register (FORCEIRQ) Register
 *  Port 0 force IRQ register (FORCEIRQ) Register.
 *
 *  Port 0 force interrupt request register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT0_FORCEIRQ_Struct
 *! \brief  Port 0 force IRQ Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT0_FORCEIRQ_t {
  union {
    struct {
      unsigned int SWIRQ      :  1;  /**< Initiate software interrupt to port 1. */
      unsigned int reserved1  : 31;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT0_FORCEIRQ_t;

/*@}*/

/** @defgroup STAT Port 0 status register (STAT) Register
 *  Port 0 status register (STAT) Register.
 *
 *  Port 0 status register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT0_STAT_Struct
 *! \brief  Port 0 status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT0_STAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int SWINT      :  1;  /**< Software interrupt status to port 0. While 0x1 the port0_msg level interrupt will be asserted. */
      unsigned int EXWR       :  1;  /**< Port 0 exclusive write status. */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT0_STAT_t;

/*@}*/

/** @defgroup ESTAT Port 0 ECC status register (ESTAT) Register
 *  Port 0 ECC status register (ESTAT) Register.
 *
 *  Port 0 ECC status register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT0_ESTAT_Struct
 *! \brief  Port 0 ECC status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT0_ESTAT_t {
  union {
    struct {
      unsigned int EERR       :  1;  /**< ECC multi-bit error (> 1 bit), indicating one detection event due to port 0 accesses. */
      unsigned int MEERR      :  1;  /**< Multiple ECC multi-bit errors detected  (> 1 bit), indicating more than one detection events due to port 0 accesses. */
      unsigned int reserved2  :  8;
      unsigned int EERRADDR   : 10;  /**< Bits [11:2] of the address of the 32-bit location containing the detected ECC error event. */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT0_ESTAT_t;

/*@}*/

/** @defgroup CTL Port 1 control register (CTL) Register
 *  Port 1 control register (CTL) Register.
 *
 *  Port 1 control register
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_MBOX_PORT1_CTL_MAP
 *! \brief  Select ECC map mode (MAP) Enumerations
 *  ========================================================================= */
typedef enum
{
  MBOX_PORT1_CTL_NORMAL   = 0,  /**< Enable ECC normal mode.     */
  MBOX_PORT1_CTL_MAP_DATA = 2,  /**< Enable ECC map data mode.   */
  MBOX_PORT1_CTL_MAP_ECC  = 3   /**< Enable ECC map parity mode. */
} ADI_MBOX_PORT1_CTL_MAP;


/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_CTL_Struct
 *! \brief  Port 1 control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_CTL_t {
  union {
    struct {
      unsigned int EERR       :  1;  /**< Enable interrupt on ECC multi-bit (> 1 bit) error detection for port 1 accesses and auto-refresh accesses. */
      unsigned int reserved1  :  1;
      unsigned int MAP        :  2;  /**< Select ECC map mode */
      unsigned int RFR        :  1;  /**< Enable auto-refresh of the ECC states. */
      unsigned int reserved5  :  3;
      unsigned int INIT       :  1;  /**< Enable memory initialization */
      unsigned int INITDONE   :  1;  /**< Enable interrupt on memory initialization completion. */
      unsigned int reserved10 :  6;
      unsigned int SWINT      :  1;  /**< Enable software interrupt to port 1. */
      unsigned int reserved17 : 14;
      unsigned int LOCK       :  1;  /**< Lock enable */
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_CTL_t;

/*@}*/

/** @defgroup FORCEIRQ Port 1 force IRQ register (FORCEIRQ) Register
 *  Port 1 force IRQ register (FORCEIRQ) Register.
 *
 *  Port 1 force interrupt request register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_FORCEIRQ_Struct
 *! \brief  Port 1 force IRQ Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_FORCEIRQ_t {
  union {
    struct {
      unsigned int SWIRQ      :  1;  /**< Initiate software interrupt to port 0. */
      unsigned int reserved1  : 31;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_FORCEIRQ_t;

/*@}*/

/** @defgroup STAT Port 1 status register (STAT) Register
 *  Port 1 status register (STAT) Register.
 *
 *  Port 1 status register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_STAT_Struct
 *! \brief  Port 1 status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_STAT_t {
  union {
    struct {
      unsigned int INITPND    :  1;  /**< Initialization pending status. */
      unsigned int INITDONE   :  1;  /**< Initialization done interrupt status. */
      unsigned int reserved2  :  2;
      unsigned int SWINT      :  1;  /**< Software interrupt status to port 1. While 0x1 the port1_msg level interrupt will be asserted. */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_STAT_t;

/*@}*/

/** @defgroup ESTAT Port 1 ECC status register (ESTAT) Register
 *  Port 1 ECC status register (ESTAT) Register.
 *
 *  Port 1 ECC status register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_ESTAT_Struct
 *! \brief  Port 1 ECC status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_ESTAT_t {
  union {
    struct {
      unsigned int EERR       :  1;  /**< ECC multi-bit error (> 1 bit), indicating one detection event due to either port 1 access or an auto-refresh access. */
      unsigned int MEERR      :  1;  /**< Multiple ECC multi-bit errors detected  (> 1 bit), indicating more than one detection events due to either port 1 access or an auto-refresh access. */
      unsigned int reserved2  :  2;
      unsigned int EERRTYPE   :  1;  /**< ECC multi-bit error access type */
      unsigned int EWRNTYPE   :  1;  /**< ECC single bit error access type */
      unsigned int reserved6  :  4;
      unsigned int EERRADDR   : 10;  /**< Bits [11:2] of the address of the 32-bit location containing the detected ECC error event. */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_ESTAT_t;

/*@}*/

/** @defgroup RFRPER Auto-refresh period register (RFRPER) Register
 *  Auto-refresh period register (RFRPER) Register.
 *
 *  Auto-refresh period register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_RFRPER_Struct
 *! \brief  Auto-refresh period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_RFRPER_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< ECC Memory auto-refresh period */
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_RFRPER_t;

/*@}*/

/** @defgroup RFRADDR Auto-refresh address register (RFRADDR) Register
 *  Auto-refresh address register (RFRADDR) Register.
 *
 *  Auto-refresh address register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_RFRADDR_Struct
 *! \brief  Auto-refresh address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_RFRADDR_t {
  union {
    struct {
      unsigned int reserved0  :  2;
      unsigned int VALUE      : 10;  /**< Auto-refresh Address value */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_RFRADDR_t;

/*@}*/

/** @defgroup RFRCNT Auto-refresh counter register (RFRCNT) Register
 *  Auto-refresh counter register (RFRCNT) Register.
 *
 *  Auto-refresh counter register
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_MBOX_PORT1_RFRCNT_Struct
 *! \brief  Auto-refresh counter Register bit field structure
 * ========================================================================== */
typedef struct _ADI_MBOX_PORT1_RFRCNT_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< ECC auto-refresh count down counter value */
    };
    uint32_t VALUE32;
  };
} ADI_MBOX_PORT1_RFRCNT_t;

/*@}*/

/** @defgroup CTL SMPU Control Register (CTL) Register
 *  SMPU Control Register (CTL) Register.
 *
 *  The CTL register provides access to the locking control, error interrupts and SMPU violations.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_CTL_RSDIS
 *! \brief  Read Speculation Disable (RSDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_CTL_RSEN  = 0,  /**< Read Speculation Enable  */
  SMPU_CTL_RSDIS = 1   /**< Read Speculation Disable */
} ADI_SMPU_CFG0_CTL_RSDIS;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_CTL_PBEDIS
 *! \brief  Protection Violation Bus Error Disable (PBEDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_CTL_PBEEN  = 0,  /**< Bus Error Generation Enable  */
  SMPU_CTL_PBEDIS = 1   /**< Bus Error Generation Disable */
} ADI_SMPU_CFG0_CTL_PBEDIS;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_CTL_PBETYPE
 *! \brief  Protection Violation Bus Error Type (PBETYPE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_CTL_DECERR = 0,  /**< Decode Error Type */
  SMPU_CTL_SLVERR = 1   /**< Save Error Type   */
} ADI_SMPU_CFG0_CTL_PBETYPE;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_CTL_PINTEN
 *! \brief  Protection Violation Interrupt Enable (PINTEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_CTL_PINTDIS = 0,  /**< Protection Violation IRQ Disable */
  SMPU_CTL_PINTEN  = 1   /**< Protection Violation IRQ Enable  */
} ADI_SMPU_CFG0_CTL_PINTEN;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_CTL_Struct
 *! \brief  SMPU Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_CTL_t {
  union {
    struct {
      unsigned int RSDIS      :  1;  /**< Read Speculation Disable */
      unsigned int PBEDIS     :  1;  /**< Protection Violation Bus Error Disable */
      unsigned int PBETYPE    :  1;  /**< Protection Violation Bus Error Type */
      unsigned int PINTEN     :  1;  /**< Protection Violation Interrupt Enable */
      unsigned int RLOCK      :  1;  /**< RCTLn, RADDRn, RIDxn and RIDMxn Registers Lock Bit */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_CTL_t;

/*@}*/

/** @defgroup STAT SMPU Status Register (STAT) Register
 *  SMPU Status Register (STAT) Register.
 *
 *  The STAT register provides the state of the SMPU and indicates various errors.  All bits in this register are write '1' to clear.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_STAT_IRQ
 *! \brief  Interrupt Request (IRQ) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_STAT_NOIRQ = 0,  /**< No Interrupt since this bit has been cleared */
  SMPU_STAT_IRQ   = 1   /**< Interrupt has been generated                 */
} ADI_SMPU_CFG0_STAT_IRQ;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_STAT_IOVR
 *! \brief  Interrupt Overrun (IOVR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_STAT_NOIOVR = 0,  /**< No Interrupt overrun          */
  SMPU_STAT_IOVR   = 1   /**< Interrupt overrun has occured */
} ADI_SMPU_CFG0_STAT_IOVR;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_STAT_BERR
 *! \brief  Bus Error (BERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_STAT_NOBERR = 0,  /**< No Bus Error since this bit has been cleared */
  SMPU_STAT_BERR   = 1   /**< Bus Error has been generated                 */
} ADI_SMPU_CFG0_STAT_BERR;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_STAT_BEOVR
 *! \brief  Bus Error Overrun (BEOVR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_STAT_NOBEOVR = 0,  /**< No Bus Error overrun          */
  SMPU_STAT_BEOVR   = 1   /**< Bus Error overrun has occured */
} ADI_SMPU_CFG0_STAT_BEOVR;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_STAT_ADRERR
 *! \brief  Address Error (ADRERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_STAT_NOADRERR = 0,  /**< No Address Error */
  SMPU_STAT_ADRERR   = 1   /**< Address Error    */
} ADI_SMPU_CFG0_STAT_ADRERR;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_STAT_LWERR
 *! \brief  Lock Write Error (LWERR) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_STAT_NOLWERR = 0,  /**< No Lock Write Error */
  SMPU_STAT_LWERR   = 1   /**< Lock Write Error    */
} ADI_SMPU_CFG0_STAT_LWERR;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_STAT_Struct
 *! \brief  SMPU Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_STAT_t {
  union {
    struct {
      unsigned int IRQ        :  1;  /**< Interrupt Request */
      unsigned int IOVR       :  1;  /**< Interrupt Overrun */
      unsigned int BERR       :  1;  /**< Bus Error */
      unsigned int BEOVR      :  1;  /**< Bus Error Overrun */
      unsigned int reserved4  : 12;
      unsigned int ADRERR     :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
      unsigned int reserved18 : 14;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_STAT_t;

/*@}*/

/** @defgroup IADDR Interrupt Address Register (IADDR) Register
 *  Interrupt Address Register (IADDR) Register.
 *
 *  The IADDR register indicates an attempt to make a read or write access to unimplemented addresses or accesses are non-aligned. The SMPU_CFG0 issues a bus error for this condition.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_IADDR_Struct
 *! \brief  Interrupt Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_IADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Interrupt Address */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_IADDR_t;

/*@}*/

/** @defgroup IDTLS Interrupt Details Register (IDTLS) Register
 *  Interrupt Details Register (IDTLS) Register.
 *
 *  The IDTLS register provides the ID of the last signaled interrupt, whether the interrupt was caused by a read or write, and whether the transaction that caused the last signaled interrupt was secure.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_IDTLS_SECURE
 *! \brief  Secure Status (SECURE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_IDTLS_NONSECURE = 0,  /**< Transaction that caused last signaled interrupt was non-secure */
  SMPU_IDTLS_SECURE    = 1   /**< Transaction that caused last signaled interrupt was secure     */
} ADI_SMPU_CFG0_IDTLS_SECURE;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_IDTLS_RNW
 *! \brief  Read/Write Status (RNW) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_IDTLS_WRITE = 0,  /**< Transaction that caused last signaled interrupt was a write */
  SMPU_IDTLS_READ  = 1   /**< Transaction that caused last signaled interrupt was a read  */
} ADI_SMPU_CFG0_IDTLS_RNW;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_IDTLS_Struct
 *! \brief  Interrupt Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_IDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         :  9;  /**< ID of Transaction */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_IDTLS_t;

/*@}*/

/** @defgroup BADDR Bus Error Address Register (BADDR) Register
 *  Bus Error Address Register (BADDR) Register.
 *
 *  Programs read the BADDR and the BDTLS registers to determine the cause of a bus error. Write errors are prioritized over read errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_BADDR_Struct
 *! \brief  Bus Error Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_BADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Bus Error Address */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_BADDR_t;

/*@}*/

/** @defgroup BDTLS Bus Error Details Register (BDTLS) Register
 *  Bus Error Details Register (BDTLS) Register.
 *
 *  The BDTLS register indicates the ID of the bus error transaction, whether the transaction that caused the last bus error was a read, a write, secure or non-secure.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_BDTLS_SECURE
 *! \brief  Secure Status Register (SECURE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_BDTLS_NONSECURE = 0,  /**< Transaction that caused last bus error was non-secure */
  SMPU_BDTLS_SECURE    = 1   /**< Transaction that caused last bus error was secure     */
} ADI_SMPU_CFG0_BDTLS_SECURE;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_BDTLS_RNW
 *! \brief  Read/Write Status (RNW) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_BDTLS_WRITE = 0,  /**< Transaction that caused last bus error was a write */
  SMPU_BDTLS_READ  = 1   /**< Transaction that caused last bus error was a read  */
} ADI_SMPU_CFG0_BDTLS_RNW;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_BDTLS_Struct
 *! \brief  Bus Error Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_BDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status Register */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         :  9;  /**< ID of Transaction */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_BDTLS_t;

/*@}*/

/** @defgroup REVID SMPU Revision ID Register (REVID) Register
 *  SMPU Revision ID Register (REVID) Register.
 *
 *  The REVID register provides the major and minor revision numbers of this module.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_REVID_Struct
 *! \brief  SMPU Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Incremental Version ID */
      unsigned int MAJOR      :  4;  /**< Major Version ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_REVID_t;

/*@}*/

/** @defgroup SECURECTL SMPU Control Secure Accesses Register (SECURECTL) Register
 *  SMPU Control Secure Accesses Register (SECURECTL) Register.
 *
 *  The SECURECTL register provides the bits required to set up the security settings for the processor. This includes error generation and read/write security.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_SBEDIS
 *! \brief  Security Violation Bus Error Disable (SBEDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_SBEEN  = 0,  /**< Security Violation Bus Error Generation Enable  */
  SMPU_SECURECTL_SBEDIS = 1   /**< Security Violation Bus Error Generation Disable */
} ADI_SMPU_CFG0_SECURECTL_SBEDIS;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_SBETYPE
 *! \brief  Security Violation Bus Error Type (SBETYPE) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_DECERR = 0,  /**< Decode Error */
  SMPU_SECURECTL_SLVERR = 1   /**< Slave Error  */
} ADI_SMPU_CFG0_SECURECTL_SBETYPE;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_SINTEN
 *! \brief  Security Violation Interrupt Enable (SINTEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_SINTDIS = 0,  /**< Security Violation Interrupt Disable */
  SMPU_SECURECTL_SINTEN  = 1   /**< Security Violation Interrupt Enable  */
} ADI_SMPU_CFG0_SECURECTL_SINTEN;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_RLOCK
 *! \brief  Secure Region Registers Lock Bit (RLOCK) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_RLOCKDIS = 0,  /**< Secure Region Registers Write Protection Disable */
  SMPU_SECURECTL_RLOCKEN  = 1   /**< Secure Region Registers Write Protection Enable  */
} ADI_SMPU_CFG0_SECURECTL_RLOCK;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_RNSEN
 *! \brief  Non-secure Read Transaction Enable (RNSEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_RNSDIS = 0,  /**< Non-Secure Reads Disable */
  SMPU_SECURECTL_RNSEN  = 1   /**< Non-Secure Reads Enable  */
} ADI_SMPU_CFG0_SECURECTL_RNSEN;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_RSECDIS
 *! \brief  Secure Read Transaction Disable (RSECDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_RSECEN  = 0,  /**< Secure Reads Enable  */
  SMPU_SECURECTL_RSECDIS = 1   /**< Secure Reads Disable */
} ADI_SMPU_CFG0_SECURECTL_RSECDIS;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_WNSEN
 *! \brief  Non-secure Write Transaction Enable (WNSEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_WNSDIS = 0,  /**< Non-Secure Writes Disable */
  SMPU_SECURECTL_WNSEN  = 1   /**< Non-Secure Writes Enable  */
} ADI_SMPU_CFG0_SECURECTL_WNSEN;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURECTL_WSECDIS
 *! \brief  Secure Write Transaction Disable (WSECDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURECTL_WSECEN  = 0,  /**< Secure Writes Enable  */
  SMPU_SECURECTL_WSECDIS = 1   /**< Secure Writes Disable */
} ADI_SMPU_CFG0_SECURECTL_WSECDIS;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_SECURECTL_Struct
 *! \brief  SMPU Control Secure Accesses Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_SECURECTL_t {
  union {
    struct {
      unsigned int SBEDIS     :  1;  /**< Security Violation Bus Error Disable */
      unsigned int SBETYPE    :  1;  /**< Security Violation Bus Error Type */
      unsigned int SINTEN     :  1;  /**< Security Violation Interrupt Enable */
      unsigned int RLOCK      :  1;  /**< Secure Region Registers Lock Bit */
      unsigned int reserved4  :  4;
      unsigned int RNSEN      :  1;  /**< Non-secure Read Transaction Enable */
      unsigned int RSECDIS    :  1;  /**< Secure Read Transaction Disable */
      unsigned int WNSEN      :  1;  /**< Non-secure Write Transaction Enable */
      unsigned int WSECDIS    :  1;  /**< Secure Write Transaction Disable */
      unsigned int reserved12 : 19;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_SECURECTL_t;

/*@}*/

/** @defgroup RCTL Region n Control Register (RCTL) Register
 *  Region n Control Register (RCTL) Register.
 *
 *  The RCTL[n] register is used to define the level of protection for a region of memory.  The protection of a region is controlled and defined by this register, SMPU_RCTL, and along with SMPU_RADDRn, SMPU_RIDAn, SMPU_RIDBn,  SMPU_RIDMSKAn, and SMPU_RIDMSKBn registers.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_RCTL_RPROTEN
 *! \brief  Read Transaction Protection Enable (RPROTEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_RCTL_RPROTDIS = 0,  /**< Read transaction ID-Based protection disabled */
  SMPU_RCTL_RPROTEN  = 1   /**< Read transaction ID-Based protection enabled  */
} ADI_SMPU_CFG0_RCTL_RPROTEN;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_RCTL_WPROTEN
 *! \brief  Write Transaction Protection Enable (WPROTEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_RCTL_WPROTDIS = 0,  /**< Write transaction ID-Based protection disabled */
  SMPU_RCTL_WPROTEN  = 1   /**< Write transaction ID-Based protection enabled  */
} ADI_SMPU_CFG0_RCTL_WPROTEN;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_RCTL_Struct
 *! \brief  Region n Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_RCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Region Enable */
      unsigned int SIZE       :  5;  /**< Size of the memory region */
      unsigned int reserved6  :  2;
      unsigned int RPROTEN    :  1;  /**< Read Transaction Protection Enable */
      unsigned int RIDCINV    :  1;  /**< Read Transaction ID Compare Invert */
      unsigned int WPROTEN    :  1;  /**< Write Transaction Protection Enable */
      unsigned int WIDCINV    :  1;  /**< Write Transaction ID Compare Invert */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_RCTL_t;

/*@}*/

/** @defgroup RADDR Region n Address Register (RADDR) Register
 *  Region n Address Register (RADDR) Register.
 *
 *  The RADDR[n] register is used to define the base address for a memory region to be protected.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_RADDR_Struct
 *! \brief  Region n Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_RADDR_t {
  union {
    struct {
      unsigned int reserved0  : 12;
      unsigned int BADDR      : 20;  /**< Region n Base Address 20 M.S.B. */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_RADDR_t;

/*@}*/

/** @defgroup RIDA Region n ID A Register (RIDA) Register
 *  Region n ID A Register (RIDA) Register.
 *
 *  The RIDA[n] register is used for ID comparison 'A'. This comparison is performed after a mask is applied to both the transaction ID (from either the read or write IDs) and the register value. An ID Match means that the ID is the exception to the rule and the read or write is allowed even if the region is read or write protected. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_RIDA_Struct
 *! \brief  Region n ID A Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_RIDA_t {
  union {
    struct {
      unsigned int ID         :  9;  /**< Region n ID Register A */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_RIDA_t;

/*@}*/

/** @defgroup RIDMSKA Region n ID Mask A Register (RIDMSKA) Register
 *  Region n ID Mask A Register (RIDMSKA) Register.
 *
 *  The RIDMSKA[n] register is used for ID comparison 'A'.  The mask allows or disallows certain ID's from affecting the final result of the ID Match. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_RIDMSKA_Struct
 *! \brief  Region n ID Mask A Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_RIDMSKA_t {
  union {
    struct {
      unsigned int MSK        :  9;  /**< Region n ID Mask Register A */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_RIDMSKA_t;

/*@}*/

/** @defgroup RIDB Region n ID B Register (RIDB) Register
 *  Region n ID B Register (RIDB) Register.
 *
 *  The RIDB[n] register is used for ID comparison 'B'. This comparison is performed after a mask is applied to both the transaction ID (from either the read or write IDs) and the register value. An ID Match means that the ID is the exception to the rule and the read or write is allowed even if the region is read or write protected. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_RIDB_Struct
 *! \brief  Region n ID B Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_RIDB_t {
  union {
    struct {
      unsigned int ID         :  9;  /**< Region n ID Register B */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_RIDB_t;

/*@}*/

/** @defgroup RIDMSKB Region n ID Mask B Register (RIDMSKB) Register
 *  Region n ID Mask B Register (RIDMSKB) Register.
 *
 *  The RIDMSKB[n] register is used for ID comparison 'B'.  The mask allows or disallows certain ID's from affecting the final result of the ID Match. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_RIDMSKB_Struct
 *! \brief  Region n ID Mask B Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_RIDMSKB_t {
  union {
    struct {
      unsigned int MSK        :  9;  /**< Region n ID Mask Register B */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_RIDMSKB_t;

/*@}*/

/** @defgroup SECURERCTL Region n Control Secure Accesses Register (SECURERCTL) Register
 *  Region n Control Secure Accesses Register (SECURERCTL) Register.
 *
 *  The SECURERCTL[n] register contains bits that configure read/write security for a specific region.
 *  @{
 */

/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURERCTL_RNSEN
 *! \brief  Non-secure Read Transaction Enable (RNSEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURERCTL_RNSDIS = 0,  /**< Non-Secure Reads Disable */
  SMPU_SECURERCTL_RNSEN  = 1   /**< Non-Secure Reads Enable  */
} ADI_SMPU_CFG0_SECURERCTL_RNSEN;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURERCTL_RSECDIS
 *! \brief  Secure Read Transaction Disable (RSECDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURERCTL_RSECEN  = 0,  /**< Secure Reads Enable  */
  SMPU_SECURERCTL_RSECDIS = 1   /**< Secure Reads Disable */
} ADI_SMPU_CFG0_SECURERCTL_RSECDIS;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURERCTL_WNSEN
 *! \brief  Non-secure Write Transaction Enable (WNSEN) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURERCTL_WNSDIS = 0,  /**< Non-secure write transactions to this region are disallowed */
  SMPU_SECURERCTL_WNSEN  = 1   /**< Non-secure write transactions to this region are allowed    */
} ADI_SMPU_CFG0_SECURERCTL_WNSEN;


/*  =========================================================================
 *! \enum   ADI_SMPU_CFG0_SECURERCTL_WSECDIS
 *! \brief  Secure Write Transaction Disable (WSECDIS) Enumerations
 *  ========================================================================= */
typedef enum
{
  SMPU_SECURERCTL_WSECEN  = 0,  /**< Secure write transactions to this region are allowed    */
  SMPU_SECURERCTL_WSECDIS = 1   /**< Secure write transactions to this region are disallowed */
} ADI_SMPU_CFG0_SECURERCTL_WSECDIS;


/* ==========================================================================
 *! \struct ADI_SMPU_CFG0_SECURERCTL_Struct
 *! \brief  Region n Control Secure Accesses Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG0_SECURERCTL_t {
  union {
    struct {
      unsigned int RNSEN      :  1;  /**< Non-secure Read Transaction Enable */
      unsigned int RSECDIS    :  1;  /**< Secure Read Transaction Disable */
      unsigned int WNSEN      :  1;  /**< Non-secure Write Transaction Enable */
      unsigned int WSECDIS    :  1;  /**< Secure Write Transaction Disable */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG0_SECURERCTL_t;

/*@}*/

/** @defgroup CTL SMPU Control Register (CTL) Register
 *  SMPU Control Register (CTL) Register.
 *
 *  The CTL register provides access to the locking control, error interrupts and SMPU violations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_CTL_Struct
 *! \brief  SMPU Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_CTL_t {
  union {
    struct {
      unsigned int RSDIS      :  1;  /**< Read Speculation Disable */
      unsigned int PBEDIS     :  1;  /**< Protection Violation Bus Error Disable */
      unsigned int PBETYPE    :  1;  /**< Protection Violation Bus Error Type */
      unsigned int PINTEN     :  1;  /**< Protection Violation Interrupt Enable */
      unsigned int RLOCK      :  1;  /**< RCTLn, RADDRn, RIDxn and RIDMxn Registers Lock Bit */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_CTL_t;

/*@}*/

/** @defgroup STAT SMPU Status Register (STAT) Register
 *  SMPU Status Register (STAT) Register.
 *
 *  The STAT register provides the state of the SMPU and indicates various errors.  All bits in this register are write '1' to clear.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_STAT_Struct
 *! \brief  SMPU Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_STAT_t {
  union {
    struct {
      unsigned int IRQ        :  1;  /**< Interrupt Request */
      unsigned int IOVR       :  1;  /**< Interrupt Overrun */
      unsigned int BERR       :  1;  /**< Bus Error */
      unsigned int BEOVR      :  1;  /**< Bus Error Overrun */
      unsigned int reserved4  : 12;
      unsigned int ADRERR     :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
      unsigned int reserved18 : 14;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_STAT_t;

/*@}*/

/** @defgroup IADDR Interrupt Address Register (IADDR) Register
 *  Interrupt Address Register (IADDR) Register.
 *
 *  The IADDR register indicates an attempt to make a read or write access to unimplemented addresses or accesses are non-aligned. The SMPU_CFG1 issues a bus error for this condition.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_IADDR_Struct
 *! \brief  Interrupt Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_IADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Interrupt Address */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_IADDR_t;

/*@}*/

/** @defgroup IDTLS Interrupt Details Register (IDTLS) Register
 *  Interrupt Details Register (IDTLS) Register.
 *
 *  The IDTLS register provides the ID of the last signaled interrupt, whether the interrupt was caused by a read or write, and whether the transaction that caused the last signaled interrupt was secure.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_IDTLS_Struct
 *! \brief  Interrupt Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_IDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         :  9;  /**< ID of Transaction */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_IDTLS_t;

/*@}*/

/** @defgroup BADDR Bus Error Address Register (BADDR) Register
 *  Bus Error Address Register (BADDR) Register.
 *
 *  Programs read the BADDR and the BDTLS registers to determine the cause of a bus error. Write errors are prioritized over read errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_BADDR_Struct
 *! \brief  Bus Error Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_BADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Bus Error Address */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_BADDR_t;

/*@}*/

/** @defgroup BDTLS Bus Error Details Register (BDTLS) Register
 *  Bus Error Details Register (BDTLS) Register.
 *
 *  The BDTLS register indicates the ID of the bus error transaction, whether the transaction that caused the last bus error was a read, a write, secure or non-secure.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_BDTLS_Struct
 *! \brief  Bus Error Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_BDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status Register */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         :  9;  /**< ID of Transaction */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_BDTLS_t;

/*@}*/

/** @defgroup REVID SMPU Revision ID Register (REVID) Register
 *  SMPU Revision ID Register (REVID) Register.
 *
 *  The REVID register provides the major and minor revision numbers of this module.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_REVID_Struct
 *! \brief  SMPU Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Incremental Version ID */
      unsigned int MAJOR      :  4;  /**< Major Version ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_REVID_t;

/*@}*/

/** @defgroup SECURECTL SMPU Control Secure Accesses Register (SECURECTL) Register
 *  SMPU Control Secure Accesses Register (SECURECTL) Register.
 *
 *  The SECURECTL register provides the bits required to set up the security settings for the processor. This includes error generation and read/write security.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_SECURECTL_Struct
 *! \brief  SMPU Control Secure Accesses Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_SECURECTL_t {
  union {
    struct {
      unsigned int SBEDIS     :  1;  /**< Security Violation Bus Error Disable */
      unsigned int SBETYPE    :  1;  /**< Security Violation Bus Error Type */
      unsigned int SINTEN     :  1;  /**< Security Violation Interrupt Enable */
      unsigned int RLOCK      :  1;  /**< Secure Region Registers Lock Bit */
      unsigned int reserved4  :  4;
      unsigned int RNSEN      :  1;  /**< Non-secure Read Transaction Enable */
      unsigned int RSECDIS    :  1;  /**< Secure Read Transaction Disable */
      unsigned int WNSEN      :  1;  /**< Non-secure Write Transaction Enable */
      unsigned int WSECDIS    :  1;  /**< Secure Write Transaction Disable */
      unsigned int reserved12 : 19;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_SECURECTL_t;

/*@}*/

/** @defgroup RCTL Region n Control Register (RCTL) Register
 *  Region n Control Register (RCTL) Register.
 *
 *  The RCTL[n] register is used to define the level of protection for a region of memory.  The protection of a region is controlled and defined by this register, SMPU_RCTL, and along with SMPU_RADDRn, SMPU_RIDAn, SMPU_RIDBn,  SMPU_RIDMSKAn, and SMPU_RIDMSKBn registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_RCTL_Struct
 *! \brief  Region n Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_RCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Region Enable */
      unsigned int SIZE       :  5;  /**< Size of the memory region */
      unsigned int reserved6  :  2;
      unsigned int RPROTEN    :  1;  /**< Read Transaction Protection Enable */
      unsigned int RIDCINV    :  1;  /**< Read Transaction ID Compare Invert */
      unsigned int WPROTEN    :  1;  /**< Write Transaction Protection Enable */
      unsigned int WIDCINV    :  1;  /**< Write Transaction ID Compare Invert */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_RCTL_t;

/*@}*/

/** @defgroup RADDR Region n Address Register (RADDR) Register
 *  Region n Address Register (RADDR) Register.
 *
 *  The RADDR[n] register is used to define the base address for a memory region to be protected.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_RADDR_Struct
 *! \brief  Region n Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_RADDR_t {
  union {
    struct {
      unsigned int reserved0  : 12;
      unsigned int BADDR      : 20;  /**< Region n Base Address 20 M.S.B. */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_RADDR_t;

/*@}*/

/** @defgroup RIDA Region n ID A Register (RIDA) Register
 *  Region n ID A Register (RIDA) Register.
 *
 *  The RIDA[n] register is used for ID comparison 'A'. This comparison is performed after a mask is applied to both the transaction ID (from either the read or write IDs) and the register value. An ID Match means that the ID is the exception to the rule and the read or write is allowed even if the region is read or write protected. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_RIDA_Struct
 *! \brief  Region n ID A Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_RIDA_t {
  union {
    struct {
      unsigned int ID         :  9;  /**< Region n ID Register A */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_RIDA_t;

/*@}*/

/** @defgroup RIDMSKA Region n ID Mask A Register (RIDMSKA) Register
 *  Region n ID Mask A Register (RIDMSKA) Register.
 *
 *  The RIDMSKA[n] register is used for ID comparison 'A'.  The mask allows or disallows certain ID's from affecting the final result of the ID Match. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_RIDMSKA_Struct
 *! \brief  Region n ID Mask A Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_RIDMSKA_t {
  union {
    struct {
      unsigned int MSK        :  9;  /**< Region n ID Mask Register A */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_RIDMSKA_t;

/*@}*/

/** @defgroup RIDB Region n ID B Register (RIDB) Register
 *  Region n ID B Register (RIDB) Register.
 *
 *  The RIDB[n] register is used for ID comparison 'B'. This comparison is performed after a mask is applied to both the transaction ID (from either the read or write IDs) and the register value. An ID Match means that the ID is the exception to the rule and the read or write is allowed even if the region is read or write protected. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_RIDB_Struct
 *! \brief  Region n ID B Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_RIDB_t {
  union {
    struct {
      unsigned int ID         :  9;  /**< Region n ID Register B */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_RIDB_t;

/*@}*/

/** @defgroup RIDMSKB Region n ID Mask B Register (RIDMSKB) Register
 *  Region n ID Mask B Register (RIDMSKB) Register.
 *
 *  The RIDMSKB[n] register is used for ID comparison 'B'.  The mask allows or disallows certain ID's from affecting the final result of the ID Match. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_RIDMSKB_Struct
 *! \brief  Region n ID Mask B Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_RIDMSKB_t {
  union {
    struct {
      unsigned int MSK        :  9;  /**< Region n ID Mask Register B */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_RIDMSKB_t;

/*@}*/

/** @defgroup SECURERCTL Region n Control Secure Accesses Register (SECURERCTL) Register
 *  Region n Control Secure Accesses Register (SECURERCTL) Register.
 *
 *  The SECURERCTL[n] register contains bits that configure read/write security for a specific region.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG1_SECURERCTL_Struct
 *! \brief  Region n Control Secure Accesses Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG1_SECURERCTL_t {
  union {
    struct {
      unsigned int RNSEN      :  1;  /**< Non-secure Read Transaction Enable */
      unsigned int RSECDIS    :  1;  /**< Secure Read Transaction Disable */
      unsigned int WNSEN      :  1;  /**< Non-secure Write Transaction Enable */
      unsigned int WSECDIS    :  1;  /**< Secure Write Transaction Disable */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG1_SECURERCTL_t;

/*@}*/

/** @defgroup GCTL Global Control Register (GCTL) Register
 *  Global Control Register (GCTL) Register.
 *
 *  The SWU global control register (GCTL) provides SWU reset and enable.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_GCTL_Struct
 *! \brief  Global Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_GCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Global Enable */
      unsigned int RST        :  1;  /**< Global Reset */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SWU_GCTL_t;

/*@}*/

/** @defgroup GSTAT Global Status Register (GSTAT) Register
 *  Global Status Register (GSTAT) Register.
 *
 *  The SWU global status register (GSTAT) contains status bits for all four watchpoint groups.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_GSTAT_Struct
 *! \brief  Global Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_GSTAT_t {
  union {
    struct {
      unsigned int MTCH0      :  1;  /**< Group 0 Match */
      unsigned int MTCH1      :  1;  /**< Group 1 Match */
      unsigned int MTCH2      :  1;  /**< Group 2 Match */
      unsigned int MTCH3      :  1;  /**< Group 3 Match */
      unsigned int INT0       :  1;  /**< Group 0 Interrupt Status */
      unsigned int INT1       :  1;  /**< Group 1 Interrupt Status */
      unsigned int INT2       :  1;  /**< Group 2 Interrupt Status */
      unsigned int INT3       :  1;  /**< Group 3 Interrupt Status */
      unsigned int UNDRBW0    :  1;  /**< Group 0 Bandwidth Below Minimum Target */
      unsigned int OVRBW0     :  1;  /**< Group 0 Bandwidth Above Maximum Target */
      unsigned int UNDRBW1    :  1;  /**< Group 1 Bandwidth Below Minimum Target */
      unsigned int OVRBW1     :  1;  /**< Group 1 Bandwidth Above Maximum Target */
      unsigned int UNDRBW2    :  1;  /**< Group 2 Bandwidth Below Minimum Target */
      unsigned int OVRBW2     :  1;  /**< Group 2 Bandwidth Above Maximum Target */
      unsigned int UNDRBW3    :  1;  /**< Group 3 Bandwidth Below Minimum Target */
      unsigned int OVRBW3     :  1;  /**< Group 3 Bandwidth Above Maximum Target */
      unsigned int reserved16 : 14;
      unsigned int ADDRERR    :  1;  /**< Address Error Status */
      unsigned int reserved31 :  1;
    };
    uint32_t VALUE32;
  };
} ADI_SWU_GSTAT_t;

/*@}*/

/** @defgroup CTL Control Register n (CTL) Register
 *  Control Register n (CTL) Register.
 *
 *  The SWU control registers (CTL[n]) contain watchpoint attribute controls for all four watchpoint groups. These controls include enabling watchpoints, selecting the transaction direction for match, selecting address comparison mode, enabling ID comparison, enabling security comparison, enabling locked comparison, enabling cycle count, enabling count repeat, enabling debug events, enabling interrupts, enabling triggers, enabling trace messages, enabling bandwidth mode, selecting the burst length increment, and enabling bandwidth underflow and overflow detection.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_CTL_Struct
 *! \brief  Control Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_CTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable Watchpoint */
      unsigned int DIR        :  1;  /**< Transaction Direction for Match */
      unsigned int ACMPM      :  2;  /**< Address Comparison Mode */
      unsigned int IDCMPEN    :  1;  /**< ID Comparison Enable */
      unsigned int SCMPEN     :  1;  /**< Secure Comparison Enable */
      unsigned int LCMPEN     :  1;  /**< Locked Comparison Enable */
      unsigned int reserved7  :  1;
      unsigned int CNTEN      :  1;  /**< Count Enable */
      unsigned int CNTRPTEN   :  1;  /**< Count Repeat Enable */
      unsigned int reserved10 :  2;
      unsigned int DBGEN      :  1;  /**< Debug Event Enable */
      unsigned int INTEN      :  1;  /**< Interrupt Enable */
      unsigned int TRGEN      :  1;  /**< Trigger Enable */
      unsigned int TMEN       :  1;  /**< Trace Message Enable */
      unsigned int BWEN       :  1;  /**< Bandwidth Mode Enable */
      unsigned int BLENINC    :  1;  /**< Increment Bandwidth Count by Burst Length */
      unsigned int MINACT     :  1;  /**< Action for Bandwidth Below Minimum */
      unsigned int MAXACT     :  1;  /**< Action for Bandwidth Above Maximum */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SWU_CTL_t;

/*@}*/

/** @defgroup LA Lower Address Register n (LA) Register
 *  Lower Address Register n (LA) Register.
 *
 *  The SWU lower address registers (LA[n]) contain each watchpoint group's lower address for address match comparison. In exact match on LA[n] address mode (CTLn:ACMPM bits =01), the watchpoint group uses only this address for match comparison.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_LA_Struct
 *! \brief  Lower Address Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_LA_t {
  union {
    struct {
      unsigned int ADDR       : 32;  /**< Lower Address */
    };
    uint32_t VALUE32;
  };
} ADI_SWU_LA_t;

/*@}*/

/** @defgroup UA Upper Address Register n (UA) Register
 *  Upper Address Register n (UA) Register.
 *
 *  The SWU upper address registers (UA[n]) contain each watchpoint group's upper address for address match comparison. In exact match on LAn address mode (CTLn:ACMPM bits =01), the UA[n] is not used for match comparison.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_UA_Struct
 *! \brief  Upper Address Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_UA_t {
  union {
    struct {
      unsigned int ADDR       : 32;  /**< Upper Address */
    };
    uint32_t VALUE32;
  };
} ADI_SWU_UA_t;

/*@}*/

/** @defgroup ID ID Register n (ID) Register
 *  ID Register n (ID) Register.
 *
 *  The SWU ID registers (ID[n]) contain a 16-bit ID field (ID) and a 16-bit ID mask field (IDMASK) that watchpoint groups use for ID comparison. The ID on the bus is AND'ed with the IDMASK field, then the watchpoint group compares the result against the ID field.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_ID_Struct
 *! \brief  ID Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_ID_t {
  union {
    struct {
      unsigned int ID         : 16;  /**< Identity */
      unsigned int IDMASK     : 16;  /**< Identity Mask (for Or with ID) */
    };
    uint32_t VALUE32;
  };
} ADI_SWU_ID_t;

/*@}*/

/** @defgroup CNT Count Register n (CNT) Register
 *  Count Register n (CNT) Register.
 *
 *  The SWU count registers (CNT[n]) contain a 16-bit count field (COUNT) whose usage differs depending on the mode of the watchpoint group. In bandwidth mode, the COUNT field value defines the number of clock cycles in a bandwidth period. In watchpoint mode, when the cycle count is enabled, the COUNT field value determines how many matches occur before the watchpoint group takes action.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_CNT_Struct
 *! \brief  Count Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_CNT_t {
  union {
    struct {
      unsigned int COUNT      : 16;  /**< Count */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SWU_CNT_t;

/*@}*/

/** @defgroup TARG Target Register n (TARG) Register
 *  Target Register n (TARG) Register.
 *
 *  The SWU target registers (TARG[n]) contain a minimum value field (BWMIN) and maximum value field (BWMAX) of bandwidth targets used by watchpoint groups in bandwidth mode. When the bandwidth period expires, if the current bandwidth value (CURn register, CURn:CURBW bits) is below the minimum target or above the maximum target, the watchpoint group takes action as enabled by the CTLn register's CTLn:MINACT or CTLn:MAXACT bits. 
 *   In bandwidth mode, note that the watchpoint group increments its count of $[i$]either$[/i$] data bus transactions $[i$]or$[/i$] address bus transactions (bursts) as selected by the CTLn:BLENINC bit. Keep this mode selection in mind when programming the bandwidth target values.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_TARG_Struct
 *! \brief  Target Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_TARG_t {
  union {
    struct {
      unsigned int BWMIN      : 16;  /**< Minimum Bandwidth Target */
      unsigned int BWMAX      : 16;  /**< Maximum Bandwidth Target */
    };
    uint32_t VALUE32;
  };
} ADI_SWU_TARG_t;

/*@}*/

/** @defgroup HIST Bandwidth History Register n (HIST) Register
 *  Bandwidth History Register n (HIST) Register.
 *
 *  The SWU bandwidth history registers (HIST[n]) contain data copied from a watchpoint group's current bandwidth value (CURn register, CURn:CURBW bits) at the end of the last two watchpoint periods. At the end of each watchpoint period, the SWU copies the previous bandwidth value from the BWHIST0 field to the BWHIST1 field and copies the new bandwidth value from the CURn:CURBW field to the BWHIST0 field.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_HIST_Struct
 *! \brief  Bandwidth History Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_HIST_t {
  union {
    struct {
      unsigned int BWHIST0    : 16;  /**< Bandwidth from Last Window */
      unsigned int BWHIST1    : 16;  /**< Bandwidth from Window Before Last */
    };
    uint32_t VALUE32;
  };
} ADI_SWU_HIST_t;

/*@}*/

/** @defgroup CUR Current Register n (CUR) Register
 *  Current Register n (CUR) Register.
 *
 *  The SWU current register (CUR[n]) operation varies depending whether the watchpoint group is in bandwidth mode or watchpoint mode. In both modes, the watchpoint count begins when the SWU loads the register's CURCNT field from the CNTn register's CNTn:COUNT field when the watchpoint count is enabled (CTLn register, CTLn:CNTEN bit =1). 
 *  In bandwidth mode, the current count field (CURCNT) contains the cycle count remaining within the current watchpoint period. The SWU decrements this value every cycle until the count reaches zero. At that point, the SWU reloads the CURCNT field from CNTn register's CNTn:COUNT field. In bandwidth mode, the current bandwidth field (CURBW) contains the count of watchpoint matches (bandwidth) accummulated in the current watchpoint period. 
 *  In watchpoint mode, the current count field (CURCNT) contains the watchpoint match count remaining within the current watchpoint period. The SWU decrements this value with every watchpoint match until the count reaches zero. At that point, the SWU reloads the CURCNT field from CNTn register's CNTn:COUNT field if the CTLn register's CTLn:CNTRPTEN bit is set (=1). In watchpoint mode, the current bandwidth field (CURBW) is undefined.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SWU_CUR_Struct
 *! \brief  Current Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SWU_CUR_t {
  union {
    struct {
      unsigned int CURCNT     : 16;  /**< Current Count */
      unsigned int CURBW      : 16;  /**< Current Bandwidth */
    };
    uint32_t VALUE32;
  };
} ADI_SWU_CUR_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The SPU_CFG0 Control Register (CTL) provides a global lock for configuration registers as well as control for locking the Write Protect (SPU_WPn) registers.  It also controls the generation of an interrupt to report blocked accesses.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_CTL_t {
  union {
    struct {
      unsigned int GLCK       :  8;  /**< Global Lock */
      unsigned int reserved8  :  6;
      unsigned int PINTEN     :  1;  /**< Protection Violation Interrupt Enable */
      unsigned int reserved15 :  1;
      unsigned int WPLCK      :  1;  /**< Write Protect Register Lock */
      unsigned int reserved17 :  1;
      unsigned int APLCK      :  1;  /**< Access Protect Register Lock */
      unsigned int reserved19 :  1;
      unsigned int TOMON      :  1;  /**< Timeout Monitor */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_CTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates if there have been any errors, active interrupts and Global Lock status.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_STAT_t {
  union {
    struct {
      unsigned int GLCK       :  1;  /**< Global Lock Status */
      unsigned int reserved1  : 11;
      unsigned int VIRQ       :  1;  /**< Violation Interrupt Request */
      unsigned int TIRQ       :  1;  /**< Timeout Interrupt */
      unsigned int reserved14 : 15;
      unsigned int TOERR      :  1;  /**< Timeout Error */
      unsigned int ADDRERR    :  1;  /**< Address Error. */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_STAT_t;

/*@}*/

/** @defgroup TIMEOUT Timeout Register (TIMEOUT) Register
 *  Timeout Register (TIMEOUT) Register.
 *
 *  Timeout counter value. Program TOMON in SPU_CTL to enable transaction timeout monitoring. TIRQ interrupt is triggered when timeout period expires.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_TIMEOUT_Struct
 *! \brief  Timeout Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_TIMEOUT_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timeout counter value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_TIMEOUT_t;

/*@}*/

/** @defgroup AP Access Protect Register n (AP) Register
 *  Access Protect Register n (AP) Register.
 *
 *  In the system, each AP[n] register is assigned to a specific MMR address range associated with one peripheral. When the appropriate bits are set, read and writes access to the peripheral from a specific master are blocked and an error is returned to the master. For more information, see the processor specific additional information for the AP[n] register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_AP_Struct
 *! \brief  Access Protect Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_AP_t {
  union {
    struct {
      unsigned int CMA0       :  1;  /**< Core Master x Access Protect Enable */
      unsigned int CMA1       :  1;  /**< Core Master x Access Protect Enable */
      unsigned int reserved2  : 14;
      unsigned int SMA0       :  1;  /**< System Master x Access Protect Enable */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_AP_t;

/*@}*/

/** @defgroup IDTLS Interrupt Details Register (IDTLS) Register
 *  Interrupt Details Register (IDTLS) Register.
 *
 *  The SPU_CFG0 Interrupt Details register (IDTLS) reports the details of the master that caused a security and/or protection violation. Value is set and remain sticky upon each assertion of VIRQ. If a second memory access violation occurs while the IRQ bit in SPU_STAT register is set, the SPU_IADDR and the SPU_IDTLS are not updated until the IRQ bit in SPU_STAT register is cleared.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_IDTLS_Struct
 *! \brief  Interrupt Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_IDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         : 16;  /**< ID of transaction */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_IDTLS_t;

/*@}*/

/** @defgroup IADDR Interrupt Address Register (IADDR) Register
 *  Interrupt Address Register (IADDR) Register.
 *
 *  The SPU_CFG0 violation address register (IADDR) reports the address of the first master that caused a security and/or protection violation. Value is set and remain sticky upon each assertion of VIRQ.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_IADDR_Struct
 *! \brief  Interrupt Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_IADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Violation Address */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_IADDR_t;

/*@}*/

/** @defgroup DEVID Device Configuration Register (DEVID) Register
 *  Device Configuration Register (DEVID) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_DEVID_Struct
 *! \brief  Device Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_DEVID_t {
  union {
    struct {
      unsigned int ITYPE      :  3;  /**< Interface Type */
      unsigned int reserved3  :  1;
      unsigned int NS         :  1;  /**< No Security */
      unsigned int reserved5  :  1;
      unsigned int CMCNT      :  5;  /**< Core Master Count */
      unsigned int SMCNT      :  5;  /**< System Master Count */
      unsigned int ENDPTCNT   :  9;  /**< End Point Count */
      unsigned int reserved25 :  7;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_DEVID_t;

/*@}*/

/** @defgroup DEVTYPE Device Type Identifier Register (DEVTYPE) Register
 *  Device Type Identifier Register (DEVTYPE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_DEVTYPE_Struct
 *! \brief  Device Type Identifier Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_DEVTYPE_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Device Type */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_DEVTYPE_t;

/*@}*/

/** @defgroup PID4 Peripheral ID4 Register (PID4) Register
 *  Peripheral ID4 Register (PID4) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID4_Struct
 *! \brief  Peripheral ID4 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID4_t {
  union {
    struct {
      unsigned int JEOP106CC  :  4;  /**< JEOP106 continuation code (number of leading 0x7Fs) */
      unsigned int SIZE       :  4;  /**< Number of 4k blocks. Size of component 4k chunks minus 1 (i.e. 0=4k) */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID4_t;

/*@}*/

/** @defgroup PID5 Peripheral ID5 Register (PID5) Register
 *  Peripheral ID5 Register (PID5) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID5_Struct
 *! \brief  Peripheral ID5 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID5_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For future use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID5_t;

/*@}*/

/** @defgroup PID6 Peripheral ID6 Register (PID6) Register
 *  Peripheral ID6 Register (PID6) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID6_Struct
 *! \brief  Peripheral ID6 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID6_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For future use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID6_t;

/*@}*/

/** @defgroup PID7 Peripheral ID7 Register (PID7) Register
 *  Peripheral ID7 Register (PID7) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID7_Struct
 *! \brief  Peripheral ID7 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID7_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For future use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID7_t;

/*@}*/

/** @defgroup PID0 Peripheral ID0 Register (PID0) Register
 *  Peripheral ID0 Register (PID0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID0_Struct
 *! \brief  Peripheral ID0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID0_t {
  union {
    struct {
      unsigned int PARTNUM    :  8;  /**< PARTNUM[7:0] Part Number for component identification. SPU in this case. */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID0_t;

/*@}*/

/** @defgroup PID1 Peripheral ID1 Register (PID1) Register
 *  Peripheral ID1 Register (PID1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID1_Struct
 *! \brief  Peripheral ID1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID1_t {
  union {
    struct {
      unsigned int PARTNUM    :  4;  /**< PARTNUM[11:8] Part Number for component identification. SPU in this case. */
      unsigned int JEP106     : 28;  /**< JEDEC JEP106 Manufacturer ID code */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID1_t;

/*@}*/

/** @defgroup PID2 Peripheral ID2 Register (PID2) Register
 *  Peripheral ID2 Register (PID2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID2_Struct
 *! \brief  Peripheral ID2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID2_t {
  union {
    struct {
      unsigned int JEP106     :  3;  /**< JEDEC JEP106 Manufacturer ID code */
      unsigned int JEDECASGN  :  1;  /**< A JEDEC Assigned Value is Used. Indicates that a JEDEC assigned value is used. */
      unsigned int REV        :  4;  /**< Peripheral Revision */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID2_t;

/*@}*/

/** @defgroup PID3 Peripheral ID3 Register (PID3) Register
 *  Peripheral ID3 Register (PID3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_PID3_Struct
 *! \brief  Peripheral ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_PID3_t {
  union {
    struct {
      unsigned int CUSTMOD    :  4;  /**< Customer Modified */
      unsigned int REVAND     :  4;  /**< Metal fix revision */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_PID3_t;

/*@}*/

/** @defgroup CID0 Component ID0 Register (CID0) Register
 *  Component ID0 Register (CID0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_CID0_Struct
 *! \brief  Component ID0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_CID0_t {
  union {
    struct {
      unsigned int PREAMBLE   :  8;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_CID0_t;

/*@}*/

/** @defgroup CID1 Component ID1 Register (CID1) Register
 *  Component ID1 Register (CID1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_CID1_Struct
 *! \brief  Component ID1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_CID1_t {
  union {
    struct {
      unsigned int PREAMBLE   :  4;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int COMPCLASS  :  4;  /**< Component Class */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_CID1_t;

/*@}*/

/** @defgroup CID2 Component ID2 Register (CID2) Register
 *  Component ID2 Register (CID2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_CID2_Struct
 *! \brief  Component ID2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_CID2_t {
  union {
    struct {
      unsigned int PREAMBLE   :  8;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_CID2_t;

/*@}*/

/** @defgroup CID3 Component ID3 Register (CID3) Register
 *  Component ID3 Register (CID3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_CID3_Struct
 *! \brief  Component ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_CID3_t {
  union {
    struct {
      unsigned int PREAMBLE   :  8;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_CID3_t;

/*@}*/

/** @defgroup WP Write Protect Register n (WP) Register
 *  Write Protect Register n (WP) Register.
 *
 *  In the system, each WP[n] register is assigned to a specific MMR address range associated with one peripheral. When the appropriate bits are set, writes to the peripheral from a specific master are blocked and an error is returned to the master. For more information, see the processor specific additional information for the WP[n] register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG0_WP_Struct
 *! \brief  Write Protect Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG0_WP_t {
  union {
    struct {
      unsigned int CM0        :  1;  /**< Core Master x Write Protect Enable */
      unsigned int CM1        :  1;  /**< Core Master x Write Protect Enable */
      unsigned int reserved2  : 14;
      unsigned int SM0        :  1;  /**< System Master x Write Protect Enable */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG0_WP_t;

/*@}*/

/** @defgroup SYSSTAT System Status Register (SYSSTAT) Register
 *  System Status Register (SYSSTAT) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SYSSTAT_Struct
 *! \brief  System Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SYSSTAT_t {
  union {
    struct {
      unsigned int AFE_OK     :  1;  /**< Status of AFE_OK signal */
      unsigned int AFE_LIMIT  :  1;  /**< Status of AFE_LIMIT signal */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SYSSTAT_t;

/*@}*/

/** @defgroup AHB_RESP_CFG AHB Response Configuration Register (AHB_RESP_CFG) Register
 *  AHB Response Configuration Register (AHB_RESP_CFG) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_AHB_RESP_CFG_Struct
 *! \brief  AHB Response Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_AHB_RESP_CFG_t {
  union {
    struct {
      unsigned int TOENA      :  1;  /**< Enable AHB Timeout Interrupt */
      unsigned int TOERR      :  1;  /**< Status Error bit indicating AHB bus has timed out */
      unsigned int PWENA      :  1;  /**< Posted Write Error interrupt enable */
      unsigned int PWERR      :  1;  /**< Posted Write Error has occurred */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_AHB_RESP_CFG_t;

/*@}*/

/** @defgroup AHB_TIMEOUT_VALUE AHB Timeout Value Register (AHB_TIMEOUT_VALUE) Register
 *  AHB Timeout Value Register (AHB_TIMEOUT_VALUE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_AHB_TIMEOUT_VALUE_Struct
 *! \brief  AHB Timeout Value Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_AHB_TIMEOUT_VALUE_t {
  union {
    struct {
      unsigned int DATA       : 16;  /**< Timeout Value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_AHB_TIMEOUT_VALUE_t;

/*@}*/

/** @defgroup ENG_MODE_CFG0 Engineering Mode Configuration Register 0 (ENG_MODE_CFG0) Register
 *  Engineering Mode Configuration Register 0 (ENG_MODE_CFG0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_ENG_MODE_CFG0_Struct
 *! \brief  Engineering Mode Configuration Register 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_ENG_MODE_CFG0_t {
  union {
    struct {
      unsigned int DATA       : 32;  /**< Data Value */
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_ENG_MODE_CFG0_t;

/*@}*/

/** @defgroup M0_VTOR Vector table base offset field (M0_VTOR) Register
 *  Vector table base offset field (M0_VTOR) Register.
 *
 *  It contains the MS bits of the offset of the table base from the bottom of the memory map.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_M0_VTOR_Struct
 *! \brief  Vector table base offset field Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_M0_VTOR_t {
  union {
    struct {
      unsigned int reserved0  :  8;
      unsigned int TBLOFF     : 24;  /**< Vector table base offset field. It contains the MS bits of the offset of the table base from the bottom of the memory map. */
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_M0_VTOR_t;

/*@}*/

/** @defgroup SRAM0_ECC M0 SRAM ECC (SRAM0_ECC) Register
 *  M0 SRAM ECC (SRAM0_ECC) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SRAM0_ECC_Struct
 *! \brief  M0 SRAM ECC Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SRAM0_ECC_t {
  union {
    struct {
      unsigned int IEN        :  1;  /**< Interrupt Enable */
      unsigned int FLTST      :  1;  /**< Fault Status */
      unsigned int FADDR      : 13;  /**< ECC Fault Address */
      unsigned int reserved15 : 15;
      unsigned int MAPMODE    :  2;  /**< ECC Bypass Modes */
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SRAM0_ECC_t;

/*@}*/

/** @defgroup SYS_STCALIB System (SYS_STCALIB) Register
 *  System (SYS_STCALIB) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SYS_STCALIB_Struct
 *! \brief  System Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SYS_STCALIB_t {
  union {
    struct {
      unsigned int TENMS      : 24;  /**< Sys Tick Calibration Register Value in units of ten milliseconds */
      unsigned int SKEW       :  1;  /**< Tie low is SCLK can guarantee an exact multiple of 10ms */
      unsigned int NOREF      :  1;  /**< No External Reference */
      unsigned int reserved26 :  6;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SYS_STCALIB_t;

/*@}*/

/** @defgroup IRQ_LATENCY M0 IRQ LATENCY (IRQ_LATENCY) Register
 *  M0 IRQ LATENCY (IRQ_LATENCY) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_IRQ_LATENCY_Struct
 *! \brief  M0 IRQ LATENCY Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_IRQ_LATENCY_t {
  union {
    struct {
      unsigned int VALUE      :  8;  /**< IRQ LATENCY VALUE */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_IRQ_LATENCY_t;

/*@}*/

/** @defgroup SISTAT0 Shared Interrupt 0 Status Register (SISTAT0) Register
 *  Shared Interrupt 0 Status Register (SISTAT0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT0_Struct
 *! \brief  Shared Interrupt 0 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT0_t {
  union {
    struct {
      unsigned int CGU0_ERR   :  1;  /**< Shared INTR_0 status bit (From CGU[0]_ERR) */
      unsigned int CGU0_OSCW_INT :  1;  /**< Shared INTR_0 status bit (From CGU[0]_OSCW_INT) */
      unsigned int OCU0_ERR      :  1;  /**< Shared INTR_0 status bit (From OCU[0]_ERR) */
      unsigned int VMU0_VDDEXT_EVT :  1;  /**< Shared INTR_0 status bit (From VMU[0]_VDDEXT_EVT) */
      unsigned int VMU0_VDDINT_EVT :  1;  /**< Shared INTR_0 status bit (From VMU[0]_VDDINT_EVT) */
      unsigned int reserved5       : 27;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT0_t;

/*@}*/

/** @defgroup SISTAT3 Shared Interrupt 3 Status Register (SISTAT3) Register
 *  Shared Interrupt 3 Status Register (SISTAT3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT3_Struct
 *! \brief  Shared Interrupt 3 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT3_t {
  union {
    struct {
      unsigned int SPU0_TIMEOUT :  1;  /**< Shared INTR_3 status bit (From SPU[0]_TIMEOUT) */
      unsigned int TESYS0_BUS_TIMEOUT :  1;  /**< Shared INTR_3 status bit (From TESYS[0]_BUS_TIMEOUT) */
      unsigned int TESYS0_POSTWR_ERR  :  1;  /**< Shared INTR_3 status bit (From TESYS[0]_POSTWR_ERR) */
      unsigned int reserved3          : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT3_t;

/*@}*/

/** @defgroup SISTAT5 Shared Interrupt 5 Status Register (SISTAT5) Register
 *  Shared Interrupt 5 Status Register (SISTAT5) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT5_Struct
 *! \brief  Shared Interrupt 5 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT5_t {
  union {
    struct {
      unsigned int M4PFLASH0_CORE_FLASH_EERR :  1;  /**< Shared INTR_5 status bit (From M4PFLASH[0]_CORE_FLASH_EERR) */
      unsigned int M4P_BUS_FAULT             :  1;  /**< Shared INTR_5 status bit (From M4P_BUS_FAULT) */
      unsigned int M4P_CORE_SRAM_EERR        :  1;  /**< Shared INTR_5 status bit (From M4P_CORE_SRAM_EERR) */
      unsigned int M4P_LOCKUP                :  1;  /**< Shared INTR_5 status bit (From M4P_LOCKUP) */
      unsigned int MBOX0_PORT1_EERR          :  1;  /**< Shared INTR_5 status bit (From MBOX[0]_PORT1_EERR) */
      unsigned int SPU1_TIMEOUT              :  1;  /**< Shared INTR_5 status bit (From SPU[1]_TIMEOUT) */
      unsigned int TESYS1_BUS_TIMEOUT        :  1;  /**< Shared INTR_5 status bit (From TESYS[1]_BUS_TIMEOUT) */
      unsigned int reserved7                 : 25;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT5_t;

/*@}*/

/** @defgroup SISTAT6 Shared Interrupt 6 Status Register (SISTAT6) Register
 *  Shared Interrupt 6 Status Register (SISTAT6) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT6_Struct
 *! \brief  Shared Interrupt 6 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT6_t {
  union {
    struct {
      unsigned int FFTB0_DPERR :  1;  /**< Shared INTR_6 status bit (From FFTB[0]_DPERR) */
      unsigned int FFTB0_SPERR :  1;  /**< Shared INTR_6 status bit (From FFTB[0]_SPERR) */
      unsigned int HAE0_PERR   :  1;  /**< Shared INTR_6 status bit (From HAE[0]_PERR) */
      unsigned int reserved3   : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT6_t;

/*@}*/

/** @defgroup SISTAT7 Shared Interrupt 7 Status Register (SISTAT7) Register
 *  Shared Interrupt 7 Status Register (SISTAT7) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT7_Struct
 *! \brief  Shared Interrupt 7 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT7_t {
  union {
    struct {
      unsigned int CGU0_EVT   :  1;  /**< Shared INTR_7 status bit (From CGU[0]_EVT) */
      unsigned int DPM0_EVT   :  1;  /**< Shared INTR_7 status bit (From DPM[0]_EVT) */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT7_t;

/*@}*/

/** @defgroup SISTAT8 Shared Interrupt 8 Status Register (SISTAT8) Register
 *  Shared Interrupt 8 Status Register (SISTAT8) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT8_Struct
 *! \brief  Shared Interrupt 8 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT8_t {
  union {
    struct {
      unsigned int SEC0_ERR   :  1;  /**< Shared INTR_8 status bit (From SEC[0]_ERR) */
      unsigned int SMPU0_ERR  :  1;  /**< Shared INTR_8 status bit (From SMPU[0]_ERR) */
      unsigned int SPU0_INT   :  1;  /**< Shared INTR_8 status bit (From SPU[0]_INT) */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT8_t;

/*@}*/

/** @defgroup SISTAT10 Shared Interrupt 10 Status Register (SISTAT10) Register
 *  Shared Interrupt 10 Status Register (SISTAT10) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT10_Struct
 *! \brief  Shared Interrupt 10 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT10_t {
  union {
    struct {
      unsigned int SYS_AFE_LIMIT :  1;  /**< Shared INTR_10 status bit (From SYS_AFE_LIMIT) */
      unsigned int SYS_AFE_NOTOK :  1;  /**< Shared INTR_10 status bit (From SYS_AFE_NOTOK) */
      unsigned int reserved2     : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT10_t;

/*@}*/

/** @defgroup SISTAT11 Shared Interrupt 11 Status Register (SISTAT11) Register
 *  Shared Interrupt 11 Status Register (SISTAT11) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT11_Struct
 *! \brief  Shared Interrupt 11 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT11_t {
  union {
    struct {
      unsigned int SWU0_EVT   :  1;  /**< Shared INTR_11 status bit (From SWU[0]_EVT) */
      unsigned int SWU1_EVT   :  1;  /**< Shared INTR_11 status bit (From SWU[1]_EVT) */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT11_t;

/*@}*/

/** @defgroup SISTAT12 Shared Interrupt 12 Status Register (SISTAT12) Register
 *  Shared Interrupt 12 Status Register (SISTAT12) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT12_Struct
 *! \brief  Shared Interrupt 12 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT12_t {
  union {
    struct {
      unsigned int DMA0_ERR   :  1;  /**< Shared INTR_12 status bit (From DMA[0]_ERR) */
      unsigned int DMA10_ERR  :  1;  /**< Shared INTR_12 status bit (From DMA[10]_ERR) */
      unsigned int DMA1_ERR   :  1;  /**< Shared INTR_12 status bit (From DMA[1]_ERR) */
      unsigned int DMA2_ERR   :  1;  /**< Shared INTR_12 status bit (From DMA[2]_ERR) */
      unsigned int DMA3_ERR   :  1;  /**< Shared INTR_12 status bit (From DMA[3]_ERR) */
      unsigned int DMA8_ERR   :  1;  /**< Shared INTR_12 status bit (From DMA[8]_ERR) */
      unsigned int DMA9_ERR   :  1;  /**< Shared INTR_12 status bit (From DMA[9]_ERR) */
      unsigned int reserved7  : 25;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT12_t;

/*@}*/

/** @defgroup SISTAT15 Shared Interrupt 15 Status Register (SISTAT15) Register
 *  Shared Interrupt 15 Status Register (SISTAT15) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT15_Struct
 *! \brief  Shared Interrupt 15 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT15_t {
  union {
    struct {
      unsigned int TIMER0_STAT :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_STAT) */
      unsigned int TIMER0_TMR0 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[0]) */
      unsigned int TIMER0_TMR1 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[1]) */
      unsigned int TIMER0_TMR2 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[2]) */
      unsigned int TIMER0_TMR3 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[3]) */
      unsigned int TIMER0_TMR4 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[4]) */
      unsigned int TIMER0_TMR5 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[5]) */
      unsigned int TIMER0_TMR6 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[6]) */
      unsigned int TIMER0_TMR7 :  1;  /**< Shared INTR_15 status bit (From TIMER[0]_TMR[7]) */
      unsigned int reserved9   : 23;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT15_t;

/*@}*/

/** @defgroup SISTAT16 Shared Interrupt 16 Status Register (SISTAT16) Register
 *  Shared Interrupt 16 Status Register (SISTAT16) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT16_Struct
 *! \brief  Shared Interrupt 16 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT16_t {
  union {
    struct {
      unsigned int CPTMR0_CPT0_MEAS :  1;  /**< Shared INTR_16 status bit (From CPTMR[0]_CPT[0]_MEAS) */
      unsigned int CPTMR0_CPT1_MEAS :  1;  /**< Shared INTR_16 status bit (From CPTMR[0]_CPT[1]_MEAS) */
      unsigned int CPTMR0_CPT2_MEAS :  1;  /**< Shared INTR_16 status bit (From CPTMR[0]_CPT[2]_MEAS) */
      unsigned int reserved3        : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT16_t;

/*@}*/

/** @defgroup SISTAT17 Shared Interrupt 17 Status Register (SISTAT17) Register
 *  Shared Interrupt 17 Status Register (SISTAT17) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT17_Struct
 *! \brief  Shared Interrupt 17 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT17_t {
  union {
    struct {
      unsigned int DMA0_INT   :  1;  /**< Shared INTR_17 status bit (From DMA[0]_INT) */
      unsigned int DMA2_INT   :  1;  /**< Shared INTR_17 status bit (From DMA[2]_INT) */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT17_t;

/*@}*/

/** @defgroup SISTAT18 Shared Interrupt 18 Status Register (SISTAT18) Register
 *  Shared Interrupt 18 Status Register (SISTAT18) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT18_Struct
 *! \brief  Shared Interrupt 18 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT18_t {
  union {
    struct {
      unsigned int DMA1_INT   :  1;  /**< Shared INTR_18 status bit (From DMA[1]_INT) */
      unsigned int DMA3_INT   :  1;  /**< Shared INTR_18 status bit (From DMA[3]_INT) */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT18_t;

/*@}*/

/** @defgroup SISTAT19 Shared Interrupt 19 Status Register (SISTAT19) Register
 *  Shared Interrupt 19 Status Register (SISTAT19) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT19_Struct
 *! \brief  Shared Interrupt 19 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT19_t {
  union {
    struct {
      unsigned int DMA10_INT  :  1;  /**< Shared INTR_19 status bit (From DMA[10]_INT) */
      unsigned int DMA8_INT   :  1;  /**< Shared INTR_19 status bit (From DMA[8]_INT) */
      unsigned int DMA9_INT   :  1;  /**< Shared INTR_19 status bit (From DMA[9]_INT) */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT19_t;

/*@}*/

/** @defgroup SISTAT22 Shared Interrupt 22 Status Register (SISTAT22) Register
 *  Shared Interrupt 22 Status Register (SISTAT22) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT22_Struct
 *! \brief  Shared Interrupt 22 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT22_t {
  union {
    struct {
      unsigned int FFTB0_DONE :  1;  /**< Shared INTR_22 status bit (From FFTB[0]_DONE) */
      unsigned int FFTB0_LIMERR :  1;  /**< Shared INTR_22 status bit (From FFTB[0]_LIMERR) */
      unsigned int reserved2    : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT22_t;

/*@}*/

/** @defgroup SISTAT25 Shared Interrupt 25 Status Register (SISTAT25) Register
 *  Shared Interrupt 25 Status Register (SISTAT25) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT25_Struct
 *! \brief  Shared Interrupt 25 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT25_t {
  union {
    struct {
      unsigned int SPI0_ERR   :  1;  /**< Shared INTR_25 status bit (From SPI[0]_ERR) */
      unsigned int SPI0_STAT  :  1;  /**< Shared INTR_25 status bit (From SPI[0]_STAT) */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT25_t;

/*@}*/

/** @defgroup SISTAT28 Shared Interrupt 28 Status Register (SISTAT28) Register
 *  Shared Interrupt 28 Status Register (SISTAT28) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_C_CFG1_SISTAT28_Struct
 *! \brief  Shared Interrupt 28 Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_C_CFG1_SISTAT28_t {
  union {
    struct {
      unsigned int CAN0_RX    :  1;  /**< Shared INTR_28 status bit (From CAN[0]_RX) */
      unsigned int CAN0_STAT  :  1;  /**< Shared INTR_28 status bit (From CAN[0]_STAT) */
      unsigned int CAN0_TX    :  1;  /**< Shared INTR_28 status bit (From CAN[0]_TX) */
      unsigned int reserved3  : 29;
    };
    uint32_t VALUE32;
  };
} ADI_C_CFG1_SISTAT28_t;

/*@}*/

/** @defgroup PCFG0 Peripheral Configuration0 Register (PCFG0) Register
 *  Peripheral Configuration0 Register (PCFG0) Register.
 *
 *  The PCFG0 register provides several configuration options for various peripherals.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG1_PCFG0_Struct
 *! \brief  Peripheral Configuration0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG1_PCFG0_t {
  union {
    struct {
      unsigned int reserved0  : 12;
      unsigned int PUE        :  1;  /**< Pull-Up Enable */
      unsigned int reserved13 :  3;
      unsigned int AUXTRMEN   :  1;  /**< Enable for 3V Auxiliary Watchdog Oscillator  latches which control trim values */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG1_PCFG0_t;

/*@}*/

/** @defgroup PORT_DS Multiport Drive Strength Register (PORT_DS) Register
 *  Multiport Drive Strength Register (PORT_DS) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG1_PORT_DS_Struct
 *! \brief  Multiport Drive Strength Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG1_PORT_DS_t {
  union {
    struct {
      unsigned int GPIO_DS    : 16;  /**< Port Drive Strength */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG1_PORT_DS_t;

/*@}*/

/** @defgroup PORT_RCTL Multiport Pullup/Pulldown Resistor Control Register (PORT_RCTL) Register
 *  Multiport Pullup/Pulldown Resistor Control Register (PORT_RCTL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG1_PORT_RCTL_Struct
 *! \brief  Multiport Pullup/Pulldown Resistor Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG1_PORT_RCTL_t {
  union {
    struct {
      unsigned int REN_CTL    : 16;  /**< Port Resistor Enable Control */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG1_PORT_RCTL_t;

/*@}*/

/** @defgroup PORT_TRIPST Multiport Trip State Register (PORT_TRIPST) Register
 *  Multiport Trip State Register (PORT_TRIPST) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG1_PORT_TRIPST_Struct
 *! \brief  Multiport Trip State Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG1_PORT_TRIPST_t {
  union {
    struct {
      unsigned int TS0        :  2;  /**< Port IO_0 Trip State */
      unsigned int TS1        :  2;  /**< Port IO 1 Trip State */
      unsigned int TS2        :  2;  /**< Port IO 2 Trip State */
      unsigned int TS3        :  2;  /**< Port IO 3 Trip State */
      unsigned int TS4        :  2;  /**< Port IO 4 Trip State */
      unsigned int TS5        :  2;  /**< Port IO 5 Trip State */
      unsigned int TS6        :  2;  /**< Port IO 6 Trip State */
      unsigned int TS7        :  2;  /**< Port IO 7 Trip State */
      unsigned int TS8        :  2;  /**< Port IO 8 Trip State */
      unsigned int TS9        :  2;  /**< Port IO 9 Trip State */
      unsigned int TS10       :  2;  /**< Port IO 10 Trip State */
      unsigned int TS11       :  2;  /**< Port IO 11 Trip State */
      unsigned int TS12       :  2;  /**< Port IO 12 Trip State */
      unsigned int TS13       :  2;  /**< Port IO 13 Trip State */
      unsigned int TS14       :  2;  /**< Port IO 14 Trip State */
      unsigned int TS15       :  2;  /**< Port IO 15 Trip State */
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG1_PORT_TRIPST_t;

/*@}*/

/** @defgroup PORT_TRIPSEL Multiport Trip Select (PORT_TRIPSEL) Register
 *  Multiport Trip Select (PORT_TRIPSEL) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TEPADS_CFG1_PORT_TRIPSEL_Struct
 *! \brief  Multiport Trip Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TEPADS_CFG1_PORT_TRIPSEL_t {
  union {
    struct {
      unsigned int SEL        : 16;  /**< Trip A/B Mux Select */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_TEPADS_CFG1_PORT_TRIPSEL_t;

/*@}*/

/** @defgroup FER Port x Function Enable Register (FER) Register
 *  Port x Function Enable Register (FER) Register.
 *
 *  The FER register bits indicate each port bit's operating mode: general purpose I/O mode or peripheral mode. After reset, all pins default to GPIO mode. Setting a bit in the FER registers enables a peripheral module to take ownership of the pin. The function enable bits impact output control only. Regardless of the setting of the function enable bits, both GPIO and peripherals can still sense the pin input. After a function is enabled, it is up to the MUX registers as to which peripheral takes control.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_FER_Struct
 *! \brief  Port x Function Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_FER_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Mode */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Mode */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Mode */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Mode */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Mode */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Mode */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Mode */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Mode */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Mode */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Mode */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Mode */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Mode */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Mode */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Mode */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Mode */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Mode */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_FER_t;

/*@}*/

/** @defgroup FER_SET Port x Function Enable Set Register (FER_SET) Register
 *  Port x Function Enable Set Register (FER_SET) Register.
 *
 *  The FER_SET register permits enabling peripheral mode for each bit and corresponding GPIO pin. Writing 1 to a bit in FER_SET enables peripheral mode for the corresponding pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_FER_SET_Struct
 *! \brief  Port x Function Enable Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_FER_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Mode Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Mode Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Mode Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Mode Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Mode Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Mode Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Mode Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Mode Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Mode Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Mode Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Mode Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Mode Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Mode Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Mode Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Mode Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Mode Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_FER_SET_t;

/*@}*/

/** @defgroup FER_CLR Port x Function Enable Clear Register (FER_CLR) Register
 *  Port x Function Enable Clear Register (FER_CLR) Register.
 *
 *  The FER_CLR register permits enabling GPIO mode for each bit and corresponding GPIO pin. Writing 1 to a bit in FER_CLR enables GPIO mode for the corresponding pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_FER_CLR_Struct
 *! \brief  Port x Function Enable Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_FER_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Mode Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Mode Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Mode Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Mode Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Mode Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Mode Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Mode Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Mode Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Mode Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Mode Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Mode Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Mode Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Mode Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Mode Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Mode Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Mode Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_FER_CLR_t;

/*@}*/

/** @defgroup DATA Port x GPIO Data Register (DATA) Register
 *  Port x GPIO Data Register (DATA) Register.
 *
 *  The DATA register operates differently for port bits/pins, depending on whether the bit/pin is in output mode or input mode. In both modes, a set bit in the DATA register corresponds to a signal high on a GPIO pin, and a cleared bit in the DATA register corresponds to a signal low on a GPIO pin. 
 *  The DATA, DATA_SET, and DATA_CLR registers control the state of GPIO pins in output mode. To enable output mode (and output drivers), use the DIR_SET and DIR_CLR registers. 
 *  Writes to the DATA register affect the state of all pins of the port that are in output mode. To set or clear specific pins without impacting other pins of the port, use the DATA_SET and DATA_CLR registers. 
 *  When the GPIO pins are in input mode (input driver is enabled with the INEN register), reads from the DATA, DATA_SET, and DATA_CLR registers return the state of the respective GPIO pins.  
 *  Note that when the input driver is not enabled, reads from the DATA, DATA_SET, and DATA_CLR registers return the value previously written to the registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DATA_Struct
 *! \brief  Port x GPIO Data Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DATA_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Data */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Data */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Data */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Data */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Data */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Data */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Data */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Data */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Data */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Data */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Data */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Data */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Data */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Data */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Data */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Data */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DATA_t;

/*@}*/

/** @defgroup DATA_SET Port x GPIO Data Set Register (DATA_SET) Register
 *  Port x GPIO Data Set Register (DATA_SET) Register.
 *
 *  The DATA_SET register operates differently for port bits/pins, depending on whether the bit/pin is output mode or input mode. For more information, see the DATA register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DATA_SET_Struct
 *! \brief  Port x GPIO Data Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DATA_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Data Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Data Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Data Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Data Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Data Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Data Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Data Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Data Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Data Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Data Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Data Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Data Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Data Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Data Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Data Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Data Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DATA_SET_t;

/*@}*/

/** @defgroup DATA_CLR Port x GPIO Data Clear Register (DATA_CLR) Register
 *  Port x GPIO Data Clear Register (DATA_CLR) Register.
 *
 *  The DATA_CLR register operates differently for port bits/pins, depending on whether the bit/pin is output mode or input mode. For more information, see the DATA register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DATA_CLR_Struct
 *! \brief  Port x GPIO Data Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DATA_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Data Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Data Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Data Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Data Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Data Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Data Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Data Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Data Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Data Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Data Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Data Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Data Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Data Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Data Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Data Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Data Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DATA_CLR_t;

/*@}*/

/** @defgroup DIR Port x GPIO Direction Register (DIR) Register
 *  Port x GPIO Direction Register (DIR) Register.
 *
 *  The DIR, DIR_SET, and DIR_CLR registers select output or input mode for GPIO pins and enable output drivers. Use the INEN, INEN_SET, and INEN_CLR registers to enable or disable input drivers. 
 *  Writes to the DIR register affect the state of all pins of the port. To select direction for specific pins without impacting other pins of the port, use the DIR_SET and DIR_CLR registers. 
 *  Setting a bit in the DIR register enables output mode on the corresponding a GPIO pin, and a clearing a bit in the DIR register disables output mode on the corresponding GPIO pin. 
 *  Input Mode - The default mode of every GPIO pin after reset is input mode, but the input drivers are not enabled. To enable any GPIO input drivers, set the corresponding bits in INEN register. When enabled, a read from the DATA register returns the logical state of the input pin. The input signal does not overwrite the state of the bit used for the output case. That state can only be altered by software. If the input driver is enabled, a write to the DATA register can alter the state of the bit, but the change cannot be read back. 
 *  Output Mode - Any GPIO pin can be configured for output mode. The GPIO output drivers are enabled by setting the corresponding bits in the DIR, DIR_SET, or DIR_CLR registers.  By using the DIR_SET and DIR_CLR registers, direction of the signal flow of individual GPIO pins can be altered by separate software threads without mutually impacting other GPIOs on the same port. Both registers return the same value when read. Because the state of the GPIO output can already be controlled before the output driver is enabled, it is recommended to first set or clear the bit (using the DATA, DATA_SET, or DATA_CLR registers) to avoid any volatile levels on the output. 
 *  Open-Drain Mode- Every GPIO can also be used in open-drain mode. To accomplish this, first, clear the respective bit in the DATA or DATA_CLR register then set the one bit in the INEN register. Reads from the DATA register then return the status from the pin and do not return the state of the internal flip-flop. By toggling the output driver through the DIR_SET and DIR_CLR register pair, the output signal can be pulled low or three-stated as required. Note that the polarity of the driven signal can be inverted when the internal flip-flop is set instead. When a GPIO port is used in open-drain mode, care must be taken not to exceed the V$[sub$]IH$[/sub$] operating condition associated with the respective pin.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DIR_Struct
 *! \brief  Port x GPIO Direction Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DIR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Direction */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Direction */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Direction */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Direction */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Direction */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Direction */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Direction */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Direction */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Direction */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Direction */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Direction */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Direction */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Direction */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Direction */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Direction */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Direction */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DIR_t;

/*@}*/

/** @defgroup DIR_SET Port x GPIO Direction Set Register (DIR_SET) Register
 *  Port x GPIO Direction Set Register (DIR_SET) Register.
 *
 *  The DIR_SET register enable output mode and enables output drivers for GPIO pins. For more information, see the DIR register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DIR_SET_Struct
 *! \brief  Port x GPIO Direction Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DIR_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Direction Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Direction Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Direction Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Direction Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Direction Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Direction Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Direction Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Direction Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Direction Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Direction Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Direction Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Direction Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Direction Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Direction Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Direction Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Direction Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DIR_SET_t;

/*@}*/

/** @defgroup DIR_CLR Port x GPIO Direction Clear Register (DIR_CLR) Register
 *  Port x GPIO Direction Clear Register (DIR_CLR) Register.
 *
 *  The DIR_CLR register disables output mode and disables output drivers for GPIO pins. For more information, see the DIR register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DIR_CLR_Struct
 *! \brief  Port x GPIO Direction Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DIR_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Direction Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Direction Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Direction Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Direction Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Direction Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Direction Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Direction Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Direction Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Direction Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Direction Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Direction Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Direction Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Direction Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Direction Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Direction Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Direction Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DIR_CLR_t;

/*@}*/

/** @defgroup INEN Port x GPIO Input Enable Register (INEN) Register
 *  Port x GPIO Input Enable Register (INEN) Register.
 *
 *  The INEN, INEN_SET, and INEN_CLR registers enable or disable input drivers, which are required for using a GPIO pin in input mode. 
 *  Writes to the INEN register affect the input drivers for all pins of the port. To set or clear specific pin drivers without impacting other pin drivers of the port, use the INEN_SET and INEN_CLR registers. 
 *  If the input is enabled, reads from the DATA, DATA_SET, or DATA_CLR registers return the state of the pins. However, the state of the output is not overwritten by the input. It is altered by software writes only. Input and output drivers can be enabled at the same time. In this case, a read of the data register returns the true value of the data register and not the pin state. 
 *  For more information see the DATA register description and the DIR register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_INEN_Struct
 *! \brief  Port x GPIO Input Enable Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_INEN_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Input Enable */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Input Enable */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Input Enable */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Input Enable */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Input Enable */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Input Enable */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Input Enable */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Input Enable */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Input Enable */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Input Enable */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Input Enable */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Input Enable */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Input Enable */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Input Enable */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Input Enable */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Input Enable */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_INEN_t;

/*@}*/

/** @defgroup INEN_SET Port x GPIO Input Enable Set Register (INEN_SET) Register
 *  Port x GPIO Input Enable Set Register (INEN_SET) Register.
 *
 *  The INEN_SET register enables input drivers for GPIO pins. For more information, see the INEN register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_INEN_SET_Struct
 *! \brief  Port x GPIO Input Enable Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_INEN_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Input Enable Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Input Enable Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Input Enable Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Input Enable Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Input Enable Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Input Enable Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Input Enable Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Input Enable Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Input Enable Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Input Enable Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Input Enable Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Input Enable Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Input Enable Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Input Enable Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Input Enable Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Input Enable Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_INEN_SET_t;

/*@}*/

/** @defgroup INEN_CLR Port x GPIO Input Enable Clear Register (INEN_CLR) Register
 *  Port x GPIO Input Enable Clear Register (INEN_CLR) Register.
 *
 *  The INEN_CLR register disables input drivers for GPIO pins. For more information, see the INEN register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_INEN_CLR_Struct
 *! \brief  Port x GPIO Input Enable Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_INEN_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Input Enable Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Input Enable Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Input Enable Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Input Enable Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Input Enable Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Input Enable Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Input Enable Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Input Enable Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Input Enable Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Input Enable Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Input Enable Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Input Enable Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Input Enable Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Input Enable Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Input Enable Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Input Enable Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_INEN_CLR_t;

/*@}*/

/** @defgroup MUX Port x Multiplexer Control Register (MUX) Register
 *  Port x Multiplexer Control Register (MUX) Register.
 *
 *  When a pin is in peripheral mode (not GPIO mode), the MUX register controls which peripheral takes ownership of a pin. Ports may have multiple, different peripheral functions. Two bits are required to describe every multiplexer on an individual pin-by-pin scheme. For example, Bit 0 and Bit 1 of the MUX register control the multiplexer of Pin 0, Bit 2 and Bit 3 of MUX control the multiplexer of Pin 1, and so on. The value of any MUX bit has no effect on the port pins when the associated bit in the FER register is 0 (selects GPIO mode). Even if a port has only one function, the MUX register is still present. For single function ports (no multiplexing is needed), leave the MUX bits at 0 (default). For all MUX bit fields: 00 = default/reset peripheral option, 01 = first alternate peripheral option, 10 = second alternate peripheral option, and 11 = third alternate peripheral option.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_MUX_Struct
 *! \brief  Port x Multiplexer Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_MUX_t {
  union {
    struct {
      unsigned int MUX0       :  2;  /**< Mux for Port x Bit 0 */
      unsigned int MUX1       :  2;  /**< Mux for Port x Bit 1 */
      unsigned int MUX2       :  2;  /**< Mux for Port x Bit 2 */
      unsigned int MUX3       :  2;  /**< Mux for Port x Bit 3 */
      unsigned int MUX4       :  2;  /**< Mux for Port x Bit 4 */
      unsigned int MUX5       :  2;  /**< Mux for Port x Bit 5 */
      unsigned int MUX6       :  2;  /**< Mux for Port x Bit 6 */
      unsigned int MUX7       :  2;  /**< Mux for Port x Bit 7 */
      unsigned int MUX8       :  2;  /**< Mux for Port x Bit 8 */
      unsigned int MUX9       :  2;  /**< Mux for Port x Bit 9 */
      unsigned int MUX10      :  2;  /**< Mux for Port x Bit 10 */
      unsigned int MUX11      :  2;  /**< Mux for Port x Bit 11 */
      unsigned int MUX12      :  2;  /**< Mux for Port x Bit 12 */
      unsigned int MUX13      :  2;  /**< Mux for Port x Bit 13 */
      unsigned int MUX14      :  2;  /**< Mux for Port x Bit 14 */
      unsigned int MUX15      :  2;  /**< Mux for Port x Bit 15 */
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_MUX_t;

/*@}*/

/** @defgroup DATA_TGL Port x GPIO Input Enable Toggle Register (DATA_TGL) Register
 *  Port x GPIO Input Enable Toggle Register (DATA_TGL) Register.
 *
 *  The DATA_TGL register permits toggling the state of output GPIO pins. Setting bits in the DATA_TGL register affects the state of specific pins without impacting other pins of the port. 
 *  Reading the DATA_TGL returns the state of the DATA register output pin state, but does not return the input pin/signal state.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_DATA_TGL_Struct
 *! \brief  Port x GPIO Input Enable Toggle Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_DATA_TGL_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Toggle */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Toggle */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Toggle */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Toggle */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Toggle */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Toggle */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Toggle */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Toggle */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Toggle */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Toggle */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Toggle */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Toggle */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Toggle */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Toggle */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Toggle */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Toggle */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_DATA_TGL_t;

/*@}*/

/** @defgroup POL Port x GPIO Polarity Invert Register (POL) Register
 *  Port x GPIO Polarity Invert Register (POL) Register.
 *
 *  The POL, POL_SET, and POL_CLR registers enable or disable inverting polarity of GPIO signals. To invert polarity of peripheral signals, use the inversion selection programming in the signal's corresponding module.  
 *  Writes to the POL register affect the polarity inversion selection of all pins of the port. To enable or disable polarity inversion for specific pins without impacting other pins of the port, use the POL_SET and POL_CLR registers. 
 *  Setting a bit in the POL register enables polarity inversion on the corresponding inversion GPIO pin, making the pin active-low or falling-edge sensitive. Clearing a bit in the POL register disables polarity (default state) on the corresponding GPIO pin, making it active-high or rising-edge sensitive.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_POL_Struct
 *! \brief  Port x GPIO Polarity Invert Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_POL_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Polarity Invert */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Polarity Invert */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Polarity Invert */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Polarity Invert */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Polarity Invert */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Polarity Invert */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Polarity Invert */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Polarity Invert */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Polarity Invert */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Polarity Invert */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Polarity Invert */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Polarity Invert */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Polarity Invert */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Polarity Invert */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Polarity Invert */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Polarity Invert */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_POL_t;

/*@}*/

/** @defgroup POL_SET Port x GPIO Polarity Invert Set Register (POL_SET) Register
 *  Port x GPIO Polarity Invert Set Register (POL_SET) Register.
 *
 *  The POL_SET register enables polarity inversion for GPIO pins. For more information, see the POL register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_POL_SET_Struct
 *! \brief  Port x GPIO Polarity Invert Set Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_POL_SET_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Polarity Invert Set */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Polarity Invert Set */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Polarity Invert Set */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Polarity Invert Set */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Polarity Invert Set */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Polarity Invert Set */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Polarity Invert Set */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Polarity Invert Set */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Polarity Invert Set */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Polarity Invert Set */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Polarity Invert Set */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Polarity Invert Set */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Polarity Invert Set */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Polarity Invert Set */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Polarity Invert Set */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Polarity Invert Set */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_POL_SET_t;

/*@}*/

/** @defgroup POL_CLR Port x GPIO Polarity Invert Clear Register (POL_CLR) Register
 *  Port x GPIO Polarity Invert Clear Register (POL_CLR) Register.
 *
 *  The POL_CLR register disables polarity inversion for GPIO pins. For more information, see the POL register description.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_POL_CLR_Struct
 *! \brief  Port x GPIO Polarity Invert Clear Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_POL_CLR_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< Port x Bit 0 Polarity Invert Clear */
      unsigned int PX1        :  1;  /**< Port x Bit 1 Polarity Invert Clear */
      unsigned int PX2        :  1;  /**< Port x Bit 2 Polarity Invert Clear */
      unsigned int PX3        :  1;  /**< Port x Bit 3 Polarity Invert Clear */
      unsigned int PX4        :  1;  /**< Port x Bit 4 Polarity Invert Clear */
      unsigned int PX5        :  1;  /**< Port x Bit 5 Polarity Invert Clear */
      unsigned int PX6        :  1;  /**< Port x Bit 6 Polarity Invert Clear */
      unsigned int PX7        :  1;  /**< Port x Bit 7 Polarity Invert Clear */
      unsigned int PX8        :  1;  /**< Port x Bit 8 Polarity Invert Clear */
      unsigned int PX9        :  1;  /**< Port x Bit 9 Polarity Invert Clear */
      unsigned int PX10       :  1;  /**< Port x Bit 10 Polarity Invert Clear */
      unsigned int PX11       :  1;  /**< Port x Bit 11 Polarity Invert Clear */
      unsigned int PX12       :  1;  /**< Port x Bit 12 Polarity Invert Clear */
      unsigned int PX13       :  1;  /**< Port x Bit 13 Polarity Invert Clear */
      unsigned int PX14       :  1;  /**< Port x Bit 14 Polarity Invert Clear */
      unsigned int PX15       :  1;  /**< Port x Bit 15 Polarity Invert Clear */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_POL_CLR_t;

/*@}*/

/** @defgroup LOCK Port x GPIO Lock Register (LOCK) Register
 *  Port x GPIO Lock Register (LOCK) Register.
 *
 *  The LOCK register enables (unlocks) or disables (locks) write access selectively for the PORT_CFG1 control registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_LOCK_Struct
 *! \brief  Port x GPIO Lock Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_LOCK_t {
  union {
    struct {
      unsigned int FER        :  1;  /**< Function Enable Lock */
      unsigned int MUX        :  1;  /**< Function Multiplexer Lock */
      unsigned int DATA       :  1;  /**< Data, TGL Lock */
      unsigned int DIR        :  1;  /**< Direction Lock */
      unsigned int INEN       :  1;  /**< Input Enable Lock */
      unsigned int POLAR      :  1;  /**< Polarity Lock */
      unsigned int reserved6  : 25;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_LOCK_t;

/*@}*/

/** @defgroup TRIG_TGL Port x GPIO Trigger Toggle Register (TRIG_TGL) Register
 *  Port x GPIO Trigger Toggle Register (TRIG_TGL) Register.
 *
 *  The TRIG_TGL register is reserved for internal ADI usage only.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_PORT_CFG1_TRIG_TGL_Struct
 *! \brief  Port x GPIO Trigger Toggle Register bit field structure
 * ========================================================================== */
typedef struct _ADI_PORT_CFG1_TRIG_TGL_t {
  union {
    struct {
      unsigned int PX0        :  1;  /**< PX0 Data Toggle on Trigger */
      unsigned int PX1        :  1;  /**< PX1 Data Toggle on Trigger */
      unsigned int PX2        :  1;  /**< PX2 Data Toggle on Trigger */
      unsigned int PX3        :  1;  /**< PX3 Data Toggle on Trigger */
      unsigned int PX4        :  1;  /**< PX4 Data Toggle on Trigger */
      unsigned int PX5        :  1;  /**< PX5 Data Toggle on Trigger */
      unsigned int PX6        :  1;  /**< PX6 Data Toggle on Trigger */
      unsigned int PX7        :  1;  /**< PX7 Data Toggle on Trigger */
      unsigned int PX8        :  1;  /**< PX8 Data Toggle on Trigger */
      unsigned int PX9        :  1;  /**< PX9 Data Toggle on Trigger */
      unsigned int PX10       :  1;  /**< PX10 Data Toggle on Trigger */
      unsigned int PX11       :  1;  /**< PX11 Data Toggle on Trigger */
      unsigned int PX12       :  1;  /**< PX12 Data Toggle on Trigger */
      unsigned int PX13       :  1;  /**< PX13 Data Toggle on Trigger */
      unsigned int PX14       :  1;  /**< PX14 Data Toggle on Trigger */
      unsigned int PX15       :  1;  /**< PX15 Data Toggle on Trigger */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_PORT_CFG1_TRIG_TGL_t;

/*@}*/

/** @defgroup SCTL Source Control Register n (SCTL) Register
 *  Source Control Register n (SCTL) Register.
 *
 *  The SEC_CFG1 source control register (SCTL[n]) contains control bits to configure the SEC_CFG1 event sources. This register controls the configuration of the corresponding SEC event source.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_SCTL_Struct
 *! \brief  Source Control Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_SCTL_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int FEN        :  1;  /**< Fault Enable */
      unsigned int SEN        :  1;  /**< Source (signal) Enable */
      unsigned int ES         :  1;  /**< Edge Select */
      unsigned int ERREN      :  1;  /**< Error Enable */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_SCTL_t;

/*@}*/

/** @defgroup SSTAT Source Status Register n (SSTAT) Register
 *  Source Status Register n (SSTAT) Register.
 *
 *  The SEC_CFG1 event source status register (SSTAT[n]) contains bits indicating the status of the corresponding event source n. An event source may be: pending, active, active and pending, or neither pending nor active.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_SSTAT_Struct
 *! \brief  Source Status Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_SSTAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int ERR        :  1;  /**< Error */
      unsigned int reserved2  :  2;
      unsigned int ERRC       :  2;  /**< Error Cause */
      unsigned int reserved6  :  2;
      unsigned int PND        :  1;  /**< Pending Source */
      unsigned int reserved9  : 23;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_SSTAT_t;

/*@}*/

/** @defgroup FCTL Fault Control Register (FCTL) Register
 *  Fault Control Register (FCTL) Register.
 *
 *  The SEC_CFG1 fault control register (FCTL) contains fault control bits for all SEC_CFG1 channels. This register controls the operation of the System Fault Management Interface (SFI).
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FCTL_Struct
 *! \brief  Fault Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int RESET      :  1;  /**< Reset */
      unsigned int reserved2  :  2;
      unsigned int FOEN       :  1;  /**< Fault Output Enable */
      unsigned int TOEN       :  1;  /**< Trigger Output Enable */
      unsigned int SREN       :  1;  /**< System Reset Enable */
      unsigned int FIEN       :  1;  /**< Fault Input Enable */
      unsigned int reserved8  :  4;
      unsigned int CMS        :  1;  /**< COP Mode Select */
      unsigned int TES        :  1;  /**< Trigger Event Select */
      unsigned int reserved14 : 17;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FCTL_t;

/*@}*/

/** @defgroup FSTAT Fault Status Register (FSTAT) Register
 *  Fault Status Register (FSTAT) Register.
 *
 *  The SEC_CFG1 fault status register (FSTAT) indicates the operational status of the SFI.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FSTAT_Struct
 *! \brief  Fault Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FSTAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int ERR        :  1;  /**< Error */
      unsigned int reserved2  :  2;
      unsigned int ERRC       :  2;  /**< Error Cause */
      unsigned int reserved6  :  2;
      unsigned int PND        :  1;  /**< Pending Fault */
      unsigned int ACT        :  1;  /**< Fault Active */
      unsigned int NPND       :  1;  /**< Next Pending Fault */
      unsigned int reserved11 : 21;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FSTAT_t;

/*@}*/

/** @defgroup FSID Fault Source ID Register (FSID) Register
 *  Fault Source ID Register (FSID) Register.
 *
 *  The SEC_CFG1 fault source ID register (FSID) contains a fault source ID and internal/external fields.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FSID_Struct
 *! \brief  Fault Source ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FSID_t {
  union {
    struct {
      unsigned int SID        :  8;  /**< Source ID */
      unsigned int reserved8  :  8;
      unsigned int FEXT       :  1;  /**< Fault External */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FSID_t;

/*@}*/

/** @defgroup FEND Fault End Register (FEND) Register
 *  Fault End Register (FEND) Register.
 *
 *  The SEC_CFG1 fault end register (FEND) contains fault source ID and internal/external fields. This register receives fault end indication from a core.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FEND_Struct
 *! \brief  Fault End Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FEND_t {
  union {
    struct {
      unsigned int SID        :  8;  /**< Source ID */
      unsigned int reserved8  :  8;
      unsigned int FEXT       :  1;  /**< Fault External */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FEND_t;

/*@}*/

/** @defgroup FDLY Fault Delay Register (FDLY) Register
 *  Fault Delay Register (FDLY) Register.
 *
 *  The SEC_CFG1 fault delay register (FDLY) contains the number (COUNT field) of (SEC) clock periods to delay from fault pending to fault active, when actions are enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FDLY_Struct
 *! \brief  Fault Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FDLY_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FDLY_t;

/*@}*/

/** @defgroup FDLY_CUR Fault Delay Current Register (FDLY_CUR) Register
 *  Fault Delay Current Register (FDLY_CUR) Register.
 *
 *  The SEC_CFG1 fault delay current register (FDLY_CUR) contains the active count (COUNT field) in (SEC) clock periods for the delay from fault pending to fault active, when actions are enabled. The count is loaded from the FDLY register when a fault becomes pending (FSTAT:PND bit is set). The SEC_CFG1 decrements the value in FDLY_CUR each (SEC) clock cycle while the FSTAT:PND bit is set.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FDLY_CUR_Struct
 *! \brief  Fault Delay Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FDLY_CUR_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FDLY_CUR_t;

/*@}*/

/** @defgroup FSRDLY Fault System Reset Delay Register (FSRDLY) Register
 *  Fault System Reset Delay Register (FSRDLY) Register.
 *
 *  The SEC_CFG1 fault system reset delay register (FSRDLY) contains the number (COUNT field) of (SEC) clock periods for the delay from a fault becoming active to system reset request assertion, if enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FSRDLY_Struct
 *! \brief  Fault System Reset Delay Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FSRDLY_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault System Reset Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FSRDLY_t;

/*@}*/

/** @defgroup FSRDLY_CUR Fault System Reset Delay Current Register (FSRDLY_CUR) Register
 *  Fault System Reset Delay Current Register (FSRDLY_CUR) Register.
 *
 *  The SEC_CFG1 fault system reset delay current register (FSRDLY_CUR) contains the active count (COUNT field) in (SEC) clock periods for the delay from fault active to system reset assertion, if enabled. The count is loaded from the FSRDLY register when a fault becomes active (FSTAT:ACT bit is set). The SEC_CFG1 decrements the value in FSRDLY_CUR each (SEC) clock cycle while the FSTAT:ACT bit is set.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FSRDLY_CUR_Struct
 *! \brief  Fault System Reset Delay Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FSRDLY_CUR_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault System Reset Delay */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FSRDLY_CUR_t;

/*@}*/

/** @defgroup FCOPP Fault COP Period Register (FCOPP) Register
 *  Fault COP Period Register (FCOPP) Register.
 *
 *  The SEC_CFG1 fault COP period register (FCOPP) contains the width value (count in (SEC) clock cycles) for the high and low phase of the computer operating properly (COP) toggled output on the COP pin. Note that the actual high/low phase is value is the COUNT programmed value plus 1.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FCOPP_Struct
 *! \brief  Fault COP Period Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FCOPP_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault COP Period */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FCOPP_t;

/*@}*/

/** @defgroup FCOPP_CUR Fault COP Period Current Register (FCOPP_CUR) Register
 *  Fault COP Period Current Register (FCOPP_CUR) Register.
 *
 *  The SEC_CFG1 fault COP period current register (FCOPP_CUR) contains the active count (in (SEC) clock periods) for the current phase (high or low) of the computer operating properly (COP) toggled output on the COP pin. The SEC_CFG1 loads the FCOPP_CUR register from the FCOPP register when the COUNT field is cleared and the SEC_CFG1 is in COP mode (FCTL:CMS bit =1). The SEC_CFG1 decrements the FCOPP_CUR count each (SEC) clock cycle while FCTL:CMS is set and the FSTAT:ACT bit is not set.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_FCOPP_CUR_Struct
 *! \brief  Fault COP Period Current Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_FCOPP_CUR_t {
  union {
    struct {
      unsigned int COUNT      : 32;  /**< Fault COP Period */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_FCOPP_CUR_t;

/*@}*/

/** @defgroup GCTL Global Control Register (GCTL) Register
 *  Global Control Register (GCTL) Register.
 *
 *  The SEC_CFG1 global control register (GCTL) provides register locking, reset, and enable for the SEC_CFG1 module.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_GCTL_Struct
 *! \brief  Global Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_GCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Enable */
      unsigned int RESET      :  1;  /**< Reset */
      unsigned int reserved2  : 29;
      unsigned int LOCK       :  1;  /**< Lock */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_GCTL_t;

/*@}*/

/** @defgroup GSTAT Global Status Register (GSTAT) Register
 *  Global Status Register (GSTAT) Register.
 *
 *  The SEC_CFG1 global status register (GSTAT) contains global status bits for the SEC_CFG1.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_GSTAT_Struct
 *! \brief  Global Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_GSTAT_t {
  union {
    struct {
      unsigned int reserved0  :  1;
      unsigned int ERR        :  1;  /**< Error */
      unsigned int reserved2  :  2;
      unsigned int ERRC       :  2;  /**< Error Cause */
      unsigned int reserved6  : 24;
      unsigned int ADRERR     :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_GSTAT_t;

/*@}*/

/** @defgroup RAISE Global Raise Register (RAISE) Register
 *  Global Raise Register (RAISE) Register.
 *
 *  The SEC_CFG1 global raise register (RAISE) contains a source ID event set-to-pending field (SID). When a source ID value is written to this field, the SEC_CFG1 raises the source's event status to pending.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SEC_CFG1_RAISE_Struct
 *! \brief  Global Raise Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SEC_CFG1_RAISE_t {
  union {
    struct {
      unsigned int SID        :  8;  /**< Source ID of event that is set to Pending status */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SEC_CFG1_RAISE_t;

/*@}*/

/** @defgroup MTR Master Trigger Register (MTR) Register
 *  Master Trigger Register (MTR) Register.
 *
 *  The TRU_CFG1 master trigger register (MTR) permits trigger generation through software by writing a trigger master ID value to one of the four fields in the MTR register. If the global lock is enabled SPU:CTL:GLCK bit =1) and the GCTL:LOCK bit is set, the MTR register is read only.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG1_MTR_Struct
 *! \brief  Master Trigger Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG1_MTR_t {
  union {
    struct {
      unsigned int MTR0       :  6;  /**< Master Trigger Register 0 */
      unsigned int reserved6  :  2;
      unsigned int MTR1       :  6;  /**< Master Trigger Register 1 */
      unsigned int reserved14 :  2;
      unsigned int MTR2       :  6;  /**< Master Trigger Register 2 */
      unsigned int reserved22 :  2;
      unsigned int MTR3       :  6;  /**< Master Trigger Register 3 */
      unsigned int reserved30 :  2;
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG1_MTR_t;

/*@}*/

/** @defgroup ERRADDR Error Address Register (ERRADDR) Register
 *  Error Address Register (ERRADDR) Register.
 *
 *  The TRU_CFG1 error address register (ERRADDR) holds the address from the memory mapped register access generating an access error of TRU_CFG1 registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG1_ERRADDR_Struct
 *! \brief  Error Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG1_ERRADDR_t {
  union {
    struct {
      unsigned int ADDR       : 12;  /**< Error Address */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG1_ERRADDR_t;

/*@}*/

/** @defgroup STAT Status Information Register (STAT) Register
 *  Status Information Register (STAT) Register.
 *
 *  The TRU_CFG1 status register (STAT) contains the status of MTR and SSRn register writes and status of bus read/write errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG1_STAT_Struct
 *! \brief  Status Information Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG1_STAT_t {
  union {
    struct {
      unsigned int LWERR      :  1;  /**< Lock Write Error Status */
      unsigned int ADDRERR    :  1;  /**< Address Error Status */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG1_STAT_t;

/*@}*/

/** @defgroup GCTL Global Control Register (GCTL) Register
 *  Global Control Register (GCTL) Register.
 *
 *  The TRU_CFG1 global control register (GCTL) provides register locking, TRU_CFG1 reset, and TRU_CFG1 enable.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG1_GCTL_Struct
 *! \brief  Global Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG1_GCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Non-MMR Enable */
      unsigned int RESET      :  1;  /**< Soft Reset */
      unsigned int MTRL       :  1;  /**< MTR Lock Bit */
      unsigned int reserved3  : 28;
      unsigned int LOCK       :  1;  /**< GCTL Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG1_GCTL_t;

/*@}*/

/** @defgroup SSR Slave Select Register (SSR) Register
 *  Slave Select Register (SSR) Register.
 *
 *  The TRU_CFG1 slave select registers (SSR[n]) each provide slave selection and register locking.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_TRU_CFG1_SSR_Struct
 *! \brief  Slave Select Register bit field structure
 * ========================================================================== */
typedef struct _ADI_TRU_CFG1_SSR_t {
  union {
    struct {
      unsigned int SSR        :  6;  /**< SSRn Slave Select */
      unsigned int reserved6  : 25;
      unsigned int LOCK       :  1;  /**< SSRn Lock */
    };
    uint32_t VALUE32;
  };
} ADI_TRU_CFG1_SSR_t;

/*@}*/

/** @defgroup CTL SMPU Control Register (CTL) Register
 *  SMPU Control Register (CTL) Register.
 *
 *  The CTL register provides access to the locking control, error interrupts and SMPU violations.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_CTL_Struct
 *! \brief  SMPU Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_CTL_t {
  union {
    struct {
      unsigned int RSDIS      :  1;  /**< Read Speculation Disable */
      unsigned int PBEDIS     :  1;  /**< Protection Violation Bus Error Disable */
      unsigned int PBETYPE    :  1;  /**< Protection Violation Bus Error Type */
      unsigned int PINTEN     :  1;  /**< Protection Violation Interrupt Enable */
      unsigned int RLOCK      :  1;  /**< RCTLn, RADDRn, RIDxn and RIDMxn Registers Lock Bit */
      unsigned int reserved5  : 26;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_CTL_t;

/*@}*/

/** @defgroup STAT SMPU Status Register (STAT) Register
 *  SMPU Status Register (STAT) Register.
 *
 *  The STAT register provides the state of the SMPU and indicates various errors.  All bits in this register are write '1' to clear.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_STAT_Struct
 *! \brief  SMPU Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_STAT_t {
  union {
    struct {
      unsigned int IRQ        :  1;  /**< Interrupt Request */
      unsigned int IOVR       :  1;  /**< Interrupt Overrun */
      unsigned int BERR       :  1;  /**< Bus Error */
      unsigned int BEOVR      :  1;  /**< Bus Error Overrun */
      unsigned int reserved4  : 12;
      unsigned int ADRERR     :  1;  /**< Address Error */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
      unsigned int reserved18 : 14;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_STAT_t;

/*@}*/

/** @defgroup IADDR Interrupt Address Register (IADDR) Register
 *  Interrupt Address Register (IADDR) Register.
 *
 *  The IADDR register indicates an attempt to make a read or write access to unimplemented addresses or accesses are non-aligned. The SMPU_CFG2 issues a bus error for this condition.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_IADDR_Struct
 *! \brief  Interrupt Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_IADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Interrupt Address */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_IADDR_t;

/*@}*/

/** @defgroup IDTLS Interrupt Details Register (IDTLS) Register
 *  Interrupt Details Register (IDTLS) Register.
 *
 *  The IDTLS register provides the ID of the last signaled interrupt, whether the interrupt was caused by a read or write, and whether the transaction that caused the last signaled interrupt was secure.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_IDTLS_Struct
 *! \brief  Interrupt Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_IDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         : 12;  /**< ID of Transaction */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_IDTLS_t;

/*@}*/

/** @defgroup BADDR Bus Error Address Register (BADDR) Register
 *  Bus Error Address Register (BADDR) Register.
 *
 *  Programs read the BADDR and the BDTLS registers to determine the cause of a bus error. Write errors are prioritized over read errors.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_BADDR_Struct
 *! \brief  Bus Error Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_BADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Bus Error Address */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_BADDR_t;

/*@}*/

/** @defgroup BDTLS Bus Error Details Register (BDTLS) Register
 *  Bus Error Details Register (BDTLS) Register.
 *
 *  The BDTLS register indicates the ID of the bus error transaction, whether the transaction that caused the last bus error was a read, a write, secure or non-secure.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_BDTLS_Struct
 *! \brief  Bus Error Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_BDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status Register */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         : 12;  /**< ID of Transaction */
      unsigned int reserved20 : 12;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_BDTLS_t;

/*@}*/

/** @defgroup REVID SMPU Revision ID Register (REVID) Register
 *  SMPU Revision ID Register (REVID) Register.
 *
 *  The REVID register provides the major and minor revision numbers of this module.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_REVID_Struct
 *! \brief  SMPU Revision ID Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_REVID_t {
  union {
    struct {
      unsigned int REV        :  4;  /**< Incremental Version ID */
      unsigned int MAJOR      :  4;  /**< Major Version ID */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_REVID_t;

/*@}*/

/** @defgroup SECURECTL SMPU Control Secure Accesses Register (SECURECTL) Register
 *  SMPU Control Secure Accesses Register (SECURECTL) Register.
 *
 *  The SECURECTL register provides the bits required to set up the security settings for the processor. This includes error generation and read/write security.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_SECURECTL_Struct
 *! \brief  SMPU Control Secure Accesses Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_SECURECTL_t {
  union {
    struct {
      unsigned int SBEDIS     :  1;  /**< Security Violation Bus Error Disable */
      unsigned int SBETYPE    :  1;  /**< Security Violation Bus Error Type */
      unsigned int SINTEN     :  1;  /**< Security Violation Interrupt Enable */
      unsigned int RLOCK      :  1;  /**< Secure Region Registers Lock Bit */
      unsigned int reserved4  :  4;
      unsigned int RNSEN      :  1;  /**< Non-secure Read Transaction Enable */
      unsigned int RSECDIS    :  1;  /**< Secure Read Transaction Disable */
      unsigned int WNSEN      :  1;  /**< Non-secure Write Transaction Enable */
      unsigned int WSECDIS    :  1;  /**< Secure Write Transaction Disable */
      unsigned int reserved12 : 19;
      unsigned int LOCK       :  1;  /**< Lock Bit */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_SECURECTL_t;

/*@}*/

/** @defgroup RCTL Region n Control Register (RCTL) Register
 *  Region n Control Register (RCTL) Register.
 *
 *  The RCTL[n] register is used to define the level of protection for a region of memory.  The protection of a region is controlled and defined by this register, SMPU_RCTL, and along with SMPU_RADDRn, SMPU_RIDAn, SMPU_RIDBn,  SMPU_RIDMSKAn, and SMPU_RIDMSKBn registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_RCTL_Struct
 *! \brief  Region n Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_RCTL_t {
  union {
    struct {
      unsigned int EN         :  1;  /**< Region Enable */
      unsigned int SIZE       :  5;  /**< Size of the memory region */
      unsigned int reserved6  :  2;
      unsigned int RPROTEN    :  1;  /**< Read Transaction Protection Enable */
      unsigned int RIDCINV    :  1;  /**< Read Transaction ID Compare Invert */
      unsigned int WPROTEN    :  1;  /**< Write Transaction Protection Enable */
      unsigned int WIDCINV    :  1;  /**< Write Transaction ID Compare Invert */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_RCTL_t;

/*@}*/

/** @defgroup RADDR Region n Address Register (RADDR) Register
 *  Region n Address Register (RADDR) Register.
 *
 *  The RADDR[n] register is used to define the base address for a memory region to be protected.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_RADDR_Struct
 *! \brief  Region n Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_RADDR_t {
  union {
    struct {
      unsigned int reserved0  : 12;
      unsigned int BADDR      : 20;  /**< Region n Base Address 20 M.S.B. */
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_RADDR_t;

/*@}*/

/** @defgroup RIDA Region n ID A Register (RIDA) Register
 *  Region n ID A Register (RIDA) Register.
 *
 *  The RIDA[n] register is used for ID comparison 'A'. This comparison is performed after a mask is applied to both the transaction ID (from either the read or write IDs) and the register value. An ID Match means that the ID is the exception to the rule and the read or write is allowed even if the region is read or write protected. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_RIDA_Struct
 *! \brief  Region n ID A Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_RIDA_t {
  union {
    struct {
      unsigned int ID         : 12;  /**< Region n ID Register A */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_RIDA_t;

/*@}*/

/** @defgroup RIDMSKA Region n ID Mask A Register (RIDMSKA) Register
 *  Region n ID Mask A Register (RIDMSKA) Register.
 *
 *  The RIDMSKA[n] register is used for ID comparison 'A'.  The mask allows or disallows certain ID's from affecting the final result of the ID Match. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_RIDMSKA_Struct
 *! \brief  Region n ID Mask A Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_RIDMSKA_t {
  union {
    struct {
      unsigned int MSK        : 12;  /**< Region n ID Mask Register A */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_RIDMSKA_t;

/*@}*/

/** @defgroup RIDB Region n ID B Register (RIDB) Register
 *  Region n ID B Register (RIDB) Register.
 *
 *  The RIDB[n] register is used for ID comparison 'B'. This comparison is performed after a mask is applied to both the transaction ID (from either the read or write IDs) and the register value. An ID Match means that the ID is the exception to the rule and the read or write is allowed even if the region is read or write protected. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_RIDB_Struct
 *! \brief  Region n ID B Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_RIDB_t {
  union {
    struct {
      unsigned int ID         : 12;  /**< Region n ID Register B */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_RIDB_t;

/*@}*/

/** @defgroup RIDMSKB Region n ID Mask B Register (RIDMSKB) Register
 *  Region n ID Mask B Register (RIDMSKB) Register.
 *
 *  The RIDMSKB[n] register is used for ID comparison 'B'.  The mask allows or disallows certain ID's from affecting the final result of the ID Match. For more detail, refer to ID Comparison section.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_RIDMSKB_Struct
 *! \brief  Region n ID Mask B Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_RIDMSKB_t {
  union {
    struct {
      unsigned int MSK        : 12;  /**< Region n ID Mask Register B */
      unsigned int reserved12 : 20;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_RIDMSKB_t;

/*@}*/

/** @defgroup SECURERCTL Region n Control Secure Accesses Register (SECURERCTL) Register
 *  Region n Control Secure Accesses Register (SECURERCTL) Register.
 *
 *  The SECURERCTL[n] register contains bits that configure read/write security for a specific region.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SMPU_CFG2_SECURERCTL_Struct
 *! \brief  Region n Control Secure Accesses Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SMPU_CFG2_SECURERCTL_t {
  union {
    struct {
      unsigned int RNSEN      :  1;  /**< Non-secure Read Transaction Enable */
      unsigned int RSECDIS    :  1;  /**< Secure Read Transaction Disable */
      unsigned int WNSEN      :  1;  /**< Non-secure Write Transaction Enable */
      unsigned int WSECDIS    :  1;  /**< Secure Write Transaction Disable */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SMPU_CFG2_SECURERCTL_t;

/*@}*/

/** @defgroup CTL Control Register (CTL) Register
 *  Control Register (CTL) Register.
 *
 *  The SPU_CFG1 Control Register (CTL) provides a global lock for configuration registers as well as control for locking the Write Protect (SPU_WPn) registers.  It also controls the generation of an interrupt to report blocked accesses.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_CTL_Struct
 *! \brief  Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_CTL_t {
  union {
    struct {
      unsigned int GLCK       :  8;  /**< Global Lock */
      unsigned int reserved8  :  6;
      unsigned int PINTEN     :  1;  /**< Protection Violation Interrupt Enable */
      unsigned int reserved15 :  1;
      unsigned int WPLCK      :  1;  /**< Write Protect Register Lock */
      unsigned int reserved17 :  1;
      unsigned int APLCK      :  1;  /**< Access Protect Register Lock */
      unsigned int reserved19 :  1;
      unsigned int TOMON      :  1;  /**< Timeout Monitor */
      unsigned int reserved21 : 11;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_CTL_t;

/*@}*/

/** @defgroup STAT Status Register (STAT) Register
 *  Status Register (STAT) Register.
 *
 *  The STAT register indicates if there have been any errors, active interrupts and Global Lock status.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_STAT_Struct
 *! \brief  Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_STAT_t {
  union {
    struct {
      unsigned int GLCK       :  1;  /**< Global Lock Status */
      unsigned int reserved1  : 11;
      unsigned int VIRQ       :  1;  /**< Violation Interrupt Request */
      unsigned int TIRQ       :  1;  /**< Timeout Interrupt */
      unsigned int reserved14 : 15;
      unsigned int TOERR      :  1;  /**< Timeout Error */
      unsigned int ADDRERR    :  1;  /**< Address Error. */
      unsigned int LWERR      :  1;  /**< Lock Write Error */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_STAT_t;

/*@}*/

/** @defgroup TIMEOUT Timeout Register (TIMEOUT) Register
 *  Timeout Register (TIMEOUT) Register.
 *
 *  Timeout counter value. Program TOMON in SPU_CTL to enable transaction timeout monitoring. TIRQ interrupt is triggered when timeout period expires.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_TIMEOUT_Struct
 *! \brief  Timeout Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_TIMEOUT_t {
  union {
    struct {
      unsigned int VALUE      : 16;  /**< Timeout counter value */
      unsigned int reserved16 : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_TIMEOUT_t;

/*@}*/

/** @defgroup AP Access Protect Register n (AP) Register
 *  Access Protect Register n (AP) Register.
 *
 *  In the system, each AP[n] register is assigned to a specific MMR address range associated with one peripheral. When the appropriate bits are set, read and writes access to the peripheral from a specific master are blocked and an error is returned to the master. For more information, see the processor specific additional information for the AP[n] register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_AP_Struct
 *! \brief  Access Protect Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_AP_t {
  union {
    struct {
      unsigned int CMA0       :  1;  /**< Core Master x Access Protect Enable */
      unsigned int CMA1       :  1;  /**< Core Master x Access Protect Enable */
      unsigned int reserved2  : 14;
      unsigned int SMA0       :  1;  /**< System Master x Access Protect Enable */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_AP_t;

/*@}*/

/** @defgroup IDTLS Interrupt Details Register (IDTLS) Register
 *  Interrupt Details Register (IDTLS) Register.
 *
 *  The SPU_CFG1 Interrupt Details register (IDTLS) reports the details of the master that caused a security and/or protection violation. Value is set and remain sticky upon each assertion of VIRQ. If a second memory access violation occurs while the IRQ bit in SPU_STAT register is set, the SPU_IADDR and the SPU_IDTLS are not updated until the IRQ bit in SPU_STAT register is cleared.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_IDTLS_Struct
 *! \brief  Interrupt Details Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_IDTLS_t {
  union {
    struct {
      unsigned int SECURE     :  1;  /**< Secure Status */
      unsigned int RNW        :  1;  /**< Read/Write Status */
      unsigned int reserved2  :  6;
      unsigned int ID         : 16;  /**< ID of transaction */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_IDTLS_t;

/*@}*/

/** @defgroup IADDR Interrupt Address Register (IADDR) Register
 *  Interrupt Address Register (IADDR) Register.
 *
 *  The SPU_CFG1 violation address register (IADDR) reports the address of the first master that caused a security and/or protection violation. Value is set and remain sticky upon each assertion of VIRQ.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_IADDR_Struct
 *! \brief  Interrupt Address Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_IADDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Violation Address */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_IADDR_t;

/*@}*/

/** @defgroup DEVID Device Configuration Register (DEVID) Register
 *  Device Configuration Register (DEVID) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_DEVID_Struct
 *! \brief  Device Configuration Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_DEVID_t {
  union {
    struct {
      unsigned int ITYPE      :  3;  /**< Interface Type */
      unsigned int reserved3  :  1;
      unsigned int NS         :  1;  /**< No Security */
      unsigned int reserved5  :  1;
      unsigned int CMCNT      :  5;  /**< Core Master Count */
      unsigned int SMCNT      :  5;  /**< System Master Count */
      unsigned int ENDPTCNT   :  9;  /**< End Point Count */
      unsigned int reserved25 :  7;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_DEVID_t;

/*@}*/

/** @defgroup DEVTYPE Device Type Identifier Register (DEVTYPE) Register
 *  Device Type Identifier Register (DEVTYPE) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_DEVTYPE_Struct
 *! \brief  Device Type Identifier Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_DEVTYPE_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Device Type */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_DEVTYPE_t;

/*@}*/

/** @defgroup PID4 Peripheral ID4 Register (PID4) Register
 *  Peripheral ID4 Register (PID4) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID4_Struct
 *! \brief  Peripheral ID4 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID4_t {
  union {
    struct {
      unsigned int JEOP106CC  :  4;  /**< JEOP106 continuation code (number of leading 0x7Fs) */
      unsigned int SIZE       :  4;  /**< Number of 4k blocks. Size of component 4k chunks minus 1 (i.e. 0=4k) */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID4_t;

/*@}*/

/** @defgroup PID5 Peripheral ID5 Register (PID5) Register
 *  Peripheral ID5 Register (PID5) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID5_Struct
 *! \brief  Peripheral ID5 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID5_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For future use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID5_t;

/*@}*/

/** @defgroup PID6 Peripheral ID6 Register (PID6) Register
 *  Peripheral ID6 Register (PID6) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID6_Struct
 *! \brief  Peripheral ID6 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID6_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For future use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID6_t;

/*@}*/

/** @defgroup PID7 Peripheral ID7 Register (PID7) Register
 *  Peripheral ID7 Register (PID7) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID7_Struct
 *! \brief  Peripheral ID7 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID7_t {
  union {
    struct {
      unsigned int FUTUREUSE  :  8;  /**< For future use */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID7_t;

/*@}*/

/** @defgroup PID0 Peripheral ID0 Register (PID0) Register
 *  Peripheral ID0 Register (PID0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID0_Struct
 *! \brief  Peripheral ID0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID0_t {
  union {
    struct {
      unsigned int PARTNUM    :  8;  /**< PARTNUM[7:0] Part Number for component identification. SPU in this case. */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID0_t;

/*@}*/

/** @defgroup PID1 Peripheral ID1 Register (PID1) Register
 *  Peripheral ID1 Register (PID1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID1_Struct
 *! \brief  Peripheral ID1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID1_t {
  union {
    struct {
      unsigned int PARTNUM    :  4;  /**< PARTNUM[11:8] Part Number for component identification. SPU in this case. */
      unsigned int JEP106     : 28;  /**< JEDEC JEP106 Manufacturer ID code */
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID1_t;

/*@}*/

/** @defgroup PID2 Peripheral ID2 Register (PID2) Register
 *  Peripheral ID2 Register (PID2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID2_Struct
 *! \brief  Peripheral ID2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID2_t {
  union {
    struct {
      unsigned int JEP106     :  3;  /**< JEDEC JEP106 Manufacturer ID code */
      unsigned int JEDECASGN  :  1;  /**< A JEDEC Assigned Value is Used. Indicates that a JEDEC assigned value is used. */
      unsigned int REV        :  4;  /**< Peripheral Revision */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID2_t;

/*@}*/

/** @defgroup PID3 Peripheral ID3 Register (PID3) Register
 *  Peripheral ID3 Register (PID3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_PID3_Struct
 *! \brief  Peripheral ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_PID3_t {
  union {
    struct {
      unsigned int CUSTMOD    :  4;  /**< Customer Modified */
      unsigned int REVAND     :  4;  /**< Metal fix revision */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_PID3_t;

/*@}*/

/** @defgroup CID0 Component ID0 Register (CID0) Register
 *  Component ID0 Register (CID0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_CID0_Struct
 *! \brief  Component ID0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_CID0_t {
  union {
    struct {
      unsigned int PREAMBLE   :  8;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_CID0_t;

/*@}*/

/** @defgroup CID1 Component ID1 Register (CID1) Register
 *  Component ID1 Register (CID1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_CID1_Struct
 *! \brief  Component ID1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_CID1_t {
  union {
    struct {
      unsigned int PREAMBLE   :  4;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int COMPCLASS  :  4;  /**< Component Class */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_CID1_t;

/*@}*/

/** @defgroup CID2 Component ID2 Register (CID2) Register
 *  Component ID2 Register (CID2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_CID2_Struct
 *! \brief  Component ID2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_CID2_t {
  union {
    struct {
      unsigned int PREAMBLE   :  8;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_CID2_t;

/*@}*/

/** @defgroup CID3 Component ID3 Register (CID3) Register
 *  Component ID3 Register (CID3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_CID3_Struct
 *! \brief  Component ID3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_CID3_t {
  union {
    struct {
      unsigned int PREAMBLE   :  8;  /**< Component ID Preamble. Identifies this as a Component ID Register */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_CID3_t;

/*@}*/

/** @defgroup WP Write Protect Register n (WP) Register
 *  Write Protect Register n (WP) Register.
 *
 *  In the system, each WP[n] register is assigned to a specific MMR address range associated with one peripheral. When the appropriate bits are set, writes to the peripheral from a specific master are blocked and an error is returned to the master. For more information, see the processor specific additional information for the WP[n] register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SPU_CFG1_WP_Struct
 *! \brief  Write Protect Register n Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SPU_CFG1_WP_t {
  union {
    struct {
      unsigned int CM0        :  1;  /**< Core Master x Write Protect Enable */
      unsigned int CM1        :  1;  /**< Core Master x Write Protect Enable */
      unsigned int reserved2  : 14;
      unsigned int SM0        :  1;  /**< System Master x Write Protect Enable */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SPU_CFG1_WP_t;

/*@}*/

/** @defgroup periph_id_4 Periph Id 4 (periph_id_4) Register
 *  Periph Id 4 (periph_id_4) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_4_Struct
 *! \brief  Periph Id 4 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_4_t {
  union {
    struct {
      unsigned int periph_id_4 :  8;  /**< Periph Id 4 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_4_t;

/*@}*/

/** @defgroup periph_id_5 Periph Id 5 (periph_id_5) Register
 *  Periph Id 5 (periph_id_5) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_5_Struct
 *! \brief  Periph Id 5 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_5_t {
  union {
    struct {
      unsigned int periph_id_5 :  8;  /**< Periph Id 5 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_5_t;

/*@}*/

/** @defgroup periph_id_6 Periph Id 6 (periph_id_6) Register
 *  Periph Id 6 (periph_id_6) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_6_Struct
 *! \brief  Periph Id 6 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_6_t {
  union {
    struct {
      unsigned int periph_id_6 :  8;  /**< Periph Id 6 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_6_t;

/*@}*/

/** @defgroup periph_id_7 Periph Id 7 (periph_id_7) Register
 *  Periph Id 7 (periph_id_7) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_7_Struct
 *! \brief  Periph Id 7 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_7_t {
  union {
    struct {
      unsigned int periph_id_7 :  8;  /**< Periph Id 7 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_7_t;

/*@}*/

/** @defgroup periph_id_0 Periph Id 0 (periph_id_0) Register
 *  Periph Id 0 (periph_id_0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_0_Struct
 *! \brief  Periph Id 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_0_t {
  union {
    struct {
      unsigned int periph_id_0 :  8;  /**< Periph Id 0 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_0_t;

/*@}*/

/** @defgroup periph_id_1 Periph Id 1 (periph_id_1) Register
 *  Periph Id 1 (periph_id_1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_1_Struct
 *! \brief  Periph Id 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_1_t {
  union {
    struct {
      unsigned int periph_id_1 :  8;  /**< Periph Id 1 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_1_t;

/*@}*/

/** @defgroup periph_id_2 Periph Id 2 (periph_id_2) Register
 *  Periph Id 2 (periph_id_2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_2_Struct
 *! \brief  Periph Id 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_2_t {
  union {
    struct {
      unsigned int periph_id_2 :  8;  /**< Periph Id 2 */
      unsigned int reserved8   : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_2_t;

/*@}*/

/** @defgroup periph_id_3 Periph Id 3 (periph_id_3) Register
 *  Periph Id 3 (periph_id_3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_periph_id_3_Struct
 *! \brief  Periph Id 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_periph_id_3_t {
  union {
    struct {
      unsigned int cust_mod_num :  4;  /**< Cust Mod Num */
      unsigned int rev_and      :  4;  /**< Rev And */
      unsigned int reserved8    : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_periph_id_3_t;

/*@}*/

/** @defgroup comp_id_0 Comp Id 0 (comp_id_0) Register
 *  Comp Id 0 (comp_id_0) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_comp_id_0_Struct
 *! \brief  Comp Id 0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_comp_id_0_t {
  union {
    struct {
      unsigned int comp_id_0  :  8;  /**< Comp Id 0 */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_comp_id_0_t;

/*@}*/

/** @defgroup comp_id_1 Comp Id 1 (comp_id_1) Register
 *  Comp Id 1 (comp_id_1) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_comp_id_1_Struct
 *! \brief  Comp Id 1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_comp_id_1_t {
  union {
    struct {
      unsigned int comp_id_1  :  8;  /**< Comp Id 1 */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_comp_id_1_t;

/*@}*/

/** @defgroup comp_id_2 Comp Id 2 (comp_id_2) Register
 *  Comp Id 2 (comp_id_2) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_comp_id_2_Struct
 *! \brief  Comp Id 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_comp_id_2_t {
  union {
    struct {
      unsigned int comp_id_2  :  8;  /**< Comp Id 2 */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_comp_id_2_t;

/*@}*/

/** @defgroup comp_id_3 Comp Id 3 (comp_id_3) Register
 *  Comp Id 3 (comp_id_3) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_comp_id_3_Struct
 *! \brief  Comp Id 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_comp_id_3_t {
  union {
    struct {
      unsigned int comp_id_3  :  8;  /**< Comp Id 3 */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_comp_id_3_t;

/*@}*/

/** @defgroup dma0_read_qos Dma0.read Qos (dma0_read_qos) Register
 *  Dma0.read Qos (dma0_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma0_read_qos_Struct
 *! \brief  Dma0.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma0_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma0_read_qos_t;

/*@}*/

/** @defgroup dma0_write_qos Dma0.write Qos (dma0_write_qos) Register
 *  Dma0.write Qos (dma0_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma0_write_qos_Struct
 *! \brief  Dma0.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma0_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma0_write_qos_t;

/*@}*/

/** @defgroup dma0_fn_mod Dma0.fn Mod (dma0_fn_mod) Register
 *  Dma0.fn Mod (dma0_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma0_fn_mod_Struct
 *! \brief  Dma0.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma0_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma0_fn_mod_t;

/*@}*/

/** @defgroup dma1_read_qos Dma1.read Qos (dma1_read_qos) Register
 *  Dma1.read Qos (dma1_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma1_read_qos_Struct
 *! \brief  Dma1.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma1_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma1_read_qos_t;

/*@}*/

/** @defgroup dma1_write_qos Dma1.write Qos (dma1_write_qos) Register
 *  Dma1.write Qos (dma1_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma1_write_qos_Struct
 *! \brief  Dma1.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma1_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma1_write_qos_t;

/*@}*/

/** @defgroup dma1_fn_mod Dma1.fn Mod (dma1_fn_mod) Register
 *  Dma1.fn Mod (dma1_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma1_fn_mod_Struct
 *! \brief  Dma1.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma1_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma1_fn_mod_t;

/*@}*/

/** @defgroup dma2_read_qos Dma2.read Qos (dma2_read_qos) Register
 *  Dma2.read Qos (dma2_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma2_read_qos_Struct
 *! \brief  Dma2.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma2_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma2_read_qos_t;

/*@}*/

/** @defgroup dma2_write_qos Dma2.write Qos (dma2_write_qos) Register
 *  Dma2.write Qos (dma2_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma2_write_qos_Struct
 *! \brief  Dma2.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma2_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma2_write_qos_t;

/*@}*/

/** @defgroup dma2_fn_mod Dma2.fn Mod (dma2_fn_mod) Register
 *  Dma2.fn Mod (dma2_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma2_fn_mod_Struct
 *! \brief  Dma2.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma2_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma2_fn_mod_t;

/*@}*/

/** @defgroup dma3_read_qos Dma3.read Qos (dma3_read_qos) Register
 *  Dma3.read Qos (dma3_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma3_read_qos_Struct
 *! \brief  Dma3.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma3_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma3_read_qos_t;

/*@}*/

/** @defgroup dma3_write_qos Dma3.write Qos (dma3_write_qos) Register
 *  Dma3.write Qos (dma3_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma3_write_qos_Struct
 *! \brief  Dma3.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma3_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma3_write_qos_t;

/*@}*/

/** @defgroup dma3_fn_mod Dma3.fn Mod (dma3_fn_mod) Register
 *  Dma3.fn Mod (dma3_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma3_fn_mod_Struct
 *! \brief  Dma3.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma3_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma3_fn_mod_t;

/*@}*/

/** @defgroup dma4_read_qos Dma4.read Qos (dma4_read_qos) Register
 *  Dma4.read Qos (dma4_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma4_read_qos_Struct
 *! \brief  Dma4.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma4_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma4_read_qos_t;

/*@}*/

/** @defgroup dma4_write_qos Dma4.write Qos (dma4_write_qos) Register
 *  Dma4.write Qos (dma4_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma4_write_qos_Struct
 *! \brief  Dma4.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma4_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma4_write_qos_t;

/*@}*/

/** @defgroup dma4_fn_mod Dma4.fn Mod (dma4_fn_mod) Register
 *  Dma4.fn Mod (dma4_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma4_fn_mod_Struct
 *! \brief  Dma4.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma4_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma4_fn_mod_t;

/*@}*/

/** @defgroup dma5_read_qos Dma5.read Qos (dma5_read_qos) Register
 *  Dma5.read Qos (dma5_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma5_read_qos_Struct
 *! \brief  Dma5.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma5_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma5_read_qos_t;

/*@}*/

/** @defgroup dma5_write_qos Dma5.write Qos (dma5_write_qos) Register
 *  Dma5.write Qos (dma5_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma5_write_qos_Struct
 *! \brief  Dma5.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma5_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma5_write_qos_t;

/*@}*/

/** @defgroup dma5_fn_mod Dma5.fn Mod (dma5_fn_mod) Register
 *  Dma5.fn Mod (dma5_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma5_fn_mod_Struct
 *! \brief  Dma5.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma5_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma5_fn_mod_t;

/*@}*/

/** @defgroup dma6_read_qos Dma6.read Qos (dma6_read_qos) Register
 *  Dma6.read Qos (dma6_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma6_read_qos_Struct
 *! \brief  Dma6.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma6_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma6_read_qos_t;

/*@}*/

/** @defgroup dma6_write_qos Dma6.write Qos (dma6_write_qos) Register
 *  Dma6.write Qos (dma6_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma6_write_qos_Struct
 *! \brief  Dma6.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma6_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma6_write_qos_t;

/*@}*/

/** @defgroup dma6_fn_mod Dma6.fn Mod (dma6_fn_mod) Register
 *  Dma6.fn Mod (dma6_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma6_fn_mod_Struct
 *! \brief  Dma6.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma6_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma6_fn_mod_t;

/*@}*/

/** @defgroup dma7_read_qos Dma7.read Qos (dma7_read_qos) Register
 *  Dma7.read Qos (dma7_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma7_read_qos_Struct
 *! \brief  Dma7.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma7_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma7_read_qos_t;

/*@}*/

/** @defgroup dma7_write_qos Dma7.write Qos (dma7_write_qos) Register
 *  Dma7.write Qos (dma7_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma7_write_qos_Struct
 *! \brief  Dma7.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma7_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma7_write_qos_t;

/*@}*/

/** @defgroup dma7_fn_mod Dma7.fn Mod (dma7_fn_mod) Register
 *  Dma7.fn Mod (dma7_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma7_fn_mod_Struct
 *! \brief  Dma7.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma7_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma7_fn_mod_t;

/*@}*/

/** @defgroup dma8_read_qos Dma8.read Qos (dma8_read_qos) Register
 *  Dma8.read Qos (dma8_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma8_read_qos_Struct
 *! \brief  Dma8.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma8_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma8_read_qos_t;

/*@}*/

/** @defgroup dma8_write_qos Dma8.write Qos (dma8_write_qos) Register
 *  Dma8.write Qos (dma8_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma8_write_qos_Struct
 *! \brief  Dma8.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma8_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma8_write_qos_t;

/*@}*/

/** @defgroup dma8_fn_mod Dma8.fn Mod (dma8_fn_mod) Register
 *  Dma8.fn Mod (dma8_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma8_fn_mod_Struct
 *! \brief  Dma8.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma8_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma8_fn_mod_t;

/*@}*/

/** @defgroup dma9_read_qos Dma9.read Qos (dma9_read_qos) Register
 *  Dma9.read Qos (dma9_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma9_read_qos_Struct
 *! \brief  Dma9.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma9_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma9_read_qos_t;

/*@}*/

/** @defgroup dma9_write_qos Dma9.write Qos (dma9_write_qos) Register
 *  Dma9.write Qos (dma9_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma9_write_qos_Struct
 *! \brief  Dma9.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma9_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma9_write_qos_t;

/*@}*/

/** @defgroup dma9_fn_mod Dma9.fn Mod (dma9_fn_mod) Register
 *  Dma9.fn Mod (dma9_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_dma9_fn_mod_Struct
 *! \brief  Dma9.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_dma9_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_dma9_fn_mod_t;

/*@}*/

/** @defgroup afe0_read_qos Afe0.read Qos (afe0_read_qos) Register
 *  Afe0.read Qos (afe0_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_afe0_read_qos_Struct
 *! \brief  Afe0.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_afe0_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_afe0_read_qos_t;

/*@}*/

/** @defgroup afe0_write_qos Afe0.write Qos (afe0_write_qos) Register
 *  Afe0.write Qos (afe0_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_afe0_write_qos_Struct
 *! \brief  Afe0.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_afe0_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_afe0_write_qos_t;

/*@}*/

/** @defgroup afe0_fn_mod Afe0.fn Mod (afe0_fn_mod) Register
 *  Afe0.fn Mod (afe0_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_afe0_fn_mod_Struct
 *! \brief  Afe0.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_afe0_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_afe0_fn_mod_t;

/*@}*/

/** @defgroup fft0_mst_read_qos Fft0 Mst.read Qos (fft0_mst_read_qos) Register
 *  Fft0 Mst.read Qos (fft0_mst_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_fft0_mst_read_qos_Struct
 *! \brief  Fft0 Mst.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_fft0_mst_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_fft0_mst_read_qos_t;

/*@}*/

/** @defgroup fft0_mst_write_qos Fft0 Mst.write Qos (fft0_mst_write_qos) Register
 *  Fft0 Mst.write Qos (fft0_mst_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_fft0_mst_write_qos_Struct
 *! \brief  Fft0 Mst.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_fft0_mst_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_fft0_mst_write_qos_t;

/*@}*/

/** @defgroup fft0_mst_fn_mod Fft0 Mst.fn Mod (fft0_mst_fn_mod) Register
 *  Fft0 Mst.fn Mod (fft0_mst_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_fft0_mst_fn_mod_Struct
 *! \brief  Fft0 Mst.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_fft0_mst_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_fft0_mst_fn_mod_t;

/*@}*/

/** @defgroup cont_sys_fn_mod_ahb Cont Sys.fn Mod Ahb (cont_sys_fn_mod_ahb) Register
 *  Cont Sys.fn Mod Ahb (cont_sys_fn_mod_ahb) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_cont_sys_fn_mod_ahb_Struct
 *! \brief  Cont Sys.fn Mod Ahb Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_cont_sys_fn_mod_ahb_t {
  union {
    struct {
      unsigned int rd_inc_override :  1;  /**< Rd Inc Override */
      unsigned int wr_inc_override :  1;  /**< Wr Inc Override */
      unsigned int lock_override   :  1;  /**< Lock Override */
      unsigned int reserved3       : 29;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_cont_sys_fn_mod_ahb_t;

/*@}*/

/** @defgroup cont_sys_read_qos Cont Sys.read Qos (cont_sys_read_qos) Register
 *  Cont Sys.read Qos (cont_sys_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_cont_sys_read_qos_Struct
 *! \brief  Cont Sys.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_cont_sys_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_cont_sys_read_qos_t;

/*@}*/

/** @defgroup cont_sys_write_qos Cont Sys.write Qos (cont_sys_write_qos) Register
 *  Cont Sys.write Qos (cont_sys_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_cont_sys_write_qos_Struct
 *! \brief  Cont Sys.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_cont_sys_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_cont_sys_write_qos_t;

/*@}*/

/** @defgroup cont_sys_fn_mod Cont Sys.fn Mod (cont_sys_fn_mod) Register
 *  Cont Sys.fn Mod (cont_sys_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_cont_sys_fn_mod_Struct
 *! \brief  Cont Sys.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_cont_sys_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_cont_sys_fn_mod_t;

/*@}*/

/** @defgroup super_axi_read_qos Super Axi.read Qos (super_axi_read_qos) Register
 *  Super Axi.read Qos (super_axi_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_super_axi_read_qos_Struct
 *! \brief  Super Axi.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_super_axi_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_super_axi_read_qos_t;

/*@}*/

/** @defgroup super_axi_write_qos Super Axi.write Qos (super_axi_write_qos) Register
 *  Super Axi.write Qos (super_axi_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_super_axi_write_qos_Struct
 *! \brief  Super Axi.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_super_axi_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_super_axi_write_qos_t;

/*@}*/

/** @defgroup super_axi_fn_mod Super Axi.fn Mod (super_axi_fn_mod) Register
 *  Super Axi.fn Mod (super_axi_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_super_axi_fn_mod_Struct
 *! \brief  Super Axi.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_super_axi_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_super_axi_fn_mod_t;

/*@}*/

/** @defgroup sinc0_mst_read_qos Sinc0 Mst.read Qos (sinc0_mst_read_qos) Register
 *  Sinc0 Mst.read Qos (sinc0_mst_read_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_sinc0_mst_read_qos_Struct
 *! \brief  Sinc0 Mst.read Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_sinc0_mst_read_qos_t {
  union {
    struct {
      unsigned int ar_qos     :  4;  /**< Ar Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_sinc0_mst_read_qos_t;

/*@}*/

/** @defgroup sinc0_mst_write_qos Sinc0 Mst.write Qos (sinc0_mst_write_qos) Register
 *  Sinc0 Mst.write Qos (sinc0_mst_write_qos) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_sinc0_mst_write_qos_Struct
 *! \brief  Sinc0 Mst.write Qos Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_sinc0_mst_write_qos_t {
  union {
    struct {
      unsigned int aw_qos     :  4;  /**< Aw Qos */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_sinc0_mst_write_qos_t;

/*@}*/

/** @defgroup sinc0_mst_fn_mod Sinc0 Mst.fn Mod (sinc0_mst_fn_mod) Register
 *  Sinc0 Mst.fn Mod (sinc0_mst_fn_mod) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCB_sinc0_mst_fn_mod_Struct
 *! \brief  Sinc0 Mst.fn Mod Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCB_sinc0_mst_fn_mod_t {
  union {
    struct {
      unsigned int fn_mod     :  2;  /**< Fn Mod */
      unsigned int reserved2  : 30;
    };
    uint32_t VALUE32;
  };
} ADI_SCB_sinc0_mst_fn_mod_t;

/*@}*/

/** @defgroup DWT_CTRL Dwt Ctrl (DWT_CTRL) Register
 *  Dwt Ctrl (DWT_CTRL) Register.
 *
 *  Use the DW Control Register to check how many comparators are available.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_CTRL_Struct
 *! \brief  Dwt Ctrl Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_CTRL_t {
  union {
    struct {
      unsigned int reserved0  : 28;
      unsigned int NUMCOMP    :  4;  /**< Number of comparators. */
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_CTRL_t;

/*@}*/

/** @defgroup DWT_PCSR Dwt Pcsr (DWT_PCSR) Register
 *  Dwt Pcsr (DWT_PCSR) Register.
 *
 *  Use the DW Program Counter Sample Register (DWPCSR) to enable coarse-grained software profiling using a debug agent, without changing the currently executing code. If the core is not in debug state, the value returned is the instruction address of a recently executed instruction. If the core is in debug state, the value returned is 0xFFFFFFFF.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_PCSR_Struct
 *! \brief  Dwt Pcsr Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_PCSR_t {
  union {
    struct {
      unsigned int EIASAMPLE  : 32;  /**< Execution instruction address sample */
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_PCSR_t;

/*@}*/

/** @defgroup DWT_COMP0 Dwt Comp0 (DWT_COMP0) Register
 *  Dwt Comp0 (DWT_COMP0) Register.
 *
 *  Use the DW Comparator Registers to write the values that trigger watchpoint events
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_COMP0_Struct
 *! \brief  Dwt Comp0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_COMP0_t {
  union {
    struct {
      unsigned int COMP       : 32;  /**< PC compare value */
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_COMP0_t;

/*@}*/

/** @defgroup DWT_MASK0 Dwt Mask0 (DWT_MASK0) Register
 *  Dwt Mask0 (DWT_MASK0) Register.
 *
 *  Use the DW Mask Registers to apply a mask to data addresses when matching against COMP
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_MASK0_Struct
 *! \brief  Dwt Mask0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_MASK0_t {
  union {
    struct {
      unsigned int MASK       :  4;  /**< Data Mask */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_MASK0_t;

/*@}*/

/** @defgroup DWT_FUNCTION0 Dwt Function0 (DWT_FUNCTION0) Register
 *  Dwt Function0 (DWT_FUNCTION0) Register.
 *
 *  Use the DW Function Registers to control the operation of the comparator. Each comparator can Match against either the PC or the data address and halt the core. This function is in conjunction with DWT_COMP
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_FUNCTION0_Struct
 *! \brief  Dwt Function0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_FUNCTION0_t {
  union {
    struct {
      unsigned int FUNCTION   :  4;  /**< Function setting */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_FUNCTION0_t;

/*@}*/

/** @defgroup DWT_COMP1 Dwt Comp1 (DWT_COMP1) Register
 *  Dwt Comp1 (DWT_COMP1) Register.
 *
 *  Use the DW Comparator Registers to write the values that trigger watchpoint events
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_COMP1_Struct
 *! \brief  Dwt Comp1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_COMP1_t {
  union {
    struct {
      unsigned int COMP       : 32;  /**< PC compare value */
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_COMP1_t;

/*@}*/

/** @defgroup DWT_MASK1 Dwt Mask1 (DWT_MASK1) Register
 *  Dwt Mask1 (DWT_MASK1) Register.
 *
 *  Use the DW Mask Registers to apply a mask to data addresses when matching against COMP
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_MASK1_Struct
 *! \brief  Dwt Mask1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_MASK1_t {
  union {
    struct {
      unsigned int MASK       :  4;  /**< Data Mask */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_MASK1_t;

/*@}*/

/** @defgroup DWT_FUNCTION1 Dwt Function1 (DWT_FUNCTION1) Register
 *  Dwt Function1 (DWT_FUNCTION1) Register.
 *
 *  Use the DW Function Registers to control the operation of the comparator. Each comparator can Match against either the PC or the data address and halt the core. This function is in conjunction with DWT_COMP
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_DWT_DWT_FUNCTION1_Struct
 *! \brief  Dwt Function1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_DWT_DWT_FUNCTION1_t {
  union {
    struct {
      unsigned int FUNCTION   :  4;  /**< Function setting */
      unsigned int reserved4  : 28;
    };
    uint32_t VALUE32;
  };
} ADI_DWT_DWT_FUNCTION1_t;

/*@}*/

/** @defgroup BP_CTRL Bp Ctrl (BP_CTRL) Register
 *  Bp Ctrl (BP_CTRL) Register.
 *
 *  Use the Breakpoint Control Register to enable the Breakpoint block
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_BKPT_BP_CTRL_Struct
 *! \brief  Bp Ctrl Register bit field structure
 * ========================================================================== */
typedef struct _ADI_BKPT_BP_CTRL_t {
  union {
    struct {
      unsigned int ENABLE     :  1;  /**< Breakpoint unit enable bit. */
      unsigned int KEY        :  1;  /**< Key field */
      unsigned int reserved2  :  2;
      unsigned int NUM_CODE   :  4;  /**< Number of comparators. */
      unsigned int reserved8  : 24;
    };
    uint32_t VALUE32;
  };
} ADI_BKPT_BP_CTRL_t;

/*@}*/

/** @defgroup BP_COMP0 Bp Comp0 (BP_COMP0) Register
 *  Bp Comp0 (BP_COMP0) Register.
 *
 *  Use the Breakpoint Comparator Registers to store the values to compare with the instruction address.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_BKPT_BP_COMP0_Struct
 *! \brief  Bp Comp0 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_BKPT_BP_COMP0_t {
  union {
    struct {
      unsigned int ENABLE     :  1;  /**< Compare Enable */
      unsigned int reserved1  :  1;
      unsigned int COMP       : 27;  /**< Comparison address, UNKNOWN on reset. */
      unsigned int reserved29 :  1;
      unsigned int BP_MATCH   :  2;  /**< This selects what happens when the COMP address is matched */
    };
    uint32_t VALUE32;
  };
} ADI_BKPT_BP_COMP0_t;

/*@}*/

/** @defgroup BP_COMP1 Bp Comp1 (BP_COMP1) Register
 *  Bp Comp1 (BP_COMP1) Register.
 *
 *  Use the Breakpoint Comparator Registers to store the values to compare with the instruction address.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_BKPT_BP_COMP1_Struct
 *! \brief  Bp Comp1 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_BKPT_BP_COMP1_t {
  union {
    struct {
      unsigned int reserved0  :  2;
      unsigned int COMP       : 27;  /**< Comparison address, UNKNOWN on reset. */
      unsigned int reserved29 :  1;
      unsigned int BP_MATCH   :  2;  /**< This selects what happens when the COMP address is matched */
    };
    uint32_t VALUE32;
  };
} ADI_BKPT_BP_COMP1_t;

/*@}*/

/** @defgroup BP_COMP2 Bp Comp2 (BP_COMP2) Register
 *  Bp Comp2 (BP_COMP2) Register.
 *
 *  Use the Breakpoint Comparator Registers to store the values to compare with the PC address.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_BKPT_BP_COMP2_Struct
 *! \brief  Bp Comp2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_BKPT_BP_COMP2_t {
  union {
    struct {
      unsigned int ENABLE     :  1;  /**< Compare Enable */
      unsigned int reserved1  :  1;
      unsigned int COMP       : 27;  /**< Comparison address, UNKNOWN on reset. */
      unsigned int reserved29 :  1;
      unsigned int BP_MATCH   :  2;  /**< This selects what happens when the COMP address is matched */
    };
    uint32_t VALUE32;
  };
} ADI_BKPT_BP_COMP2_t;

/*@}*/

/** @defgroup BP_COMP3 Bp Comp3 (BP_COMP3) Register
 *  Bp Comp3 (BP_COMP3) Register.
 *
 *  Use the Breakpoint Comparator Registers to store the values to compare with the instruction address.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_BKPT_BP_COMP3_Struct
 *! \brief  Bp Comp3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_BKPT_BP_COMP3_t {
  union {
    struct {
      unsigned int ENABLE     :  1;  /**< Compare Enable */
      unsigned int reserved1  :  1;
      unsigned int COMP       : 27;  /**< Comparison address, UNKNOWN on reset. */
      unsigned int reserved29 :  1;
      unsigned int BP_MATCH   :  2;  /**< This selects what happens when the COMP address is matched */
    };
    uint32_t VALUE32;
  };
} ADI_BKPT_BP_COMP3_t;

/*@}*/

/** @defgroup ACTLR  (ACTLR) Register
 *   (ACTLR) Register.
 *
 *  
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_ACTLR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_ACTLR_t {
  union {
    struct {
      unsigned int ACTLR      : 32;  /**< ACTLR */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_ACTLR_t;

/*@}*/

/** @defgroup STCSR  (STCSR) Register
 *   (STCSR) Register.
 *
 *  Use the SysTick Control and Status Register to enable the SysTick features.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_STCSR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_STCSR_t {
  union {
    struct {
      unsigned int ENABLE     :  1;  /**< Enable SysTick counter */
      unsigned int TICKINT    :  1;  /**< Pend SysTick */
      unsigned int CLKSOURCE  :  1;  /**< SysTick clock source. */
      unsigned int reserved3  : 13;
      unsigned int COUNTFLAG  :  1;  /**< Count down flag */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SCS_STCSR_t;

/*@}*/

/** @defgroup STRVR  (STRVR) Register
 *   (STRVR) Register.
 *
 *  Use the SysTick Reload Value Register to specify the start value to load into the current value register when the counter reaches 0. It can be any value between 0 and 0x00FFFFFF. A start value of 0 is possible, but has no effect because the SysTick interrupt and COUNTFLAG are activated when counting from 1 to 0. The reset value of this register is UNKNOWN.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_STRVR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_STRVR_t {
  union {
    struct {
      unsigned int RELOAD     : 24;  /**< Counter reload value */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_SCS_STRVR_t;

/*@}*/

/** @defgroup STCVR  (STCVR) Register
 *   (STCVR) Register.
 *
 *  Use the SysTick Current Value Register to find the current value in the register. The reset value of this register is UNKNOWN.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_STCVR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_STCVR_t {
  union {
    struct {
      unsigned int CURRENT    : 24;  /**< Current counter value */
      unsigned int reserved24 :  8;
    };
    uint32_t VALUE32;
  };
} ADI_SCS_STCVR_t;

/*@}*/

/** @defgroup STCR  (STCR) Register
 *   (STCR) Register.
 *
 *  Use the SysTick Calibration Value Register to enable software to scale to any required speed using divide and multiply.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_STCR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_STCR_t {
  union {
    struct {
      unsigned int TENMS      : 24;  /**< Optional reload value */
      unsigned int reserved24 :  6;
      unsigned int SKEW       :  1;  /**< Calibration inexact */
      unsigned int NOREF      :  1;  /**< Reference clock provided */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_STCR_t;

/*@}*/

/** @defgroup ISER  (ISER) Register
 *   (ISER) Register.
 *
 *  Use the Interrupt Set-Enable Register to enable interrupts and determine which interrupts are currently enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_ISER_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_ISER_t {
  union {
    struct {
      unsigned int SETENA     : 32;  /**< Interrupt Enable */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_ISER_t;

/*@}*/

/** @defgroup ICER  (ICER) Register
 *   (ICER) Register.
 *
 *  Use the Interrupt Clear-Enable Registers to disable interrupts and determine which interrupts are currently enabled.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_ICER_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_ICER_t {
  union {
    struct {
      unsigned int CLRENA     : 32;  /**< Interrupt Disable */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_ICER_t;

/*@}*/

/** @defgroup ISPR  (ISPR) Register
 *   (ISPR) Register.
 *
 *  Use the Interrupt Set-Pending Register to force interrupts into the pending state and determine which interrupts are currently pending
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_ISPR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_ISPR_t {
  union {
    struct {
      unsigned int SETPEND    : 32;  /**< Set pending bit */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_ISPR_t;

/*@}*/

/** @defgroup ICPR  (ICPR) Register
 *   (ICPR) Register.
 *
 *  Use the Interrupt Clear-Pending Register to clear pending interrupts and determine which interrupts are currently pending.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_ICPR_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_ICPR_t {
  union {
    struct {
      unsigned int CLRPEND    : 32;  /**< Clear pending bit */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_ICPR_t;

/*@}*/

/** @defgroup IPR0  (IPR0) Register
 *   (IPR0) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR0_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR0_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_0       :  2;  /**< Priority of interrupt 0 */
      unsigned int reserved8  :  6;
      unsigned int IP_1       :  2;  /**< Priority of interrupt 1 */
      unsigned int reserved16 :  6;
      unsigned int IP_2       :  2;  /**< Priority of interrupt 2 */
      unsigned int reserved24 :  6;
      unsigned int IP_3       :  2;  /**< Priority of interrupt 3 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR0_t;

/*@}*/

/** @defgroup IPR1  (IPR1) Register
 *   (IPR1) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR1_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR1_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_4       :  2;  /**< Priority of interrupt 4 */
      unsigned int reserved8  :  6;
      unsigned int IP_5       :  2;  /**< Priority of interrupt 5 */
      unsigned int reserved16 :  6;
      unsigned int IP_6       :  2;  /**< Priority of interrupt 6 */
      unsigned int reserved24 :  6;
      unsigned int IP_7       :  2;  /**< Priority of interrupt 7 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR1_t;

/*@}*/

/** @defgroup IPR2  (IPR2) Register
 *   (IPR2) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR2_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR2_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_8       :  2;  /**< Priority of interrupt 8 */
      unsigned int reserved8  :  6;
      unsigned int IP_9       :  2;  /**< Priority of interrupt 9 */
      unsigned int reserved16 :  6;
      unsigned int IP_10      :  2;  /**< Priority of interrupt 10 */
      unsigned int reserved24 :  6;
      unsigned int IP_11      :  2;  /**< Priority of interrupt 11 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR2_t;

/*@}*/

/** @defgroup IPR3  (IPR3) Register
 *   (IPR3) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR3_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR3_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_12      :  2;  /**< Priority of interrupt 12 */
      unsigned int reserved8  :  6;
      unsigned int IP_13      :  2;  /**< Priority of interrupt 13 */
      unsigned int reserved16 :  6;
      unsigned int IP_14      :  2;  /**< Priority of interrupt 14 */
      unsigned int reserved24 :  6;
      unsigned int IP_15      :  2;  /**< Priority of interrupt 15 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR3_t;

/*@}*/

/** @defgroup IPR4  (IPR4) Register
 *   (IPR4) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR4_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR4_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_16      :  2;  /**< Priority of interrupt 16 */
      unsigned int reserved8  :  6;
      unsigned int IP_17      :  2;  /**< Priority of interrupt 17 */
      unsigned int reserved16 :  6;
      unsigned int IP_18      :  2;  /**< Priority of interrupt 18 */
      unsigned int reserved24 :  6;
      unsigned int IP_19      :  2;  /**< Priority of interrupt 19 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR4_t;

/*@}*/

/** @defgroup IPR5  (IPR5) Register
 *   (IPR5) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR5_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR5_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_20      :  2;  /**< Priority of interrupt 20 */
      unsigned int reserved8  :  6;
      unsigned int IP_21      :  2;  /**< Priority of interrupt 21 */
      unsigned int reserved16 :  6;
      unsigned int IP_22      :  2;  /**< Priority of interrupt 22 */
      unsigned int reserved24 :  6;
      unsigned int IP_23      :  2;  /**< Priority of interrupt 23 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR5_t;

/*@}*/

/** @defgroup IPR6  (IPR6) Register
 *   (IPR6) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR6_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR6_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_24      :  2;  /**< Priority of interrupt 24 */
      unsigned int reserved8  :  6;
      unsigned int IP_25      :  2;  /**< Priority of interrupt 25 */
      unsigned int reserved16 :  6;
      unsigned int IP_26      :  2;  /**< Priority of interrupt 26 */
      unsigned int reserved24 :  6;
      unsigned int IP_27      :  2;  /**< Priority of interrupt 27 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR6_t;

/*@}*/

/** @defgroup IPR7  (IPR7) Register
 *   (IPR7) Register.
 *
 *  Use the Interrupt Priority Registers to assign a priority from 0 to 3 to each of the available interrupts. 0 is the highest priority, and 3 is the lowest.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SCS_IPR7_Struct
 *! \brief   Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SCS_IPR7_t {
  union {
    struct {
      unsigned int reserved0  :  6;
      unsigned int IP_28      :  2;  /**< Priority of interrupt 28 */
      unsigned int reserved8  :  6;
      unsigned int IP_29      :  2;  /**< Priority of interrupt 29 */
      unsigned int reserved16 :  6;
      unsigned int IP_30      :  2;  /**< Priority of interrupt 30 */
      unsigned int reserved24 :  6;
      unsigned int IP_31      :  2;  /**< Priority of interrupt 31 */
    };
    uint32_t VALUE32;
  };
} ADI_SCS_IPR7_t;

/*@}*/

/** @defgroup CPUID CPU ID Base Register (CPUID) Register
 *  CPU ID Base Register (CPUID) Register.
 *
 *  Read the CPU ID Base Register to determine: the ID number of the processor core, the version number of the processor core, the implementation details of the processor core.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_CPUID_Struct
 *! \brief  CPU ID Base Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_CPUID_t {
  union {
    struct {
      unsigned int REVISION   :  4;  /**< Revision Number */
      unsigned int PARTNO     : 12;  /**< Number of processor within family: 0xC20 */
      unsigned int CONSTANT   :  4;  /**< Reads as 0xC */
      unsigned int VARIANT    :  4;  /**< Implementation defined variant number: 0x0 (for r0) */
      unsigned int IMPLEMENTER :  8;  /**< Implementor code: 0x41 = ARM */
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_CPUID_t;

/*@}*/

/** @defgroup ICSR Interrupt Control State Register (ICSR) Register
 *  Interrupt Control State Register (ICSR) Register.
 *
 *  Use the Interrupt Control State Register to set a pending Non-Maskable Interrupt (NMI), set or clear a pending PendSV, set or clear a pending SysTick, check for pending exceptions, check the vector number of the highest priority pended exception, check the vector number of the active exception.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_ICSR_Struct
 *! \brief  Interrupt Control State Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_ICSR_t {
  union {
    struct {
      unsigned int VECTACTIVE :  9;  /**< Active exception number field */
      unsigned int reserved9   :  3;
      unsigned int VECTPENDING :  9;  /**< Highest pending exception */
      unsigned int reserved21  :  1;
      unsigned int ISRPENDING  :  1;  /**< External interrupt pending flag */
      unsigned int ISRPREEMPT  :  1;  /**< Pending Interrupt */
      unsigned int reserved24  :  1;
      unsigned int PENDSTCLR   :  1;  /**< Clear pending SysTick bit */
      unsigned int PENDSTSET   :  1;  /**< Set a pending SysTick bit */
      unsigned int PENDSVCLR   :  1;  /**< Clear pending PendSV bit */
      unsigned int PENDSVSET   :  1;  /**< Set pending PendSV bit */
      unsigned int reserved29  :  2;
      unsigned int NMIPENDSET  :  1;  /**< Set NMI */
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_ICSR_t;

/*@}*/

/** @defgroup AIRCR Application Interrupt and Reset Control Register (AIRCR) Register
 *  Application Interrupt and Reset Control Register (AIRCR) Register.
 *
 *  Use the Application Interrupt and Reset Control Register to: determine data endianness, clear all active state information from debug halt mode, request a system reset.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_AIRCR_Struct
 *! \brief  Application Interrupt and Reset Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_AIRCR_t {
  union {
    struct {
      unsigned int reserved0     :  1;
      unsigned int VECTCLRACTIVE :  1;  /**< Clear active state information */
      unsigned int SYSRESETREQ   :  1;  /**< Assert SYSRESETIRQ */
      unsigned int reserved3     : 12;
      unsigned int ENDIANESS     :  1;  /**< Data endianness bit */
      unsigned int VECTKEY       : 16;  /**< Register key */
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_AIRCR_t;

/*@}*/

/** @defgroup SCR System Control Register (SCR) Register
 *  System Control Register (SCR) Register.
 *
 *  Use the System Control Register for power-management functions: signal to the system when the processor can enter a low power state, control how the processor enters and exits low power states.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_SCR_Struct
 *! \brief  System Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_SCR_t {
  union {
    struct {
      unsigned int reserved0   :  1;
      unsigned int SLEEPONEXIT :  1;  /**< Sleep on exit */
      unsigned int SLEEPDEEP   :  1;  /**< Sleep deep bit. */
      unsigned int reserved3   :  1;
      unsigned int SEVONPEND   :  1;  /**< Wake on pend */
      unsigned int reserved5   : 27;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_SCR_t;

/*@}*/

/** @defgroup CCR Configuration and Control Register (CCR) Register
 *  Configuration and Control Register (CCR) Register.
 *
 *  The Configuration and Control Register permanently enables stack alignment and causes unaligned accesses to result in a Hard Fault.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_CCR_Struct
 *! \brief  Configuration and Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_CCR_t {
  union {
    struct {
      unsigned int reserved0   :  3;
      unsigned int UNALIGN_TRP :  1;  /**< Unalign Trp */
      unsigned int reserved4   :  5;
      unsigned int STKALIGN    :  1;  /**< Stack align */
      unsigned int reserved10  : 22;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_CCR_t;

/*@}*/

/** @defgroup SHPR2 System Handler Priority Register 2 (SHPR2) Register
 *  System Handler Priority Register 2 (SHPR2) Register.
 *
 *  System handlers are a special class of exception handler that can have their priority set to any of the priority levels. Use the System Handler Priority Register 2 to set the priority of SVCall.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_SHPR2_Struct
 *! \brief  System Handler Priority Register 2 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_SHPR2_t {
  union {
    struct {
      unsigned int reserved0  : 30;
      unsigned int PRI_11     :  2;  /**< Priority of system handler 11, SVCall */
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_SHPR2_t;

/*@}*/

/** @defgroup SHPR3 System Handler Priority Register 3 (SHPR3) Register
 *  System Handler Priority Register 3 (SHPR3) Register.
 *
 *  System handlers are a special class of exception handler that can have their priority set to any of the priority levels. Use the System Handler Priority Register 3 to set the priority of PendSV and SysTick.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_SHPR3_Struct
 *! \brief  System Handler Priority Register 3 Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_SHPR3_t {
  union {
    struct {
      unsigned int reserved0  : 22;
      unsigned int PRI_14     :  2;  /**< Priority of system handler 14, PendSV */
      unsigned int reserved24 :  6;
      unsigned int PRI_15     :  2;  /**< Priority of system handler 15, SysTick */
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_SHPR3_t;

/*@}*/

/** @defgroup SHCSR System Handler Control and State Register (SHCSR) Register
 *  System Handler Control and State Register (SHCSR) Register.
 *
 *  Use the System Handler Control and State Register to determine or clear the pending status of SVCall. This register is only accessible as part of debug and not through the processor memory map.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_SHCSR_Struct
 *! \brief  System Handler Control and State Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_SHCSR_t {
  union {
    struct {
      unsigned int reserved0    : 15;
      unsigned int SVCALLPENDED :  1;  /**< SVCall pending */
      unsigned int reserved16   : 16;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_SHCSR_t;

/*@}*/

/** @defgroup DFSR Debug Fault Status Register (DFSR) Register
 *  Debug Fault Status Register (DFSR) Register.
 *
 *  Use the Debug Fault Status Register to monitor external debug requests, vector catches, data watchpoint match, BKPT instruction execution and BPU comparator matches, halt requests. Write one to clear. C_DEBUGEN must be set before any bits in DFSR are updated.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_DFSR_Struct
 *! \brief  Debug Fault Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_DFSR_t {
  union {
    struct {
      unsigned int HALTED     :  1;  /**< Halt request flag */
      unsigned int BKPT       :  1;  /**< BKPT flag */
      unsigned int DWTRAP     :  1;  /**< Data Watchpoint (DW) flag. */
      unsigned int VCATCH     :  1;  /**< Vector catch flag */
      unsigned int EXTERNAL   :  1;  /**< External debug request flag */
      unsigned int reserved5  : 27;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_DFSR_t;

/*@}*/

/** @defgroup DHCSR Debug Halting Control and Status Register (DHCSR) Register
 *  Debug Halting Control and Status Register (DHCSR) Register.
 *
 *  The purpose of the Debug Halting Control and Status Register (DHCSR) is to provide status information about the state of the processor, enable core debug, halt and step the processor. For writes, 0xA05F must be written to bits [31:16], otherwise the write operation is ignored and no bits are written into the register.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_DHCSR_Struct
 *! \brief  Debug Halting Control and Status Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_DHCSR_t {
  union {
    struct {
      unsigned int C_DEBUGEN  :  1;  /**< Enables or disable debug */
      unsigned int C_HALT     :  1;  /**< C Halt */
      unsigned int C_STEP     :  1;  /**< C Step */
      unsigned int C_MASKINTS :  1;  /**< C Maskints */
      unsigned int reserved4  : 12;
      unsigned int S_REGRDY   :  1;  /**< S Regrdy */
      unsigned int S_HALT     :  1;  /**< The core is halted in debug state only if S_HALT is set. */
      unsigned int reserved18  :  6;
      unsigned int S_RETIRE_ST :  1;  /**< S Retire St */
      unsigned int S_RESET_ST  :  1;  /**< S Reset St */
      unsigned int reserved26  :  6;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_DHCSR_t;

/*@}*/

/** @defgroup DCRSR Debug Core Register Selector Register (DCRSR) Register
 *  Debug Core Register Selector Register (DCRSR) Register.
 *
 *  The purpose of the Debug Core Register Selector Register (DCRSR) is to select the processor register to transfer data to or from.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_DCRSR_Struct
 *! \brief  Debug Core Register Selector Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_DCRSR_t {
  union {
    struct {
      unsigned int REGSEL     :  5;  /**< Select processor register */
      unsigned int reserved5  : 11;
      unsigned int REGWnR     :  1;  /**< Register Write-not-Read */
      unsigned int reserved17 : 15;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_DCRSR_t;

/*@}*/

/** @defgroup DCRDR Debug Core Register Data Register (DCRDR) Register
 *  Debug Core Register Data Register (DCRDR) Register.
 *
 *  The purpose of the Debug Core Register Data Register (DCRDR) is to hold data read from or written to core registers.
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_DCRDR_Struct
 *! \brief  Debug Core Register Data Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_DCRDR_t {
  union {
    struct {
      unsigned int VALUE      : 32;  /**< Value */
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_DCRDR_t;

/*@}*/

/** @defgroup DEMCR Debug Exception and Monitor Control Register (DEMCR) Register
 *  Debug Exception and Monitor Control Register (DEMCR) Register.
 *
 *  The purpose of the Debug Exception and Monitor Control Register (DEMCR) is: Global enable for the DW unit, Vector catching (that is, causes debug entry on execution of a specified vector.)
 *  @{
 */

/* ==========================================================================
 *! \struct ADI_SDCTRL_DEMCR_Struct
 *! \brief  Debug Exception and Monitor Control Register bit field structure
 * ========================================================================== */
typedef struct _ADI_SDCTRL_DEMCR_t {
  union {
    struct {
      unsigned int VC_CORERESET :  1;  /**< Vc Corereset */
      unsigned int reserved1    :  9;
      unsigned int VC_HARDERR   :  1;  /**< Debug trap on a Hard Fault */
      unsigned int reserved11   : 13;
      unsigned int DWTENA       :  1;  /**< Global enable or disable for the DW unit */
      unsigned int reserved25   :  7;
    };
    uint32_t VALUE32;
  };
} ADI_SDCTRL_DEMCR_t;

/*@}*/

